"use strict";function _interopDefault(e){return e&&"object"==typeof e&&"default"in e?e.default:e}Object.defineProperty(exports,"__esModule",{value:!0});var fs$1=require("./graceful-fs.js"),fs$1__default=_interopDefault(fs$1),fs$2=require("fs"),fs$2__default=_interopDefault(fs$2),path$2=require("path"),path$2__default=_interopDefault(path$2),util$2$1=_interopDefault(require("util")),events$1=require("events"),events$1__default=_interopDefault(events$1),assert$2=_interopDefault(require("assert")),ts=_interopDefault(require("typescript")),cp=require("child_process"),cp__default=_interopDefault(cp),tty$1=_interopDefault(require("tty")),net$1=_interopDefault(require("net")),url$1=require("url"),url$1__default=_interopDefault(url$1),module$1$1=_interopDefault(require("module")),crypto$1=require("crypto"),crypto$1__default=_interopDefault(crypto$1),os$1=require("os"),os$1__default=_interopDefault(os$1);function createCommonjsModule(e,t){return e(t={exports:{}},t.exports),t.exports}function getCjsExportFromNamespace(e){return e&&e.default||e}var symbols=createCommonjsModule(function(e){const t="win32"===process.platform,r="linux"===process.platform,n={bullet:"•",check:"√",cross:"×",ellipsis:"...",heart:"❤",info:"i",line:"─",middot:"·",minus:"－",plus:"＋",question:"?",questionSmall:"﹖",pointer:">",pointerSmall:"»",warning:"‼"},i={ballotCross:"✘",bullet:"•",check:"✔",cross:"✖",ellipsis:"…",heart:"❤",info:"ℹ",line:"─",middot:"·",minus:"－",plus:"＋",question:"?",questionFull:"？",questionSmall:"﹖",pointer:r?"▸":"❯",pointerSmall:r?"‣":"›",warning:"⚠"};e.exports=t?n:i,Reflect.defineProperty(e.exports,"windows",{enumerable:!1,value:n}),Reflect.defineProperty(e.exports,"other",{enumerable:!1,value:i})});const colors={enabled:!0,visible:!0,styles:{},keys:{}};"FORCE_COLOR"in process.env&&(colors.enabled="0"!==process.env.FORCE_COLOR);const ansi=e=>(e.open=`[${e.codes[0]}m`,e.close=`[${e.codes[1]}m`,e.regex=new RegExp(`\\u001b\\[${e.codes[1]}m`,"g"),e),wrap=(e,t,r)=>{let{open:n,close:i,regex:s}=e;return t=n+(t.includes(i)?t.replace(s,i+n):t)+i,r?t.replace(/\r?\n/g,`${i}$&${n}`):t},style=(e,t)=>{if(""===e||null==e)return"";if(!1===colors.enabled)return e;if(!1===colors.visible)return"";let r=""+e,n=r.includes("\n"),i=t.length;for(;i-- >0;)r=wrap(colors.styles[t[i]],r,n);return r},define=(e,t,r)=>{colors.styles[e]=ansi({name:e,codes:t}),(colors.keys[r]||(colors.keys[r]=[])).push(e),Reflect.defineProperty(colors,e,{get(){let t=e=>style(e,t.stack);return Reflect.setPrototypeOf(t,colors),t.stack=this.stack?this.stack.concat(e):[e],t}})};define("reset",[0,0],"modifier"),define("bold",[1,22],"modifier"),define("dim",[2,22],"modifier"),define("italic",[3,23],"modifier"),define("underline",[4,24],"modifier"),define("inverse",[7,27],"modifier"),define("hidden",[8,28],"modifier"),define("strikethrough",[9,29],"modifier"),define("black",[30,39],"color"),define("red",[31,39],"color"),define("green",[32,39],"color"),define("yellow",[33,39],"color"),define("blue",[34,39],"color"),define("magenta",[35,39],"color"),define("cyan",[36,39],"color"),define("white",[37,39],"color"),define("gray",[90,39],"color"),define("grey",[90,39],"color"),define("bgBlack",[40,49],"bg"),define("bgRed",[41,49],"bg"),define("bgGreen",[42,49],"bg"),define("bgYellow",[43,49],"bg"),define("bgBlue",[44,49],"bg"),define("bgMagenta",[45,49],"bg"),define("bgCyan",[46,49],"bg"),define("bgWhite",[47,49],"bg"),define("blackBright",[90,39],"bright"),define("redBright",[91,39],"bright"),define("greenBright",[92,39],"bright"),define("yellowBright",[93,39],"bright"),define("blueBright",[94,39],"bright"),define("magentaBright",[95,39],"bright"),define("cyanBright",[96,39],"bright"),define("whiteBright",[97,39],"bright"),define("bgBlackBright",[100,49],"bgBright"),define("bgRedBright",[101,49],"bgBright"),define("bgGreenBright",[102,49],"bgBright"),define("bgYellowBright",[103,49],"bgBright"),define("bgBlueBright",[104,49],"bgBright"),define("bgMagentaBright",[105,49],"bgBright"),define("bgCyanBright",[106,49],"bgBright"),define("bgWhiteBright",[107,49],"bgBright");const re=colors.ansiRegex=/[\u001b\u009b][[\]#;?()]*(?:(?:(?:[^\W_]*;?[^\W_]*)\u0007)|(?:(?:[0-9]{1,4}(;[0-9]{0,4})*)?[~0-9=<>cf-nqrtyA-PRZ]))/g;colors.hasColor=colors.hasAnsi=(e=>(re.lastIndex=0,!!e&&"string"==typeof e&&re.test(e))),colors.unstyle=(e=>(re.lastIndex=0,"string"==typeof e?e.replace(re,""):e)),colors.none=colors.clear=colors.noop=(e=>e),colors.stripColor=colors.unstyle,colors.symbols=symbols,colors.define=define;var ansiColors=colors;class NodeLogger{constructor(){this._level="info",this.writeLogQueue=[],this.buildLogFilePath=null}get level(){return this._level}set level(e){"string"==typeof e&&(e=e.toLowerCase().trim(),-1===LOG_LEVELS.indexOf(e)?this.error(`Invalid log level '${ansiColors.bold(e)}' (choose from: ${LOG_LEVELS.map(e=>ansiColors.bold(e)).join(", ")})`):this._level=e)}info(...e){if(this.shouldLog("info")){const t=wordWrap(e,getColumns());this.infoPrefix(t),console.log(t.join("\n"))}this.queueWriteLog("I",e)}infoPrefix(e){if(e.length){const t=new Date,r="["+("0"+t.getMinutes()).slice(-2)+":"+("0"+t.getSeconds()).slice(-2)+"."+Math.floor(t.getMilliseconds()/1e3*10)+"]";e[0]=this.dim(r)+e[0].substr(r.length)}}warn(...e){if(this.shouldLog("warn")){const t=wordWrap(e,getColumns());this.warnPrefix(t),console.warn("\n"+t.join("\n")+"\n")}this.queueWriteLog("W",e)}warnPrefix(e){if(e.length){const t="[ WARN  ]";e[0]=this.bold(ansiColors.yellow(t))+e[0].substr(t.length)}}error(...e){for(let t=0;t<e.length;t++)if(e[t]instanceof Error){const r=e[t];e[t]=r.message,r.stack&&(e[t]+="\n"+r.stack)}if(this.shouldLog("error")){const t=wordWrap(e,getColumns());this.errorPrefix(t),console.error("\n"+t.join("\n")+"\n")}this.queueWriteLog("E",e)}errorPrefix(e){if(e.length){const t="[ ERROR ]";e[0]=this.bold(ansiColors.red(t))+e[0].substr(t.length)}}debug(...e){if(this.shouldLog("debug")){e.push(this.dim(` MEM: ${(process.memoryUsage().rss/1e6).toFixed(1)}MB`));const t=wordWrap(e,getColumns());this.debugPrefix(t),console.log(t.join("\n"))}this.queueWriteLog("D",e)}debugPrefix(e){if(e.length){const t=new Date,r="["+("0"+t.getMinutes()).slice(-2)+":"+("0"+t.getSeconds()).slice(-2)+"."+Math.floor(t.getMilliseconds()/1e3*10)+"]";e[0]=ansiColors.cyan(r)+e[0].substr(r.length)}}timespanStart(e,t,r){const n=[`${e} ${this.dim("...")}`];if(t){if(this.shouldLog("debug")){const t=wordWrap(n,getColumns());this.debugPrefix(t),console.log(t.join("\n")),this.queueWriteLog("D",[`${e} ...`])}}else{const t=wordWrap(n,getColumns());this.infoPrefix(t),console.log(t.join("\n")),this.queueWriteLog("I",[`${e} ...`]),r&&r.push(`${e} ...`)}}timespanFinish(e,t,r,n,i,s,o){let a=e;if(r&&(a=this.color(e,r)),n&&(a=this.bold(a)),a+=" "+this.dim(t),s){if(this.shouldLog("debug")){const e=wordWrap([a],getColumns());this.debugPrefix(e),console.log(e.join("\n"))}this.queueWriteLog("D",[`${e} ${t}`])}else{const r=wordWrap([a],getColumns());this.infoPrefix(r),console.log(r.join("\n")),this.queueWriteLog("I",[`${e} ${t}`]),o&&o.push(`${e} ${t}`)}i&&console.log("")}queueWriteLog(e,t){if(this.buildLogFilePath){const r=new Date,n=("0"+r.getHours()).slice(-2)+":"+("0"+r.getMinutes()).slice(-2)+":"+("0"+r.getSeconds()).slice(-2)+".0"+Math.floor(r.getMilliseconds()/1e3*10)+"  "+("000"+(process.memoryUsage().rss/1e6).toFixed(1)).slice(-6)+"MB  "+e+"  "+t.join(", ");this.writeLogQueue.push(n)}}writeLogs(e){if(this.buildLogFilePath)try{this.queueWriteLog("F",["--------------------------------------"]);const t=this.writeLogQueue.join("\n");if(e)try{fs$1__default.accessSync(this.buildLogFilePath)}catch(t){e=!1}e?fs$1__default.appendFileSync(this.buildLogFilePath,t):fs$1__default.writeFileSync(this.buildLogFilePath,t)}catch(e){}this.writeLogQueue.length=0}color(e,t){return ansiColors[t](e)}red(e){return ansiColors.red(e)}green(e){return ansiColors.green(e)}yellow(e){return ansiColors.yellow(e)}blue(e){return ansiColors.blue(e)}magenta(e){return ansiColors.magenta(e)}cyan(e){return ansiColors.cyan(e)}gray(e){return ansiColors.gray(e)}bold(e){return ansiColors.bold(e)}dim(e){return ansiColors.dim(e)}shouldLog(e){return LOG_LEVELS.indexOf(e)>=LOG_LEVELS.indexOf(this.level)}createTimeSpan(e,t=!1,r){return new CmdTimeSpan(this,e,t,r)}printDiagnostics(e){if(!e||!e.length)return;let t=[""];e.forEach(e=>{t=t.concat(this.printDiagnostic(e))}),console.log(t.join("\n"))}printDiagnostic(e){const t=wordWrap([e.messageText],getColumns());let r="";if(e.header&&"Build Error"!==e.header&&(r+=e.header),e.relFilePath&&(r.length>0&&(r+=": "),r+=ansiColors.cyan(e.relFilePath),"number"==typeof e.lineNumber&&e.lineNumber>-1&&(r+=ansiColors.dim(":"),r+=ansiColors.yellow(`${e.lineNumber}`),"number"==typeof e.columnNumber&&e.columnNumber>-1&&(r+=ansiColors.dim(":"),r+=ansiColors.yellow(`${e.columnNumber}`)))),r.length>0&&t.unshift(INDENT+r),t.push(""),e.lines&&e.lines.length){prepareLines(e.lines).forEach(r=>{if(!isMeaningfulLine(r.text))return;let n=`L${r.lineNumber}:  `;for(;n.length<INDENT.length;)n=" "+n;let i=r.text;r.errorCharStart>-1&&(i=this.highlightError(i,r.errorCharStart,r.errorLength)),n=this.dim(n),"typescript"===e.language||"javascript"===e.language?n+=this.javaScriptSyntaxHighlight(i):"scss"===e.language||"css"===e.language?n+=this.cssSyntaxHighlight(i):n+=i,t.push(n)}),t.push("")}return"error"===e.level?this.errorPrefix(t):"warn"===e.level?this.warnPrefix(t):"debug"===e.level?this.debugPrefix(t):this.infoPrefix(t),t}highlightError(e,t,r){let n=e.length-t+r-1;for(;e.length+INDENT.length>MAX_COLUMNS;)if(t>e.length-t+r&&t>5)e=e.substr(1),t--;else{if(!(n>1))break;e=e.substr(0,e.length-1),n--}const i=[],s=Math.max(e.length,t+r);for(var o=0;o<s;o++){var a=e.charAt(o);o>=t&&o<t+r&&(a=ansiColors.bgRed(""===a?" ":a)),i.push(a)}return i.join("")}javaScriptSyntaxHighlight(e){if(e.trim().startsWith("//"))return this.dim(e);return e.split(" ").map(e=>JS_KEYWORDS.indexOf(e)>-1?ansiColors.cyan(e):e).join(" ")}cssSyntaxHighlight(e){let t=!0;const r=[];for(var n=0;n<e.length;n++){const i=e.charAt(n);";"===i||"{"===i?t=!0:".#,:}@$[]/*".indexOf(i)>-1&&(t=!1),t&&"abcdefghijklmnopqrstuvwxyz-_".indexOf(i.toLowerCase())>-1?r.push(ansiColors.cyan(i)):r.push(i)}return r.join("")}}class CmdTimeSpan{constructor(e,t,r,n){this.debug=r,this.appendTo=n,this.logger=e,this.start=Date.now(),this.logger.timespanStart(t,r,this.appendTo)}finish(e,t,r,n){const i=Date.now()-this.start;let s;if(i>1e3)s="in "+(i/1e3).toFixed(2)+" s";else{s=parseFloat(i.toFixed(3))>0?"in "+i+" ms":"in less than 1 ms"}this.logger.timespanFinish(e,s,t,r,n,this.debug,this.appendTo)}}const LOG_LEVELS=["debug","info","warn","error"];function getColumns(){const e=process.stdout&&process.stdout.columns||80;return Math.max(Math.min(MAX_COLUMNS,e),MIN_COLUMNS)}function wordWrap(e,t){const r=[],n=[];e.forEach(e=>{null===e?n.push("null"):void 0===e?n.push("undefined"):"string"==typeof e?e.replace(/\s/gm," ").split(" ").forEach(e=>{e.trim().length&&n.push(e.trim())}):"number"==typeof e||"boolean"==typeof e||"function"==typeof e?n.push(e.toString()):Array.isArray(e)?n.push(()=>e.toString()):Object(e)===e?n.push(()=>e.toString()):n.push(e.toString())});let i=INDENT;return n.forEach(e=>{r.length>25||("function"==typeof e?(i.trim().length&&r.push(i),r.push(e()),i=INDENT):INDENT.length+e.length>t-1?(i.trim().length&&r.push(i),r.push(INDENT+e),i=INDENT):e.length+i.length>t-1?(r.push(i),i=INDENT+e+" "):i+=e+" ")}),i.trim().length&&r.push(i),r.map(e=>e.trimRight())}function prepareLines(e){const t=JSON.parse(JSON.stringify(e));for(let e=0;e<100;e++){if(!eachLineHasLeadingWhitespace(t))return t;for(let e=0;e<t.length;e++)if(t[e].text=t[e].text.substr(1),t[e].errorCharStart--,!t[e].text.length)return t}return t}function eachLineHasLeadingWhitespace(e){if(!e.length)return!1;for(var t=0;t<e.length;t++){if(!e[t].text||e[t].text.length<1)return!1;const r=e[t].text.charAt(0);if(" "!==r&&"\t"!==r)return!1}return!0}function isMeaningfulLine(e){return!!e&&(e=e.trim()).length>0}const JS_KEYWORDS=["abstract","any","as","break","boolean","case","catch","class","console","const","continue","debugger","declare","default","delete","do","else","enum","export","extends","false","finally","for","from","function","get","if","import","in","implements","Infinity","instanceof","let","module","namespace","NaN","new","number","null","public","private","protected","require","return","static","set","string","super","switch","this","throw","try","true","type","typeof","undefined","var","void","with","while","yield"],INDENT="           ",MIN_COLUMNS=60,MAX_COLUMNS=120;function __awaiter(e,t,r,n){return new(r||(r=Promise))(function(i,s){function o(e){try{u(n.next(e))}catch(e){s(e)}}function a(e){try{u(n.throw(e))}catch(e){s(e)}}function u(e){e.done?i(e.value):new r(function(t){t(e.value)}).then(o,a)}u((n=n.apply(e,t||[])).next())})}function createServer(e,t){if(e.localPrerenderServer)return;const r=require("fs"),n=require("http");e.localPrerenderServer=n.createServer((e,n)=>{const i=getFilePath(t,e.url);r.readFile(i,"utf8",(t,r)=>{t?n.write(`\x3c!--localPrerenderServer, error fetching: ${e.url} : ${t} --\x3e`):n.write(r),n.end()})}),e.localPrerenderServer.listen(PORT)}function getFilePath(e,t){const r=require("path");let n=require("url").parse(t).pathname;return"/"!==n.charAt(0)&&(n="/"+n),n.startsWith(e.baseUrl)&&(n=n.substring(e.baseUrl.length)),r.join(e.dir,n)}function normalizeUrl(e){const t=require("url"),r=t.parse(e);return r.protocol&&r.hostname||(r.protocol="http:",r.host="localhost:"+PORT,e=t.format(r)),e}const PORT=53536;function createContext(e,t,r){const n=require("vm");return patchFetch(e,t,r),patchRaf(r),n.createContext(r)}function patchFetch(e,t,r){r.fetch=function(r,n){const i=require("path"),s=require(i.join(__dirname,"./node-fetch.js"));return createServer(e,t),"string"==typeof r?s.nodeFetch(normalizeUrl(r),n):(r.url=normalizeUrl(r.url),s.nodeFetch(r,n))}}function patchRaf(e){e.requestAnimationFrame||(e.requestAnimationFrame=function(t){return e.setTimeout(function(){t(Date.now())},0)},e.cancelAnimationFrame=function(e){clearTimeout(e)})}function runInContext(e,t,r){require("vm").runInContext(e,t,r)}function createFsWatcher(e,t,r){const n=require("chokidar").watch(t,r);return n.on("change",t=>{e.emit("fileUpdate",t)}).on("add",t=>{e.emit("fileAdd",t)}).on("unlink",t=>{e.emit("fileDelete",t)}).on("addDir",t=>{e.emit("dirAdd",t)}).on("unlinkDir",t=>{e.emit("dirDelete",t)}).on("error",e=>{console.error(e)}),n}function createDom(){let e=null;return{parse(t){e&&e.window.close();const r=require("jsdom"),n={url:t.url,referrer:t.referrer,userAgent:t.userAgent};return t.console&&(n.virtualConsole=new r.VirtualConsole,n.virtualConsole.sendTo(t.console)),polyfillJsDom((e=new r.JSDOM(t.html,n)).window),e.window},serialize:()=>e.serialize(),destroy(){e&&e.window&&e.window.close(),e=null}}}function polyfillJsDom(e){e.Element.prototype.closest||(e.Element.prototype.closest=function(e){let t=this;for(;t;){if(t.matches(e))return t;t=t.parentElement}}),e.matchMedia||(e.matchMedia=(()=>({matches:!0})))}var isWindows="win32"===process.platform,DEBUG=process.env.NODE_DEBUG&&/fs/.test(process.env.NODE_DEBUG);function rethrow(){var e;if(DEBUG){var t=new Error;e=function(e){e&&(t.message=e.message,r(e=t))}}else e=r;return e;function r(e){if(e){if(process.throwDeprecation)throw e;if(!process.noDeprecation){var t="fs: missing callback "+(e.stack||e.message);process.traceDeprecation?console.trace(t):console.error(t)}}}}function maybeCallback(e){return"function"==typeof e?e:rethrow()}var normalize=path$2__default.normalize;if(isWindows)var nextPartRe=/(.*?)(?:[\/\\]+|$)/g;else nextPartRe=/(.*?)(?:[\/]+|$)/g;if(isWindows)var splitRootRe=/^(?:[a-zA-Z]:|[\\\/]{2}[^\\\/]+[\\\/][^\\\/]+)?[\\\/]*/;else splitRootRe=/^[\/]*/;var realpathSync=function(e,t){if(e=path$2__default.resolve(e),t&&Object.prototype.hasOwnProperty.call(t,e))return t[e];var r,n,i,s,o=e,a={},u={};function c(){var t=splitRootRe.exec(e);r=t[0].length,n=t[0],i=t[0],s="",isWindows&&!u[i]&&(fs$2__default.lstatSync(i),u[i]=!0)}for(c();r<e.length;){nextPartRe.lastIndex=r;var p=nextPartRe.exec(e);if(s=n,n+=p[0],i=s+p[1],r=nextPartRe.lastIndex,!(u[i]||t&&t[i]===i)){var l;if(t&&Object.prototype.hasOwnProperty.call(t,i))l=t[i];else{var h=fs$2__default.lstatSync(i);if(!h.isSymbolicLink()){u[i]=!0,t&&(t[i]=i);continue}var f=null;if(!isWindows){var d=h.dev.toString(32)+":"+h.ino.toString(32);a.hasOwnProperty(d)&&(f=a[d])}null===f&&(fs$2__default.statSync(i),f=fs$2__default.readlinkSync(i)),l=path$2__default.resolve(s,f),t&&(t[i]=l),isWindows||(a[d]=f)}e=path$2__default.resolve(l,e.slice(r)),c()}}return t&&(t[o]=e),e},realpath=function(e,t,r){if("function"!=typeof r&&(r=maybeCallback(t),t=null),e=path$2__default.resolve(e),t&&Object.prototype.hasOwnProperty.call(t,e))return process.nextTick(r.bind(null,null,t[e]));var n,i,s,o,a=e,u={},c={};function p(){var t=splitRootRe.exec(e);n=t[0].length,i=t[0],s=t[0],o="",isWindows&&!c[s]?fs$2__default.lstat(s,function(e){if(e)return r(e);c[s]=!0,l()}):process.nextTick(l)}function l(){if(n>=e.length)return t&&(t[a]=e),r(null,e);nextPartRe.lastIndex=n;var u=nextPartRe.exec(e);return o=i,i+=u[0],s=o+u[1],n=nextPartRe.lastIndex,c[s]||t&&t[s]===s?process.nextTick(l):t&&Object.prototype.hasOwnProperty.call(t,s)?d(t[s]):fs$2__default.lstat(s,h)}function h(e,n){if(e)return r(e);if(!n.isSymbolicLink())return c[s]=!0,t&&(t[s]=s),process.nextTick(l);if(!isWindows){var i=n.dev.toString(32)+":"+n.ino.toString(32);if(u.hasOwnProperty(i))return f(null,u[i],s)}fs$2__default.stat(s,function(e){if(e)return r(e);fs$2__default.readlink(s,function(e,t){isWindows||(u[i]=t),f(e,t)})})}function f(e,n,i){if(e)return r(e);var s=path$2__default.resolve(o,n);t&&(t[i]=s),d(s)}function d(t){e=path$2__default.resolve(t,e.slice(n)),p()}p()},old={realpathSync:realpathSync,realpath:realpath},fs_realpath=realpath$1;realpath$1.realpath=realpath$1,realpath$1.sync=realpathSync$1,realpath$1.realpathSync=realpathSync$1,realpath$1.monkeypatch=monkeypatch,realpath$1.unmonkeypatch=unmonkeypatch;var origRealpath=fs$2__default.realpath,origRealpathSync=fs$2__default.realpathSync,version=process.version,ok=/^v[0-5]\./.test(version);function newError(e){return e&&"realpath"===e.syscall&&("ELOOP"===e.code||"ENOMEM"===e.code||"ENAMETOOLONG"===e.code)}function realpath$1(e,t,r){if(ok)return origRealpath(e,t,r);"function"==typeof t&&(r=t,t=null),origRealpath(e,t,function(n,i){newError(n)?old.realpath(e,t,r):r(n,i)})}function realpathSync$1(e,t){if(ok)return origRealpathSync(e,t);try{return origRealpathSync(e,t)}catch(r){if(newError(r))return old.realpathSync(e,t);throw r}}function monkeypatch(){fs$2__default.realpath=realpath$1,fs$2__default.realpathSync=realpathSync$1}function unmonkeypatch(){fs$2__default.realpath=origRealpath,fs$2__default.realpathSync=origRealpathSync}var concatMap=function(e,t){for(var r=[],n=0;n<e.length;n++){var i=t(e[n],n);isArray(i)?r.push.apply(r,i):r.push(i)}return r},isArray=Array.isArray||function(e){return"[object Array]"===Object.prototype.toString.call(e)},balancedMatch=balanced;function balanced(e,t,r){e instanceof RegExp&&(e=maybeMatch(e,r)),t instanceof RegExp&&(t=maybeMatch(t,r));var n=range(e,t,r);return n&&{start:n[0],end:n[1],pre:r.slice(0,n[0]),body:r.slice(n[0]+e.length,n[1]),post:r.slice(n[1]+t.length)}}function maybeMatch(e,t){var r=t.match(e);return r?r[0]:null}function range(e,t,r){var n,i,s,o,a,u=r.indexOf(e),c=r.indexOf(t,u+1),p=u;if(u>=0&&c>0){for(n=[],s=r.length;p>=0&&!a;)p==u?(n.push(p),u=r.indexOf(e,p+1)):1==n.length?a=[n.pop(),c]:((i=n.pop())<s&&(s=i,o=c),c=r.indexOf(t,p+1)),p=u<c&&u>=0?u:c;n.length&&(a=[s,o])}return a}balanced.range=range;var braceExpansion=expandTop,escSlash="\0SLASH"+Math.random()+"\0",escOpen="\0OPEN"+Math.random()+"\0",escClose="\0CLOSE"+Math.random()+"\0",escComma="\0COMMA"+Math.random()+"\0",escPeriod="\0PERIOD"+Math.random()+"\0";function numeric(e){return parseInt(e,10)==e?parseInt(e,10):e.charCodeAt(0)}function escapeBraces(e){return e.split("\\\\").join(escSlash).split("\\{").join(escOpen).split("\\}").join(escClose).split("\\,").join(escComma).split("\\.").join(escPeriod)}function unescapeBraces(e){return e.split(escSlash).join("\\").split(escOpen).join("{").split(escClose).join("}").split(escComma).join(",").split(escPeriod).join(".")}function parseCommaParts(e){if(!e)return[""];var t=[],r=balancedMatch("{","}",e);if(!r)return e.split(",");var n=r.pre,i=r.body,s=r.post,o=n.split(",");o[o.length-1]+="{"+i+"}";var a=parseCommaParts(s);return s.length&&(o[o.length-1]+=a.shift(),o.push.apply(o,a)),t.push.apply(t,o),t}function expandTop(e){return e?("{}"===e.substr(0,2)&&(e="\\{\\}"+e.substr(2)),expand(escapeBraces(e),!0).map(unescapeBraces)):[]}function embrace(e){return"{"+e+"}"}function isPadded(e){return/^-?0\d/.test(e)}function lte(e,t){return e<=t}function gte(e,t){return e>=t}function expand(e,t){var r=[],n=balancedMatch("{","}",e);if(!n||/\$$/.test(n.pre))return[e];var i,s=/^-?\d+\.\.-?\d+(?:\.\.-?\d+)?$/.test(n.body),o=/^[a-zA-Z]\.\.[a-zA-Z](?:\.\.-?\d+)?$/.test(n.body),a=s||o,u=n.body.indexOf(",")>=0;if(!a&&!u)return n.post.match(/,.*\}/)?expand(e=n.pre+"{"+n.body+escClose+n.post):[e];if(a)i=n.body.split(/\.\./);else if(1===(i=parseCommaParts(n.body)).length&&1===(i=expand(i[0],!1).map(embrace)).length)return(l=n.post.length?expand(n.post,!1):[""]).map(function(e){return n.pre+i[0]+e});var c,p=n.pre,l=n.post.length?expand(n.post,!1):[""];if(a){var h=numeric(i[0]),f=numeric(i[1]),d=Math.max(i[0].length,i[1].length),m=3==i.length?Math.abs(numeric(i[2])):1,g=lte;f<h&&(m*=-1,g=gte);var y=i.some(isPadded);c=[];for(var v=h;g(v,f);v+=m){var _;if(o)"\\"===(_=String.fromCharCode(v))&&(_="");else if(_=String(v),y){var b=d-_.length;if(b>0){var E=new Array(b+1).join("0");_=v<0?"-"+E+_.slice(1):E+_}}c.push(_)}}else c=concatMap(i,function(e){return expand(e,!1)});for(var x=0;x<c.length;x++)for(var S=0;S<l.length;S++){var A=p+c[x]+l[S];(!t||a||A)&&r.push(A)}return r}var minimatch_1=minimatch;minimatch.Minimatch=Minimatch;var path={sep:"/"};try{path=path$2__default}catch(e){}var GLOBSTAR=minimatch.GLOBSTAR=Minimatch.GLOBSTAR={},plTypes={"!":{open:"(?:(?!(?:",close:"))[^/]*?)"},"?":{open:"(?:",close:")?"},"+":{open:"(?:",close:")+"},"*":{open:"(?:",close:")*"},"@":{open:"(?:",close:")"}},qmark="[^/]",star=qmark+"*?",twoStarDot="(?:(?!(?:\\/|^)(?:\\.{1,2})($|\\/)).)*?",twoStarNoDot="(?:(?!(?:\\/|^)\\.).)*?",reSpecials=charSet("().*{}+?[]^$\\!");function charSet(e){return e.split("").reduce(function(e,t){return e[t]=!0,e},{})}var slashSplit=/\/+/;function filter(e,t){return t=t||{},function(r,n,i){return minimatch(r,e,t)}}function ext(e,t){e=e||{},t=t||{};var r={};return Object.keys(t).forEach(function(e){r[e]=t[e]}),Object.keys(e).forEach(function(t){r[t]=e[t]}),r}function minimatch(e,t,r){if("string"!=typeof t)throw new TypeError("glob pattern string required");return r||(r={}),!(!r.nocomment&&"#"===t.charAt(0))&&(""===t.trim()?""===e:new Minimatch(t,r).match(e))}function Minimatch(e,t){if(!(this instanceof Minimatch))return new Minimatch(e,t);if("string"!=typeof e)throw new TypeError("glob pattern string required");t||(t={}),e=e.trim(),"/"!==path.sep&&(e=e.split(path.sep).join("/")),this.options=t,this.set=[],this.pattern=e,this.regexp=null,this.negate=!1,this.comment=!1,this.empty=!1,this.make()}function make(){if(!this._made){var e=this.pattern,t=this.options;if(t.nocomment||"#"!==e.charAt(0))if(e){this.parseNegate();var r=this.globSet=this.braceExpand();t.debug&&(this.debug=console.error),this.debug(this.pattern,r),r=this.globParts=r.map(function(e){return e.split(slashSplit)}),this.debug(this.pattern,r),r=r.map(function(e,t,r){return e.map(this.parse,this)},this),this.debug(this.pattern,r),r=r.filter(function(e){return-1===e.indexOf(!1)}),this.debug(this.pattern,r),this.set=r}else this.empty=!0;else this.comment=!0}}function parseNegate(){var e=this.pattern,t=!1,r=0;if(!this.options.nonegate){for(var n=0,i=e.length;n<i&&"!"===e.charAt(n);n++)t=!t,r++;r&&(this.pattern=e.substr(r)),this.negate=t}}function braceExpand(e,t){if(t||(t=this instanceof Minimatch?this.options:{}),void 0===(e=void 0===e?this.pattern:e))throw new TypeError("undefined pattern");return t.nobrace||!e.match(/\{.*\}/)?[e]:braceExpansion(e)}minimatch.filter=filter,minimatch.defaults=function(e){if(!e||!Object.keys(e).length)return minimatch;var t=minimatch,r=function(r,n,i){return t.minimatch(r,n,ext(e,i))};return r.Minimatch=function(r,n){return new t.Minimatch(r,ext(e,n))},r},Minimatch.defaults=function(e){return e&&Object.keys(e).length?minimatch.defaults(e).Minimatch:Minimatch},Minimatch.prototype.debug=function(){},Minimatch.prototype.make=make,Minimatch.prototype.parseNegate=parseNegate,minimatch.braceExpand=function(e,t){return braceExpand(e,t)},Minimatch.prototype.braceExpand=braceExpand,Minimatch.prototype.parse=parse;var SUBPARSE={};function parse(e,t){if(e.length>65536)throw new TypeError("pattern is too long");var r=this.options;if(!r.noglobstar&&"**"===e)return GLOBSTAR;if(""===e)return"";var n,i="",s=!!r.nocase,o=!1,a=[],u=[],c=!1,p=-1,l=-1,h="."===e.charAt(0)?"":r.dot?"(?!(?:^|\\/)\\.{1,2}(?:$|\\/))":"(?!\\.)",f=this;function d(){if(n){switch(n){case"*":i+=star,s=!0;break;case"?":i+=qmark,s=!0;break;default:i+="\\"+n}f.debug("clearStateChar %j %j",n,i),n=!1}}for(var m,g=0,y=e.length;g<y&&(m=e.charAt(g));g++)if(this.debug("%s\t%s %s %j",e,g,i,m),o&&reSpecials[m])i+="\\"+m,o=!1;else switch(m){case"/":return!1;case"\\":d(),o=!0;continue;case"?":case"*":case"+":case"@":case"!":if(this.debug("%s\t%s %s %j <-- stateChar",e,g,i,m),c){this.debug("  in class"),"!"===m&&g===l+1&&(m="^"),i+=m;continue}f.debug("call clearStateChar %j",n),d(),n=m,r.noext&&d();continue;case"(":if(c){i+="(";continue}if(!n){i+="\\(";continue}a.push({type:n,start:g-1,reStart:i.length,open:plTypes[n].open,close:plTypes[n].close}),i+="!"===n?"(?:(?!(?:":"(?:",this.debug("plType %j %j",n,i),n=!1;continue;case")":if(c||!a.length){i+="\\)";continue}d(),s=!0;var v=a.pop();i+=v.close,"!"===v.type&&u.push(v),v.reEnd=i.length;continue;case"|":if(c||!a.length||o){i+="\\|",o=!1;continue}d(),i+="|";continue;case"[":if(d(),c){i+="\\"+m;continue}c=!0,l=g,p=i.length,i+=m;continue;case"]":if(g===l+1||!c){i+="\\"+m,o=!1;continue}if(c)var _,b=e.substring(l+1,g);s=!0,c=!1,i+=m;continue;default:d(),o?o=!1:!reSpecials[m]||"^"===m&&c||(i+="\\"),i+=m}for(c&&(b=e.substr(l+1),_=this.parse(b,SUBPARSE),i=i.substr(0,p)+"\\["+_[0],s=s||_[1]),v=a.pop();v;v=a.pop()){var E=i.slice(v.reStart+v.open.length);this.debug("setting tail",i,v),E=E.replace(/((?:\\{2}){0,64})(\\?)\|/g,function(e,t,r){return r||(r="\\"),t+t+r+"|"}),this.debug("tail=%j\n   %s",E,E,v,i);var x="*"===v.type?star:"?"===v.type?qmark:"\\"+v.type;s=!0,i=i.slice(0,v.reStart)+x+"\\("+E}d(),o&&(i+="\\\\");var S=!1;switch(i.charAt(0)){case".":case"[":case"(":S=!0}for(var A=u.length-1;A>-1;A--){var w=u[A],N=i.slice(0,w.reStart),P=i.slice(w.reStart,w.reEnd-8),C=i.slice(w.reEnd-8,w.reEnd),I=i.slice(w.reEnd);C+=I;var k=N.split("(").length-1,O=I;for(g=0;g<k;g++)O=O.replace(/\)[+*?]?/,"");var $="";""===(I=O)&&t!==SUBPARSE&&($="$"),i=N+P+I+$+C}if(""!==i&&s&&(i="(?=.)"+i),S&&(i=h+i),t===SUBPARSE)return[i,s];if(!s)return globUnescape(e);var R=r.nocase?"i":"";try{var M=new RegExp("^"+i+"$",R)}catch(e){return new RegExp("$.")}return M._glob=e,M._src=i,M}function makeRe(){if(this.regexp||!1===this.regexp)return this.regexp;var e=this.set;if(!e.length)return this.regexp=!1,this.regexp;var t=this.options,r=t.noglobstar?star:t.dot?twoStarDot:twoStarNoDot,n=t.nocase?"i":"",i=e.map(function(e){return e.map(function(e){return e===GLOBSTAR?r:"string"==typeof e?regExpEscape(e):e._src}).join("\\/")}).join("|");i="^(?:"+i+")$",this.negate&&(i="^(?!"+i+").*$");try{this.regexp=new RegExp(i,n)}catch(e){this.regexp=!1}return this.regexp}function match(e,t){if(this.debug("match",e,this.pattern),this.comment)return!1;if(this.empty)return""===e;if("/"===e&&t)return!0;var r=this.options;"/"!==path.sep&&(e=e.split(path.sep).join("/")),e=e.split(slashSplit),this.debug(this.pattern,"split",e);var n,i,s=this.set;for(this.debug(this.pattern,"set",s),i=e.length-1;i>=0&&!(n=e[i]);i--);for(i=0;i<s.length;i++){var o=s[i],a=e;if(r.matchBase&&1===o.length&&(a=[n]),this.matchOne(a,o,t))return!!r.flipNegate||!this.negate}return!r.flipNegate&&this.negate}function globUnescape(e){return e.replace(/\\(.)/g,"$1")}function regExpEscape(e){return e.replace(/[-[\]{}()*+?.,\\^$|#\s]/g,"\\$&")}minimatch.makeRe=function(e,t){return new Minimatch(e,t||{}).makeRe()},Minimatch.prototype.makeRe=makeRe,minimatch.match=function(e,t,r){var n=new Minimatch(t,r=r||{});return e=e.filter(function(e){return n.match(e)}),n.options.nonull&&!e.length&&e.push(t),e},Minimatch.prototype.match=match,Minimatch.prototype.matchOne=function(e,t,r){var n=this.options;this.debug("matchOne",{this:this,file:e,pattern:t}),this.debug("matchOne",e.length,t.length);for(var i=0,s=0,o=e.length,a=t.length;i<o&&s<a;i++,s++){this.debug("matchOne loop");var u,c=t[s],p=e[i];if(this.debug(t,c,p),!1===c)return!1;if(c===GLOBSTAR){this.debug("GLOBSTAR",[t,c,p]);var l=i,h=s+1;if(h===a){for(this.debug("** at the end");i<o;i++)if("."===e[i]||".."===e[i]||!n.dot&&"."===e[i].charAt(0))return!1;return!0}for(;l<o;){var f=e[l];if(this.debug("\nglobstar while",e,l,t,h,f),this.matchOne(e.slice(l),t.slice(h),r))return this.debug("globstar found match!",l,o,f),!0;if("."===f||".."===f||!n.dot&&"."===f.charAt(0)){this.debug("dot detected!",e,l,t,h);break}this.debug("globstar swallow a segment, and continue"),l++}return!(!r||(this.debug("\n>>> no match, partial?",e,l,t,h),l!==o))}if("string"==typeof c?(u=n.nocase?p.toLowerCase()===c.toLowerCase():p===c,this.debug("string match",c,p,u)):(u=p.match(c),this.debug("pattern match",c,p,u)),!u)return!1}if(i===o&&s===a)return!0;if(i===o)return r;if(s===a)return i===o-1&&""===e[i];throw new Error("wtf?")};var inherits_browser=createCommonjsModule(function(e){"function"==typeof Object.create?e.exports=function(e,t){e.super_=t,e.prototype=Object.create(t.prototype,{constructor:{value:e,enumerable:!1,writable:!0,configurable:!0}})}:e.exports=function(e,t){e.super_=t;var r=function(){};r.prototype=t.prototype,e.prototype=new r,e.prototype.constructor=e}}),inherits=createCommonjsModule(function(e){try{var t=util$2$1;if("function"!=typeof t.inherits)throw"";e.exports=t.inherits}catch(t){e.exports=inherits_browser}});function posix(e){return"/"===e.charAt(0)}function win32(e){var t=/^([a-zA-Z]:|[\\\/]{2}[^\\\/]+[\\\/]+[^\\\/]+)?([\\\/])?([\s\S]*?)$/.exec(e),r=t[1]||"",n=Boolean(r&&":"!==r.charAt(1));return Boolean(t[2]||n)}var pathIsAbsolute="win32"===process.platform?win32:posix,posix_1=posix,win32_1=win32;pathIsAbsolute.posix=posix_1,pathIsAbsolute.win32=win32_1;var alphasort_1=alphasort,alphasorti_1=alphasorti,setopts_1=setopts,ownProp_1=ownProp,makeAbs_1=makeAbs,finish_1=finish,mark_1=mark,isIgnored_1=isIgnored,childrenIgnored_1=childrenIgnored;function ownProp(e,t){return Object.prototype.hasOwnProperty.call(e,t)}var Minimatch$1=minimatch_1.Minimatch;function alphasorti(e,t){return e.toLowerCase().localeCompare(t.toLowerCase())}function alphasort(e,t){return e.localeCompare(t)}function setupIgnores(e,t){e.ignore=t.ignore||[],Array.isArray(e.ignore)||(e.ignore=[e.ignore]),e.ignore.length&&(e.ignore=e.ignore.map(ignoreMap))}function ignoreMap(e){var t=null;if("/**"===e.slice(-3)){var r=e.replace(/(\/\*\*)+$/,"");t=new Minimatch$1(r,{dot:!0})}return{matcher:new Minimatch$1(e,{dot:!0}),gmatcher:t}}function setopts(e,t,r){if(r||(r={}),r.matchBase&&-1===t.indexOf("/")){if(r.noglobstar)throw new Error("base matching requires globstar");t="**/"+t}e.silent=!!r.silent,e.pattern=t,e.strict=!1!==r.strict,e.realpath=!!r.realpath,e.realpathCache=r.realpathCache||Object.create(null),e.follow=!!r.follow,e.dot=!!r.dot,e.mark=!!r.mark,e.nodir=!!r.nodir,e.nodir&&(e.mark=!0),e.sync=!!r.sync,e.nounique=!!r.nounique,e.nonull=!!r.nonull,e.nosort=!!r.nosort,e.nocase=!!r.nocase,e.stat=!!r.stat,e.noprocess=!!r.noprocess,e.absolute=!!r.absolute,e.maxLength=r.maxLength||1/0,e.cache=r.cache||Object.create(null),e.statCache=r.statCache||Object.create(null),e.symlinks=r.symlinks||Object.create(null),setupIgnores(e,r),e.changedCwd=!1;var n=process.cwd();ownProp(r,"cwd")?(e.cwd=path$2__default.resolve(r.cwd),e.changedCwd=e.cwd!==n):e.cwd=n,e.root=r.root||path$2__default.resolve(e.cwd,"/"),e.root=path$2__default.resolve(e.root),"win32"===process.platform&&(e.root=e.root.replace(/\\/g,"/")),e.cwdAbs=pathIsAbsolute(e.cwd)?e.cwd:makeAbs(e,e.cwd),"win32"===process.platform&&(e.cwdAbs=e.cwdAbs.replace(/\\/g,"/")),e.nomount=!!r.nomount,r.nonegate=!0,r.nocomment=!0,e.minimatch=new Minimatch$1(t,r),e.options=e.minimatch.options}function finish(e){for(var t=e.nounique,r=t?[]:Object.create(null),n=0,i=e.matches.length;n<i;n++){var s=e.matches[n];if(s&&0!==Object.keys(s).length){var o=Object.keys(s);t?r.push.apply(r,o):o.forEach(function(e){r[e]=!0})}else if(e.nonull){var a=e.minimatch.globSet[n];t?r.push(a):r[a]=!0}}if(t||(r=Object.keys(r)),e.nosort||(r=r.sort(e.nocase?alphasorti:alphasort)),e.mark){for(n=0;n<r.length;n++)r[n]=e._mark(r[n]);e.nodir&&(r=r.filter(function(t){var r=!/\/$/.test(t),n=e.cache[t]||e.cache[makeAbs(e,t)];return r&&n&&(r="DIR"!==n&&!Array.isArray(n)),r}))}e.ignore.length&&(r=r.filter(function(t){return!isIgnored(e,t)})),e.found=r}function mark(e,t){var r=makeAbs(e,t),n=e.cache[r],i=t;if(n){var s="DIR"===n||Array.isArray(n),o="/"===t.slice(-1);if(s&&!o?i+="/":!s&&o&&(i=i.slice(0,-1)),i!==t){var a=makeAbs(e,i);e.statCache[a]=e.statCache[r],e.cache[a]=e.cache[r]}}return i}function makeAbs(e,t){var r=t;return r="/"===t.charAt(0)?path$2__default.join(e.root,t):pathIsAbsolute(t)||""===t?t:e.changedCwd?path$2__default.resolve(e.cwd,t):path$2__default.resolve(t),"win32"===process.platform&&(r=r.replace(/\\/g,"/")),r}function isIgnored(e,t){return!!e.ignore.length&&e.ignore.some(function(e){return e.matcher.match(t)||!(!e.gmatcher||!e.gmatcher.match(t))})}function childrenIgnored(e,t){return!!e.ignore.length&&e.ignore.some(function(e){return!(!e.gmatcher||!e.gmatcher.match(t))})}var common={alphasort:alphasort_1,alphasorti:alphasorti_1,setopts:setopts_1,ownProp:ownProp_1,makeAbs:makeAbs_1,finish:finish_1,mark:mark_1,isIgnored:isIgnored_1,childrenIgnored:childrenIgnored_1},sync=globSync;globSync.GlobSync=GlobSync;var setopts$1=common.setopts,ownProp$1=common.ownProp,childrenIgnored$1=common.childrenIgnored,isIgnored$1=common.isIgnored;function globSync(e,t){if("function"==typeof t||3===arguments.length)throw new TypeError("callback provided to sync glob\nSee: https://github.com/isaacs/node-glob/issues/167");return new GlobSync(e,t).found}function GlobSync(e,t){if(!e)throw new Error("must provide pattern");if("function"==typeof t||3===arguments.length)throw new TypeError("callback provided to sync glob\nSee: https://github.com/isaacs/node-glob/issues/167");if(!(this instanceof GlobSync))return new GlobSync(e,t);if(setopts$1(this,e,t),this.noprocess)return this;var r=this.minimatch.set.length;this.matches=new Array(r);for(var n=0;n<r;n++)this._process(this.minimatch.set[n],n,!1);this._finish()}GlobSync.prototype._finish=function(){if(assert$2(this instanceof GlobSync),this.realpath){var e=this;this.matches.forEach(function(t,r){var n=e.matches[r]=Object.create(null);for(var i in t)try{i=e._makeAbs(i),n[fs_realpath.realpathSync(i,e.realpathCache)]=!0}catch(t){if("stat"!==t.syscall)throw t;n[e._makeAbs(i)]=!0}})}common.finish(this)},GlobSync.prototype._process=function(e,t,r){assert$2(this instanceof GlobSync);for(var n,i=0;"string"==typeof e[i];)i++;switch(i){case e.length:return void this._processSimple(e.join("/"),t);case 0:n=null;break;default:n=e.slice(0,i).join("/")}var s,o=e.slice(i);null===n?s=".":pathIsAbsolute(n)||pathIsAbsolute(e.join("/"))?(n&&pathIsAbsolute(n)||(n="/"+n),s=n):s=n;var a=this._makeAbs(s);childrenIgnored$1(this,s)||(o[0]===minimatch_1.GLOBSTAR?this._processGlobStar(n,s,a,o,t,r):this._processReaddir(n,s,a,o,t,r))},GlobSync.prototype._processReaddir=function(e,t,r,n,i,s){var o=this._readdir(r,s);if(o){for(var a=n[0],u=!!this.minimatch.negate,c=a._glob,p=this.dot||"."===c.charAt(0),l=[],h=0;h<o.length;h++){if("."!==(m=o[h]).charAt(0)||p)(u&&!e?!m.match(a):m.match(a))&&l.push(m)}var f=l.length;if(0!==f)if(1!==n.length||this.mark||this.stat){n.shift();for(h=0;h<f;h++){var d;m=l[h];d=e?[e,m]:[m],this._process(d.concat(n),i,s)}}else{this.matches[i]||(this.matches[i]=Object.create(null));for(var h=0;h<f;h++){var m=l[h];e&&(m="/"!==e.slice(-1)?e+"/"+m:e+m),"/"!==m.charAt(0)||this.nomount||(m=path$2__default.join(this.root,m)),this._emitMatch(i,m)}}}},GlobSync.prototype._emitMatch=function(e,t){if(!isIgnored$1(this,t)){var r=this._makeAbs(t);if(this.mark&&(t=this._mark(t)),this.absolute&&(t=r),!this.matches[e][t]){if(this.nodir){var n=this.cache[r];if("DIR"===n||Array.isArray(n))return}this.matches[e][t]=!0,this.stat&&this._stat(t)}}},GlobSync.prototype._readdirInGlobStar=function(e){if(this.follow)return this._readdir(e,!1);var t,r;try{r=fs$2__default.lstatSync(e)}catch(e){if("ENOENT"===e.code)return null}var n=r&&r.isSymbolicLink();return this.symlinks[e]=n,n||!r||r.isDirectory()?t=this._readdir(e,!1):this.cache[e]="FILE",t},GlobSync.prototype._readdir=function(e,t){if(t&&!ownProp$1(this.symlinks,e))return this._readdirInGlobStar(e);if(ownProp$1(this.cache,e)){var r=this.cache[e];if(!r||"FILE"===r)return null;if(Array.isArray(r))return r}try{return this._readdirEntries(e,fs$2__default.readdirSync(e))}catch(t){return this._readdirError(e,t),null}},GlobSync.prototype._readdirEntries=function(e,t){if(!this.mark&&!this.stat)for(var r=0;r<t.length;r++){var n=t[r];n="/"===e?e+n:e+"/"+n,this.cache[n]=!0}return this.cache[e]=t,t},GlobSync.prototype._readdirError=function(e,t){switch(t.code){case"ENOTSUP":case"ENOTDIR":var r=this._makeAbs(e);if(this.cache[r]="FILE",r===this.cwdAbs){var n=new Error(t.code+" invalid cwd "+this.cwd);throw n.path=this.cwd,n.code=t.code,n}break;case"ENOENT":case"ELOOP":case"ENAMETOOLONG":case"UNKNOWN":this.cache[this._makeAbs(e)]=!1;break;default:if(this.cache[this._makeAbs(e)]=!1,this.strict)throw t;this.silent||console.error("glob error",t)}},GlobSync.prototype._processGlobStar=function(e,t,r,n,i,s){var o=this._readdir(r,s);if(o){var a=n.slice(1),u=e?[e]:[],c=u.concat(a);this._process(c,i,!1);var p=o.length;if(!this.symlinks[r]||!s)for(var l=0;l<p;l++){if("."!==o[l].charAt(0)||this.dot){var h=u.concat(o[l],a);this._process(h,i,!0);var f=u.concat(o[l],n);this._process(f,i,!0)}}}},GlobSync.prototype._processSimple=function(e,t){var r=this._stat(e);if(this.matches[t]||(this.matches[t]=Object.create(null)),r){if(e&&pathIsAbsolute(e)&&!this.nomount){var n=/[\/\\]$/.test(e);"/"===e.charAt(0)?e=path$2__default.join(this.root,e):(e=path$2__default.resolve(this.root,e),n&&(e+="/"))}"win32"===process.platform&&(e=e.replace(/\\/g,"/")),this._emitMatch(t,e)}},GlobSync.prototype._stat=function(e){var t=this._makeAbs(e),r="/"===e.slice(-1);if(e.length>this.maxLength)return!1;if(!this.stat&&ownProp$1(this.cache,t)){var n=this.cache[t];if(Array.isArray(n)&&(n="DIR"),!r||"DIR"===n)return n;if(r&&"FILE"===n)return!1}var i=this.statCache[t];if(!i){var s;try{s=fs$2__default.lstatSync(t)}catch(e){if(e&&("ENOENT"===e.code||"ENOTDIR"===e.code))return this.statCache[t]=!1,!1}if(s&&s.isSymbolicLink())try{i=fs$2__default.statSync(t)}catch(e){i=s}else i=s}this.statCache[t]=i;n=!0;return i&&(n=i.isDirectory()?"DIR":"FILE"),this.cache[t]=this.cache[t]||n,(!r||"FILE"!==n)&&n},GlobSync.prototype._mark=function(e){return common.mark(this,e)},GlobSync.prototype._makeAbs=function(e){return common.makeAbs(this,e)};var wrappy_1=wrappy;function wrappy(e,t){if(e&&t)return wrappy(e)(t);if("function"!=typeof e)throw new TypeError("need wrapper function");return Object.keys(e).forEach(function(t){r[t]=e[t]}),r;function r(){for(var t=new Array(arguments.length),r=0;r<t.length;r++)t[r]=arguments[r];var n=e.apply(this,t),i=t[t.length-1];return"function"==typeof n&&n!==i&&Object.keys(i).forEach(function(e){n[e]=i[e]}),n}}var once_1=wrappy_1(once),strict=wrappy_1(onceStrict);function once(e){var t=function(){return t.called?t.value:(t.called=!0,t.value=e.apply(this,arguments))};return t.called=!1,t}function onceStrict(e){var t=function(){if(t.called)throw new Error(t.onceError);return t.called=!0,t.value=e.apply(this,arguments)},r=e.name||"Function wrapped with `once`";return t.onceError=r+" shouldn't be called more than once",t.called=!1,t}once.proto=once(function(){Object.defineProperty(Function.prototype,"once",{value:function(){return once(this)},configurable:!0}),Object.defineProperty(Function.prototype,"onceStrict",{value:function(){return onceStrict(this)},configurable:!0})}),once_1.strict=strict;var reqs=Object.create(null),inflight_1=wrappy_1(inflight);function inflight(e,t){return reqs[e]?(reqs[e].push(t),null):(reqs[e]=[t],makeres(e))}function makeres(e){return once_1(function t(){var r=reqs[e],n=r.length,i=slice(arguments);try{for(var s=0;s<n;s++)r[s].apply(null,i)}finally{r.length>n?(r.splice(0,n),process.nextTick(function(){t.apply(null,i)})):delete reqs[e]}})}function slice(e){for(var t=e.length,r=[],n=0;n<t;n++)r[n]=e[n];return r}var glob_1=glob,EE=events$1__default.EventEmitter,setopts$2=common.setopts,ownProp$2=common.ownProp,childrenIgnored$2=common.childrenIgnored,isIgnored$2=common.isIgnored;function glob(e,t,r){if("function"==typeof t&&(r=t,t={}),t||(t={}),t.sync){if(r)throw new TypeError("callback provided to sync glob");return sync(e,t)}return new Glob(e,t,r)}glob.sync=sync;var GlobSync$1=glob.GlobSync=sync.GlobSync;function extend(e,t){if(null===t||"object"!=typeof t)return e;for(var r=Object.keys(t),n=r.length;n--;)e[r[n]]=t[r[n]];return e}function Glob(e,t,r){if("function"==typeof t&&(r=t,t=null),t&&t.sync){if(r)throw new TypeError("callback provided to sync glob");return new GlobSync$1(e,t)}if(!(this instanceof Glob))return new Glob(e,t,r);setopts$2(this,e,t),this._didRealPath=!1;var n=this.minimatch.set.length;this.matches=new Array(n),"function"==typeof r&&(r=once_1(r),this.on("error",r),this.on("end",function(e){r(null,e)}));var i=this;if(this._processing=0,this._emitQueue=[],this._processQueue=[],this.paused=!1,this.noprocess)return this;if(0===n)return a();for(var s=!0,o=0;o<n;o++)this._process(this.minimatch.set[o],o,!1,a);function a(){--i._processing,i._processing<=0&&(s?process.nextTick(function(){i._finish()}):i._finish())}s=!1}function readdirCb(e,t,r){return function(n,i){n?e._readdirError(t,n,r):e._readdirEntries(t,i,r)}}glob.glob=glob,glob.hasMagic=function(e,t){var r=extend({},t);r.noprocess=!0;var n=new Glob(e,r).minimatch.set;if(!e)return!1;if(n.length>1)return!0;for(var i=0;i<n[0].length;i++)if("string"!=typeof n[0][i])return!0;return!1},glob.Glob=Glob,inherits(Glob,EE),Glob.prototype._finish=function(){if(assert$2(this instanceof Glob),!this.aborted){if(this.realpath&&!this._didRealpath)return this._realpath();common.finish(this),this.emit("end",this.found)}},Glob.prototype._realpath=function(){if(!this._didRealpath){this._didRealpath=!0;var e=this.matches.length;if(0===e)return this._finish();for(var t=this,r=0;r<this.matches.length;r++)this._realpathSet(r,n)}function n(){0==--e&&t._finish()}},Glob.prototype._realpathSet=function(e,t){var r=this.matches[e];if(!r)return t();var n=Object.keys(r),i=this,s=n.length;if(0===s)return t();var o=this.matches[e]=Object.create(null);n.forEach(function(r,n){r=i._makeAbs(r),fs_realpath.realpath(r,i.realpathCache,function(n,a){n?"stat"===n.syscall?o[r]=!0:i.emit("error",n):o[a]=!0,0==--s&&(i.matches[e]=o,t())})})},Glob.prototype._mark=function(e){return common.mark(this,e)},Glob.prototype._makeAbs=function(e){return common.makeAbs(this,e)},Glob.prototype.abort=function(){this.aborted=!0,this.emit("abort")},Glob.prototype.pause=function(){this.paused||(this.paused=!0,this.emit("pause"))},Glob.prototype.resume=function(){if(this.paused){if(this.emit("resume"),this.paused=!1,this._emitQueue.length){var e=this._emitQueue.slice(0);this._emitQueue.length=0;for(var t=0;t<e.length;t++){var r=e[t];this._emitMatch(r[0],r[1])}}if(this._processQueue.length){var n=this._processQueue.slice(0);this._processQueue.length=0;for(t=0;t<n.length;t++){var i=n[t];this._processing--,this._process(i[0],i[1],i[2],i[3])}}}},Glob.prototype._process=function(e,t,r,n){if(assert$2(this instanceof Glob),assert$2("function"==typeof n),!this.aborted)if(this._processing++,this.paused)this._processQueue.push([e,t,r,n]);else{for(var i,s=0;"string"==typeof e[s];)s++;switch(s){case e.length:return void this._processSimple(e.join("/"),t,n);case 0:i=null;break;default:i=e.slice(0,s).join("/")}var o,a=e.slice(s);null===i?o=".":pathIsAbsolute(i)||pathIsAbsolute(e.join("/"))?(i&&pathIsAbsolute(i)||(i="/"+i),o=i):o=i;var u=this._makeAbs(o);if(childrenIgnored$2(this,o))return n();a[0]===minimatch_1.GLOBSTAR?this._processGlobStar(i,o,u,a,t,r,n):this._processReaddir(i,o,u,a,t,r,n)}},Glob.prototype._processReaddir=function(e,t,r,n,i,s,o){var a=this;this._readdir(r,s,function(u,c){return a._processReaddir2(e,t,r,n,i,s,c,o)})},Glob.prototype._processReaddir2=function(e,t,r,n,i,s,o,a){if(!o)return a();for(var u=n[0],c=!!this.minimatch.negate,p=u._glob,l=this.dot||"."===p.charAt(0),h=[],f=0;f<o.length;f++){if("."!==(m=o[f]).charAt(0)||l)(c&&!e?!m.match(u):m.match(u))&&h.push(m)}var d=h.length;if(0===d)return a();if(1===n.length&&!this.mark&&!this.stat){this.matches[i]||(this.matches[i]=Object.create(null));for(f=0;f<d;f++){var m=h[f];e&&(m="/"!==e?e+"/"+m:e+m),"/"!==m.charAt(0)||this.nomount||(m=path$2__default.join(this.root,m)),this._emitMatch(i,m)}return a()}n.shift();for(f=0;f<d;f++){m=h[f];e&&(m="/"!==e?e+"/"+m:e+m),this._process([m].concat(n),i,s,a)}a()},Glob.prototype._emitMatch=function(e,t){if(!this.aborted&&!isIgnored$2(this,t))if(this.paused)this._emitQueue.push([e,t]);else{var r=pathIsAbsolute(t)?t:this._makeAbs(t);if(this.mark&&(t=this._mark(t)),this.absolute&&(t=r),!this.matches[e][t]){if(this.nodir){var n=this.cache[r];if("DIR"===n||Array.isArray(n))return}this.matches[e][t]=!0;var i=this.statCache[r];i&&this.emit("stat",t,i),this.emit("match",t)}}},Glob.prototype._readdirInGlobStar=function(e,t){if(!this.aborted){if(this.follow)return this._readdir(e,!1,t);var r=this,n=inflight_1("lstat\0"+e,function(n,i){if(n&&"ENOENT"===n.code)return t();var s=i&&i.isSymbolicLink();r.symlinks[e]=s,s||!i||i.isDirectory()?r._readdir(e,!1,t):(r.cache[e]="FILE",t())});n&&fs$2__default.lstat(e,n)}},Glob.prototype._readdir=function(e,t,r){if(!this.aborted&&(r=inflight_1("readdir\0"+e+"\0"+t,r))){if(t&&!ownProp$2(this.symlinks,e))return this._readdirInGlobStar(e,r);if(ownProp$2(this.cache,e)){var n=this.cache[e];if(!n||"FILE"===n)return r();if(Array.isArray(n))return r(null,n)}fs$2__default.readdir(e,readdirCb(this,e,r))}},Glob.prototype._readdirEntries=function(e,t,r){if(!this.aborted){if(!this.mark&&!this.stat)for(var n=0;n<t.length;n++){var i=t[n];i="/"===e?e+i:e+"/"+i,this.cache[i]=!0}return this.cache[e]=t,r(null,t)}},Glob.prototype._readdirError=function(e,t,r){if(!this.aborted){switch(t.code){case"ENOTSUP":case"ENOTDIR":var n=this._makeAbs(e);if(this.cache[n]="FILE",n===this.cwdAbs){var i=new Error(t.code+" invalid cwd "+this.cwd);i.path=this.cwd,i.code=t.code,this.emit("error",i),this.abort()}break;case"ENOENT":case"ELOOP":case"ENAMETOOLONG":case"UNKNOWN":this.cache[this._makeAbs(e)]=!1;break;default:this.cache[this._makeAbs(e)]=!1,this.strict&&(this.emit("error",t),this.abort()),this.silent||console.error("glob error",t)}return r()}},Glob.prototype._processGlobStar=function(e,t,r,n,i,s,o){var a=this;this._readdir(r,s,function(u,c){a._processGlobStar2(e,t,r,n,i,s,c,o)})},Glob.prototype._processGlobStar2=function(e,t,r,n,i,s,o,a){if(!o)return a();var u=n.slice(1),c=e?[e]:[],p=c.concat(u);this._process(p,i,!1,a);var l=this.symlinks[r],h=o.length;if(l&&s)return a();for(var f=0;f<h;f++){if("."!==o[f].charAt(0)||this.dot){var d=c.concat(o[f],u);this._process(d,i,!0,a);var m=c.concat(o[f],n);this._process(m,i,!0,a)}}a()},Glob.prototype._processSimple=function(e,t,r){var n=this;this._stat(e,function(i,s){n._processSimple2(e,t,i,s,r)})},Glob.prototype._processSimple2=function(e,t,r,n,i){if(this.matches[t]||(this.matches[t]=Object.create(null)),!n)return i();if(e&&pathIsAbsolute(e)&&!this.nomount){var s=/[\/\\]$/.test(e);"/"===e.charAt(0)?e=path$2__default.join(this.root,e):(e=path$2__default.resolve(this.root,e),s&&(e+="/"))}"win32"===process.platform&&(e=e.replace(/\\/g,"/")),this._emitMatch(t,e),i()},Glob.prototype._stat=function(e,t){var r=this._makeAbs(e),n="/"===e.slice(-1);if(e.length>this.maxLength)return t();if(!this.stat&&ownProp$2(this.cache,r)){var i=this.cache[r];if(Array.isArray(i)&&(i="DIR"),!n||"DIR"===i)return t(null,i);if(n&&"FILE"===i)return t()}var s=this.statCache[r];if(void 0!==s){if(!1===s)return t(null,s);var o=s.isDirectory()?"DIR":"FILE";return n&&"FILE"===o?t():t(null,o,s)}var a=this,u=inflight_1("stat\0"+r,function(n,i){if(i&&i.isSymbolicLink())return fs$2__default.stat(r,function(n,s){n?a._stat2(e,r,null,i,t):a._stat2(e,r,n,s,t)});a._stat2(e,r,n,i,t)});u&&fs$2__default.lstat(r,u)},Glob.prototype._stat2=function(e,t,r,n,i){if(r&&("ENOENT"===r.code||"ENOTDIR"===r.code))return this.statCache[t]=!1,i();var s="/"===e.slice(-1);if(this.statCache[t]=n,"/"===t.slice(-1)&&n&&!n.isDirectory())return i(null,!1,n);var o=!0;return n&&(o=n.isDirectory()?"DIR":"FILE"),this.cache[t]=this.cache[t]||o,s&&"FILE"===o?i():i(null,o,n)};const TASK_CANCELED_MSG="task canceled";function normalizePath(e){if("string"!=typeof e)throw new Error("invalid path to normalize");if(e=e.trim(),EXTENDED_PATH_REGEX.test(e)||NON_ASCII_REGEX.test(e))return e;if("/"===(e=e.replace(SLASH_REGEX,"/")).charAt(e.length-1)){const t=e.indexOf(":");t>-1?t<e.length-2&&(e=e.substring(0,e.length-1)):e.length>1&&(e=e.substring(0,e.length-1))}return e}const EXTENDED_PATH_REGEX=/^\\\\\?\\/,NON_ASCII_REGEX=/[^\x00-\x80]+/,SLASH_REGEX=/\\/g;function loadConfigFile(e,t,r){let n,i="";r&&(r.cwd&&(i=r.cwd()),r.env&&"string"==typeof r.env.PWD&&(i=r.env.PWD));let s=!1;if("string"==typeof t){if(!path$2.isAbsolute(t))throw new Error(`Stencil configuration file "${t}" must be an absolute path.`);try{const r=e.statSync(t);r.isFile()?s=!0:r.isDirectory()&&(s=null!=(t=getConfigPathFromDirectory(e,t)))}catch(e){}}if(s){const r=requireConfigFile(e,t);if(!r.config)throw new Error(`Invalid Stencil configuration file "${t}". Missing "config" property.`);(n=r.config).configPath=t,t&&(n.rootDir=normalizePath(path$2.dirname(t)))}else n={rootDir:i};return n.cwd=normalizePath(i),n}function getConfigPathFromDirectory(e,t){for(let r=0;r<CONFIG_FILENAMES.length;r++)try{const n=path$2.join(t,CONFIG_FILENAMES[r]);if(e.statSync(n).isFile())return n}catch(e){}return null}const CONFIG_FILENAMES=["stencil.config.ts","stencil.config.js"];function requireConfigFile(e,t){delete require.cache[path$2.resolve(t)],require.extensions[".ts"]=((t,r)=>{let n=e.readFileSync(r);n=convertSourceConfig(n,r),t._compile(n,r)});const r=require(t);return require.extensions[".ts"]=void 0,r}function convertSourceConfig(e,t){return e=t.endsWith(".ts")?transpileTypedConfig(e,t):e.replace(/export\s+\w+\s+(\w+)/gm,"exports.$1")}function transpileTypedConfig(e,t){const r={fileName:t,compilerOptions:{module:ts.ModuleKind.CommonJS,moduleResolution:ts.ModuleResolutionKind.NodeJs,esModuleInterop:!0,target:ts.ScriptTarget.ES5},reportDiagnostics:!1};return ts.transpileModule(e,r).outputText}class NodeFs{copyFile(e,t){return new Promise((r,n)=>{const i=fs$1__default.createReadStream(e);i.on("error",n);const s=fs$1__default.createWriteStream(t);s.on("error",n),s.on("close",r),i.pipe(s)})}createReadStream(e){return fs$1__default.createReadStream(e)}mkdir(e){return new Promise((t,r)=>{fs$1__default.mkdir(e,e=>{e?r(e):t()})})}mkdirSync(e){fs$1__default.mkdirSync(e)}readdir(e){return new Promise((t,r)=>{fs$1__default.readdir(e,(e,n)=>{e?r(e):t(n)})})}readdirSync(e){return fs$1__default.readdirSync(e)}readFile(e){return new Promise((t,r)=>{fs$1__default.readFile(e,"utf8",(e,n)=>{e?r(e):t(n)})})}exists(e){return new Promise(t=>{fs$1__default.exists(e,t)})}existsSync(e){return fs$1__default.existsSync(e)}readFileSync(e){return fs$1__default.readFileSync(e,"utf8")}rmdir(e){return new Promise((t,r)=>{fs$1__default.rmdir(e,e=>{e?r(e):t()})})}stat(e){return new Promise((t,r)=>{fs$1__default.stat(e,(e,n)=>{e?r(e):t(n)})})}statSync(e){return fs$1__default.statSync(e)}unlink(e){return new Promise((t,r)=>{fs$1__default.unlink(e,e=>{e?r(e):t()})})}writeFile(e,t){return new Promise((r,n)=>{fs$1__default.writeFile(e,t,{encoding:"utf8"},e=>{e?n(e):r()})})}writeFileSync(e,t){return fs$1__default.writeFileSync(e,t,{encoding:"utf8"})}}class NodeLazyRequire{constructor(e,t,r){this.semver=e,this.nodeResolveModule=t,this.stencilPackageJson=r,this.moduleData=new Map}ensure(e,t,r){return __awaiter(this,void 0,void 0,function*(){if(!this.stencilPackageJson||!this.stencilPackageJson.lazyDependencies)return Promise.resolve();if(!this.stencilPackageJson.lazyDependencies)return Promise.resolve();const n=[];let i=!1;const s=r.map(e=>__awaiter(this,void 0,void 0,function*(){const r=this.moduleData.get(e);if(r&&r.fromDir&&r.modulePath)return;const s=this.stencilPackageJson.lazyDependencies[e];try{const r=this.nodeResolveModule.resolveModule(t,e),n=yield readPackageJson(r);if(i=!0,this.semver.satisfies(n.version,s))return void this.moduleData.set(e,{fromDir:t,modulePath:path$2.dirname(r)})}catch(e){}n.push({moduleId:e,requiredVersionRange:s})}));if(yield Promise.all(s),0===n.length)return Promise.resolve();const o=`Please wait while required dependencies are ${i?"updated":"installed"}. This may take a few moments and will only be required for the initial run.`;e.info(e.magenta(o));const a=n.map(e=>e.moduleId),u=e.createTimeSpan(`installing dependenc${a.length>1?"ies":"y"}: ${a.join(", ")}`);try{const r=n.map(e=>{let t=e.moduleId;return e.requiredVersionRange&&(t+="@"+e.requiredVersionRange),t});yield npmInstall(e,t,r),n.forEach(e=>{this.moduleData.set(e.moduleId,{fromDir:t,modulePath:null})}),u.finish("installing dependencies finished")}catch(t){e.error(`lazy require failed: ${t}`)}})}require(e){const t=this.moduleData.get(e);if(!t)throw new Error(`lazy required module has not been ensured: ${e}`);if(!t.modulePath){const r=this.nodeResolveModule.resolveModule(t.fromDir,e);t.modulePath=path$2.dirname(r),this.moduleData.set(e,t)}return require(t.modulePath)}getModulePath(e){const t=this.moduleData.get(e);if(!t)throw new Error(`lazy required module has not been ensured: ${e}`);if(!t.modulePath){const r=this.nodeResolveModule.resolveModule(t.fromDir,e);t.modulePath=path$2.dirname(r),this.moduleData.set(e,t)}return t.modulePath}}function npmInstall(e,t,r){return new Promise((n,i)=>{const s=["install",...r,"--no-audit","--save-exact","--save-dev"],o={shell:!0,cwd:t,env:Object.assign({},process.env),stdio:"inherit"};o.env.NODE_ENV="development","debug"===e.level&&s.push("--verbose"),e.debug(`npm ${s.join(" ")}`),e.debug(`npm, cwd: ${t}`);const a=cp.spawn("npm",s,o);let u="";a.stderr&&a.stderr.on("data",e=>{u+=e.toString()}),a.once("exit",t=>{"debug"===e.level&&e.debug(`npm, exit ${t}`),0===t?n():i(`failed to install: ${r.join(", ")}${u?", "+u:""}`)})})}function readPackageJson(e){return new Promise((t,r)=>{fs$1.readFile(e,"utf8",(e,n)=>{if(e)r(e);else try{t(JSON.parse(n))}catch(e){r(e)}})})}class NodeResolveModule{constructor(){this.resolveModuleCache=new Map}resolveModule(e,t,r){const n=`${e}:${t}`,i=this.resolveModuleCache.get(n);if(i)return i;if(r&&r.manuallyResolve)return this.resolveModuleManually(e,t,n);if(t.startsWith("@types/"))return this.resolveTypesModule(e,t,n);const s=require("module");e=path$2__default.resolve(e);const o=path$2__default.join(e,"noop.js");let a=normalizePath(s._resolveFilename(t,{id:o,filename:o,paths:s._nodeModulePaths(e)}));const u=normalizePath(path$2__default.parse(e).root);let c;for(;a!==u;)if(a=normalizePath(path$2__default.dirname(a)),hasAccess(c=path$2__default.join(a,"package.json")))return this.resolveModuleCache.set(n,c),c;throw new Error(`error loading "${t}" from "${e}"`)}resolveTypesModule(e,t,r){const n=t.split("/"),i=normalizePath(path$2__default.parse(e).root);let s,o=normalizePath(path$2__default.join(e,"noop.js"));for(;o!==i;)if(o=normalizePath(path$2__default.dirname(o)),hasAccess(s=path$2__default.join(o,"node_modules",n[0],n[1],"package.json")))return this.resolveModuleCache.set(r,s),s;throw new Error(`error loading "${t}" from "${e}"`)}resolveModuleManually(e,t,r){const n=normalizePath(path$2__default.parse(e).root);let i,s=normalizePath(path$2__default.join(e,"noop.js"));for(;s!==n;)if(s=normalizePath(path$2__default.dirname(s)),hasAccess(i=path$2__default.join(s,"node_modules",t,"package.json")))return this.resolveModuleCache.set(r,i),i;throw new Error(`error loading "${t}" from "${e}"`)}}function hasAccess(e){let t=!1;try{fs$1__default.accessSync(e),t=!0}catch(e){}return t}var reservedWords={3:"abstract boolean byte char class double enum export extends final float goto implements import int interface long native package private protected public short static super synchronized throws transient volatile",5:"class enum extends super const export import",6:"enum",strict:"implements interface let package private protected public static yield",strictBind:"eval arguments"},ecma5AndLessKeywords="break case catch continue debugger default do else finally for function if return switch throw try var while with null true false instanceof typeof void delete new in this",keywords={5:ecma5AndLessKeywords,6:ecma5AndLessKeywords+" const class extends export import super"},keywordRelationalOperator=/^in(stanceof)?$/,nonASCIIidentifierStartChars="ªµºÀ-ÖØ-öø-ˁˆ-ˑˠ-ˤˬˮͰ-ʹͶͷͺ-ͽͿΆΈ-ΊΌΎ-ΡΣ-ϵϷ-ҁҊ-ԯԱ-Ֆՙՠ-ֈא-תׯ-ײؠ-يٮٯٱ-ۓەۥۦۮۯۺ-ۼۿܐܒ-ܯݍ-ޥޱߊ-ߪߴߵߺࠀ-ࠕࠚࠤࠨࡀ-ࡘࡠ-ࡪࢠ-ࢴࢶ-ࢽऄ-हऽॐक़-ॡॱ-ঀঅ-ঌএঐও-নপ-রলশ-হঽৎড়ঢ়য়-ৡৰৱৼਅ-ਊਏਐਓ-ਨਪ-ਰਲਲ਼ਵਸ਼ਸਹਖ਼-ੜਫ਼ੲ-ੴઅ-ઍએ-ઑઓ-નપ-રલળવ-હઽૐૠૡૹଅ-ଌଏଐଓ-ନପ-ରଲଳଵ-ହଽଡ଼ଢ଼ୟ-ୡୱஃஅ-ஊஎ-ஐஒ-கஙசஜஞடணதந-பம-ஹௐఅ-ఌఎ-ఐఒ-నప-హఽౘ-ౚౠౡಀಅ-ಌಎ-ಐಒ-ನಪ-ಳವ-ಹಽೞೠೡೱೲഅ-ഌഎ-ഐഒ-ഺഽൎൔ-ൖൟ-ൡൺ-ൿඅ-ඖක-නඳ-රලව-ෆก-ะาำเ-ๆກຂຄງຈຊຍດ-ທນ-ຟມ-ຣລວສຫອ-ະາຳຽເ-ໄໆໜ-ໟༀཀ-ཇཉ-ཬྈ-ྌက-ဪဿၐ-ၕၚ-ၝၡၥၦၮ-ၰၵ-ႁႎႠ-ჅჇჍა-ჺჼ-ቈቊ-ቍቐ-ቖቘቚ-ቝበ-ኈኊ-ኍነ-ኰኲ-ኵኸ-ኾዀዂ-ዅወ-ዖዘ-ጐጒ-ጕጘ-ፚᎀ-ᎏᎠ-Ᏽᏸ-ᏽᐁ-ᙬᙯ-ᙿᚁ-ᚚᚠ-ᛪᛮ-ᛸᜀ-ᜌᜎ-ᜑᜠ-ᜱᝀ-ᝑᝠ-ᝬᝮ-ᝰក-ឳៗៜᠠ-ᡸᢀ-ᢨᢪᢰ-ᣵᤀ-ᤞᥐ-ᥭᥰ-ᥴᦀ-ᦫᦰ-ᧉᨀ-ᨖᨠ-ᩔᪧᬅ-ᬳᭅ-ᭋᮃ-ᮠᮮᮯᮺ-ᯥᰀ-ᰣᱍ-ᱏᱚ-ᱽᲀ-ᲈᲐ-ᲺᲽ-Ჿᳩ-ᳬᳮ-ᳱᳵᳶᴀ-ᶿḀ-ἕἘ-Ἕἠ-ὅὈ-Ὅὐ-ὗὙὛὝὟ-ώᾀ-ᾴᾶ-ᾼιῂ-ῄῆ-ῌῐ-ΐῖ-Ίῠ-Ῥῲ-ῴῶ-ῼⁱⁿₐ-ₜℂℇℊ-ℓℕ℘-ℝℤΩℨK-ℹℼ-ℿⅅ-ⅉⅎⅠ-ↈⰀ-Ⱞⰰ-ⱞⱠ-ⳤⳫ-ⳮⳲⳳⴀ-ⴥⴧⴭⴰ-ⵧⵯⶀ-ⶖⶠ-ⶦⶨ-ⶮⶰ-ⶶⶸ-ⶾⷀ-ⷆⷈ-ⷎⷐ-ⷖⷘ-ⷞ々-〇〡-〩〱-〵〸-〼ぁ-ゖ゛-ゟァ-ヺー-ヿㄅ-ㄯㄱ-ㆎㆠ-ㆺㇰ-ㇿ㐀-䶵一-鿯ꀀ-ꒌꓐ-ꓽꔀ-ꘌꘐ-ꘟꘪꘫꙀ-ꙮꙿ-ꚝꚠ-ꛯꜗ-ꜟꜢ-ꞈꞋ-ꞹꟷ-ꠁꠃ-ꠅꠇ-ꠊꠌ-ꠢꡀ-ꡳꢂ-ꢳꣲ-ꣷꣻꣽꣾꤊ-ꤥꤰ-ꥆꥠ-ꥼꦄ-ꦲꧏꧠ-ꧤꧦ-ꧯꧺ-ꧾꨀ-ꨨꩀ-ꩂꩄ-ꩋꩠ-ꩶꩺꩾ-ꪯꪱꪵꪶꪹ-ꪽꫀꫂꫛ-ꫝꫠ-ꫪꫲ-ꫴꬁ-ꬆꬉ-ꬎꬑ-ꬖꬠ-ꬦꬨ-ꬮꬰ-ꭚꭜ-ꭥꭰ-ꯢ가-힣ힰ-ퟆퟋ-ퟻ豈-舘並-龎ﬀ-ﬆﬓ-ﬗיִײַ-ﬨשׁ-זּטּ-לּמּנּסּףּפּצּ-ﮱﯓ-ﴽﵐ-ﶏﶒ-ﷇﷰ-ﷻﹰ-ﹴﹶ-ﻼＡ-Ｚａ-ｚｦ-ﾾￂ-ￇￊ-ￏￒ-ￗￚ-ￜ",nonASCIIidentifierChars="‌‍·̀-ͯ·҃-֑҇-ׇֽֿׁׂׅׄؐ-ًؚ-٩ٰۖ-ۜ۟-۪ۤۧۨ-ۭ۰-۹ܑܰ-݊ަ-ް߀-߉߫-߽߳ࠖ-࠙ࠛ-ࠣࠥ-ࠧࠩ-࡙࠭-࡛࣓-ࣣ࣡-ःऺ-़ा-ॏ॑-ॗॢॣ०-९ঁ-ঃ়া-ৄেৈো-্ৗৢৣ০-৯৾ਁ-ਃ਼ਾ-ੂੇੈੋ-੍ੑ੦-ੱੵઁ-ઃ઼ા-ૅે-ૉો-્ૢૣ૦-૯ૺ-૿ଁ-ଃ଼ା-ୄେୈୋ-୍ୖୗୢୣ୦-୯ஂா-ூெ-ைொ-்ௗ௦-௯ఀ-ఄా-ౄె-ైొ-్ౕౖౢౣ౦-౯ಁ-ಃ಼ಾ-ೄೆ-ೈೊ-್ೕೖೢೣ೦-೯ഀ-ഃ഻഼ാ-ൄെ-ൈൊ-്ൗൢൣ൦-൯ංඃ්ා-ුූෘ-ෟ෦-෯ෲෳัิ-ฺ็-๎๐-๙ັິ-ູົຼ່-ໍ໐-໙༘༙༠-༩༹༵༷༾༿ཱ-྄྆྇ྍ-ྗྙ-ྼ࿆ါ-ှ၀-၉ၖ-ၙၞ-ၠၢ-ၤၧ-ၭၱ-ၴႂ-ႍႏ-ႝ፝-፟፩-፱ᜒ-᜔ᜲ-᜴ᝒᝓᝲᝳ឴-៓៝០-៩᠋-᠍᠐-᠙ᢩᤠ-ᤫᤰ-᤻᥆-᥏᧐-᧚ᨗ-ᨛᩕ-ᩞ᩠-᩿᩼-᪉᪐-᪙᪰-᪽ᬀ-ᬄ᬴-᭄᭐-᭙᭫-᭳ᮀ-ᮂᮡ-ᮭ᮰-᮹᯦-᯳ᰤ-᰷᱀-᱉᱐-᱙᳐-᳔᳒-᳨᳭ᳲ-᳴᳷-᳹᷀-᷹᷻-᷿‿⁀⁔⃐-⃥⃜⃡-⃰⳯-⵿⳱ⷠ-〪ⷿ-゙゚〯꘠-꘩꙯ꙴ-꙽ꚞꚟ꛰꛱ꠂ꠆ꠋꠣ-ꠧꢀꢁꢴ-ꣅ꣐-꣙꣠-꣱ꣿ-꤉ꤦ-꤭ꥇ-꥓ꦀ-ꦃ꦳-꧀꧐-꧙ꧥ꧰-꧹ꨩ-ꨶꩃꩌꩍ꩐-꩙ꩻ-ꩽꪰꪲ-ꪴꪷꪸꪾ꪿꫁ꫫ-ꫯꫵ꫶ꯣ-ꯪ꯬꯭꯰-꯹ﬞ︀-️︠-︯︳︴﹍-﹏０-９＿",nonASCIIidentifierStart=new RegExp("["+nonASCIIidentifierStartChars+"]"),nonASCIIidentifier=new RegExp("["+nonASCIIidentifierStartChars+nonASCIIidentifierChars+"]");nonASCIIidentifierStartChars=nonASCIIidentifierChars=null;var astralIdentifierStartCodes=[0,11,2,25,2,18,2,1,2,14,3,13,35,122,70,52,268,28,4,48,48,31,14,29,6,37,11,29,3,35,5,7,2,4,43,157,19,35,5,35,5,39,9,51,157,310,10,21,11,7,153,5,3,0,2,43,2,1,4,0,3,22,11,22,10,30,66,18,2,1,11,21,11,25,71,55,7,1,65,0,16,3,2,2,2,28,43,28,4,28,36,7,2,27,28,53,11,21,11,18,14,17,111,72,56,50,14,50,14,35,477,28,11,0,9,21,190,52,76,44,33,24,27,35,30,0,12,34,4,0,13,47,15,3,22,0,2,0,36,17,2,24,85,6,2,0,2,3,2,14,2,9,8,46,39,7,3,1,3,21,2,6,2,1,2,4,4,0,19,0,13,4,159,52,19,3,54,47,21,1,2,0,185,46,42,3,37,47,21,0,60,42,86,26,230,43,117,63,32,0,257,0,11,39,8,0,22,0,12,39,3,3,20,0,35,56,264,8,2,36,18,0,50,29,113,6,2,1,2,37,22,0,26,5,2,1,2,31,15,0,328,18,270,921,103,110,18,195,2749,1070,4050,582,8634,568,8,30,114,29,19,47,17,3,32,20,6,18,689,63,129,68,12,0,67,12,65,1,31,6129,15,754,9486,286,82,395,2309,106,6,12,4,8,8,9,5991,84,2,70,2,1,3,0,3,1,3,3,2,11,2,0,2,6,2,64,2,3,3,7,2,6,2,27,2,3,2,4,2,0,4,6,2,339,3,24,2,24,2,30,2,24,2,30,2,24,2,30,2,24,2,30,2,24,2,7,4149,196,60,67,1213,3,2,26,2,1,2,0,3,0,2,9,2,3,2,0,2,0,7,0,5,0,2,0,2,0,2,2,2,1,2,0,3,0,2,0,2,0,2,0,2,0,2,1,2,0,3,3,2,6,2,3,2,3,2,0,2,9,2,16,6,2,2,4,2,16,4421,42710,42,4148,12,221,3,5761,15,7472,3104,541],astralIdentifierCodes=[509,0,227,0,150,4,294,9,1368,2,2,1,6,3,41,2,5,0,166,1,574,3,9,9,525,10,176,2,54,14,32,9,16,3,46,10,54,9,7,2,37,13,2,9,6,1,45,0,13,2,49,13,9,3,4,9,83,11,7,0,161,11,6,9,7,3,56,1,2,6,3,1,3,2,10,0,11,1,3,6,4,4,193,17,10,9,5,0,82,19,13,9,214,6,3,8,28,1,83,16,16,9,82,12,9,9,84,14,5,9,243,14,166,9,280,9,41,6,2,3,9,0,10,10,47,15,406,7,2,7,17,9,57,21,2,13,123,5,4,0,2,1,2,6,2,0,9,9,49,4,2,1,2,4,9,9,330,3,19306,9,135,4,60,6,26,9,1016,45,17,3,19723,1,5319,4,4,5,9,7,3,6,31,3,149,2,1418,49,513,54,5,49,9,0,15,0,23,4,2,14,1361,6,2,16,3,6,2,1,2,4,2214,6,110,6,6,9,792487,239];function isInAstralSet(e,t){for(var r=65536,n=0;n<t.length;n+=2){if((r+=t[n])>e)return!1;if((r+=t[n+1])>=e)return!0}}function isIdentifierStart(e,t){return e<65?36===e:e<91||(e<97?95===e:e<123||(e<=65535?e>=170&&nonASCIIidentifierStart.test(String.fromCharCode(e)):!1!==t&&isInAstralSet(e,astralIdentifierStartCodes)))}function isIdentifierChar(e,t){return e<48?36===e:e<58||!(e<65)&&(e<91||(e<97?95===e:e<123||(e<=65535?e>=170&&nonASCIIidentifier.test(String.fromCharCode(e)):!1!==t&&(isInAstralSet(e,astralIdentifierStartCodes)||isInAstralSet(e,astralIdentifierCodes)))))}var TokenType=function(e,t){void 0===t&&(t={}),this.label=e,this.keyword=t.keyword,this.beforeExpr=!!t.beforeExpr,this.startsExpr=!!t.startsExpr,this.isLoop=!!t.isLoop,this.isAssign=!!t.isAssign,this.prefix=!!t.prefix,this.postfix=!!t.postfix,this.binop=t.binop||null,this.updateContext=null};function binop(e,t){return new TokenType(e,{beforeExpr:!0,binop:t})}var beforeExpr={beforeExpr:!0},startsExpr={startsExpr:!0},keywords$1={};function kw(e,t){return void 0===t&&(t={}),t.keyword=e,keywords$1[e]=new TokenType(e,t)}var types={num:new TokenType("num",startsExpr),regexp:new TokenType("regexp",startsExpr),string:new TokenType("string",startsExpr),name:new TokenType("name",startsExpr),eof:new TokenType("eof"),bracketL:new TokenType("[",{beforeExpr:!0,startsExpr:!0}),bracketR:new TokenType("]"),braceL:new TokenType("{",{beforeExpr:!0,startsExpr:!0}),braceR:new TokenType("}"),parenL:new TokenType("(",{beforeExpr:!0,startsExpr:!0}),parenR:new TokenType(")"),comma:new TokenType(",",beforeExpr),semi:new TokenType(";",beforeExpr),colon:new TokenType(":",beforeExpr),dot:new TokenType("."),question:new TokenType("?",beforeExpr),arrow:new TokenType("=>",beforeExpr),template:new TokenType("template"),invalidTemplate:new TokenType("invalidTemplate"),ellipsis:new TokenType("...",beforeExpr),backQuote:new TokenType("`",startsExpr),dollarBraceL:new TokenType("${",{beforeExpr:!0,startsExpr:!0}),eq:new TokenType("=",{beforeExpr:!0,isAssign:!0}),assign:new TokenType("_=",{beforeExpr:!0,isAssign:!0}),incDec:new TokenType("++/--",{prefix:!0,postfix:!0,startsExpr:!0}),prefix:new TokenType("!/~",{beforeExpr:!0,prefix:!0,startsExpr:!0}),logicalOR:binop("||",1),logicalAND:binop("&&",2),bitwiseOR:binop("|",3),bitwiseXOR:binop("^",4),bitwiseAND:binop("&",5),equality:binop("==/!=/===/!==",6),relational:binop("</>/<=/>=",7),bitShift:binop("<</>>/>>>",8),plusMin:new TokenType("+/-",{beforeExpr:!0,binop:9,prefix:!0,startsExpr:!0}),modulo:binop("%",10),star:binop("*",10),slash:binop("/",10),starstar:new TokenType("**",{beforeExpr:!0}),_break:kw("break"),_case:kw("case",beforeExpr),_catch:kw("catch"),_continue:kw("continue"),_debugger:kw("debugger"),_default:kw("default",beforeExpr),_do:kw("do",{isLoop:!0,beforeExpr:!0}),_else:kw("else",beforeExpr),_finally:kw("finally"),_for:kw("for",{isLoop:!0}),_function:kw("function",startsExpr),_if:kw("if"),_return:kw("return",beforeExpr),_switch:kw("switch"),_throw:kw("throw",beforeExpr),_try:kw("try"),_var:kw("var"),_const:kw("const"),_while:kw("while",{isLoop:!0}),_with:kw("with"),_new:kw("new",{beforeExpr:!0,startsExpr:!0}),_this:kw("this",startsExpr),_super:kw("super",startsExpr),_class:kw("class",startsExpr),_extends:kw("extends",beforeExpr),_export:kw("export"),_import:kw("import"),_null:kw("null",startsExpr),_true:kw("true",startsExpr),_false:kw("false",startsExpr),_in:kw("in",{beforeExpr:!0,binop:7}),_instanceof:kw("instanceof",{beforeExpr:!0,binop:7}),_typeof:kw("typeof",{beforeExpr:!0,prefix:!0,startsExpr:!0}),_void:kw("void",{beforeExpr:!0,prefix:!0,startsExpr:!0}),_delete:kw("delete",{beforeExpr:!0,prefix:!0,startsExpr:!0})},lineBreak=/\r\n?|\n|\u2028|\u2029/,lineBreakG=new RegExp(lineBreak.source,"g");function isNewLine(e,t){return 10===e||13===e||!t&&(8232===e||8233===e)}var nonASCIIwhitespace=/[\u1680\u2000-\u200a\u202f\u205f\u3000\ufeff]/,skipWhiteSpace=/(?:\s|\/\/.*|\/\*[^]*?\*\/)*/g,ref=Object.prototype,hasOwnProperty=ref.hasOwnProperty,toString=ref.toString;function has(e,t){return hasOwnProperty.call(e,t)}var isArray$1=Array.isArray||function(e){return"[object Array]"===toString.call(e)};function wordsRegexp(e){return new RegExp("^(?:"+e.replace(/ /g,"|")+")$")}var Position=function(e,t){this.line=e,this.column=t};Position.prototype.offset=function(e){return new Position(this.line,this.column+e)};var SourceLocation=function(e,t,r){this.start=t,this.end=r,null!==e.sourceFile&&(this.source=e.sourceFile)};function getLineInfo(e,t){for(var r=1,n=0;;){lineBreakG.lastIndex=n;var i=lineBreakG.exec(e);if(!(i&&i.index<t))return new Position(r,t-n);++r,n=i.index+i[0].length}}var defaultOptions={ecmaVersion:9,sourceType:"script",onInsertedSemicolon:null,onTrailingComma:null,allowReserved:null,allowReturnOutsideFunction:!1,allowImportExportEverywhere:!1,allowAwaitOutsideFunction:!1,allowHashBang:!1,locations:!1,onToken:null,onComment:null,ranges:!1,program:null,sourceFile:null,directSourceFile:null,preserveParens:!1};function getOptions(e){var t={};for(var r in defaultOptions)t[r]=e&&has(e,r)?e[r]:defaultOptions[r];if(t.ecmaVersion>=2015&&(t.ecmaVersion-=2009),null==t.allowReserved&&(t.allowReserved=t.ecmaVersion<5),isArray$1(t.onToken)){var n=t.onToken;t.onToken=function(e){return n.push(e)}}return isArray$1(t.onComment)&&(t.onComment=pushComment(t,t.onComment)),t}function pushComment(e,t){return function(r,n,i,s,o,a){var u={type:r?"Block":"Line",value:n,start:i,end:s};e.locations&&(u.loc=new SourceLocation(this,o,a)),e.ranges&&(u.range=[i,s]),t.push(u)}}var SCOPE_TOP=1,SCOPE_FUNCTION=2,SCOPE_VAR=SCOPE_TOP|SCOPE_FUNCTION,SCOPE_ASYNC=4,SCOPE_GENERATOR=8,SCOPE_ARROW=16,SCOPE_SIMPLE_CATCH=32,SCOPE_SUPER=64,SCOPE_DIRECT_SUPER=128;function functionFlags(e,t){return SCOPE_FUNCTION|(e?SCOPE_ASYNC:0)|(t?SCOPE_GENERATOR:0)}var BIND_NONE=0,BIND_VAR=1,BIND_LEXICAL=2,BIND_FUNCTION=3,BIND_SIMPLE_CATCH=4,BIND_OUTSIDE=5,Parser=function(e,t,r){this.options=e=getOptions(e),this.sourceFile=e.sourceFile,this.keywords=wordsRegexp(keywords[e.ecmaVersion>=6?6:5]);var n="";if(!e.allowReserved){for(var i=e.ecmaVersion;!(n=reservedWords[i]);i--);"module"===e.sourceType&&(n+=" await")}this.reservedWords=wordsRegexp(n);var s=(n?n+" ":"")+reservedWords.strict;this.reservedWordsStrict=wordsRegexp(s),this.reservedWordsStrictBind=wordsRegexp(s+" "+reservedWords.strictBind),this.input=String(t),this.containsEsc=!1,r?(this.pos=r,this.lineStart=this.input.lastIndexOf("\n",r-1)+1,this.curLine=this.input.slice(0,this.lineStart).split(lineBreak).length):(this.pos=this.lineStart=0,this.curLine=1),this.type=types.eof,this.value=null,this.start=this.end=this.pos,this.startLoc=this.endLoc=this.curPosition(),this.lastTokEndLoc=this.lastTokStartLoc=null,this.lastTokStart=this.lastTokEnd=this.pos,this.context=this.initialContext(),this.exprAllowed=!0,this.inModule="module"===e.sourceType,this.strict=this.inModule||this.strictDirective(this.pos),this.potentialArrowAt=-1,this.yieldPos=this.awaitPos=this.awaitIdentPos=0,this.labels=[],this.undefinedExports={},0===this.pos&&e.allowHashBang&&"#!"===this.input.slice(0,2)&&this.skipLineComment(2),this.scopeStack=[],this.enterScope(SCOPE_TOP),this.regexpState=null},prototypeAccessors={inFunction:{configurable:!0},inGenerator:{configurable:!0},inAsync:{configurable:!0},allowSuper:{configurable:!0},allowDirectSuper:{configurable:!0},treatFunctionsAsVar:{configurable:!0}};Parser.prototype.parse=function(){var e=this.options.program||this.startNode();return this.nextToken(),this.parseTopLevel(e)},prototypeAccessors.inFunction.get=function(){return(this.currentVarScope().flags&SCOPE_FUNCTION)>0},prototypeAccessors.inGenerator.get=function(){return(this.currentVarScope().flags&SCOPE_GENERATOR)>0},prototypeAccessors.inAsync.get=function(){return(this.currentVarScope().flags&SCOPE_ASYNC)>0},prototypeAccessors.allowSuper.get=function(){return(this.currentThisScope().flags&SCOPE_SUPER)>0},prototypeAccessors.allowDirectSuper.get=function(){return(this.currentThisScope().flags&SCOPE_DIRECT_SUPER)>0},prototypeAccessors.treatFunctionsAsVar.get=function(){return this.treatFunctionsAsVarInScope(this.currentScope())},Parser.prototype.inNonArrowFunction=function(){return(this.currentThisScope().flags&SCOPE_FUNCTION)>0},Parser.extend=function(){for(var e=[],t=arguments.length;t--;)e[t]=arguments[t];for(var r=this,n=0;n<e.length;n++)r=e[n](r);return r},Parser.parse=function(e,t){return new this(t,e).parse()},Parser.parseExpressionAt=function(e,t,r){var n=new this(r,e,t);return n.nextToken(),n.parseExpression()},Parser.tokenizer=function(e,t){return new this(t,e)},Object.defineProperties(Parser.prototype,prototypeAccessors);var pp=Parser.prototype,literal=/^(?:'((?:\\.|[^'])*?)'|"((?:\\.|[^"])*?)")/;function DestructuringErrors(){this.shorthandAssign=this.trailingComma=this.parenthesizedAssign=this.parenthesizedBind=this.doubleProto=-1}pp.strictDirective=function(e){for(;;){skipWhiteSpace.lastIndex=e,e+=skipWhiteSpace.exec(this.input)[0].length;var t=literal.exec(this.input.slice(e));if(!t)return!1;if("use strict"===(t[1]||t[2]))return!0;e+=t[0].length,skipWhiteSpace.lastIndex=e,e+=skipWhiteSpace.exec(this.input)[0].length,";"===this.input[e]&&e++}},pp.eat=function(e){return this.type===e&&(this.next(),!0)},pp.isContextual=function(e){return this.type===types.name&&this.value===e&&!this.containsEsc},pp.eatContextual=function(e){return!!this.isContextual(e)&&(this.next(),!0)},pp.expectContextual=function(e){this.eatContextual(e)||this.unexpected()},pp.canInsertSemicolon=function(){return this.type===types.eof||this.type===types.braceR||lineBreak.test(this.input.slice(this.lastTokEnd,this.start))},pp.insertSemicolon=function(){if(this.canInsertSemicolon())return this.options.onInsertedSemicolon&&this.options.onInsertedSemicolon(this.lastTokEnd,this.lastTokEndLoc),!0},pp.semicolon=function(){this.eat(types.semi)||this.insertSemicolon()||this.unexpected()},pp.afterTrailingComma=function(e,t){if(this.type===e)return this.options.onTrailingComma&&this.options.onTrailingComma(this.lastTokStart,this.lastTokStartLoc),t||this.next(),!0},pp.expect=function(e){this.eat(e)||this.unexpected()},pp.unexpected=function(e){this.raise(null!=e?e:this.start,"Unexpected token")},pp.checkPatternErrors=function(e,t){if(e){e.trailingComma>-1&&this.raiseRecoverable(e.trailingComma,"Comma is not permitted after the rest element");var r=t?e.parenthesizedAssign:e.parenthesizedBind;r>-1&&this.raiseRecoverable(r,"Parenthesized pattern")}},pp.checkExpressionErrors=function(e,t){if(!e)return!1;var r=e.shorthandAssign,n=e.doubleProto;if(!t)return r>=0||n>=0;r>=0&&this.raise(r,"Shorthand property assignments are valid only in destructuring patterns"),n>=0&&this.raiseRecoverable(n,"Redefinition of __proto__ property")},pp.checkYieldAwaitInDefaultParams=function(){this.yieldPos&&(!this.awaitPos||this.yieldPos<this.awaitPos)&&this.raise(this.yieldPos,"Yield expression cannot be a default value"),this.awaitPos&&this.raise(this.awaitPos,"Await expression cannot be a default value")},pp.isSimpleAssignTarget=function(e){return"ParenthesizedExpression"===e.type?this.isSimpleAssignTarget(e.expression):"Identifier"===e.type||"MemberExpression"===e.type};var pp$1=Parser.prototype;pp$1.parseTopLevel=function(e){var t={};for(e.body||(e.body=[]);this.type!==types.eof;){var r=this.parseStatement(null,!0,t);e.body.push(r)}if(this.inModule)for(var n=0,i=Object.keys(this.undefinedExports);n<i.length;n+=1){var s=i[n];this.raiseRecoverable(this.undefinedExports[s].start,"Export '"+s+"' is not defined")}return this.adaptDirectivePrologue(e.body),this.next(),this.options.ecmaVersion>=6&&(e.sourceType=this.options.sourceType),this.finishNode(e,"Program")};var loopLabel={kind:"loop"},switchLabel={kind:"switch"};pp$1.isLet=function(e){if(this.options.ecmaVersion<6||!this.isContextual("let"))return!1;skipWhiteSpace.lastIndex=this.pos;var t=skipWhiteSpace.exec(this.input),r=this.pos+t[0].length,n=this.input.charCodeAt(r);if(91===n)return!0;if(e)return!1;if(123===n)return!0;if(isIdentifierStart(n,!0)){for(var i=r+1;isIdentifierChar(this.input.charCodeAt(i),!0);)++i;var s=this.input.slice(r,i);if(!keywordRelationalOperator.test(s))return!0}return!1},pp$1.isAsyncFunction=function(){if(this.options.ecmaVersion<8||!this.isContextual("async"))return!1;skipWhiteSpace.lastIndex=this.pos;var e=skipWhiteSpace.exec(this.input),t=this.pos+e[0].length;return!(lineBreak.test(this.input.slice(this.pos,t))||"function"!==this.input.slice(t,t+8)||t+8!==this.input.length&&isIdentifierChar(this.input.charAt(t+8)))},pp$1.parseStatement=function(e,t,r){var n,i=this.type,s=this.startNode();switch(this.isLet(e)&&(i=types._var,n="let"),i){case types._break:case types._continue:return this.parseBreakContinueStatement(s,i.keyword);case types._debugger:return this.parseDebuggerStatement(s);case types._do:return this.parseDoStatement(s);case types._for:return this.parseForStatement(s);case types._function:return e&&(this.strict||"if"!==e&&"label"!==e)&&this.options.ecmaVersion>=6&&this.unexpected(),this.parseFunctionStatement(s,!1,!e);case types._class:return e&&this.unexpected(),this.parseClass(s,!0);case types._if:return this.parseIfStatement(s);case types._return:return this.parseReturnStatement(s);case types._switch:return this.parseSwitchStatement(s);case types._throw:return this.parseThrowStatement(s);case types._try:return this.parseTryStatement(s);case types._const:case types._var:return n=n||this.value,e&&"var"!==n&&this.unexpected(),this.parseVarStatement(s,n);case types._while:return this.parseWhileStatement(s);case types._with:return this.parseWithStatement(s);case types.braceL:return this.parseBlock(!0,s);case types.semi:return this.parseEmptyStatement(s);case types._export:case types._import:return this.options.allowImportExportEverywhere||(t||this.raise(this.start,"'import' and 'export' may only appear at the top level"),this.inModule||this.raise(this.start,"'import' and 'export' may appear only with 'sourceType: module'")),i===types._import?this.parseImport(s):this.parseExport(s,r);default:if(this.isAsyncFunction())return e&&this.unexpected(),this.next(),this.parseFunctionStatement(s,!0,!e);var o=this.value,a=this.parseExpression();return i===types.name&&"Identifier"===a.type&&this.eat(types.colon)?this.parseLabeledStatement(s,o,a,e):this.parseExpressionStatement(s,a)}},pp$1.parseBreakContinueStatement=function(e,t){var r="break"===t;this.next(),this.eat(types.semi)||this.insertSemicolon()?e.label=null:this.type!==types.name?this.unexpected():(e.label=this.parseIdent(),this.semicolon());for(var n=0;n<this.labels.length;++n){var i=this.labels[n];if(null==e.label||i.name===e.label.name){if(null!=i.kind&&(r||"loop"===i.kind))break;if(e.label&&r)break}}return n===this.labels.length&&this.raise(e.start,"Unsyntactic "+t),this.finishNode(e,r?"BreakStatement":"ContinueStatement")},pp$1.parseDebuggerStatement=function(e){return this.next(),this.semicolon(),this.finishNode(e,"DebuggerStatement")},pp$1.parseDoStatement=function(e){return this.next(),this.labels.push(loopLabel),e.body=this.parseStatement("do"),this.labels.pop(),this.expect(types._while),e.test=this.parseParenExpression(),this.options.ecmaVersion>=6?this.eat(types.semi):this.semicolon(),this.finishNode(e,"DoWhileStatement")},pp$1.parseForStatement=function(e){this.next();var t=this.options.ecmaVersion>=9&&(this.inAsync||!this.inFunction&&this.options.allowAwaitOutsideFunction)&&this.eatContextual("await")?this.lastTokStart:-1;if(this.labels.push(loopLabel),this.enterScope(0),this.expect(types.parenL),this.type===types.semi)return t>-1&&this.unexpected(t),this.parseFor(e,null);var r=this.isLet();if(this.type===types._var||this.type===types._const||r){var n=this.startNode(),i=r?"let":this.value;return this.next(),this.parseVar(n,!0,i),this.finishNode(n,"VariableDeclaration"),!(this.type===types._in||this.options.ecmaVersion>=6&&this.isContextual("of"))||1!==n.declarations.length||"var"!==i&&n.declarations[0].init?(t>-1&&this.unexpected(t),this.parseFor(e,n)):(this.options.ecmaVersion>=9&&(this.type===types._in?t>-1&&this.unexpected(t):e.await=t>-1),this.parseForIn(e,n))}var s=new DestructuringErrors,o=this.parseExpression(!0,s);return this.type===types._in||this.options.ecmaVersion>=6&&this.isContextual("of")?(this.options.ecmaVersion>=9&&(this.type===types._in?t>-1&&this.unexpected(t):e.await=t>-1),this.toAssignable(o,!1,s),this.checkLVal(o),this.parseForIn(e,o)):(this.checkExpressionErrors(s,!0),t>-1&&this.unexpected(t),this.parseFor(e,o))},pp$1.parseFunctionStatement=function(e,t,r){return this.next(),this.parseFunction(e,FUNC_STATEMENT|(r?0:FUNC_HANGING_STATEMENT),!1,t)},pp$1.parseIfStatement=function(e){return this.next(),e.test=this.parseParenExpression(),e.consequent=this.parseStatement("if"),e.alternate=this.eat(types._else)?this.parseStatement("if"):null,this.finishNode(e,"IfStatement")},pp$1.parseReturnStatement=function(e){return this.inFunction||this.options.allowReturnOutsideFunction||this.raise(this.start,"'return' outside of function"),this.next(),this.eat(types.semi)||this.insertSemicolon()?e.argument=null:(e.argument=this.parseExpression(),this.semicolon()),this.finishNode(e,"ReturnStatement")},pp$1.parseSwitchStatement=function(e){var t;this.next(),e.discriminant=this.parseParenExpression(),e.cases=[],this.expect(types.braceL),this.labels.push(switchLabel),this.enterScope(0);for(var r=!1;this.type!==types.braceR;)if(this.type===types._case||this.type===types._default){var n=this.type===types._case;t&&this.finishNode(t,"SwitchCase"),e.cases.push(t=this.startNode()),t.consequent=[],this.next(),n?t.test=this.parseExpression():(r&&this.raiseRecoverable(this.lastTokStart,"Multiple default clauses"),r=!0,t.test=null),this.expect(types.colon)}else t||this.unexpected(),t.consequent.push(this.parseStatement(null));return this.exitScope(),t&&this.finishNode(t,"SwitchCase"),this.next(),this.labels.pop(),this.finishNode(e,"SwitchStatement")},pp$1.parseThrowStatement=function(e){return this.next(),lineBreak.test(this.input.slice(this.lastTokEnd,this.start))&&this.raise(this.lastTokEnd,"Illegal newline after throw"),e.argument=this.parseExpression(),this.semicolon(),this.finishNode(e,"ThrowStatement")};var empty=[];pp$1.parseTryStatement=function(e){if(this.next(),e.block=this.parseBlock(),e.handler=null,this.type===types._catch){var t=this.startNode();if(this.next(),this.eat(types.parenL)){t.param=this.parseBindingAtom();var r="Identifier"===t.param.type;this.enterScope(r?SCOPE_SIMPLE_CATCH:0),this.checkLVal(t.param,r?BIND_SIMPLE_CATCH:BIND_LEXICAL),this.expect(types.parenR)}else this.options.ecmaVersion<10&&this.unexpected(),t.param=null,this.enterScope(0);t.body=this.parseBlock(!1),this.exitScope(),e.handler=this.finishNode(t,"CatchClause")}return e.finalizer=this.eat(types._finally)?this.parseBlock():null,e.handler||e.finalizer||this.raise(e.start,"Missing catch or finally clause"),this.finishNode(e,"TryStatement")},pp$1.parseVarStatement=function(e,t){return this.next(),this.parseVar(e,!1,t),this.semicolon(),this.finishNode(e,"VariableDeclaration")},pp$1.parseWhileStatement=function(e){return this.next(),e.test=this.parseParenExpression(),this.labels.push(loopLabel),e.body=this.parseStatement("while"),this.labels.pop(),this.finishNode(e,"WhileStatement")},pp$1.parseWithStatement=function(e){return this.strict&&this.raise(this.start,"'with' in strict mode"),this.next(),e.object=this.parseParenExpression(),e.body=this.parseStatement("with"),this.finishNode(e,"WithStatement")},pp$1.parseEmptyStatement=function(e){return this.next(),this.finishNode(e,"EmptyStatement")},pp$1.parseLabeledStatement=function(e,t,r,n){for(var i=0,s=this.labels;i<s.length;i+=1){s[i].name===t&&this.raise(r.start,"Label '"+t+"' is already declared")}for(var o=this.type.isLoop?"loop":this.type===types._switch?"switch":null,a=this.labels.length-1;a>=0;a--){var u=this.labels[a];if(u.statementStart!==e.start)break;u.statementStart=this.start,u.kind=o}return this.labels.push({name:t,kind:o,statementStart:this.start}),e.body=this.parseStatement(n?-1===n.indexOf("label")?n+"label":n:"label"),this.labels.pop(),e.label=r,this.finishNode(e,"LabeledStatement")},pp$1.parseExpressionStatement=function(e,t){return e.expression=t,this.semicolon(),this.finishNode(e,"ExpressionStatement")},pp$1.parseBlock=function(e,t){for(void 0===e&&(e=!0),void 0===t&&(t=this.startNode()),t.body=[],this.expect(types.braceL),e&&this.enterScope(0);!this.eat(types.braceR);){var r=this.parseStatement(null);t.body.push(r)}return e&&this.exitScope(),this.finishNode(t,"BlockStatement")},pp$1.parseFor=function(e,t){return e.init=t,this.expect(types.semi),e.test=this.type===types.semi?null:this.parseExpression(),this.expect(types.semi),e.update=this.type===types.parenR?null:this.parseExpression(),this.expect(types.parenR),e.body=this.parseStatement("for"),this.exitScope(),this.labels.pop(),this.finishNode(e,"ForStatement")},pp$1.parseForIn=function(e,t){var r=this.type===types._in?"ForInStatement":"ForOfStatement";return this.next(),"ForInStatement"===r&&("AssignmentPattern"===t.type||"VariableDeclaration"===t.type&&null!=t.declarations[0].init&&(this.strict||"Identifier"!==t.declarations[0].id.type))&&this.raise(t.start,"Invalid assignment in for-in loop head"),e.left=t,e.right="ForInStatement"===r?this.parseExpression():this.parseMaybeAssign(),this.expect(types.parenR),e.body=this.parseStatement("for"),this.exitScope(),this.labels.pop(),this.finishNode(e,r)},pp$1.parseVar=function(e,t,r){for(e.declarations=[],e.kind=r;;){var n=this.startNode();if(this.parseVarId(n,r),this.eat(types.eq)?n.init=this.parseMaybeAssign(t):"const"!==r||this.type===types._in||this.options.ecmaVersion>=6&&this.isContextual("of")?"Identifier"===n.id.type||t&&(this.type===types._in||this.isContextual("of"))?n.init=null:this.raise(this.lastTokEnd,"Complex binding patterns require an initialization value"):this.unexpected(),e.declarations.push(this.finishNode(n,"VariableDeclarator")),!this.eat(types.comma))break}return e},pp$1.parseVarId=function(e,t){"const"!==t&&"let"!==t||!this.isContextual("let")||this.raiseRecoverable(this.start,"let is disallowed as a lexically bound name"),e.id=this.parseBindingAtom(),this.checkLVal(e.id,"var"===t?BIND_VAR:BIND_LEXICAL,!1)};var FUNC_STATEMENT=1,FUNC_HANGING_STATEMENT=2,FUNC_NULLABLE_ID=4;pp$1.parseFunction=function(e,t,r,n){this.initFunction(e),(this.options.ecmaVersion>=9||this.options.ecmaVersion>=6&&!n)&&(this.type===types.star&&t&FUNC_HANGING_STATEMENT&&this.unexpected(),e.generator=this.eat(types.star)),this.options.ecmaVersion>=8&&(e.async=!!n),t&FUNC_STATEMENT&&(e.id=t&FUNC_NULLABLE_ID&&this.type!==types.name?null:this.parseIdent(),!e.id||t&FUNC_HANGING_STATEMENT||this.checkLVal(e.id,this.strict||e.generator||e.async?this.treatFunctionsAsVar?BIND_VAR:BIND_LEXICAL:BIND_FUNCTION));var i=this.yieldPos,s=this.awaitPos,o=this.awaitIdentPos;return this.yieldPos=0,this.awaitPos=0,this.awaitIdentPos=0,this.enterScope(functionFlags(e.async,e.generator)),t&FUNC_STATEMENT||(e.id=this.type===types.name?this.parseIdent():null),this.parseFunctionParams(e),this.parseFunctionBody(e,r,!1),this.yieldPos=i,this.awaitPos=s,this.awaitIdentPos=o,this.finishNode(e,t&FUNC_STATEMENT?"FunctionDeclaration":"FunctionExpression")},pp$1.parseFunctionParams=function(e){this.expect(types.parenL),e.params=this.parseBindingList(types.parenR,!1,this.options.ecmaVersion>=8),this.checkYieldAwaitInDefaultParams()},pp$1.parseClass=function(e,t){this.next();var r=this.strict;this.strict=!0,this.parseClassId(e,t),this.parseClassSuper(e);var n=this.startNode(),i=!1;for(n.body=[],this.expect(types.braceL);!this.eat(types.braceR);){var s=this.parseClassElement(null!==e.superClass);s&&(n.body.push(s),"MethodDefinition"===s.type&&"constructor"===s.kind&&(i&&this.raise(s.start,"Duplicate constructor in the same class"),i=!0))}return e.body=this.finishNode(n,"ClassBody"),this.strict=r,this.finishNode(e,t?"ClassDeclaration":"ClassExpression")},pp$1.parseClassElement=function(e){var t=this;if(this.eat(types.semi))return null;var r=this.startNode(),n=function(e,n){void 0===n&&(n=!1);var i=t.start,s=t.startLoc;return!!t.eatContextual(e)&&(!(t.type===types.parenL||n&&t.canInsertSemicolon())||(r.key&&t.unexpected(),r.computed=!1,r.key=t.startNodeAt(i,s),r.key.name=e,t.finishNode(r.key,"Identifier"),!1))};r.kind="method",r.static=n("static");var i=this.eat(types.star),s=!1;i||(this.options.ecmaVersion>=8&&n("async",!0)?(s=!0,i=this.options.ecmaVersion>=9&&this.eat(types.star)):n("get")?r.kind="get":n("set")&&(r.kind="set")),r.key||this.parsePropertyName(r);var o=r.key,a=!1;return r.computed||r.static||!("Identifier"===o.type&&"constructor"===o.name||"Literal"===o.type&&"constructor"===o.value)?r.static&&"Identifier"===o.type&&"prototype"===o.name&&this.raise(o.start,"Classes may not have a static property named prototype"):("method"!==r.kind&&this.raise(o.start,"Constructor can't have get/set modifier"),i&&this.raise(o.start,"Constructor can't be a generator"),s&&this.raise(o.start,"Constructor can't be an async method"),r.kind="constructor",a=e),this.parseClassMethod(r,i,s,a),"get"===r.kind&&0!==r.value.params.length&&this.raiseRecoverable(r.value.start,"getter should have no params"),"set"===r.kind&&1!==r.value.params.length&&this.raiseRecoverable(r.value.start,"setter should have exactly one param"),"set"===r.kind&&"RestElement"===r.value.params[0].type&&this.raiseRecoverable(r.value.params[0].start,"Setter cannot use rest params"),r},pp$1.parseClassMethod=function(e,t,r,n){return e.value=this.parseMethod(t,r,n),this.finishNode(e,"MethodDefinition")},pp$1.parseClassId=function(e,t){this.type===types.name?(e.id=this.parseIdent(),t&&this.checkLVal(e.id,BIND_LEXICAL,!1)):(!0===t&&this.unexpected(),e.id=null)},pp$1.parseClassSuper=function(e){e.superClass=this.eat(types._extends)?this.parseExprSubscripts():null},pp$1.parseExport=function(e,t){if(this.next(),this.eat(types.star))return this.expectContextual("from"),this.type!==types.string&&this.unexpected(),e.source=this.parseExprAtom(),this.semicolon(),this.finishNode(e,"ExportAllDeclaration");if(this.eat(types._default)){var r;if(this.checkExport(t,"default",this.lastTokStart),this.type===types._function||(r=this.isAsyncFunction())){var n=this.startNode();this.next(),r&&this.next(),e.declaration=this.parseFunction(n,FUNC_STATEMENT|FUNC_NULLABLE_ID,!1,r)}else if(this.type===types._class){var i=this.startNode();e.declaration=this.parseClass(i,"nullableID")}else e.declaration=this.parseMaybeAssign(),this.semicolon();return this.finishNode(e,"ExportDefaultDeclaration")}if(this.shouldParseExportStatement())e.declaration=this.parseStatement(null),"VariableDeclaration"===e.declaration.type?this.checkVariableExport(t,e.declaration.declarations):this.checkExport(t,e.declaration.id.name,e.declaration.id.start),e.specifiers=[],e.source=null;else{if(e.declaration=null,e.specifiers=this.parseExportSpecifiers(t),this.eatContextual("from"))this.type!==types.string&&this.unexpected(),e.source=this.parseExprAtom();else{for(var s=0,o=e.specifiers;s<o.length;s+=1){var a=o[s];this.checkUnreserved(a.local),this.checkLocalExport(a.local)}e.source=null}this.semicolon()}return this.finishNode(e,"ExportNamedDeclaration")},pp$1.checkExport=function(e,t,r){e&&(has(e,t)&&this.raiseRecoverable(r,"Duplicate export '"+t+"'"),e[t]=!0)},pp$1.checkPatternExport=function(e,t){var r=t.type;if("Identifier"===r)this.checkExport(e,t.name,t.start);else if("ObjectPattern"===r)for(var n=0,i=t.properties;n<i.length;n+=1){var s=i[n];this.checkPatternExport(e,s)}else if("ArrayPattern"===r)for(var o=0,a=t.elements;o<a.length;o+=1){var u=a[o];u&&this.checkPatternExport(e,u)}else"Property"===r?this.checkPatternExport(e,t.value):"AssignmentPattern"===r?this.checkPatternExport(e,t.left):"RestElement"===r?this.checkPatternExport(e,t.argument):"ParenthesizedExpression"===r&&this.checkPatternExport(e,t.expression)},pp$1.checkVariableExport=function(e,t){if(e)for(var r=0,n=t;r<n.length;r+=1){var i=n[r];this.checkPatternExport(e,i.id)}},pp$1.shouldParseExportStatement=function(){return"var"===this.type.keyword||"const"===this.type.keyword||"class"===this.type.keyword||"function"===this.type.keyword||this.isLet()||this.isAsyncFunction()},pp$1.parseExportSpecifiers=function(e){var t=[],r=!0;for(this.expect(types.braceL);!this.eat(types.braceR);){if(r)r=!1;else if(this.expect(types.comma),this.afterTrailingComma(types.braceR))break;var n=this.startNode();n.local=this.parseIdent(!0),n.exported=this.eatContextual("as")?this.parseIdent(!0):n.local,this.checkExport(e,n.exported.name,n.exported.start),t.push(this.finishNode(n,"ExportSpecifier"))}return t},pp$1.parseImport=function(e){return this.next(),this.type===types.string?(e.specifiers=empty,e.source=this.parseExprAtom()):(e.specifiers=this.parseImportSpecifiers(),this.expectContextual("from"),e.source=this.type===types.string?this.parseExprAtom():this.unexpected()),this.semicolon(),this.finishNode(e,"ImportDeclaration")},pp$1.parseImportSpecifiers=function(){var e=[],t=!0;if(this.type===types.name){var r=this.startNode();if(r.local=this.parseIdent(),this.checkLVal(r.local,BIND_LEXICAL),e.push(this.finishNode(r,"ImportDefaultSpecifier")),!this.eat(types.comma))return e}if(this.type===types.star){var n=this.startNode();return this.next(),this.expectContextual("as"),n.local=this.parseIdent(),this.checkLVal(n.local,BIND_LEXICAL),e.push(this.finishNode(n,"ImportNamespaceSpecifier")),e}for(this.expect(types.braceL);!this.eat(types.braceR);){if(t)t=!1;else if(this.expect(types.comma),this.afterTrailingComma(types.braceR))break;var i=this.startNode();i.imported=this.parseIdent(!0),this.eatContextual("as")?i.local=this.parseIdent():(this.checkUnreserved(i.imported),i.local=i.imported),this.checkLVal(i.local,BIND_LEXICAL),e.push(this.finishNode(i,"ImportSpecifier"))}return e},pp$1.adaptDirectivePrologue=function(e){for(var t=0;t<e.length&&this.isDirectiveCandidate(e[t]);++t)e[t].directive=e[t].expression.raw.slice(1,-1)},pp$1.isDirectiveCandidate=function(e){return"ExpressionStatement"===e.type&&"Literal"===e.expression.type&&"string"==typeof e.expression.value&&('"'===this.input[e.start]||"'"===this.input[e.start])};var pp$2=Parser.prototype;pp$2.toAssignable=function(e,t,r){if(this.options.ecmaVersion>=6&&e)switch(e.type){case"Identifier":this.inAsync&&"await"===e.name&&this.raise(e.start,"Cannot use 'await' as identifier inside an async function");break;case"ObjectPattern":case"ArrayPattern":case"RestElement":break;case"ObjectExpression":e.type="ObjectPattern",r&&this.checkPatternErrors(r,!0);for(var n=0,i=e.properties;n<i.length;n+=1){var s=i[n];this.toAssignable(s,t),"RestElement"!==s.type||"ArrayPattern"!==s.argument.type&&"ObjectPattern"!==s.argument.type||this.raise(s.argument.start,"Unexpected token")}break;case"Property":"init"!==e.kind&&this.raise(e.key.start,"Object pattern can't contain getter or setter"),this.toAssignable(e.value,t);break;case"ArrayExpression":e.type="ArrayPattern",r&&this.checkPatternErrors(r,!0),this.toAssignableList(e.elements,t);break;case"SpreadElement":e.type="RestElement",this.toAssignable(e.argument,t),"AssignmentPattern"===e.argument.type&&this.raise(e.argument.start,"Rest elements cannot have a default value");break;case"AssignmentExpression":"="!==e.operator&&this.raise(e.left.end,"Only '=' operator can be used for specifying default value."),e.type="AssignmentPattern",delete e.operator,this.toAssignable(e.left,t);case"AssignmentPattern":break;case"ParenthesizedExpression":this.toAssignable(e.expression,t,r);break;case"MemberExpression":if(!t)break;default:this.raise(e.start,"Assigning to rvalue")}else r&&this.checkPatternErrors(r,!0);return e},pp$2.toAssignableList=function(e,t){for(var r=e.length,n=0;n<r;n++){var i=e[n];i&&this.toAssignable(i,t)}if(r){var s=e[r-1];6===this.options.ecmaVersion&&t&&s&&"RestElement"===s.type&&"Identifier"!==s.argument.type&&this.unexpected(s.argument.start)}return e},pp$2.parseSpread=function(e){var t=this.startNode();return this.next(),t.argument=this.parseMaybeAssign(!1,e),this.finishNode(t,"SpreadElement")},pp$2.parseRestBinding=function(){var e=this.startNode();return this.next(),6===this.options.ecmaVersion&&this.type!==types.name&&this.unexpected(),e.argument=this.parseBindingAtom(),this.finishNode(e,"RestElement")},pp$2.parseBindingAtom=function(){if(this.options.ecmaVersion>=6)switch(this.type){case types.bracketL:var e=this.startNode();return this.next(),e.elements=this.parseBindingList(types.bracketR,!0,!0),this.finishNode(e,"ArrayPattern");case types.braceL:return this.parseObj(!0)}return this.parseIdent()},pp$2.parseBindingList=function(e,t,r){for(var n=[],i=!0;!this.eat(e);)if(i?i=!1:this.expect(types.comma),t&&this.type===types.comma)n.push(null);else{if(r&&this.afterTrailingComma(e))break;if(this.type===types.ellipsis){var s=this.parseRestBinding();this.parseBindingListItem(s),n.push(s),this.type===types.comma&&this.raise(this.start,"Comma is not permitted after the rest element"),this.expect(e);break}var o=this.parseMaybeDefault(this.start,this.startLoc);this.parseBindingListItem(o),n.push(o)}return n},pp$2.parseBindingListItem=function(e){return e},pp$2.parseMaybeDefault=function(e,t,r){if(r=r||this.parseBindingAtom(),this.options.ecmaVersion<6||!this.eat(types.eq))return r;var n=this.startNodeAt(e,t);return n.left=r,n.right=this.parseMaybeAssign(),this.finishNode(n,"AssignmentPattern")},pp$2.checkLVal=function(e,t,r){switch(void 0===t&&(t=BIND_NONE),e.type){case"Identifier":this.strict&&this.reservedWordsStrictBind.test(e.name)&&this.raiseRecoverable(e.start,(t?"Binding ":"Assigning to ")+e.name+" in strict mode"),r&&(has(r,e.name)&&this.raiseRecoverable(e.start,"Argument name clash"),r[e.name]=!0),t!==BIND_NONE&&t!==BIND_OUTSIDE&&this.declareName(e.name,t,e.start);break;case"MemberExpression":t&&this.raiseRecoverable(e.start,"Binding member expression");break;case"ObjectPattern":for(var n=0,i=e.properties;n<i.length;n+=1){var s=i[n];this.checkLVal(s,t,r)}break;case"Property":this.checkLVal(e.value,t,r);break;case"ArrayPattern":for(var o=0,a=e.elements;o<a.length;o+=1){var u=a[o];u&&this.checkLVal(u,t,r)}break;case"AssignmentPattern":this.checkLVal(e.left,t,r);break;case"RestElement":this.checkLVal(e.argument,t,r);break;case"ParenthesizedExpression":this.checkLVal(e.expression,t,r);break;default:this.raise(e.start,(t?"Binding":"Assigning to")+" rvalue")}};var pp$3=Parser.prototype;pp$3.checkPropClash=function(e,t,r){if(!(this.options.ecmaVersion>=9&&"SpreadElement"===e.type||this.options.ecmaVersion>=6&&(e.computed||e.method||e.shorthand))){var n,i=e.key;switch(i.type){case"Identifier":n=i.name;break;case"Literal":n=String(i.value);break;default:return}var s=e.kind;if(this.options.ecmaVersion>=6)"__proto__"===n&&"init"===s&&(t.proto&&(r&&r.doubleProto<0?r.doubleProto=i.start:this.raiseRecoverable(i.start,"Redefinition of __proto__ property")),t.proto=!0);else{var o=t[n="$"+n];if(o)("init"===s?this.strict&&o.init||o.get||o.set:o.init||o[s])&&this.raiseRecoverable(i.start,"Redefinition of property");else o=t[n]={init:!1,get:!1,set:!1};o[s]=!0}}},pp$3.parseExpression=function(e,t){var r=this.start,n=this.startLoc,i=this.parseMaybeAssign(e,t);if(this.type===types.comma){var s=this.startNodeAt(r,n);for(s.expressions=[i];this.eat(types.comma);)s.expressions.push(this.parseMaybeAssign(e,t));return this.finishNode(s,"SequenceExpression")}return i},pp$3.parseMaybeAssign=function(e,t,r){if(this.isContextual("yield")){if(this.inGenerator)return this.parseYield(e);this.exprAllowed=!1}var n=!1,i=-1,s=-1,o=-1;t?(i=t.parenthesizedAssign,s=t.trailingComma,o=t.shorthandAssign,t.parenthesizedAssign=t.trailingComma=t.shorthandAssign=-1):(t=new DestructuringErrors,n=!0);var a=this.start,u=this.startLoc;this.type!==types.parenL&&this.type!==types.name||(this.potentialArrowAt=this.start);var c=this.parseMaybeConditional(e,t);if(r&&(c=r.call(this,c,a,u)),this.type.isAssign){var p=this.startNodeAt(a,u);return p.operator=this.value,p.left=this.type===types.eq?this.toAssignable(c,!1,t):c,n||DestructuringErrors.call(t),t.shorthandAssign=-1,this.checkLVal(c),this.next(),p.right=this.parseMaybeAssign(e),this.finishNode(p,"AssignmentExpression")}return n&&this.checkExpressionErrors(t,!0),i>-1&&(t.parenthesizedAssign=i),s>-1&&(t.trailingComma=s),o>-1&&(t.shorthandAssign=o),c},pp$3.parseMaybeConditional=function(e,t){var r=this.start,n=this.startLoc,i=this.parseExprOps(e,t);if(this.checkExpressionErrors(t))return i;if(this.eat(types.question)){var s=this.startNodeAt(r,n);return s.test=i,s.consequent=this.parseMaybeAssign(),this.expect(types.colon),s.alternate=this.parseMaybeAssign(e),this.finishNode(s,"ConditionalExpression")}return i},pp$3.parseExprOps=function(e,t){var r=this.start,n=this.startLoc,i=this.parseMaybeUnary(t,!1);return this.checkExpressionErrors(t)?i:i.start===r&&"ArrowFunctionExpression"===i.type?i:this.parseExprOp(i,r,n,-1,e)},pp$3.parseExprOp=function(e,t,r,n,i){var s=this.type.binop;if(null!=s&&(!i||this.type!==types._in)&&s>n){var o=this.type===types.logicalOR||this.type===types.logicalAND,a=this.value;this.next();var u=this.start,c=this.startLoc,p=this.parseExprOp(this.parseMaybeUnary(null,!1),u,c,s,i),l=this.buildBinary(t,r,e,p,a,o);return this.parseExprOp(l,t,r,n,i)}return e},pp$3.buildBinary=function(e,t,r,n,i,s){var o=this.startNodeAt(e,t);return o.left=r,o.operator=i,o.right=n,this.finishNode(o,s?"LogicalExpression":"BinaryExpression")},pp$3.parseMaybeUnary=function(e,t){var r,n=this.start,i=this.startLoc;if(this.isContextual("await")&&(this.inAsync||!this.inFunction&&this.options.allowAwaitOutsideFunction))r=this.parseAwait(),t=!0;else if(this.type.prefix){var s=this.startNode(),o=this.type===types.incDec;s.operator=this.value,s.prefix=!0,this.next(),s.argument=this.parseMaybeUnary(null,!0),this.checkExpressionErrors(e,!0),o?this.checkLVal(s.argument):this.strict&&"delete"===s.operator&&"Identifier"===s.argument.type?this.raiseRecoverable(s.start,"Deleting local variable in strict mode"):t=!0,r=this.finishNode(s,o?"UpdateExpression":"UnaryExpression")}else{if(r=this.parseExprSubscripts(e),this.checkExpressionErrors(e))return r;for(;this.type.postfix&&!this.canInsertSemicolon();){var a=this.startNodeAt(n,i);a.operator=this.value,a.prefix=!1,a.argument=r,this.checkLVal(r),this.next(),r=this.finishNode(a,"UpdateExpression")}}return!t&&this.eat(types.starstar)?this.buildBinary(n,i,r,this.parseMaybeUnary(null,!1),"**",!1):r},pp$3.parseExprSubscripts=function(e){var t=this.start,r=this.startLoc,n=this.parseExprAtom(e),i="ArrowFunctionExpression"===n.type&&")"!==this.input.slice(this.lastTokStart,this.lastTokEnd);if(this.checkExpressionErrors(e)||i)return n;var s=this.parseSubscripts(n,t,r);return e&&"MemberExpression"===s.type&&(e.parenthesizedAssign>=s.start&&(e.parenthesizedAssign=-1),e.parenthesizedBind>=s.start&&(e.parenthesizedBind=-1)),s},pp$3.parseSubscripts=function(e,t,r,n){for(var i=this.options.ecmaVersion>=8&&"Identifier"===e.type&&"async"===e.name&&this.lastTokEnd===e.end&&!this.canInsertSemicolon()&&"async"===this.input.slice(e.start,e.end);;){var s=this.parseSubscript(e,t,r,n,i);if(s===e||"ArrowFunctionExpression"===s.type)return s;e=s}},pp$3.parseSubscript=function(e,t,r,n,i){var s=this.eat(types.bracketL);if(s||this.eat(types.dot)){var o=this.startNodeAt(t,r);o.object=e,o.property=s?this.parseExpression():this.parseIdent(!0),o.computed=!!s,s&&this.expect(types.bracketR),e=this.finishNode(o,"MemberExpression")}else if(!n&&this.eat(types.parenL)){var a=new DestructuringErrors,u=this.yieldPos,c=this.awaitPos,p=this.awaitIdentPos;this.yieldPos=0,this.awaitPos=0,this.awaitIdentPos=0;var l=this.parseExprList(types.parenR,this.options.ecmaVersion>=8,!1,a);if(i&&!this.canInsertSemicolon()&&this.eat(types.arrow))return this.checkPatternErrors(a,!1),this.checkYieldAwaitInDefaultParams(),this.awaitIdentPos>0&&this.raise(this.awaitIdentPos,"Cannot use 'await' as identifier inside an async function"),this.yieldPos=u,this.awaitPos=c,this.awaitIdentPos=p,this.parseArrowExpression(this.startNodeAt(t,r),l,!0);this.checkExpressionErrors(a,!0),this.yieldPos=u||this.yieldPos,this.awaitPos=c||this.awaitPos,this.awaitIdentPos=p||this.awaitIdentPos;var h=this.startNodeAt(t,r);h.callee=e,h.arguments=l,e=this.finishNode(h,"CallExpression")}else if(this.type===types.backQuote){var f=this.startNodeAt(t,r);f.tag=e,f.quasi=this.parseTemplate({isTagged:!0}),e=this.finishNode(f,"TaggedTemplateExpression")}return e},pp$3.parseExprAtom=function(e){this.type===types.slash&&this.readRegexp();var t,r=this.potentialArrowAt===this.start;switch(this.type){case types._super:return this.allowSuper||this.raise(this.start,"'super' keyword outside a method"),t=this.startNode(),this.next(),this.type!==types.parenL||this.allowDirectSuper||this.raise(t.start,"super() call outside constructor of a subclass"),this.type!==types.dot&&this.type!==types.bracketL&&this.type!==types.parenL&&this.unexpected(),this.finishNode(t,"Super");case types._this:return t=this.startNode(),this.next(),this.finishNode(t,"ThisExpression");case types.name:var n=this.start,i=this.startLoc,s=this.containsEsc,o=this.parseIdent(!1);if(this.options.ecmaVersion>=8&&!s&&"async"===o.name&&!this.canInsertSemicolon()&&this.eat(types._function))return this.parseFunction(this.startNodeAt(n,i),0,!1,!0);if(r&&!this.canInsertSemicolon()){if(this.eat(types.arrow))return this.parseArrowExpression(this.startNodeAt(n,i),[o],!1);if(this.options.ecmaVersion>=8&&"async"===o.name&&this.type===types.name&&!s)return o=this.parseIdent(!1),!this.canInsertSemicolon()&&this.eat(types.arrow)||this.unexpected(),this.parseArrowExpression(this.startNodeAt(n,i),[o],!0)}return o;case types.regexp:var a=this.value;return(t=this.parseLiteral(a.value)).regex={pattern:a.pattern,flags:a.flags},t;case types.num:case types.string:return this.parseLiteral(this.value);case types._null:case types._true:case types._false:return(t=this.startNode()).value=this.type===types._null?null:this.type===types._true,t.raw=this.type.keyword,this.next(),this.finishNode(t,"Literal");case types.parenL:var u=this.start,c=this.parseParenAndDistinguishExpression(r);return e&&(e.parenthesizedAssign<0&&!this.isSimpleAssignTarget(c)&&(e.parenthesizedAssign=u),e.parenthesizedBind<0&&(e.parenthesizedBind=u)),c;case types.bracketL:return t=this.startNode(),this.next(),t.elements=this.parseExprList(types.bracketR,!0,!0,e),this.finishNode(t,"ArrayExpression");case types.braceL:return this.parseObj(!1,e);case types._function:return t=this.startNode(),this.next(),this.parseFunction(t,0);case types._class:return this.parseClass(this.startNode(),!1);case types._new:return this.parseNew();case types.backQuote:return this.parseTemplate();default:this.unexpected()}},pp$3.parseLiteral=function(e){var t=this.startNode();return t.value=e,t.raw=this.input.slice(this.start,this.end),this.next(),this.finishNode(t,"Literal")},pp$3.parseParenExpression=function(){this.expect(types.parenL);var e=this.parseExpression();return this.expect(types.parenR),e},pp$3.parseParenAndDistinguishExpression=function(e){var t,r=this.start,n=this.startLoc,i=this.options.ecmaVersion>=8;if(this.options.ecmaVersion>=6){this.next();var s,o=this.start,a=this.startLoc,u=[],c=!0,p=!1,l=new DestructuringErrors,h=this.yieldPos,f=this.awaitPos;for(this.yieldPos=0,this.awaitPos=0;this.type!==types.parenR;){if(c?c=!1:this.expect(types.comma),i&&this.afterTrailingComma(types.parenR,!0)){p=!0;break}if(this.type===types.ellipsis){s=this.start,u.push(this.parseParenItem(this.parseRestBinding())),this.type===types.comma&&this.raise(this.start,"Comma is not permitted after the rest element");break}u.push(this.parseMaybeAssign(!1,l,this.parseParenItem))}var d=this.start,m=this.startLoc;if(this.expect(types.parenR),e&&!this.canInsertSemicolon()&&this.eat(types.arrow))return this.checkPatternErrors(l,!1),this.checkYieldAwaitInDefaultParams(),this.yieldPos=h,this.awaitPos=f,this.parseParenArrowList(r,n,u);u.length&&!p||this.unexpected(this.lastTokStart),s&&this.unexpected(s),this.checkExpressionErrors(l,!0),this.yieldPos=h||this.yieldPos,this.awaitPos=f||this.awaitPos,u.length>1?((t=this.startNodeAt(o,a)).expressions=u,this.finishNodeAt(t,"SequenceExpression",d,m)):t=u[0]}else t=this.parseParenExpression();if(this.options.preserveParens){var g=this.startNodeAt(r,n);return g.expression=t,this.finishNode(g,"ParenthesizedExpression")}return t},pp$3.parseParenItem=function(e){return e},pp$3.parseParenArrowList=function(e,t,r){return this.parseArrowExpression(this.startNodeAt(e,t),r)};var empty$1=[];pp$3.parseNew=function(){var e=this.startNode(),t=this.parseIdent(!0);if(this.options.ecmaVersion>=6&&this.eat(types.dot)){e.meta=t;var r=this.containsEsc;return e.property=this.parseIdent(!0),("target"!==e.property.name||r)&&this.raiseRecoverable(e.property.start,"The only valid meta property for new is new.target"),this.inNonArrowFunction()||this.raiseRecoverable(e.start,"new.target can only be used in functions"),this.finishNode(e,"MetaProperty")}var n=this.start,i=this.startLoc;return e.callee=this.parseSubscripts(this.parseExprAtom(),n,i,!0),this.eat(types.parenL)?e.arguments=this.parseExprList(types.parenR,this.options.ecmaVersion>=8,!1):e.arguments=empty$1,this.finishNode(e,"NewExpression")},pp$3.parseTemplateElement=function(e){var t=e.isTagged,r=this.startNode();return this.type===types.invalidTemplate?(t||this.raiseRecoverable(this.start,"Bad escape sequence in untagged template literal"),r.value={raw:this.value,cooked:null}):r.value={raw:this.input.slice(this.start,this.end).replace(/\r\n?/g,"\n"),cooked:this.value},this.next(),r.tail=this.type===types.backQuote,this.finishNode(r,"TemplateElement")},pp$3.parseTemplate=function(e){void 0===e&&(e={});var t=e.isTagged;void 0===t&&(t=!1);var r=this.startNode();this.next(),r.expressions=[];var n=this.parseTemplateElement({isTagged:t});for(r.quasis=[n];!n.tail;)this.type===types.eof&&this.raise(this.pos,"Unterminated template literal"),this.expect(types.dollarBraceL),r.expressions.push(this.parseExpression()),this.expect(types.braceR),r.quasis.push(n=this.parseTemplateElement({isTagged:t}));return this.next(),this.finishNode(r,"TemplateLiteral")},pp$3.isAsyncProp=function(e){return!e.computed&&"Identifier"===e.key.type&&"async"===e.key.name&&(this.type===types.name||this.type===types.num||this.type===types.string||this.type===types.bracketL||this.type.keyword||this.options.ecmaVersion>=9&&this.type===types.star)&&!lineBreak.test(this.input.slice(this.lastTokEnd,this.start))},pp$3.parseObj=function(e,t){var r=this.startNode(),n=!0,i={};for(r.properties=[],this.next();!this.eat(types.braceR);){if(n)n=!1;else if(this.expect(types.comma),this.afterTrailingComma(types.braceR))break;var s=this.parseProperty(e,t);e||this.checkPropClash(s,i,t),r.properties.push(s)}return this.finishNode(r,e?"ObjectPattern":"ObjectExpression")},pp$3.parseProperty=function(e,t){var r,n,i,s,o=this.startNode();if(this.options.ecmaVersion>=9&&this.eat(types.ellipsis))return e?(o.argument=this.parseIdent(!1),this.type===types.comma&&this.raise(this.start,"Comma is not permitted after the rest element"),this.finishNode(o,"RestElement")):(this.type===types.parenL&&t&&(t.parenthesizedAssign<0&&(t.parenthesizedAssign=this.start),t.parenthesizedBind<0&&(t.parenthesizedBind=this.start)),o.argument=this.parseMaybeAssign(!1,t),this.type===types.comma&&t&&t.trailingComma<0&&(t.trailingComma=this.start),this.finishNode(o,"SpreadElement"));this.options.ecmaVersion>=6&&(o.method=!1,o.shorthand=!1,(e||t)&&(i=this.start,s=this.startLoc),e||(r=this.eat(types.star)));var a=this.containsEsc;return this.parsePropertyName(o),!e&&!a&&this.options.ecmaVersion>=8&&!r&&this.isAsyncProp(o)?(n=!0,r=this.options.ecmaVersion>=9&&this.eat(types.star),this.parsePropertyName(o,t)):n=!1,this.parsePropertyValue(o,e,r,n,i,s,t,a),this.finishNode(o,"Property")},pp$3.parsePropertyValue=function(e,t,r,n,i,s,o,a){if((r||n)&&this.type===types.colon&&this.unexpected(),this.eat(types.colon))e.value=t?this.parseMaybeDefault(this.start,this.startLoc):this.parseMaybeAssign(!1,o),e.kind="init";else if(this.options.ecmaVersion>=6&&this.type===types.parenL)t&&this.unexpected(),e.kind="init",e.method=!0,e.value=this.parseMethod(r,n);else if(t||a||!(this.options.ecmaVersion>=5)||e.computed||"Identifier"!==e.key.type||"get"!==e.key.name&&"set"!==e.key.name||this.type===types.comma||this.type===types.braceR)this.options.ecmaVersion>=6&&!e.computed&&"Identifier"===e.key.type?((r||n)&&this.unexpected(),this.checkUnreserved(e.key),"await"!==e.key.name||this.awaitIdentPos||(this.awaitIdentPos=i),e.kind="init",t?e.value=this.parseMaybeDefault(i,s,e.key):this.type===types.eq&&o?(o.shorthandAssign<0&&(o.shorthandAssign=this.start),e.value=this.parseMaybeDefault(i,s,e.key)):e.value=e.key,e.shorthand=!0):this.unexpected();else{(r||n)&&this.unexpected(),e.kind=e.key.name,this.parsePropertyName(e),e.value=this.parseMethod(!1);var u="get"===e.kind?0:1;if(e.value.params.length!==u){var c=e.value.start;"get"===e.kind?this.raiseRecoverable(c,"getter should have no params"):this.raiseRecoverable(c,"setter should have exactly one param")}else"set"===e.kind&&"RestElement"===e.value.params[0].type&&this.raiseRecoverable(e.value.params[0].start,"Setter cannot use rest params")}},pp$3.parsePropertyName=function(e){if(this.options.ecmaVersion>=6){if(this.eat(types.bracketL))return e.computed=!0,e.key=this.parseMaybeAssign(),this.expect(types.bracketR),e.key;e.computed=!1}return e.key=this.type===types.num||this.type===types.string?this.parseExprAtom():this.parseIdent(!0)},pp$3.initFunction=function(e){e.id=null,this.options.ecmaVersion>=6&&(e.generator=e.expression=!1),this.options.ecmaVersion>=8&&(e.async=!1)},pp$3.parseMethod=function(e,t,r){var n=this.startNode(),i=this.yieldPos,s=this.awaitPos,o=this.awaitIdentPos;return this.initFunction(n),this.options.ecmaVersion>=6&&(n.generator=e),this.options.ecmaVersion>=8&&(n.async=!!t),this.yieldPos=0,this.awaitPos=0,this.awaitIdentPos=0,this.enterScope(functionFlags(t,n.generator)|SCOPE_SUPER|(r?SCOPE_DIRECT_SUPER:0)),this.expect(types.parenL),n.params=this.parseBindingList(types.parenR,!1,this.options.ecmaVersion>=8),this.checkYieldAwaitInDefaultParams(),this.parseFunctionBody(n,!1,!0),this.yieldPos=i,this.awaitPos=s,this.awaitIdentPos=o,this.finishNode(n,"FunctionExpression")},pp$3.parseArrowExpression=function(e,t,r){var n=this.yieldPos,i=this.awaitPos,s=this.awaitIdentPos;return this.enterScope(functionFlags(r,!1)|SCOPE_ARROW),this.initFunction(e),this.options.ecmaVersion>=8&&(e.async=!!r),this.yieldPos=0,this.awaitPos=0,this.awaitIdentPos=0,e.params=this.toAssignableList(t,!0),this.parseFunctionBody(e,!0,!1),this.yieldPos=n,this.awaitPos=i,this.awaitIdentPos=s,this.finishNode(e,"ArrowFunctionExpression")},pp$3.parseFunctionBody=function(e,t,r){var n=t&&this.type!==types.braceL,i=this.strict,s=!1;if(n)e.body=this.parseMaybeAssign(),e.expression=!0,this.checkParams(e,!1);else{var o=this.options.ecmaVersion>=7&&!this.isSimpleParamList(e.params);i&&!o||(s=this.strictDirective(this.end))&&o&&this.raiseRecoverable(e.start,"Illegal 'use strict' directive in function with non-simple parameter list");var a=this.labels;this.labels=[],s&&(this.strict=!0),this.checkParams(e,!i&&!s&&!t&&!r&&this.isSimpleParamList(e.params)),e.body=this.parseBlock(!1),e.expression=!1,this.adaptDirectivePrologue(e.body.body),this.labels=a}this.exitScope(),this.strict&&e.id&&this.checkLVal(e.id,BIND_OUTSIDE),this.strict=i},pp$3.isSimpleParamList=function(e){for(var t=0,r=e;t<r.length;t+=1){if("Identifier"!==r[t].type)return!1}return!0},pp$3.checkParams=function(e,t){for(var r={},n=0,i=e.params;n<i.length;n+=1){var s=i[n];this.checkLVal(s,BIND_VAR,t?null:r)}},pp$3.parseExprList=function(e,t,r,n){for(var i=[],s=!0;!this.eat(e);){if(s)s=!1;else if(this.expect(types.comma),t&&this.afterTrailingComma(e))break;var o=void 0;r&&this.type===types.comma?o=null:this.type===types.ellipsis?(o=this.parseSpread(n),n&&this.type===types.comma&&n.trailingComma<0&&(n.trailingComma=this.start)):o=this.parseMaybeAssign(!1,n),i.push(o)}return i},pp$3.checkUnreserved=function(e){var t=e.start,r=e.end,n=e.name;(this.inGenerator&&"yield"===n&&this.raiseRecoverable(t,"Cannot use 'yield' as identifier inside a generator"),this.inAsync&&"await"===n&&this.raiseRecoverable(t,"Cannot use 'await' as identifier inside an async function"),this.keywords.test(n)&&this.raise(t,"Unexpected keyword '"+n+"'"),this.options.ecmaVersion<6&&-1!==this.input.slice(t,r).indexOf("\\"))||(this.strict?this.reservedWordsStrict:this.reservedWords).test(n)&&(this.inAsync||"await"!==n||this.raiseRecoverable(t,"Cannot use keyword 'await' outside an async function"),this.raiseRecoverable(t,"The keyword '"+n+"' is reserved"))},pp$3.parseIdent=function(e,t){var r=this.startNode();return e&&"never"===this.options.allowReserved&&(e=!1),this.type===types.name?r.name=this.value:this.type.keyword?(r.name=this.type.keyword,"class"!==r.name&&"function"!==r.name||this.lastTokEnd===this.lastTokStart+1&&46===this.input.charCodeAt(this.lastTokStart)||this.context.pop()):this.unexpected(),this.next(),this.finishNode(r,"Identifier"),e||(this.checkUnreserved(r),"await"!==r.name||this.awaitIdentPos||(this.awaitIdentPos=r.start)),r},pp$3.parseYield=function(e){this.yieldPos||(this.yieldPos=this.start);var t=this.startNode();return this.next(),this.type===types.semi||this.canInsertSemicolon()||this.type!==types.star&&!this.type.startsExpr?(t.delegate=!1,t.argument=null):(t.delegate=this.eat(types.star),t.argument=this.parseMaybeAssign(e)),this.finishNode(t,"YieldExpression")},pp$3.parseAwait=function(){this.awaitPos||(this.awaitPos=this.start);var e=this.startNode();return this.next(),e.argument=this.parseMaybeUnary(null,!0),this.finishNode(e,"AwaitExpression")};var pp$4=Parser.prototype;pp$4.raise=function(e,t){var r=getLineInfo(this.input,e);t+=" ("+r.line+":"+r.column+")";var n=new SyntaxError(t);throw n.pos=e,n.loc=r,n.raisedAt=this.pos,n},pp$4.raiseRecoverable=pp$4.raise,pp$4.curPosition=function(){if(this.options.locations)return new Position(this.curLine,this.pos-this.lineStart)};var pp$5=Parser.prototype,Scope=function(e){this.flags=e,this.var=[],this.lexical=[],this.functions=[]};pp$5.enterScope=function(e){this.scopeStack.push(new Scope(e))},pp$5.exitScope=function(){this.scopeStack.pop()},pp$5.treatFunctionsAsVarInScope=function(e){return e.flags&SCOPE_FUNCTION||!this.inModule&&e.flags&SCOPE_TOP},pp$5.declareName=function(e,t,r){var n=!1;if(t===BIND_LEXICAL){var i=this.currentScope();n=i.lexical.indexOf(e)>-1||i.functions.indexOf(e)>-1||i.var.indexOf(e)>-1,i.lexical.push(e),this.inModule&&i.flags&SCOPE_TOP&&delete this.undefinedExports[e]}else if(t===BIND_SIMPLE_CATCH){this.currentScope().lexical.push(e)}else if(t===BIND_FUNCTION){var s=this.currentScope();n=this.treatFunctionsAsVar?s.lexical.indexOf(e)>-1:s.lexical.indexOf(e)>-1||s.var.indexOf(e)>-1,s.functions.push(e)}else for(var o=this.scopeStack.length-1;o>=0;--o){var a=this.scopeStack[o];if(a.lexical.indexOf(e)>-1&&!(a.flags&SCOPE_SIMPLE_CATCH&&a.lexical[0]===e)||!this.treatFunctionsAsVarInScope(a)&&a.functions.indexOf(e)>-1){n=!0;break}if(a.var.push(e),this.inModule&&a.flags&SCOPE_TOP&&delete this.undefinedExports[e],a.flags&SCOPE_VAR)break}n&&this.raiseRecoverable(r,"Identifier '"+e+"' has already been declared")},pp$5.checkLocalExport=function(e){-1===this.scopeStack[0].lexical.indexOf(e.name)&&-1===this.scopeStack[0].var.indexOf(e.name)&&(this.undefinedExports[e.name]=e)},pp$5.currentScope=function(){return this.scopeStack[this.scopeStack.length-1]},pp$5.currentVarScope=function(){for(var e=this.scopeStack.length-1;;e--){var t=this.scopeStack[e];if(t.flags&SCOPE_VAR)return t}},pp$5.currentThisScope=function(){for(var e=this.scopeStack.length-1;;e--){var t=this.scopeStack[e];if(t.flags&SCOPE_VAR&&!(t.flags&SCOPE_ARROW))return t}};var Node=function(e,t,r){this.type="",this.start=t,this.end=0,e.options.locations&&(this.loc=new SourceLocation(e,r)),e.options.directSourceFile&&(this.sourceFile=e.options.directSourceFile),e.options.ranges&&(this.range=[t,0])},pp$6=Parser.prototype;function finishNodeAt(e,t,r,n){return e.type=t,e.end=r,this.options.locations&&(e.loc.end=n),this.options.ranges&&(e.range[1]=r),e}pp$6.startNode=function(){return new Node(this,this.start,this.startLoc)},pp$6.startNodeAt=function(e,t){return new Node(this,e,t)},pp$6.finishNode=function(e,t){return finishNodeAt.call(this,e,t,this.lastTokEnd,this.lastTokEndLoc)},pp$6.finishNodeAt=function(e,t,r,n){return finishNodeAt.call(this,e,t,r,n)};var TokContext=function(e,t,r,n,i){this.token=e,this.isExpr=!!t,this.preserveSpace=!!r,this.override=n,this.generator=!!i},types$1={b_stat:new TokContext("{",!1),b_expr:new TokContext("{",!0),b_tmpl:new TokContext("${",!1),p_stat:new TokContext("(",!1),p_expr:new TokContext("(",!0),q_tmpl:new TokContext("`",!0,!0,function(e){return e.tryReadTemplateToken()}),f_stat:new TokContext("function",!1),f_expr:new TokContext("function",!0),f_expr_gen:new TokContext("function",!0,!1,null,!0),f_gen:new TokContext("function",!1,!1,null,!0)},pp$7=Parser.prototype;pp$7.initialContext=function(){return[types$1.b_stat]},pp$7.braceIsBlock=function(e){var t=this.curContext();return t===types$1.f_expr||t===types$1.f_stat||(e!==types.colon||t!==types$1.b_stat&&t!==types$1.b_expr?e===types._return||e===types.name&&this.exprAllowed?lineBreak.test(this.input.slice(this.lastTokEnd,this.start)):e===types._else||e===types.semi||e===types.eof||e===types.parenR||e===types.arrow||(e===types.braceL?t===types$1.b_stat:e!==types._var&&e!==types._const&&e!==types.name&&!this.exprAllowed):!t.isExpr)},pp$7.inGeneratorContext=function(){for(var e=this.context.length-1;e>=1;e--){var t=this.context[e];if("function"===t.token)return t.generator}return!1},pp$7.updateContext=function(e){var t,r=this.type;r.keyword&&e===types.dot?this.exprAllowed=!1:(t=r.updateContext)?t.call(this,e):this.exprAllowed=r.beforeExpr},types.parenR.updateContext=types.braceR.updateContext=function(){if(1!==this.context.length){var e=this.context.pop();e===types$1.b_stat&&"function"===this.curContext().token&&(e=this.context.pop()),this.exprAllowed=!e.isExpr}else this.exprAllowed=!0},types.braceL.updateContext=function(e){this.context.push(this.braceIsBlock(e)?types$1.b_stat:types$1.b_expr),this.exprAllowed=!0},types.dollarBraceL.updateContext=function(){this.context.push(types$1.b_tmpl),this.exprAllowed=!0},types.parenL.updateContext=function(e){var t=e===types._if||e===types._for||e===types._with||e===types._while;this.context.push(t?types$1.p_stat:types$1.p_expr),this.exprAllowed=!0},types.incDec.updateContext=function(){},types._function.updateContext=types._class.updateContext=function(e){!e.beforeExpr||e===types.semi||e===types._else||e===types._return&&lineBreak.test(this.input.slice(this.lastTokEnd,this.start))||(e===types.colon||e===types.braceL)&&this.curContext()===types$1.b_stat?this.context.push(types$1.f_stat):this.context.push(types$1.f_expr),this.exprAllowed=!1},types.backQuote.updateContext=function(){this.curContext()===types$1.q_tmpl?this.context.pop():this.context.push(types$1.q_tmpl),this.exprAllowed=!1},types.star.updateContext=function(e){if(e===types._function){var t=this.context.length-1;this.context[t]===types$1.f_expr?this.context[t]=types$1.f_expr_gen:this.context[t]=types$1.f_gen}this.exprAllowed=!0},types.name.updateContext=function(e){var t=!1;this.options.ecmaVersion>=6&&e!==types.dot&&("of"===this.value&&!this.exprAllowed||"yield"===this.value&&this.inGeneratorContext())&&(t=!0),this.exprAllowed=t};var ecma9BinaryProperties="ASCII ASCII_Hex_Digit AHex Alphabetic Alpha Any Assigned Bidi_Control Bidi_C Bidi_Mirrored Bidi_M Case_Ignorable CI Cased Changes_When_Casefolded CWCF Changes_When_Casemapped CWCM Changes_When_Lowercased CWL Changes_When_NFKC_Casefolded CWKCF Changes_When_Titlecased CWT Changes_When_Uppercased CWU Dash Default_Ignorable_Code_Point DI Deprecated Dep Diacritic Dia Emoji Emoji_Component Emoji_Modifier Emoji_Modifier_Base Emoji_Presentation Extender Ext Grapheme_Base Gr_Base Grapheme_Extend Gr_Ext Hex_Digit Hex IDS_Binary_Operator IDSB IDS_Trinary_Operator IDST ID_Continue IDC ID_Start IDS Ideographic Ideo Join_Control Join_C Logical_Order_Exception LOE Lowercase Lower Math Noncharacter_Code_Point NChar Pattern_Syntax Pat_Syn Pattern_White_Space Pat_WS Quotation_Mark QMark Radical Regional_Indicator RI Sentence_Terminal STerm Soft_Dotted SD Terminal_Punctuation Term Unified_Ideograph UIdeo Uppercase Upper Variation_Selector VS White_Space space XID_Continue XIDC XID_Start XIDS",unicodeBinaryProperties={9:ecma9BinaryProperties,10:ecma9BinaryProperties+" Extended_Pictographic"},unicodeGeneralCategoryValues="Cased_Letter LC Close_Punctuation Pe Connector_Punctuation Pc Control Cc cntrl Currency_Symbol Sc Dash_Punctuation Pd Decimal_Number Nd digit Enclosing_Mark Me Final_Punctuation Pf Format Cf Initial_Punctuation Pi Letter L Letter_Number Nl Line_Separator Zl Lowercase_Letter Ll Mark M Combining_Mark Math_Symbol Sm Modifier_Letter Lm Modifier_Symbol Sk Nonspacing_Mark Mn Number N Open_Punctuation Ps Other C Other_Letter Lo Other_Number No Other_Punctuation Po Other_Symbol So Paragraph_Separator Zp Private_Use Co Punctuation P punct Separator Z Space_Separator Zs Spacing_Mark Mc Surrogate Cs Symbol S Titlecase_Letter Lt Unassigned Cn Uppercase_Letter Lu",ecma9ScriptValues="Adlam Adlm Ahom Ahom Anatolian_Hieroglyphs Hluw Arabic Arab Armenian Armn Avestan Avst Balinese Bali Bamum Bamu Bassa_Vah Bass Batak Batk Bengali Beng Bhaiksuki Bhks Bopomofo Bopo Brahmi Brah Braille Brai Buginese Bugi Buhid Buhd Canadian_Aboriginal Cans Carian Cari Caucasian_Albanian Aghb Chakma Cakm Cham Cham Cherokee Cher Common Zyyy Coptic Copt Qaac Cuneiform Xsux Cypriot Cprt Cyrillic Cyrl Deseret Dsrt Devanagari Deva Duployan Dupl Egyptian_Hieroglyphs Egyp Elbasan Elba Ethiopic Ethi Georgian Geor Glagolitic Glag Gothic Goth Grantha Gran Greek Grek Gujarati Gujr Gurmukhi Guru Han Hani Hangul Hang Hanunoo Hano Hatran Hatr Hebrew Hebr Hiragana Hira Imperial_Aramaic Armi Inherited Zinh Qaai Inscriptional_Pahlavi Phli Inscriptional_Parthian Prti Javanese Java Kaithi Kthi Kannada Knda Katakana Kana Kayah_Li Kali Kharoshthi Khar Khmer Khmr Khojki Khoj Khudawadi Sind Lao Laoo Latin Latn Lepcha Lepc Limbu Limb Linear_A Lina Linear_B Linb Lisu Lisu Lycian Lyci Lydian Lydi Mahajani Mahj Malayalam Mlym Mandaic Mand Manichaean Mani Marchen Marc Masaram_Gondi Gonm Meetei_Mayek Mtei Mende_Kikakui Mend Meroitic_Cursive Merc Meroitic_Hieroglyphs Mero Miao Plrd Modi Modi Mongolian Mong Mro Mroo Multani Mult Myanmar Mymr Nabataean Nbat New_Tai_Lue Talu Newa Newa Nko Nkoo Nushu Nshu Ogham Ogam Ol_Chiki Olck Old_Hungarian Hung Old_Italic Ital Old_North_Arabian Narb Old_Permic Perm Old_Persian Xpeo Old_South_Arabian Sarb Old_Turkic Orkh Oriya Orya Osage Osge Osmanya Osma Pahawh_Hmong Hmng Palmyrene Palm Pau_Cin_Hau Pauc Phags_Pa Phag Phoenician Phnx Psalter_Pahlavi Phlp Rejang Rjng Runic Runr Samaritan Samr Saurashtra Saur Sharada Shrd Shavian Shaw Siddham Sidd SignWriting Sgnw Sinhala Sinh Sora_Sompeng Sora Soyombo Soyo Sundanese Sund Syloti_Nagri Sylo Syriac Syrc Tagalog Tglg Tagbanwa Tagb Tai_Le Tale Tai_Tham Lana Tai_Viet Tavt Takri Takr Tamil Taml Tangut Tang Telugu Telu Thaana Thaa Thai Thai Tibetan Tibt Tifinagh Tfng Tirhuta Tirh Ugaritic Ugar Vai Vaii Warang_Citi Wara Yi Yiii Zanabazar_Square Zanb",unicodeScriptValues={9:ecma9ScriptValues,10:ecma9ScriptValues+" Dogra Dogr Gunjala_Gondi Gong Hanifi_Rohingya Rohg Makasar Maka Medefaidrin Medf Old_Sogdian Sogo Sogdian Sogd"},data={};function buildUnicodeData(e){var t=data[e]={binary:wordsRegexp(unicodeBinaryProperties[e]+" "+unicodeGeneralCategoryValues),nonBinary:{General_Category:wordsRegexp(unicodeGeneralCategoryValues),Script:wordsRegexp(unicodeScriptValues[e])}};t.nonBinary.Script_Extensions=t.nonBinary.Script,t.nonBinary.gc=t.nonBinary.General_Category,t.nonBinary.sc=t.nonBinary.Script,t.nonBinary.scx=t.nonBinary.Script_Extensions}buildUnicodeData(9),buildUnicodeData(10);var pp$9=Parser.prototype,RegExpValidationState=function(e){this.parser=e,this.validFlags="gim"+(e.options.ecmaVersion>=6?"uy":"")+(e.options.ecmaVersion>=9?"s":""),this.unicodeProperties=data[e.options.ecmaVersion>=10?10:e.options.ecmaVersion],this.source="",this.flags="",this.start=0,this.switchU=!1,this.switchN=!1,this.pos=0,this.lastIntValue=0,this.lastStringValue="",this.lastAssertionIsQuantifiable=!1,this.numCapturingParens=0,this.maxBackReference=0,this.groupNames=[],this.backReferenceNames=[]};function codePointToString$1(e){return e<=65535?String.fromCharCode(e):(e-=65536,String.fromCharCode(55296+(e>>10),56320+(1023&e)))}function isSyntaxCharacter(e){return 36===e||e>=40&&e<=43||46===e||63===e||e>=91&&e<=94||e>=123&&e<=125}function isRegExpIdentifierStart(e){return isIdentifierStart(e,!0)||36===e||95===e}function isRegExpIdentifierPart(e){return isIdentifierChar(e,!0)||36===e||95===e||8204===e||8205===e}function isControlLetter(e){return e>=65&&e<=90||e>=97&&e<=122}function isValidUnicode(e){return e>=0&&e<=1114111}function isCharacterClassEscape(e){return 100===e||68===e||115===e||83===e||119===e||87===e}function isUnicodePropertyNameCharacter(e){return isControlLetter(e)||95===e}function isUnicodePropertyValueCharacter(e){return isUnicodePropertyNameCharacter(e)||isDecimalDigit(e)}function isDecimalDigit(e){return e>=48&&e<=57}function isHexDigit(e){return e>=48&&e<=57||e>=65&&e<=70||e>=97&&e<=102}function hexToInt(e){return e>=65&&e<=70?e-65+10:e>=97&&e<=102?e-97+10:e-48}function isOctalDigit(e){return e>=48&&e<=55}RegExpValidationState.prototype.reset=function(e,t,r){var n=-1!==r.indexOf("u");this.start=0|e,this.source=t+"",this.flags=r,this.switchU=n&&this.parser.options.ecmaVersion>=6,this.switchN=n&&this.parser.options.ecmaVersion>=9},RegExpValidationState.prototype.raise=function(e){this.parser.raiseRecoverable(this.start,"Invalid regular expression: /"+this.source+"/: "+e)},RegExpValidationState.prototype.at=function(e){var t=this.source,r=t.length;if(e>=r)return-1;var n=t.charCodeAt(e);return!this.switchU||n<=55295||n>=57344||e+1>=r?n:(n<<10)+t.charCodeAt(e+1)-56613888},RegExpValidationState.prototype.nextIndex=function(e){var t=this.source,r=t.length;if(e>=r)return r;var n=t.charCodeAt(e);return!this.switchU||n<=55295||n>=57344||e+1>=r?e+1:e+2},RegExpValidationState.prototype.current=function(){return this.at(this.pos)},RegExpValidationState.prototype.lookahead=function(){return this.at(this.nextIndex(this.pos))},RegExpValidationState.prototype.advance=function(){this.pos=this.nextIndex(this.pos)},RegExpValidationState.prototype.eat=function(e){return this.current()===e&&(this.advance(),!0)},pp$9.validateRegExpFlags=function(e){for(var t=e.validFlags,r=e.flags,n=0;n<r.length;n++){var i=r.charAt(n);-1===t.indexOf(i)&&this.raise(e.start,"Invalid regular expression flag"),r.indexOf(i,n+1)>-1&&this.raise(e.start,"Duplicate regular expression flag")}},pp$9.validateRegExpPattern=function(e){this.regexp_pattern(e),!e.switchN&&this.options.ecmaVersion>=9&&e.groupNames.length>0&&(e.switchN=!0,this.regexp_pattern(e))},pp$9.regexp_pattern=function(e){e.pos=0,e.lastIntValue=0,e.lastStringValue="",e.lastAssertionIsQuantifiable=!1,e.numCapturingParens=0,e.maxBackReference=0,e.groupNames.length=0,e.backReferenceNames.length=0,this.regexp_disjunction(e),e.pos!==e.source.length&&(e.eat(41)&&e.raise("Unmatched ')'"),(e.eat(93)||e.eat(125))&&e.raise("Lone quantifier brackets")),e.maxBackReference>e.numCapturingParens&&e.raise("Invalid escape");for(var t=0,r=e.backReferenceNames;t<r.length;t+=1){var n=r[t];-1===e.groupNames.indexOf(n)&&e.raise("Invalid named capture referenced")}},pp$9.regexp_disjunction=function(e){for(this.regexp_alternative(e);e.eat(124);)this.regexp_alternative(e);this.regexp_eatQuantifier(e,!0)&&e.raise("Nothing to repeat"),e.eat(123)&&e.raise("Lone quantifier brackets")},pp$9.regexp_alternative=function(e){for(;e.pos<e.source.length&&this.regexp_eatTerm(e););},pp$9.regexp_eatTerm=function(e){return this.regexp_eatAssertion(e)?(e.lastAssertionIsQuantifiable&&this.regexp_eatQuantifier(e)&&e.switchU&&e.raise("Invalid quantifier"),!0):!(e.switchU?!this.regexp_eatAtom(e):!this.regexp_eatExtendedAtom(e))&&(this.regexp_eatQuantifier(e),!0)},pp$9.regexp_eatAssertion=function(e){var t=e.pos;if(e.lastAssertionIsQuantifiable=!1,e.eat(94)||e.eat(36))return!0;if(e.eat(92)){if(e.eat(66)||e.eat(98))return!0;e.pos=t}if(e.eat(40)&&e.eat(63)){var r=!1;if(this.options.ecmaVersion>=9&&(r=e.eat(60)),e.eat(61)||e.eat(33))return this.regexp_disjunction(e),e.eat(41)||e.raise("Unterminated group"),e.lastAssertionIsQuantifiable=!r,!0}return e.pos=t,!1},pp$9.regexp_eatQuantifier=function(e,t){return void 0===t&&(t=!1),!!this.regexp_eatQuantifierPrefix(e,t)&&(e.eat(63),!0)},pp$9.regexp_eatQuantifierPrefix=function(e,t){return e.eat(42)||e.eat(43)||e.eat(63)||this.regexp_eatBracedQuantifier(e,t)},pp$9.regexp_eatBracedQuantifier=function(e,t){var r=e.pos;if(e.eat(123)){var n=0,i=-1;if(this.regexp_eatDecimalDigits(e)&&(n=e.lastIntValue,e.eat(44)&&this.regexp_eatDecimalDigits(e)&&(i=e.lastIntValue),e.eat(125)))return-1!==i&&i<n&&!t&&e.raise("numbers out of order in {} quantifier"),!0;e.switchU&&!t&&e.raise("Incomplete quantifier"),e.pos=r}return!1},pp$9.regexp_eatAtom=function(e){return this.regexp_eatPatternCharacters(e)||e.eat(46)||this.regexp_eatReverseSolidusAtomEscape(e)||this.regexp_eatCharacterClass(e)||this.regexp_eatUncapturingGroup(e)||this.regexp_eatCapturingGroup(e)},pp$9.regexp_eatReverseSolidusAtomEscape=function(e){var t=e.pos;if(e.eat(92)){if(this.regexp_eatAtomEscape(e))return!0;e.pos=t}return!1},pp$9.regexp_eatUncapturingGroup=function(e){var t=e.pos;if(e.eat(40)){if(e.eat(63)&&e.eat(58)){if(this.regexp_disjunction(e),e.eat(41))return!0;e.raise("Unterminated group")}e.pos=t}return!1},pp$9.regexp_eatCapturingGroup=function(e){if(e.eat(40)){if(this.options.ecmaVersion>=9?this.regexp_groupSpecifier(e):63===e.current()&&e.raise("Invalid group"),this.regexp_disjunction(e),e.eat(41))return e.numCapturingParens+=1,!0;e.raise("Unterminated group")}return!1},pp$9.regexp_eatExtendedAtom=function(e){return e.eat(46)||this.regexp_eatReverseSolidusAtomEscape(e)||this.regexp_eatCharacterClass(e)||this.regexp_eatUncapturingGroup(e)||this.regexp_eatCapturingGroup(e)||this.regexp_eatInvalidBracedQuantifier(e)||this.regexp_eatExtendedPatternCharacter(e)},pp$9.regexp_eatInvalidBracedQuantifier=function(e){return this.regexp_eatBracedQuantifier(e,!0)&&e.raise("Nothing to repeat"),!1},pp$9.regexp_eatSyntaxCharacter=function(e){var t=e.current();return!!isSyntaxCharacter(t)&&(e.lastIntValue=t,e.advance(),!0)},pp$9.regexp_eatPatternCharacters=function(e){for(var t=e.pos,r=0;-1!==(r=e.current())&&!isSyntaxCharacter(r);)e.advance();return e.pos!==t},pp$9.regexp_eatExtendedPatternCharacter=function(e){var t=e.current();return!(-1===t||36===t||t>=40&&t<=43||46===t||63===t||91===t||94===t||124===t)&&(e.advance(),!0)},pp$9.regexp_groupSpecifier=function(e){if(e.eat(63)){if(this.regexp_eatGroupName(e))return-1!==e.groupNames.indexOf(e.lastStringValue)&&e.raise("Duplicate capture group name"),void e.groupNames.push(e.lastStringValue);e.raise("Invalid group")}},pp$9.regexp_eatGroupName=function(e){if(e.lastStringValue="",e.eat(60)){if(this.regexp_eatRegExpIdentifierName(e)&&e.eat(62))return!0;e.raise("Invalid capture group name")}return!1},pp$9.regexp_eatRegExpIdentifierName=function(e){if(e.lastStringValue="",this.regexp_eatRegExpIdentifierStart(e)){for(e.lastStringValue+=codePointToString$1(e.lastIntValue);this.regexp_eatRegExpIdentifierPart(e);)e.lastStringValue+=codePointToString$1(e.lastIntValue);return!0}return!1},pp$9.regexp_eatRegExpIdentifierStart=function(e){var t=e.pos,r=e.current();return e.advance(),92===r&&this.regexp_eatRegExpUnicodeEscapeSequence(e)&&(r=e.lastIntValue),isRegExpIdentifierStart(r)?(e.lastIntValue=r,!0):(e.pos=t,!1)},pp$9.regexp_eatRegExpIdentifierPart=function(e){var t=e.pos,r=e.current();return e.advance(),92===r&&this.regexp_eatRegExpUnicodeEscapeSequence(e)&&(r=e.lastIntValue),isRegExpIdentifierPart(r)?(e.lastIntValue=r,!0):(e.pos=t,!1)},pp$9.regexp_eatAtomEscape=function(e){return!!(this.regexp_eatBackReference(e)||this.regexp_eatCharacterClassEscape(e)||this.regexp_eatCharacterEscape(e)||e.switchN&&this.regexp_eatKGroupName(e))||(e.switchU&&(99===e.current()&&e.raise("Invalid unicode escape"),e.raise("Invalid escape")),!1)},pp$9.regexp_eatBackReference=function(e){var t=e.pos;if(this.regexp_eatDecimalEscape(e)){var r=e.lastIntValue;if(e.switchU)return r>e.maxBackReference&&(e.maxBackReference=r),!0;if(r<=e.numCapturingParens)return!0;e.pos=t}return!1},pp$9.regexp_eatKGroupName=function(e){if(e.eat(107)){if(this.regexp_eatGroupName(e))return e.backReferenceNames.push(e.lastStringValue),!0;e.raise("Invalid named reference")}return!1},pp$9.regexp_eatCharacterEscape=function(e){return this.regexp_eatControlEscape(e)||this.regexp_eatCControlLetter(e)||this.regexp_eatZero(e)||this.regexp_eatHexEscapeSequence(e)||this.regexp_eatRegExpUnicodeEscapeSequence(e)||!e.switchU&&this.regexp_eatLegacyOctalEscapeSequence(e)||this.regexp_eatIdentityEscape(e)},pp$9.regexp_eatCControlLetter=function(e){var t=e.pos;if(e.eat(99)){if(this.regexp_eatControlLetter(e))return!0;e.pos=t}return!1},pp$9.regexp_eatZero=function(e){return 48===e.current()&&!isDecimalDigit(e.lookahead())&&(e.lastIntValue=0,e.advance(),!0)},pp$9.regexp_eatControlEscape=function(e){var t=e.current();return 116===t?(e.lastIntValue=9,e.advance(),!0):110===t?(e.lastIntValue=10,e.advance(),!0):118===t?(e.lastIntValue=11,e.advance(),!0):102===t?(e.lastIntValue=12,e.advance(),!0):114===t&&(e.lastIntValue=13,e.advance(),!0)},pp$9.regexp_eatControlLetter=function(e){var t=e.current();return!!isControlLetter(t)&&(e.lastIntValue=t%32,e.advance(),!0)},pp$9.regexp_eatRegExpUnicodeEscapeSequence=function(e){var t=e.pos;if(e.eat(117)){if(this.regexp_eatFixedHexDigits(e,4)){var r=e.lastIntValue;if(e.switchU&&r>=55296&&r<=56319){var n=e.pos;if(e.eat(92)&&e.eat(117)&&this.regexp_eatFixedHexDigits(e,4)){var i=e.lastIntValue;if(i>=56320&&i<=57343)return e.lastIntValue=1024*(r-55296)+(i-56320)+65536,!0}e.pos=n,e.lastIntValue=r}return!0}if(e.switchU&&e.eat(123)&&this.regexp_eatHexDigits(e)&&e.eat(125)&&isValidUnicode(e.lastIntValue))return!0;e.switchU&&e.raise("Invalid unicode escape"),e.pos=t}return!1},pp$9.regexp_eatIdentityEscape=function(e){if(e.switchU)return!!this.regexp_eatSyntaxCharacter(e)||!!e.eat(47)&&(e.lastIntValue=47,!0);var t=e.current();return!(99===t||e.switchN&&107===t)&&(e.lastIntValue=t,e.advance(),!0)},pp$9.regexp_eatDecimalEscape=function(e){e.lastIntValue=0;var t=e.current();if(t>=49&&t<=57){do{e.lastIntValue=10*e.lastIntValue+(t-48),e.advance()}while((t=e.current())>=48&&t<=57);return!0}return!1},pp$9.regexp_eatCharacterClassEscape=function(e){var t=e.current();if(isCharacterClassEscape(t))return e.lastIntValue=-1,e.advance(),!0;if(e.switchU&&this.options.ecmaVersion>=9&&(80===t||112===t)){if(e.lastIntValue=-1,e.advance(),e.eat(123)&&this.regexp_eatUnicodePropertyValueExpression(e)&&e.eat(125))return!0;e.raise("Invalid property name")}return!1},pp$9.regexp_eatUnicodePropertyValueExpression=function(e){var t=e.pos;if(this.regexp_eatUnicodePropertyName(e)&&e.eat(61)){var r=e.lastStringValue;if(this.regexp_eatUnicodePropertyValue(e)){var n=e.lastStringValue;return this.regexp_validateUnicodePropertyNameAndValue(e,r,n),!0}}if(e.pos=t,this.regexp_eatLoneUnicodePropertyNameOrValue(e)){var i=e.lastStringValue;return this.regexp_validateUnicodePropertyNameOrValue(e,i),!0}return!1},pp$9.regexp_validateUnicodePropertyNameAndValue=function(e,t,r){has(e.unicodeProperties.nonBinary,t)||e.raise("Invalid property name"),e.unicodeProperties.nonBinary[t].test(r)||e.raise("Invalid property value")},pp$9.regexp_validateUnicodePropertyNameOrValue=function(e,t){e.unicodeProperties.binary.test(t)||e.raise("Invalid property name")},pp$9.regexp_eatUnicodePropertyName=function(e){var t=0;for(e.lastStringValue="";isUnicodePropertyNameCharacter(t=e.current());)e.lastStringValue+=codePointToString$1(t),e.advance();return""!==e.lastStringValue},pp$9.regexp_eatUnicodePropertyValue=function(e){var t=0;for(e.lastStringValue="";isUnicodePropertyValueCharacter(t=e.current());)e.lastStringValue+=codePointToString$1(t),e.advance();return""!==e.lastStringValue},pp$9.regexp_eatLoneUnicodePropertyNameOrValue=function(e){return this.regexp_eatUnicodePropertyValue(e)},pp$9.regexp_eatCharacterClass=function(e){if(e.eat(91)){if(e.eat(94),this.regexp_classRanges(e),e.eat(93))return!0;e.raise("Unterminated character class")}return!1},pp$9.regexp_classRanges=function(e){for(;this.regexp_eatClassAtom(e);){var t=e.lastIntValue;if(e.eat(45)&&this.regexp_eatClassAtom(e)){var r=e.lastIntValue;!e.switchU||-1!==t&&-1!==r||e.raise("Invalid character class"),-1!==t&&-1!==r&&t>r&&e.raise("Range out of order in character class")}}},pp$9.regexp_eatClassAtom=function(e){var t=e.pos;if(e.eat(92)){if(this.regexp_eatClassEscape(e))return!0;if(e.switchU){var r=e.current();(99===r||isOctalDigit(r))&&e.raise("Invalid class escape"),e.raise("Invalid escape")}e.pos=t}var n=e.current();return 93!==n&&(e.lastIntValue=n,e.advance(),!0)},pp$9.regexp_eatClassEscape=function(e){var t=e.pos;if(e.eat(98))return e.lastIntValue=8,!0;if(e.switchU&&e.eat(45))return e.lastIntValue=45,!0;if(!e.switchU&&e.eat(99)){if(this.regexp_eatClassControlLetter(e))return!0;e.pos=t}return this.regexp_eatCharacterClassEscape(e)||this.regexp_eatCharacterEscape(e)},pp$9.regexp_eatClassControlLetter=function(e){var t=e.current();return!(!isDecimalDigit(t)&&95!==t)&&(e.lastIntValue=t%32,e.advance(),!0)},pp$9.regexp_eatHexEscapeSequence=function(e){var t=e.pos;if(e.eat(120)){if(this.regexp_eatFixedHexDigits(e,2))return!0;e.switchU&&e.raise("Invalid escape"),e.pos=t}return!1},pp$9.regexp_eatDecimalDigits=function(e){var t=e.pos,r=0;for(e.lastIntValue=0;isDecimalDigit(r=e.current());)e.lastIntValue=10*e.lastIntValue+(r-48),e.advance();return e.pos!==t},pp$9.regexp_eatHexDigits=function(e){var t=e.pos,r=0;for(e.lastIntValue=0;isHexDigit(r=e.current());)e.lastIntValue=16*e.lastIntValue+hexToInt(r),e.advance();return e.pos!==t},pp$9.regexp_eatLegacyOctalEscapeSequence=function(e){if(this.regexp_eatOctalDigit(e)){var t=e.lastIntValue;if(this.regexp_eatOctalDigit(e)){var r=e.lastIntValue;t<=3&&this.regexp_eatOctalDigit(e)?e.lastIntValue=64*t+8*r+e.lastIntValue:e.lastIntValue=8*t+r}else e.lastIntValue=t;return!0}return!1},pp$9.regexp_eatOctalDigit=function(e){var t=e.current();return isOctalDigit(t)?(e.lastIntValue=t-48,e.advance(),!0):(e.lastIntValue=0,!1)},pp$9.regexp_eatFixedHexDigits=function(e,t){var r=e.pos;e.lastIntValue=0;for(var n=0;n<t;++n){var i=e.current();if(!isHexDigit(i))return e.pos=r,!1;e.lastIntValue=16*e.lastIntValue+hexToInt(i),e.advance()}return!0};var Token=function(e){this.type=e.type,this.value=e.value,this.start=e.start,this.end=e.end,e.options.locations&&(this.loc=new SourceLocation(e,e.startLoc,e.endLoc)),e.options.ranges&&(this.range=[e.start,e.end])},pp$8=Parser.prototype;function codePointToString(e){return e<=65535?String.fromCharCode(e):(e-=65536,String.fromCharCode(55296+(e>>10),56320+(1023&e)))}pp$8.next=function(){this.options.onToken&&this.options.onToken(new Token(this)),this.lastTokEnd=this.end,this.lastTokStart=this.start,this.lastTokEndLoc=this.endLoc,this.lastTokStartLoc=this.startLoc,this.nextToken()},pp$8.getToken=function(){return this.next(),new Token(this)},"undefined"!=typeof Symbol&&(pp$8[Symbol.iterator]=function(){var e=this;return{next:function(){var t=e.getToken();return{done:t.type===types.eof,value:t}}}}),pp$8.curContext=function(){return this.context[this.context.length-1]},pp$8.nextToken=function(){var e=this.curContext();return e&&e.preserveSpace||this.skipSpace(),this.start=this.pos,this.options.locations&&(this.startLoc=this.curPosition()),this.pos>=this.input.length?this.finishToken(types.eof):e.override?e.override(this):void this.readToken(this.fullCharCodeAtPos())},pp$8.readToken=function(e){return isIdentifierStart(e,this.options.ecmaVersion>=6)||92===e?this.readWord():this.getTokenFromCode(e)},pp$8.fullCharCodeAtPos=function(){var e=this.input.charCodeAt(this.pos);return e<=55295||e>=57344?e:(e<<10)+this.input.charCodeAt(this.pos+1)-56613888},pp$8.skipBlockComment=function(){var e,t=this.options.onComment&&this.curPosition(),r=this.pos,n=this.input.indexOf("*/",this.pos+=2);if(-1===n&&this.raise(this.pos-2,"Unterminated comment"),this.pos=n+2,this.options.locations)for(lineBreakG.lastIndex=r;(e=lineBreakG.exec(this.input))&&e.index<this.pos;)++this.curLine,this.lineStart=e.index+e[0].length;this.options.onComment&&this.options.onComment(!0,this.input.slice(r+2,n),r,this.pos,t,this.curPosition())},pp$8.skipLineComment=function(e){for(var t=this.pos,r=this.options.onComment&&this.curPosition(),n=this.input.charCodeAt(this.pos+=e);this.pos<this.input.length&&!isNewLine(n);)n=this.input.charCodeAt(++this.pos);this.options.onComment&&this.options.onComment(!1,this.input.slice(t+e,this.pos),t,this.pos,r,this.curPosition())},pp$8.skipSpace=function(){e:for(;this.pos<this.input.length;){var e=this.input.charCodeAt(this.pos);switch(e){case 32:case 160:++this.pos;break;case 13:10===this.input.charCodeAt(this.pos+1)&&++this.pos;case 10:case 8232:case 8233:++this.pos,this.options.locations&&(++this.curLine,this.lineStart=this.pos);break;case 47:switch(this.input.charCodeAt(this.pos+1)){case 42:this.skipBlockComment();break;case 47:this.skipLineComment(2);break;default:break e}break;default:if(!(e>8&&e<14||e>=5760&&nonASCIIwhitespace.test(String.fromCharCode(e))))break e;++this.pos}}},pp$8.finishToken=function(e,t){this.end=this.pos,this.options.locations&&(this.endLoc=this.curPosition());var r=this.type;this.type=e,this.value=t,this.updateContext(r)},pp$8.readToken_dot=function(){var e=this.input.charCodeAt(this.pos+1);if(e>=48&&e<=57)return this.readNumber(!0);var t=this.input.charCodeAt(this.pos+2);return this.options.ecmaVersion>=6&&46===e&&46===t?(this.pos+=3,this.finishToken(types.ellipsis)):(++this.pos,this.finishToken(types.dot))},pp$8.readToken_slash=function(){var e=this.input.charCodeAt(this.pos+1);return this.exprAllowed?(++this.pos,this.readRegexp()):61===e?this.finishOp(types.assign,2):this.finishOp(types.slash,1)},pp$8.readToken_mult_modulo_exp=function(e){var t=this.input.charCodeAt(this.pos+1),r=1,n=42===e?types.star:types.modulo;return this.options.ecmaVersion>=7&&42===e&&42===t&&(++r,n=types.starstar,t=this.input.charCodeAt(this.pos+2)),61===t?this.finishOp(types.assign,r+1):this.finishOp(n,r)},pp$8.readToken_pipe_amp=function(e){var t=this.input.charCodeAt(this.pos+1);return t===e?this.finishOp(124===e?types.logicalOR:types.logicalAND,2):61===t?this.finishOp(types.assign,2):this.finishOp(124===e?types.bitwiseOR:types.bitwiseAND,1)},pp$8.readToken_caret=function(){return 61===this.input.charCodeAt(this.pos+1)?this.finishOp(types.assign,2):this.finishOp(types.bitwiseXOR,1)},pp$8.readToken_plus_min=function(e){var t=this.input.charCodeAt(this.pos+1);return t===e?45!==t||this.inModule||62!==this.input.charCodeAt(this.pos+2)||0!==this.lastTokEnd&&!lineBreak.test(this.input.slice(this.lastTokEnd,this.pos))?this.finishOp(types.incDec,2):(this.skipLineComment(3),this.skipSpace(),this.nextToken()):61===t?this.finishOp(types.assign,2):this.finishOp(types.plusMin,1)},pp$8.readToken_lt_gt=function(e){var t=this.input.charCodeAt(this.pos+1),r=1;return t===e?(r=62===e&&62===this.input.charCodeAt(this.pos+2)?3:2,61===this.input.charCodeAt(this.pos+r)?this.finishOp(types.assign,r+1):this.finishOp(types.bitShift,r)):33!==t||60!==e||this.inModule||45!==this.input.charCodeAt(this.pos+2)||45!==this.input.charCodeAt(this.pos+3)?(61===t&&(r=2),this.finishOp(types.relational,r)):(this.skipLineComment(4),this.skipSpace(),this.nextToken())},pp$8.readToken_eq_excl=function(e){var t=this.input.charCodeAt(this.pos+1);return 61===t?this.finishOp(types.equality,61===this.input.charCodeAt(this.pos+2)?3:2):61===e&&62===t&&this.options.ecmaVersion>=6?(this.pos+=2,this.finishToken(types.arrow)):this.finishOp(61===e?types.eq:types.prefix,1)},pp$8.getTokenFromCode=function(e){switch(e){case 46:return this.readToken_dot();case 40:return++this.pos,this.finishToken(types.parenL);case 41:return++this.pos,this.finishToken(types.parenR);case 59:return++this.pos,this.finishToken(types.semi);case 44:return++this.pos,this.finishToken(types.comma);case 91:return++this.pos,this.finishToken(types.bracketL);case 93:return++this.pos,this.finishToken(types.bracketR);case 123:return++this.pos,this.finishToken(types.braceL);case 125:return++this.pos,this.finishToken(types.braceR);case 58:return++this.pos,this.finishToken(types.colon);case 63:return++this.pos,this.finishToken(types.question);case 96:if(this.options.ecmaVersion<6)break;return++this.pos,this.finishToken(types.backQuote);case 48:var t=this.input.charCodeAt(this.pos+1);if(120===t||88===t)return this.readRadixNumber(16);if(this.options.ecmaVersion>=6){if(111===t||79===t)return this.readRadixNumber(8);if(98===t||66===t)return this.readRadixNumber(2)}case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return this.readNumber(!1);case 34:case 39:return this.readString(e);case 47:return this.readToken_slash();case 37:case 42:return this.readToken_mult_modulo_exp(e);case 124:case 38:return this.readToken_pipe_amp(e);case 94:return this.readToken_caret();case 43:case 45:return this.readToken_plus_min(e);case 60:case 62:return this.readToken_lt_gt(e);case 61:case 33:return this.readToken_eq_excl(e);case 126:return this.finishOp(types.prefix,1)}this.raise(this.pos,"Unexpected character '"+codePointToString(e)+"'")},pp$8.finishOp=function(e,t){var r=this.input.slice(this.pos,this.pos+t);return this.pos+=t,this.finishToken(e,r)},pp$8.readRegexp=function(){for(var e,t,r=this.pos;;){this.pos>=this.input.length&&this.raise(r,"Unterminated regular expression");var n=this.input.charAt(this.pos);if(lineBreak.test(n)&&this.raise(r,"Unterminated regular expression"),e)e=!1;else{if("["===n)t=!0;else if("]"===n&&t)t=!1;else if("/"===n&&!t)break;e="\\"===n}++this.pos}var i=this.input.slice(r,this.pos);++this.pos;var s=this.pos,o=this.readWord1();this.containsEsc&&this.unexpected(s);var a=this.regexpState||(this.regexpState=new RegExpValidationState(this));a.reset(r,i,o),this.validateRegExpFlags(a),this.validateRegExpPattern(a);var u=null;try{u=new RegExp(i,o)}catch(e){}return this.finishToken(types.regexp,{pattern:i,flags:o,value:u})},pp$8.readInt=function(e,t){for(var r=this.pos,n=0,i=0,s=null==t?1/0:t;i<s;++i){var o=this.input.charCodeAt(this.pos),a=void 0;if((a=o>=97?o-97+10:o>=65?o-65+10:o>=48&&o<=57?o-48:1/0)>=e)break;++this.pos,n=n*e+a}return this.pos===r||null!=t&&this.pos-r!==t?null:n},pp$8.readRadixNumber=function(e){this.pos+=2;var t=this.readInt(e);return null==t&&this.raise(this.start+2,"Expected number in radix "+e),isIdentifierStart(this.fullCharCodeAtPos())&&this.raise(this.pos,"Identifier directly after number"),this.finishToken(types.num,t)},pp$8.readNumber=function(e){var t=this.pos;e||null!==this.readInt(10)||this.raise(t,"Invalid number");var r=this.pos-t>=2&&48===this.input.charCodeAt(t);r&&this.strict&&this.raise(t,"Invalid number"),r&&/[89]/.test(this.input.slice(t,this.pos))&&(r=!1);var n=this.input.charCodeAt(this.pos);46!==n||r||(++this.pos,this.readInt(10),n=this.input.charCodeAt(this.pos)),69!==n&&101!==n||r||(43!==(n=this.input.charCodeAt(++this.pos))&&45!==n||++this.pos,null===this.readInt(10)&&this.raise(t,"Invalid number")),isIdentifierStart(this.fullCharCodeAtPos())&&this.raise(this.pos,"Identifier directly after number");var i=this.input.slice(t,this.pos),s=r?parseInt(i,8):parseFloat(i);return this.finishToken(types.num,s)},pp$8.readCodePoint=function(){var e;if(123===this.input.charCodeAt(this.pos)){this.options.ecmaVersion<6&&this.unexpected();var t=++this.pos;e=this.readHexChar(this.input.indexOf("}",this.pos)-this.pos),++this.pos,e>1114111&&this.invalidStringToken(t,"Code point out of bounds")}else e=this.readHexChar(4);return e},pp$8.readString=function(e){for(var t="",r=++this.pos;;){this.pos>=this.input.length&&this.raise(this.start,"Unterminated string constant");var n=this.input.charCodeAt(this.pos);if(n===e)break;92===n?(t+=this.input.slice(r,this.pos),t+=this.readEscapedChar(!1),r=this.pos):(isNewLine(n,this.options.ecmaVersion>=10)&&this.raise(this.start,"Unterminated string constant"),++this.pos)}return t+=this.input.slice(r,this.pos++),this.finishToken(types.string,t)};var INVALID_TEMPLATE_ESCAPE_ERROR={};pp$8.tryReadTemplateToken=function(){this.inTemplateElement=!0;try{this.readTmplToken()}catch(e){if(e!==INVALID_TEMPLATE_ESCAPE_ERROR)throw e;this.readInvalidTemplateToken()}this.inTemplateElement=!1},pp$8.invalidStringToken=function(e,t){if(this.inTemplateElement&&this.options.ecmaVersion>=9)throw INVALID_TEMPLATE_ESCAPE_ERROR;this.raise(e,t)},pp$8.readTmplToken=function(){for(var e="",t=this.pos;;){this.pos>=this.input.length&&this.raise(this.start,"Unterminated template");var r=this.input.charCodeAt(this.pos);if(96===r||36===r&&123===this.input.charCodeAt(this.pos+1))return this.pos!==this.start||this.type!==types.template&&this.type!==types.invalidTemplate?(e+=this.input.slice(t,this.pos),this.finishToken(types.template,e)):36===r?(this.pos+=2,this.finishToken(types.dollarBraceL)):(++this.pos,this.finishToken(types.backQuote));if(92===r)e+=this.input.slice(t,this.pos),e+=this.readEscapedChar(!0),t=this.pos;else if(isNewLine(r)){switch(e+=this.input.slice(t,this.pos),++this.pos,r){case 13:10===this.input.charCodeAt(this.pos)&&++this.pos;case 10:e+="\n";break;default:e+=String.fromCharCode(r)}this.options.locations&&(++this.curLine,this.lineStart=this.pos),t=this.pos}else++this.pos}},pp$8.readInvalidTemplateToken=function(){for(;this.pos<this.input.length;this.pos++)switch(this.input[this.pos]){case"\\":++this.pos;break;case"$":if("{"!==this.input[this.pos+1])break;case"`":return this.finishToken(types.invalidTemplate,this.input.slice(this.start,this.pos))}this.raise(this.start,"Unterminated template")},pp$8.readEscapedChar=function(e){var t=this.input.charCodeAt(++this.pos);switch(++this.pos,t){case 110:return"\n";case 114:return"\r";case 120:return String.fromCharCode(this.readHexChar(2));case 117:return codePointToString(this.readCodePoint());case 116:return"\t";case 98:return"\b";case 118:return"\v";case 102:return"\f";case 13:10===this.input.charCodeAt(this.pos)&&++this.pos;case 10:return this.options.locations&&(this.lineStart=this.pos,++this.curLine),"";default:if(t>=48&&t<=55){var r=this.input.substr(this.pos-1,3).match(/^[0-7]+/)[0],n=parseInt(r,8);return n>255&&(r=r.slice(0,-1),n=parseInt(r,8)),this.pos+=r.length-1,t=this.input.charCodeAt(this.pos),"0"===r&&56!==t&&57!==t||!this.strict&&!e||this.invalidStringToken(this.pos-1-r.length,e?"Octal literal in template string":"Octal literal in strict mode"),String.fromCharCode(n)}return isNewLine(t)?"":String.fromCharCode(t)}},pp$8.readHexChar=function(e){var t=this.pos,r=this.readInt(16,e);return null===r&&this.invalidStringToken(t,"Bad character escape sequence"),r},pp$8.readWord1=function(){this.containsEsc=!1;for(var e="",t=!0,r=this.pos,n=this.options.ecmaVersion>=6;this.pos<this.input.length;){var i=this.fullCharCodeAtPos();if(isIdentifierChar(i,n))this.pos+=i<=65535?1:2;else{if(92!==i)break;this.containsEsc=!0,e+=this.input.slice(r,this.pos);var s=this.pos;117!==this.input.charCodeAt(++this.pos)&&this.invalidStringToken(this.pos,"Expecting Unicode escape sequence \\uXXXX"),++this.pos;var o=this.readCodePoint();(t?isIdentifierStart:isIdentifierChar)(o,n)||this.invalidStringToken(s,"Invalid Unicode escape"),e+=codePointToString(o),r=this.pos}t=!1}return e+this.input.slice(r,this.pos)},pp$8.readWord=function(){var e=this.readWord1(),t=types.name;return this.keywords.test(e)&&(this.containsEsc&&this.raiseRecoverable(this.start,"Escape sequence in keyword "+e),t=keywords$1[e]),this.finishToken(t,e)};var extendStatics=function(e,t){return(extendStatics=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r])})(e,t)};function __extends(e,t){function r(){this.constructor=e}extendStatics(e,t),e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)}var __assign=function(){return(__assign=Object.assign||function(e){for(var t,r=1,n=arguments.length;r<n;r++)for(var i in t=arguments[r])Object.prototype.hasOwnProperty.call(t,i)&&(e[i]=t[i]);return e}).apply(this,arguments)},version$1="1.4.1",minimalisticAssert=assert;function assert(e,t){if(!e)throw new Error(t||"Assertion failed")}assert.equal=function(e,t,r){if(e!=t)throw new Error(r||"Assertion failed: "+e+" != "+t)};var commonjsGlobal="undefined"!=typeof window?window:"undefined"!=typeof global?global:"undefined"!=typeof self?self:{};function createCommonjsModule$1(e,t){return e(t={exports:{}},t.exports),t.exports}var inherits_browser$1=createCommonjsModule$1(function(e){"function"==typeof Object.create?e.exports=function(e,t){e.super_=t,e.prototype=Object.create(t.prototype,{constructor:{value:e,enumerable:!1,writable:!0,configurable:!0}})}:e.exports=function(e,t){e.super_=t;var r=function(){};r.prototype=t.prototype,e.prototype=new r,e.prototype.constructor=e}}),inherits$1=createCommonjsModule$1(function(e){try{var t=util$2$1;if("function"!=typeof t.inherits)throw"";e.exports=t.inherits}catch(t){e.exports=inherits_browser$1}}),inherits_1=inherits$1;function isSurrogatePair(e,t){return 55296==(64512&e.charCodeAt(t))&&(!(t<0||t+1>=e.length)&&56320==(64512&e.charCodeAt(t+1)))}function toArray(e,t){if(Array.isArray(e))return e.slice();if(!e)return[];var r=[];if("string"==typeof e)if(t){if("hex"===t)for((e=e.replace(/[^a-z0-9]+/gi,"")).length%2!=0&&(e="0"+e),i=0;i<e.length;i+=2)r.push(parseInt(e[i]+e[i+1],16))}else for(var n=0,i=0;i<e.length;i++){var s=e.charCodeAt(i);s<128?r[n++]=s:s<2048?(r[n++]=s>>6|192,r[n++]=63&s|128):isSurrogatePair(e,i)?(s=65536+((1023&s)<<10)+(1023&e.charCodeAt(++i)),r[n++]=s>>18|240,r[n++]=s>>12&63|128,r[n++]=s>>6&63|128,r[n++]=63&s|128):(r[n++]=s>>12|224,r[n++]=s>>6&63|128,r[n++]=63&s|128)}else for(i=0;i<e.length;i++)r[i]=0|e[i];return r}var toArray_1=toArray;function toHex(e){for(var t="",r=0;r<e.length;r++)t+=zero2(e[r].toString(16));return t}var toHex_1=toHex;function htonl(e){return(e>>>24|e>>>8&65280|e<<8&16711680|(255&e)<<24)>>>0}var htonl_1=htonl;function toHex32(e,t){for(var r="",n=0;n<e.length;n++){var i=e[n];"little"===t&&(i=htonl(i)),r+=zero8(i.toString(16))}return r}var toHex32_1=toHex32;function zero2(e){return 1===e.length?"0"+e:e}var zero2_1=zero2;function zero8(e){return 7===e.length?"0"+e:6===e.length?"00"+e:5===e.length?"000"+e:4===e.length?"0000"+e:3===e.length?"00000"+e:2===e.length?"000000"+e:1===e.length?"0000000"+e:e}var zero8_1=zero8;function join32(e,t,r,n){var i=r-t;minimalisticAssert(i%4==0);for(var s=new Array(i/4),o=0,a=t;o<s.length;o++,a+=4){var u;u="big"===n?e[a]<<24|e[a+1]<<16|e[a+2]<<8|e[a+3]:e[a+3]<<24|e[a+2]<<16|e[a+1]<<8|e[a],s[o]=u>>>0}return s}var join32_1=join32;function split32(e,t){for(var r=new Array(4*e.length),n=0,i=0;n<e.length;n++,i+=4){var s=e[n];"big"===t?(r[i]=s>>>24,r[i+1]=s>>>16&255,r[i+2]=s>>>8&255,r[i+3]=255&s):(r[i+3]=s>>>24,r[i+2]=s>>>16&255,r[i+1]=s>>>8&255,r[i]=255&s)}return r}var split32_1=split32;function rotr32(e,t){return e>>>t|e<<32-t}var rotr32_1=rotr32;function rotl32(e,t){return e<<t|e>>>32-t}var rotl32_1=rotl32;function sum32(e,t){return e+t>>>0}var sum32_1=sum32;function sum32_3(e,t,r){return e+t+r>>>0}var sum32_3_1=sum32_3;function sum32_4(e,t,r,n){return e+t+r+n>>>0}var sum32_4_1=sum32_4;function sum32_5(e,t,r,n,i){return e+t+r+n+i>>>0}var sum32_5_1=sum32_5;function sum64(e,t,r,n){var i=e[t],s=n+e[t+1]>>>0,o=(s<n?1:0)+r+i;e[t]=o>>>0,e[t+1]=s}var sum64_1=sum64;function sum64_hi(e,t,r,n){return(t+n>>>0<t?1:0)+e+r>>>0}var sum64_hi_1=sum64_hi;function sum64_lo(e,t,r,n){return t+n>>>0}var sum64_lo_1=sum64_lo;function sum64_4_hi(e,t,r,n,i,s,o,a){var u=0,c=t;return u+=(c=c+n>>>0)<t?1:0,u+=(c=c+s>>>0)<s?1:0,e+r+i+o+(u+=(c=c+a>>>0)<a?1:0)>>>0}var sum64_4_hi_1=sum64_4_hi;function sum64_4_lo(e,t,r,n,i,s,o,a){return t+n+s+a>>>0}var sum64_4_lo_1=sum64_4_lo;function sum64_5_hi(e,t,r,n,i,s,o,a,u,c){var p=0,l=t;return p+=(l=l+n>>>0)<t?1:0,p+=(l=l+s>>>0)<s?1:0,p+=(l=l+a>>>0)<a?1:0,e+r+i+o+u+(p+=(l=l+c>>>0)<c?1:0)>>>0}var sum64_5_hi_1=sum64_5_hi;function sum64_5_lo(e,t,r,n,i,s,o,a,u,c){return t+n+s+a+c>>>0}var sum64_5_lo_1=sum64_5_lo;function rotr64_hi(e,t,r){return(t<<32-r|e>>>r)>>>0}var rotr64_hi_1=rotr64_hi;function rotr64_lo(e,t,r){return(e<<32-r|t>>>r)>>>0}var rotr64_lo_1=rotr64_lo;function shr64_hi(e,t,r){return e>>>r}var shr64_hi_1=shr64_hi;function shr64_lo(e,t,r){return(e<<32-r|t>>>r)>>>0}var shr64_lo_1=shr64_lo,utils={inherits:inherits_1,toArray:toArray_1,toHex:toHex_1,htonl:htonl_1,toHex32:toHex32_1,zero2:zero2_1,zero8:zero8_1,join32:join32_1,split32:split32_1,rotr32:rotr32_1,rotl32:rotl32_1,sum32:sum32_1,sum32_3:sum32_3_1,sum32_4:sum32_4_1,sum32_5:sum32_5_1,sum64:sum64_1,sum64_hi:sum64_hi_1,sum64_lo:sum64_lo_1,sum64_4_hi:sum64_4_hi_1,sum64_4_lo:sum64_4_lo_1,sum64_5_hi:sum64_5_hi_1,sum64_5_lo:sum64_5_lo_1,rotr64_hi:rotr64_hi_1,rotr64_lo:rotr64_lo_1,shr64_hi:shr64_hi_1,shr64_lo:shr64_lo_1};function BlockHash(){this.pending=null,this.pendingTotal=0,this.blockSize=this.constructor.blockSize,this.outSize=this.constructor.outSize,this.hmacStrength=this.constructor.hmacStrength,this.padLength=this.constructor.padLength/8,this.endian="big",this._delta8=this.blockSize/8,this._delta32=this.blockSize/32}var BlockHash_1=BlockHash;BlockHash.prototype.update=function(e,t){if(e=utils.toArray(e,t),this.pending?this.pending=this.pending.concat(e):this.pending=e,this.pendingTotal+=e.length,this.pending.length>=this._delta8){var r=(e=this.pending).length%this._delta8;this.pending=e.slice(e.length-r,e.length),0===this.pending.length&&(this.pending=null),e=utils.join32(e,0,e.length-r,this.endian);for(var n=0;n<e.length;n+=this._delta32)this._update(e,n,n+this._delta32)}return this},BlockHash.prototype.digest=function(e){return this.update(this._pad()),minimalisticAssert(null===this.pending),this._digest(e)},BlockHash.prototype._pad=function(){var e=this.pendingTotal,t=this._delta8,r=t-(e+this.padLength)%t,n=new Array(r+this.padLength);n[0]=128;for(var i=1;i<r;i++)n[i]=0;if(e<<=3,"big"===this.endian){for(var s=8;s<this.padLength;s++)n[i++]=0;n[i++]=0,n[i++]=0,n[i++]=0,n[i++]=0,n[i++]=e>>>24&255,n[i++]=e>>>16&255,n[i++]=e>>>8&255,n[i++]=255&e}else for(n[i++]=255&e,n[i++]=e>>>8&255,n[i++]=e>>>16&255,n[i++]=e>>>24&255,n[i++]=0,n[i++]=0,n[i++]=0,n[i++]=0,s=8;s<this.padLength;s++)n[i++]=0;return n};var common$1={BlockHash:BlockHash_1},rotr32$1=utils.rotr32;function ft_1(e,t,r,n){return 0===e?ch32(t,r,n):1===e||3===e?p32(t,r,n):2===e?maj32(t,r,n):void 0}var ft_1_1=ft_1;function ch32(e,t,r){return e&t^~e&r}var ch32_1=ch32;function maj32(e,t,r){return e&t^e&r^t&r}var maj32_1=maj32;function p32(e,t,r){return e^t^r}var p32_1=p32;function s0_256(e){return rotr32$1(e,2)^rotr32$1(e,13)^rotr32$1(e,22)}var s0_256_1=s0_256;function s1_256(e){return rotr32$1(e,6)^rotr32$1(e,11)^rotr32$1(e,25)}var s1_256_1=s1_256;function g0_256(e){return rotr32$1(e,7)^rotr32$1(e,18)^e>>>3}var g0_256_1=g0_256;function g1_256(e){return rotr32$1(e,17)^rotr32$1(e,19)^e>>>10}var g1_256_1=g1_256,common$1$1={ft_1:ft_1_1,ch32:ch32_1,maj32:maj32_1,p32:p32_1,s0_256:s0_256_1,s1_256:s1_256_1,g0_256:g0_256_1,g1_256:g1_256_1},sum32$1=utils.sum32,sum32_4$1=utils.sum32_4,sum32_5$1=utils.sum32_5,ch32$1=common$1$1.ch32,maj32$1=common$1$1.maj32,s0_256$1=common$1$1.s0_256,s1_256$1=common$1$1.s1_256,g0_256$1=common$1$1.g0_256,g1_256$1=common$1$1.g1_256,BlockHash$1=common$1.BlockHash,sha256_K=[1116352408,1899447441,3049323471,3921009573,961987163,1508970993,2453635748,2870763221,3624381080,310598401,607225278,1426881987,1925078388,2162078206,2614888103,3248222580,3835390401,4022224774,264347078,604807628,770255983,1249150122,1555081692,1996064986,2554220882,2821834349,2952996808,3210313671,3336571891,3584528711,113926993,338241895,666307205,773529912,1294757372,1396182291,1695183700,1986661051,2177026350,2456956037,2730485921,2820302411,3259730800,3345764771,3516065817,3600352804,4094571909,275423344,430227734,506948616,659060556,883997877,958139571,1322822218,1537002063,1747873779,1955562222,2024104815,2227730452,2361852424,2428436474,2756734187,3204031479,3329325298];function SHA256(){if(!(this instanceof SHA256))return new SHA256;BlockHash$1.call(this),this.h=[1779033703,3144134277,1013904242,2773480762,1359893119,2600822924,528734635,1541459225],this.k=sha256_K,this.W=new Array(64)}utils.inherits(SHA256,BlockHash$1);var _256=SHA256;SHA256.blockSize=512,SHA256.outSize=256,SHA256.hmacStrength=192,SHA256.padLength=64,SHA256.prototype._update=function(e,t){for(var r=this.W,n=0;n<16;n++)r[n]=e[t+n];for(;n<r.length;n++)r[n]=sum32_4$1(g1_256$1(r[n-2]),r[n-7],g0_256$1(r[n-15]),r[n-16]);var i=this.h[0],s=this.h[1],o=this.h[2],a=this.h[3],u=this.h[4],c=this.h[5],p=this.h[6],l=this.h[7];for(minimalisticAssert(this.k.length===r.length),n=0;n<r.length;n++){var h=sum32_5$1(l,s1_256$1(u),ch32$1(u,c,p),this.k[n],r[n]),f=sum32$1(s0_256$1(i),maj32$1(i,s,o));l=p,p=c,c=u,u=sum32$1(a,h),a=o,o=s,s=i,i=sum32$1(h,f)}this.h[0]=sum32$1(this.h[0],i),this.h[1]=sum32$1(this.h[1],s),this.h[2]=sum32$1(this.h[2],o),this.h[3]=sum32$1(this.h[3],a),this.h[4]=sum32$1(this.h[4],u),this.h[5]=sum32$1(this.h[5],c),this.h[6]=sum32$1(this.h[6],p),this.h[7]=sum32$1(this.h[7],l)},SHA256.prototype._digest=function(e){return"hex"===e?utils.toHex32(this.h,"big"):utils.split32(this.h,"big")};for(var charToInteger={},chars="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=",i=0;i<chars.length;i++)charToInteger[chars.charCodeAt(i)]=i;function decode(e){for(var t=0,r=0,n=0,i=0,s=0,o=[],a=[],u=[],c=0,p=0,l=0,h=0,f=e.length;c<f;c++){var d=e.charCodeAt(c);if(44===d)u.length&&a.push(new Int32Array(u)),u=[],p=0;else if(59===d)u.length&&a.push(new Int32Array(u)),u=[],p=0,o.push(a),a=[],t=0;else{var m=charToInteger[d];if(void 0===m)throw new Error("Invalid character ("+String.fromCharCode(d)+")");var g=32&m;if(h+=(m&=31)<<l,g)l+=5;else{var y=1&h;h>>=1;var v=y?-h:h;0==p?(t+=v,u.push(t)):1===p?(r+=v,u.push(r)):2===p?(n+=v,u.push(n)):3===p?(i+=v,u.push(i)):4===p&&(s+=v,u.push(s)),p++,h=l=0}}}return u.length&&a.push(new Int32Array(u)),o.push(a),o}function encode(e){for(var t=0,r=0,n=0,i=0,s="",o=0;o<e.length;o++){var a=e[o];if(o>0&&(s+=";"),0!==a.length){for(var u=0,c=[],p=0,l=a;p<l.length;p++){var h=l[p],f=encodeInteger(h[0]-u);u=h[0],h.length>1&&(f+=encodeInteger(h[1]-t)+encodeInteger(h[2]-r)+encodeInteger(h[3]-n),t=h[1],r=h[2],n=h[3]),5===h.length&&(f+=encodeInteger(h[4]-i),i=h[4]),c.push(f)}s+=c.join(",")}}return s}function encodeInteger(e){var t="";e=e<0?-e<<1|1:e<<1;do{var r=31&e;(e>>=5)>0&&(r|=32),t+=chars[r]}while(e>0);return t}var Chunk=function(e,t,r){this.start=e,this.end=t,this.original=r,this.intro="",this.outro="",this.content=r,this.storeName=!1,this.edited=!1,Object.defineProperties(this,{previous:{writable:!0,value:null},next:{writable:!0,value:null}})};Chunk.prototype.appendLeft=function(e){this.outro+=e},Chunk.prototype.appendRight=function(e){this.intro=this.intro+e},Chunk.prototype.clone=function(){var e=new Chunk(this.start,this.end,this.original);return e.intro=this.intro,e.outro=this.outro,e.content=this.content,e.storeName=this.storeName,e.edited=this.edited,e},Chunk.prototype.contains=function(e){return this.start<e&&e<this.end},Chunk.prototype.eachNext=function(e){for(var t=this;t;)e(t),t=t.next},Chunk.prototype.eachPrevious=function(e){for(var t=this;t;)e(t),t=t.previous},Chunk.prototype.edit=function(e,t,r){return this.content=e,r||(this.intro="",this.outro=""),this.storeName=t,this.edited=!0,this},Chunk.prototype.prependLeft=function(e){this.outro=e+this.outro},Chunk.prototype.prependRight=function(e){this.intro=e+this.intro},Chunk.prototype.split=function(e){var t=e-this.start,r=this.original.slice(0,t),n=this.original.slice(t);this.original=r;var i=new Chunk(e,this.end,n);return i.outro=this.outro,this.outro="",this.end=e,this.edited?(i.edit("",!1),this.content=""):this.content=r,i.next=this.next,i.next&&(i.next.previous=i),i.previous=this,this.next=i,i},Chunk.prototype.toString=function(){return this.intro+this.content+this.outro},Chunk.prototype.trimEnd=function(e){if(this.outro=this.outro.replace(e,""),this.outro.length)return!0;var t=this.content.replace(e,"");return t.length?(t!==this.content&&this.split(this.start+t.length).edit("",void 0,!0),!0):(this.edit("",void 0,!0),this.intro=this.intro.replace(e,""),!!this.intro.length||void 0)},Chunk.prototype.trimStart=function(e){if(this.intro=this.intro.replace(e,""),this.intro.length)return!0;var t=this.content.replace(e,"");return t.length?(t!==this.content&&(this.split(this.end-t.length),this.edit("",void 0,!0)),!0):(this.edit("",void 0,!0),this.outro=this.outro.replace(e,""),!!this.outro.length||void 0)};var btoa=function(){throw new Error("Unsupported environment: `window.btoa` or `Buffer` should be supported.")};"undefined"!=typeof window&&"function"==typeof window.btoa?btoa=function(e){return window.btoa(unescape(encodeURIComponent(e)))}:"function"==typeof Buffer&&(btoa=function(e){return Buffer.from(e,"utf-8").toString("base64")});var SourceMap=function(e){this.version=3,this.file=e.file,this.sources=e.sources,this.sourcesContent=e.sourcesContent,this.names=e.names,this.mappings=encode(e.mappings)};function guessIndent(e){var t=e.split("\n"),r=t.filter(function(e){return/^\t+/.test(e)}),n=t.filter(function(e){return/^ {2,}/.test(e)});if(0===r.length&&0===n.length)return null;if(r.length>=n.length)return"\t";var i=n.reduce(function(e,t){var r=/^ +/.exec(t)[0].length;return Math.min(r,e)},1/0);return new Array(i+1).join(" ")}function getRelativePath(e,t){var r=e.split(/[\/\\]/),n=t.split(/[\/\\]/);for(r.pop();r[0]===n[0];)r.shift(),n.shift();if(r.length)for(var i=r.length;i--;)r[i]="..";return r.concat(n).join("/")}SourceMap.prototype.toString=function(){return JSON.stringify(this)},SourceMap.prototype.toUrl=function(){return"data:application/json;charset=utf-8;base64,"+btoa(this.toString())};var toString$1=Object.prototype.toString;function isObject(e){return"[object Object]"===toString$1.call(e)}function getLocator(e){for(var t=e.split("\n"),r=[],n=0,i=0;n<t.length;n++)r.push(i),i+=t[n].length+1;return function(e){for(var t=0,n=r.length;t<n;){var i=t+n>>1;e<r[i]?n=i:t=i+1}var s=t-1;return{line:s,column:e-r[s]}}}var Mappings=function(e){this.hires=e,this.generatedCodeLine=0,this.generatedCodeColumn=0,this.raw=[],this.rawSegments=this.raw[this.generatedCodeLine]=[],this.pending=null};Mappings.prototype.addEdit=function(e,t,r,n){if(t.length){var i=[this.generatedCodeColumn,e,r.line,r.column];n>=0&&i.push(n),this.rawSegments.push(i)}else this.pending&&this.rawSegments.push(this.pending);this.advance(t),this.pending=null},Mappings.prototype.addUneditedChunk=function(e,t,r,n,i){for(var s=t.start,o=!0;s<t.end;)(this.hires||o||i[s])&&this.rawSegments.push([this.generatedCodeColumn,e,n.line,n.column]),"\n"===r[s]?(n.line+=1,n.column=0,this.generatedCodeLine+=1,this.raw[this.generatedCodeLine]=this.rawSegments=[],this.generatedCodeColumn=0):(n.column+=1,this.generatedCodeColumn+=1),s+=1,o=!1;this.pending=[this.generatedCodeColumn,e,n.line,n.column]},Mappings.prototype.advance=function(e){if(e){var t=e.split("\n");if(t.length>1){for(var r=0;r<t.length-1;r++)this.generatedCodeLine++,this.raw[this.generatedCodeLine]=this.rawSegments=[];this.generatedCodeColumn=0}this.generatedCodeColumn+=t[t.length-1].length}};var n="\n",warned={insertLeft:!1,insertRight:!1,storeName:!1},MagicString=function(e,t){void 0===t&&(t={});var r=new Chunk(0,e.length,e);Object.defineProperties(this,{original:{writable:!0,value:e},outro:{writable:!0,value:""},intro:{writable:!0,value:""},firstChunk:{writable:!0,value:r},lastChunk:{writable:!0,value:r},lastSearchedChunk:{writable:!0,value:r},byStart:{writable:!0,value:{}},byEnd:{writable:!0,value:{}},filename:{writable:!0,value:t.filename},indentExclusionRanges:{writable:!0,value:t.indentExclusionRanges},sourcemapLocations:{writable:!0,value:{}},storedNames:{writable:!0,value:{}},indentStr:{writable:!0,value:guessIndent(e)}}),this.byStart[0]=r,this.byEnd[e.length]=r};MagicString.prototype.addSourcemapLocation=function(e){this.sourcemapLocations[e]=!0},MagicString.prototype.append=function(e){if("string"!=typeof e)throw new TypeError("outro content must be a string");return this.outro+=e,this},MagicString.prototype.appendLeft=function(e,t){if("string"!=typeof t)throw new TypeError("inserted content must be a string");this._split(e);var r=this.byEnd[e];return r?r.appendLeft(t):this.intro+=t,this},MagicString.prototype.appendRight=function(e,t){if("string"!=typeof t)throw new TypeError("inserted content must be a string");this._split(e);var r=this.byStart[e];return r?r.appendRight(t):this.outro+=t,this},MagicString.prototype.clone=function(){for(var e=new MagicString(this.original,{filename:this.filename}),t=this.firstChunk,r=e.firstChunk=e.lastSearchedChunk=t.clone();t;){e.byStart[r.start]=r,e.byEnd[r.end]=r;var n=t.next,i=n&&n.clone();i&&(r.next=i,i.previous=r,r=i),t=n}return e.lastChunk=r,this.indentExclusionRanges&&(e.indentExclusionRanges=this.indentExclusionRanges.slice()),Object.keys(this.sourcemapLocations).forEach(function(t){e.sourcemapLocations[t]=!0}),e},MagicString.prototype.generateDecodedMap=function(e){var t=this;e=e||{};var r=Object.keys(this.storedNames),n=new Mappings(e.hires),i=getLocator(this.original);return this.intro&&n.advance(this.intro),this.firstChunk.eachNext(function(e){var s=i(e.start);e.intro.length&&n.advance(e.intro),e.edited?n.addEdit(0,e.content,s,e.storeName?r.indexOf(e.original):-1):n.addUneditedChunk(0,e,t.original,s,t.sourcemapLocations),e.outro.length&&n.advance(e.outro)}),{file:e.file?e.file.split(/[\/\\]/).pop():null,sources:[e.source?getRelativePath(e.file||"",e.source):null],sourcesContent:e.includeContent?[this.original]:[null],names:r,mappings:n.raw}},MagicString.prototype.generateMap=function(e){return new SourceMap(this.generateDecodedMap(e))},MagicString.prototype.getIndentString=function(){return null===this.indentStr?"\t":this.indentStr},MagicString.prototype.indent=function(e,t){var r=/^[^\r\n]/gm;if(isObject(e)&&(t=e,e=void 0),""===(e=void 0!==e?e:this.indentStr||"\t"))return this;var n={};(t=t||{}).exclude&&("number"==typeof t.exclude[0]?[t.exclude]:t.exclude).forEach(function(e){for(var t=e[0];t<e[1];t+=1)n[t]=!0});var i=!1!==t.indentStart,s=function(t){return i?""+e+t:(i=!0,t)};this.intro=this.intro.replace(r,s);for(var o=0,a=this.firstChunk;a;){var u=a.end;if(a.edited)n[o]||(a.content=a.content.replace(r,s),a.content.length&&(i="\n"===a.content[a.content.length-1]));else for(o=a.start;o<u;){if(!n[o]){var c=this.original[o];"\n"===c?i=!0:"\r"!==c&&i&&(i=!1,o===a.start?a.prependRight(e):(this._splitChunk(a,o),(a=a.next).prependRight(e)))}o+=1}o=a.end,a=a.next}return this.outro=this.outro.replace(r,s),this},MagicString.prototype.insert=function(){throw new Error("magicString.insert(...) is deprecated. Use prependRight(...) or appendLeft(...)")},MagicString.prototype.insertLeft=function(e,t){return warned.insertLeft||(console.warn("magicString.insertLeft(...) is deprecated. Use magicString.appendLeft(...) instead"),warned.insertLeft=!0),this.appendLeft(e,t)},MagicString.prototype.insertRight=function(e,t){return warned.insertRight||(console.warn("magicString.insertRight(...) is deprecated. Use magicString.prependRight(...) instead"),warned.insertRight=!0),this.prependRight(e,t)},MagicString.prototype.move=function(e,t,r){if(r>=e&&r<=t)throw new Error("Cannot move a selection inside itself");this._split(e),this._split(t),this._split(r);var n=this.byStart[e],i=this.byEnd[t],s=n.previous,o=i.next,a=this.byStart[r];if(!a&&i===this.lastChunk)return this;var u=a?a.previous:this.lastChunk;return s&&(s.next=o),o&&(o.previous=s),u&&(u.next=n),a&&(a.previous=i),n.previous||(this.firstChunk=i.next),i.next||(this.lastChunk=n.previous,this.lastChunk.next=null),n.previous=u,i.next=a||null,u||(this.firstChunk=n),a||(this.lastChunk=i),this},MagicString.prototype.overwrite=function(e,t,r,n){if("string"!=typeof r)throw new TypeError("replacement content must be a string");for(;e<0;)e+=this.original.length;for(;t<0;)t+=this.original.length;if(t>this.original.length)throw new Error("end is out of bounds");if(e===t)throw new Error("Cannot overwrite a zero-length range – use appendLeft or prependRight instead");this._split(e),this._split(t),!0===n&&(warned.storeName||(console.warn("The final argument to magicString.overwrite(...) should be an options object. See https://github.com/rich-harris/magic-string"),warned.storeName=!0),n={storeName:!0});var i=void 0!==n&&n.storeName,s=void 0!==n&&n.contentOnly;if(i){var o=this.original.slice(e,t);this.storedNames[o]=!0}var a=this.byStart[e],u=this.byEnd[t];if(a){if(t>a.end&&a.next!==this.byStart[a.end])throw new Error("Cannot overwrite across a split point");if(a.edit(r,i,s),a!==u){for(var c=a.next;c!==u;)c.edit("",!1),c=c.next;c.edit("",!1)}}else{var p=new Chunk(e,t,"").edit(r,i);u.next=p,p.previous=u}return this},MagicString.prototype.prepend=function(e){if("string"!=typeof e)throw new TypeError("outro content must be a string");return this.intro=e+this.intro,this},MagicString.prototype.prependLeft=function(e,t){if("string"!=typeof t)throw new TypeError("inserted content must be a string");this._split(e);var r=this.byEnd[e];return r?r.prependLeft(t):this.intro=t+this.intro,this},MagicString.prototype.prependRight=function(e,t){if("string"!=typeof t)throw new TypeError("inserted content must be a string");this._split(e);var r=this.byStart[e];return r?r.prependRight(t):this.outro=t+this.outro,this},MagicString.prototype.remove=function(e,t){for(;e<0;)e+=this.original.length;for(;t<0;)t+=this.original.length;if(e===t)return this;if(e<0||t>this.original.length)throw new Error("Character is out of bounds");if(e>t)throw new Error("end must be greater than start");this._split(e),this._split(t);for(var r=this.byStart[e];r;)r.intro="",r.outro="",r.edit(""),r=t>r.end?this.byStart[r.end]:null;return this},MagicString.prototype.lastChar=function(){if(this.outro.length)return this.outro[this.outro.length-1];var e=this.lastChunk;do{if(e.outro.length)return e.outro[e.outro.length-1];if(e.content.length)return e.content[e.content.length-1];if(e.intro.length)return e.intro[e.intro.length-1]}while(e=e.previous);return this.intro.length?this.intro[this.intro.length-1]:""},MagicString.prototype.lastLine=function(){var e=this.outro.lastIndexOf(n);if(-1!==e)return this.outro.substr(e+1);var t=this.outro,r=this.lastChunk;do{if(r.outro.length>0){if(-1!==(e=r.outro.lastIndexOf(n)))return r.outro.substr(e+1)+t;t=r.outro+t}if(r.content.length>0){if(-1!==(e=r.content.lastIndexOf(n)))return r.content.substr(e+1)+t;t=r.content+t}if(r.intro.length>0){if(-1!==(e=r.intro.lastIndexOf(n)))return r.intro.substr(e+1)+t;t=r.intro+t}}while(r=r.previous);return-1!==(e=this.intro.lastIndexOf(n))?this.intro.substr(e+1)+t:this.intro+t},MagicString.prototype.slice=function(e,t){for(void 0===e&&(e=0),void 0===t&&(t=this.original.length);e<0;)e+=this.original.length;for(;t<0;)t+=this.original.length;for(var r="",n=this.firstChunk;n&&(n.start>e||n.end<=e);){if(n.start<t&&n.end>=t)return r;n=n.next}if(n&&n.edited&&n.start!==e)throw new Error("Cannot use replaced character "+e+" as slice start anchor.");for(var i=n;n;){!n.intro||i===n&&n.start!==e||(r+=n.intro);var s=n.start<t&&n.end>=t;if(s&&n.edited&&n.end!==t)throw new Error("Cannot use replaced character "+t+" as slice end anchor.");var o=i===n?e-n.start:0,a=s?n.content.length+t-n.end:n.content.length;if(r+=n.content.slice(o,a),!n.outro||s&&n.end!==t||(r+=n.outro),s)break;n=n.next}return r},MagicString.prototype.snip=function(e,t){var r=this.clone();return r.remove(0,e),r.remove(t,r.original.length),r},MagicString.prototype._split=function(e){if(!this.byStart[e]&&!this.byEnd[e])for(var t=this.lastSearchedChunk,r=e>t.end;t;){if(t.contains(e))return this._splitChunk(t,e);t=r?this.byStart[t.end]:this.byEnd[t.start]}},MagicString.prototype._splitChunk=function(e,t){if(e.edited&&e.content.length){var r=getLocator(this.original)(t);throw new Error("Cannot split a chunk that has already been edited ("+r.line+":"+r.column+' – "'+e.original+'")')}var n=e.split(t);return this.byEnd[t]=e,this.byStart[t]=n,this.byEnd[n.end]=n,e===this.lastChunk&&(this.lastChunk=n),this.lastSearchedChunk=e,!0},MagicString.prototype.toString=function(){for(var e=this.intro,t=this.firstChunk;t;)e+=t.toString(),t=t.next;return e+this.outro},MagicString.prototype.isEmpty=function(){var e=this.firstChunk;do{if(e.intro.length&&e.intro.trim()||e.content.length&&e.content.trim()||e.outro.length&&e.outro.trim())return!1}while(e=e.next);return!0},MagicString.prototype.length=function(){var e=this.firstChunk,t=0;do{t+=e.intro.length+e.content.length+e.outro.length}while(e=e.next);return t},MagicString.prototype.trimLines=function(){return this.trim("[\\r\\n]")},MagicString.prototype.trim=function(e){return this.trimStart(e).trimEnd(e)},MagicString.prototype.trimEndAborted=function(e){var t=new RegExp((e||"\\s")+"+$");if(this.outro=this.outro.replace(t,""),this.outro.length)return!0;var r=this.lastChunk;do{var n=r.end,i=r.trimEnd(t);if(r.end!==n&&(this.lastChunk===r&&(this.lastChunk=r.next),this.byEnd[r.end]=r,this.byStart[r.next.start]=r.next,this.byEnd[r.next.end]=r.next),i)return!0;r=r.previous}while(r);return!1},MagicString.prototype.trimEnd=function(e){return this.trimEndAborted(e),this},MagicString.prototype.trimStartAborted=function(e){var t=new RegExp("^"+(e||"\\s")+"+");if(this.intro=this.intro.replace(t,""),this.intro.length)return!0;var r=this.firstChunk;do{var n=r.end,i=r.trimStart(t);if(r.end!==n&&(r===this.lastChunk&&(this.lastChunk=r.next),this.byEnd[r.end]=r,this.byStart[r.next.start]=r.next,this.byEnd[r.next.end]=r.next),i)return!0;r=r.next}while(r);return!1},MagicString.prototype.trimStart=function(e){return this.trimStartAborted(e),this};var hasOwnProp=Object.prototype.hasOwnProperty,Bundle=function(e){void 0===e&&(e={}),this.intro=e.intro||"",this.separator=void 0!==e.separator?e.separator:"\n",this.sources=[],this.uniqueSources=[],this.uniqueSourceIndexByFilename={}};Bundle.prototype.addSource=function(e){if(e instanceof MagicString)return this.addSource({content:e,filename:e.filename,separator:this.separator});if(!isObject(e)||!e.content)throw new Error("bundle.addSource() takes an object with a `content` property, which should be an instance of MagicString, and an optional `filename`");if(["filename","indentExclusionRanges","separator"].forEach(function(t){hasOwnProp.call(e,t)||(e[t]=e.content[t])}),void 0===e.separator&&(e.separator=this.separator),e.filename)if(hasOwnProp.call(this.uniqueSourceIndexByFilename,e.filename)){var t=this.uniqueSources[this.uniqueSourceIndexByFilename[e.filename]];if(e.content.original!==t.content)throw new Error("Illegal source: same filename ("+e.filename+"), different contents")}else this.uniqueSourceIndexByFilename[e.filename]=this.uniqueSources.length,this.uniqueSources.push({filename:e.filename,content:e.content.original});return this.sources.push(e),this},Bundle.prototype.append=function(e,t){return this.addSource({content:new MagicString(e),separator:t&&t.separator||""}),this},Bundle.prototype.clone=function(){var e=new Bundle({intro:this.intro,separator:this.separator});return this.sources.forEach(function(t){e.addSource({filename:t.filename,content:t.content.clone(),separator:t.separator})}),e},Bundle.prototype.generateDecodedMap=function(e){var t=this;void 0===e&&(e={});var r=[];this.sources.forEach(function(e){Object.keys(e.content.storedNames).forEach(function(e){~r.indexOf(e)||r.push(e)})});var n=new Mappings(e.hires);return this.intro&&n.advance(this.intro),this.sources.forEach(function(e,i){i>0&&n.advance(t.separator);var s=e.filename?t.uniqueSourceIndexByFilename[e.filename]:-1,o=e.content,a=getLocator(o.original);o.intro&&n.advance(o.intro),o.firstChunk.eachNext(function(t){var i=a(t.start);t.intro.length&&n.advance(t.intro),e.filename?t.edited?n.addEdit(s,t.content,i,t.storeName?r.indexOf(t.original):-1):n.addUneditedChunk(s,t,o.original,i,o.sourcemapLocations):n.advance(t.content),t.outro.length&&n.advance(t.outro)}),o.outro&&n.advance(o.outro)}),{file:e.file?e.file.split(/[\/\\]/).pop():null,sources:this.uniqueSources.map(function(t){return e.file?getRelativePath(e.file,t.filename):t.filename}),sourcesContent:this.uniqueSources.map(function(t){return e.includeContent?t.content:null}),names:r,mappings:n.raw}},Bundle.prototype.generateMap=function(e){return new SourceMap(this.generateDecodedMap(e))},Bundle.prototype.getIndentString=function(){var e={};return this.sources.forEach(function(t){var r=t.content.indentStr;null!==r&&(e[r]||(e[r]=0),e[r]+=1)}),Object.keys(e).sort(function(t,r){return e[t]-e[r]})[0]||"\t"},Bundle.prototype.indent=function(e){var t=this;if(arguments.length||(e=this.getIndentString()),""===e)return this;var r=!this.intro||"\n"===this.intro.slice(-1);return this.sources.forEach(function(n,i){var s=void 0!==n.separator?n.separator:t.separator,o=r||i>0&&/\r?\n$/.test(s);n.content.indent(e,{exclude:n.indentExclusionRanges,indentStart:o}),r="\n"===n.content.lastChar()}),this.intro&&(this.intro=e+this.intro.replace(/^[^\n]/gm,function(t,r){return r>0?e+t:t})),this},Bundle.prototype.prepend=function(e){return this.intro=e+this.intro,this},Bundle.prototype.toString=function(){var e=this,t=this.sources.map(function(t,r){var n=void 0!==t.separator?t.separator:e.separator;return(r>0?n:"")+t.content.toString()}).join("");return this.intro+t},Bundle.prototype.isEmpty=function(){return(!this.intro.length||!this.intro.trim())&&!this.sources.some(function(e){return!e.content.isEmpty()})},Bundle.prototype.length=function(){return this.sources.reduce(function(e,t){return e+t.content.length()},this.intro.length)},Bundle.prototype.trimLines=function(){return this.trim("[\\r\\n]")},Bundle.prototype.trim=function(e){return this.trimStart(e).trimEnd(e)},Bundle.prototype.trimStart=function(e){var t=new RegExp("^"+(e||"\\s")+"+");if(this.intro=this.intro.replace(t,""),!this.intro){var r,n=0;do{if(!(r=this.sources[n++]))break}while(!r.content.trimStartAborted(e))}return this},Bundle.prototype.trimEnd=function(e){var t,r=new RegExp((e||"\\s")+"+$"),n=this.sources.length-1;do{if(!(t=this.sources[n--])){this.intro=this.intro.replace(r,"");break}}while(!t.content.trimEndAborted(e));return this};var BlockStatement="BlockStatement",CallExpression="CallExpression",ClassDeclaration="ClassDeclaration",ExportAllDeclaration="ExportAllDeclaration",ExportDefaultDeclaration="ExportDefaultDeclaration",ExpressionStatement="ExpressionStatement",FunctionDeclaration="FunctionDeclaration",FunctionExpression="FunctionExpression",Identifier="Identifier",ImportDefaultSpecifier="ImportDefaultSpecifier",ImportNamespaceSpecifier="ImportNamespaceSpecifier",Literal="Literal",MemberExpression="MemberExpression",Program="Program",Property="Property",ReturnStatement="ReturnStatement",TemplateLiteral="TemplateLiteral",VariableDeclaration="VariableDeclaration",CallOptions=function(){function e(e){var t=void 0===e?{}:e,r=t.withNew,n=void 0!==r&&r,i=t.args,s=void 0===i?[]:i,o=t.callIdentifier,a=void 0===o?void 0:o;this.withNew=n,this.args=s,this.callIdentifier=a}return e.create=function(e){return new this(e)},e.prototype.equals=function(e){return e&&this.callIdentifier===e.callIdentifier},e}(),UNKNOWN_KEY={UNKNOWN_KEY:!0},EMPTY_PATH=[],UNKNOWN_PATH=[UNKNOWN_KEY];function assembleMemberDescriptions(e,t){return void 0===t&&(t=null),Object.create(t,e)}var UNKNOWN_VALUE={UNKNOWN_VALUE:!0},UNKNOWN_EXPRESSION={deoptimizePath:function(){},getLiteralValueAtPath:function(){return UNKNOWN_VALUE},getReturnExpressionWhenCalledAtPath:function(){return UNKNOWN_EXPRESSION},hasEffectsWhenAccessedAtPath:function(e){return e.length>0},hasEffectsWhenAssignedAtPath:function(e){return e.length>0},hasEffectsWhenCalledAtPath:function(){return!0},include:function(){},included:!0,toString:function(){return"[[UNKNOWN]]"}},UNDEFINED_EXPRESSION={deoptimizePath:function(){},getLiteralValueAtPath:function(){},getReturnExpressionWhenCalledAtPath:function(){return UNKNOWN_EXPRESSION},hasEffectsWhenAccessedAtPath:function(e){return e.length>0},hasEffectsWhenAssignedAtPath:function(e){return e.length>0},hasEffectsWhenCalledAtPath:function(){return!0},include:function(){},included:!0,toString:function(){return"undefined"}},returnsUnknown={value:{callsArgs:null,mutatesSelf:!1,returns:null,returnsPrimitive:UNKNOWN_EXPRESSION}},mutatesSelfReturnsUnknown={value:{returns:null,returnsPrimitive:UNKNOWN_EXPRESSION,callsArgs:null,mutatesSelf:!0}},callsArgReturnsUnknown={value:{returns:null,returnsPrimitive:UNKNOWN_EXPRESSION,callsArgs:[0],mutatesSelf:!1}},UnknownArrayExpression=function(){function e(){this.included=!1}return e.prototype.deoptimizePath=function(){},e.prototype.getLiteralValueAtPath=function(){return UNKNOWN_VALUE},e.prototype.getReturnExpressionWhenCalledAtPath=function(e){return 1===e.length?getMemberReturnExpressionWhenCalled(arrayMembers,e[0]):UNKNOWN_EXPRESSION},e.prototype.hasEffectsWhenAccessedAtPath=function(e){return e.length>1},e.prototype.hasEffectsWhenAssignedAtPath=function(e){return e.length>1},e.prototype.hasEffectsWhenCalledAtPath=function(e,t,r){return 1!==e.length||hasMemberEffectWhenCalled(arrayMembers,e[0],this.included,t,r)},e.prototype.include=function(){this.included=!0},e.prototype.toString=function(){return"[[UNKNOWN ARRAY]]"},e}(),returnsArray={value:{callsArgs:null,mutatesSelf:!1,returns:UnknownArrayExpression,returnsPrimitive:null}},mutatesSelfReturnsArray={value:{callsArgs:null,mutatesSelf:!0,returns:UnknownArrayExpression,returnsPrimitive:null}},callsArgReturnsArray={value:{callsArgs:[0],mutatesSelf:!1,returns:UnknownArrayExpression,returnsPrimitive:null}},callsArgMutatesSelfReturnsArray={value:{callsArgs:[0],mutatesSelf:!0,returns:UnknownArrayExpression,returnsPrimitive:null}},UNKNOWN_LITERAL_BOOLEAN={deoptimizePath:function(){},getLiteralValueAtPath:function(){return UNKNOWN_VALUE},getReturnExpressionWhenCalledAtPath:function(e){return 1===e.length?getMemberReturnExpressionWhenCalled(literalBooleanMembers,e[0]):UNKNOWN_EXPRESSION},hasEffectsWhenAccessedAtPath:function(e){return e.length>1},hasEffectsWhenAssignedAtPath:function(e){return e.length>0},hasEffectsWhenCalledAtPath:function(e){if(1===e.length){var t=e[0];return"string"!=typeof t||!literalBooleanMembers[t]}return!0},include:function(){},included:!0,toString:function(){return"[[UNKNOWN BOOLEAN]]"}},returnsBoolean={value:{callsArgs:null,mutatesSelf:!1,returns:null,returnsPrimitive:UNKNOWN_LITERAL_BOOLEAN}},callsArgReturnsBoolean={value:{callsArgs:[0],mutatesSelf:!1,returns:null,returnsPrimitive:UNKNOWN_LITERAL_BOOLEAN}},UNKNOWN_LITERAL_NUMBER={deoptimizePath:function(){},getLiteralValueAtPath:function(){return UNKNOWN_VALUE},getReturnExpressionWhenCalledAtPath:function(e){return 1===e.length?getMemberReturnExpressionWhenCalled(literalNumberMembers,e[0]):UNKNOWN_EXPRESSION},hasEffectsWhenAccessedAtPath:function(e){return e.length>1},hasEffectsWhenAssignedAtPath:function(e){return e.length>0},hasEffectsWhenCalledAtPath:function(e){if(1===e.length){var t=e[0];return"string"!=typeof t||!literalNumberMembers[t]}return!0},include:function(){},included:!0,toString:function(){return"[[UNKNOWN NUMBER]]"}},returnsNumber={value:{callsArgs:null,mutatesSelf:!1,returns:null,returnsPrimitive:UNKNOWN_LITERAL_NUMBER}},mutatesSelfReturnsNumber={value:{callsArgs:null,mutatesSelf:!0,returns:null,returnsPrimitive:UNKNOWN_LITERAL_NUMBER}},callsArgReturnsNumber={value:{callsArgs:[0],mutatesSelf:!1,returns:null,returnsPrimitive:UNKNOWN_LITERAL_NUMBER}},UNKNOWN_LITERAL_STRING={deoptimizePath:function(){},getLiteralValueAtPath:function(){return UNKNOWN_VALUE},getReturnExpressionWhenCalledAtPath:function(e){return 1===e.length?getMemberReturnExpressionWhenCalled(literalStringMembers,e[0]):UNKNOWN_EXPRESSION},hasEffectsWhenAccessedAtPath:function(e){return e.length>1},hasEffectsWhenAssignedAtPath:function(e){return e.length>0},hasEffectsWhenCalledAtPath:function(e,t,r){return 1!==e.length||hasMemberEffectWhenCalled(literalStringMembers,e[0],!0,t,r)},include:function(){},included:!0,toString:function(){return"[[UNKNOWN STRING]]"}},returnsString={value:{callsArgs:null,mutatesSelf:!1,returns:null,returnsPrimitive:UNKNOWN_LITERAL_STRING}},UnknownObjectExpression=function(){function e(){this.included=!1}return e.prototype.deoptimizePath=function(){},e.prototype.getLiteralValueAtPath=function(){return UNKNOWN_VALUE},e.prototype.getReturnExpressionWhenCalledAtPath=function(e){return 1===e.length?getMemberReturnExpressionWhenCalled(objectMembers,e[0]):UNKNOWN_EXPRESSION},e.prototype.hasEffectsWhenAccessedAtPath=function(e){return e.length>1},e.prototype.hasEffectsWhenAssignedAtPath=function(e){return e.length>1},e.prototype.hasEffectsWhenCalledAtPath=function(e,t,r){return 1!==e.length||hasMemberEffectWhenCalled(objectMembers,e[0],this.included,t,r)},e.prototype.include=function(){this.included=!0},e.prototype.toString=function(){return"[[UNKNOWN OBJECT]]"},e}(),objectMembers=assembleMemberDescriptions({hasOwnProperty:returnsBoolean,isPrototypeOf:returnsBoolean,propertyIsEnumerable:returnsBoolean,toLocaleString:returnsString,toString:returnsString,valueOf:returnsUnknown}),arrayMembers=assembleMemberDescriptions({concat:returnsArray,copyWithin:mutatesSelfReturnsArray,every:callsArgReturnsBoolean,fill:mutatesSelfReturnsArray,filter:callsArgReturnsArray,find:callsArgReturnsUnknown,findIndex:callsArgReturnsNumber,forEach:callsArgReturnsUnknown,includes:returnsBoolean,indexOf:returnsNumber,join:returnsString,lastIndexOf:returnsNumber,map:callsArgReturnsArray,pop:mutatesSelfReturnsUnknown,push:mutatesSelfReturnsNumber,reduce:callsArgReturnsUnknown,reduceRight:callsArgReturnsUnknown,reverse:mutatesSelfReturnsArray,shift:mutatesSelfReturnsUnknown,slice:returnsArray,some:callsArgReturnsBoolean,sort:callsArgMutatesSelfReturnsArray,splice:mutatesSelfReturnsArray,unshift:mutatesSelfReturnsNumber},objectMembers),literalBooleanMembers=assembleMemberDescriptions({valueOf:returnsBoolean},objectMembers),literalNumberMembers=assembleMemberDescriptions({toExponential:returnsString,toFixed:returnsString,toLocaleString:returnsString,toPrecision:returnsString,valueOf:returnsNumber},objectMembers),literalStringMembers=assembleMemberDescriptions({charAt:returnsString,charCodeAt:returnsNumber,codePointAt:returnsNumber,concat:returnsString,endsWith:returnsBoolean,includes:returnsBoolean,indexOf:returnsNumber,lastIndexOf:returnsNumber,localeCompare:returnsNumber,match:returnsBoolean,normalize:returnsString,padEnd:returnsString,padStart:returnsString,repeat:returnsString,replace:{value:{callsArgs:[1],mutatesSelf:!1,returns:null,returnsPrimitive:UNKNOWN_LITERAL_STRING}},search:returnsNumber,slice:returnsString,split:returnsArray,startsWith:returnsBoolean,substr:returnsString,substring:returnsString,toLocaleLowerCase:returnsString,toLocaleUpperCase:returnsString,toLowerCase:returnsString,toUpperCase:returnsString,trim:returnsString,valueOf:returnsString},objectMembers);function getLiteralMembersForValue(e){switch(typeof e){case"boolean":return literalBooleanMembers;case"number":return literalNumberMembers;case"string":return literalStringMembers;default:return Object.create(null)}}function hasMemberEffectWhenCalled(e,t,r,n,i){if("string"!=typeof t||!e[t])return!0;if(e[t].mutatesSelf&&r)return!0;if(!e[t].callsArgs)return!1;for(var s=0,o=e[t].callsArgs;s<o.length;s++){var a=o[s];if(n.args[a]&&n.args[a].hasEffectsWhenCalledAtPath(EMPTY_PATH,CallOptions.create({args:[],callIdentifier:{},withNew:!1}),i.getHasEffectsWhenCalledOptions()))return!0}return!1}function getMemberReturnExpressionWhenCalled(e,t){return"string"==typeof t&&e[t]?null!==e[t].returnsPrimitive?e[t].returnsPrimitive:new e[t].returns:UNKNOWN_EXPRESSION}var Variable=function(){function e(e){this.exportName=null,this.included=!1,this.isId=!1,this.isReassigned=!1,this.reexported=!1,this.renderBaseName=null,this.renderName=null,this.safeExportName=null,this.name=e}return e.prototype.addReference=function(e){},e.prototype.deoptimizePath=function(e){},e.prototype.getBaseVariableName=function(){return this.renderBaseName||this.renderName||this.name},e.prototype.getLiteralValueAtPath=function(e,t,r){return UNKNOWN_VALUE},e.prototype.getName=function(){var e=this.renderName||this.name;return this.renderBaseName?this.renderBaseName+"."+e:e},e.prototype.getReturnExpressionWhenCalledAtPath=function(e,t,r){return UNKNOWN_EXPRESSION},e.prototype.hasEffectsWhenAccessedAtPath=function(e,t){return e.length>0},e.prototype.hasEffectsWhenAssignedAtPath=function(e,t){return!0},e.prototype.hasEffectsWhenCalledAtPath=function(e,t,r){return!0},e.prototype.include=function(){this.included=!0},e.prototype.setRenderNames=function(e,t){this.renderBaseName=e,this.renderName=t},e.prototype.setSafeName=function(e){this.renderName=e},e.prototype.toString=function(){return this.name},e}(),MAX_PATH_DEPTH=7,LocalVariable=function(e){function t(t,r,n,i){var s=e.call(this,t)||this;return s.additionalInitializers=null,s.expressionsToBeDeoptimized=[],s.declarations=r?[r]:[],s.init=n,s.deoptimizationTracker=i.deoptimizationTracker,s.module=i.module,s}return __extends(t,e),t.prototype.addDeclaration=function(e,t){this.declarations.push(e),null===this.additionalInitializers&&(this.additionalInitializers=null===this.init?[]:[this.init],this.init=UNKNOWN_EXPRESSION,this.isReassigned=!0),null!==t&&this.additionalInitializers.push(t)},t.prototype.consolidateInitializers=function(){if(null!==this.additionalInitializers){for(var e=0,t=this.additionalInitializers;e<t.length;e++){t[e].deoptimizePath(UNKNOWN_PATH)}this.additionalInitializers=null}},t.prototype.deoptimizePath=function(e){if(!(e.length>MAX_PATH_DEPTH||this.isReassigned||this.deoptimizationTracker.track(this,e)))if(0===e.length){if(!this.isReassigned){this.isReassigned=!0;for(var t=0,r=this.expressionsToBeDeoptimized;t<r.length;t++){r[t].deoptimizeCache()}this.init&&this.init.deoptimizePath(UNKNOWN_PATH)}}else this.init&&this.init.deoptimizePath(e)},t.prototype.getLiteralValueAtPath=function(e,t,r){return this.isReassigned||!this.init||e.length>MAX_PATH_DEPTH||t.isTracked(this.init,e)?UNKNOWN_VALUE:(this.expressionsToBeDeoptimized.push(r),this.init.getLiteralValueAtPath(e,t.track(this.init,e),r))},t.prototype.getReturnExpressionWhenCalledAtPath=function(e,t,r){return this.isReassigned||!this.init||e.length>MAX_PATH_DEPTH||t.isTracked(this.init,e)?UNKNOWN_EXPRESSION:(this.expressionsToBeDeoptimized.push(r),this.init.getReturnExpressionWhenCalledAtPath(e,t.track(this.init,e),r))},t.prototype.hasEffectsWhenAccessedAtPath=function(e,t){return 0!==e.length&&(this.isReassigned||e.length>MAX_PATH_DEPTH||this.init&&!t.hasNodeBeenAccessedAtPath(e,this.init)&&this.init.hasEffectsWhenAccessedAtPath(e,t.addAccessedNodeAtPath(e,this.init)))},t.prototype.hasEffectsWhenAssignedAtPath=function(e,t){return!!(this.included||e.length>MAX_PATH_DEPTH)||0!==e.length&&(this.isReassigned||this.init&&!t.hasNodeBeenAssignedAtPath(e,this.init)&&this.init.hasEffectsWhenAssignedAtPath(e,t.addAssignedNodeAtPath(e,this.init)))},t.prototype.hasEffectsWhenCalledAtPath=function(e,t,r){return e.length>MAX_PATH_DEPTH||(this.isReassigned||this.init&&!r.hasNodeBeenCalledAtPathWithOptions(e,this.init,t)&&this.init.hasEffectsWhenCalledAtPath(e,t,r.addCalledNodeAtPathWithOptions(e,this.init,t)))},t.prototype.include=function(){if(!this.included){this.included=!0;for(var e=0,t=this.declarations;e<t.length;e++){var r=t[e];r.included||r.include(!1);for(var n=r.parent;!n.included&&(n.included=!0,n.type!==Program);)n=n.parent}}},t}(Variable);function isExportDefaultVariable(e){return e.isDefault}LocalVariable.prototype.isLocal=!0;var ExportDefaultVariable=function(e){function t(t,r,n){var i=e.call(this,t,r,r.declaration,n)||this;i.originalId=null;var s=r.declaration;return s.type!==FunctionDeclaration&&s.type!==ClassDeclaration||!s.id?s.type===Identifier&&(i.originalId=s):(i.hasId=!0,i.originalId=s.id),i}return __extends(t,e),t.prototype.addReference=function(e){this.hasId||(this.name=e.name)},t.prototype.getName=function(){return this.referencesOriginal()?this.originalId.variable.getName():e.prototype.getName.call(this)},t.prototype.getOriginalVariable=function(){return this.originalId&&this.originalId.variable||null},t.prototype.getOriginalVariableName=function(){return this.originalId&&this.originalId.name||null},t.prototype.referencesOriginal=function(){return this.originalId&&(this.hasId||!this.originalId.variable.isReassigned)},t.prototype.setRenderNames=function(t,r){this.referencesOriginal()?this.originalId.variable.setRenderNames(t,r):e.prototype.setRenderNames.call(this,t,r)},t.prototype.setSafeName=function(t){this.referencesOriginal()?this.originalId.variable.setSafeName(t):e.prototype.setSafeName.call(this,t)},t}(LocalVariable);ExportDefaultVariable.prototype.getBaseVariableName=ExportDefaultVariable.prototype.getName,ExportDefaultVariable.prototype.isDefault=!0;var MISSING_EXPORT_SHIM_VARIABLE="_missingExportShim",INTEROP_DEFAULT_VARIABLE="_interopDefault",ExportShimVariable=function(e){function t(t){var r=e.call(this,MISSING_EXPORT_SHIM_VARIABLE)||this;return r.module=t,r}return __extends(t,e),t}(Variable),pureFunctions={},arrayTypes="Array Int8Array Uint8Array Uint8ClampedArray Int16Array Uint16Array Int32Array Uint32Array Float32Array Float64Array".split(" "),simdTypes="Int8x16 Int16x8 Int32x4 Float32x4 Float64x2".split(" "),simdMethods="abs add and bool check div equal extractLane fromFloat32x4 fromFloat32x4Bits fromFloat64x2 fromFloat64x2Bits fromInt16x8Bits fromInt32x4 fromInt32x4Bits fromInt8x16Bits greaterThan greaterThanOrEqual lessThan lessThanOrEqual load max maxNum min minNum mul neg not notEqual or reciprocalApproximation reciprocalSqrtApproximation replaceLane select selectBits shiftLeftByScalar shiftRightArithmeticByScalar shiftRightLogicalByScalar shuffle splat sqrt store sub swizzle xor".split(" "),allSimdMethods=[];simdTypes.forEach(function(e){simdMethods.forEach(function(t){allSimdMethods.push("SIMD."+e+"."+t)})}),["Array.isArray","Error","EvalError","InternalError","RangeError","ReferenceError","SyntaxError","TypeError","URIError","isFinite","isNaN","parseFloat","parseInt","decodeURI","decodeURIComponent","encodeURI","encodeURIComponent","escape","unescape","Object","Object.create","Object.getNotifier","Object.getOwn","Object.getOwnPropertyDescriptor","Object.getOwnPropertyNames","Object.getOwnPropertySymbols","Object.getPrototypeOf","Object.is","Object.isExtensible","Object.isFrozen","Object.isSealed","Object.keys","Boolean","Number","Number.isFinite","Number.isInteger","Number.isNaN","Number.isSafeInteger","Number.parseFloat","Number.parseInt","Symbol","Symbol.for","Symbol.keyFor","Math.abs","Math.acos","Math.acosh","Math.asin","Math.asinh","Math.atan","Math.atan2","Math.atanh","Math.cbrt","Math.ceil","Math.clz32","Math.cos","Math.cosh","Math.exp","Math.expm1","Math.floor","Math.fround","Math.hypot","Math.imul","Math.log","Math.log10","Math.log1p","Math.log2","Math.max","Math.min","Math.pow","Math.random","Math.round","Math.sign","Math.sin","Math.sinh","Math.sqrt","Math.tan","Math.tanh","Math.trunc","Date","Date.UTC","Date.now","Date.parse","String","String.fromCharCode","String.fromCodePoint","String.raw","RegExp","Map","Set","WeakMap","WeakSet","ArrayBuffer","ArrayBuffer.isView","DataView","Promise.all","Promise.race","Promise.resolve","Intl.Collator","Intl.Collator.supportedLocalesOf","Intl.DateTimeFormat","Intl.DateTimeFormat.supportedLocalesOf","Intl.NumberFormat","Intl.NumberFormat.supportedLocalesOf"].concat(arrayTypes,arrayTypes.map(function(e){return e+".from"}),arrayTypes.map(function(e){return e+".of"}),simdTypes.map(function(e){return"SIMD."+e}),allSimdMethods).forEach(function(e){return pureFunctions[e]=!0});var GlobalVariable=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),t.prototype.hasEffectsWhenAccessedAtPath=function(e){return e.length>0&&!this.isPureFunctionMember(e)&&!("Reflect"===this.name&&1===e.length)},t.prototype.hasEffectsWhenCalledAtPath=function(e){return!pureFunctions[[this.name].concat(e).join(".")]},t.prototype.isPureFunctionMember=function(e){return pureFunctions[[this.name].concat(e).join(".")]||e.length>=1&&pureFunctions[[this.name].concat(e.slice(0,-1)).join(".")]||e.length>=2&&pureFunctions[[this.name].concat(e.slice(0,-2)).join(".")]&&"prototype"===e[e.length-2]},t}(Variable),NamespaceVariable=function(e){function t(t){var r=e.call(this,t.getModuleName())||this;r.memberVariables=Object.create(null),r.containsExternalNamespace=!1,r.referencedEarly=!1,r.references=[],r.context=t,r.module=t.module;for(var n=0,i=r.context.getExports().concat(r.context.getReexports());n<i.length;n++){var s=i[n];"*"===s[0]&&s.length>1&&(r.containsExternalNamespace=!0),r.memberVariables[s]=r.context.traceExport(s)}return r}return __extends(t,e),t.prototype.addReference=function(e){this.references.push(e),this.name=e.name},t.prototype.deoptimizePath=function(){for(var e in this.memberVariables)this.memberVariables[e].deoptimizePath(UNKNOWN_PATH)},t.prototype.include=function(){if(!this.included){this.containsExternalNamespace&&this.context.error({code:"NAMESPACE_CANNOT_CONTAIN_EXTERNAL",id:this.module.id,message:'Cannot create an explicit namespace object for module "'+this.context.getModuleName()+'" because it contains a reexported external namespace'},void 0),this.included=!0;for(var e=0,t=this.references;e<t.length;e++){if(t[e].context.getModuleExecIndex()<=this.context.getModuleExecIndex()){this.referencedEarly=!0;break}}if(this.context.preserveModules)for(var r=0,n=Object.keys(this.memberVariables);r<n.length;r++){var i=n[r];this.memberVariables[i].include()}else for(var s=0,o=Object.keys(this.memberVariables);s<o.length;s++){i=o[s];this.context.includeVariable(this.memberVariables[i])}}},t.prototype.renderBlock=function(e){var t=this,r=e.compact?"":" ",n=e.compact?"":"\n",i=e.indent,s=Object.keys(this.memberVariables).map(function(n){var s=t.memberVariables[n];return t.referencedEarly||s.isReassigned?i+"get "+n+r+"()"+r+"{"+r+"return "+s.getName()+(e.compact?"":";")+r+"}":""+i+n+": "+s.getName()}),o=this.getName(),a=e.freeze?"/*#__PURE__*/Object.freeze":"",u=e.varOrConst+" "+o+" = "+(e.namespaceToStringTag?"{"+n+s.join(","+n)+n+"};":a+"({"+n+s.join(","+n)+n+"});");return e.namespaceToStringTag&&(u+=n+"if"+r+"(typeof Symbol"+r+"!=="+r+"'undefined'"+r+"&&"+r+"Symbol.toStringTag)"+n,u+=i+"Object.defineProperty("+o+","+r+"Symbol.toStringTag,"+r+"{"+r+"value:"+r+"'Module'"+r+"});"+n,u+="else"+(n||" "),u+=i+"Object.defineProperty("+o+","+r+"'toString',"+r+"{"+r+"value:"+r+"function"+r+"()"+r+"{"+r+"return"+r+"'[object Module]'"+(e.compact?";":"")+r+"}"+r+"});"+n,u+=a+"("+o+");"),"system"===e.format&&this.exportName&&(u+=n+"exports('"+this.exportName+"',"+r+o+");"),u},t.prototype.renderFirst=function(){return this.referencedEarly},t}(Variable);NamespaceVariable.prototype.isNamespace=!0;var ExternalVariable=function(e){function t(t,r){var n=e.call(this,r)||this;return n.module=t,n.isNamespace="*"===r,n.referenced=!1,n}return __extends(t,e),t.prototype.addReference=function(e){this.referenced=!0,"default"!==this.name&&"*"!==this.name||this.module.suggestName(e.name)},t.prototype.include=function(){this.included||(this.included=!0,this.module.used=!0)},t}(Variable);ExternalVariable.prototype.isExternal=!0;var reservedWords$1="break case class catch const continue debugger default delete do else export extends finally for function if import in instanceof let new return super switch this throw try typeof var void while with yield enum await implements package protected static interface private public".split(" "),builtins="Infinity NaN undefined null true false eval uneval isFinite isNaN parseFloat parseInt decodeURI decodeURIComponent encodeURI encodeURIComponent escape unescape Object Function Boolean Symbol Error EvalError InternalError RangeError ReferenceError SyntaxError TypeError URIError Number Math Date String RegExp Array Int8Array Uint8Array Uint8ClampedArray Int16Array Uint16Array Int32Array Uint32Array Float32Array Float64Array Map Set WeakMap WeakSet SIMD ArrayBuffer DataView JSON Promise Generator GeneratorFunction Reflect Proxy Intl".split(" "),blacklisted=Object.create(null);reservedWords$1.concat(builtins).forEach(function(e){return blacklisted[e]=!0});var illegalCharacters=/[^$_a-zA-Z0-9]/g,startsWithDigit=function(e){return/\d/.test(e[0])};function isLegal(e){return!startsWithDigit(e)&&!blacklisted[e]&&!illegalCharacters.test(e)}function makeLegal(e){return e=e.replace(/-(\w)/g,function(e,t){return t.toUpperCase()}).replace(illegalCharacters,"_"),(startsWithDigit(e)||blacklisted[e])&&(e="_"+e),e}var absolutePath=/^(?:\/|(?:[A-Za-z]:)?[\\|\/])/,relativePath=/^\.?\.\//;function isAbsolute(e){return absolutePath.test(e)}function isRelative(e){return relativePath.test(e)}function normalize$1(e){return-1==e.indexOf("\\")?e:e.replace(/\\/g,"/")}var ExternalModule=function(){function e(e){var t=e.graph,r=e.id;this.exportsNames=!1,this.exportsNamespace=!1,this.isEntryPoint=!1,this.isExternal=!0,this.mostCommonSuggestion=0,this.reexported=!1,this.renderPath=void 0,this.renormalizeRenderPath=!1,this.used=!1,this.graph=t,this.id=r,this.execIndex=1/0;var n=r.split(/[\\\/]/);this.variableName=makeLegal(n.pop()),this.nameSuggestions=Object.create(null),this.declarations=Object.create(null),this.exportedVariables=new Map}return e.prototype.getVariableForExportName=function(e,t){"default"!==e&&"*"!==e&&(this.exportsNames=!0),"*"===e&&(this.exportsNamespace=!0);var r=this.declarations[e];return r||(this.declarations[e]=r=new ExternalVariable(this,e),this.exportedVariables.set(r,e),r)},e.prototype.setRenderPath=function(e,t){return this.renderPath="",e.paths&&(this.renderPath="function"==typeof e.paths?e.paths(this.id):e.paths[this.id]),this.renderPath||(isAbsolute(this.id)?(this.renderPath=normalize$1(path$2.relative(t,this.id)),this.renormalizeRenderPath=!0):this.renderPath=this.id),this.renderPath},e.prototype.suggestName=function(e){this.nameSuggestions[e]||(this.nameSuggestions[e]=0),this.nameSuggestions[e]+=1,this.nameSuggestions[e]>this.mostCommonSuggestion&&(this.mostCommonSuggestion=this.nameSuggestions[e],this.variableName=e)},e.prototype.warnUnusedImports=function(){var e=this,t=Object.keys(this.declarations).filter(function(t){if("*"===t)return!1;var r=e.declarations[t];return!r.included&&!e.reexported&&!r.referenced});if(0!==t.length){var r=1===t.length?"'"+t[0]+"' is":t.slice(0,-1).map(function(e){return"'"+e+"'"}).join(", ")+" and '"+t.slice(-1)+"' are";this.graph.warn({code:"UNUSED_EXTERNAL_IMPORT",message:r+" imported from external module '"+this.id+"' but never used",names:t,source:this.id})}},e}(),esModuleExport="Object.defineProperty(exports, '__esModule', { value: true });",compactEsModuleExport="Object.defineProperty(exports,'__esModule',{value:true});";function getExportBlock(e,t,r,n,i,s){void 0===s&&(s="return ");var o,a=i?"":" ";if(!r)return e.some(function(e){return"default"===e.exported&&(o=e.local,!0)}),o||t.some(function(e){return!!e.reexports&&e.reexports.some(function(t){return"default"===t.reexported&&(o=e.namedExportsMode?e.name+"."+t.imported:e.name,!0)})}),""+s+o+";";var u="";return t.forEach(function(e){var t=e.name,n=e.reexports;n&&r&&n.forEach(function(e){"*"===e.reexported&&(!i&&u&&(u+="\n"),u+="Object.keys("+t+").forEach(function"+a+"(key)"+a+"{"+a+"exports[key]"+a+"="+a+t+"[key];"+a+"});")})}),t.forEach(function(e){var t=e.name,s=e.imports,o=e.reexports,c=e.isChunk,p=e.namedExportsMode;o&&r&&o.forEach(function(e){if("default"!==e.imported||c)if("*"!==e.imported){u&&!i&&(u+="\n");var r="default"!==e.imported||p?t+"."+e.imported:t;u+="exports."+e.reexported+a+"="+a+r+";"}else"*"!==e.reexported&&(u&&!i&&(u+="\n"),u+="exports."+e.reexported+a+"="+a+t+";");else{var l=s&&s.some(function(e){return"*"===e.imported||"default"!==e.imported})||o&&o.some(function(e){return"default"!==e.imported&&"*"!==e.imported}),h=o&&o.some(function(e){return"default"===e.imported&&"default"===e.reexported});u&&!i&&(u+="\n"),u+=l||h?"exports."+e.reexported+a+"="+a+t+(!1!==n?"__default":".default")+";":"exports."+e.reexported+a+"="+a+t+";"}})}),e.forEach(function(e){var t="exports."+e.exported,r=e.local;t!==r&&(u&&!i&&(u+="\n"),u+=""+t+a+"="+a+r+";")}),u}function getInteropBlock(e,t,r){return e.map(function(e){var n=e.name,i=e.exportsNames,s=e.exportsDefault;if(e.namedExportsMode)return s&&!1!==t.interop?i?t.compact?r+" "+n+"__default='default'in "+n+"?"+n+"['default']:"+n+";":r+" "+n+"__default = 'default' in "+n+" ? "+n+"['default'] : "+n+";":t.compact?n+"="+n+"&&"+n+".hasOwnProperty('default')?"+n+"['default']:"+n+";":n+" = "+n+" && "+n+".hasOwnProperty('default') ? "+n+"['default'] : "+n+";":null}).filter(Boolean).join(t.compact?"":"\n")}var builtins$1={assert:!0,buffer:!0,console:!0,constants:!0,domain:!0,events:!0,http:!0,https:!0,os:!0,path:!0,process:!0,punycode:!0,querystring:!0,stream:!0,string_decoder:!0,timers:!0,tty:!0,url:!0,util:!0,vm:!0,zlib:!0};function warnOnBuiltins(e,t){var r=t.map(function(e){return e.id}).filter(function(e){return e in builtins$1});r.length&&e({code:"MISSING_NODE_BUILTINS",message:"Creating a browser bundle that depends on Node.js built-in "+(1===r.length?"module ('"+r[0]+"')":"modules ("+r.slice(0,-1).map(function(e){return"'"+e+"'"}).join(", ")+" and '"+r.slice(-1)+"')")+". You might need to include https://www.npmjs.com/package/rollup-plugin-node-builtins",modules:r})}function amd(e,t,r){var n=t.dependencies,i=t.dynamicImport,s=t.exports,o=t.hasExports,a=t.indentString,u=t.intro,c=t.isEntryModuleFacade,p=t.namedExportsMode,l=t.needsAmdModule,h=t.outro,f=t.varOrConst;warnOnBuiltins(t.warn,n);var d=n.map(function(e){return"'"+e.id+"'"}),m=n.map(function(e){return e.name}),g=r.compact?"":"\n",y=r.compact?"":" ";p&&o&&(m.unshift("exports"),d.unshift("'exports'")),i&&(m.unshift("require"),d.unshift("'require'")),l&&(m.unshift("module"),d.unshift("'module'"));var v=r.amd||{},_=(v.id?"'"+v.id+"',"+y:"")+(d.length?"["+d.join(","+y)+"],"+y:""),b=!1!==r.strict?y+"'use strict';":"",E=(v.define||"define")+"("+_+"function"+y+"("+m.join(","+y)+")"+y+"{"+b+g+g,x=getInteropBlock(n,r,f);x&&e.prepend(x+g+g),u&&e.prepend(u);var S=getExportBlock(s,n,p,r.interop,r.compact);return S&&e.append(g+g+S),p&&o&&c&&r.esModule&&e.append(""+g+g+(r.compact?compactEsModuleExport:esModuleExport)),h&&e.append(h),e.indent(a).append(g+g+"});").prepend(E)}function cjs(e,t,r){var n=t.dependencies,i=t.exports,s=t.hasExports,o=t.intro,a=t.isEntryModuleFacade,u=t.namedExportsMode,c=t.outro,p=t.varOrConst,l=r.compact?"":"\n",h=r.compact?"":" ";o=(!1===r.strict?o:"'use strict';"+l+l+o)+(u&&s&&a&&r.esModule?""+(r.compact?compactEsModuleExport:esModuleExport)+l+l:"");var f,d=!1,m=!1!==r.interop;if(r.compact){var g=!1;f="",n.forEach(function(e){var t=e.id,r=e.namedExportsMode,n=e.isChunk,i=e.name,s=e.reexports,o=e.imports,a=e.exportsNames,u=e.exportsDefault;s||o?(f+=g?",":(f?";":"")+p+" ",g=!0,m&&!n&&u&&r?(d=!0,f+=a?i+"=require('"+t+"'),"+i+"__default="+INTEROP_DEFAULT_VARIABLE+"("+i+")":i+"="+INTEROP_DEFAULT_VARIABLE+"(require('"+t+"'))"):f+=i+"=require('"+t+"')"):(f+=g?";":",",g=!1,f+="require('"+t+"')")}),f.length&&(f+=";")}else f=n.map(function(e){var t=e.id,r=e.namedExportsMode,n=e.isChunk,i=e.name,s=e.reexports,o=e.imports,a=e.exportsNames,u=e.exportsDefault;return s||o?m&&!n&&u&&r?(d=!0,a?p+" "+i+" = require('"+t+"');\n"+p+" "+i+"__default = "+INTEROP_DEFAULT_VARIABLE+"("+i+");":p+" "+i+" = "+INTEROP_DEFAULT_VARIABLE+"(require('"+t+"'));"):p+" "+i+" = require('"+t+"');":"require('"+t+"');"}).join("\n");d&&(r.compact?o+="function "+INTEROP_DEFAULT_VARIABLE+"(e){return(e&&(typeof e==='object')&&'default'in e)?e['default']:e}":o+="function "+INTEROP_DEFAULT_VARIABLE+" (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }\n\n"),f&&(o+=f+l+l);var y=getExportBlock(i,n,u,r.interop,r.compact,"module.exports"+h+"="+h);return e.prepend(o),y&&e.append(l+l+y),c&&e.append(c),e}function esm(e,t,r){var n=t.intro,i=t.outro,s=t.dependencies,o=t.exports,a=r.compact?"":" ",u=r.compact?"":"\n",c=s.map(function(e){var t=e.id,r=e.reexports,n=e.imports,i=e.name;if(!r&&!n)return"import"+a+"'"+t+"';";var s="";if(n){var o=n.find(function(e){return"default"===e.imported}),c=n.find(function(e){return"*"===e.imported});c&&(s+="import"+a+"*"+a+"as "+c.local+" from"+a+"'"+t+"';",n.length>1&&(s+=u)),o&&1===n.length?s+="import "+o.local+" from"+a+"'"+t+"';":(!c||n.length>1)&&(s+="import "+(o?o.local+","+a:"")+"{"+a+n.filter(function(e){return e!==o&&e!==c}).map(function(e){return e.imported===e.local?e.imported:e.imported+" as "+e.local}).join(","+a)+a+"}"+a+"from"+a+"'"+t+"';")}if(r){n&&(s+=u);var p=r.find(function(e){return"*"===e.reexported}),l=r.find(function(e){return"*"===e.imported&&"*"!==e.reexported});if(p){if(s+="export"+a+"*"+a+"from"+a+"'"+t+"';",1===r.length)return s;s+=u}if(l){if(n&&n.some(function(e){return"*"===e.imported&&e.local===i})||(s+="import"+a+"*"+a+"as "+i+" from"+a+"'"+t+"';"+u),s+="export"+a+"{"+a+(i===l.reexported?i:i+" as "+l.reexported)+" };",r.length===(p?2:1))return s;s+=u}s+="export"+a+"{"+a+r.filter(function(e){return e!==p&&e!==l}).map(function(e){return e.imported===e.reexported?e.imported:e.imported+" as "+e.reexported}).join(","+a)+a+"}"+a+"from"+a+"'"+t+"';"}return s}).join(u);c&&(n+=c+u+u),n&&e.prepend(n);var p=[],l=[];return o.forEach(function(e){"default"===e.exported?p.push("export default "+e.local+";"):l.push(e.exported===e.local?e.local:e.local+" as "+e.exported)}),l.length&&p.push("export"+a+"{"+a+l.join(","+a)+a+"};"),p.length&&e.append(u+u+p.join(u).trim()),i&&e.append(i),e.trim()}function getLocator$1(e,t){void 0===t&&(t={});var r=t.offsetLine||0,n=t.offsetColumn||0,i=e.split("\n"),s=0,o=i.map(function(e,t){var r=s+e.length+1,n={start:s,end:r,line:t};return s=r,n}),a=0;function u(e,t){return e.start<=t&&t<e.end}function c(e,t){return{line:r+e.line,column:n+t-e.start,character:t}}return function(t,r){"string"==typeof t&&(t=e.indexOf(t,r||0));for(var n=o[a],i=t>=n.end?1:-1;n;){if(u(n,t))return c(n,t);n=o[a+=i]}}}function locate(e,t,r){if("number"==typeof r)throw new Error("locate takes a { startIndex, offsetLine, offsetColumn } object as the third argument");return getLocator$1(e,r)(t,r&&r.startIndex)}function spaces(e){for(var t="";e--;)t+=" ";return t}function tabsToSpaces(e){return e.replace(/^\t+/,function(e){return e.split("\t").join("  ")})}function getCodeFrame(e,t,r){var n=e.split("\n"),i=Math.max(0,t-3),s=Math.min(t+2,n.length);for(n=n.slice(i,s);!/\S/.test(n[n.length-1]);)n.pop(),s-=1;var o=String(s).length;return n.map(function(e,n){for(var s=i+n+1===t,a=String(n+i+1);a.length<o;)a=" "+a;if(s){var u=spaces(o+2+tabsToSpaces(e.slice(0,r)).length)+"^";return a+": "+tabsToSpaces(e)+"\n"+u}return a+": "+tabsToSpaces(e)}).join("\n")}function error(e,t){throw e instanceof Error==!1&&(e=Object.assign(new Error(e.message),e)),t&&Object.assign(e,t),e}function augmentCodeLocation(e,t,r,n){if(void 0!==t.line&&void 0!==t.column){var i=t.line,s=t.column;e.loc={file:n,line:i,column:s}}else{e.pos=t;var o=locate(r,t,{offsetLine:1});i=o.line,s=o.column;e.loc={file:n,line:i,column:s}}if(void 0===e.frame){var a=e.loc;i=a.line,s=a.column;e.frame=getCodeFrame(r,i,s)}}var shouldUseDot=/^[a-zA-Z$_][a-zA-Z0-9$_]*$/;function property(e){return shouldUseDot.test(e)?"."+e:"['"+e+"']"}function keypath(e){return e.split(".").map(property).join("")}function setupNamespace(e,t,r,n){var i=e.split(".");r&&(i[0]=("function"==typeof r?r(i[0]):r[i[0]])||i[0]);var s=n?"":" ";i.pop();var o=t;return i.map(function(e){return""+(o+=property(e))+s+"="+s+o+s+"||"+s+"{}"+(n?"":";")}).join(n?",":"\n")+(n&&i.length?";":"\n")}function assignToDeepVariable(e,t,r,n,i){var s=n?"":" ",o=e.split(".");r&&(o[0]=("function"==typeof r?r(o[0]):r[o[0]])||o[0]);var a=o.pop(),u=t,c=o.map(function(e){return""+(u+=property(e))+s+"="+s+u+s+"||"+s+"{}"}).concat(""+u+property(a)).join(","+s).concat(s+"="+s+i);return o.length>0&&(c="("+c+")"),c}function trimEmptyImports(e){for(var t=e.length;t--;){var r=e[t];if(r.exportsDefault||r.exportsNames)return e.slice(0,t+1)}return[]}var thisProp=function(e){return"this"+keypath(e)};function iife(e,t,r){var n=t.dependencies,i=t.exports,s=t.hasExports,o=t.indentString,a=t.intro,u=t.namedExportsMode,c=t.outro,p=t.varOrConst,l=t.warn,h=r.compact?"":" ",f=r.compact?"":"\n",d=r.extend,m=r.name,g=m&&-1!==m.indexOf("."),y=!d&&!g;m&&y&&!isLegal(m)&&error({code:"ILLEGAL_IDENTIFIER_AS_NAME",message:"Given name ("+m+") is not legal JS identifier. If you need this you can try --extend option"}),warnOnBuiltins(l,n);var v=trimEmptyImports(n),_=v.map(function(e){return e.globalName||"null"}),b=v.map(function(e){return e.name});s&&!m&&error({code:"INVALID_OPTION",message:'You must supply "output.name" for IIFE bundles.'}),u&&s&&(d?(_.unshift(""+thisProp(m)+h+"="+h+thisProp(m)+h+"||"+h+"{}"),b.unshift("exports")):(_.unshift("{}"),b.unshift("exports")));var E=!1!==r.strict?o+"'use strict';"+f+f:"",x="(function"+h+"("+b.join(","+h)+")"+h+"{"+f+E;!s||d&&u||(x=(y?p+" "+m:thisProp(m))+(h+"=")+h+x),g&&s&&(x=setupNamespace(m,"this",r.globals,r.compact)+x);var S=""+f+f+"}("+_.join(","+h)+"));";!d&&u&&s&&(S=""+f+f+o+"return exports;"+S);var A=getInteropBlock(n,r,p);A&&e.prepend(A+f+f),a&&e.prepend(a);var w=getExportBlock(i,n,u,r.interop,r.compact);return w&&e.append(f+f+w),c&&e.append(c),e.indent(o).prepend(x).append(S)}function getStarExcludes(e){var t=e.dependencies,r=e.exports,n=new Set(r.map(function(e){return e.exported}));return n.has("default")||n.add("default"),t.forEach(function(e){var t=e.reexports;t&&t.forEach(function(e){"*"===e.imported||n.has(e.reexported)||n.add(e.reexported)})}),n}var getStarExcludesBlock=function(e,t,r,n,i){return e?""+i+n+t+" _starExcludes"+r+"="+r+"{"+r+Array.from(e).join(":"+r+"1,"+r)+(e.size?":"+r+"1":"")+r+"};":""},getImportBindingsBlock=function(e,t,r,n){return e.length?""+n+r+"var "+e.join(","+t)+";":""};function getExportsBlock(e,t,r,n){return 0===e.length?"":1===e.length?""+r+r+r+"exports('"+e[0].name+"',"+t+e[0].value+");"+n+n:""+r+r+r+"exports({"+n+e.map(function(e){var n=e.name,i=e.value;return""+r+r+r+r+n+":"+t+i}).join(","+n)+n+r+r+r+"});"+n+n}var getHoistedExportsBlock=function(e,t,r,n){return getExportsBlock(e.filter(function(e){return e.hoisted||e.uninitialized}).map(function(e){return{name:e.exported,value:e.uninitialized?"void 0":e.local}}),t,r,n)},getMissingExportsBlock=function(e,t,r,n){return getExportsBlock(e.filter(function(e){return e.local===MISSING_EXPORT_SHIM_VARIABLE}).map(function(e){return{name:e.exported,value:MISSING_EXPORT_SHIM_VARIABLE}}),t,r,n)};function system(e,t,r){var n,i=t.dependencies,s=t.exports,o=t.indentString,a=t.intro,u=t.outro,c=t.usesTopLevelAwait,p=t.varOrConst,l=r.compact?"":"\n",h=r.compact?"":" ",f=i.map(function(e){return"'"+e.id+"'"}),d=[],m=[];i.forEach(function(e){var t=e.imports,r=e.reexports,a=[];if(t&&t.forEach(function(e){d.push(e.local),"*"===e.imported?a.push(""+e.local+h+"="+h+"module;"):a.push(""+e.local+h+"="+h+"module."+e.imported+";")}),r){var u=!1;r.length>1||1===r.length&&("*"===r[0].reexported||"*"===r[0].imported)?(r.forEach(function(e){"*"===e.reexported&&(n||(n=getStarExcludes({dependencies:i,exports:s})),u||(a.push(p+" _setter"+h+"="+h+"{};"),u=!0),a.push("for"+h+"(var _$p"+h+"in"+h+"module)"+h+"{"),a.push(o+"if"+h+"(!_starExcludes[_$p])"+h+"_setter[_$p]"+h+"="+h+"module[_$p];"),a.push("}"))}),r.forEach(function(e){"*"===e.imported&&"*"!==e.reexported&&a.push("exports('"+e.reexported+"',"+h+"module);")}),r.forEach(function(e){"*"!==e.reexported&&"*"!==e.imported&&(u||(a.push(p+" _setter"+h+"="+h+"{};"),u=!0),a.push("_setter."+e.reexported+h+"="+h+"module."+e.imported+";"))}),u&&a.push("exports(_setter);")):r.forEach(function(e){a.push("exports('"+e.reexported+"',"+h+"module."+e.imported+");")})}m.push(a.join(""+l+o+o+o))});var g="System.register("+(r.name?"'"+r.name+"',"+h:"")+"["+f.join(","+h)+"],"+h+"function"+h+"(exports,"+h+"module)"+h+"{"+l+o+"'use strict';"+getStarExcludesBlock(n,p,h,o,l)+getImportBindingsBlock(d,h,o,l)+l+o+"return"+h+"{"+(m.length?""+l+o+o+"setters:"+h+"["+m.map(function(e){return e?"function"+h+"(module)"+h+"{"+l+o+o+o+e+l+o+o+"}":"function"+h+"()"+h+"{}"}).join(","+h)+"],":"")+l;g+=""+o+o+"execute:"+h+(c?"async"+h:"")+"function"+h+"()"+h+"{"+l+l+getHoistedExportsBlock(s,h,o,l);var y=""+l+l+getMissingExportsBlock(s,h,o,l)+o+o+"}"+l+o+"}"+(r.compact?"":";")+l+"});";return a&&e.prepend(a),u&&e.append(u),e.indent(""+o+o+o).append(y).prepend(g)}function globalProp(e,t){return e?""+t+keypath(e):"null"}function safeAccess(e,t,r){var n=e.split("."),i=t;return n.map(function(e){return i+=property(e)}).join(r+"&&"+r)}function umd(e,t,r){var n=t.dependencies,i=t.exports,s=t.hasExports,o=t.indentString,a=t.intro,u=t.namedExportsMode,c=t.outro,p=t.varOrConst,l=t.warn,h=r.compact?"":" ",f=r.compact?"":"\n",d=r.compact?"f":"factory",m=r.compact?"g":"global";s&&!r.name&&error({code:"INVALID_OPTION",message:'You must supply "output.name" for UMD bundles.'}),warnOnBuiltins(l,n);var g=n.map(function(e){return"'"+e.id+"'"}),y=n.map(function(e){return"require('"+e.id+"')"}),v=trimEmptyImports(n),_=v.map(function(e){return globalProp(e.globalName,m)}),b=v.map(function(e){return e.name});u&&(s||!0===r.noConflict)&&(g.unshift("'exports'"),y.unshift("exports"),_.unshift(assignToDeepVariable(r.name,m,r.globals,r.compact,(r.extend?""+globalProp(r.name,m)+h+"||"+h:"")+"{}")),b.unshift("exports"));var E,x=r.amd||{},S=(x.id?"'"+x.id+"',"+h:"")+(g.length?"["+g.join(","+h)+"],"+h:""),A=x.define||"define",w=!u&&s?"module.exports"+h+"="+h:"",N=!1!==r.strict?h+"'use strict';"+f:"";if(!0===r.noConflict){var P=r.compact?"e":"exports",C=void 0;if(!u&&s)C="var "+P+h+"="+h+assignToDeepVariable(r.name,m,r.globals,r.compact,d+"("+_.join(","+h)+")")+";";else if(u){C="var "+P+h+"="+h+_.shift()+";"+f+o+o+d+"("+[P].concat(_).join(","+h)+");"}E="(function"+h+"()"+h+"{"+f+o+o+"var current"+h+"="+h+safeAccess(r.name,m,h)+";"+f+o+o+C+f+o+o+P+".noConflict"+h+"="+h+"function"+h+"()"+h+"{"+h+globalProp(r.name,m)+h+"="+h+"current;"+h+"return "+P+(r.compact?"":"; ")+"};"+f+o+"}())"}else E=d+"("+_.join(","+h)+")",!u&&s&&(E=assignToDeepVariable(r.name,m,r.globals,r.compact,E));var I=s||!0===r.noConflict&&u||_.length>0,k=I?"this,"+h:"",O=I?"("+m+h+"="+h+m+h+"||"+h+"self,"+h:"",$=I?")":"",R="(function"+h+"("+(I?m+","+h:"")+d+")"+h+"{"+f+(I?o+"typeof exports"+h+"==="+h+"'object'"+h+"&&"+h+"typeof module"+h+"!=="+h+"'undefined'"+h+"?"+h+w+d+"("+y.join(","+h)+")"+h+":"+f:"")+o+"typeof "+A+h+"==="+h+"'function'"+h+"&&"+h+A+".amd"+h+"?"+h+A+"("+S+d+")"+h+":"+f+o+O+E+$+";"+f+"}("+k+"function"+h+"("+b.join(", ")+")"+h+"{"+N+f,M=f+f+"}));",T=getInteropBlock(n,r,p);T&&e.prepend(T+f+f),a&&e.prepend(a);var L=getExportBlock(i,n,u,r.interop,r.compact);return L&&e.append(f+f+L),u&&s&&r.esModule&&e.append(f+f+(r.compact?compactEsModuleExport:esModuleExport)),c&&e.append(c),e.trim().indent(o).append(M).prepend(R)}var finalisers={system:system,amd:amd,cjs:cjs,es:esm,iife:iife,umd:umd},BLANK=Object.create(null);function treeshakeNode(e,t,r,n){if(t.remove(r,n),e.annotations)for(var i=0,s=e.annotations;i<s.length;i++){var o=s[i];if(!(o.start<r))return;t.remove(o.start,o.end)}}function removeAnnotations(e,t){if(e.annotations||e.parent.type!==ExpressionStatement||(e=e.parent),e.annotations)for(var r=0,n=e.annotations;r<n.length;r++){var i=n[r];t.remove(i.start,i.end)}}var NO_SEMICOLON={isNoStatement:!0};function findFirstOccurrenceOutsideComment(e,t,r){var n,i;for(void 0===r&&(r=0),n=e.indexOf(t,r);;){if(-1===(r=e.indexOf("/",r))||r>n)return n;if(i=e.charCodeAt(++r),++r,47===i){if(0===(r=e.indexOf("\n",r)+1))return-1;r>n&&(n=e.indexOf(t,r))}else 42===i&&(r=e.indexOf("*/",r)+2)>n&&(n=e.indexOf(t,r))}}function findFirstLineBreakOutsideComment(e,t){var r,n;for(void 0===t&&(t=0),r=e.indexOf("\n",t);;){if(-1===(t=e.indexOf("/",t))||t>r)return r;if(47===(n=e.charCodeAt(++t)))return r;++t,42===n&&(t=e.indexOf("*/",t)+2)>r&&(r=e.indexOf("\n",t))}}function renderStatementList(e,t,r,n,i){if(0!==e.length){var s,o,a,u,c=e[0],p=!c.included||c.needsBoundaries;p&&(u=r+findFirstLineBreakOutsideComment(t.original.slice(r,c.start))+1);for(var l=1;l<=e.length;l++)s=c,o=u,a=p,p=void 0!==(c=e[l])&&(!c.included||c.needsBoundaries),a||p?(u=s.end+findFirstLineBreakOutsideComment(t.original.slice(s.end,void 0===c?n:c.start))+1,s.included?a?s.render(t,i,{end:u,start:o}):s.render(t,i):treeshakeNode(s,t,o,u)):s.render(t,i)}}function getCommaSeparatedNodesWithBoundaries(e,t,r,n){for(var i,s,o,a,u,c=[],p=r-1,l=0;l<e.length;l++){for(s=e[l],void 0!==i&&(p=i.end+findFirstOccurrenceOutsideComment(t.original.slice(i.end,s.start),",")),o=a=p+2+findFirstLineBreakOutsideComment(t.original.slice(p+1,s.start));32===(u=t.original.charCodeAt(o))||9===u||10===u||13===u;)o++;void 0!==i&&c.push({contentEnd:a,end:o,node:i,separator:p,start:r}),i=s,r=o}return c.push({contentEnd:n,end:n,node:i,separator:null,start:r}),c}var chars$1="0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ_$",base=64;function toBase64(e){var t="";do{var r=e%base;e=Math.floor(e/base),t=chars$1[r]+t}while(0!==e);return t}function getSafeName(e,t){for(var r=e,n=1;t[r];)r=e+"$"+toBase64(n++);return t[r]=!0,r}var Scope$1=function(){function e(){this.children=[],this.variables=Object.create(null)}return e.prototype.addDeclaration=function(e,t,r,n){void 0===r&&(r=null);var i=e.name;return this.variables[i]?this.variables[i].addDeclaration(e,r):this.variables[i]=new LocalVariable(e.name,e,r||UNDEFINED_EXPRESSION,t),this.variables[i]},e.prototype.contains=function(e){return e in this.variables},e.prototype.findVariable=function(e){throw new Error("Internal Error: findVariable needs to be implemented by a subclass")},e}(),ChildScope=function(e){function t(t){var r=e.call(this)||this;return r.accessedOutsideVariables=Object.create(null),r.parent=t,t.children.push(r),r}return __extends(t,e),t.prototype.addNamespaceMemberAccess=function(e,r){this.accessedOutsideVariables[e]=r,this.parent instanceof t&&this.parent.addNamespaceMemberAccess(e,r)},t.prototype.addReturnExpression=function(e){this.parent instanceof t&&this.parent.addReturnExpression(e)},t.prototype.contains=function(e){return e in this.variables||this.parent.contains(e)},t.prototype.deconflict=function(e){for(var t=Object.assign(Object.create(null),e),r=0,n=Object.keys(this.accessedOutsideVariables);r<n.length;r++){var i=n[r];(a=this.accessedOutsideVariables[i]).included&&(t[a.getBaseVariableName()]=!0)}for(var s=0,o=Object.keys(this.variables);s<o.length;s++){var a;i=o[s];(a=this.variables[i]).included&&a.setSafeName(getSafeName(i,t))}for(var u=0,c=this.children;u<c.length;u++){c[u].deconflict(e)}},t.prototype.findLexicalBoundary=function(){return this.parent instanceof t?this.parent.findLexicalBoundary():this},t.prototype.findVariable=function(e){var t=this.variables[e]||this.accessedOutsideVariables[e];return t||(this.accessedOutsideVariables[e]=this.parent.findVariable(e))},t}(Scope$1),DELETE="delete",SHIFT=5,SIZE=1<<SHIFT,MASK=SIZE-1,NOT_SET={};function MakeRef(){return{value:!1}}function SetRef(e){e&&(e.value=!0)}function OwnerID(){}function ensureSize(e){return void 0===e.size&&(e.size=e.__iterate(returnTrue)),e.size}function wrapIndex(e,t){if("number"!=typeof t){var r=t>>>0;if(""+r!==t||4294967295===r)return NaN;t=r}return t<0?ensureSize(e)+t:t}function returnTrue(){return!0}function wholeSlice(e,t,r){return(0===e&&!isNeg(e)||void 0!==r&&e<=-r)&&(void 0===t||void 0!==r&&t>=r)}function resolveBegin(e,t){return resolveIndex(e,t,0)}function resolveEnd(e,t){return resolveIndex(e,t,t)}function resolveIndex(e,t,r){return void 0===e?r:isNeg(e)?t===1/0?t:0|Math.max(0,t+e):void 0===t||t===e?e:0|Math.min(t,e)}function isNeg(e){return e<0||0===e&&1/e==-1/0}var IS_COLLECTION_SYMBOL="@@__IMMUTABLE_ITERABLE__@@";function isCollection(e){return Boolean(e&&e[IS_COLLECTION_SYMBOL])}var IS_KEYED_SYMBOL="@@__IMMUTABLE_KEYED__@@";function isKeyed(e){return Boolean(e&&e[IS_KEYED_SYMBOL])}var IS_INDEXED_SYMBOL="@@__IMMUTABLE_INDEXED__@@";function isIndexed(e){return Boolean(e&&e[IS_INDEXED_SYMBOL])}function isAssociative(e){return isKeyed(e)||isIndexed(e)}var Collection=function(e){return isCollection(e)?e:Seq(e)},KeyedCollection=function(e){function t(e){return isKeyed(e)?e:KeyedSeq(e)}return e&&(t.__proto__=e),t.prototype=Object.create(e&&e.prototype),t.prototype.constructor=t,t}(Collection),IndexedCollection=function(e){function t(e){return isIndexed(e)?e:IndexedSeq(e)}return e&&(t.__proto__=e),t.prototype=Object.create(e&&e.prototype),t.prototype.constructor=t,t}(Collection),SetCollection=function(e){function t(e){return isCollection(e)&&!isAssociative(e)?e:SetSeq(e)}return e&&(t.__proto__=e),t.prototype=Object.create(e&&e.prototype),t.prototype.constructor=t,t}(Collection);Collection.Keyed=KeyedCollection,Collection.Indexed=IndexedCollection,Collection.Set=SetCollection;var IS_SEQ_SYMBOL="@@__IMMUTABLE_SEQ__@@";function isSeq(e){return Boolean(e&&e[IS_SEQ_SYMBOL])}var IS_RECORD_SYMBOL="@@__IMMUTABLE_RECORD__@@";function isRecord(e){return Boolean(e&&e[IS_RECORD_SYMBOL])}function isImmutable(e){return isCollection(e)||isRecord(e)}var IS_ORDERED_SYMBOL="@@__IMMUTABLE_ORDERED__@@";function isOrdered(e){return Boolean(e&&e[IS_ORDERED_SYMBOL])}var ITERATE_KEYS=0,ITERATE_VALUES=1,ITERATE_ENTRIES=2,REAL_ITERATOR_SYMBOL="function"==typeof Symbol&&Symbol.iterator,FAUX_ITERATOR_SYMBOL="@@iterator",ITERATOR_SYMBOL=REAL_ITERATOR_SYMBOL||FAUX_ITERATOR_SYMBOL,Iterator=function(e){this.next=e};function iteratorValue(e,t,r,n){var i=0===e?t:1===e?r:[t,r];return n?n.value=i:n={value:i,done:!1},n}function iteratorDone(){return{value:void 0,done:!0}}function hasIterator(e){return!!getIteratorFn(e)}function isIterator(e){return e&&"function"==typeof e.next}function getIterator(e){var t=getIteratorFn(e);return t&&t.call(e)}function getIteratorFn(e){var t=e&&(REAL_ITERATOR_SYMBOL&&e[REAL_ITERATOR_SYMBOL]||e[FAUX_ITERATOR_SYMBOL]);if("function"==typeof t)return t}Iterator.prototype.toString=function(){return"[Iterator]"},Iterator.KEYS=ITERATE_KEYS,Iterator.VALUES=ITERATE_VALUES,Iterator.ENTRIES=ITERATE_ENTRIES,Iterator.prototype.inspect=Iterator.prototype.toSource=function(){return this.toString()},Iterator.prototype[ITERATOR_SYMBOL]=function(){return this};var hasOwnProperty$1=Object.prototype.hasOwnProperty;function isArrayLike(e){return!(!Array.isArray(e)&&"string"!=typeof e)||e&&"object"==typeof e&&Number.isInteger(e.length)&&e.length>=0&&(0===e.length?1===Object.keys(e).length:e.hasOwnProperty(e.length-1))}var Seq=function(e){function t(e){return null==e?emptySequence():isImmutable(e)?e.toSeq():seqFromValue(e)}return e&&(t.__proto__=e),t.prototype=Object.create(e&&e.prototype),t.prototype.constructor=t,t.prototype.toSeq=function(){return this},t.prototype.toString=function(){return this.__toString("Seq {","}")},t.prototype.cacheResult=function(){return!this._cache&&this.__iterateUncached&&(this._cache=this.entrySeq().toArray(),this.size=this._cache.length),this},t.prototype.__iterate=function(e,t){var r=this._cache;if(r){for(var n=r.length,i=0;i!==n;){var s=r[t?n-++i:i++];if(!1===e(s[1],s[0],this))break}return i}return this.__iterateUncached(e,t)},t.prototype.__iterator=function(e,t){var r=this._cache;if(r){var n=r.length,i=0;return new Iterator(function(){if(i===n)return iteratorDone();var s=r[t?n-++i:i++];return iteratorValue(e,s[0],s[1])})}return this.__iteratorUncached(e,t)},t}(Collection),KeyedSeq=function(e){function t(e){return null==e?emptySequence().toKeyedSeq():isCollection(e)?isKeyed(e)?e.toSeq():e.fromEntrySeq():isRecord(e)?e.toSeq():keyedSeqFromValue(e)}return e&&(t.__proto__=e),t.prototype=Object.create(e&&e.prototype),t.prototype.constructor=t,t.prototype.toKeyedSeq=function(){return this},t}(Seq),IndexedSeq=function(e){function t(e){return null==e?emptySequence():isCollection(e)?isKeyed(e)?e.entrySeq():e.toIndexedSeq():isRecord(e)?e.toSeq().entrySeq():indexedSeqFromValue(e)}return e&&(t.__proto__=e),t.prototype=Object.create(e&&e.prototype),t.prototype.constructor=t,t.of=function(){return t(arguments)},t.prototype.toIndexedSeq=function(){return this},t.prototype.toString=function(){return this.__toString("Seq [","]")},t}(Seq),SetSeq=function(e){function t(e){return(isCollection(e)&&!isAssociative(e)?e:IndexedSeq(e)).toSetSeq()}return e&&(t.__proto__=e),t.prototype=Object.create(e&&e.prototype),t.prototype.constructor=t,t.of=function(){return t(arguments)},t.prototype.toSetSeq=function(){return this},t}(Seq);Seq.isSeq=isSeq,Seq.Keyed=KeyedSeq,Seq.Set=SetSeq,Seq.Indexed=IndexedSeq,Seq.prototype[IS_SEQ_SYMBOL]=!0;var ArraySeq=function(e){function t(e){this._array=e,this.size=e.length}return e&&(t.__proto__=e),t.prototype=Object.create(e&&e.prototype),t.prototype.constructor=t,t.prototype.get=function(e,t){return this.has(e)?this._array[wrapIndex(this,e)]:t},t.prototype.__iterate=function(e,t){for(var r=this._array,n=r.length,i=0;i!==n;){var s=t?n-++i:i++;if(!1===e(r[s],s,this))break}return i},t.prototype.__iterator=function(e,t){var r=this._array,n=r.length,i=0;return new Iterator(function(){if(i===n)return iteratorDone();var s=t?n-++i:i++;return iteratorValue(e,s,r[s])})},t}(IndexedSeq),ObjectSeq=function(e){function t(e){var t=Object.keys(e);this._object=e,this._keys=t,this.size=t.length}return e&&(t.__proto__=e),t.prototype=Object.create(e&&e.prototype),t.prototype.constructor=t,t.prototype.get=function(e,t){return void 0===t||this.has(e)?this._object[e]:t},t.prototype.has=function(e){return hasOwnProperty$1.call(this._object,e)},t.prototype.__iterate=function(e,t){for(var r=this._object,n=this._keys,i=n.length,s=0;s!==i;){var o=n[t?i-++s:s++];if(!1===e(r[o],o,this))break}return s},t.prototype.__iterator=function(e,t){var r=this._object,n=this._keys,i=n.length,s=0;return new Iterator(function(){if(s===i)return iteratorDone();var o=n[t?i-++s:s++];return iteratorValue(e,o,r[o])})},t}(KeyedSeq);ObjectSeq.prototype[IS_ORDERED_SYMBOL]=!0;var EMPTY_SEQ,CollectionSeq=function(e){function t(e){this._collection=e,this.size=e.length||e.size}return e&&(t.__proto__=e),t.prototype=Object.create(e&&e.prototype),t.prototype.constructor=t,t.prototype.__iterateUncached=function(e,t){if(t)return this.cacheResult().__iterate(e,t);var r=getIterator(this._collection),n=0;if(isIterator(r))for(var i;!(i=r.next()).done&&!1!==e(i.value,n++,this););return n},t.prototype.__iteratorUncached=function(e,t){if(t)return this.cacheResult().__iterator(e,t);var r=getIterator(this._collection);if(!isIterator(r))return new Iterator(iteratorDone);var n=0;return new Iterator(function(){var t=r.next();return t.done?t:iteratorValue(e,n++,t.value)})},t}(IndexedSeq);function emptySequence(){return EMPTY_SEQ||(EMPTY_SEQ=new ArraySeq([]))}function keyedSeqFromValue(e){var t=Array.isArray(e)?new ArraySeq(e):hasIterator(e)?new CollectionSeq(e):void 0;if(t)return t.fromEntrySeq();if("object"==typeof e)return new ObjectSeq(e);throw new TypeError("Expected Array or collection object of [k, v] entries, or keyed object: "+e)}function indexedSeqFromValue(e){var t=maybeIndexedSeqFromValue(e);if(t)return t;throw new TypeError("Expected Array or collection object of values: "+e)}function seqFromValue(e){var t=maybeIndexedSeqFromValue(e);if(t)return t;if("object"==typeof e)return new ObjectSeq(e);throw new TypeError("Expected Array or collection object of values, or keyed object: "+e)}function maybeIndexedSeqFromValue(e){return isArrayLike(e)?new ArraySeq(e):hasIterator(e)?new CollectionSeq(e):void 0}var IS_MAP_SYMBOL="@@__IMMUTABLE_MAP__@@";function isMap(e){return Boolean(e&&e[IS_MAP_SYMBOL])}function isOrderedMap(e){return isMap(e)&&isOrdered(e)}function isValueObject(e){return Boolean(e&&"function"==typeof e.equals&&"function"==typeof e.hashCode)}function is(e,t){if(e===t||e!=e&&t!=t)return!0;if(!e||!t)return!1;if("function"==typeof e.valueOf&&"function"==typeof t.valueOf){if((e=e.valueOf())===(t=t.valueOf())||e!=e&&t!=t)return!0;if(!e||!t)return!1}return!!(isValueObject(e)&&isValueObject(t)&&e.equals(t))}var imul="function"==typeof Math.imul&&-2===Math.imul(4294967295,2)?Math.imul:function(e,t){var r=65535&(e|=0),n=65535&(t|=0);return r*n+((e>>>16)*n+r*(t>>>16)<<16>>>0)|0};function smi(e){return e>>>1&1073741824|3221225471&e}var defaultValueOf=Object.prototype.valueOf;function hash(e){switch(typeof e){case"boolean":return e?1108378657:1108378656;case"number":return hashNumber(e);case"string":return e.length>STRING_HASH_CACHE_MIN_STRLEN?cachedHashString(e):hashString(e);case"object":case"function":return null===e?1108378658:"function"==typeof e.hashCode?smi(e.hashCode(e)):(e.valueOf!==defaultValueOf&&"function"==typeof e.valueOf&&(e=e.valueOf(e)),hashJSObj(e));case"undefined":return 1108378659;default:if("function"==typeof e.toString)return hashString(e.toString());throw new Error("Value type "+typeof e+" cannot be hashed.")}}function hashNumber(e){if(e!=e||e===1/0)return 0;var t=0|e;for(t!==e&&(t^=4294967295*e);e>4294967295;)t^=e/=4294967295;return smi(t)}function cachedHashString(e){var t=stringHashCache[e];return void 0===t&&(t=hashString(e),STRING_HASH_CACHE_SIZE===STRING_HASH_CACHE_MAX_SIZE&&(STRING_HASH_CACHE_SIZE=0,stringHashCache={}),STRING_HASH_CACHE_SIZE++,stringHashCache[e]=t),t}function hashString(e){for(var t=0,r=0;r<e.length;r++)t=31*t+e.charCodeAt(r)|0;return smi(t)}function hashJSObj(e){var t;if(usingWeakMap&&void 0!==(t=weakMap.get(e)))return t;if(void 0!==(t=e[UID_HASH_KEY]))return t;if(!canDefineProperty){if(void 0!==(t=e.propertyIsEnumerable&&e.propertyIsEnumerable[UID_HASH_KEY]))return t;if(void 0!==(t=getIENodeHash(e)))return t}if(t=++objHashUID,1073741824&objHashUID&&(objHashUID=0),usingWeakMap)weakMap.set(e,t);else{if(void 0!==isExtensible&&!1===isExtensible(e))throw new Error("Non-extensible objects are not allowed as keys.");if(canDefineProperty)Object.defineProperty(e,UID_HASH_KEY,{enumerable:!1,configurable:!1,writable:!1,value:t});else if(void 0!==e.propertyIsEnumerable&&e.propertyIsEnumerable===e.constructor.prototype.propertyIsEnumerable)e.propertyIsEnumerable=function(){return this.constructor.prototype.propertyIsEnumerable.apply(this,arguments)},e.propertyIsEnumerable[UID_HASH_KEY]=t;else{if(void 0===e.nodeType)throw new Error("Unable to set a non-enumerable property on object.");e[UID_HASH_KEY]=t}}return t}var isExtensible=Object.isExtensible,canDefineProperty=function(){try{return Object.defineProperty({},"@",{}),!0}catch(e){return!1}}();function getIENodeHash(e){if(e&&e.nodeType>0)switch(e.nodeType){case 1:return e.uniqueID;case 9:return e.documentElement&&e.documentElement.uniqueID}}var weakMap,usingWeakMap="function"==typeof WeakMap;usingWeakMap&&(weakMap=new WeakMap);var objHashUID=0,UID_HASH_KEY="__immutablehash__";"function"==typeof Symbol&&(UID_HASH_KEY=Symbol(UID_HASH_KEY));var STRING_HASH_CACHE_MIN_STRLEN=16,STRING_HASH_CACHE_MAX_SIZE=255,STRING_HASH_CACHE_SIZE=0,stringHashCache={},ToKeyedSequence=function(e){function t(e,t){this._iter=e,this._useKeys=t,this.size=e.size}return e&&(t.__proto__=e),t.prototype=Object.create(e&&e.prototype),t.prototype.constructor=t,t.prototype.get=function(e,t){return this._iter.get(e,t)},t.prototype.has=function(e){return this._iter.has(e)},t.prototype.valueSeq=function(){return this._iter.valueSeq()},t.prototype.reverse=function(){var e=this,t=reverseFactory(this,!0);return this._useKeys||(t.valueSeq=function(){return e._iter.toSeq().reverse()}),t},t.prototype.map=function(e,t){var r=this,n=mapFactory(this,e,t);return this._useKeys||(n.valueSeq=function(){return r._iter.toSeq().map(e,t)}),n},t.prototype.__iterate=function(e,t){var r=this;return this._iter.__iterate(function(t,n){return e(t,n,r)},t)},t.prototype.__iterator=function(e,t){return this._iter.__iterator(e,t)},t}(KeyedSeq);ToKeyedSequence.prototype[IS_ORDERED_SYMBOL]=!0;var ToIndexedSequence=function(e){function t(e){this._iter=e,this.size=e.size}return e&&(t.__proto__=e),t.prototype=Object.create(e&&e.prototype),t.prototype.constructor=t,t.prototype.includes=function(e){return this._iter.includes(e)},t.prototype.__iterate=function(e,t){var r=this,n=0;return t&&ensureSize(this),this._iter.__iterate(function(i){return e(i,t?r.size-++n:n++,r)},t)},t.prototype.__iterator=function(e,t){var r=this,n=this._iter.__iterator(ITERATE_VALUES,t),i=0;return t&&ensureSize(this),new Iterator(function(){var s=n.next();return s.done?s:iteratorValue(e,t?r.size-++i:i++,s.value,s)})},t}(IndexedSeq),ToSetSequence=function(e){function t(e){this._iter=e,this.size=e.size}return e&&(t.__proto__=e),t.prototype=Object.create(e&&e.prototype),t.prototype.constructor=t,t.prototype.has=function(e){return this._iter.includes(e)},t.prototype.__iterate=function(e,t){var r=this;return this._iter.__iterate(function(t){return e(t,t,r)},t)},t.prototype.__iterator=function(e,t){var r=this._iter.__iterator(ITERATE_VALUES,t);return new Iterator(function(){var t=r.next();return t.done?t:iteratorValue(e,t.value,t.value,t)})},t}(SetSeq),FromEntriesSequence=function(e){function t(e){this._iter=e,this.size=e.size}return e&&(t.__proto__=e),t.prototype=Object.create(e&&e.prototype),t.prototype.constructor=t,t.prototype.entrySeq=function(){return this._iter.toSeq()},t.prototype.__iterate=function(e,t){var r=this;return this._iter.__iterate(function(t){if(t){validateEntry(t);var n=isCollection(t);return e(n?t.get(1):t[1],n?t.get(0):t[0],r)}},t)},t.prototype.__iterator=function(e,t){var r=this._iter.__iterator(ITERATE_VALUES,t);return new Iterator(function(){for(;;){var t=r.next();if(t.done)return t;var n=t.value;if(n){validateEntry(n);var i=isCollection(n);return iteratorValue(e,i?n.get(0):n[0],i?n.get(1):n[1],t)}}})},t}(KeyedSeq);function flipFactory(e){var t=makeSequence(e);return t._iter=e,t.size=e.size,t.flip=function(){return e},t.reverse=function(){var t=e.reverse.apply(this);return t.flip=function(){return e.reverse()},t},t.has=function(t){return e.includes(t)},t.includes=function(t){return e.has(t)},t.cacheResult=cacheResultThrough,t.__iterateUncached=function(t,r){var n=this;return e.__iterate(function(e,r){return!1!==t(r,e,n)},r)},t.__iteratorUncached=function(t,r){if(t===ITERATE_ENTRIES){var n=e.__iterator(t,r);return new Iterator(function(){var e=n.next();if(!e.done){var t=e.value[0];e.value[0]=e.value[1],e.value[1]=t}return e})}return e.__iterator(t===ITERATE_VALUES?ITERATE_KEYS:ITERATE_VALUES,r)},t}function mapFactory(e,t,r){var n=makeSequence(e);return n.size=e.size,n.has=function(t){return e.has(t)},n.get=function(n,i){var s=e.get(n,NOT_SET);return s===NOT_SET?i:t.call(r,s,n,e)},n.__iterateUncached=function(n,i){var s=this;return e.__iterate(function(e,i,o){return!1!==n(t.call(r,e,i,o),i,s)},i)},n.__iteratorUncached=function(n,i){var s=e.__iterator(ITERATE_ENTRIES,i);return new Iterator(function(){var i=s.next();if(i.done)return i;var o=i.value,a=o[0];return iteratorValue(n,a,t.call(r,o[1],a,e),i)})},n}function reverseFactory(e,t){var r=this,n=makeSequence(e);return n._iter=e,n.size=e.size,n.reverse=function(){return e},e.flip&&(n.flip=function(){var t=flipFactory(e);return t.reverse=function(){return e.flip()},t}),n.get=function(r,n){return e.get(t?r:-1-r,n)},n.has=function(r){return e.has(t?r:-1-r)},n.includes=function(t){return e.includes(t)},n.cacheResult=cacheResultThrough,n.__iterate=function(r,n){var i=this,s=0;return n&&ensureSize(e),e.__iterate(function(e,o){return r(e,t?o:n?i.size-++s:s++,i)},!n)},n.__iterator=function(n,i){var s=0;i&&ensureSize(e);var o=e.__iterator(ITERATE_ENTRIES,!i);return new Iterator(function(){var e=o.next();if(e.done)return e;var a=e.value;return iteratorValue(n,t?a[0]:i?r.size-++s:s++,a[1],e)})},n}function filterFactory(e,t,r,n){var i=makeSequence(e);return n&&(i.has=function(n){var i=e.get(n,NOT_SET);return i!==NOT_SET&&!!t.call(r,i,n,e)},i.get=function(n,i){var s=e.get(n,NOT_SET);return s!==NOT_SET&&t.call(r,s,n,e)?s:i}),i.__iterateUncached=function(i,s){var o=this,a=0;return e.__iterate(function(e,s,u){if(t.call(r,e,s,u))return a++,i(e,n?s:a-1,o)},s),a},i.__iteratorUncached=function(i,s){var o=e.__iterator(ITERATE_ENTRIES,s),a=0;return new Iterator(function(){for(;;){var s=o.next();if(s.done)return s;var u=s.value,c=u[0],p=u[1];if(t.call(r,p,c,e))return iteratorValue(i,n?c:a++,p,s)}})},i}function countByFactory(e,t,r){var n=Map$1().asMutable();return e.__iterate(function(i,s){n.update(t.call(r,i,s,e),0,function(e){return e+1})}),n.asImmutable()}function groupByFactory(e,t,r){var n=isKeyed(e),i=(isOrdered(e)?OrderedMap():Map$1()).asMutable();e.__iterate(function(s,o){i.update(t.call(r,s,o,e),function(e){return(e=e||[]).push(n?[o,s]:s),e})});var s=collectionClass(e);return i.map(function(t){return reify(e,s(t))}).asImmutable()}function sliceFactory(e,t,r,n){var i=e.size;if(wholeSlice(t,r,i))return e;var s=resolveBegin(t,i),o=resolveEnd(r,i);if(s!=s||o!=o)return sliceFactory(e.toSeq().cacheResult(),t,r,n);var a,u=o-s;u==u&&(a=u<0?0:u);var c=makeSequence(e);return c.size=0===a?a:e.size&&a||void 0,!n&&isSeq(e)&&a>=0&&(c.get=function(t,r){return(t=wrapIndex(this,t))>=0&&t<a?e.get(t+s,r):r}),c.__iterateUncached=function(t,r){var i=this;if(0===a)return 0;if(r)return this.cacheResult().__iterate(t,r);var o=0,u=!0,c=0;return e.__iterate(function(e,r){if(!u||!(u=o++<s))return c++,!1!==t(e,n?r:c-1,i)&&c!==a}),c},c.__iteratorUncached=function(t,r){if(0!==a&&r)return this.cacheResult().__iterator(t,r);if(0===a)return new Iterator(iteratorDone);var i=e.__iterator(t,r),o=0,u=0;return new Iterator(function(){for(;o++<s;)i.next();if(++u>a)return iteratorDone();var e=i.next();return n||t===ITERATE_VALUES||e.done?e:iteratorValue(t,u-1,t===ITERATE_KEYS?void 0:e.value[1],e)})},c}function takeWhileFactory(e,t,r){var n=makeSequence(e);return n.__iterateUncached=function(n,i){var s=this;if(i)return this.cacheResult().__iterate(n,i);var o=0;return e.__iterate(function(e,i,a){return t.call(r,e,i,a)&&++o&&n(e,i,s)}),o},n.__iteratorUncached=function(n,i){var s=this;if(i)return this.cacheResult().__iterator(n,i);var o=e.__iterator(ITERATE_ENTRIES,i),a=!0;return new Iterator(function(){if(!a)return iteratorDone();var e=o.next();if(e.done)return e;var i=e.value,u=i[0],c=i[1];return t.call(r,c,u,s)?n===ITERATE_ENTRIES?e:iteratorValue(n,u,c,e):(a=!1,iteratorDone())})},n}function skipWhileFactory(e,t,r,n){var i=makeSequence(e);return i.__iterateUncached=function(i,s){var o=this;if(s)return this.cacheResult().__iterate(i,s);var a=!0,u=0;return e.__iterate(function(e,s,c){if(!a||!(a=t.call(r,e,s,c)))return u++,i(e,n?s:u-1,o)}),u},i.__iteratorUncached=function(i,s){var o=this;if(s)return this.cacheResult().__iterator(i,s);var a=e.__iterator(ITERATE_ENTRIES,s),u=!0,c=0;return new Iterator(function(){var e,s,p;do{if((e=a.next()).done)return n||i===ITERATE_VALUES?e:iteratorValue(i,c++,i===ITERATE_KEYS?void 0:e.value[1],e);var l=e.value;s=l[0],p=l[1],u&&(u=t.call(r,p,s,o))}while(u);return i===ITERATE_ENTRIES?e:iteratorValue(i,s,p,e)})},i}function concatFactory(e,t){var r=isKeyed(e),n=[e].concat(t).map(function(e){return isCollection(e)?r&&(e=KeyedCollection(e)):e=r?keyedSeqFromValue(e):indexedSeqFromValue(Array.isArray(e)?e:[e]),e}).filter(function(e){return 0!==e.size});if(0===n.length)return e;if(1===n.length){var i=n[0];if(i===e||r&&isKeyed(i)||isIndexed(e)&&isIndexed(i))return i}var s=new ArraySeq(n);return r?s=s.toKeyedSeq():isIndexed(e)||(s=s.toSetSeq()),(s=s.flatten(!0)).size=n.reduce(function(e,t){if(void 0!==e){var r=t.size;if(void 0!==r)return e+r}},0),s}function flattenFactory(e,t,r){var n=makeSequence(e);return n.__iterateUncached=function(i,s){if(s)return this.cacheResult().__iterate(i,s);var o=0,a=!1;return function e(u,c){u.__iterate(function(s,u){return(!t||c<t)&&isCollection(s)?e(s,c+1):(o++,!1===i(s,r?u:o-1,n)&&(a=!0)),!a},s)}(e,0),o},n.__iteratorUncached=function(n,i){if(i)return this.cacheResult().__iterator(n,i);var s=e.__iterator(n,i),o=[],a=0;return new Iterator(function(){for(;s;){var e=s.next();if(!1===e.done){var u=e.value;if(n===ITERATE_ENTRIES&&(u=u[1]),t&&!(o.length<t)||!isCollection(u))return r?e:iteratorValue(n,a++,u,e);o.push(s),s=u.__iterator(n,i)}else s=o.pop()}return iteratorDone()})},n}function flatMapFactory(e,t,r){var n=collectionClass(e);return e.toSeq().map(function(i,s){return n(t.call(r,i,s,e))}).flatten(!0)}function interposeFactory(e,t){var r=makeSequence(e);return r.size=e.size&&2*e.size-1,r.__iterateUncached=function(r,n){var i=this,s=0;return e.__iterate(function(e){return(!s||!1!==r(t,s++,i))&&!1!==r(e,s++,i)},n),s},r.__iteratorUncached=function(r,n){var i,s=e.__iterator(ITERATE_VALUES,n),o=0;return new Iterator(function(){return(!i||o%2)&&(i=s.next()).done?i:o%2?iteratorValue(r,o++,t):iteratorValue(r,o++,i.value,i)})},r}function sortFactory(e,t,r){t||(t=defaultComparator);var n=isKeyed(e),i=0,s=e.toSeq().map(function(t,n){return[n,t,i++,r?r(t,n,e):t]}).valueSeq().toArray();return s.sort(function(e,r){return t(e[3],r[3])||e[2]-r[2]}).forEach(n?function(e,t){s[t].length=2}:function(e,t){s[t]=e[1]}),n?KeyedSeq(s):isIndexed(e)?IndexedSeq(s):SetSeq(s)}function maxFactory(e,t,r){if(t||(t=defaultComparator),r){var n=e.toSeq().map(function(t,n){return[t,r(t,n,e)]}).reduce(function(e,r){return maxCompare(t,e[1],r[1])?r:e});return n&&n[0]}return e.reduce(function(e,r){return maxCompare(t,e,r)?r:e})}function maxCompare(e,t,r){var n=e(r,t);return 0===n&&r!==t&&(null==r||r!=r)||n>0}function zipWithFactory(e,t,r,n){var i=makeSequence(e),s=new ArraySeq(r).map(function(e){return e.size});return i.size=n?s.max():s.min(),i.__iterate=function(e,t){for(var r,n=this.__iterator(ITERATE_VALUES,t),i=0;!(r=n.next()).done&&!1!==e(r.value,i++,this););return i},i.__iteratorUncached=function(e,i){var s=r.map(function(e){return e=Collection(e),getIterator(i?e.reverse():e)}),o=0,a=!1;return new Iterator(function(){var r;return a||(r=s.map(function(e){return e.next()}),a=n?r.every(function(e){return e.done}):r.some(function(e){return e.done})),a?iteratorDone():iteratorValue(e,o++,t.apply(null,r.map(function(e){return e.value})))})},i}function reify(e,t){return e===t?e:isSeq(e)?t:e.constructor(t)}function validateEntry(e){if(e!==Object(e))throw new TypeError("Expected [K, V] tuple: "+e)}function collectionClass(e){return isKeyed(e)?KeyedCollection:isIndexed(e)?IndexedCollection:SetCollection}function makeSequence(e){return Object.create((isKeyed(e)?KeyedSeq:isIndexed(e)?IndexedSeq:SetSeq).prototype)}function cacheResultThrough(){return this._iter.cacheResult?(this._iter.cacheResult(),this.size=this._iter.size,this):Seq.prototype.cacheResult.call(this)}function defaultComparator(e,t){return void 0===e&&void 0===t?0:void 0===e?1:void 0===t?-1:e>t?1:e<t?-1:0}function arrCopy(e,t){t=t||0;for(var r=Math.max(0,e.length-t),n=new Array(r),i=0;i<r;i++)n[i]=e[i+t];return n}function invariant(e,t){if(!e)throw new Error(t)}function assertNotInfinite(e){invariant(e!==1/0,"Cannot perform this action with an infinite size.")}function coerceKeyPath(e){if(isArrayLike(e)&&"string"!=typeof e)return e;if(isOrdered(e))return e.toArray();throw new TypeError("Invalid keyPath: expected Ordered Collection or Array: "+e)}function isPlainObj(e){return e&&("function"!=typeof e.constructor||"Object"===e.constructor.name)}function isDataStructure(e){return"object"==typeof e&&(isImmutable(e)||Array.isArray(e)||isPlainObj(e))}function quoteString(e){try{return"string"==typeof e?JSON.stringify(e):String(e)}catch(t){return JSON.stringify(e)}}function has$1(e,t){return isImmutable(e)?e.has(t):isDataStructure(e)&&hasOwnProperty$1.call(e,t)}function get(e,t,r){return isImmutable(e)?e.get(t,r):has$1(e,t)?"function"==typeof e.get?e.get(t):e[t]:r}function shallowCopy(e){if(Array.isArray(e))return arrCopy(e);var t={};for(var r in e)hasOwnProperty$1.call(e,r)&&(t[r]=e[r]);return t}function remove(e,t){if(!isDataStructure(e))throw new TypeError("Cannot update non-data-structure value: "+e);if(isImmutable(e)){if(!e.remove)throw new TypeError("Cannot update immutable value without .remove() method: "+e);return e.remove(t)}if(!hasOwnProperty$1.call(e,t))return e;var r=shallowCopy(e);return Array.isArray(r)?r.splice(t,1):delete r[t],r}function set(e,t,r){if(!isDataStructure(e))throw new TypeError("Cannot update non-data-structure value: "+e);if(isImmutable(e)){if(!e.set)throw new TypeError("Cannot update immutable value without .set() method: "+e);return e.set(t,r)}if(hasOwnProperty$1.call(e,t)&&r===e[t])return e;var n=shallowCopy(e);return n[t]=r,n}function updateIn(e,t,r,n){n||(n=r,r=void 0);var i=updateInDeeply(isImmutable(e),e,coerceKeyPath(t),0,r,n);return i===NOT_SET?r:i}function updateInDeeply(e,t,r,n,i,s){var o=t===NOT_SET;if(n===r.length){var a=o?i:t,u=s(a);return u===a?t:u}if(!o&&!isDataStructure(t))throw new TypeError("Cannot update within non-data-structure value in path ["+r.slice(0,n).map(quoteString)+"]: "+t);var c=r[n],p=o?NOT_SET:get(t,c,NOT_SET),l=updateInDeeply(p===NOT_SET?e:isImmutable(p),p,r,n+1,i,s);return l===p?t:l===NOT_SET?remove(t,c):set(o?e?emptyMap():{}:t,c,l)}function setIn(e,t,r){return updateIn(e,t,NOT_SET,function(){return r})}function setIn$1(e,t){return setIn(this,e,t)}function removeIn(e,t){return updateIn(e,t,function(){return NOT_SET})}function deleteIn(e){return removeIn(this,e)}function update(e,t,r,n){return updateIn(e,[t],r,n)}function update$1(e,t,r){return 1===arguments.length?e(this):update(this,e,t,r)}function updateIn$1(e,t,r){return updateIn(this,e,t,r)}function merge(){for(var e=[],t=arguments.length;t--;)e[t]=arguments[t];return mergeIntoKeyedWith(this,e)}function mergeWith(e){for(var t=[],r=arguments.length-1;r-- >0;)t[r]=arguments[r+1];if("function"!=typeof e)throw new TypeError("Invalid merger function: "+e);return mergeIntoKeyedWith(this,t,e)}function mergeIntoKeyedWith(e,t,r){for(var n=[],i=0;i<t.length;i++){var s=KeyedCollection(t[i]);0!==s.size&&n.push(s)}return 0===n.length?e:0!==e.toSeq().size||e.__ownerID||1!==n.length?e.withMutations(function(e){for(var t=r?function(t,n){update(e,n,NOT_SET,function(e){return e===NOT_SET?t:r(e,t,n)})}:function(t,r){e.set(r,t)},i=0;i<n.length;i++)n[i].forEach(t)}):e.constructor(n[0])}function merge$1(e){for(var t=[],r=arguments.length-1;r-- >0;)t[r]=arguments[r+1];return mergeWithSources(e,t)}function mergeWith$1(e,t){for(var r=[],n=arguments.length-2;n-- >0;)r[n]=arguments[n+2];return mergeWithSources(t,r,e)}function mergeDeep(e){for(var t=[],r=arguments.length-1;r-- >0;)t[r]=arguments[r+1];return mergeDeepWithSources(e,t)}function mergeDeepWith(e,t){for(var r=[],n=arguments.length-2;n-- >0;)r[n]=arguments[n+2];return mergeDeepWithSources(t,r,e)}function mergeDeepWithSources(e,t,r){return mergeWithSources(e,t,deepMergerWith(r))}function mergeWithSources(e,t,r){if(!isDataStructure(e))throw new TypeError("Cannot merge into non-data-structure value: "+e);if(isImmutable(e))return"function"==typeof r&&e.mergeWith?e.mergeWith.apply(e,[r].concat(t)):e.merge?e.merge.apply(e,t):e.concat.apply(e,t);for(var n=Array.isArray(e),i=e,s=n?IndexedCollection:KeyedCollection,o=n?function(t){i===e&&(i=shallowCopy(i)),i.push(t)}:function(t,n){var s=hasOwnProperty$1.call(i,n),o=s&&r?r(i[n],t,n):t;s&&o===i[n]||(i===e&&(i=shallowCopy(i)),i[n]=o)},a=0;a<t.length;a++)s(t[a]).forEach(o);return i}function deepMergerWith(e){return function t(r,n,i){return isDataStructure(r)&&isDataStructure(n)?mergeWithSources(r,[n],t):e?e(r,n,i):n}}function mergeDeep$1(){for(var e=[],t=arguments.length;t--;)e[t]=arguments[t];return mergeDeepWithSources(this,e)}function mergeDeepWith$1(e){for(var t=[],r=arguments.length-1;r-- >0;)t[r]=arguments[r+1];return mergeDeepWithSources(this,t,e)}function mergeIn(e){for(var t=[],r=arguments.length-1;r-- >0;)t[r]=arguments[r+1];return updateIn(this,e,emptyMap(),function(e){return mergeWithSources(e,t)})}function mergeDeepIn(e){for(var t=[],r=arguments.length-1;r-- >0;)t[r]=arguments[r+1];return updateIn(this,e,emptyMap(),function(e){return mergeDeepWithSources(e,t)})}function withMutations(e){var t=this.asMutable();return e(t),t.wasAltered()?t.__ensureOwner(this.__ownerID):this}function asMutable(){return this.__ownerID?this:this.__ensureOwner(new OwnerID)}function asImmutable(){return this.__ensureOwner()}function wasAltered(){return this.__altered}ToIndexedSequence.prototype.cacheResult=ToKeyedSequence.prototype.cacheResult=ToSetSequence.prototype.cacheResult=FromEntriesSequence.prototype.cacheResult=cacheResultThrough;var Map$1=function(e){function t(t){return null==t?emptyMap():isMap(t)&&!isOrdered(t)?t:emptyMap().withMutations(function(r){var n=e(t);assertNotInfinite(n.size),n.forEach(function(e,t){return r.set(t,e)})})}return e&&(t.__proto__=e),t.prototype=Object.create(e&&e.prototype),t.prototype.constructor=t,t.of=function(){for(var e=[],t=arguments.length;t--;)e[t]=arguments[t];return emptyMap().withMutations(function(t){for(var r=0;r<e.length;r+=2){if(r+1>=e.length)throw new Error("Missing value for key: "+e[r]);t.set(e[r],e[r+1])}})},t.prototype.toString=function(){return this.__toString("Map {","}")},t.prototype.get=function(e,t){return this._root?this._root.get(0,void 0,e,t):t},t.prototype.set=function(e,t){return updateMap(this,e,t)},t.prototype.remove=function(e){return updateMap(this,e,NOT_SET)},t.prototype.deleteAll=function(e){var t=Collection(e);return 0===t.size?this:this.withMutations(function(e){t.forEach(function(t){return e.remove(t)})})},t.prototype.clear=function(){return 0===this.size?this:this.__ownerID?(this.size=0,this._root=null,this.__hash=void 0,this.__altered=!0,this):emptyMap()},t.prototype.sort=function(e){return OrderedMap(sortFactory(this,e))},t.prototype.sortBy=function(e,t){return OrderedMap(sortFactory(this,t,e))},t.prototype.map=function(e,t){return this.withMutations(function(r){r.forEach(function(n,i){r.set(i,e.call(t,n,i,r))})})},t.prototype.__iterator=function(e,t){return new MapIterator(this,e,t)},t.prototype.__iterate=function(e,t){var r=this,n=0;return this._root&&this._root.iterate(function(t){return n++,e(t[1],t[0],r)},t),n},t.prototype.__ensureOwner=function(e){return e===this.__ownerID?this:e?makeMap(this.size,this._root,e,this.__hash):0===this.size?emptyMap():(this.__ownerID=e,this.__altered=!1,this)},t}(KeyedCollection);Map$1.isMap=isMap;var MapPrototype=Map$1.prototype;MapPrototype[IS_MAP_SYMBOL]=!0,MapPrototype[DELETE]=MapPrototype.remove,MapPrototype.removeAll=MapPrototype.deleteAll,MapPrototype.setIn=setIn$1,MapPrototype.removeIn=MapPrototype.deleteIn=deleteIn,MapPrototype.update=update$1,MapPrototype.updateIn=updateIn$1,MapPrototype.merge=MapPrototype.concat=merge,MapPrototype.mergeWith=mergeWith,MapPrototype.mergeDeep=mergeDeep$1,MapPrototype.mergeDeepWith=mergeDeepWith$1,MapPrototype.mergeIn=mergeIn,MapPrototype.mergeDeepIn=mergeDeepIn,MapPrototype.withMutations=withMutations,MapPrototype.wasAltered=wasAltered,MapPrototype.asImmutable=asImmutable,MapPrototype["@@transducer/init"]=MapPrototype.asMutable=asMutable,MapPrototype["@@transducer/step"]=function(e,t){return e.set(t[0],t[1])},MapPrototype["@@transducer/result"]=function(e){return e.asImmutable()};var ArrayMapNode=function(e,t){this.ownerID=e,this.entries=t};ArrayMapNode.prototype.get=function(e,t,r,n){for(var i=this.entries,s=0,o=i.length;s<o;s++)if(is(r,i[s][0]))return i[s][1];return n},ArrayMapNode.prototype.update=function(e,t,r,n,i,s,o){for(var a=i===NOT_SET,u=this.entries,c=0,p=u.length;c<p&&!is(n,u[c][0]);c++);var l=c<p;if(l?u[c][1]===i:a)return this;if(SetRef(o),(a||!l)&&SetRef(s),!a||1!==u.length){if(!l&&!a&&u.length>=MAX_ARRAY_MAP_SIZE)return createNodes(e,u,n,i);var h=e&&e===this.ownerID,f=h?u:arrCopy(u);return l?a?c===p-1?f.pop():f[c]=f.pop():f[c]=[n,i]:f.push([n,i]),h?(this.entries=f,this):new ArrayMapNode(e,f)}};var BitmapIndexedNode=function(e,t,r){this.ownerID=e,this.bitmap=t,this.nodes=r};BitmapIndexedNode.prototype.get=function(e,t,r,n){void 0===t&&(t=hash(r));var i=1<<((0===e?t:t>>>e)&MASK),s=this.bitmap;return 0==(s&i)?n:this.nodes[popCount(s&i-1)].get(e+SHIFT,t,r,n)},BitmapIndexedNode.prototype.update=function(e,t,r,n,i,s,o){void 0===r&&(r=hash(n));var a=(0===t?r:r>>>t)&MASK,u=1<<a,c=this.bitmap,p=0!=(c&u);if(!p&&i===NOT_SET)return this;var l=popCount(c&u-1),h=this.nodes,f=p?h[l]:void 0,d=updateNode(f,e,t+SHIFT,r,n,i,s,o);if(d===f)return this;if(!p&&d&&h.length>=MAX_BITMAP_INDEXED_SIZE)return expandNodes(e,h,c,a,d);if(p&&!d&&2===h.length&&isLeafNode(h[1^l]))return h[1^l];if(p&&d&&1===h.length&&isLeafNode(d))return d;var m=e&&e===this.ownerID,g=p?d?c:c^u:c|u,y=p?d?setAt(h,l,d,m):spliceOut(h,l,m):spliceIn(h,l,d,m);return m?(this.bitmap=g,this.nodes=y,this):new BitmapIndexedNode(e,g,y)};var HashArrayMapNode=function(e,t,r){this.ownerID=e,this.count=t,this.nodes=r};HashArrayMapNode.prototype.get=function(e,t,r,n){void 0===t&&(t=hash(r));var i=(0===e?t:t>>>e)&MASK,s=this.nodes[i];return s?s.get(e+SHIFT,t,r,n):n},HashArrayMapNode.prototype.update=function(e,t,r,n,i,s,o){void 0===r&&(r=hash(n));var a=(0===t?r:r>>>t)&MASK,u=i===NOT_SET,c=this.nodes,p=c[a];if(u&&!p)return this;var l=updateNode(p,e,t+SHIFT,r,n,i,s,o);if(l===p)return this;var h=this.count;if(p){if(!l&&--h<MIN_HASH_ARRAY_MAP_SIZE)return packNodes(e,c,h,a)}else h++;var f=e&&e===this.ownerID,d=setAt(c,a,l,f);return f?(this.count=h,this.nodes=d,this):new HashArrayMapNode(e,h,d)};var HashCollisionNode=function(e,t,r){this.ownerID=e,this.keyHash=t,this.entries=r};HashCollisionNode.prototype.get=function(e,t,r,n){for(var i=this.entries,s=0,o=i.length;s<o;s++)if(is(r,i[s][0]))return i[s][1];return n},HashCollisionNode.prototype.update=function(e,t,r,n,i,s,o){void 0===r&&(r=hash(n));var a=i===NOT_SET;if(r!==this.keyHash)return a?this:(SetRef(o),SetRef(s),mergeIntoNode(this,e,t,r,[n,i]));for(var u=this.entries,c=0,p=u.length;c<p&&!is(n,u[c][0]);c++);var l=c<p;if(l?u[c][1]===i:a)return this;if(SetRef(o),(a||!l)&&SetRef(s),a&&2===p)return new ValueNode(e,this.keyHash,u[1^c]);var h=e&&e===this.ownerID,f=h?u:arrCopy(u);return l?a?c===p-1?f.pop():f[c]=f.pop():f[c]=[n,i]:f.push([n,i]),h?(this.entries=f,this):new HashCollisionNode(e,this.keyHash,f)};var ValueNode=function(e,t,r){this.ownerID=e,this.keyHash=t,this.entry=r};ValueNode.prototype.get=function(e,t,r,n){return is(r,this.entry[0])?this.entry[1]:n},ValueNode.prototype.update=function(e,t,r,n,i,s,o){var a=i===NOT_SET,u=is(n,this.entry[0]);return(u?i===this.entry[1]:a)?this:(SetRef(o),a?void SetRef(s):u?e&&e===this.ownerID?(this.entry[1]=i,this):new ValueNode(e,this.keyHash,[n,i]):(SetRef(s),mergeIntoNode(this,e,t,hash(n),[n,i])))},ArrayMapNode.prototype.iterate=HashCollisionNode.prototype.iterate=function(e,t){for(var r=this.entries,n=0,i=r.length-1;n<=i;n++)if(!1===e(r[t?i-n:n]))return!1},BitmapIndexedNode.prototype.iterate=HashArrayMapNode.prototype.iterate=function(e,t){for(var r=this.nodes,n=0,i=r.length-1;n<=i;n++){var s=r[t?i-n:n];if(s&&!1===s.iterate(e,t))return!1}},ValueNode.prototype.iterate=function(e,t){return e(this.entry)};var EMPTY_MAP,MapIterator=function(e){function t(e,t,r){this._type=t,this._reverse=r,this._stack=e._root&&mapIteratorFrame(e._root)}return e&&(t.__proto__=e),t.prototype=Object.create(e&&e.prototype),t.prototype.constructor=t,t.prototype.next=function(){for(var e=this._type,t=this._stack;t;){var r=t.node,n=t.index++,i=void 0;if(r.entry){if(0===n)return mapIteratorValue(e,r.entry)}else if(r.entries){if(n<=(i=r.entries.length-1))return mapIteratorValue(e,r.entries[this._reverse?i-n:n])}else if(n<=(i=r.nodes.length-1)){var s=r.nodes[this._reverse?i-n:n];if(s){if(s.entry)return mapIteratorValue(e,s.entry);t=this._stack=mapIteratorFrame(s,t)}continue}t=this._stack=this._stack.__prev}return iteratorDone()},t}(Iterator);function mapIteratorValue(e,t){return iteratorValue(e,t[0],t[1])}function mapIteratorFrame(e,t){return{node:e,index:0,__prev:t}}function makeMap(e,t,r,n){var i=Object.create(MapPrototype);return i.size=e,i._root=t,i.__ownerID=r,i.__hash=n,i.__altered=!1,i}function emptyMap(){return EMPTY_MAP||(EMPTY_MAP=makeMap(0))}function updateMap(e,t,r){var n,i;if(e._root){var s=MakeRef(),o=MakeRef();if(n=updateNode(e._root,e.__ownerID,0,void 0,t,r,s,o),!o.value)return e;i=e.size+(s.value?r===NOT_SET?-1:1:0)}else{if(r===NOT_SET)return e;i=1,n=new ArrayMapNode(e.__ownerID,[[t,r]])}return e.__ownerID?(e.size=i,e._root=n,e.__hash=void 0,e.__altered=!0,e):n?makeMap(i,n):emptyMap()}function updateNode(e,t,r,n,i,s,o,a){return e?e.update(t,r,n,i,s,o,a):s===NOT_SET?e:(SetRef(a),SetRef(o),new ValueNode(t,n,[i,s]))}function isLeafNode(e){return e.constructor===ValueNode||e.constructor===HashCollisionNode}function mergeIntoNode(e,t,r,n,i){if(e.keyHash===n)return new HashCollisionNode(t,n,[e.entry,i]);var s,o=(0===r?e.keyHash:e.keyHash>>>r)&MASK,a=(0===r?n:n>>>r)&MASK,u=o===a?[mergeIntoNode(e,t,r+SHIFT,n,i)]:(s=new ValueNode(t,n,i),o<a?[e,s]:[s,e]);return new BitmapIndexedNode(t,1<<o|1<<a,u)}function createNodes(e,t,r,n){e||(e=new OwnerID);for(var i=new ValueNode(e,hash(r),[r,n]),s=0;s<t.length;s++){var o=t[s];i=i.update(e,0,void 0,o[0],o[1])}return i}function packNodes(e,t,r,n){for(var i=0,s=0,o=new Array(r),a=0,u=1,c=t.length;a<c;a++,u<<=1){var p=t[a];void 0!==p&&a!==n&&(i|=u,o[s++]=p)}return new BitmapIndexedNode(e,i,o)}function expandNodes(e,t,r,n,i){for(var s=0,o=new Array(SIZE),a=0;0!==r;a++,r>>>=1)o[a]=1&r?t[s++]:void 0;return o[n]=i,new HashArrayMapNode(e,s+1,o)}function popCount(e){return e=(e=(858993459&(e-=e>>1&1431655765))+(e>>2&858993459))+(e>>4)&252645135,e+=e>>8,127&(e+=e>>16)}function setAt(e,t,r,n){var i=n?e:arrCopy(e);return i[t]=r,i}function spliceIn(e,t,r,n){var i=e.length+1;if(n&&t+1===i)return e[t]=r,e;for(var s=new Array(i),o=0,a=0;a<i;a++)a===t?(s[a]=r,o=-1):s[a]=e[a+o];return s}function spliceOut(e,t,r){var n=e.length-1;if(r&&t===n)return e.pop(),e;for(var i=new Array(n),s=0,o=0;o<n;o++)o===t&&(s=1),i[o]=e[o+s];return i}var MAX_ARRAY_MAP_SIZE=SIZE/4,MAX_BITMAP_INDEXED_SIZE=SIZE/2,MIN_HASH_ARRAY_MAP_SIZE=SIZE/4,IS_LIST_SYMBOL="@@__IMMUTABLE_LIST__@@";function isList(e){return Boolean(e&&e[IS_LIST_SYMBOL])}var List=function(e){function t(t){var r=emptyList();if(null==t)return r;if(isList(t))return t;var n=e(t),i=n.size;return 0===i?r:(assertNotInfinite(i),i>0&&i<SIZE?makeList(0,i,SHIFT,null,new VNode(n.toArray())):r.withMutations(function(e){e.setSize(i),n.forEach(function(t,r){return e.set(r,t)})}))}return e&&(t.__proto__=e),t.prototype=Object.create(e&&e.prototype),t.prototype.constructor=t,t.of=function(){return this(arguments)},t.prototype.toString=function(){return this.__toString("List [","]")},t.prototype.get=function(e,t){if((e=wrapIndex(this,e))>=0&&e<this.size){var r=listNodeFor(this,e+=this._origin);return r&&r.array[e&MASK]}return t},t.prototype.set=function(e,t){return updateList(this,e,t)},t.prototype.remove=function(e){return this.has(e)?0===e?this.shift():e===this.size-1?this.pop():this.splice(e,1):this},t.prototype.insert=function(e,t){return this.splice(e,0,t)},t.prototype.clear=function(){return 0===this.size?this:this.__ownerID?(this.size=this._origin=this._capacity=0,this._level=SHIFT,this._root=this._tail=null,this.__hash=void 0,this.__altered=!0,this):emptyList()},t.prototype.push=function(){var e=arguments,t=this.size;return this.withMutations(function(r){setListBounds(r,0,t+e.length);for(var n=0;n<e.length;n++)r.set(t+n,e[n])})},t.prototype.pop=function(){return setListBounds(this,0,-1)},t.prototype.unshift=function(){var e=arguments;return this.withMutations(function(t){setListBounds(t,-e.length);for(var r=0;r<e.length;r++)t.set(r,e[r])})},t.prototype.shift=function(){return setListBounds(this,1)},t.prototype.concat=function(){for(var t=arguments,r=[],n=0;n<arguments.length;n++){var i=t[n],s=e("string"!=typeof i&&hasIterator(i)?i:[i]);0!==s.size&&r.push(s)}return 0===r.length?this:0!==this.size||this.__ownerID||1!==r.length?this.withMutations(function(e){r.forEach(function(t){return t.forEach(function(t){return e.push(t)})})}):this.constructor(r[0])},t.prototype.setSize=function(e){return setListBounds(this,0,e)},t.prototype.map=function(e,t){var r=this;return this.withMutations(function(n){for(var i=0;i<r.size;i++)n.set(i,e.call(t,n.get(i),i,n))})},t.prototype.slice=function(e,t){var r=this.size;return wholeSlice(e,t,r)?this:setListBounds(this,resolveBegin(e,r),resolveEnd(t,r))},t.prototype.__iterator=function(e,t){var r=t?this.size:0,n=iterateList(this,t);return new Iterator(function(){var i=n();return i===DONE?iteratorDone():iteratorValue(e,t?--r:r++,i)})},t.prototype.__iterate=function(e,t){for(var r,n=t?this.size:0,i=iterateList(this,t);(r=i())!==DONE&&!1!==e(r,t?--n:n++,this););return n},t.prototype.__ensureOwner=function(e){return e===this.__ownerID?this:e?makeList(this._origin,this._capacity,this._level,this._root,this._tail,e,this.__hash):0===this.size?emptyList():(this.__ownerID=e,this.__altered=!1,this)},t}(IndexedCollection);List.isList=isList;var ListPrototype=List.prototype;ListPrototype[IS_LIST_SYMBOL]=!0,ListPrototype[DELETE]=ListPrototype.remove,ListPrototype.merge=ListPrototype.concat,ListPrototype.setIn=setIn$1,ListPrototype.deleteIn=ListPrototype.removeIn=deleteIn,ListPrototype.update=update$1,ListPrototype.updateIn=updateIn$1,ListPrototype.mergeIn=mergeIn,ListPrototype.mergeDeepIn=mergeDeepIn,ListPrototype.withMutations=withMutations,ListPrototype.wasAltered=wasAltered,ListPrototype.asImmutable=asImmutable,ListPrototype["@@transducer/init"]=ListPrototype.asMutable=asMutable,ListPrototype["@@transducer/step"]=function(e,t){return e.push(t)},ListPrototype["@@transducer/result"]=function(e){return e.asImmutable()};var VNode=function(e,t){this.array=e,this.ownerID=t};VNode.prototype.removeBefore=function(e,t,r){if(r===t?1<<t:0===this.array.length)return this;var n=r>>>t&MASK;if(n>=this.array.length)return new VNode([],e);var i,s=0===n;if(t>0){var o=this.array[n];if((i=o&&o.removeBefore(e,t-SHIFT,r))===o&&s)return this}if(s&&!i)return this;var a=editableVNode(this,e);if(!s)for(var u=0;u<n;u++)a.array[u]=void 0;return i&&(a.array[n]=i),a},VNode.prototype.removeAfter=function(e,t,r){if(r===(t?1<<t:0)||0===this.array.length)return this;var n,i=r-1>>>t&MASK;if(i>=this.array.length)return this;if(t>0){var s=this.array[i];if((n=s&&s.removeAfter(e,t-SHIFT,r))===s&&i===this.array.length-1)return this}var o=editableVNode(this,e);return o.array.splice(i+1),n&&(o.array[i]=n),o};var EMPTY_LIST,DONE={};function iterateList(e,t){var r=e._origin,n=e._capacity,i=getTailOffset(n),s=e._tail;return o(e._root,e._level,0);function o(e,a,u){return 0===a?function(e,o){var a=o===i?s&&s.array:e&&e.array,u=o>r?0:r-o,c=n-o;c>SIZE&&(c=SIZE);return function(){if(u===c)return DONE;var e=t?--c:u++;return a&&a[e]}}(e,u):function(e,i,s){var a,u=e&&e.array,c=s>r?0:r-s>>i,p=1+(n-s>>i);p>SIZE&&(p=SIZE);return function(){for(;;){if(a){var e=a();if(e!==DONE)return e;a=null}if(c===p)return DONE;var r=t?--p:c++;a=o(u&&u[r],i-SHIFT,s+(r<<i))}}}(e,a,u)}}function makeList(e,t,r,n,i,s,o){var a=Object.create(ListPrototype);return a.size=t-e,a._origin=e,a._capacity=t,a._level=r,a._root=n,a._tail=i,a.__ownerID=s,a.__hash=o,a.__altered=!1,a}function emptyList(){return EMPTY_LIST||(EMPTY_LIST=makeList(0,0,SHIFT))}function updateList(e,t,r){if((t=wrapIndex(e,t))!=t)return e;if(t>=e.size||t<0)return e.withMutations(function(e){t<0?setListBounds(e,t).set(0,r):setListBounds(e,0,t+1).set(t,r)});t+=e._origin;var n=e._tail,i=e._root,s=MakeRef();return t>=getTailOffset(e._capacity)?n=updateVNode(n,e.__ownerID,0,t,r,s):i=updateVNode(i,e.__ownerID,e._level,t,r,s),s.value?e.__ownerID?(e._root=i,e._tail=n,e.__hash=void 0,e.__altered=!0,e):makeList(e._origin,e._capacity,e._level,i,n):e}function updateVNode(e,t,r,n,i,s){var o,a=n>>>r&MASK,u=e&&a<e.array.length;if(!u&&void 0===i)return e;if(r>0){var c=e&&e.array[a],p=updateVNode(c,t,r-SHIFT,n,i,s);return p===c?e:((o=editableVNode(e,t)).array[a]=p,o)}return u&&e.array[a]===i?e:(s&&SetRef(s),o=editableVNode(e,t),void 0===i&&a===o.array.length-1?o.array.pop():o.array[a]=i,o)}function editableVNode(e,t){return t&&e&&t===e.ownerID?e:new VNode(e?e.array.slice():[],t)}function listNodeFor(e,t){if(t>=getTailOffset(e._capacity))return e._tail;if(t<1<<e._level+SHIFT){for(var r=e._root,n=e._level;r&&n>0;)r=r.array[t>>>n&MASK],n-=SHIFT;return r}}function setListBounds(e,t,r){void 0!==t&&(t|=0),void 0!==r&&(r|=0);var n=e.__ownerID||new OwnerID,i=e._origin,s=e._capacity,o=i+t,a=void 0===r?s:r<0?s+r:i+r;if(o===i&&a===s)return e;if(o>=a)return e.clear();for(var u=e._level,c=e._root,p=0;o+p<0;)c=new VNode(c&&c.array.length?[void 0,c]:[],n),p+=1<<(u+=SHIFT);p&&(o+=p,i+=p,a+=p,s+=p);for(var l=getTailOffset(s),h=getTailOffset(a);h>=1<<u+SHIFT;)c=new VNode(c&&c.array.length?[c]:[],n),u+=SHIFT;var f=e._tail,d=h<l?listNodeFor(e,a-1):h>l?new VNode([],n):f;if(f&&h>l&&o<s&&f.array.length){for(var m=c=editableVNode(c,n),g=u;g>SHIFT;g-=SHIFT){var y=l>>>g&MASK;m=m.array[y]=editableVNode(m.array[y],n)}m.array[l>>>SHIFT&MASK]=f}if(a<s&&(d=d&&d.removeAfter(n,0,a)),o>=h)o-=h,a-=h,u=SHIFT,c=null,d=d&&d.removeBefore(n,0,o);else if(o>i||h<l){for(p=0;c;){var v=o>>>u&MASK;if(v!==h>>>u&MASK)break;v&&(p+=(1<<u)*v),u-=SHIFT,c=c.array[v]}c&&o>i&&(c=c.removeBefore(n,u,o-p)),c&&h<l&&(c=c.removeAfter(n,u,h-p)),p&&(o-=p,a-=p)}return e.__ownerID?(e.size=a-o,e._origin=o,e._capacity=a,e._level=u,e._root=c,e._tail=d,e.__hash=void 0,e.__altered=!0,e):makeList(o,a,u,c,d)}function getTailOffset(e){return e<SIZE?0:e-1>>>SHIFT<<SHIFT}var EMPTY_ORDERED_MAP,OrderedMap=function(e){function t(e){return null==e?emptyOrderedMap():isOrderedMap(e)?e:emptyOrderedMap().withMutations(function(t){var r=KeyedCollection(e);assertNotInfinite(r.size),r.forEach(function(e,r){return t.set(r,e)})})}return e&&(t.__proto__=e),t.prototype=Object.create(e&&e.prototype),t.prototype.constructor=t,t.of=function(){return this(arguments)},t.prototype.toString=function(){return this.__toString("OrderedMap {","}")},t.prototype.get=function(e,t){var r=this._map.get(e);return void 0!==r?this._list.get(r)[1]:t},t.prototype.clear=function(){return 0===this.size?this:this.__ownerID?(this.size=0,this._map.clear(),this._list.clear(),this):emptyOrderedMap()},t.prototype.set=function(e,t){return updateOrderedMap(this,e,t)},t.prototype.remove=function(e){return updateOrderedMap(this,e,NOT_SET)},t.prototype.wasAltered=function(){return this._map.wasAltered()||this._list.wasAltered()},t.prototype.__iterate=function(e,t){var r=this;return this._list.__iterate(function(t){return t&&e(t[1],t[0],r)},t)},t.prototype.__iterator=function(e,t){return this._list.fromEntrySeq().__iterator(e,t)},t.prototype.__ensureOwner=function(e){if(e===this.__ownerID)return this;var t=this._map.__ensureOwner(e),r=this._list.__ensureOwner(e);return e?makeOrderedMap(t,r,e,this.__hash):0===this.size?emptyOrderedMap():(this.__ownerID=e,this._map=t,this._list=r,this)},t}(Map$1);function makeOrderedMap(e,t,r,n){var i=Object.create(OrderedMap.prototype);return i.size=e?e.size:0,i._map=e,i._list=t,i.__ownerID=r,i.__hash=n,i}function emptyOrderedMap(){return EMPTY_ORDERED_MAP||(EMPTY_ORDERED_MAP=makeOrderedMap(emptyMap(),emptyList()))}function updateOrderedMap(e,t,r){var n,i,s=e._map,o=e._list,a=s.get(t),u=void 0!==a;if(r===NOT_SET){if(!u)return e;o.size>=SIZE&&o.size>=2*s.size?(n=(i=o.filter(function(e,t){return void 0!==e&&a!==t})).toKeyedSeq().map(function(e){return e[0]}).flip().toMap(),e.__ownerID&&(n.__ownerID=i.__ownerID=e.__ownerID)):(n=s.remove(t),i=a===o.size-1?o.pop():o.set(a,void 0))}else if(u){if(r===o.get(a)[1])return e;n=s,i=o.set(a,[t,r])}else n=s.set(t,o.size),i=o.set(o.size,[t,r]);return e.__ownerID?(e.size=n.size,e._map=n,e._list=i,e.__hash=void 0,e):makeOrderedMap(n,i)}OrderedMap.isOrderedMap=isOrderedMap,OrderedMap.prototype[IS_ORDERED_SYMBOL]=!0,OrderedMap.prototype[DELETE]=OrderedMap.prototype.remove;var IS_STACK_SYMBOL="@@__IMMUTABLE_STACK__@@";function isStack(e){return Boolean(e&&e[IS_STACK_SYMBOL])}var Stack=function(e){function t(e){return null==e?emptyStack():isStack(e)?e:emptyStack().pushAll(e)}return e&&(t.__proto__=e),t.prototype=Object.create(e&&e.prototype),t.prototype.constructor=t,t.of=function(){return this(arguments)},t.prototype.toString=function(){return this.__toString("Stack [","]")},t.prototype.get=function(e,t){var r=this._head;for(e=wrapIndex(this,e);r&&e--;)r=r.next;return r?r.value:t},t.prototype.peek=function(){return this._head&&this._head.value},t.prototype.push=function(){var e=arguments;if(0===arguments.length)return this;for(var t=this.size+arguments.length,r=this._head,n=arguments.length-1;n>=0;n--)r={value:e[n],next:r};return this.__ownerID?(this.size=t,this._head=r,this.__hash=void 0,this.__altered=!0,this):makeStack(t,r)},t.prototype.pushAll=function(t){if(0===(t=e(t)).size)return this;if(0===this.size&&isStack(t))return t;assertNotInfinite(t.size);var r=this.size,n=this._head;return t.__iterate(function(e){r++,n={value:e,next:n}},!0),this.__ownerID?(this.size=r,this._head=n,this.__hash=void 0,this.__altered=!0,this):makeStack(r,n)},t.prototype.pop=function(){return this.slice(1)},t.prototype.clear=function(){return 0===this.size?this:this.__ownerID?(this.size=0,this._head=void 0,this.__hash=void 0,this.__altered=!0,this):emptyStack()},t.prototype.slice=function(t,r){if(wholeSlice(t,r,this.size))return this;var n=resolveBegin(t,this.size);if(resolveEnd(r,this.size)!==this.size)return e.prototype.slice.call(this,t,r);for(var i=this.size-n,s=this._head;n--;)s=s.next;return this.__ownerID?(this.size=i,this._head=s,this.__hash=void 0,this.__altered=!0,this):makeStack(i,s)},t.prototype.__ensureOwner=function(e){return e===this.__ownerID?this:e?makeStack(this.size,this._head,e,this.__hash):0===this.size?emptyStack():(this.__ownerID=e,this.__altered=!1,this)},t.prototype.__iterate=function(e,t){var r=this;if(t)return new ArraySeq(this.toArray()).__iterate(function(t,n){return e(t,n,r)},t);for(var n=0,i=this._head;i&&!1!==e(i.value,n++,this);)i=i.next;return n},t.prototype.__iterator=function(e,t){if(t)return new ArraySeq(this.toArray()).__iterator(e,t);var r=0,n=this._head;return new Iterator(function(){if(n){var t=n.value;return n=n.next,iteratorValue(e,r++,t)}return iteratorDone()})},t}(IndexedCollection);Stack.isStack=isStack;var EMPTY_STACK,StackPrototype=Stack.prototype;function makeStack(e,t,r,n){var i=Object.create(StackPrototype);return i.size=e,i._head=t,i.__ownerID=r,i.__hash=n,i.__altered=!1,i}function emptyStack(){return EMPTY_STACK||(EMPTY_STACK=makeStack(0))}StackPrototype[IS_STACK_SYMBOL]=!0,StackPrototype.shift=StackPrototype.pop,StackPrototype.unshift=StackPrototype.push,StackPrototype.unshiftAll=StackPrototype.pushAll,StackPrototype.withMutations=withMutations,StackPrototype.wasAltered=wasAltered,StackPrototype.asImmutable=asImmutable,StackPrototype["@@transducer/init"]=StackPrototype.asMutable=asMutable,StackPrototype["@@transducer/step"]=function(e,t){return e.unshift(t)},StackPrototype["@@transducer/result"]=function(e){return e.asImmutable()};var IS_SET_SYMBOL="@@__IMMUTABLE_SET__@@";function isSet(e){return Boolean(e&&e[IS_SET_SYMBOL])}function isOrderedSet(e){return isSet(e)&&isOrdered(e)}function deepEqual(e,t){if(e===t)return!0;if(!isCollection(t)||void 0!==e.size&&void 0!==t.size&&e.size!==t.size||void 0!==e.__hash&&void 0!==t.__hash&&e.__hash!==t.__hash||isKeyed(e)!==isKeyed(t)||isIndexed(e)!==isIndexed(t)||isOrdered(e)!==isOrdered(t))return!1;if(0===e.size&&0===t.size)return!0;var r=!isAssociative(e);if(isOrdered(e)){var n=e.entries();return t.every(function(e,t){var i=n.next().value;return i&&is(i[1],e)&&(r||is(i[0],t))})&&n.next().done}var i=!1;if(void 0===e.size)if(void 0===t.size)"function"==typeof e.cacheResult&&e.cacheResult();else{i=!0;var s=e;e=t,t=s}var o=!0,a=t.__iterate(function(t,n){if(r?!e.has(t):i?!is(t,e.get(n,NOT_SET)):!is(e.get(n,NOT_SET),t))return o=!1,!1});return o&&e.size===a}function mixin(e,t){var r=function(r){e.prototype[r]=t[r]};return Object.keys(t).forEach(r),Object.getOwnPropertySymbols&&Object.getOwnPropertySymbols(t).forEach(r),e}function toJS(e){if(!e||"object"!=typeof e)return e;if(!isCollection(e)){if(!isDataStructure(e))return e;e=Seq(e)}if(isKeyed(e)){var t={};return e.__iterate(function(e,r){t[r]=toJS(e)}),t}var r=[];return e.__iterate(function(e){r.push(toJS(e))}),r}var Set$1=function(e){function t(t){return null==t?emptySet():isSet(t)&&!isOrdered(t)?t:emptySet().withMutations(function(r){var n=e(t);assertNotInfinite(n.size),n.forEach(function(e){return r.add(e)})})}return e&&(t.__proto__=e),t.prototype=Object.create(e&&e.prototype),t.prototype.constructor=t,t.of=function(){return this(arguments)},t.fromKeys=function(e){return this(KeyedCollection(e).keySeq())},t.intersect=function(e){return(e=Collection(e).toArray()).length?SetPrototype.intersect.apply(t(e.pop()),e):emptySet()},t.union=function(e){return(e=Collection(e).toArray()).length?SetPrototype.union.apply(t(e.pop()),e):emptySet()},t.prototype.toString=function(){return this.__toString("Set {","}")},t.prototype.has=function(e){return this._map.has(e)},t.prototype.add=function(e){return updateSet(this,this._map.set(e,e))},t.prototype.remove=function(e){return updateSet(this,this._map.remove(e))},t.prototype.clear=function(){return updateSet(this,this._map.clear())},t.prototype.map=function(e,t){var r=this,n=[],i=[];return this.forEach(function(s){var o=e.call(t,s,s,r);o!==s&&(n.push(s),i.push(o))}),this.withMutations(function(e){n.forEach(function(t){return e.remove(t)}),i.forEach(function(t){return e.add(t)})})},t.prototype.union=function(){for(var t=[],r=arguments.length;r--;)t[r]=arguments[r];return 0===(t=t.filter(function(e){return 0!==e.size})).length?this:0!==this.size||this.__ownerID||1!==t.length?this.withMutations(function(r){for(var n=0;n<t.length;n++)e(t[n]).forEach(function(e){return r.add(e)})}):this.constructor(t[0])},t.prototype.intersect=function(){for(var t=[],r=arguments.length;r--;)t[r]=arguments[r];if(0===t.length)return this;t=t.map(function(t){return e(t)});var n=[];return this.forEach(function(e){t.every(function(t){return t.includes(e)})||n.push(e)}),this.withMutations(function(e){n.forEach(function(t){e.remove(t)})})},t.prototype.subtract=function(){for(var t=[],r=arguments.length;r--;)t[r]=arguments[r];if(0===t.length)return this;t=t.map(function(t){return e(t)});var n=[];return this.forEach(function(e){t.some(function(t){return t.includes(e)})&&n.push(e)}),this.withMutations(function(e){n.forEach(function(t){e.remove(t)})})},t.prototype.sort=function(e){return OrderedSet(sortFactory(this,e))},t.prototype.sortBy=function(e,t){return OrderedSet(sortFactory(this,t,e))},t.prototype.wasAltered=function(){return this._map.wasAltered()},t.prototype.__iterate=function(e,t){var r=this;return this._map.__iterate(function(t){return e(t,t,r)},t)},t.prototype.__iterator=function(e,t){return this._map.__iterator(e,t)},t.prototype.__ensureOwner=function(e){if(e===this.__ownerID)return this;var t=this._map.__ensureOwner(e);return e?this.__make(t,e):0===this.size?this.__empty():(this.__ownerID=e,this._map=t,this)},t}(SetCollection);Set$1.isSet=isSet;var EMPTY_SET,SetPrototype=Set$1.prototype;function updateSet(e,t){return e.__ownerID?(e.size=t.size,e._map=t,e):t===e._map?e:0===t.size?e.__empty():e.__make(t)}function makeSet(e,t){var r=Object.create(SetPrototype);return r.size=e?e.size:0,r._map=e,r.__ownerID=t,r}function emptySet(){return EMPTY_SET||(EMPTY_SET=makeSet(emptyMap()))}SetPrototype[IS_SET_SYMBOL]=!0,SetPrototype[DELETE]=SetPrototype.remove,SetPrototype.merge=SetPrototype.concat=SetPrototype.union,SetPrototype.withMutations=withMutations,SetPrototype.asImmutable=asImmutable,SetPrototype["@@transducer/init"]=SetPrototype.asMutable=asMutable,SetPrototype["@@transducer/step"]=function(e,t){return e.add(t)},SetPrototype["@@transducer/result"]=function(e){return e.asImmutable()},SetPrototype.__empty=emptySet,SetPrototype.__make=makeSet;var EMPTY_RANGE,Range=function(e){function t(e,r,n){if(!(this instanceof t))return new t(e,r,n);if(invariant(0!==n,"Cannot step a Range by 0"),e=e||0,void 0===r&&(r=1/0),n=void 0===n?1:Math.abs(n),r<e&&(n=-n),this._start=e,this._end=r,this._step=n,this.size=Math.max(0,Math.ceil((r-e)/n-1)+1),0===this.size){if(EMPTY_RANGE)return EMPTY_RANGE;EMPTY_RANGE=this}}return e&&(t.__proto__=e),t.prototype=Object.create(e&&e.prototype),t.prototype.constructor=t,t.prototype.toString=function(){return 0===this.size?"Range []":"Range [ "+this._start+"..."+this._end+(1!==this._step?" by "+this._step:"")+" ]"},t.prototype.get=function(e,t){return this.has(e)?this._start+wrapIndex(this,e)*this._step:t},t.prototype.includes=function(e){var t=(e-this._start)/this._step;return t>=0&&t<this.size&&t===Math.floor(t)},t.prototype.slice=function(e,r){return wholeSlice(e,r,this.size)?this:(e=resolveBegin(e,this.size),(r=resolveEnd(r,this.size))<=e?new t(0,0):new t(this.get(e,this._end),this.get(r,this._end),this._step))},t.prototype.indexOf=function(e){var t=e-this._start;if(t%this._step==0){var r=t/this._step;if(r>=0&&r<this.size)return r}return-1},t.prototype.lastIndexOf=function(e){return this.indexOf(e)},t.prototype.__iterate=function(e,t){for(var r=this.size,n=this._step,i=t?this._start+(r-1)*n:this._start,s=0;s!==r&&!1!==e(i,t?r-++s:s++,this);)i+=t?-n:n;return s},t.prototype.__iterator=function(e,t){var r=this.size,n=this._step,i=t?this._start+(r-1)*n:this._start,s=0;return new Iterator(function(){if(s===r)return iteratorDone();var o=i;return i+=t?-n:n,iteratorValue(e,t?r-++s:s++,o)})},t.prototype.equals=function(e){return e instanceof t?this._start===e._start&&this._end===e._end&&this._step===e._step:deepEqual(this,e)},t}(IndexedSeq);function getIn(e,t,r){for(var n=coerceKeyPath(t),i=0;i!==n.length;)if((e=get(e,n[i++],NOT_SET))===NOT_SET)return r;return e}function getIn$1(e,t){return getIn(this,e,t)}function hasIn(e,t){return getIn(e,t,NOT_SET)!==NOT_SET}function hasIn$1(e){return hasIn(this,e)}function toObject(){assertNotInfinite(this.size);var e={};return this.__iterate(function(t,r){e[r]=t}),e}Collection.isIterable=isCollection,Collection.isKeyed=isKeyed,Collection.isIndexed=isIndexed,Collection.isAssociative=isAssociative,Collection.isOrdered=isOrdered,Collection.Iterator=Iterator,mixin(Collection,{toArray:function(){assertNotInfinite(this.size);var e=new Array(this.size||0),t=isKeyed(this),r=0;return this.__iterate(function(n,i){e[r++]=t?[i,n]:n}),e},toIndexedSeq:function(){return new ToIndexedSequence(this)},toJS:function(){return toJS(this)},toKeyedSeq:function(){return new ToKeyedSequence(this,!0)},toMap:function(){return Map$1(this.toKeyedSeq())},toObject:toObject,toOrderedMap:function(){return OrderedMap(this.toKeyedSeq())},toOrderedSet:function(){return OrderedSet(isKeyed(this)?this.valueSeq():this)},toSet:function(){return Set$1(isKeyed(this)?this.valueSeq():this)},toSetSeq:function(){return new ToSetSequence(this)},toSeq:function(){return isIndexed(this)?this.toIndexedSeq():isKeyed(this)?this.toKeyedSeq():this.toSetSeq()},toStack:function(){return Stack(isKeyed(this)?this.valueSeq():this)},toList:function(){return List(isKeyed(this)?this.valueSeq():this)},toString:function(){return"[Collection]"},__toString:function(e,t){return 0===this.size?e+t:e+" "+this.toSeq().map(this.__toStringMapper).join(", ")+" "+t},concat:function(){for(var e=[],t=arguments.length;t--;)e[t]=arguments[t];return reify(this,concatFactory(this,e))},includes:function(e){return this.some(function(t){return is(t,e)})},entries:function(){return this.__iterator(ITERATE_ENTRIES)},every:function(e,t){assertNotInfinite(this.size);var r=!0;return this.__iterate(function(n,i,s){if(!e.call(t,n,i,s))return r=!1,!1}),r},filter:function(e,t){return reify(this,filterFactory(this,e,t,!0))},find:function(e,t,r){var n=this.findEntry(e,t);return n?n[1]:r},forEach:function(e,t){return assertNotInfinite(this.size),this.__iterate(t?e.bind(t):e)},join:function(e){assertNotInfinite(this.size),e=void 0!==e?""+e:",";var t="",r=!0;return this.__iterate(function(n){r?r=!1:t+=e,t+=null!=n?n.toString():""}),t},keys:function(){return this.__iterator(ITERATE_KEYS)},map:function(e,t){return reify(this,mapFactory(this,e,t))},reduce:function(e,t,r){return reduce(this,e,t,r,arguments.length<2,!1)},reduceRight:function(e,t,r){return reduce(this,e,t,r,arguments.length<2,!0)},reverse:function(){return reify(this,reverseFactory(this,!0))},slice:function(e,t){return reify(this,sliceFactory(this,e,t,!0))},some:function(e,t){return!this.every(not(e),t)},sort:function(e){return reify(this,sortFactory(this,e))},values:function(){return this.__iterator(ITERATE_VALUES)},butLast:function(){return this.slice(0,-1)},isEmpty:function(){return void 0!==this.size?0===this.size:!this.some(function(){return!0})},count:function(e,t){return ensureSize(e?this.toSeq().filter(e,t):this)},countBy:function(e,t){return countByFactory(this,e,t)},equals:function(e){return deepEqual(this,e)},entrySeq:function(){var e=this;if(e._cache)return new ArraySeq(e._cache);var t=e.toSeq().map(entryMapper).toIndexedSeq();return t.fromEntrySeq=function(){return e.toSeq()},t},filterNot:function(e,t){return this.filter(not(e),t)},findEntry:function(e,t,r){var n=r;return this.__iterate(function(r,i,s){if(e.call(t,r,i,s))return n=[i,r],!1}),n},findKey:function(e,t){var r=this.findEntry(e,t);return r&&r[0]},findLast:function(e,t,r){return this.toKeyedSeq().reverse().find(e,t,r)},findLastEntry:function(e,t,r){return this.toKeyedSeq().reverse().findEntry(e,t,r)},findLastKey:function(e,t){return this.toKeyedSeq().reverse().findKey(e,t)},first:function(e){return this.find(returnTrue,null,e)},flatMap:function(e,t){return reify(this,flatMapFactory(this,e,t))},flatten:function(e){return reify(this,flattenFactory(this,e,!0))},fromEntrySeq:function(){return new FromEntriesSequence(this)},get:function(e,t){return this.find(function(t,r){return is(r,e)},void 0,t)},getIn:getIn$1,groupBy:function(e,t){return groupByFactory(this,e,t)},has:function(e){return this.get(e,NOT_SET)!==NOT_SET},hasIn:hasIn$1,isSubset:function(e){return e="function"==typeof e.includes?e:Collection(e),this.every(function(t){return e.includes(t)})},isSuperset:function(e){return(e="function"==typeof e.isSubset?e:Collection(e)).isSubset(this)},keyOf:function(e){return this.findKey(function(t){return is(t,e)})},keySeq:function(){return this.toSeq().map(keyMapper).toIndexedSeq()},last:function(e){return this.toSeq().reverse().first(e)},lastKeyOf:function(e){return this.toKeyedSeq().reverse().keyOf(e)},max:function(e){return maxFactory(this,e)},maxBy:function(e,t){return maxFactory(this,t,e)},min:function(e){return maxFactory(this,e?neg(e):defaultNegComparator)},minBy:function(e,t){return maxFactory(this,t?neg(t):defaultNegComparator,e)},rest:function(){return this.slice(1)},skip:function(e){return 0===e?this:this.slice(Math.max(0,e))},skipLast:function(e){return 0===e?this:this.slice(0,-Math.max(0,e))},skipWhile:function(e,t){return reify(this,skipWhileFactory(this,e,t,!0))},skipUntil:function(e,t){return this.skipWhile(not(e),t)},sortBy:function(e,t){return reify(this,sortFactory(this,t,e))},take:function(e){return this.slice(0,Math.max(0,e))},takeLast:function(e){return this.slice(-Math.max(0,e))},takeWhile:function(e,t){return reify(this,takeWhileFactory(this,e,t))},takeUntil:function(e,t){return this.takeWhile(not(e),t)},update:function(e){return e(this)},valueSeq:function(){return this.toIndexedSeq()},hashCode:function(){return this.__hash||(this.__hash=hashCollection(this))}});var CollectionPrototype=Collection.prototype;CollectionPrototype[IS_COLLECTION_SYMBOL]=!0,CollectionPrototype[ITERATOR_SYMBOL]=CollectionPrototype.values,CollectionPrototype.toJSON=CollectionPrototype.toArray,CollectionPrototype.__toStringMapper=quoteString,CollectionPrototype.inspect=CollectionPrototype.toSource=function(){return this.toString()},CollectionPrototype.chain=CollectionPrototype.flatMap,CollectionPrototype.contains=CollectionPrototype.includes,mixin(KeyedCollection,{flip:function(){return reify(this,flipFactory(this))},mapEntries:function(e,t){var r=this,n=0;return reify(this,this.toSeq().map(function(i,s){return e.call(t,[s,i],n++,r)}).fromEntrySeq())},mapKeys:function(e,t){var r=this;return reify(this,this.toSeq().flip().map(function(n,i){return e.call(t,n,i,r)}).flip())}});var KeyedCollectionPrototype=KeyedCollection.prototype;KeyedCollectionPrototype[IS_KEYED_SYMBOL]=!0,KeyedCollectionPrototype[ITERATOR_SYMBOL]=CollectionPrototype.entries,KeyedCollectionPrototype.toJSON=toObject,KeyedCollectionPrototype.__toStringMapper=function(e,t){return quoteString(t)+": "+quoteString(e)},mixin(IndexedCollection,{toKeyedSeq:function(){return new ToKeyedSequence(this,!1)},filter:function(e,t){return reify(this,filterFactory(this,e,t,!1))},findIndex:function(e,t){var r=this.findEntry(e,t);return r?r[0]:-1},indexOf:function(e){var t=this.keyOf(e);return void 0===t?-1:t},lastIndexOf:function(e){var t=this.lastKeyOf(e);return void 0===t?-1:t},reverse:function(){return reify(this,reverseFactory(this,!1))},slice:function(e,t){return reify(this,sliceFactory(this,e,t,!1))},splice:function(e,t){var r=arguments.length;if(t=Math.max(t||0,0),0===r||2===r&&!t)return this;e=resolveBegin(e,e<0?this.count():this.size);var n=this.slice(0,e);return reify(this,1===r?n:n.concat(arrCopy(arguments,2),this.slice(e+t)))},findLastIndex:function(e,t){var r=this.findLastEntry(e,t);return r?r[0]:-1},first:function(e){return this.get(0,e)},flatten:function(e){return reify(this,flattenFactory(this,e,!1))},get:function(e,t){return(e=wrapIndex(this,e))<0||this.size===1/0||void 0!==this.size&&e>this.size?t:this.find(function(t,r){return r===e},void 0,t)},has:function(e){return(e=wrapIndex(this,e))>=0&&(void 0!==this.size?this.size===1/0||e<this.size:-1!==this.indexOf(e))},interpose:function(e){return reify(this,interposeFactory(this,e))},interleave:function(){var e=[this].concat(arrCopy(arguments)),t=zipWithFactory(this.toSeq(),IndexedSeq.of,e),r=t.flatten(!0);return t.size&&(r.size=t.size*e.length),reify(this,r)},keySeq:function(){return Range(0,this.size)},last:function(e){return this.get(-1,e)},skipWhile:function(e,t){return reify(this,skipWhileFactory(this,e,t,!1))},zip:function(){return reify(this,zipWithFactory(this,defaultZipper,[this].concat(arrCopy(arguments))))},zipAll:function(){return reify(this,zipWithFactory(this,defaultZipper,[this].concat(arrCopy(arguments)),!0))},zipWith:function(e){var t=arrCopy(arguments);return t[0]=this,reify(this,zipWithFactory(this,e,t))}});var IndexedCollectionPrototype=IndexedCollection.prototype;function reduce(e,t,r,n,i,s){return assertNotInfinite(e.size),e.__iterate(function(e,s,o){i?(i=!1,r=e):r=t.call(n,r,e,s,o)},s),r}function keyMapper(e,t){return t}function entryMapper(e,t){return[t,e]}function not(e){return function(){return!e.apply(this,arguments)}}function neg(e){return function(){return-e.apply(this,arguments)}}function defaultZipper(){return arrCopy(arguments)}function defaultNegComparator(e,t){return e<t?1:e>t?-1:0}function hashCollection(e){if(e.size===1/0)return 0;var t=isOrdered(e),r=isKeyed(e),n=t?1:0;return murmurHashOfSize(e.__iterate(r?t?function(e,t){n=31*n+hashMerge(hash(e),hash(t))|0}:function(e,t){n=n+hashMerge(hash(e),hash(t))|0}:t?function(e){n=31*n+hash(e)|0}:function(e){n=n+hash(e)|0}),n)}function murmurHashOfSize(e,t){return t=imul(t,3432918353),t=imul(t<<15|t>>>-15,461845907),t=imul(t<<13|t>>>-13,5),t=imul((t=(t+3864292196|0)^e)^t>>>16,2246822507),t=smi((t=imul(t^t>>>13,3266489909))^t>>>16)}function hashMerge(e,t){return e^t+2654435769+(e<<6)+(e>>2)|0}IndexedCollectionPrototype[IS_INDEXED_SYMBOL]=!0,IndexedCollectionPrototype[IS_ORDERED_SYMBOL]=!0,mixin(SetCollection,{get:function(e,t){return this.has(e)?e:t},includes:function(e){return this.has(e)},keySeq:function(){return this.valueSeq()}}),SetCollection.prototype.has=CollectionPrototype.includes,SetCollection.prototype.contains=SetCollection.prototype.includes,mixin(KeyedSeq,KeyedCollection.prototype),mixin(IndexedSeq,IndexedCollection.prototype),mixin(SetSeq,SetCollection.prototype);var OrderedSet=function(e){function t(e){return null==e?emptyOrderedSet():isOrderedSet(e)?e:emptyOrderedSet().withMutations(function(t){var r=SetCollection(e);assertNotInfinite(r.size),r.forEach(function(e){return t.add(e)})})}return e&&(t.__proto__=e),t.prototype=Object.create(e&&e.prototype),t.prototype.constructor=t,t.of=function(){return this(arguments)},t.fromKeys=function(e){return this(KeyedCollection(e).keySeq())},t.prototype.toString=function(){return this.__toString("OrderedSet {","}")},t}(Set$1);OrderedSet.isOrderedSet=isOrderedSet;var EMPTY_ORDERED_SET,OrderedSetPrototype=OrderedSet.prototype;function makeOrderedSet(e,t){var r=Object.create(OrderedSetPrototype);return r.size=e?e.size:0,r._map=e,r.__ownerID=t,r}function emptyOrderedSet(){return EMPTY_ORDERED_SET||(EMPTY_ORDERED_SET=makeOrderedSet(emptyOrderedMap()))}OrderedSetPrototype[IS_ORDERED_SYMBOL]=!0,OrderedSetPrototype.zip=IndexedCollectionPrototype.zip,OrderedSetPrototype.zipWith=IndexedCollectionPrototype.zipWith,OrderedSetPrototype.__empty=emptyOrderedSet,OrderedSetPrototype.__make=makeOrderedSet;var Record=function(e,t){var r,n=function(s){var o=this;if(s instanceof n)return s;if(!(this instanceof n))return new n(s);if(!r){r=!0;var a=Object.keys(e),u=i._indices={};i._name=t,i._keys=a,i._defaultValues=e;for(var c=0;c<a.length;c++){var p=a[c];u[p]=c,i[p]?"object"==typeof console&&console.warn&&console.warn("Cannot define "+recordName(this)+' with property "'+p+'" since that property name is part of the Record API.'):setProp(i,p)}}this.__ownerID=void 0,this._values=List().withMutations(function(e){e.setSize(o._keys.length),KeyedCollection(s).forEach(function(t,r){e.set(o._indices[r],t===o._defaultValues[r]?void 0:t)})})},i=n.prototype=Object.create(RecordPrototype);return i.constructor=n,t&&(n.displayName=t),n};Record.prototype.toString=function(){for(var e,t=recordName(this)+" { ",r=this._keys,n=0,i=r.length;n!==i;n++)t+=(n?", ":"")+(e=r[n])+": "+quoteString(this.get(e));return t+" }"},Record.prototype.equals=function(e){return this===e||e&&this._keys===e._keys&&recordSeq(this).equals(recordSeq(e))},Record.prototype.hashCode=function(){return recordSeq(this).hashCode()},Record.prototype.has=function(e){return this._indices.hasOwnProperty(e)},Record.prototype.get=function(e,t){if(!this.has(e))return t;var r=this._indices[e],n=this._values.get(r);return void 0===n?this._defaultValues[e]:n},Record.prototype.set=function(e,t){if(this.has(e)){var r=this._values.set(this._indices[e],t===this._defaultValues[e]?void 0:t);if(r!==this._values&&!this.__ownerID)return makeRecord(this,r)}return this},Record.prototype.remove=function(e){return this.set(e)},Record.prototype.clear=function(){var e=this._values.clear().setSize(this._keys.length);return this.__ownerID?this:makeRecord(this,e)},Record.prototype.wasAltered=function(){return this._values.wasAltered()},Record.prototype.toSeq=function(){return recordSeq(this)},Record.prototype.toJS=function(){return toJS(this)},Record.prototype.entries=function(){return this.__iterator(ITERATE_ENTRIES)},Record.prototype.__iterator=function(e,t){return recordSeq(this).__iterator(e,t)},Record.prototype.__iterate=function(e,t){return recordSeq(this).__iterate(e,t)},Record.prototype.__ensureOwner=function(e){if(e===this.__ownerID)return this;var t=this._values.__ensureOwner(e);return e?makeRecord(this,t,e):(this.__ownerID=e,this._values=t,this)},Record.isRecord=isRecord,Record.getDescriptiveName=recordName;var RecordPrototype=Record.prototype;function makeRecord(e,t,r){var n=Object.create(Object.getPrototypeOf(e));return n._values=t,n.__ownerID=r,n}function recordName(e){return e.constructor.displayName||e.constructor.name||"Record"}function recordSeq(e){return keyedSeqFromValue(e._keys.map(function(t){return[t,e.get(t)]}))}function setProp(e,t){try{Object.defineProperty(e,t,{get:function(){return this.get(t)},set:function(e){invariant(this.__ownerID,"Cannot set on an immutable record."),this.set(t,e)}})}catch(e){}}RecordPrototype[IS_RECORD_SYMBOL]=!0,RecordPrototype[DELETE]=RecordPrototype.remove,RecordPrototype.deleteIn=RecordPrototype.removeIn=deleteIn,RecordPrototype.getIn=getIn$1,RecordPrototype.hasIn=CollectionPrototype.hasIn,RecordPrototype.merge=merge,RecordPrototype.mergeWith=mergeWith,RecordPrototype.mergeIn=mergeIn,RecordPrototype.mergeDeep=mergeDeep$1,RecordPrototype.mergeDeepWith=mergeDeepWith$1,RecordPrototype.mergeDeepIn=mergeDeepIn,RecordPrototype.setIn=setIn$1,RecordPrototype.update=update$1,RecordPrototype.updateIn=updateIn$1,RecordPrototype.withMutations=withMutations,RecordPrototype.asMutable=asMutable,RecordPrototype.asImmutable=asImmutable,RecordPrototype[ITERATOR_SYMBOL]=RecordPrototype.entries,RecordPrototype.toJSON=RecordPrototype.toObject=CollectionPrototype.toObject,RecordPrototype.inspect=RecordPrototype.toSource=function(){return this.toString()};var EMPTY_REPEAT,Repeat=function(e){function t(e,r){if(!(this instanceof t))return new t(e,r);if(this._value=e,this.size=void 0===r?1/0:Math.max(0,r),0===this.size){if(EMPTY_REPEAT)return EMPTY_REPEAT;EMPTY_REPEAT=this}}return e&&(t.__proto__=e),t.prototype=Object.create(e&&e.prototype),t.prototype.constructor=t,t.prototype.toString=function(){return 0===this.size?"Repeat []":"Repeat [ "+this._value+" "+this.size+" times ]"},t.prototype.get=function(e,t){return this.has(e)?this._value:t},t.prototype.includes=function(e){return is(this._value,e)},t.prototype.slice=function(e,r){var n=this.size;return wholeSlice(e,r,n)?this:new t(this._value,resolveEnd(r,n)-resolveBegin(e,n))},t.prototype.reverse=function(){return this},t.prototype.indexOf=function(e){return is(this._value,e)?0:-1},t.prototype.lastIndexOf=function(e){return is(this._value,e)?this.size:-1},t.prototype.__iterate=function(e,t){for(var r=this.size,n=0;n!==r&&!1!==e(this._value,t?r-++n:n++,this););return n},t.prototype.__iterator=function(e,t){var r=this,n=this.size,i=0;return new Iterator(function(){return i===n?iteratorDone():iteratorValue(e,t?n-++i:i++,r._value)})},t.prototype.equals=function(e){return e instanceof t?is(this._value,e._value):deepEqual(e)},t}(IndexedSeq);function fromJS(e,t){return fromJSWith([],t||defaultConverter,e,"",t&&t.length>2?[]:void 0,{"":e})}function fromJSWith(e,t,r,n,i,s){var o=Array.isArray(r)?IndexedSeq:isPlainObj(r)?KeyedSeq:null;if(o){if(~e.indexOf(r))throw new TypeError("Cannot convert circular structure to Immutable");e.push(r),i&&""!==n&&i.push(n);var a=t.call(s,n,o(r).map(function(n,s){return fromJSWith(e,t,n,s,i,r)}),i&&i.slice());return e.pop(),i&&i.pop(),a}return r}function defaultConverter(e,t){return isKeyed(t)?t.toMap():t.toList()}var OptionTypes,version$1$1="4.0.0-rc.11",Immutable={version:version$1$1,Collection:Collection,Iterable:Collection,Seq:Seq,Map:Map$1,OrderedMap:OrderedMap,List:List,Stack:Stack,Set:Set$1,OrderedSet:OrderedSet,Record:Record,Range:Range,Repeat:Repeat,is:is,fromJS:fromJS,hash:hash,isImmutable:isImmutable,isCollection:isCollection,isKeyed:isKeyed,isIndexed:isIndexed,isAssociative:isAssociative,isOrdered:isOrdered,isValueObject:isValueObject,isSeq:isSeq,isList:isList,isMap:isMap,isOrderedMap:isOrderedMap,isStack:isStack,isSet:isSet,isOrderedSet:isOrderedSet,isRecord:isRecord,get:get,getIn:getIn,has:has$1,hasIn:hasIn,merge:merge$1,mergeDeep:mergeDeep,mergeWith:mergeWith$1,mergeDeepWith:mergeDeepWith,remove:remove,removeIn:removeIn,set:set,setIn:setIn,update:update,updateIn:updateIn};!function(e){e[e.IGNORED_LABELS=0]="IGNORED_LABELS",e[e.ACCESSED_NODES=1]="ACCESSED_NODES",e[e.ARGUMENTS_VARIABLES=2]="ARGUMENTS_VARIABLES",e[e.ASSIGNED_NODES=3]="ASSIGNED_NODES",e[e.IGNORE_BREAK_STATEMENTS=4]="IGNORE_BREAK_STATEMENTS",e[e.IGNORE_RETURN_AWAIT_YIELD=5]="IGNORE_RETURN_AWAIT_YIELD",e[e.NODES_CALLED_AT_PATH_WITH_OPTIONS=6]="NODES_CALLED_AT_PATH_WITH_OPTIONS",e[e.REPLACED_VARIABLE_INITS=7]="REPLACED_VARIABLE_INITS",e[e.RETURN_EXPRESSIONS_ACCESSED_AT_PATH=8]="RETURN_EXPRESSIONS_ACCESSED_AT_PATH",e[e.RETURN_EXPRESSIONS_ASSIGNED_AT_PATH=9]="RETURN_EXPRESSIONS_ASSIGNED_AT_PATH",e[e.RETURN_EXPRESSIONS_CALLED_AT_PATH=10]="RETURN_EXPRESSIONS_CALLED_AT_PATH"}(OptionTypes||(OptionTypes={}));var RESULT_KEY={},ExecutionPathOptions=function(){function e(e){this.optionValues=e}return e.create=function(){return new this(Immutable.Map())},e.prototype.addAccessedNodeAtPath=function(e,t){return this.setIn([OptionTypes.ACCESSED_NODES,t].concat(e,[RESULT_KEY]),!0)},e.prototype.addAccessedReturnExpressionAtPath=function(e,t){return this.setIn([OptionTypes.RETURN_EXPRESSIONS_ACCESSED_AT_PATH,t].concat(e,[RESULT_KEY]),!0)},e.prototype.addAssignedNodeAtPath=function(e,t){return this.setIn([OptionTypes.ASSIGNED_NODES,t].concat(e,[RESULT_KEY]),!0)},e.prototype.addAssignedReturnExpressionAtPath=function(e,t){return this.setIn([OptionTypes.RETURN_EXPRESSIONS_ASSIGNED_AT_PATH,t].concat(e,[RESULT_KEY]),!0)},e.prototype.addCalledNodeAtPathWithOptions=function(e,t,r){return this.setIn([OptionTypes.NODES_CALLED_AT_PATH_WITH_OPTIONS,t].concat(e,[RESULT_KEY,r]),!0)},e.prototype.addCalledReturnExpressionAtPath=function(e,t){return this.setIn([OptionTypes.RETURN_EXPRESSIONS_CALLED_AT_PATH,t].concat(e,[RESULT_KEY]),!0)},e.prototype.getArgumentsVariables=function(){return this.get(OptionTypes.ARGUMENTS_VARIABLES)||[]},e.prototype.getHasEffectsWhenCalledOptions=function(){return this.setIgnoreReturnAwaitYield().setIgnoreBreakStatements(!1).setIgnoreNoLabels()},e.prototype.getReplacedVariableInit=function(e){return this.optionValues.getIn([OptionTypes.REPLACED_VARIABLE_INITS,e])},e.prototype.hasNodeBeenAccessedAtPath=function(e,t){return this.optionValues.getIn([OptionTypes.ACCESSED_NODES,t].concat(e,[RESULT_KEY]))},e.prototype.hasNodeBeenAssignedAtPath=function(e,t){return this.optionValues.getIn([OptionTypes.ASSIGNED_NODES,t].concat(e,[RESULT_KEY]))},e.prototype.hasNodeBeenCalledAtPathWithOptions=function(e,t,r){var n=this.optionValues.getIn([OptionTypes.NODES_CALLED_AT_PATH_WITH_OPTIONS,t].concat(e,[RESULT_KEY]));return n&&n.find(function(e,t){return t.equals(r)})},e.prototype.hasReturnExpressionBeenAccessedAtPath=function(e,t){return this.optionValues.getIn([OptionTypes.RETURN_EXPRESSIONS_ACCESSED_AT_PATH,t].concat(e,[RESULT_KEY]))},e.prototype.hasReturnExpressionBeenAssignedAtPath=function(e,t){return this.optionValues.getIn([OptionTypes.RETURN_EXPRESSIONS_ASSIGNED_AT_PATH,t].concat(e,[RESULT_KEY]))},e.prototype.hasReturnExpressionBeenCalledAtPath=function(e,t){return this.optionValues.getIn([OptionTypes.RETURN_EXPRESSIONS_CALLED_AT_PATH,t].concat(e,[RESULT_KEY]))},e.prototype.ignoreBreakStatements=function(){return this.get(OptionTypes.IGNORE_BREAK_STATEMENTS)},e.prototype.ignoreLabel=function(e){return this.optionValues.getIn([OptionTypes.IGNORED_LABELS,e])},e.prototype.ignoreReturnAwaitYield=function(){return this.get(OptionTypes.IGNORE_RETURN_AWAIT_YIELD)},e.prototype.replaceVariableInit=function(e,t){return this.setIn([OptionTypes.REPLACED_VARIABLE_INITS,e],t)},e.prototype.setArgumentsVariables=function(e){return this.set(OptionTypes.ARGUMENTS_VARIABLES,e)},e.prototype.setIgnoreBreakStatements=function(e){return void 0===e&&(e=!0),this.set(OptionTypes.IGNORE_BREAK_STATEMENTS,e)},e.prototype.setIgnoreLabel=function(e){return this.setIn([OptionTypes.IGNORED_LABELS,e],!0)},e.prototype.setIgnoreNoLabels=function(){return this.remove(OptionTypes.IGNORED_LABELS)},e.prototype.setIgnoreReturnAwaitYield=function(e){return void 0===e&&(e=!0),this.set(OptionTypes.IGNORE_RETURN_AWAIT_YIELD,e)},e.prototype.get=function(e){return this.optionValues.get(e)},e.prototype.remove=function(t){return new e(this.optionValues.remove(t))},e.prototype.set=function(t,r){return new e(this.optionValues.set(t,r))},e.prototype.setIn=function(t,r){return new e(this.optionValues.setIn(t,r))},e}(),keys={Literal:[],Program:["body"]};function getAndCreateKeys(e){return keys[e.type]=Object.keys(e).filter(function(t){return"object"==typeof e[t]}),keys[e.type]}var NEW_EXECUTION_PATH=ExecutionPathOptions.create(),NodeBase=function(){function e(e,t,r){this.keys=keys[e.type]||getAndCreateKeys(e),this.parent=t,this.context=t.context,this.createScope(r),this.parseNode(e),this.initialise(),this.context.magicString.addSourcemapLocation(this.start),this.context.magicString.addSourcemapLocation(this.end)}return e.prototype.bind=function(){for(var e=0,t=this.keys;e<t.length;e++){var r=t[e],n=this[r];if(null!==n&&"annotations"!==r)if(Array.isArray(n))for(var i=0,s=n;i<s.length;i++){var o=s[i];null!==o&&o.bind()}else n.bind()}},e.prototype.createScope=function(e){this.scope=e},e.prototype.declare=function(e,t){},e.prototype.deoptimizePath=function(e){},e.prototype.getLiteralValueAtPath=function(e,t,r){return UNKNOWN_VALUE},e.prototype.getReturnExpressionWhenCalledAtPath=function(e,t,r){return UNKNOWN_EXPRESSION},e.prototype.hasEffects=function(e){for(var t=0,r=this.keys;t<r.length;t++){var n=r[t],i=this[n];if(null!==i&&"annotations"!==n)if(Array.isArray(i))for(var s=0,o=i;s<o.length;s++){var a=o[s];if(null!==a&&a.hasEffects(e))return!0}else if(i.hasEffects(e))return!0}return!1},e.prototype.hasEffectsWhenAccessedAtPath=function(e,t){return e.length>0},e.prototype.hasEffectsWhenAssignedAtPath=function(e,t){return!0},e.prototype.hasEffectsWhenCalledAtPath=function(e,t,r){return!0},e.prototype.include=function(e){this.included=!0;for(var t=0,r=this.keys;t<r.length;t++){var n=r[t],i=this[n];if(null!==i&&"annotations"!==n)if(Array.isArray(i))for(var s=0,o=i;s<o.length;s++){var a=o[s];null!==a&&a.include(e)}else i.include(e)}},e.prototype.includeWithAllDeclaredVariables=function(e){this.include(e)},e.prototype.initialise=function(){this.included=!1},e.prototype.insertSemicolon=function(e){";"!==e.original[this.end-1]&&e.appendLeft(this.end,";")},e.prototype.locate=function(){var e=locate(this.context.code,this.start,{offsetLine:1});return e.file=this.context.fileName,e.toString=function(){return JSON.stringify(e)},e},e.prototype.parseNode=function(e){for(var t=0,r=Object.keys(e);t<r.length;t++){var n=r[t];if(!this.hasOwnProperty(n)){var i=e[n];if("object"!=typeof i||null===i||"annotations"===n)this[n]=i;else if(Array.isArray(i)){this[n]=[];for(var s=0,o=i;s<o.length;s++){var a=o[s];this[n].push(null===a?null:new(this.context.nodeConstructors[a.type]||this.context.nodeConstructors.UnknownNode)(a,this,this.scope))}}else this[n]=new(this.context.nodeConstructors[i.type]||this.context.nodeConstructors.UnknownNode)(i,this,this.scope)}}},e.prototype.render=function(e,t){for(var r=0,n=this.keys;r<n.length;r++){var i=n[r],s=this[i];if(null!==s&&"annotations"!==i)if(Array.isArray(s))for(var o=0,a=s;o<a.length;o++){var u=a[o];null!==u&&u.render(e,t)}else s.render(e,t)}},e.prototype.shouldBeIncluded=function(){return this.included||this.hasEffects(NEW_EXECUTION_PATH)},e.prototype.toString=function(){return this.context.code.slice(this.start,this.end)},e}(),ClassNode=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),t.prototype.createScope=function(e){this.scope=new ChildScope(e)},t.prototype.hasEffectsWhenAccessedAtPath=function(e,t){return e.length>1},t.prototype.hasEffectsWhenAssignedAtPath=function(e,t){return e.length>1},t.prototype.hasEffectsWhenCalledAtPath=function(e,t,r){return this.body.hasEffectsWhenCalledAtPath(e,t,r)||this.superClass&&this.superClass.hasEffectsWhenCalledAtPath(e,t,r)},t.prototype.initialise=function(){this.included=!1,null!==this.id&&this.id.declare("class",this)},t}(NodeBase);function isClassDeclaration(e){return e.type===ClassDeclaration}var ClassDeclaration$1=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),t.prototype.initialise=function(){e.prototype.initialise.call(this),null!==this.id&&(this.id.variable.isId=!0)},t.prototype.parseNode=function(t){null!==t.id&&(this.id=new this.context.nodeConstructors.Identifier(t.id,this,this.scope.parent)),e.prototype.parseNode.call(this,t)},t.prototype.render=function(t,r){"system"===r.format&&this.id&&this.id.variable.exportName&&t.appendLeft(this.end," exports('"+this.id.variable.exportName+"', "+this.id.variable.getName()+");"),e.prototype.render.call(this,t,r)},t}(ClassNode),getParameterVariable=function(e,t){var r=parseInt(e[0],10);return r<t.getArgumentsVariables().length&&t.getArgumentsVariables()[r]||UNKNOWN_EXPRESSION},ArgumentsVariable=function(e){function t(t,r){var n=e.call(this,"arguments",null,UNKNOWN_EXPRESSION,r)||this;return n.parameters=t,n}return __extends(t,e),t.prototype.deoptimizePath=function(e){var t=parseInt(e[0],10);e.length>0&&t>=0&&this.parameters[t]&&this.parameters[t].deoptimizePath(e.slice(1))},t.prototype.hasEffectsWhenAccessedAtPath=function(e,t){return e.length>1&&getParameterVariable(e,t).hasEffectsWhenAccessedAtPath(e.slice(1),t)},t.prototype.hasEffectsWhenAssignedAtPath=function(e,t){return 0===e.length||this.included||getParameterVariable(e,t).hasEffectsWhenAssignedAtPath(e.slice(1),t)},t.prototype.hasEffectsWhenCalledAtPath=function(e,t,r){return 0===e.length||getParameterVariable(e,r).hasEffectsWhenCalledAtPath(e.slice(1),t,r)},t}(LocalVariable),ThisVariable=function(e){function t(t){return e.call(this,"this",null,null,t)||this}return __extends(t,e),t.prototype._getInit=function(e){return e.getReplacedVariableInit(this)||UNKNOWN_EXPRESSION},t.prototype.getLiteralValueAtPath=function(){return UNKNOWN_VALUE},t.prototype.hasEffectsWhenAccessedAtPath=function(t,r){return this._getInit(r).hasEffectsWhenAccessedAtPath(t,r)||e.prototype.hasEffectsWhenAccessedAtPath.call(this,t,r)},t.prototype.hasEffectsWhenAssignedAtPath=function(t,r){return this._getInit(r).hasEffectsWhenAssignedAtPath(t,r)||e.prototype.hasEffectsWhenAssignedAtPath.call(this,t,r)},t.prototype.hasEffectsWhenCalledAtPath=function(t,r,n){return this._getInit(n).hasEffectsWhenCalledAtPath(t,r,n)||e.prototype.hasEffectsWhenCalledAtPath.call(this,t,r,n)},t}(LocalVariable),ParameterScope=function(e){function t(t,r){var n=e.call(this,t)||this;return n.parameters=[],n.context=r,n.hoistedBodyVarScope=new ChildScope(n),n}return __extends(t,e),t.prototype.addParameterDeclaration=function(e){var t,r=e.name;return r in this.hoistedBodyVarScope.variables?(t=this.hoistedBodyVarScope.variables[r]).addDeclaration(e,null):t=new LocalVariable(r,e,UNKNOWN_EXPRESSION,this.context),this.variables[r]=t,this.parameters.push(t),t},t.prototype.getParameterVariables=function(){return this.parameters},t}(ChildScope),ReturnValueScope=function(e){function t(){var t=null!==e&&e.apply(this,arguments)||this;return t.returnExpression=null,t.returnExpressions=[],t}return __extends(t,e),t.prototype.addReturnExpression=function(e){this.returnExpressions.push(e)},t.prototype.getReturnExpression=function(){return null===this.returnExpression&&this.updateReturnExpression(),this.returnExpression},t.prototype.updateReturnExpression=function(){if(1===this.returnExpressions.length)this.returnExpression=this.returnExpressions[0];else{this.returnExpression=UNKNOWN_EXPRESSION;for(var e=0,t=this.returnExpressions;e<t.length;e++){t[e].deoptimizePath(UNKNOWN_PATH)}}},t}(ParameterScope),FunctionScope=function(e){function t(t,r){var n=e.call(this,t,r)||this;return n.variables.arguments=new ArgumentsVariable(e.prototype.getParameterVariables.call(n),r),n.variables.this=new ThisVariable(r),n}return __extends(t,e),t.prototype.findLexicalBoundary=function(){return this},t.prototype.getOptionsWhenCalledWith=function(t,r){var n=this,i=t.args,s=t.withNew;return r.replaceVariableInit(this.variables.this,s?new UnknownObjectExpression:UNKNOWN_EXPRESSION).setArgumentsVariables(i.map(function(t,r){return e.prototype.getParameterVariables.call(n)[r]||t}))},t}(ReturnValueScope),FunctionNode=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),t.prototype.createScope=function(e){this.scope=new FunctionScope(e,this.context)},t.prototype.deoptimizePath=function(e){1===e.length&&("prototype"===e[0]?this.isPrototypeDeoptimized=!0:e[0]===UNKNOWN_KEY&&(this.isPrototypeDeoptimized=!0,this.scope.getReturnExpression().deoptimizePath(UNKNOWN_PATH)))},t.prototype.getReturnExpressionWhenCalledAtPath=function(e){return 0===e.length?this.scope.getReturnExpression():UNKNOWN_EXPRESSION},t.prototype.hasEffects=function(e){return this.id&&this.id.hasEffects(e)},t.prototype.hasEffectsWhenAccessedAtPath=function(e){return!(e.length<=1)&&(e.length>2||"prototype"!==e[0]||this.isPrototypeDeoptimized)},t.prototype.hasEffectsWhenAssignedAtPath=function(e){return!(e.length<=1)&&(e.length>2||"prototype"!==e[0]||this.isPrototypeDeoptimized)},t.prototype.hasEffectsWhenCalledAtPath=function(e,t,r){if(e.length>0)return!0;for(var n=this.scope.getOptionsWhenCalledWith(t,r),i=0,s=this.params;i<s.length;i++){if(s[i].hasEffects(n))return!0}return this.body.hasEffects(n)},t.prototype.include=function(t){this.scope.variables.arguments.include(),e.prototype.include.call(this,t)},t.prototype.initialise=function(){this.included=!1,this.isPrototypeDeoptimized=!1,null!==this.id&&this.id.declare("function",this);for(var e=0,t=this.params;e<t.length;e++){t[e].declare("parameter",UNKNOWN_EXPRESSION)}this.body.addImplicitReturnExpressionToScope()},t.prototype.parseNode=function(t){this.body=new this.context.nodeConstructors.BlockStatement(t.body,this,this.scope.hoistedBodyVarScope),e.prototype.parseNode.call(this,t)},t}(NodeBase);function isFunctionDeclaration(e){return e.type===FunctionDeclaration}FunctionNode.prototype.preventChildBlockScope=!0;var FunctionDeclaration$1=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),t.prototype.initialise=function(){e.prototype.initialise.call(this),null!==this.id&&(this.id.variable.isId=!0)},t.prototype.parseNode=function(t){null!==t.id&&(this.id=new this.context.nodeConstructors.Identifier(t.id,this,this.scope.parent)),e.prototype.parseNode.call(this,t)},t}(FunctionNode),WHITESPACE=/\s/;function getDeclarationStart(e,t){for(void 0===t&&(t=0),t=findFirstOccurrenceOutsideComment(e,"default",t)+7;WHITESPACE.test(e[t]);)t++;return t}function getIdInsertPosition(e,t,r){void 0===r&&(r=0);var n=findFirstOccurrenceOutsideComment(e,t,r)+t.length;e=e.slice(n,findFirstOccurrenceOutsideComment(e,"{",n));var i=findFirstOccurrenceOutsideComment(e,"*");return-1===i?n:n+i+1}function isExportDefaultDeclaration(e){return e.type===ExportDefaultDeclaration}var ExportDefaultDeclaration$1=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),t.prototype.initialise=function(){this.included=!1,this.declarationName=this.declaration.id&&this.declaration.id.name||this.declaration.name,this.variable=this.scope.addExportDefaultDeclaration(this.declarationName||this.context.getModuleName(),this,this.context),this.context.addExport(this)},t.prototype.render=function(e,t,r){var n=void 0===r?BLANK:r,i=n.start,s=n.end,o=getDeclarationStart(e.original,this.start);if(isFunctionDeclaration(this.declaration))this.renderNamedDeclaration(e,o,"function",null===this.declaration.id,t);else if(isClassDeclaration(this.declaration))this.renderNamedDeclaration(e,o,"class",null===this.declaration.id,t);else{if(this.variable.referencesOriginal())return void("system"===t.format&&this.variable.exportName?e.overwrite(i,s,"exports('"+this.variable.exportName+"', "+this.variable.getName()+");"):treeshakeNode(this,e,i,s));if(!this.variable.included)return e.remove(this.start,o),this.declaration.render(e,t,{isCalleeOfRenderedParent:!1,renderedParentType:ExpressionStatement}),void(";"!==e.original[this.end-1]&&e.appendLeft(this.end,";"));this.renderVariableDeclaration(e,o,t)}this.declaration.render(e,t)},t.prototype.renderNamedDeclaration=function(e,t,r,n,i){var s=this.variable.getName();e.remove(this.start,t),n&&e.appendLeft(getIdInsertPosition(e.original,r,t)," "+s),"system"===i.format&&isClassDeclaration(this.declaration)&&this.variable.exportName&&e.appendLeft(this.end," exports('"+this.variable.exportName+"', "+s+");")},t.prototype.renderVariableDeclaration=function(e,t,r){var n="system"===r.format&&this.variable.exportName?"exports('"+this.variable.exportName+"', ":"";e.overwrite(this.start,t,r.varOrConst+" "+this.variable.getName()+" = "+n);var i=59===e.original.charCodeAt(this.end-1);n?e.appendRight(i?this.end-1:this.end,")"+(i?"":";")):i||e.appendLeft(this.end,";")},t}(NodeBase);ExportDefaultDeclaration$1.prototype.needsBoundaries=!0;var ArrayExpression=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),t.prototype.bind=function(){e.prototype.bind.call(this);for(var t=0,r=this.elements;t<r.length;t++){var n=r[t];null!==n&&n.deoptimizePath(UNKNOWN_PATH)}},t.prototype.getReturnExpressionWhenCalledAtPath=function(e){return 1!==e.length?UNKNOWN_EXPRESSION:getMemberReturnExpressionWhenCalled(arrayMembers,e[0])},t.prototype.hasEffectsWhenAccessedAtPath=function(e){return e.length>1},t.prototype.hasEffectsWhenCalledAtPath=function(e,t,r){return 1!==e.length||hasMemberEffectWhenCalled(arrayMembers,e[0],this.included,t,r)},t}(NodeBase),ArrayPattern=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),t.prototype.addExportedVariables=function(e){for(var t=0,r=this.elements;t<r.length;t++){var n=r[t];null!==n&&n.addExportedVariables(e)}},t.prototype.declare=function(e,t){for(var r=0,n=this.elements;r<n.length;r++){var i=n[r];null!==i&&i.declare(e,UNKNOWN_EXPRESSION)}},t.prototype.deoptimizePath=function(e){if(0===e.length)for(var t=0,r=this.elements;t<r.length;t++){var n=r[t];null!==n&&n.deoptimizePath(e)}},t.prototype.hasEffectsWhenAssignedAtPath=function(e,t){if(e.length>0)return!0;for(var r=0,n=this.elements;r<n.length;r++){var i=n[r];if(null!==i&&i.hasEffectsWhenAssignedAtPath(EMPTY_PATH,t))return!0}return!1},t}(NodeBase),BlockScope=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),t.prototype.addDeclaration=function(t,r,n,i){return void 0===n&&(n=null),void 0===i&&(i=!1),i?this.parent.addDeclaration(t,r,UNKNOWN_EXPRESSION,!0):e.prototype.addDeclaration.call(this,t,r,n,!1)},t}(ChildScope),BlockStatement$1=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),t.prototype.addImplicitReturnExpressionToScope=function(){var e=this.body[this.body.length-1];e&&e.type===ReturnStatement||this.scope.addReturnExpression(UNKNOWN_EXPRESSION)},t.prototype.createScope=function(e){this.scope=this.parent.preventChildBlockScope?e:new BlockScope(e)},t.prototype.hasEffects=function(e){for(var t=0,r=this.body;t<r.length;t++){if(r[t].hasEffects(e))return!0}},t.prototype.include=function(e){this.included=!0;for(var t=0,r=this.body;t<r.length;t++){var n=r[t];(e||n.shouldBeIncluded())&&n.include(e)}},t.prototype.render=function(t,r){this.body.length?renderStatementList(this.body,t,this.start+1,this.end-1,r):e.prototype.render.call(this,t,r)},t}(NodeBase),ArrowFunctionExpression=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),t.prototype.createScope=function(e){this.scope=new ReturnValueScope(e,this.context)},t.prototype.deoptimizePath=function(e){1===e.length&&e[0]===UNKNOWN_KEY&&this.scope.getReturnExpression().deoptimizePath(UNKNOWN_PATH)},t.prototype.getReturnExpressionWhenCalledAtPath=function(e){return 0===e.length?this.scope.getReturnExpression():UNKNOWN_EXPRESSION},t.prototype.hasEffects=function(e){return!1},t.prototype.hasEffectsWhenAccessedAtPath=function(e,t){return e.length>1},t.prototype.hasEffectsWhenAssignedAtPath=function(e,t){return e.length>1},t.prototype.hasEffectsWhenCalledAtPath=function(e,t,r){if(e.length>0)return!0;for(var n=0,i=this.params;n<i.length;n++){if(i[n].hasEffects(r))return!0}return this.body.hasEffects(r)},t.prototype.initialise=function(){this.included=!1;for(var e=0,t=this.params;e<t.length;e++){t[e].declare("parameter",UNKNOWN_EXPRESSION)}this.body instanceof BlockStatement$1?this.body.addImplicitReturnExpressionToScope():this.scope.addReturnExpression(this.body)},t.prototype.parseNode=function(t){t.body.type===BlockStatement&&(this.body=new this.context.nodeConstructors.BlockStatement(t.body,this,this.scope.hoistedBodyVarScope)),e.prototype.parseNode.call(this,t)},t}(NodeBase);function getSystemExportStatement(e){return 1===e.length?"exports('"+(e[0].safeExportName||e[0].exportName)+"', "+e[0].getName()+");":"exports({"+e.map(function(e){return(e.safeExportName||e.exportName)+": "+e.getName()}).join(", ")+"});"}ArrowFunctionExpression.prototype.preventChildBlockScope=!0;var AssignmentExpression=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),t.prototype.bind=function(){e.prototype.bind.call(this),this.left.deoptimizePath(EMPTY_PATH),this.right.deoptimizePath(UNKNOWN_PATH)},t.prototype.hasEffects=function(e){return this.right.hasEffects(e)||this.left.hasEffects(e)||this.left.hasEffectsWhenAssignedAtPath(EMPTY_PATH,e)},t.prototype.hasEffectsWhenAccessedAtPath=function(e,t){return e.length>0&&this.right.hasEffectsWhenAccessedAtPath(e,t)},t.prototype.render=function(e,t){if(this.left.render(e,t),this.right.render(e,t),"system"===t.format)if(this.left.variable&&this.left.variable.exportName)e.prependLeft(e.original.indexOf("=",this.left.end)+1," exports('"+this.left.variable.exportName+"',"),e.appendLeft(this.right.end,")");else if("addExportedVariables"in this.left){var r=[];this.left.addExportedVariables(r),r.length>0&&(e.prependRight(this.start,"function (v) {"+getSystemExportStatement(r)+" return v;} ("),e.appendLeft(this.end,")"))}},t}(NodeBase),AssignmentPattern=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),t.prototype.addExportedVariables=function(e){this.left.addExportedVariables(e)},t.prototype.bind=function(){e.prototype.bind.call(this),this.left.deoptimizePath(EMPTY_PATH),this.right.deoptimizePath(UNKNOWN_PATH)},t.prototype.declare=function(e,t){this.left.declare(e,t)},t.prototype.deoptimizePath=function(e){0===e.length&&this.left.deoptimizePath(e)},t.prototype.hasEffectsWhenAssignedAtPath=function(e,t){return e.length>0||this.left.hasEffectsWhenAssignedAtPath(EMPTY_PATH,t)},t.prototype.render=function(e,t,r){var n=(void 0===r?BLANK:r).isShorthandProperty;this.left.render(e,t,{isShorthandProperty:n}),this.right.render(e,t)},t}(NodeBase),AwaitExpression=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),t.prototype.hasEffects=function(t){return e.prototype.hasEffects.call(this,t)||!t.ignoreReturnAwaitYield()},t.prototype.include=function(t){if(e.prototype.include.call(this,t),!this.context.usesTopLevelAwait){var r=this.parent;do{if(r instanceof FunctionNode||r instanceof ArrowFunctionExpression)return}while(r=r.parent);this.context.usesTopLevelAwait=!0}},t.prototype.render=function(t,r){e.prototype.render.call(this,t,r)},t}(NodeBase),binaryOperators={"!=":function(e,t){return e!=t},"!==":function(e,t){return e!==t},"%":function(e,t){return e%t},"&":function(e,t){return e&t},"*":function(e,t){return e*t},"**":function(e,t){return Math.pow(e,t)},"+":function(e,t){return e+t},"-":function(e,t){return e-t},"/":function(e,t){return e/t},"<":function(e,t){return e<t},"<<":function(e,t){return e<<t},"<=":function(e,t){return e<=t},"==":function(e,t){return e==t},"===":function(e,t){return e===t},">":function(e,t){return e>t},">=":function(e,t){return e>=t},">>":function(e,t){return e>>t},">>>":function(e,t){return e>>>t},"^":function(e,t){return e^t},in:function(){return UNKNOWN_VALUE},instanceof:function(){return UNKNOWN_VALUE},"|":function(e,t){return e|t}},BinaryExpression=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),t.prototype.getLiteralValueAtPath=function(e,t,r){if(e.length>0)return UNKNOWN_VALUE;var n=this.left.getLiteralValueAtPath(EMPTY_PATH,t,r);if(n===UNKNOWN_VALUE)return UNKNOWN_VALUE;var i=this.right.getLiteralValueAtPath(EMPTY_PATH,t,r);if(i===UNKNOWN_VALUE)return UNKNOWN_VALUE;var s=binaryOperators[this.operator];return s?s(n,i):UNKNOWN_VALUE},t.prototype.hasEffectsWhenAccessedAtPath=function(e,t){return e.length>1},t}(NodeBase),BreakStatement=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),t.prototype.hasEffects=function(t){return e.prototype.hasEffects.call(this,t)||!t.ignoreBreakStatements()||this.label&&!t.ignoreLabel(this.label.name)},t}(NodeBase),RESULT_KEY$1={},ImmutableEntityPathTracker=function(){function e(e){void 0===e&&(e=Immutable.Map()),this.entityPaths=e}return e.prototype.isTracked=function(e,t){return this.entityPaths.getIn([e].concat(t,[RESULT_KEY$1]))},e.prototype.track=function(t,r){return new e(this.entityPaths.setIn([t].concat(r,[RESULT_KEY$1]),!0))},e}(),EMPTY_IMMUTABLE_TRACKER=new ImmutableEntityPathTracker;function isReference(e,t){return"MemberExpression"===e.type?!e.computed&&isReference(e.object,e):"Identifier"===e.type&&(!t||("MemberExpression"===t.type?t.computed||e===t.object:"MethodDefinition"===t.type?t.computed:"Property"===t.type?t.computed||e===t.value:("ExportSpecifier"!==t.type||e===t.local)&&"LabeledStatement"!==t.type))}function isIdentifier(e){return e.type===Identifier}var Identifier$1=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),t.prototype.addExportedVariables=function(e){this.variable.exportName&&e.push(this.variable)},t.prototype.bind=function(){this.bound||(this.bound=!0,null===this.variable&&isReference(this,this.parent)&&(this.variable=this.scope.findVariable(this.name),this.variable.addReference(this)),null!==this.variable&&this.variable.isLocal&&null!==this.variable.additionalInitializers&&this.variable.consolidateInitializers())},t.prototype.declare=function(e,t){switch(e){case"var":case"function":this.variable=this.scope.addDeclaration(this,this.context,t,!0);break;case"let":case"const":case"class":this.variable=this.scope.addDeclaration(this,this.context,t,!1);break;case"parameter":this.variable=this.scope.addParameterDeclaration(this);break;default:throw new Error("Unexpected identifier kind "+e+".")}},t.prototype.deoptimizePath=function(e){this.bound||this.bind(),null!==this.variable&&(0===e.length&&this.name in this.context.importDescriptions&&!this.scope.contains(this.name)&&this.disallowImportReassignment(),this.variable.deoptimizePath(e))},t.prototype.getLiteralValueAtPath=function(e,t,r){return null!==this.variable?this.variable.getLiteralValueAtPath(e,t,r):UNKNOWN_VALUE},t.prototype.getReturnExpressionWhenCalledAtPath=function(e,t,r){return null!==this.variable?this.variable.getReturnExpressionWhenCalledAtPath(e,t,r):UNKNOWN_EXPRESSION},t.prototype.hasEffectsWhenAccessedAtPath=function(e,t){return this.variable&&this.variable.hasEffectsWhenAccessedAtPath(e,t)},t.prototype.hasEffectsWhenAssignedAtPath=function(e,t){return!this.variable||this.variable.hasEffectsWhenAssignedAtPath(e,t)},t.prototype.hasEffectsWhenCalledAtPath=function(e,t,r){return!this.variable||this.variable.hasEffectsWhenCalledAtPath(e,t,r)},t.prototype.include=function(e){this.included||(this.included=!0,null!==this.variable&&this.context.includeVariable(this.variable))},t.prototype.initialise=function(){this.included=!1,this.bound=!1,this.variable||(this.variable=null)},t.prototype.render=function(e,t,r){var n=void 0===r?BLANK:r,i=n.renderedParentType,s=n.isCalleeOfRenderedParent,o=n.isShorthandProperty;if(this.variable){var a=this.variable.getName();a!==this.name&&(e.overwrite(this.start,this.end,a,{contentOnly:!0,storeName:!0}),o&&e.prependRight(this.start,this.name+": ")),"eval"===a&&i===CallExpression&&s&&e.appendRight(this.start,"0, ")}},t.prototype.disallowImportReassignment=function(){this.context.error({code:"ILLEGAL_REASSIGNMENT",message:"Illegal reassignment to import '"+this.name+"'"},this.start)},t}(NodeBase),CallExpression$1=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),t.prototype.bind=function(){(e.prototype.bind.call(this),this.callee instanceof Identifier$1)&&(this.scope.findVariable(this.callee.name).isNamespace&&this.context.error({code:"CANNOT_CALL_NAMESPACE",message:"Cannot call a namespace ('"+this.callee.name+"')"},this.start),"eval"===this.callee.name&&this.context.warn({code:"EVAL",message:"Use of eval is strongly discouraged, as it poses security risks and may cause issues with minification",url:"https://rollupjs.org/guide/en#avoiding-eval"},this.start));null===this.returnExpression&&(this.returnExpression=this.callee.getReturnExpressionWhenCalledAtPath(EMPTY_PATH,EMPTY_IMMUTABLE_TRACKER,this));for(var t=0,r=this.arguments;t<r.length;t++){r[t].deoptimizePath(UNKNOWN_PATH)}},t.prototype.deoptimizeCache=function(){if(this.returnExpression!==UNKNOWN_EXPRESSION){this.returnExpression=UNKNOWN_EXPRESSION;for(var e=0,t=this.expressionsToBeDeoptimized;e<t.length;e++){t[e].deoptimizeCache()}}},t.prototype.deoptimizePath=function(e){e.length>0&&!this.context.deoptimizationTracker.track(this,e)&&(null===this.returnExpression&&(this.returnExpression=this.callee.getReturnExpressionWhenCalledAtPath(EMPTY_PATH,EMPTY_IMMUTABLE_TRACKER,this)),this.returnExpression.deoptimizePath(e))},t.prototype.getLiteralValueAtPath=function(e,t,r){return null===this.returnExpression&&(this.returnExpression=this.callee.getReturnExpressionWhenCalledAtPath(EMPTY_PATH,t,this)),this.returnExpression===UNKNOWN_EXPRESSION||t.isTracked(this.returnExpression,e)?UNKNOWN_VALUE:(this.expressionsToBeDeoptimized.push(r),this.returnExpression.getLiteralValueAtPath(e,t.track(this.returnExpression,e),r))},t.prototype.getReturnExpressionWhenCalledAtPath=function(e,t,r){return null===this.returnExpression&&(this.returnExpression=this.callee.getReturnExpressionWhenCalledAtPath(EMPTY_PATH,t,this)),this.returnExpression===UNKNOWN_EXPRESSION||t.isTracked(this.returnExpression,e)?UNKNOWN_EXPRESSION:(this.expressionsToBeDeoptimized.push(r),this.returnExpression.getReturnExpressionWhenCalledAtPath(e,t.track(this.returnExpression,e),r))},t.prototype.hasEffects=function(e){for(var t=0,r=this.arguments;t<r.length;t++){if(r[t].hasEffects(e))return!0}return(!this.context.annotations||!this.annotatedPure)&&(this.callee.hasEffects(e)||this.callee.hasEffectsWhenCalledAtPath(EMPTY_PATH,this.callOptions,e.getHasEffectsWhenCalledOptions()))},t.prototype.hasEffectsWhenAccessedAtPath=function(e,t){return e.length>0&&!t.hasReturnExpressionBeenAccessedAtPath(e,this)&&this.returnExpression.hasEffectsWhenAccessedAtPath(e,t.addAccessedReturnExpressionAtPath(e,this))},t.prototype.hasEffectsWhenAssignedAtPath=function(e,t){return 0===e.length||!t.hasReturnExpressionBeenAssignedAtPath(e,this)&&this.returnExpression.hasEffectsWhenAssignedAtPath(e,t.addAssignedReturnExpressionAtPath(e,this))},t.prototype.hasEffectsWhenCalledAtPath=function(e,t,r){return!r.hasReturnExpressionBeenCalledAtPath(e,this)&&this.returnExpression.hasEffectsWhenCalledAtPath(e,t,r.addCalledReturnExpressionAtPath(e,this))},t.prototype.include=function(t){e.prototype.include.call(this,t),this.returnExpression.included||this.returnExpression.include(!1)},t.prototype.initialise=function(){this.included=!1,this.returnExpression=null,this.callOptions=CallOptions.create({args:this.arguments,callIdentifier:this,withNew:!1}),this.expressionsToBeDeoptimized=[]},t.prototype.render=function(t,r,n){var i=(void 0===n?BLANK:n).renderedParentType;e.prototype.render.call(this,t,r),i===ExpressionStatement&&this.callee.type===FunctionExpression&&(t.appendRight(this.start,"("),t.prependLeft(this.end,")"))},t}(NodeBase),CatchScope=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),t.prototype.addDeclaration=function(t,r,n,i){return void 0===n&&(n=null),void 0===i&&(i=!1),i?this.parent.addDeclaration(t,r,n,!0):e.prototype.addDeclaration.call(this,t,r,n,!1)},t}(ParameterScope),CatchClause=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),t.prototype.createScope=function(e){this.scope=new CatchScope(e,this.context)},t.prototype.initialise=function(){this.included=!1,this.param&&this.param.declare("parameter",UNKNOWN_EXPRESSION)},t.prototype.parseNode=function(t){this.body=new this.context.nodeConstructors.BlockStatement(t.body,this,this.scope),e.prototype.parseNode.call(this,t)},t}(NodeBase);CatchClause.prototype.preventChildBlockScope=!0;var ClassBody=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),t.prototype.hasEffectsWhenCalledAtPath=function(e,t,r){return e.length>0||null!==this.classConstructor&&this.classConstructor.hasEffectsWhenCalledAtPath(EMPTY_PATH,t,r)},t.prototype.initialise=function(){this.included=!1;for(var e=0,t=this.body;e<t.length;e++){var r=t[e];if("constructor"===r.kind)return void(this.classConstructor=r)}this.classConstructor=null},t}(NodeBase),ClassExpression=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),t}(ClassNode),MultiExpression=function(){function e(e){this.expressions=e}return e.prototype.deoptimizePath=function(e){for(var t=0,r=this.expressions;t<r.length;t++){r[t].deoptimizePath(e)}},e.prototype.getLiteralValueAtPath=function(){return UNKNOWN_VALUE},e.prototype.getReturnExpressionWhenCalledAtPath=function(t,r,n){return new e(this.expressions.map(function(e){return e.getReturnExpressionWhenCalledAtPath(t,r,n)}))},e.prototype.hasEffectsWhenAccessedAtPath=function(e,t){for(var r=0,n=this.expressions;r<n.length;r++){if(n[r].hasEffectsWhenAccessedAtPath(e,t))return!0}return!1},e.prototype.hasEffectsWhenAssignedAtPath=function(e,t){for(var r=0,n=this.expressions;r<n.length;r++){if(n[r].hasEffectsWhenAssignedAtPath(e,t))return!0}return!1},e.prototype.hasEffectsWhenCalledAtPath=function(e,t,r){for(var n=0,i=this.expressions;n<i.length;n++){if(i[n].hasEffectsWhenCalledAtPath(e,t,r))return!0}return!1},e.prototype.include=function(){},e}(),ConditionalExpression=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),t.prototype.bind=function(){e.prototype.bind.call(this),this.isBranchResolutionAnalysed||this.analyseBranchResolution()},t.prototype.deoptimizeCache=function(){if(null!==this.usedBranch){this.usedBranch=null,this.unusedBranch.deoptimizePath(UNKNOWN_PATH);for(var e=0,t=this.expressionsToBeDeoptimized;e<t.length;e++){t[e].deoptimizeCache()}}},t.prototype.deoptimizePath=function(e){e.length>0&&(this.isBranchResolutionAnalysed||this.analyseBranchResolution(),null===this.usedBranch?(this.consequent.deoptimizePath(e),this.alternate.deoptimizePath(e)):this.usedBranch.deoptimizePath(e))},t.prototype.getLiteralValueAtPath=function(e,t,r){return this.isBranchResolutionAnalysed||this.analyseBranchResolution(),null===this.usedBranch?UNKNOWN_VALUE:(this.expressionsToBeDeoptimized.push(r),this.usedBranch.getLiteralValueAtPath(e,t,r))},t.prototype.getReturnExpressionWhenCalledAtPath=function(e,t,r){return this.isBranchResolutionAnalysed||this.analyseBranchResolution(),null===this.usedBranch?new MultiExpression([this.consequent.getReturnExpressionWhenCalledAtPath(e,t,r),this.alternate.getReturnExpressionWhenCalledAtPath(e,t,r)]):(this.expressionsToBeDeoptimized.push(r),this.usedBranch.getReturnExpressionWhenCalledAtPath(e,t,r))},t.prototype.hasEffects=function(e){return!!this.test.hasEffects(e)||(null===this.usedBranch?this.consequent.hasEffects(e)||this.alternate.hasEffects(e):this.usedBranch.hasEffects(e))},t.prototype.hasEffectsWhenAccessedAtPath=function(e,t){return 0!==e.length&&(null===this.usedBranch?this.consequent.hasEffectsWhenAccessedAtPath(e,t)||this.alternate.hasEffectsWhenAccessedAtPath(e,t):this.usedBranch.hasEffectsWhenAccessedAtPath(e,t))},t.prototype.hasEffectsWhenAssignedAtPath=function(e,t){return 0===e.length||(null===this.usedBranch?this.consequent.hasEffectsWhenAssignedAtPath(e,t)||this.alternate.hasEffectsWhenAssignedAtPath(e,t):this.usedBranch.hasEffectsWhenAssignedAtPath(e,t))},t.prototype.hasEffectsWhenCalledAtPath=function(e,t,r){return null===this.usedBranch?this.consequent.hasEffectsWhenCalledAtPath(e,t,r)||this.alternate.hasEffectsWhenCalledAtPath(e,t,r):this.usedBranch.hasEffectsWhenCalledAtPath(e,t,r)},t.prototype.include=function(e){this.included=!0,e||null===this.usedBranch||this.test.shouldBeIncluded()?(this.test.include(e),this.consequent.include(e),this.alternate.include(e)):this.usedBranch.include(e)},t.prototype.initialise=function(){this.included=!1,this.isBranchResolutionAnalysed=!1,this.usedBranch=null,this.unusedBranch=null,this.expressionsToBeDeoptimized=[]},t.prototype.render=function(t,r,n){var i=void 0===n?BLANK:n,s=i.renderedParentType,o=i.isCalleeOfRenderedParent;this.test.included?e.prototype.render.call(this,t,r):(t.remove(this.start,this.usedBranch.start),t.remove(this.usedBranch.end,this.end),removeAnnotations(this,t),this.usedBranch.render(t,r,{isCalleeOfRenderedParent:s?o:this.parent.callee===this,renderedParentType:s||this.parent.type}))},t.prototype.analyseBranchResolution=function(){this.isBranchResolutionAnalysed=!0;var e=this.test.getLiteralValueAtPath(EMPTY_PATH,EMPTY_IMMUTABLE_TRACKER,this);e!==UNKNOWN_VALUE&&(e?(this.usedBranch=this.consequent,this.unusedBranch=this.alternate):(this.usedBranch=this.alternate,this.unusedBranch=this.consequent))},t}(NodeBase),DoWhileStatement=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),t.prototype.hasEffects=function(e){return this.test.hasEffects(e)||this.body.hasEffects(e.setIgnoreBreakStatements())},t}(NodeBase),EmptyStatement=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),t.prototype.hasEffects=function(){return!1},t}(NodeBase),ExportAllDeclaration$1=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),t.prototype.hasEffects=function(){return!1},t.prototype.initialise=function(){this.included=!1,this.context.addExport(this)},t.prototype.render=function(e,t,r){var n=void 0===r?BLANK:r,i=n.start,s=n.end;e.remove(i,s)},t}(NodeBase);ExportAllDeclaration$1.prototype.needsBoundaries=!0;var ExportNamedDeclaration=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),t.prototype.bind=function(){null!==this.declaration&&this.declaration.bind()},t.prototype.hasEffects=function(e){return this.declaration&&this.declaration.hasEffects(e)},t.prototype.initialise=function(){this.included=!1,this.context.addExport(this)},t.prototype.render=function(e,t,r){var n=void 0===r?BLANK:r,i=n.start,s=n.end;null===this.declaration?e.remove(i,s):(e.remove(this.start,this.declaration.start),this.declaration.render(e,t,{start:i,end:s}))},t}(NodeBase);ExportNamedDeclaration.prototype.needsBoundaries=!0;var ExpressionStatement$1=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),t.prototype.initialise=function(){this.included=!1,this.directive&&"use strict"!==this.directive&&this.parent.type===Program&&this.context.warn({code:"MODULE_LEVEL_DIRECTIVE",message:"Module level directives cause errors when bundled, '"+this.directive+"' was ignored."},this.start)},t.prototype.render=function(t,r){e.prototype.render.call(this,t,r),this.included&&this.insertSemicolon(t)},t.prototype.shouldBeIncluded=function(){return this.directive&&"use strict"!==this.directive?this.parent.type!==Program:e.prototype.shouldBeIncluded.call(this)},t}(NodeBase),ForInStatement=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),t.prototype.bind=function(){this.left.bind(),this.left.deoptimizePath(EMPTY_PATH),this.right.bind(),this.body.bind()},t.prototype.createScope=function(e){this.scope=new BlockScope(e)},t.prototype.hasEffects=function(e){return this.left&&(this.left.hasEffects(e)||this.left.hasEffectsWhenAssignedAtPath(EMPTY_PATH,e))||this.right&&this.right.hasEffects(e)||this.body.hasEffects(e.setIgnoreBreakStatements())},t.prototype.include=function(e){this.included=!0,this.left.includeWithAllDeclaredVariables(e),this.left.deoptimizePath(EMPTY_PATH),this.right.include(e),this.body.include(e)},t.prototype.render=function(e,t){this.left.render(e,t,NO_SEMICOLON),this.right.render(e,t,NO_SEMICOLON),this.body.render(e,t)},t}(NodeBase),ForOfStatement=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),t.prototype.bind=function(){this.left.bind(),this.left.deoptimizePath(EMPTY_PATH),this.right.bind(),this.body.bind()},t.prototype.createScope=function(e){this.scope=new BlockScope(e)},t.prototype.hasEffects=function(e){return this.left&&(this.left.hasEffects(e)||this.left.hasEffectsWhenAssignedAtPath(EMPTY_PATH,e))||this.right&&this.right.hasEffects(e)||this.body.hasEffects(e.setIgnoreBreakStatements())},t.prototype.include=function(e){this.included=!0,this.left.includeWithAllDeclaredVariables(e),this.left.deoptimizePath(EMPTY_PATH),this.right.include(e),this.body.include(e)},t.prototype.render=function(e,t){this.left.render(e,t,NO_SEMICOLON),this.right.render(e,t,NO_SEMICOLON),this.body.render(e,t)},t}(NodeBase),ForStatement=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),t.prototype.createScope=function(e){this.scope=new BlockScope(e)},t.prototype.hasEffects=function(e){return this.init&&this.init.hasEffects(e)||this.test&&this.test.hasEffects(e)||this.update&&this.update.hasEffects(e)||this.body.hasEffects(e.setIgnoreBreakStatements())},t.prototype.render=function(e,t){this.init&&this.init.render(e,t,NO_SEMICOLON),this.test&&this.test.render(e,t,NO_SEMICOLON),this.update&&this.update.render(e,t,NO_SEMICOLON),this.body.render(e,t)},t}(NodeBase),FunctionExpression$1=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),t}(FunctionNode),IfStatement=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),t.prototype.bind=function(){e.prototype.bind.call(this),this.isTestValueAnalysed||(this.testValue=UNKNOWN_VALUE,this.isTestValueAnalysed=!0,this.testValue=this.test.getLiteralValueAtPath(EMPTY_PATH,EMPTY_IMMUTABLE_TRACKER,this))},t.prototype.deoptimizeCache=function(){this.testValue=UNKNOWN_VALUE},t.prototype.hasEffects=function(e){return!!this.test.hasEffects(e)||(this.testValue===UNKNOWN_VALUE?this.consequent.hasEffects(e)||null!==this.alternate&&this.alternate.hasEffects(e):this.testValue?this.consequent.hasEffects(e):null!==this.alternate&&this.alternate.hasEffects(e))},t.prototype.include=function(e){if(this.included=!0,e)return this.test.include(!0),this.consequent.include(!0),void(null!==this.alternate&&this.alternate.include(!0));var t=this.testValue===UNKNOWN_VALUE;(t||this.test.shouldBeIncluded())&&this.test.include(!1),(t||this.testValue)&&this.consequent.shouldBeIncluded()&&this.consequent.include(!1),null===this.alternate||!t&&this.testValue||!this.alternate.shouldBeIncluded()||this.alternate.include(!1)},t.prototype.initialise=function(){this.included=!1,this.isTestValueAnalysed=!1},t.prototype.render=function(e,t){if(this.test.included||(this.testValue?null!==this.alternate&&this.alternate.included:this.consequent.included))this.test.included?this.test.render(e,t):e.overwrite(this.test.start,this.test.end,this.testValue?"true":"false"),this.consequent.included?this.consequent.render(e,t):e.overwrite(this.consequent.start,this.consequent.end,";"),null!==this.alternate&&(this.alternate.included?this.alternate.render(e,t):e.remove(this.consequent.end,this.alternate.end));else{var r=this.testValue?this.consequent:this.alternate;e.remove(this.start,r.start),e.remove(r.end,this.end),removeAnnotations(this,e),r.render(e,t)}},t}(NodeBase),getDynamicImportMechanism=function(e){switch(e.format){case"cjs":return{interopLeft:"Promise.resolve({"+(t=e.compact?"":" ")+"default:"+t+"require(",interopRight:")"+t+"})",left:"Promise.resolve(require(",right:"))"};case"amd":var t=e.compact?"":" ",r=e.compact?"c":"resolve",n=e.compact?"e":"reject";return{interopLeft:"new Promise(function"+t+"("+r+","+t+n+")"+t+"{"+t+"require([",interopRight:"],"+t+"function"+t+"(m)"+t+"{"+t+r+"({"+t+"default:"+t+"m"+t+"})"+t+"},"+t+n+")"+t+"})",left:"new Promise(function"+t+"("+r+","+t+n+")"+t+"{"+t+"require([",right:"],"+t+r+","+t+n+")"+t+"})"};case"system":return{left:"module.import(",right:")"};case"es":return{left:(e.dynamicImportFunction||"import")+"(",right:")"}}},Import=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),t.prototype.include=function(){this.included=!0,this.context.includeDynamicImport(this)},t.prototype.initialise=function(){this.included=!1,this.resolutionNamespace=void 0,this.resolutionInterop=!1,this.context.addDynamicImport(this)},t.prototype.render=function(e,t){if(this.resolutionNamespace){var r=t.compact?"":" ",n=t.compact?"":";";e.overwrite(this.parent.start,this.parent.end,"Promise.resolve().then(function"+r+"()"+r+"{"+r+"return "+this.resolutionNamespace+n+r+"})")}else{var i=getDynamicImportMechanism(t);if(i){var s=this.resolutionInterop&&i.interopLeft||i.left;e.overwrite(this.parent.start,this.parent.arguments[0].start,s);var o=this.resolutionInterop&&i.interopRight||i.right;e.overwrite(this.parent.arguments[0].end,this.parent.end,o)}}},t.prototype.renderFinalResolution=function(e,t){this.included&&e.overwrite(this.parent.arguments[0].start,this.parent.arguments[0].end,t)},t.prototype.setResolution=function(e,t){void 0===t&&(t=void 0),this.resolutionInterop=e,this.resolutionNamespace=t},t}(NodeBase),ImportDeclaration=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),t.prototype.bind=function(){},t.prototype.hasEffects=function(){return!1},t.prototype.initialise=function(){this.included=!1,this.context.addImport(this)},t.prototype.render=function(e,t,r){var n=void 0===r?BLANK:r,i=n.start,s=n.end;e.remove(i,s)},t}(NodeBase);ImportDeclaration.prototype.needsBoundaries=!0;var LabeledStatement=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),t.prototype.hasEffects=function(e){return this.body.hasEffects(e.setIgnoreLabel(this.label.name).setIgnoreBreakStatements())},t}(NodeBase);function isLiteral(e){return e.type===Literal}var Literal$1=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),t.prototype.getLiteralValueAtPath=function(e){return e.length>0||null===this.value&&110!==this.context.code.charCodeAt(this.start)||"bigint"==typeof this.value?UNKNOWN_VALUE:this.value},t.prototype.getReturnExpressionWhenCalledAtPath=function(e){return 1!==e.length?UNKNOWN_EXPRESSION:getMemberReturnExpressionWhenCalled(this.members,e[0])},t.prototype.hasEffectsWhenAccessedAtPath=function(e){return null===this.value?e.length>0:e.length>1},t.prototype.hasEffectsWhenAssignedAtPath=function(e){return e.length>0},t.prototype.hasEffectsWhenCalledAtPath=function(e,t,r){return 1!==e.length||hasMemberEffectWhenCalled(this.members,e[0],this.included,t,r)},t.prototype.initialise=function(){this.included=!1,this.members=getLiteralMembersForValue(this.value)},t.prototype.render=function(e,t){"string"==typeof this.value&&e.indentExclusionRanges.push([this.start+1,this.end-1])},t}(NodeBase),LogicalExpression=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),t.prototype.bind=function(){e.prototype.bind.call(this),this.isBranchResolutionAnalysed||this.analyseBranchResolution()},t.prototype.deoptimizeCache=function(){if(null!==this.usedBranch){this.usedBranch=null,this.unusedBranch.deoptimizePath(UNKNOWN_PATH);for(var e=0,t=this.expressionsToBeDeoptimized;e<t.length;e++){t[e].deoptimizeCache()}}},t.prototype.deoptimizePath=function(e){e.length>0&&(this.isBranchResolutionAnalysed||this.analyseBranchResolution(),null===this.usedBranch?(this.left.deoptimizePath(e),this.right.deoptimizePath(e)):this.usedBranch.deoptimizePath(e))},t.prototype.getLiteralValueAtPath=function(e,t,r){return this.isBranchResolutionAnalysed||this.analyseBranchResolution(),null===this.usedBranch?UNKNOWN_VALUE:(this.expressionsToBeDeoptimized.push(r),this.usedBranch.getLiteralValueAtPath(e,t,r))},t.prototype.getReturnExpressionWhenCalledAtPath=function(e,t,r){return this.isBranchResolutionAnalysed||this.analyseBranchResolution(),null===this.usedBranch?new MultiExpression([this.left.getReturnExpressionWhenCalledAtPath(e,t,r),this.right.getReturnExpressionWhenCalledAtPath(e,t,r)]):(this.expressionsToBeDeoptimized.push(r),this.usedBranch.getReturnExpressionWhenCalledAtPath(e,t,r))},t.prototype.hasEffects=function(e){return null===this.usedBranch?this.left.hasEffects(e)||this.right.hasEffects(e):this.usedBranch.hasEffects(e)},t.prototype.hasEffectsWhenAccessedAtPath=function(e,t){return 0!==e.length&&(null===this.usedBranch?this.left.hasEffectsWhenAccessedAtPath(e,t)||this.right.hasEffectsWhenAccessedAtPath(e,t):this.usedBranch.hasEffectsWhenAccessedAtPath(e,t))},t.prototype.hasEffectsWhenAssignedAtPath=function(e,t){return 0===e.length||(null===this.usedBranch?this.left.hasEffectsWhenAssignedAtPath(e,t)||this.right.hasEffectsWhenAssignedAtPath(e,t):this.usedBranch.hasEffectsWhenAssignedAtPath(e,t))},t.prototype.hasEffectsWhenCalledAtPath=function(e,t,r){return null===this.usedBranch?this.left.hasEffectsWhenCalledAtPath(e,t,r)||this.right.hasEffectsWhenCalledAtPath(e,t,r):this.usedBranch.hasEffectsWhenCalledAtPath(e,t,r)},t.prototype.include=function(e){this.included=!0,e||null===this.usedBranch||this.unusedBranch.shouldBeIncluded()?(this.left.include(e),this.right.include(e)):this.usedBranch.include(e)},t.prototype.initialise=function(){this.included=!1,this.isBranchResolutionAnalysed=!1,this.usedBranch=null,this.unusedBranch=null,this.expressionsToBeDeoptimized=[]},t.prototype.render=function(t,r,n){var i=void 0===n?BLANK:n,s=i.renderedParentType,o=i.isCalleeOfRenderedParent;this.left.included&&this.right.included?e.prototype.render.call(this,t,r):(t.remove(this.start,this.usedBranch.start),t.remove(this.usedBranch.end,this.end),removeAnnotations(this,t),this.usedBranch.render(t,r,{isCalleeOfRenderedParent:s?o:this.parent.callee===this,renderedParentType:s||this.parent.type}))},t.prototype.analyseBranchResolution=function(){this.isBranchResolutionAnalysed=!0;var e=this.left.getLiteralValueAtPath(EMPTY_PATH,EMPTY_IMMUTABLE_TRACKER,this);e!==UNKNOWN_VALUE&&(("||"===this.operator?e:!e)?(this.usedBranch=this.left,this.unusedBranch=this.right):(this.usedBranch=this.right,this.unusedBranch=this.left))},t}(NodeBase);function getAliasName(e,t){var r=path$2.basename(t||e),n=path$2.extname(e);return r.endsWith(n)&&(r=r.substr(0,r.length-n.length)),r}function relativeId(e){return"undefined"!=typeof process&&isAbsolute(e)?path$2.relative(process.cwd(),e):e}function isPlainName(e){return"/"!==e[0]&&("."!==e[1]||"/"!==e[2]&&("."!==e[2]||"/"!==e[3]))}function getResolvablePropertyKey(e){return e.computed?getResolvableComputedPropertyKey(e.property):e.property.name}function getResolvableComputedPropertyKey(e){return e instanceof Literal$1?String(e.value):null}function getPathIfNotComputed(e){var t=e.propertyKey,r=e.object;if("string"==typeof t){if(r instanceof Identifier$1)return[{key:r.name,pos:r.start},{key:t,pos:e.property.start}];if(isMemberExpression(r)){var n=getPathIfNotComputed(r);return n&&n.concat([{key:t,pos:e.property.start}])}}return null}function getStringFromPath(e){for(var t=e[0].key,r=1;r<e.length;r++)t+="."+e[r].key;return t}function isMemberExpression(e){return e.type===MemberExpression}var MemberExpression$1=function(e){function t(){var t=null!==e&&e.apply(this,arguments)||this;return t.variable=null,t}return __extends(t,e),t.prototype.bind=function(){if(!this.bound){this.bound=!0;var t=getPathIfNotComputed(this),r=t&&this.scope.findVariable(t[0].key);if(r&&r.isNamespace){var n=this.resolveNamespaceVariables(r,t.slice(1));n?"string"==typeof n?this.replacement=n:(n.isExternal&&n.module&&n.module.suggestName(t[0].key),this.variable=n,this.scope.addNamespaceMemberAccess(getStringFromPath(t),n)):e.prototype.bind.call(this)}else e.prototype.bind.call(this),null===this.propertyKey&&this.analysePropertyKey()}},t.prototype.deoptimizeCache=function(){for(var e=0,t=this.expressionsToBeDeoptimized;e<t.length;e++){t[e].deoptimizeCache()}},t.prototype.deoptimizePath=function(e){this.bound||this.bind(),0===e.length&&this.disallowNamespaceReassignment(),this.variable?this.variable.deoptimizePath(e):(null===this.propertyKey&&this.analysePropertyKey(),this.object.deoptimizePath([this.propertyKey].concat(e)))},t.prototype.getLiteralValueAtPath=function(e,t,r){return null!==this.variable?this.variable.getLiteralValueAtPath(e,t,r):(null===this.propertyKey&&this.analysePropertyKey(),this.expressionsToBeDeoptimized.push(r),this.object.getLiteralValueAtPath([this.propertyKey].concat(e),t,r))},t.prototype.getReturnExpressionWhenCalledAtPath=function(e,t,r){return null!==this.variable?this.variable.getReturnExpressionWhenCalledAtPath(e,t,r):(null===this.propertyKey&&this.analysePropertyKey(),this.expressionsToBeDeoptimized.push(r),this.object.getReturnExpressionWhenCalledAtPath([this.propertyKey].concat(e),t,r))},t.prototype.hasEffects=function(e){return this.property.hasEffects(e)||this.object.hasEffects(e)||this.context.propertyReadSideEffects&&this.object.hasEffectsWhenAccessedAtPath([this.propertyKey],e)},t.prototype.hasEffectsWhenAccessedAtPath=function(e,t){return 0!==e.length&&(null!==this.variable?this.variable.hasEffectsWhenAccessedAtPath(e,t):this.object.hasEffectsWhenAccessedAtPath([this.propertyKey].concat(e),t))},t.prototype.hasEffectsWhenAssignedAtPath=function(e,t){return null!==this.variable?this.variable.hasEffectsWhenAssignedAtPath(e,t):this.object.hasEffectsWhenAssignedAtPath([this.propertyKey].concat(e),t)},t.prototype.hasEffectsWhenCalledAtPath=function(e,t,r){return null!==this.variable?this.variable.hasEffectsWhenCalledAtPath(e,t,r):this.object.hasEffectsWhenCalledAtPath([this.propertyKey].concat(e),t,r)},t.prototype.include=function(e){this.included||(this.included=!0,null!==this.variable&&this.context.includeVariable(this.variable)),this.object.include(e),this.property.include(e)},t.prototype.initialise=function(){this.included=!1,this.propertyKey=getResolvablePropertyKey(this),this.variable=null,this.bound=!1,this.replacement=null,this.expressionsToBeDeoptimized=[]},t.prototype.render=function(t,r,n){var i=void 0===n?BLANK:n,s=i.renderedParentType,o=i.isCalleeOfRenderedParent,a=s===CallExpression&&o;if(this.variable||this.replacement){var u=this.variable?this.variable.getName():this.replacement;a&&(u="0, "+u),t.overwrite(this.start,this.end,u,{contentOnly:!0,storeName:!0})}else a&&t.appendRight(this.start,"0, "),e.prototype.render.call(this,t,r)},t.prototype.analysePropertyKey=function(){this.propertyKey=UNKNOWN_KEY;var e=this.property.getLiteralValueAtPath(EMPTY_PATH,EMPTY_IMMUTABLE_TRACKER,this);this.propertyKey=e===UNKNOWN_VALUE?UNKNOWN_KEY:String(e)},t.prototype.disallowNamespaceReassignment=function(){this.object instanceof Identifier$1&&this.scope.findVariable(this.object.name).isNamespace&&this.context.error({code:"ILLEGAL_NAMESPACE_REASSIGNMENT",message:"Illegal reassignment to import '"+this.object.name+"'"},this.start)},t.prototype.resolveNamespaceVariables=function(e,t){if(0===t.length)return e;if(!e.isNamespace)return null;var r=t[0].key,n=e.isExternal?e.module.getVariableForExportName(r):e.context.traceExport(r);if(!n){var i=e.isExternal?e.module.id:e.context.fileName;return this.context.warn({code:"MISSING_EXPORT",exporter:relativeId(i),importer:relativeId(this.context.fileName),message:"'"+r+"' is not exported by '"+relativeId(i)+"'",missing:r,url:"https://rollupjs.org/guide/en#error-name-is-not-exported-by-module-"},t[0].pos),"undefined"}return this.resolveNamespaceVariables(n,t.slice(1))},t}(NodeBase),globalImportMetaUrlMechanism="(typeof document !== 'undefined' ? document.currentScript && document.currentScript.src || document.baseURI : new (typeof URL !== 'undefined' ? URL : require('ur'+'l').URL)('file:' + __filename).href)",importMetaUrlMechanisms={amd:"new URL((typeof process !== 'undefined' && process.versions && process.versions.node ? 'file:' : '') + module.uri).href",cjs:"new (typeof URL !== 'undefined' ? URL : require('ur'+'l').URL)((process.browser ? '' : 'file:') + __filename, process.browser && document.baseURI).href",iife:globalImportMetaUrlMechanism,umd:globalImportMetaUrlMechanism},globalImportMetaUrlMechanismCompact="(typeof document!=='undefined'?document.currentScript&&document.currentScript.src||document.baseURI:new(typeof URL!=='undefined'?URL:require('ur'+'l').URL)('file:'+__filename).href)",importMetaUrlMechanismsCompact={amd:"new URL((typeof process!=='undefined'&&process.versions&&process.versions.node?'file:':'')+module.uri).href",cjs:"new(typeof URL!=='undefined'?URL:require('ur'+'l').URL)((process.browser?'':'file:')+__filename,process.browser&&document.baseURI).href",iife:globalImportMetaUrlMechanismCompact,umd:globalImportMetaUrlMechanismCompact},globalRelUrlMechanism=function(e,t){var r=t?"":" ";return"new"+r+"(typeof URL"+r+"!=="+r+"'undefined'"+r+"?"+r+"URL"+r+":"+r+"require('ur'+'l').URL)((typeof document"+r+"!=="+r+"'undefined'"+r+"?"+r+"document.currentScript"+r+"&&"+r+"document.currentScript.src"+r+"||"+r+"document.baseURI"+r+":"+r+"'file:'"+r+"+"+r+"__filename)"+r+"+"+r+"'/../"+e+"').href"},relUrlMechanisms={amd:function(e,t){var r=t?"":" ";return"new URL((typeof process"+r+"!=="+r+"'undefined'"+r+"&&"+r+"process.versions"+r+"&&"+r+"process.versions.node"+r+"?"+r+"'file:'"+r+":"+r+"'')"+r+"+"+r+"module.uri"+r+"+"+r+"'/../"+e+"').href"},cjs:function(e,t){var r=t?"":" ";return"new"+r+"(typeof URL"+r+"!=="+r+"'undefined'"+r+"?"+r+"URL"+r+":"+r+"require('ur'+'l').URL)((process.browser"+r+"?"+r+"''"+r+":"+r+"'file:')"+r+"+"+r+"__dirname"+r+"+"+r+"'/"+e+"',"+r+"process.browser"+r+"&&"+r+"document.baseURI).href"},es:function(e,t){return"new URL('../"+e+"',"+(t?"":" ")+"import.meta.url).href"},iife:globalRelUrlMechanism,system:function(e,t){return"new URL('../"+e+"',"+(t?"":" ")+"module.url).href"},umd:globalRelUrlMechanism},MetaProperty=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),t.prototype.initialise=function(){"import"===this.meta.name&&(this.rendered=!1,this.context.addImportMeta(this)),this.included=!1},t.prototype.render=function(t,r){"import"===this.meta.name&&(this.rendered=!0),e.prototype.render.call(this,t,r)},t.prototype.renderFinalMechanism=function(e,t,r,n){if(!this.rendered)return!1;if(this.parent instanceof MemberExpression$1==!1)return!1;var i,s=this.parent;if(s.property instanceof Identifier$1)i=s.property.name;else{if(!(s.property instanceof Literal$1&&"string"==typeof s.property.value))return!1;i=s.property.value}if(i.startsWith("ROLLUP_ASSET_URL_")){var o=this.context.getAssetFileName(i.substr(17)),a=normalize$1(path$2.relative(path$2.dirname(t),o));return e.overwrite(s.start,s.end,relUrlMechanisms[r](a,n)),!0}if("system"===r)e.overwrite(this.meta.start,this.meta.end,"module");else if("url"===i){var u=(n?importMetaUrlMechanismsCompact:importMetaUrlMechanisms)[r];return u&&e.overwrite(s.start,s.end,u),!0}return!1},t}(NodeBase),MethodDefinition=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),t.prototype.hasEffects=function(e){return this.key.hasEffects(e)},t.prototype.hasEffectsWhenCalledAtPath=function(e,t,r){return e.length>0||this.value.hasEffectsWhenCalledAtPath(EMPTY_PATH,t,r)},t}(NodeBase),NewExpression=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),t.prototype.bind=function(){e.prototype.bind.call(this);for(var t=0,r=this.arguments;t<r.length;t++){r[t].deoptimizePath(UNKNOWN_PATH)}},t.prototype.hasEffects=function(e){for(var t=0,r=this.arguments;t<r.length;t++){if(r[t].hasEffects(e))return!0}return!this.annotatedPure&&this.callee.hasEffectsWhenCalledAtPath(EMPTY_PATH,this.callOptions,e.getHasEffectsWhenCalledOptions())},t.prototype.hasEffectsWhenAccessedAtPath=function(e,t){return e.length>1},t.prototype.initialise=function(){this.included=!1,this.callOptions=CallOptions.create({args:this.arguments,callIdentifier:this,withNew:!0})},t}(NodeBase),SpreadElement=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),t.prototype.bind=function(){e.prototype.bind.call(this),this.argument.deoptimizePath([UNKNOWN_KEY,UNKNOWN_KEY])},t}(NodeBase),ObjectExpression=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),t.prototype.bind=function(){e.prototype.bind.call(this),null===this.propertyMap&&this.buildPropertyMap()},t.prototype.deoptimizeCache=function(){this.hasUnknownDeoptimizedProperty||this.deoptimizeAllProperties()},t.prototype.deoptimizePath=function(e){if(!this.hasUnknownDeoptimizedProperty)if(null===this.propertyMap&&this.buildPropertyMap(),0!==e.length){var t=e[0];if(1===e.length){if("string"!=typeof t)return void this.deoptimizeAllProperties();if(!this.deoptimizedPaths[t]&&(this.deoptimizedPaths[t]=!0,this.expressionsToBeDeoptimized[t]))for(var r=0,n=this.expressionsToBeDeoptimized[t];r<n.length;r++){n[r].deoptimizeCache()}}for(var i=1===e.length?UNKNOWN_PATH:e.slice(1),s=0,o="string"==typeof t?this.propertyMap[t]?this.propertyMap[t].propertiesRead:[]:this.properties;s<o.length;s++){o[s].deoptimizePath(i)}}else this.deoptimizeAllProperties()},t.prototype.getLiteralValueAtPath=function(e,t,r){null===this.propertyMap&&this.buildPropertyMap();var n=e[0];return 0===e.length||this.hasUnknownDeoptimizedProperty||"string"!=typeof n||this.deoptimizedPaths[n]?UNKNOWN_VALUE:1!==e.length||this.propertyMap[n]||objectMembers[n]||0!==this.unmatchablePropertiesRead.length?!this.propertyMap[n]||null===this.propertyMap[n].exactMatchRead||this.propertyMap[n].propertiesRead.length>1?UNKNOWN_VALUE:(this.expressionsToBeDeoptimized[n]?this.expressionsToBeDeoptimized[n].push(r):this.expressionsToBeDeoptimized[n]=[r],this.propertyMap[n].exactMatchRead.getLiteralValueAtPath(e.slice(1),t,r)):void(this.expressionsToBeDeoptimized[n]?this.expressionsToBeDeoptimized[n].push(r):this.expressionsToBeDeoptimized[n]=[r])},t.prototype.getReturnExpressionWhenCalledAtPath=function(e,t,r){null===this.propertyMap&&this.buildPropertyMap();var n=e[0];return 0===e.length||this.hasUnknownDeoptimizedProperty||"string"!=typeof n||this.deoptimizedPaths[n]?UNKNOWN_EXPRESSION:1!==e.length||!objectMembers[n]||0!==this.unmatchablePropertiesRead.length||this.propertyMap[n]&&null!==this.propertyMap[n].exactMatchRead?!this.propertyMap[n]||null===this.propertyMap[n].exactMatchRead||this.propertyMap[n].propertiesRead.length>1?UNKNOWN_EXPRESSION:(this.expressionsToBeDeoptimized[n]?this.expressionsToBeDeoptimized[n].push(r):this.expressionsToBeDeoptimized[n]=[r],this.propertyMap[n].exactMatchRead.getReturnExpressionWhenCalledAtPath(e.slice(1),t,r)):getMemberReturnExpressionWhenCalled(objectMembers,n)},t.prototype.hasEffectsWhenAccessedAtPath=function(e,t){if(0===e.length)return!1;var r=e[0];if(e.length>1&&(this.hasUnknownDeoptimizedProperty||"string"!=typeof r||this.deoptimizedPaths[r]||!this.propertyMap[r]||null===this.propertyMap[r].exactMatchRead))return!0;for(var n=e.slice(1),i=0,s="string"!=typeof r?this.properties:this.propertyMap[r]?this.propertyMap[r].propertiesRead:[];i<s.length;i++){if(s[i].hasEffectsWhenAccessedAtPath(n,t))return!0}return!1},t.prototype.hasEffectsWhenAssignedAtPath=function(e,t){if(0===e.length)return!1;var r=e[0];if(e.length>1&&(this.hasUnknownDeoptimizedProperty||"string"!=typeof r||this.deoptimizedPaths[r]||!this.propertyMap[r]||null===this.propertyMap[r].exactMatchRead))return!0;for(var n=e.slice(1),i=0,s="string"!=typeof r?this.properties:e.length>1?this.propertyMap[r].propertiesRead:this.propertyMap[r]?this.propertyMap[r].propertiesSet:[];i<s.length;i++){if(s[i].hasEffectsWhenAssignedAtPath(n,t))return!0}return!1},t.prototype.hasEffectsWhenCalledAtPath=function(e,t,r){var n=e[0];if(0===e.length||this.hasUnknownDeoptimizedProperty||"string"!=typeof n||this.deoptimizedPaths[n]||(this.propertyMap[n]?!this.propertyMap[n].exactMatchRead:e.length>1||!objectMembers[n]))return!0;for(var i=e.slice(1),s=0,o=this.propertyMap[n]?this.propertyMap[n].propertiesRead:[];s<o.length;s++){if(o[s].hasEffectsWhenCalledAtPath(i,t,r))return!0}return!(1!==e.length||!objectMembers[n])&&hasMemberEffectWhenCalled(objectMembers,n,this.included,t,r)},t.prototype.initialise=function(){this.included=!1,this.hasUnknownDeoptimizedProperty=!1,this.deoptimizedPaths=Object.create(null),this.propertyMap=null,this.expressionsToBeDeoptimized=Object.create(null)},t.prototype.render=function(t,r,n){var i=(void 0===n?BLANK:n).renderedParentType;e.prototype.render.call(this,t,r),i===ExpressionStatement&&(t.appendRight(this.start,"("),t.prependLeft(this.end,")"))},t.prototype.buildPropertyMap=function(){var e,t;this.propertyMap=Object.create(null),this.unmatchablePropertiesRead=[],this.unmatchablePropertiesWrite=[];for(var r=this.properties.length-1;r>=0;r--){var n=this.properties[r];if(n instanceof SpreadElement)this.unmatchablePropertiesRead.push(n);else{var i="get"!==n.kind,s="set"!==n.kind,o=void 0;if(n.computed){var a=n.key.getLiteralValueAtPath(EMPTY_PATH,EMPTY_IMMUTABLE_TRACKER,this);if(a===UNKNOWN_VALUE){s?this.unmatchablePropertiesRead.push(n):this.unmatchablePropertiesWrite.push(n);continue}o=String(a)}else o=n.key instanceof Identifier$1?n.key.name:String(n.key.value);var u=this.propertyMap[o];u?(s&&null===u.exactMatchRead&&(u.exactMatchRead=n,(e=u.propertiesRead).push.apply(e,[n].concat(this.unmatchablePropertiesRead))),i&&!s&&null===u.exactMatchWrite&&(u.exactMatchWrite=n,(t=u.propertiesSet).push.apply(t,[n].concat(this.unmatchablePropertiesWrite)))):this.propertyMap[o]={exactMatchRead:s?n:null,exactMatchWrite:i?n:null,propertiesRead:s?[n].concat(this.unmatchablePropertiesRead):[],propertiesSet:i&&!s?[n].concat(this.unmatchablePropertiesWrite):[]}}}},t.prototype.deoptimizeAllProperties=function(){this.hasUnknownDeoptimizedProperty=!0;for(var e=0,t=this.properties;e<t.length;e++){t[e].deoptimizePath(UNKNOWN_PATH)}for(var r=0,n=Object.keys(this.expressionsToBeDeoptimized);r<n.length;r++)for(var i=n[r],s=0,o=this.expressionsToBeDeoptimized[i];s<o.length;s++){o[s].deoptimizeCache()}},t}(NodeBase),ObjectPattern=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),t.prototype.addExportedVariables=function(e){for(var t=0,r=this.properties;t<r.length;t++){var n=r[t];n.type===Property?n.value.addExportedVariables(e):n.argument.addExportedVariables(e)}},t.prototype.declare=function(e,t){for(var r=0,n=this.properties;r<n.length;r++){n[r].declare(e,t)}},t.prototype.deoptimizePath=function(e){if(0===e.length)for(var t=0,r=this.properties;t<r.length;t++){r[t].deoptimizePath(e)}},t.prototype.hasEffectsWhenAssignedAtPath=function(e,t){if(e.length>0)return!0;for(var r=0,n=this.properties;r<n.length;r++){if(n[r].hasEffectsWhenAssignedAtPath(EMPTY_PATH,t))return!0}return!1},t}(NodeBase),Program$1=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),t.prototype.hasEffects=function(e){for(var t=0,r=this.body;t<r.length;t++){if(r[t].hasEffects(e))return!0}},t.prototype.include=function(e){this.included=!0;for(var t=0,r=this.body;t<r.length;t++){var n=r[t];(e||n.shouldBeIncluded())&&n.include(e)}},t.prototype.render=function(t,r){this.body.length?renderStatementList(this.body,t,this.start,this.end,r):e.prototype.render.call(this,t,r)},t}(NodeBase),Property$1=function(e){function t(){var t=null!==e&&e.apply(this,arguments)||this;return t.declarationInit=null,t}return __extends(t,e),t.prototype.bind=function(){e.prototype.bind.call(this),"get"===this.kind&&null===this.returnExpression&&this.updateReturnExpression(),null!==this.declarationInit&&this.declarationInit.deoptimizePath([UNKNOWN_KEY,UNKNOWN_KEY])},t.prototype.declare=function(e,t){this.declarationInit=t,this.value.declare(e,UNKNOWN_EXPRESSION)},t.prototype.deoptimizeCache=function(){throw new Error("Unexpected deoptimization")},t.prototype.deoptimizePath=function(e){"get"===this.kind?e.length>0&&(null===this.returnExpression&&this.updateReturnExpression(),this.returnExpression.deoptimizePath(e)):"set"!==this.kind&&this.value.deoptimizePath(e)},t.prototype.getLiteralValueAtPath=function(e,t,r){return"set"===this.kind?UNKNOWN_VALUE:"get"===this.kind?(null===this.returnExpression&&this.updateReturnExpression(),this.returnExpression.getLiteralValueAtPath(e,t,r)):this.value.getLiteralValueAtPath(e,t,r)},t.prototype.getReturnExpressionWhenCalledAtPath=function(e,t,r){return"set"===this.kind?UNKNOWN_EXPRESSION:"get"===this.kind?(null===this.returnExpression&&this.updateReturnExpression(),this.returnExpression.getReturnExpressionWhenCalledAtPath(e,t,r)):this.value.getReturnExpressionWhenCalledAtPath(e,t,r)},t.prototype.hasEffects=function(e){return this.key.hasEffects(e)||this.value.hasEffects(e)},t.prototype.hasEffectsWhenAccessedAtPath=function(e,t){return"get"===this.kind?this.value.hasEffectsWhenCalledAtPath(EMPTY_PATH,this.accessorCallOptions,t.getHasEffectsWhenCalledOptions())||e.length>0&&this.returnExpression.hasEffectsWhenAccessedAtPath(e,t):this.value.hasEffectsWhenAccessedAtPath(e,t)},t.prototype.hasEffectsWhenAssignedAtPath=function(e,t){return"get"===this.kind?0===e.length||this.returnExpression.hasEffectsWhenAssignedAtPath(e,t):"set"===this.kind?e.length>0||this.value.hasEffectsWhenCalledAtPath(EMPTY_PATH,this.accessorCallOptions,t.getHasEffectsWhenCalledOptions()):this.value.hasEffectsWhenAssignedAtPath(e,t)},t.prototype.hasEffectsWhenCalledAtPath=function(e,t,r){return"get"===this.kind?this.returnExpression.hasEffectsWhenCalledAtPath(e,t,r):this.value.hasEffectsWhenCalledAtPath(e,t,r)},t.prototype.initialise=function(){this.included=!1,this.returnExpression=null,this.accessorCallOptions=CallOptions.create({callIdentifier:this,withNew:!1})},t.prototype.render=function(e,t){this.shorthand||this.key.render(e,t),this.value.render(e,t,{isShorthandProperty:this.shorthand})},t.prototype.updateReturnExpression=function(){this.returnExpression=UNKNOWN_EXPRESSION,this.returnExpression=this.value.getReturnExpressionWhenCalledAtPath(EMPTY_PATH,EMPTY_IMMUTABLE_TRACKER,this)},t}(NodeBase),RestElement=function(e){function t(){var t=null!==e&&e.apply(this,arguments)||this;return t.declarationInit=null,t}return __extends(t,e),t.prototype.addExportedVariables=function(e){this.argument.addExportedVariables(e)},t.prototype.bind=function(){e.prototype.bind.call(this),null!==this.declarationInit&&this.declarationInit.deoptimizePath([UNKNOWN_KEY,UNKNOWN_KEY])},t.prototype.declare=function(e,t){this.argument.declare(e,UNKNOWN_EXPRESSION),this.declarationInit=t},t.prototype.deoptimizePath=function(e){0===e.length&&this.argument.deoptimizePath(EMPTY_PATH)},t.prototype.hasEffectsWhenAssignedAtPath=function(e,t){return e.length>0||this.argument.hasEffectsWhenAssignedAtPath(EMPTY_PATH,t)},t}(NodeBase),ReturnStatement$1=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),t.prototype.hasEffects=function(e){return!e.ignoreReturnAwaitYield()||this.argument&&this.argument.hasEffects(e)},t.prototype.initialise=function(){this.included=!1,this.scope.addReturnExpression(this.argument||UNKNOWN_EXPRESSION)},t.prototype.render=function(e,t){this.argument&&(this.argument.render(e,t),this.argument.start===this.start+6&&e.prependLeft(this.start+6," "))},t}(NodeBase),SequenceExpression=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),t.prototype.deoptimizePath=function(e){e.length>0&&this.expressions[this.expressions.length-1].deoptimizePath(e)},t.prototype.getLiteralValueAtPath=function(e,t,r){return this.expressions[this.expressions.length-1].getLiteralValueAtPath(e,t,r)},t.prototype.hasEffects=function(e){for(var t=0,r=this.expressions;t<r.length;t++){if(r[t].hasEffects(e))return!0}return!1},t.prototype.hasEffectsWhenAccessedAtPath=function(e,t){return e.length>0&&this.expressions[this.expressions.length-1].hasEffectsWhenAccessedAtPath(e,t)},t.prototype.hasEffectsWhenAssignedAtPath=function(e,t){return 0===e.length||this.expressions[this.expressions.length-1].hasEffectsWhenAssignedAtPath(e,t)},t.prototype.hasEffectsWhenCalledAtPath=function(e,t,r){return this.expressions[this.expressions.length-1].hasEffectsWhenCalledAtPath(e,t,r)},t.prototype.include=function(e){this.included=!0;for(var t=0;t<this.expressions.length-1;t++){var r=this.expressions[t];(e||r.shouldBeIncluded())&&r.include(e)}this.expressions[this.expressions.length-1].include(e)},t.prototype.render=function(e,t,r){for(var n,i=void 0===r?BLANK:r,s=i.renderedParentType,o=i.isCalleeOfRenderedParent,a=0,u=0,c=0,p=getCommaSeparatedNodesWithBoundaries(this.expressions,e,this.start,this.end);c<p.length;c++){var l=p[c],h=l.node,f=l.start,d=l.end;h.included?(u++,0===a&&(a=f),n=d,h===this.expressions[this.expressions.length-1]&&1===u?h.render(e,t,{isCalleeOfRenderedParent:s?o:this.parent.callee===this,renderedParentType:s||this.parent.type}):h.render(e,t)):treeshakeNode(h,e,f,d)}u>1&&s&&(e.prependRight(a,"("),e.appendLeft(n,")"))},t}(NodeBase),SwitchCase=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),t.prototype.include=function(e){this.included=!0,this.test&&this.test.include(e);for(var t=0,r=this.consequent;t<r.length;t++){var n=r[t];(e||n.shouldBeIncluded())&&n.include(e)}},t.prototype.render=function(t,r){if(this.consequent.length){this.test&&this.test.render(t,r);var n=this.test?this.test.end:findFirstOccurrenceOutsideComment(t.original,"default",this.start)+7,i=findFirstOccurrenceOutsideComment(t.original,":",n)+1;renderStatementList(this.consequent,t,i,this.end,r)}else e.prototype.render.call(this,t,r)},t}(NodeBase),SwitchStatement=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),t.prototype.createScope=function(e){this.scope=new BlockScope(e)},t.prototype.hasEffects=function(t){return e.prototype.hasEffects.call(this,t.setIgnoreBreakStatements())},t}(NodeBase),TaggedTemplateExpression=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),t.prototype.bind=function(){(e.prototype.bind.call(this),this.tag.type===Identifier)&&(this.scope.findVariable(this.tag.name).isNamespace&&this.context.error({code:"CANNOT_CALL_NAMESPACE",message:"Cannot call a namespace ('"+this.tag.name+"')"},this.start),"eval"===this.tag.name&&this.context.warn({code:"EVAL",message:"Use of eval is strongly discouraged, as it poses security risks and may cause issues with minification",url:"https://rollupjs.org/guide/en#avoiding-eval"},this.start))},t.prototype.hasEffects=function(t){return e.prototype.hasEffects.call(this,t)||this.tag.hasEffectsWhenCalledAtPath(EMPTY_PATH,this.callOptions,t.getHasEffectsWhenCalledOptions())},t.prototype.initialise=function(){this.included=!1,this.callOptions=CallOptions.create({callIdentifier:this,withNew:!1})},t}(NodeBase),TemplateElement=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),t.prototype.hasEffects=function(e){return!1},t}(NodeBase);function isTemplateLiteral(e){return e.type===TemplateLiteral}var TemplateLiteral$1=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),t.prototype.getLiteralValueAtPath=function(e){return e.length>0||1!==this.quasis.length?UNKNOWN_VALUE:this.quasis[0].value.cooked},t.prototype.render=function(t,r){t.indentExclusionRanges.push([this.start,this.end]),e.prototype.render.call(this,t,r)},t}(NodeBase),ModuleScope=function(e){function t(t,r){var n=e.call(this,t)||this;return n.context=r,n.variables.this=new LocalVariable("this",null,UNDEFINED_EXPRESSION,r),n}return __extends(t,e),t.prototype.addExportDefaultDeclaration=function(e,t,r){return this.variables.default=new ExportDefaultVariable(e,t,r)},t.prototype.addNamespaceMemberAccess=function(e,t){t instanceof GlobalVariable&&(this.accessedOutsideVariables[t.name]=t)},t.prototype.deconflict=function(e){for(var t=0,r=this.children;t<r.length;t++){r[t].deconflict(e)}},t.prototype.findLexicalBoundary=function(){return this},t.prototype.findVariable=function(e){var t=this.variables[e]||this.accessedOutsideVariables[e];if(t)return t;var r=this.context.traceVariable(e)||this.parent.findVariable(e);return r instanceof GlobalVariable&&(this.accessedOutsideVariables[e]=r),r},t}(ChildScope),ThisExpression=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),t.prototype.bind=function(){e.prototype.bind.call(this),this.variable=this.scope.findVariable("this")},t.prototype.hasEffectsWhenAccessedAtPath=function(e,t){return e.length>0&&this.variable.hasEffectsWhenAccessedAtPath(e,t)},t.prototype.hasEffectsWhenAssignedAtPath=function(e,t){return this.variable.hasEffectsWhenAssignedAtPath(e,t)},t.prototype.initialise=function(){this.included=!1,this.variable=null,this.alias=this.scope.findLexicalBoundary()instanceof ModuleScope?this.context.moduleContext:null,"undefined"===this.alias&&this.context.warn({code:"THIS_IS_UNDEFINED",message:"The 'this' keyword is equivalent to 'undefined' at the top level of an ES module, and has been rewritten",url:"https://rollupjs.org/guide/en#error-this-is-undefined"},this.start)},t.prototype.render=function(e,t){null!==this.alias&&e.overwrite(this.start,this.end,this.alias,{contentOnly:!1,storeName:!0})},t}(NodeBase),ThrowStatement=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),t.prototype.hasEffects=function(e){return!0},t}(NodeBase),unaryOperators={"!":function(e){return!e},"+":function(e){return+e},"-":function(e){return-e},delete:function(){return UNKNOWN_VALUE},typeof:function(e){return typeof e},void:function(){},"~":function(e){return~e}},UnaryExpression=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),t.prototype.bind=function(){e.prototype.bind.call(this),"delete"===this.operator&&this.argument.deoptimizePath(EMPTY_PATH)},t.prototype.getLiteralValueAtPath=function(e,t,r){if(e.length>0)return UNKNOWN_VALUE;var n=this.argument.getLiteralValueAtPath(EMPTY_PATH,t,r);return n===UNKNOWN_VALUE?UNKNOWN_VALUE:unaryOperators[this.operator](n)},t.prototype.hasEffects=function(e){return this.argument.hasEffects(e)||"delete"===this.operator&&this.argument.hasEffectsWhenAssignedAtPath(EMPTY_PATH,e)},t.prototype.hasEffectsWhenAccessedAtPath=function(e,t){return"void"===this.operator?e.length>0:e.length>1},t}(NodeBase),UnknownNode=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),t.prototype.hasEffects=function(e){return!0},t.prototype.include=function(){e.prototype.include.call(this,!0)},t}(NodeBase),UpdateExpression=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),t.prototype.bind=function(){(e.prototype.bind.call(this),this.argument.deoptimizePath(EMPTY_PATH),isIdentifier(this.argument))&&(this.scope.findVariable(this.argument.name).isReassigned=!0)},t.prototype.hasEffects=function(e){return this.argument.hasEffects(e)||this.argument.hasEffectsWhenAssignedAtPath(EMPTY_PATH,e)},t.prototype.hasEffectsWhenAccessedAtPath=function(e,t){return e.length>1},t.prototype.render=function(e,t){this.argument.render(e,t);var r=this.argument.variable;if("system"===t.format&&r&&r.exportName){var n=r.getName();if(this.prefix)e.overwrite(this.start,this.end,"exports('"+r.exportName+"', "+this.operator+n+")");else{var i=void 0;switch(this.operator){case"++":i=n+" + 1";break;case"--":i=n+" - 1"}e.overwrite(this.start,this.end,"(exports('"+r.exportName+"', "+i+"), "+n+this.operator+")")}}},t}(NodeBase);function isReassignedExportsMember(e){return e.renderBaseName&&e.exportName&&e.isReassigned}function areAllDeclarationsIncludedAndNotExported(e){for(var t=0,r=e;t<r.length;t++){var n=r[t];if(!n.included)return!1;if(n.id.type===Identifier){if(n.id.variable.exportName)return!1}else{var i=[];if(n.id.addExportedVariables(i),i.length>0)return!1}}return!0}var VariableDeclaration$1=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),t.prototype.deoptimizePath=function(e){for(var t=0,r=this.declarations;t<r.length;t++){r[t].deoptimizePath(EMPTY_PATH)}},t.prototype.hasEffectsWhenAssignedAtPath=function(e,t){return!1},t.prototype.include=function(e){this.included=!0;for(var t=0,r=this.declarations;t<r.length;t++){var n=r[t];(e||n.shouldBeIncluded())&&n.include(e)}},t.prototype.includeWithAllDeclaredVariables=function(e){this.included=!0;for(var t=0,r=this.declarations;t<r.length;t++){r[t].include(e)}},t.prototype.initialise=function(){this.included=!1;for(var e=0,t=this.declarations;e<t.length;e++){t[e].declareDeclarator(this.kind)}},t.prototype.render=function(e,t,r){if(void 0===r&&(r=BLANK),areAllDeclarationsIncludedAndNotExported(this.declarations)){for(var n=0,i=this.declarations;n<i.length;n++){i[n].render(e,t)}r.isNoStatement||59===e.original.charCodeAt(this.end-1)||e.appendLeft(this.end,";")}else this.renderReplacedDeclarations(e,t,r)},t.prototype.renderDeclarationEnd=function(e,t,r,n,i,s,o){59===e.original.charCodeAt(this.end-1)&&e.remove(this.end-1,this.end),s&&(t+=";"),null!==r?(10!==e.original.charCodeAt(n-1)||10!==e.original.charCodeAt(this.end)&&13!==e.original.charCodeAt(this.end)||(n--,13===e.original.charCodeAt(n)&&n--),n===r+1?e.overwrite(r,i,t):(e.overwrite(r,r+1,t),e.remove(n,i))):e.appendLeft(i,t),o.length>0&&e.appendLeft(i," "+getSystemExportStatement(o))},t.prototype.renderReplacedDeclarations=function(e,t,r){var n,i,s=r.start,o=void 0===s?this.start:s,a=r.end,u=void 0===a?this.end:a,c=r.isNoStatement,p=getCommaSeparatedNodesWithBoundaries(this.declarations,e,this.start+this.kind.length,this.end-(59===e.original.charCodeAt(this.end-1)?1:0)),l=(i=/\n\s*$/.test(e.slice(this.start,p[0].start))?this.start+this.kind.length:p[0].start)-1;e.remove(this.start,l);for(var h,f,d=!1,m=!1,g="",y=[],v=0,_=p;v<_.length;v++){var b=_[v],E=b.node,x=b.start,S=b.separator,A=b.contentEnd,w=b.end;!E.included||isIdentifier(E.id)&&isReassignedExportsMember(E.id.variable)&&null===E.init?e.remove(x,w):(h="",f="",isIdentifier(E.id)&&isReassignedExportsMember(E.id.variable)?(m&&(g+=";"),d=!1):("system"===t.format&&null!==E.init&&(E.id.type!==Identifier?E.id.addExportedVariables(y):E.id.variable.exportName&&(e.prependLeft(e.original.indexOf("=",E.id.end)+1," exports('"+(E.id.variable.safeExportName||E.id.variable.exportName)+"',"),f+=")")),d?g+=",":(m&&(g+=";"),h+=this.kind+" ",d=!0)),i===l+1?e.overwrite(l,i,g+h):(e.overwrite(l,l+1,g),e.appendLeft(i,h)),E.render(e,t),n=A,i=w,m=!0,l=S,g=f)}m?this.renderDeclarationEnd(e,g,l,n,i,!c,y):e.remove(o,u)},t}(NodeBase),VariableDeclarator=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),t.prototype.declareDeclarator=function(e){this.id.declare(e,this.init||UNDEFINED_EXPRESSION)},t.prototype.deoptimizePath=function(e){this.id.deoptimizePath(e)},t.prototype.render=function(t,r){null===this.init||this.init.included?e.prototype.render.call(this,t,r):(t.remove(this.id.end,this.end),this.id.render(t,r))},t}(NodeBase),WhileStatement=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),t.prototype.hasEffects=function(e){return this.test.hasEffects(e)||this.body.hasEffects(e.setIgnoreBreakStatements())},t}(NodeBase),YieldExpression=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),t.prototype.bind=function(){e.prototype.bind.call(this),null!==this.argument&&this.argument.deoptimizePath(UNKNOWN_PATH)},t.prototype.hasEffects=function(e){return!e.ignoreReturnAwaitYield()||this.argument&&this.argument.hasEffects(e)},t.prototype.render=function(e,t){this.argument&&(this.argument.render(e,t),this.argument.start===this.start+5&&e.prependLeft(this.start+5," "))},t}(NodeBase),nodeConstructors={ArrayExpression:ArrayExpression,ArrayPattern:ArrayPattern,ArrowFunctionExpression:ArrowFunctionExpression,AssignmentExpression:AssignmentExpression,AssignmentPattern:AssignmentPattern,AwaitExpression:AwaitExpression,BinaryExpression:BinaryExpression,BlockStatement:BlockStatement$1,BreakStatement:BreakStatement,CallExpression:CallExpression$1,CatchClause:CatchClause,ClassBody:ClassBody,ClassDeclaration:ClassDeclaration$1,ClassExpression:ClassExpression,ConditionalExpression:ConditionalExpression,DoWhileStatement:DoWhileStatement,EmptyStatement:EmptyStatement,ExportAllDeclaration:ExportAllDeclaration$1,ExportDefaultDeclaration:ExportDefaultDeclaration$1,ExportNamedDeclaration:ExportNamedDeclaration,ExpressionStatement:ExpressionStatement$1,ForInStatement:ForInStatement,ForOfStatement:ForOfStatement,ForStatement:ForStatement,FunctionDeclaration:FunctionDeclaration$1,FunctionExpression:FunctionExpression$1,Identifier:Identifier$1,IfStatement:IfStatement,Import:Import,ImportDeclaration:ImportDeclaration,LabeledStatement:LabeledStatement,Literal:Literal$1,LogicalExpression:LogicalExpression,MemberExpression:MemberExpression$1,MetaProperty:MetaProperty,MethodDefinition:MethodDefinition,NewExpression:NewExpression,ObjectExpression:ObjectExpression,ObjectPattern:ObjectPattern,Program:Program$1,Property:Property$1,RestElement:RestElement,ReturnStatement:ReturnStatement$1,SequenceExpression:SequenceExpression,SpreadElement:SpreadElement,SwitchCase:SwitchCase,SwitchStatement:SwitchStatement,TaggedTemplateExpression:TaggedTemplateExpression,TemplateElement:TemplateElement,TemplateLiteral:TemplateLiteral$1,ThisExpression:ThisExpression,ThrowStatement:ThrowStatement,TryStatement:NodeBase,UnaryExpression:UnaryExpression,UnknownNode:UnknownNode,UpdateExpression:UpdateExpression,VariableDeclaration:VariableDeclaration$1,VariableDeclarator:VariableDeclarator,WhileStatement:WhileStatement,YieldExpression:YieldExpression};function extractNames(e){var t=[];return extractors[e.type](t,e),t}var extractors={Identifier:function(e,t){e.push(t.name)},ObjectPattern:function(e,t){t.properties.forEach(function(t){t instanceof RestElement?extractors[t.argument.type](e,t.argument):extractors[t.value.type](e,t.value)})},ArrayPattern:function(e,t){t.elements.forEach(function(t){t&&extractors[t.type](e,t)})},RestElement:function(e,t){extractors[t.argument.type](e,t.argument)},AssignmentPattern:function(e,t){extractors[t.left.type](e,t.left)}};function getOriginalLocation(e,t){for(var r=e.filter(function(e){return e.mappings});r.length>0;){var n=r.pop(),i=n.mappings[t.line-1],s=!1;if(void 0!==i)for(var o=0,a=i;o<a.length;o++){var u=a[o];if(u[0]>=t.column){if(u.length<4)break;t={column:u[3],line:u[2]+1,name:n.names[u[4]],source:n.sources[u[1]]},s=!0;break}}if(!s)throw new Error("Can't resolve original location of error.")}return t}function skipThrough(e,t,r){r(e,t)}function ignore(e,t,r){}var base$1={};function handlePureAnnotationsOfNode(e,t,r){void 0===r&&(r=e.type);for(var n=t.commentNodes[t.commentIndex];n&&e.start>=n.end;)markPureNode(e,n),n=t.commentNodes[++t.commentIndex];n&&n.end<=e.end&&base$1[r](e,t,handlePureAnnotationsOfNode)}function markPureNode(e,t){e.annotations?e.annotations.push(t):e.annotations=[t],"ExpressionStatement"===e.type&&(e=e.expression),"CallExpression"!==e.type&&"NewExpression"!==e.type||(e.annotatedPure=!0)}base$1.Program=base$1.BlockStatement=function(e,t,r){for(var n=0,i=e.body;n<i.length;n+=1){r(i[n],t,"Statement")}},base$1.Statement=skipThrough,base$1.EmptyStatement=ignore,base$1.ExpressionStatement=base$1.ParenthesizedExpression=function(e,t,r){return r(e.expression,t,"Expression")},base$1.IfStatement=function(e,t,r){r(e.test,t,"Expression"),r(e.consequent,t,"Statement"),e.alternate&&r(e.alternate,t,"Statement")},base$1.LabeledStatement=function(e,t,r){return r(e.body,t,"Statement")},base$1.BreakStatement=base$1.ContinueStatement=ignore,base$1.WithStatement=function(e,t,r){r(e.object,t,"Expression"),r(e.body,t,"Statement")},base$1.SwitchStatement=function(e,t,r){r(e.discriminant,t,"Expression");for(var n=0,i=e.cases;n<i.length;n+=1){var s=i[n];s.test&&r(s.test,t,"Expression");for(var o=0,a=s.consequent;o<a.length;o+=1){r(a[o],t,"Statement")}}},base$1.SwitchCase=function(e,t,r){e.test&&r(e.test,t,"Expression");for(var n=0,i=e.consequent;n<i.length;n+=1){r(i[n],t,"Statement")}},base$1.ReturnStatement=base$1.YieldExpression=base$1.AwaitExpression=function(e,t,r){e.argument&&r(e.argument,t,"Expression")},base$1.ThrowStatement=base$1.SpreadElement=function(e,t,r){return r(e.argument,t,"Expression")},base$1.TryStatement=function(e,t,r){r(e.block,t,"Statement"),e.handler&&r(e.handler,t),e.finalizer&&r(e.finalizer,t,"Statement")},base$1.CatchClause=function(e,t,r){e.param&&r(e.param,t,"Pattern"),r(e.body,t,"Statement")},base$1.WhileStatement=base$1.DoWhileStatement=function(e,t,r){r(e.test,t,"Expression"),r(e.body,t,"Statement")},base$1.ForStatement=function(e,t,r){e.init&&r(e.init,t,"ForInit"),e.test&&r(e.test,t,"Expression"),e.update&&r(e.update,t,"Expression"),r(e.body,t,"Statement")},base$1.ForInStatement=base$1.ForOfStatement=function(e,t,r){r(e.left,t,"ForInit"),r(e.right,t,"Expression"),r(e.body,t,"Statement")},base$1.ForInit=function(e,t,r){"VariableDeclaration"===e.type?r(e,t):r(e,t,"Expression")},base$1.DebuggerStatement=ignore,base$1.FunctionDeclaration=function(e,t,r){return r(e,t,"Function")},base$1.VariableDeclaration=function(e,t,r){for(var n=0,i=e.declarations;n<i.length;n+=1){r(i[n],t)}},base$1.VariableDeclarator=function(e,t,r){r(e.id,t,"Pattern"),e.init&&r(e.init,t,"Expression")},base$1.Function=function(e,t,r){e.id&&r(e.id,t,"Pattern");for(var n=0,i=e.params;n<i.length;n+=1){r(i[n],t,"Pattern")}r(e.body,t,e.expression?"Expression":"Statement")},base$1.Pattern=function(e,t,r){"Identifier"===e.type?r(e,t,"VariablePattern"):"MemberExpression"===e.type?r(e,t,"MemberPattern"):r(e,t)},base$1.VariablePattern=ignore,base$1.MemberPattern=skipThrough,base$1.RestElement=function(e,t,r){return r(e.argument,t,"Pattern")},base$1.ArrayPattern=function(e,t,r){for(var n=0,i=e.elements;n<i.length;n+=1){var s=i[n];s&&r(s,t,"Pattern")}},base$1.ObjectPattern=function(e,t,r){for(var n=0,i=e.properties;n<i.length;n+=1){var s=i[n];"Property"===s.type?(s.computed&&r(s.key,t,"Expression"),r(s.value,t,"Pattern")):"RestElement"===s.type&&r(s.argument,t,"Pattern")}},base$1.Expression=skipThrough,base$1.ThisExpression=base$1.Super=base$1.MetaProperty=ignore,base$1.ArrayExpression=function(e,t,r){for(var n=0,i=e.elements;n<i.length;n+=1){var s=i[n];s&&r(s,t,"Expression")}},base$1.ObjectExpression=function(e,t,r){for(var n=0,i=e.properties;n<i.length;n+=1){r(i[n],t)}},base$1.FunctionExpression=base$1.ArrowFunctionExpression=base$1.FunctionDeclaration,base$1.SequenceExpression=function(e,t,r){for(var n=0,i=e.expressions;n<i.length;n+=1){r(i[n],t,"Expression")}},base$1.TemplateLiteral=function(e,t,r){for(var n=0,i=e.quasis;n<i.length;n+=1){r(i[n],t)}for(var s=0,o=e.expressions;s<o.length;s+=1){r(o[s],t,"Expression")}},base$1.TemplateElement=ignore,base$1.UnaryExpression=base$1.UpdateExpression=function(e,t,r){r(e.argument,t,"Expression")},base$1.BinaryExpression=base$1.LogicalExpression=function(e,t,r){r(e.left,t,"Expression"),r(e.right,t,"Expression")},base$1.AssignmentExpression=base$1.AssignmentPattern=function(e,t,r){r(e.left,t,"Pattern"),r(e.right,t,"Expression")},base$1.ConditionalExpression=function(e,t,r){r(e.test,t,"Expression"),r(e.consequent,t,"Expression"),r(e.alternate,t,"Expression")},base$1.NewExpression=base$1.CallExpression=function(e,t,r){if(r(e.callee,t,"Expression"),e.arguments)for(var n=0,i=e.arguments;n<i.length;n+=1){r(i[n],t,"Expression")}},base$1.MemberExpression=function(e,t,r){r(e.object,t,"Expression"),e.computed&&r(e.property,t,"Expression")},base$1.ExportNamedDeclaration=base$1.ExportDefaultDeclaration=function(e,t,r){e.declaration&&r(e.declaration,t,"ExportNamedDeclaration"===e.type||e.declaration.id?"Statement":"Expression"),e.source&&r(e.source,t,"Expression")},base$1.ExportAllDeclaration=function(e,t,r){r(e.source,t,"Expression")},base$1.ImportDeclaration=function(e,t,r){for(var n=0,i=e.specifiers;n<i.length;n+=1){r(i[n],t)}r(e.source,t,"Expression")},base$1.ImportSpecifier=base$1.ImportDefaultSpecifier=base$1.ImportNamespaceSpecifier=base$1.Identifier=base$1.Literal=ignore,base$1.TaggedTemplateExpression=function(e,t,r){r(e.tag,t,"Expression"),r(e.quasi,t,"Expression")},base$1.ClassDeclaration=base$1.ClassExpression=function(e,t,r){return r(e,t,"Class")},base$1.Class=function(e,t,r){e.id&&r(e.id,t,"Pattern"),e.superClass&&r(e.superClass,t,"Expression"),r(e.body,t)},base$1.ClassBody=function(e,t,r){for(var n=0,i=e.body;n<i.length;n+=1){r(i[n],t)}},base$1.MethodDefinition=base$1.Property=function(e,t,r){e.computed&&r(e.key,t,"Expression"),r(e.value,t,"Expression")};var pureCommentRegex=/[@#]__PURE__/,isPureComment=function(e){return pureCommentRegex.test(e.text)};function markPureCallExpressions(e,t){handlePureAnnotationsOfNode(t,{commentIndex:0,commentNodes:e.filter(isPureComment)})}var SOURCEMAPPING_URL="sourceMa";SOURCEMAPPING_URL+="ppingURL";var SOURCEMAPPING_URL_RE=new RegExp("^#\\s+"+SOURCEMAPPING_URL+"=.+\\n?"),NOOP=function(){},getStartTime=function(){return 0},getElapsedTime=function(){return 0},getMemory=function(){return 0},timers={},normalizeHrTime=function(e){return 1e3*e[0]+e[1]/1e6};function setTimeHelpers(){"undefined"!=typeof process&&"function"==typeof process.hrtime?(getStartTime=process.hrtime.bind(process),getElapsedTime=function(e){return normalizeHrTime(process.hrtime(e))}):"undefined"!=typeof performance&&"function"==typeof performance.now&&(getStartTime=performance.now.bind(performance),getElapsedTime=function(e){return performance.now()-e}),"undefined"!=typeof process&&"function"==typeof process.memoryUsage&&(getMemory=function(){return process.memoryUsage().heapUsed})}function getPersistedLabel(e,t){switch(t){case 1:return"# "+e;case 2:return"## "+e;case 3:return e;default:return"  ".repeat(t-4)+"- "+e}}function timeStartImpl(e,t){void 0===t&&(t=3),e=getPersistedLabel(e,t),timers.hasOwnProperty(e)||(timers[e]={memory:0,startMemory:void 0,startTime:void 0,time:0,totalMemory:0});var r=getMemory();timers[e].startTime=getStartTime(),timers[e].startMemory=r}function timeEndImpl(e,t){if(void 0===t&&(t=3),e=getPersistedLabel(e,t),timers.hasOwnProperty(e)){var r=getMemory();timers[e].time+=getElapsedTime(timers[e].startTime),timers[e].totalMemory=Math.max(timers[e].totalMemory,r),timers[e].memory+=r-timers[e].startMemory}}function getTimings(){var e={};return Object.keys(timers).forEach(function(t){e[t]=[timers[t].time,timers[t].memory,timers[t].totalMemory]}),e}var timeStart=NOOP,timeEnd=NOOP,TIMED_PLUGIN_HOOKS={load:!0,ongenerate:!0,onwrite:!0,resolveDynamicImport:!0,resolveId:!0,transform:!0,transformBundle:!0};function getPluginWithTimers(e,t){for(var r={},n=function(n){if(!0===TIMED_PLUGIN_HOOKS[n]){var i="plugin "+t;e.name&&(i+=" ("+e.name+")"),i+=" - "+n,r[n]=function(){timeStart(i,4);var t=e[n].apply(this===r?e:this,arguments);return timeEnd(i,4),t&&"function"==typeof t.then&&(timeStart(i+" (async)",4),t.then(function(){return timeEnd(i+" (async)",4)})),t}}else r[n]=e[n]},i=0,s=Object.keys(e);i<s.length;i++){n(s[i])}return r}function initialiseTimers(e){e.perf?(timers={},setTimeHelpers(),timeStart=timeStartImpl,timeEnd=timeEndImpl,e.plugins=e.plugins.map(getPluginWithTimers)):(timeStart=NOOP,timeEnd=NOOP)}function visitStaticModuleDependencies(e,t){for(var r=[e],n={},i=0,s=r;i<s.length;i++){var o=s[i];if(!(t(o)||o instanceof ExternalModule))for(var a=0,u=o.dependencies;a<u.length;a++){var c=u[a];n[c.id]||(n[c.id]=!0,r.push(c))}}}var defaultAcornOptions={ecmaVersion:2019,preserveParens:!1,sourceType:"module"};function tryParse(e,t,r){try{return t.parse(e.code,__assign({},defaultAcornOptions,r,{onComment:function(t,r,n,i){return e.comments.push({block:t,text:r,start:n,end:i})}}))}catch(t){var n=t.message.replace(/ \(\d+:\d+\)$/,"");e.id.endsWith(".json")?n+=" (Note that you need rollup-plugin-json to import JSON files)":e.id.endsWith(".js")||(n+=" (Note that you need plugins to import files that are not JavaScript)"),e.error({code:"PARSE_ERROR",message:n},t.pos)}}function handleMissingExport(e,t,r,n){t.error({code:"MISSING_EXPORT",message:"'"+e+"' is not exported by "+relativeId(r),url:"https://rollupjs.org/guide/en#error-name-is-not-exported-by-module-"},n)}var _a,MISSING_EXPORT_SHIM_DESCRIPTION={localName:MISSING_EXPORT_SHIM_VARIABLE},Module=function(){function e(e,t){this.chunkAlias=void 0,this.comments=[],this.dependencies=[],this.dynamicallyImportedBy=[],this.dynamicDependencies=[],this.dynamicImports=[],this.entryPointsHash=new Uint8Array(10),this.execIndex=1/0,this.exportAllModules=null,this.exportAllSources=[],this.exports=Object.create(null),this.exportsAll=Object.create(null),this.exportShimVariable=new ExportShimVariable(this),this.facadeChunk=null,this.importDescriptions=Object.create(null),this.importMetas=[],this.imports=new Set,this.isEntryPoint=!1,this.isExecuted=!1,this.reexports=Object.create(null),this.sources=[],this.usesTopLevelAwait=!1,this.namespaceVariable=void 0,this.id=t,this.graph=e,this.excludeFromSourcemap=/\0/.test(t),this.context=e.getModuleContext(t)}return e.prototype.basename=function(){var e=path$2.basename(this.id),t=path$2.extname(this.id);return makeLegal(t?e.slice(0,-t.length):e)},e.prototype.bindReferences=function(){this.ast.bind()},e.prototype.error=function(e,t){if(void 0!==t){e.pos=t;var r=locate(this.code,t,{offsetLine:1});try{r=getOriginalLocation(this.sourcemapChain,r)}catch(e){this.warn({code:"SOURCEMAP_ERROR",loc:{column:r.column,file:this.id,line:r.line},message:"Error when using sourcemap for reporting an error: "+e.message,pos:t},void 0)}e.loc={column:r.column,file:this.id,line:r.line},e.frame=getCodeFrame(this.originalCode,r.line,r.column)}error(e)},e.prototype.getAllExports=function(){var e=Object.assign(Object.create(null),this.exports,this.reexports);return this.exportAllModules.forEach(function(t){if(t.isExternal)e["*"+t.id]=!0;else for(var r=0,n=t.getAllExports();r<n.length;r++){var i=n[r];"default"!==i&&(e[i]=!0)}}),Object.keys(e)},e.prototype.getDynamicImportExpressions=function(){return this.dynamicImports.map(function(e){var t=e.node.parent.arguments[0];if(isTemplateLiteral(t)){if(0===t.expressions.length&&1===t.quasis.length)return t.quasis[0].value.cooked}else{if(!isLiteral(t))return t;if("string"==typeof t.value)return t.value}})},e.prototype.getExports=function(){return Object.keys(this.exports)},e.prototype.getOrCreateNamespace=function(){return this.namespaceVariable||(this.namespaceVariable=new NamespaceVariable(this.astContext))},e.prototype.getReexports=function(){var e=Object.create(null);for(var t in this.reexports)e[t]=!0;return this.exportAllModules.forEach(function(t){if(t.isExternal)e["*"+t.id]=!0;else for(var r=0,n=t.getExports().concat(t.getReexports());r<n.length;r++){var i=n[r];"default"!==i&&(e[i]=!0)}}),Object.keys(e)},e.prototype.getRenderedExports=function(){var e=[],t=[];for(var r in this.exports){var n=this.exports[r];(n.node&&n.node.included?e:t).push(r)}return{renderedExports:e,removedExports:t}},e.prototype.getVariableForExportName=function(e,t){if("*"===e[0])return 1===e.length?this.getOrCreateNamespace():this.graph.moduleById.get(e.slice(1)).getVariableForExportName("*");var r=this.reexports[e];if(r)return(o=r.module.getVariableForExportName(r.localName))||handleMissingExport(r.localName,this,r.module.id,r.start),o;var n=this.exports[e];if(n){if(n===MISSING_EXPORT_SHIM_DESCRIPTION)return this.exportShimVariable;var i=n.localName;return this.traceVariable(i)||this.graph.scope.findVariable(i)}if("default"!==e)for(var s=0;s<this.exportAllModules.length;s+=1){var o;if(o=this.exportAllModules[s].getVariableForExportName(e,!0))return o}return this.graph.shimMissingExports&&!t?(this.shimMissingExport(e),this.exportShimVariable):void 0},e.prototype.include=function(){this.ast.shouldBeIncluded()&&this.ast.include(!1)},e.prototype.includeAllExports=function(){this.isExecuted||(this.graph.needsTreeshakingPass=!0,visitStaticModuleDependencies(this,function(e){return!!(e instanceof ExternalModule||e.isExecuted)||(e.isExecuted=!0,!1)}));for(var e=0,t=this.getExports();e<t.length;e++){var r=t[e];(s=this.getVariableForExportName(r)).deoptimizePath(UNKNOWN_PATH),s.included||(s.include(),this.graph.needsTreeshakingPass=!0)}for(var n=0,i=this.getReexports();n<i.length;n++){var s,o=i[n];(s=this.getVariableForExportName(o)).isExternal?s.reexported=s.module.reexported=!0:s.included||(s.include(),s.deoptimizePath(UNKNOWN_PATH),this.graph.needsTreeshakingPass=!0)}},e.prototype.includeAllInBundle=function(){this.ast.include(!0)},e.prototype.isIncluded=function(){return this.ast.included||this.namespaceVariable&&this.namespaceVariable.included},e.prototype.linkDependencies=function(){for(var t=this,r=0,n=this.sources;r<n.length;r++){var i=n[r],s=this.resolvedIds[i].id;if(s){var o=this.graph.moduleById.get(s);this.dependencies.push(o)}}for(var a=0,u=this.dynamicImports;a<u.length;a++){var c=u[a].resolution;(c instanceof e||c instanceof ExternalModule)&&this.dynamicDependencies.push(c)}this.addModulesToSpecifiers(this.importDescriptions),this.addModulesToSpecifiers(this.reexports),this.exportAllModules=this.exportAllSources.map(function(e){var r=t.resolvedIds[e].id;return t.graph.moduleById.get(r)})},e.prototype.render=function(e){var t=this.magicString.clone();return this.ast.render(t,e),this.usesTopLevelAwait=this.astContext.usesTopLevelAwait,t},e.prototype.setSource=function(e){var t=this,r=e.code,n=e.originalCode,i=e.originalSourcemap,s=e.ast,o=e.sourcemapChain,a=e.resolvedIds,u=e.transformDependencies,c=e.customTransformCache;this.code=r,this.originalCode=n,this.originalSourcemap=i,this.sourcemapChain=o,this.transformDependencies=u,this.customTransformCache=c,timeStart("generate ast",3),this.esTreeAst=s||tryParse(this,this.graph.acornParser,this.graph.acornOptions),markPureCallExpressions(this.comments,this.esTreeAst),timeEnd("generate ast",3),this.resolvedIds=a||Object.create(null);var p=this.id;this.magicString=new MagicString(r,{filename:this.excludeFromSourcemap?null:p,indentExclusionRanges:[]}),this.removeExistingSourceMap(),timeStart("analyse ast",3),this.astContext={addDynamicImport:this.addDynamicImport.bind(this),addExport:this.addExport.bind(this),addImport:this.addImport.bind(this),addImportMeta:this.addImportMeta.bind(this),annotations:this.graph.treeshake&&this.graph.treeshakingOptions.annotations,code:r,deoptimizationTracker:this.graph.deoptimizationTracker,error:this.error.bind(this),fileName:p,getAssetFileName:this.graph.pluginDriver.getAssetFileName,getExports:this.getExports.bind(this),getModuleExecIndex:function(){return t.execIndex},getModuleName:this.basename.bind(this),getReexports:this.getReexports.bind(this),importDescriptions:this.importDescriptions,includeDynamicImport:this.includeDynamicImport.bind(this),includeVariable:this.includeVariable.bind(this),isCrossChunkImport:function(e){return e.module.chunk!==t.chunk},magicString:this.magicString,module:this,moduleContext:this.context,nodeConstructors:nodeConstructors,preserveModules:this.graph.preserveModules,propertyReadSideEffects:!this.graph.treeshake||this.graph.treeshakingOptions.propertyReadSideEffects,traceExport:this.getVariableForExportName.bind(this),traceVariable:this.traceVariable.bind(this),treeshake:this.graph.treeshake,usesTopLevelAwait:!1,warn:this.warn.bind(this)},this.scope=new ModuleScope(this.graph.scope,this.astContext),this.ast=new Program$1(this.esTreeAst,{type:"Module",context:this.astContext},this.scope),timeEnd("analyse ast",3)},e.prototype.toJSON=function(){return{ast:this.esTreeAst,code:this.code,customTransformCache:this.customTransformCache,dependencies:this.dependencies.map(function(e){return e.id}),id:this.id,originalCode:this.originalCode,originalSourcemap:this.originalSourcemap,resolvedIds:this.resolvedIds,sourcemapChain:this.sourcemapChain,transformAssets:this.transformAssets,transformDependencies:this.transformDependencies}},e.prototype.traceVariable=function(e){if(e in this.scope.variables)return this.scope.variables[e];if(e in this.importDescriptions){var t=this.importDescriptions[e],r=t.module;if(!r.isExternal&&"*"===t.name)return r.getOrCreateNamespace();var n=r.getVariableForExportName(t.name);return n||handleMissingExport(t.name,this,r.id,t.start),n}return null},e.prototype.warn=function(e,t){if(void 0!==t){e.pos=t;var r=locate(this.code,t,{offsetLine:1}),n=r.line,i=r.column;e.loc={file:this.id,line:n,column:i},e.frame=getCodeFrame(this.code,n,i)}e.id=this.id,this.graph.warn(e)},e.prototype.addDynamicImport=function(e){this.dynamicImports.push({node:e,alias:void 0,resolution:void 0})},e.prototype.addExport=function(e){var t=e.source&&e.source.value;if(t)if(-1===this.sources.indexOf(t)&&this.sources.push(t),e.type===ExportAllDeclaration)this.exportAllSources.push(t);else for(var r=0,n=e.specifiers;r<n.length;r++){var i=(f=n[r]).exported.name;(this.exports[i]||this.reexports[i])&&this.error({code:"DUPLICATE_EXPORT",message:"A module cannot have multiple exports with the same name ('"+i+"')"},f.start),this.reexports[i]={localName:f.local.name,module:null,source:t,start:f.start}}else if(isExportDefaultDeclaration(e))this.exports.default&&this.error({code:"DUPLICATE_EXPORT",message:"A module can only have one default export"},e.start),this.exports.default={identifier:e.variable.getOriginalVariableName(),localName:"default",node:e};else if(e.declaration){var s=e.declaration;if(s.type===VariableDeclaration)for(var o=0,a=s.declarations;o<a.length;o++)for(var u=0,c=extractNames(a[o].id);u<c.length;u++){var p=c[u];this.exports[p]={localName:p,node:e}}else{p=s.id.name;this.exports[p]={localName:p,node:e}}}else for(var l=0,h=e.specifiers;l<h.length;l++){p=(f=h[l]).local.name;var f,d=f.exported.name;(this.exports[d]||this.reexports[d])&&this.error({code:"DUPLICATE_EXPORT",message:"A module cannot have multiple exports with the same name ('"+d+"')"},f.start),this.exports[d]={localName:p,node:e}}},e.prototype.addImport=function(e){var t=e.source.value;-1===this.sources.indexOf(t)&&this.sources.push(t);for(var r=0,n=e.specifiers;r<n.length;r++){var i=n[r],s=i.local.name;this.importDescriptions[s]&&this.error({code:"DUPLICATE_IMPORT",message:"Duplicated import '"+s+"'"},i.start);var o=i.type===ImportDefaultSpecifier,a=i.type===ImportNamespaceSpecifier,u=o?"default":a?"*":i.imported.name;this.importDescriptions[s]={source:t,start:i.start,name:u,module:null}}},e.prototype.addImportMeta=function(e){this.importMetas.push(e)},e.prototype.addModulesToSpecifiers=function(e){for(var t=0,r=Object.keys(e);t<r.length;t++){var n=e[r[t]],i=this.resolvedIds[n.source].id;n.module=this.graph.moduleById.get(i)}},e.prototype.includeDynamicImport=function(t){var r=this.dynamicImports.find(function(e){return e.node===t}).resolution;r instanceof e&&(r.dynamicallyImportedBy.push(this),r.includeAllExports())},e.prototype.includeVariable=function(e){e.included||(e.include(),this.graph.needsTreeshakingPass=!0),e.module&&e.module!==this&&this.imports.add(e)},e.prototype.removeExistingSourceMap=function(){for(var e=0,t=this.comments;e<t.length;e++){var r=t[e];!r.block&&SOURCEMAPPING_URL_RE.test(r.text)&&this.magicString.remove(r.start,r.end)}},e.prototype.shimMissingExport=function(e){this.exports[e]||(this.graph.warn({code:"SHIMMED_EXPORT",exporter:relativeId(this.id),exportName:e,message:'Missing export "'+e+'" has been shimmed in module '+relativeId(this.id)+"."}),this.exports[e]=MISSING_EXPORT_SHIM_DESCRIPTION)},e}(),Source=function(){function e(e,t){this.isOriginal=!0,this.filename=e,this.content=t}return e.prototype.traceSegment=function(e,t,r){return{line:e,column:t,name:r,source:this}},e}(),Link=function(){function e(e,t){this.sources=t,this.names=e.names,this.mappings=e.mappings}return e.prototype.traceMappings=function(){for(var e=[],t=[],r=[],n=[],i=0,s=this.mappings;i<s.length;i++){for(var o=[],a=0,u=s[i];a<u.length;a++){var c=u[a],p=this.sources[c[1]];if(p){var l=p.traceSegment(c[2],c[3],this.names[c[4]]);if(l){var h=e.lastIndexOf(l.source.filename);-1===h?(h=e.length,e.push(l.source.filename),t[h]=l.source.content):null==t[h]?t[h]=l.source.content:null!=l.source.content&&t[h]!==l.source.content&&error({message:"Multiple conflicting contents for sourcemap source "+l.source.filename});var f=[c[0],h,l.line,l.column];if(l.name){var d=r.indexOf(l.name);-1===d&&(d=r.length,r.push(l.name)),f[4]=d}o.push(f)}}}n.push(o)}return{sources:e,sourcesContent:t,names:r,mappings:n}},e.prototype.traceSegment=function(e,t,r){var n=this.mappings[e];if(!n)return null;for(var i=0,s=n.length-1;i<=s;){var o=i+s>>1,a=n[o];if(a[0]===t){var u=this.sources[a[1]];return u?u.traceSegment(a[2],a[3],this.names[a[4]]||r):null}a[0]>t?s=o-1:i=o+1}return null},e}();function collapseSourcemaps(e,t,r,n,i,s){function o(t,r){return r.missing&&(e.graph.warn({code:"SOURCEMAP_BROKEN",message:"Sourcemap is likely to be incorrect: a plugin"+(r.plugin?" ('"+r.plugin+"')":"")+" was used to transform files, but didn't generate a sourcemap for the transformation. Consult the plugin documentation for help",plugin:r.plugin,url:"https://rollupjs.org/guide/en#warning-sourcemap-is-likely-to-be-incorrect"}),r={mappings:"",names:[]}),new Link(r,[t])}var a=n.filter(function(e){return!e.excludeFromSourcemap}).map(function(e){var t,r=e.sourcemapChain,n=e.originalSourcemap;if(n){var i=n.sources,s=n.sourcesContent||[];if(null==i||i.length<=1&&null==i[0])t=new Source(e.id,s[0]),r=[n].concat(r);else{var a=path$2.dirname(e.id)||".",u=n.sourceRoot||".",c=i.map(function(e,t){return new Source(path$2.resolve(a,u,e),s[t])});t=new Link(n,c)}}else t=new Source(e.id,e.originalCode);return t=r.reduce(o,t)}),u=new Link(r,a),c=(u=i.reduce(o,u)).traceMappings(),p=c.sources,l=c.sourcesContent,h=c.names,f=c.mappings;if(t){var d=path$2.dirname(t);p=p.map(function(e){return path$2.relative(d,e)}),t=path$2.basename(t)}return new SourceMap({file:t,sources:p,sourcesContent:l=s?null:l,names:h,mappings:f})}var RESERVED_NAMES=Object.assign(Object.create(null),{await:!0,break:!0,case:!0,catch:!0,class:!0,const:!0,continue:!0,debugger:!0,default:!0,delete:!0,do:!0,else:!0,enum:!0,eval:!0,export:!0,extends:!0,finally:!0,for:!0,function:!0,if:!0,implements:!0,import:!0,in:!0,instanceof:!0,interface:!0,let:!0,new:!0,null:!0,package:!0,private:!0,protected:!0,public:!0,return:!0,static:!0,super:!0,switch:!0,throw:!0,try:!0,typeof:!0,undefined:!0,var:!0,void:!0,while:!0,with:!0,yield:!0}),NONE={},EXPORTS={exports:!0},RESERVED_NAMES_BY_FORMAT={amd:{formatGlobals:EXPORTS,forbiddenNames:RESERVED_NAMES},cjs:{forbiddenNames:RESERVED_NAMES,formatGlobals:(_a={exports:!0,module:!0},_a[INTEROP_DEFAULT_VARIABLE]=!0,_a)},es:{formatGlobals:NONE,forbiddenNames:RESERVED_NAMES},iife:{formatGlobals:EXPORTS,forbiddenNames:RESERVED_NAMES},system:{forbiddenNames:Object.assign(Object.create(null),RESERVED_NAMES,EXPORTS),formatGlobals:NONE},umd:{formatGlobals:EXPORTS,forbiddenNames:RESERVED_NAMES}},DECONFLICT_IMPORTED_VARIABLES_BY_FORMAT={amd:deconflictImportsOther,cjs:deconflictImportsOther,es:deconflictImportsEsm,iife:deconflictImportsOther,system:deconflictImportsEsm,umd:deconflictImportsOther};function deconflictChunk(e,t,r,n,i,s,o){var a=RESERVED_NAMES_BY_FORMAT[i],u=a.forbiddenNames,c=a.formatGlobals;Object.assign(n,u),Object.assign(n,c),addUsedGlobalNames(n,e),deconflictTopLevelVariables(n,e),DECONFLICT_IMPORTED_VARIABLES_BY_FORMAT[i](n,r,t,s,o);for(var p=0,l=e;p<l.length;p++){l[p].scope.deconflict(u)}}function addUsedGlobalNames(e,t){for(var r=Object.assign.apply(Object,[{}].concat(t.map(function(e){return e.scope.accessedOutsideVariables}))),n=0,i=Object.keys(r);n<i.length;n++){var s=i[n];r[s].included&&(e[s]=!0)}}function deconflictImportsEsm(e,t,r,n){for(var i=0,s=Array.from(t);i<s.length;i++){var o=s[i],a=o.module,u=o.name,c=void 0;c=a instanceof ExternalModule&&("*"===u||"default"===u)?"default"===u&&n&&a.exportsNamespace?a.variableName+"__default":a.variableName:u,o.setRenderNames(null,getSafeName(c,e))}}function deconflictImportsOther(e,t,r,n,i){for(var s=0,o=r;s<o.length;s++){var a=o[s];a.variableName=getSafeName(a.variableName,e)}for(var u=0,c=Array.from(t);u<c.length;u++){var p=c[u],l=p.module;if(l instanceof ExternalModule){var h=p.name;"default"===h&&n&&(l.exportsNamespace||l.exportsNames)?p.setRenderNames(null,l.variableName+"__default"):"*"===h||"default"===h?p.setRenderNames(null,l.variableName):p.setRenderNames(l.variableName,null)}else{var f=l.chunk;"default"===f.exportMode||i&&p.isNamespace?p.setRenderNames(null,f.variableName):p.setRenderNames(f.variableName,l.chunk.getVariableExportName(p))}}}function deconflictTopLevelVariables(e,t){for(var r=0,n=t;r<n.length;r++){for(var i=n[r],s=i.scope.variables,o=0,a=Object.keys(s);o<a.length;o++){var u=s[a[o]];u.included&&!(u.renderBaseName||u instanceof ExportDefaultVariable&&u.referencesOriginal())&&u.setRenderNames(null,getSafeName(u.name,e))}var c=i.getOrCreateNamespace();c.included&&c.setRenderNames(null,getSafeName(c.name,e))}}var compareExecIndex=function(e,t){return e.execIndex>t.execIndex?1:-1};function sortByExecutionOrder(e){e.sort(compareExecIndex)}function analyseModuleExecution(e){for(var t=0,r=!0,n=[],i={},s=[],o=[],a={},u=function(e){if(!i[e.id]){if(e instanceof ExternalModule)return e.execIndex=t++,void(i[e.id]=!0);r&&(e.isExecuted=!0);for(var c=0,p=e.dependencies;c<p.length;c++){var l=p[c];l.id in a?i[l.id]||n.push(getCyclePath(l.id,e.id,a)):(a[l.id]=e.id,u(l))}for(var h=0,f=e.dynamicImports;h<f.length;h++){var d=f[h].resolution;d instanceof Module&&-1===o.indexOf(d)&&o.push(d)}e.execIndex=t++,i[e.id]=!0,s.push(e)}},c=0,p=e;c<p.length;c++){(f=p[c]).isEntryPoint=!0,a[f.id]||(a[f.id]=null,u(f))}r=!1;for(var l=0,h=o;l<h.length;l++){var f=h[l];a[f.id]||(a[f.id]=null,u(f))}return{orderedModules:s,cyclePaths:n}}function getCyclePath(e,t,r){for(var n=[relativeId(e)],i=t;i!==e&&(n.push(relativeId(i)),i=r[i]););return n.push(n[0]),n.reverse(),n}function guessIndentString(e){var t=e.split("\n"),r=t.filter(function(e){return/^\t+/.test(e)}),n=t.filter(function(e){return/^ {2,}/.test(e)});if(0===r.length&&0===n.length)return null;if(r.length>=n.length)return"\t";var i=n.reduce(function(e,t){var r=/^ +/.exec(t)[0].length;return Math.min(r,e)},1/0);return new Array(i+1).join(" ")}function getIndentString(e,t){if(!0!==t.indent)return t.indent||"";for(var r=0;r<e.length;r++){var n=guessIndentString(e[r].originalCode);if(null!==n)return n}return"\t"}function renderChunk(e){var t=e.graph,r=e.chunk,n=e.renderChunk,i=e.code,s=e.sourcemapChain,o=e.options,a=function(e,t,r){if(null==t)return e;"string"==typeof t&&(t={code:t,map:void 0});var n="string"==typeof t.map?JSON.parse(t.map):t.map;return n&&"string"==typeof n.mappings&&(n.mappings=decode(n.mappings)),null!==n&&s.push(n||{missing:!0,plugin:r.name}),t.code},u=!1,c=!0;return t.pluginDriver.hookReduceArg0("renderChunk",[i,n,o],a).then(function(e){return c=!1,t.pluginDriver.hookReduceArg0("transformChunk",[e,o,r],a)}).then(function(e){return u=!0,t.pluginDriver.hookReduceArg0("transformBundle",[e,o,r],a)}).catch(function(e){if(c)throw e;error(e,{code:u?"BAD_BUNDLE_TRANSFORMER":"BAD_CHUNK_TRANSFORMER",message:"Error transforming "+(u?"bundle":"chunk")+(e.plugin?" with '"+e.plugin+"' plugin":"")+": "+e.message,plugin:e.plugin})})}function renderNamePattern(e,t,r){return isPlainName(e)||error({code:"INVALID_PATTERN",message:'Invalid output pattern "'+e+'" for '+t+", cannot be an absolute or relative URL or path."}),e.replace(/\[(\w+)\]/g,function(e,n){var i=r(n);return void 0===i&&error({code:"INVALID_PATTERN_REPLACEMENT",message:'"'+n+'" is not a valid substitution name in output option '+t+" pattern."}),isPlainName(i)||error({code:"INVALID_PATTERN_REPLACEMENT",message:'Invalid replacement "'+i+'" for "'+n+'" in '+t+" pattern, must be a plain path name."}),i})}function makeUnique(e,t){if(e in t==!1)return e;var r=path$2.extname(e);e=e.substr(0,e.length-r.length);for(var n,i=1;t[n=e+ ++i+r];);return n}function sanitizeFileName(e){return e.replace(/[\0]/g,"_")}function getGlobalName(e,t,r,n){var i;return"function"==typeof t?i=t(e.id):t&&(i=t[e.id]),i||(n?(r.warn({code:"MISSING_GLOBAL_NAME",guess:e.variableName,message:"No name was provided for external module '"+e.id+"' in output.globals – guessing '"+e.variableName+"'",source:e.id}),e.variableName):void 0)}var Chunk$1=function(){function e(e,t){this.entryModules=[],this.exportMode="named",this.facadeModule=null,this.hasDynamicImport=!1,this.id=void 0,this.indentString=void 0,this.isManualChunk=!1,this.usedModules=void 0,this.dependencies=void 0,this.dynamicDependencies=void 0,this.exportNames=Object.create(null),this.exports=new Set,this.imports=new Set,this.needsExportsShim=!1,this.renderedDeclarations=void 0,this.renderedHash=void 0,this.renderedModuleSources=void 0,this.renderedSource=null,this.renderedSourceLength=void 0,this.graph=e,this.orderedModules=t,this.execIndex=t.length>0?t[0].execIndex:1/0,this.isEmpty=!0;for(var r=0,n=t;r<n.length;r++){var i=n[r];this.isEmpty&&i.isIncluded()&&(this.isEmpty=!1),i.chunkAlias&&(this.isManualChunk=!0),i.chunk=this,(i.isEntryPoint||i.dynamicallyImportedBy.some(function(e){return-1===t.indexOf(e)}))&&this.entryModules.push(i)}this.entryModules.length>0?this.variableName=makeLegal(path$2.basename(this.entryModules.map(function(e){return e.chunkAlias}).find(Boolean)||this.entryModules[0].id)):this.variableName="__chunk_"+ ++e.curChunkIndex}return e.prototype.generateEntryExportsOrMarkAsTainted=function(){for(var e=this,t=this.entryModules.map(function(t){return{map:e.getVariableExportNamesForModule(t),module:t}}),r=0,n=t;r<n.length;r++)for(var i=n[r].map,s=0,o=Array.from(i.keys());s<o.length;s++){var a=o[s];this.exports.add(a)}var u=Array.from(this.exports);e:for(var c=0,p=t;c<p.length;c++){var l=p[c],h=(i=l.map,l.module);if(!this.graph.preserveModules)for(var f=0,d=u;f<d.length;f++){a=d[f];if(!i.has(a))continue e}this.facadeModule=h;for(var m=0,g=Array.from(i);m<g.length;m++)for(var y=g[m],v=y[0],_=0,b=y[1];_<b.length;_++){var E=b[_];this.exportNames[E]=v}return}},e.prototype.generateId=function(e,t,r,n,i){var s=this;this.id=makeUnique(renderNamePattern(e,t,function(e){switch(e){case"format":return"es"===n.format?"esm":n.format;case"hash":return s.computeContentHashWithDependencies(r,n);case"name":return s.getChunkName()}}),i)},e.prototype.generateIdPreserveModules=function(e,t){var r=sanitizeFileName(this.orderedModules[0].id);this.id=makeUnique(normalize$1(isAbsolute(this.orderedModules[0].id)?path$2.relative(e,r):"_virtual/"+path$2.basename(r)),t)},e.prototype.generateInternalExports=function(e){if(null===this.facadeModule){var t,r="system"===e.format||"es"===e.format||e.compact,n=0;this.exportNames=Object.create(null);var i=Array.from(this.exports);if(r)for(var s=0,o=i;s<o.length;s++){var a=o[s];49===(t=toBase64(++n)).charCodeAt(0)&&(t=toBase64(n+=9*Math.pow(64,t.length-1))),this.exportNames[t]=a}else for(var u=0,c=i;u<c.length;u++){for(n=0,t=(a=c[u]).name;this.exportNames[t];)t=a.name+"$"+ ++n;this.exportNames[t]=a}}},e.prototype.getChunkName=function(){return this.chunkName||(this.chunkName=this.computeChunkName())},e.prototype.getDynamicImportIds=function(){return this.dynamicDependencies.map(function(e){return e.id}).filter(Boolean)},e.prototype.getExportNames=function(){return Object.keys(this.exportNames)},e.prototype.getImportIds=function(){return this.dependencies.map(function(e){return e.id})},e.prototype.getRenderedHash=function(){if(this.renderedHash)return this.renderedHash;if(!this.renderedSource)return"";var e=_256();return e.update(this.renderedSource.toString()),e.update(Object.keys(this.exportNames).join(",")),this.renderedHash=e.digest("hex")},e.prototype.getRenderedSourceLength=function(){return void 0!==this.renderedSourceLength?this.renderedSourceLength:this.renderedSourceLength=this.renderedSource.length()},e.prototype.getVariableExportName=function(e){if(this.graph.preserveModules&&e instanceof NamespaceVariable)return"*";for(var t=0,r=Object.keys(this.exportNames);t<r.length;t++){var n=r[t];if(this.exportNames[n]===e)return n}},e.prototype.link=function(){for(var e=new Set,t=new Set,r=0,n=this.orderedModules;r<n.length;r++){var i=n[r];this.addChunksFromDependencies(i.dependencies,e),this.addChunksFromDependencies(i.dynamicDependencies,t),this.setUpModuleImports(i)}this.dependencies=Array.from(e),this.dynamicDependencies=Array.from(t)},e.prototype.merge=function(e,t,r,n){var i=this;if(null!==this.facadeModule||null!==e.facadeModule)throw new Error("Internal error: Code splitting chunk merges not supported for facades");for(var s=0,o=e.orderedModules;s<o.length;s++){var a=o[s];a.chunk=this,this.orderedModules.push(a)}for(var u=0,c=Array.from(e.imports);u<c.length;u++){var p=c[u];this.imports.has(p)||p.module.chunk===this||this.imports.add(p)}for(var l=0,h=Array.from(e.exports);l<h.length;l++){p=h[l];this.exports.has(p)||this.exports.add(p)}var f=this.exportNames;this.generateInternalExports(r);for(var d,m,g=function(e,t){if(e.imports)for(var r=0,n=e.imports;r<n.length;r++){var s=n[r];s.imported=i.getVariableExportName(t[s.imported])}if(e.reexports)for(var o=0,a=e.reexports;o<a.length;o++){var u=a[o];u.imported=i.getVariableExportName(t[u.imported])}},y=0,v=t;y<v.length;y++)for(var _=v[y],b=void 0,E=0;E<_.dependencies.length;E++){var x=_.dependencies[E];if(x!==e&&x!==this||!b)x===e?(_.dependencies[E]=this,g(b=_.renderedDeclarations.dependencies[E],e.exportNames)):x===this&&g(b=_.renderedDeclarations.dependencies[E],f);else{var S=_.renderedDeclarations.dependencies[E];g(S,x===e?e.exportNames:f),d=b,(m=S).imports&&(d.imports?d.imports=d.imports.concat(m.imports):d.imports=m.imports),m.reexports&&(d.reexports?d.reexports=d.reexports.concat(m.reexports):d.reexports=m.reexports),!d.exportsNames&&m.exportsNames&&(d.exportsNames=!0),!d.exportsDefault&&m.exportsDefault&&(d.exportsDefault=!0),d.name=i.variableName,_.renderedDeclarations.dependencies.splice(E,1),_.dependencies.splice(E--,1)}}this.preRender(r,n)},e.prototype.preRender=function(t,r){timeStart("render modules",3);var n=new Bundle({separator:t.compact?"":"\n\n"});this.usedModules=[],this.indentString=t.compact?"":getIndentString(this.orderedModules,t);for(var i=t.compact?"":"\n",s=t.compact?"":" ",o={compact:t.compact,dynamicImportFunction:t.dynamicImportFunction,format:t.format,freeze:!1!==t.freeze,indent:this.indentString,namespaceToStringTag:!0===t.namespaceToStringTag,varOrConst:t.preferConst?"const":"var"},a=0,u=Array.from(this.imports);a<u.length;a++){var c=(m=u[a].module)instanceof Module?m.chunk:m;-1===this.dependencies.indexOf(c)&&this.dependencies.push(c)}if(!this.graph.preserveModules&&null!==this.facadeModule)for(var p=0,l=this.dependencies;p<l.length;p++){(f=l[p])instanceof e&&this.inlineChunkDependencies(f,!0)}for(var h=0;h<this.dependencies.length;h++){var f;(f=this.dependencies[h])instanceof e&&f.isEmpty&&(this.dependencies.splice(h--,1),this.inlineChunkDependencies(f,!1))}sortByExecutionOrder(this.dependencies),this.setIdentifierRenderResolutions(t),this.prepareDynamicImports();var d="";this.renderedModules=Object.create(null),this.renderedModuleSources=[];for(h=0;h<this.orderedModules.length;h++){var m,g=(m=this.orderedModules[h]).render(o);g.trim(),t.compact&&-1!==g.lastLine().indexOf("//")&&g.append("\n"),this.renderedModuleSources.push(g);var y=m.getRenderedExports(),v=y.renderedExports,_=y.removedExports;this.renderedModules[m.id]={originalLength:m.originalCode.length,removedExports:_,renderedExports:v,renderedLength:g.length()};var b=m.getOrCreateNamespace();if((b.included||!g.isEmpty())&&(n.addSource(g),this.usedModules.push(m),b.included&&!this.graph.preserveModules)){var E=b.renderBlock(o);b.renderFirst()?d+=i+E:n.addSource(new MagicString(E))}}d&&n.prepend(d+i+i),this.needsExportsShim&&n.prepend(""+i+o.varOrConst+" "+MISSING_EXPORT_SHIM_VARIABLE+s+"="+s+"void 0;"+i+i),t.compact?this.renderedSource=n:this.renderedSource=n.trim(),this.renderedSourceLength=void 0,this.renderedHash=void 0,0===this.getExportNames().length&&0===this.getImportIds().length&&this.isEmpty&&this.graph.warn({code:"EMPTY_BUNDLE",message:"Generated an empty bundle"}),this.renderedDeclarations={dependencies:this.getChunkDependencyDeclarations(t,r),exports:"none"===this.exportMode?[]:this.getChunkExportDeclarations()},timeEnd("render modules",3)},e.prototype.render=function(t,r,n){var i=this;if(timeStart("render format",3),!this.renderedSource)throw new Error("Internal error: Chunk render called before preRender");var s=finalisers[t.format];s||error({code:"INVALID_OPTION",message:"Invalid format: "+t.format+" - valid options are "+Object.keys(finalisers).join(", ")+"."}),t.dynamicImportFunction&&"es"!==t.format&&this.graph.warn({code:"INVALID_OPTION",message:'"output.dynamicImportFunction" is ignored for formats other than "esm".'});for(var o=0;o<this.dependencies.length;o++){var a=this.dependencies[o];if(!(a instanceof ExternalModule)||a.renormalizeRenderPath){var u=this.renderedDeclarations.dependencies[o],c=a instanceof ExternalModule?u.id:a.id,p=this.id?normalize$1(path$2.relative(path$2.dirname(this.id),c)):c;p.startsWith("../")||(p="./"+p),a instanceof e&&(u.namedExportsMode="default"!==a.exportMode),u.id=p}}this.finaliseDynamicImports();var l=this.finaliseImportMetas(t),h=0!==this.renderedDeclarations.exports.length||this.renderedDeclarations.dependencies.some(function(e){return e.reexports&&0!==e.reexports.length}),f=this.orderedModules.some(function(e){return e.usesTopLevelAwait});f&&"es"!==t.format&&"system"!==t.format&&error({code:"INVALID_TLA_FORMAT",message:"Module format "+t.format+' does not support top-level await. Use the "es" or "system" output formats rather.'});var d=s(this.renderedSource,{dependencies:this.renderedDeclarations.dependencies,dynamicImport:this.hasDynamicImport,exports:this.renderedDeclarations.exports,hasExports:h,indentString:this.indentString,intro:r.intro,isEntryModuleFacade:null!==this.facadeModule&&this.facadeModule.isEntryPoint,namedExportsMode:"default"!==this.exportMode,needsAmdModule:l,outro:r.outro,usesTopLevelAwait:f,varOrConst:t.preferConst?"const":"var",warn:this.graph.warn.bind(this.graph)},t);r.banner&&d.prepend(r.banner),r.footer&&d.append(r.footer);var m=d.toString();timeEnd("render format",3);var g=null,y=[];return renderChunk({chunk:this,code:m,graph:this.graph,options:t,renderChunk:n,sourcemapChain:y}).then(function(e){if(t.sourcemap){timeStart("sourcemap",3);var r=void 0;if(r=t.file?path$2.resolve(t.sourcemapFile||t.file):t.dir?path$2.resolve(t.dir,i.id):path$2.resolve(i.id),i.graph.pluginDriver.hasLoadersOrTransforms){var n=d.generateDecodedMap({});g=collapseSourcemaps(i,r,n,i.usedModules,y,t.sourcemapExcludeSources)}else g=d.generateMap({file:r,includeContent:!t.sourcemapExcludeSources});g.sources=g.sources.map(function(e){return normalize$1(t.sourcemapPathTransform?t.sourcemapPathTransform(e):e)}),timeEnd("sourcemap",3)}return!0!==t.compact&&"\n"!==e[e.length-1]&&(e+="\n"),{code:e,map:g}})},e.prototype.turnIntoFacade=function(e){this.dependencies=[e.chunk],this.dynamicDependencies=[],this.facadeModule=e,e.facadeChunk=this;for(var t=0,r=e.getAllExports();t<r.length;t++){var n=r[t],i=e.getVariableForExportName(n);this.exports.add(i),this.exportNames[n]=i}},e.prototype.visitDependencies=function(e){for(var t=[this],r=new Set,n=0,i=t;n<i.length;n++){var s=i[n];if(e(s),!(s instanceof ExternalModule))for(var o=0,a=s.dependencies.concat(s.dynamicDependencies);o<a.length;o++){var u=a[o];r.has(u)||(r.add(u),t.push(u))}}},e.prototype.visitStaticDependenciesUntilCondition=function(t){var r=new Set;return function n(i){if(!r.has(i)){if(r.add(i),i instanceof e)for(var s=0,o=i.dependencies;s<o.length;s++)if(n(o[s]))return!0;return!0===t(i)}}(this)},e.prototype.addChunksFromDependencies=function(e,t){for(var r=0,n=e;r<n.length;r++){var i=n[r];if(i.chunk!==this){var s=void 0;if(i instanceof Module)s=i.chunk;else{if(!i.used&&this.graph.isPureExternalModule(i.id))continue;s=i}t.add(s)}}},e.prototype.computeChunkName=function(){if(null!==this.facadeModule&&this.facadeModule.chunkAlias)return sanitizeFileName(this.facadeModule.chunkAlias);for(var e=0,t=this.orderedModules;e<t.length;e++){var r=t[e];if(r.chunkAlias)return sanitizeFileName(r.chunkAlias)}return"chunk"},e.prototype.computeContentHashWithDependencies=function(e,t){var r=_256();return r.update([e.intro,e.outro,e.banner,e.footer].map(function(e){return e||""}).join(":")),r.update(t.format),this.visitDependencies(function(e){e instanceof ExternalModule?r.update(":"+e.renderPath):r.update(e.getRenderedHash())}),r.digest("hex").substr(0,8)},e.prototype.finaliseDynamicImports=function(){for(var e=0;e<this.orderedModules.length;e++)for(var t=this.orderedModules[e],r=this.renderedModuleSources[e],n=0,i=t.dynamicImports;n<i.length;n++){var s=i[n],o=s.node,a=s.resolution;if(a)if(a instanceof Module){if(!a.chunk.isEmpty&&a.chunk!==this){var u=a.facadeChunk||a.chunk,c=normalize$1(path$2.relative(path$2.dirname(this.id),u.id));c.startsWith("../")||(c="./"+c),o.renderFinalResolution(r,"'"+c+"'")}}else a instanceof ExternalModule?o.renderFinalResolution(r,"'"+a.id+"'"):o.renderFinalResolution(r,a)}},e.prototype.finaliseImportMetas=function(e){for(var t=!1,r=0;r<this.orderedModules.length;r++)for(var n=this.orderedModules[r],i=this.renderedModuleSources[r],s=0,o=n.importMetas;s<o.length;s++){o[s].renderFinalMechanism(i,this.id,e.format,e.compact)&&(t=!0)}return t},e.prototype.getChunkDependencyDeclarations=function(e,t){for(var r=new Map,n=0,i=Object.keys(this.exportNames);n<i.length;n++){var s=i[n],o=void 0,a=void 0;if("*"===s[0])o=this.graph.moduleById.get(s.substr(1)),a=s="*";else{var u=(v=this.exportNames[s]).module;if(!u||u.chunk===this)continue;u instanceof Module?(o=u.chunk,a=u.chunk.getVariableExportName(v)):(o=u,a=v.name)}var c=r.get(o);c||r.set(o,c=[]),c.push({imported:a,reexported:s})}for(var p=Array.from(this.imports),l=[],h=0,f=this.dependencies;h<f.length;h++){for(var d=f[h],m=[],g=0,y=p;g<y.length;g++){var v;if(((v=y[g]).module instanceof Module?v.module.chunk===d:v.module===d)&&!(v instanceof ExportDefaultVariable&&v.referencesOriginal()&&this.imports.has(v.getOriginalVariable()))){var _=v.getName(),b=v.module instanceof ExternalModule?v.name:v.module.chunk.getVariableExportName(v);m.push({local:_,imported:b})}}var E=r.get(d),x=void 0,S=void 0,A=!0;d instanceof ExternalModule?(x=d.exportsNames||d.exportsNamespace,S="default"in d.declarations):(x=!0,S=!1,A="default"!==d.exportMode);var w=void 0,N=void 0;d instanceof ExternalModule&&(w=d.setRenderPath(e,t),"umd"!==e.format&&"iife"!==e.format||(N=getGlobalName(d,e.globals,this.graph,x||S))),l.push({exportsDefault:S,exportsNames:x,globalName:N,id:w,imports:m.length>0?m:null,isChunk:!d.isExternal,name:d.variableName,namedExportsMode:A,reexports:E})}return l},e.prototype.getChunkExportDeclarations=function(){for(var e=[],t=function(t){if("*"===t[0])return"continue";var n=r.exportNames[t],i=n.module;if(i&&i.chunk!==r)return"continue";var s=!1,o=!1;n instanceof LocalVariable?(n.init===UNDEFINED_EXPRESSION&&(o=!0),n.declarations.forEach(function(e){e.type===ExportDefaultDeclaration?e.declaration.type===FunctionDeclaration&&(s=!0):e.parent.type===FunctionDeclaration&&(s=!0)})):n instanceof GlobalVariable&&(s=!0);var a=n.getName();e.push({exported:"*"===t?a:t,hoisted:s,local:a,uninitialized:o})},r=this,n=0,i=Object.keys(this.exportNames);n<i.length;n++){t(i[n])}return e},e.prototype.getVariableExportNamesForModule=function(e){for(var t=new Map,r=0,n=e.getAllExports();r<n.length;r++){var i=n[r],s=e.getVariableForExportName(i);if(s&&(s.included||s.isExternal)){var o=t.get(s);o?o.push(i):t.set(s,[i]);var a=s.module;a&&a.chunk&&a.chunk!==this&&a.chunk.exports.add(s)}}return t},e.prototype.inlineChunkDependencies=function(e,t){for(var r=0,n=e.dependencies;r<n.length;r++){var i=n[r];if(i instanceof ExternalModule)-1===this.dependencies.indexOf(i)&&this.dependencies.push(i);else{if(i===this||-1!==this.dependencies.indexOf(i))continue;i.isEmpty||this.dependencies.push(i),t&&this.inlineChunkDependencies(i,!0)}}},e.prototype.prepareDynamicImports=function(){for(var e=0,t=this.orderedModules;e<t.length;e++)for(var r=0,n=t[e].dynamicImports;r<n.length;r++){var i=n[r],s=i.node,o=i.resolution;if(o)if(o instanceof Module)if(o.chunk===this){var a=o.getOrCreateNamespace();s.setResolution(!1,a.getName())}else s.setResolution(!1);else o instanceof ExternalModule?s.setResolution(!0):s.setResolution(!1)}},e.prototype.setIdentifierRenderResolutions=function(e){for(var t=0,r=Object.keys(this.exportNames);t<r.length;t++){var n=r[t],i=this.exportNames[n];i&&(i instanceof ExportShimVariable&&(this.needsExportsShim=!0),i.exportName=n,"es"===e.format||"system"===e.format||!i.isReassigned||i.isId||isExportDefaultVariable(i)&&i.hasId?i.setRenderNames(null,null):i.setRenderNames("exports",n))}var s=Object.create(null);this.needsExportsShim&&(s[MISSING_EXPORT_SHIM_VARIABLE]=!0),deconflictChunk(this.orderedModules,this.dependencies,this.imports,s,e.format,!1!==e.interop,this.graph.preserveModules)},e.prototype.setUpModuleImports=function(e){for(var t=0,r=Array.from(e.imports);t<r.length;t++){(s=r[t]).module.chunk!==this&&(this.imports.add(s),s.module instanceof Module&&s.module.chunk.exports.add(s))}if(e.getOrCreateNamespace().included)for(var n=0,i=Object.keys(e.reexports);n<i.length;n++){var s,o=i[n],a=e.reexports[o];(s=a.module.getVariableForExportName(a.localName)).module.chunk!==this&&(this.imports.add(s),s.module instanceof Module&&s.module.chunk.exports.add(s))}for(var u=0,c=e.dynamicImports;u<c.length;u++){var p=c[u],l=p.node,h=p.resolution;l.included&&(this.hasDynamicImport=!0,h instanceof Module&&h.chunk===this&&h.getOrCreateNamespace().include())}},e}();function optimizeChunks(e,t,r,n){for(var i,s=function(s){var o=e[s],a=[];if(o.visitStaticDependenciesUntilCondition(function(e){e instanceof Chunk$1&&a.push(e)}),a.length<2)return i=s,"continue";var u,c=1,p=!0,l=a[0],h=a[1],f=function(e){return null===e.facadeModule&&!e.isManualChunk&&(!(!h||null!==h.facadeModule)&&!(e.getRenderedSourceLength()>r))},d=function(){if(p)return f(l)&&(p=!1),"continue";var i=r-u.getRenderedSourceLength()-l.getRenderedSourceLength();if(i<=0)return f(l)||(p=!0),"continue";var o=new Set;l.visitStaticDependenciesUntilCondition(function(e){return o.add(e)});var d=new Set([l,u]);if(u.visitStaticDependenciesUntilCondition(function(e){return e!==l&&e!==u&&(!o.has(e)&&(e instanceof ExternalModule||((i-=e.getRenderedSourceLength())<=0||void d.add(e))))}))return f(l)||(p=!0),"continue";if(l.visitStaticDependenciesUntilCondition(function(e){return!d.has(e)&&(e instanceof ExternalModule||((i-=e.getRenderedSourceLength())<=0||void 0))}))return f(l)||(p=!0),"continue";var m=e.indexOf(l);m<=s&&s--,e.splice(m,1),u.merge(l,e,t,n),a.splice(--c,1),l=u,h&&!f(h)&&(p=!0)};do{d()}while(u=l,l=h,h=a[++c],l);i=s},o=0;o<e.length;o++)s(o),o=i;return e}const DynamicImportKey="Import";function parseDynamicImport(){const e=this.startNode();return this.next(),this.type!==types.parenL&&this.unexpected(),this.finishNode(e,DynamicImportKey)}function parenAfter(){return/^(\s|\/\/.*|\/\*[^]*?\*\/)*\(/.test(this.input.slice(this.pos))}function dynamicImport(e){return class extends e{parseStatement(e,t,r){return this.type===types._import&&parenAfter.call(this)?this.parseExpressionStatement(this.startNode(),this.parseExpression()):super.parseStatement(e,t,r)}parseExprAtom(e){return this.type===types._import?parseDynamicImport.call(this):super.parseExprAtom(e)}}}types._import.startsExpr=!0;const tt=types,skipWhiteSpace$1=/(?:\s|\/\/.*|\/\*[^]*?\*\/)*/g,nextTokenIsDot=e=>{skipWhiteSpace$1.lastIndex=e.pos;let t=skipWhiteSpace$1.exec(e.input),r=e.pos+t[0].length;return"."===e.input.slice(r,r+1)};var acornImportMeta=function(e){return class extends e{parseExprAtom(e){if(this.type!==tt._import||!nextTokenIsDot(this))return super.parseExprAtom(e);this.options.allowImportExportEverywhere||this.inModule||this.raise(this.start,"'import' and 'export' may appear only with 'sourceType: module'");let t=this.startNode();return t.meta=this.parseIdent(!0),this.expect(tt.dot),t.property=this.parseIdent(!0),"meta"!==t.property.name&&this.raiseRecoverable(t.property.start,"The only valid meta property for import is import.meta"),this.containsEsc&&this.raiseRecoverable(t.property.start,'"meta" in import.meta must not contain escape sequences'),this.finishNode(t,"MetaProperty")}parseStatement(e,t,r){if(this.type!==tt._import||!nextTokenIsDot(this))return super.parseStatement(e,t,r);let n=this.startNode(),i=this.parseExpression();return this.parseExpressionStatement(n,i)}}},UndefinedVariable=function(e){function t(){return e.call(this,"undefined")||this}return __extends(t,e),t.prototype.getLiteralValueAtPath=function(){},t}(Variable),GlobalScope=function(e){function t(){var t=e.call(this)||this;return t.variables.undefined=new UndefinedVariable,t}return __extends(t,e),t.prototype.findVariable=function(e){return this.variables[e]?this.variables[e]:this.variables[e]=new GlobalVariable(e)},t}(Scope$1),getNewTrackedPaths=function(){return{paths:Object.create(null),tracked:!1,unknownPath:null}},EntityPathTracker=function(){function e(){this.entityPaths=new Map}return e.prototype.track=function(e,t){var r=this.entityPaths.get(e);r||(r=getNewTrackedPaths(),this.entityPaths.set(e,r));for(var n,i=0;i<t.length;){var s=t[i];"string"==typeof s?(n=r.paths[s])||(n=getNewTrackedPaths(),r.paths[s]=n):(n=r.unknownPath)||(n=getNewTrackedPaths(),r.unknownPath=n),r=n,i++}var o=r.tracked;return r.tracked=!0,o},e}();function getAssetFileName(e,t,r){return void 0===e.source&&error({code:"ASSET_SOURCE_NOT_FOUND",message:"Plugin error creating asset "+e.name+" - no asset source set."}),e.fileName?e.fileName:makeUnique(renderNamePattern(r,"assetFileNames",function(t){switch(t){case"hash":var r=_256();return r.update(t),r.update(":"),r.update(e.source),r.digest("hex").substr(0,8);case"name":return e.name.substr(0,e.name.length-path$2.extname(e.name).length);case"extname":return path$2.extname(e.name);case"ext":return path$2.extname(e.name).substr(1)}}),t)}function createAssetPluginHooks(e,t,r){return{emitAsset:function(n,i){var s;"string"==typeof n&&isPlainName(n)||error({code:"INVALID_ASSET_NAME",message:"Plugin error creating asset, name is not a plain (non relative or absolute URL) string name."});do{var o=_256();s?o.update(s):o.update(n),s=o.digest("hex").substr(0,8)}while(e.has(s));var a={name:n,source:i,fileName:void 0};return t&&void 0!==i&&finaliseAsset(a,t,r),e.set(s,a),s},setAssetSource:function(n,i){var s=e.get(n);s||error({code:"ASSET_NOT_FOUND",message:"Plugin error - Unable to set asset source for unknown asset "+n+"."}),void 0!==s.source&&error({code:"ASSET_SOURCE_ALREADY_SET",message:"Plugin error - Unable to set asset source for "+s.name+", source already set."}),"string"==typeof i||i||error({code:"ASSET_SOURCE_MISSING",message:"Plugin error creating asset "+name+", setAssetSource call without a source."}),s.source=i,t&&finaliseAsset(s,t,r)},getAssetFileName:function(t){var r=e.get(t);return r||error({code:"ASSET_NOT_FOUND",message:"Plugin error - Unable to get asset filename for unknown asset "+t+"."}),void 0===r.fileName&&error({code:"ASSET_NOT_FINALISED",message:"Plugin error - Unable to get asset file name for asset "+t+". Ensure that the source is set and that generate is called first."}),r.fileName}}}function finaliseAsset(e,t,r){var n=getAssetFileName(e,t,r);e.fileName=n,t[n]={fileName:n,isAsset:!0,source:e.source}}function createTransformEmitAsset(e,t){var r=[];return{assets:r,emitAsset:function(n,i){var s=t(n,i),o=e.get(s);return r.push({fileName:void 0,name:o.name,source:o.source}),s}}}var CHAR_CODE_A=97,CHAR_CODE_0=48;function intToHex(e){return e<10?String.fromCharCode(CHAR_CODE_0+e):String.fromCharCode(CHAR_CODE_A+(e-10))}function Uint8ArrayToHexString(e){for(var t="",r=0;r<e.length;r++){var n=e[r];t+=intToHex(n>>4),t+=intToHex(15&n)}return t}function Uint8ArrayXor(e,t){for(var r=0;r<e.length;r++)e[r]=e[r]^t[r];return e}function randomUint8Array(e){for(var t=new Uint8Array(e),r=0;r<t.length;r++)t[r]=512*Math.random();return t}function assignChunkColouringHashes(e,t){var r,n,i,s,o,a,u={},c=[],p=function(e){s.chunkAlias?(e.chunkAlias=s.chunkAlias,e.entryPointsHash=o):Uint8ArrayXor(e.entryPointsHash,o);for(var t=0,r=e.dependencies;t<r.length;t++){var n=r[t];n instanceof ExternalModule||n.id in a||(a[n.id]=!0,u[n.id]||n.chunkAlias||p(n))}for(var i=0,l=e.dynamicImports;i<l.length;i++){var h=l[i].resolution;h instanceof Module&&h.dynamicallyImportedBy.length>0&&!h.chunkAlias&&c.push(h)}};if(t)for(var l=0,h=Object.keys(t);l<h.length;l++){var f=h[l];o=randomUint8Array(10);for(var d=0,m=t[f];d<m.length;d++)(s=m[d]).chunkAlias&&error({code:"INVALID_CHUNK",message:"Cannot assign "+path$2.relative(process.cwd(),s.id)+' to the "'+f+'" chunk as it is already in the "'+s.chunkAlias+'" chunk.\nTry defining "'+f+'" first in the manualChunks definitions of the Rollup configuration.'}),s.chunkAlias=f,(r={})[s.id]=!0,a=r,p(s)}for(var g=0,y=e;g<y.length;g++)s=y[g],u[s.id]=!0,o=randomUint8Array(10),(n={})[s.id]=null,a=n,p(s);for(var v=0,_=c;v<_.length;v++)s=_[v],u[s.id]||(u[s.id]=!0,o=randomUint8Array(10),(i={})[s.id]=null,a=i,p(s))}function mkdirpath(e){var t=path$2.dirname(e);try{fs$2.readdirSync(t)}catch(e){mkdirpath(t);try{fs$2.mkdirSync(t)}catch(e){if("EEXIST"!==e.code)throw e}}}function writeFile(e,t){return new Promise(function(r,n){mkdirpath(e),fs$2.writeFile(e,t,function(e){e?n(e):r()})})}function getRollupDefaultPlugin(e){return{name:"Rollup Core",resolveId:createResolveId(e),load:function(e){return fs$2.readFileSync(e,"utf-8")},resolveDynamicImport:function(e,t){if("string"==typeof e&&!this.isExternal(e,t,!1))return this.resolveId(e,t)}}}function findFile(e,t){try{var r=fs$2.lstatSync(e);if(!t&&r.isSymbolicLink())return findFile(fs$2.realpathSync(e),t);if(t&&r.isSymbolicLink()||r.isFile()){var n=path$2.basename(e);if(-1!==fs$2.readdirSync(path$2.dirname(e)).indexOf(n))return e}}catch(e){}}function addJsExtensionIfNecessary(e,t){var r=findFile(e,t);return r||((r=findFile(e+".mjs",t))?r:r=findFile(e+".js",t))}function createResolveId(e){return function(t,r){return"undefined"==typeof process&&error({code:"MISSING_PROCESS",message:"It looks like you're using Rollup in a non-Node.js environment. This means you must supply a plugin with custom resolveId and load functions",url:"https://rollupjs.org/guide/en#a-simple-example"}),void 0===r||isAbsolute(t)||"."===t[0]?addJsExtensionIfNecessary(path$2.resolve(r?path$2.dirname(r):path$2.resolve(),t),e.preserveSymlinks):null}}var deprecatedHookNames={ongenerate:"generateBundle",onwrite:"generateBundle",transformBundle:"renderChunk",transformChunk:"renderChunk"};function createPluginDriver(e,t,r,n){var i=(t.plugins||[]).concat([getRollupDefaultPlugin(t)]),s=createAssetPluginHooks(e.assetsById),o=s.emitAsset,a=s.getAssetFileName,u=s.setAssetSource,c={},p=!1,l=i.map(function(t,i){var s,l=!0;if("string"!=typeof t.cacheKey&&("string"!=typeof t.name||c[t.name]?l=!1:c[t.name]=!0),!p&&(t.load||t.transform||t.transformBundle||t.transformChunk)&&(p=!0),r)if(l){var h=t.cacheKey||t.name;s=createPluginCache(r[h]||(r[h]=Object.create(null)))}else s=uncacheablePlugin(t.name);else s=noCache;var f=!1;function m(e,t){return f||(g.warn({code:"PLUGIN_WATCHER_DEPRECATED",message:"this.watcher usage is deprecated in plugins. Use the watchChange plugin hook and this.addWatchFile() instead."}),f=!0),n.on(e,t)}var g={addWatchFile:function(t){e.finished&&this.error("addWatchFile can only be called during the build."),e.watchFiles[t]=!0},cache:s,emitAsset:o,error:function(e){"string"==typeof e&&(e={message:e}),e.code&&(e.pluginCode=e.code),e.code="PLUGIN_ERROR",e.plugin=t.name||"Plugin at position "+(i+1),error(e)},isExternal:function(t,r,n){return void 0===n&&(n=!1),e.isExternal(t,r,n)},getAssetFileName:a,getModuleInfo:function(t){var r=e.moduleById.get(t);if(null==r)throw new Error("Unable to find module "+t);return{id:r.id,importedIds:r.isExternal?[]:r.sources.map(function(e){return r.resolvedIds[e].id}),isExternal:!!r.isExternal}},meta:{rollupVersion:version$1},moduleIds:e.moduleById.keys(),parse:e.contextParse,resolveId:function(e,t){return d.hookFirst("resolveId",[e,t])},setAssetSource:u,warn:function(r){"string"==typeof r&&(r={message:r}),r.code&&(r.pluginCode=r.code),r.code="PLUGIN_WARNING",r.plugin=t.name||"Plugin at position "+(i+1),e.warn(r)},watcher:n?__assign({},n,{addListener:m,on:m}):void 0};return g});function h(e,t,r,n,s){void 0===n&&(n=!1);var o=i[r],a=l[r],u=o[e];if(u){var c=deprecatedHookNames[e];if(c&&a.warn(hookDeprecationWarning(e,c,o,r)),s&&(!(a=s(a,o))||a===l[r]))throw new Error("Internal Rollup error: hookContext must return a new context object.");try{if("function"!=typeof u){if(n)return u;error({code:"INVALID_PLUGIN_HOOK",message:"Error running plugin hook "+e+" for "+(o.name||"Plugin at position "+(r+1))+", expected a function hook."})}return u.apply(a,t)}catch(t){"string"==typeof t&&(t={message:t}),"PLUGIN_ERROR"!==t.code&&(t.code&&(t.pluginCode=t.code),t.code="PLUGIN_ERROR"),t.plugin=o.name||"Plugin at position "+(r+1),t.hook=e,error(t)}}}function f(e,t,r,n,s){void 0===n&&(n=!1);var o=i[r],a=l[r],u=o[e];if(u){var c=deprecatedHookNames[e];if(c&&a.warn(hookDeprecationWarning(e,c,o,r)),s&&(!(a=s(a,o))||a===l[r]))throw new Error("Internal Rollup error: hookContext must return a new context object.");return Promise.resolve().then(function(){if("function"!=typeof u){if(n)return u;error({code:"INVALID_PLUGIN_HOOK",message:"Error running plugin hook "+e+" for "+(o.name||"Plugin at position "+(r+1))+", expected a function hook."})}return u.apply(a,t)}).catch(function(t){"string"==typeof t&&(t={message:t}),"PLUGIN_ERROR"!==t.code&&(t.code&&(t.pluginCode=t.code),t.code="PLUGIN_ERROR"),t.plugin=o.name||"Plugin at position "+(r+1),t.hook=e,error(t)})}}var d={emitAsset:o,getAssetFileName:a,hasLoadersOrTransforms:p,hookSeq:function(e,t,r){for(var n=Promise.resolve(),s=function(i){n=n.then(function(){return f(e,t,i,!1,r)})},o=0;o<i.length;o++)s(o);return n},hookSeqSync:function(e,t,r){for(var n=0;n<i.length;n++)h(e,t,n,!1,r)},hookFirst:function(e,t,r){for(var n=Promise.resolve(),s=function(i){n=n.then(function(n){return null!=n?n:f(e,t,i,!1,r)})},o=0;o<i.length;o++)s(o);return n},hookParallel:function(e,t,r){for(var n=[],s=0;s<i.length;s++){var o=f(e,t,s,!1,r);o&&n.push(o)}return Promise.all(n).then(function(){})},hookReduceArg0:function(e,t,r,n){for(var s=t[0],o=t.slice(1),a=Promise.resolve(s),u=function(t){a=a.then(function(s){var a=f(e,[s].concat(o),t,!1,n);return a?a.then(function(e){return r.call(l[t],s,e,i[t])}):s})},c=0;c<i.length;c++)u(c);return a},hookReduceValue:function(e,t,r,n,s){for(var o=Promise.resolve(t),a=function(t){o=o.then(function(o){var a=f(e,r,t,!0,s);return a?a.then(function(e){return n.call(l[t],o,e,i[t])}):o})},u=0;u<i.length;u++)a(u);return o}};return d}function createPluginCache(e){return{has:function(t){var r=e[t];return!!r&&(r[0]=0,!0)},get:function(t){var r=e[t];if(r)return r[0]=0,r[1]},set:function(t,r){e[t]=[0,r]},delete:function(t){return delete e[t]}}}function trackPluginCache(e){var t={used:!1,cache:void 0};return t.cache={has:function(r){return t.used=!0,e.has(r)},get:function(r){return t.used=!0,e.get(r)},set:function(r,n){return t.used=!0,e.set(r,n)},delete:function(r){return t.used=!0,e.delete(r)}},t}var noCache={has:function(){return!1},get:function(){},set:function(){},delete:function(){return!1}};function uncacheablePluginError(e){error(e?{code:"DUPLICATE_PLUGIN_NAME",message:"The plugin name "+e+" is being used twice in the same build. Plugin names must be distinct or provide a cacheKey (please post an issue to the plugin if you are a plugin user)."}:{code:"ANONYMOUS_PLUGIN_CACHE",message:"A plugin is trying to use the Rollup cache but is not declaring a plugin name or cacheKey."})}var uncacheablePlugin=function(e){return{has:function(){return uncacheablePluginError(e),!1},get:function(){uncacheablePluginError(e)},set:function(){uncacheablePluginError(e)},delete:function(){return uncacheablePluginError(e),!1}}};function hookDeprecationWarning(e,t,r,n){return{code:e.toUpperCase()+"_HOOK_DEPRECATED",message:"The "+e+" hook used by plugin "+(r.name||"at position "+(n+1))+" is deprecated. The "+t+" hook should be used instead."}}function transform(e,t,r){var n=r.id,i=[],s="string"==typeof t.map?JSON.parse(t.map):t.map;s&&"string"==typeof s.mappings&&(s.mappings=decode(s.mappings));var o,a,u,c,p,l=e.pluginDriver.emitAsset,h=t.code,f=t.ast,d=!1,m=t.code;return e.pluginDriver.hookReduceArg0("transform",[m,n],function(t,s,p){if(!d&&u.used&&(d=!0),d){if(s&&Array.isArray(s.dependencies))for(var l=0,h=s.dependencies;l<h.length;l++){var m=h[l],g=path$2.resolve(path$2.dirname(n),m);e.watchFiles[g]||(e.watchFiles[g]=!0)}}else if(a.length&&(r.transformAssets=a),s&&Array.isArray(s.dependencies)){c.warnedTransformDependencies||this.warn({code:"TRANSFORM_DEPENDENCIES_DEPRECATED",message:'Returning "dependencies" from plugin transform hook is deprecated for using this.addWatchFile() instead.'}),c.warnedTransformDependencies=!0,o||(o=[]);for(var y=0,v=s.dependencies;y<v.length;y++)m=v[y],o.push(path$2.resolve(path$2.dirname(n),m))}return null==s?t:("string"==typeof s?s={ast:void 0,code:s,map:void 0}:"string"==typeof s.map&&(s.map=JSON.parse(s.map)),s.map&&"string"==typeof s.map.mappings&&(s.map.mappings=decode(s.map.mappings)),null!==s.map&&i.push(s.map||{missing:!0,plugin:p.name}),f=s.ast,s.code)},function(t,r){var i,s;return c=r,r.cacheKey?d=!0:u=trackPluginCache(t.cache),i=createTransformEmitAsset(e.assetsById,l),a=i.assets,s=i.emitAsset,__assign({},t,{cache:u?u.cache:t.cache,warn:function(e,r){"string"==typeof e&&(e={message:e}),r&&augmentCodeLocation(e,r,m,n),e.id=n,e.hook="transform",t.warn(e)},error:function(e,r){"string"==typeof e&&(e={message:e}),r&&augmentCodeLocation(e,r,m,n),e.id=n,e.hook="transform",t.error(e)},emitAsset:s,addWatchFile:function(e){o||(o=[]),o.push(e),t.addWatchFile(e)},setAssetSource:function(e,r){if(t.setAssetSource(e,r),!d&&!p)try{this.error({code:"INVALID_SETASSETSOURCE",message:"setAssetSource cannot be called in transform for caching reasons. Use emitAsset with a source, or call setAssetSource in another hook."})}catch(e){p=e}}})}).catch(function(e){"string"==typeof e&&(e={message:e}),"PLUGIN_ERROR"!==e.code&&(e.code&&(e.pluginCode=e.code),e.code="PLUGIN_ERROR"),e.id=n,error(e)}).then(function(e){if(!d&&p)throw p;return{ast:f,code:e,customTransformCache:d,originalCode:h,originalSourcemap:s,sourcemapChain:i,transformDependencies:o}})}function makeOnwarn(){var e=Object.create(null);return function(t){var r=t.toString();r in e||(console.error(r),e[r]=!0)}}var Graph=function(){function e(e,t){var r,n=this;if(this.assetsById=new Map,this.curChunkIndex=0,this.externalModules=[],this.finished=!1,this.moduleById=new Map,this.modules=[],this.needsTreeshakingPass=!1,this.watchFiles=Object.create(null),this.curChunkIndex=0,this.deoptimizationTracker=new EntityPathTracker,this.cachedModules=new Map,e.cache&&e.cache.modules)for(var i=0,s=e.cache.modules;i<s.length;i++){var o=s[i];this.cachedModules.set(o.id,o)}if(!1!==e.cache)for(var a in this.pluginCache=e.cache&&e.cache.plugins||Object.create(null),this.pluginCache)for(var u=this.pluginCache[a],c=0,p=Object.keys(u);c<p.length;c++){u[v=p[c]][0]++}if(this.preserveModules=e.preserveModules,this.cacheExpiry=e.experimentalCacheExpiry,!e.input)throw new Error("You must supply options.input to rollup");if(this.treeshake=!1!==e.treeshake,this.treeshake)if(this.treeshakingOptions=e.treeshake?{annotations:!1!==e.treeshake.annotations,propertyReadSideEffects:!1!==e.treeshake.propertyReadSideEffects,pureExternalModules:e.treeshake.pureExternalModules}:{propertyReadSideEffects:!0,annotations:!0,pureExternalModules:!1},!0===this.treeshakingOptions.pureExternalModules)this.isPureExternalModule=function(){return!0};else if("function"==typeof this.treeshakingOptions.pureExternalModules)this.isPureExternalModule=this.treeshakingOptions.pureExternalModules;else if(Array.isArray(this.treeshakingOptions.pureExternalModules)){var l=new Set(this.treeshakingOptions.pureExternalModules);this.isPureExternalModule=function(e){return l.has(e)}}else this.isPureExternalModule=function(){return!1};else this.isPureExternalModule=function(){return!1};if(this.contextParse=function(e,t){return void 0===t&&(t={}),n.acornParser.parse(e,__assign({},defaultAcornOptions,t,n.acornOptions))},this.pluginDriver=createPluginDriver(this,e,this.pluginCache,t),t){var h=function(e){return n.pluginDriver.hookSeqSync("watchChange",[e])};t.on("change",h),t.once("restart",function(){t.removeListener("change",h)})}if("function"==typeof e.external){var f=e.external;this.isExternal=function(e,t,r){return!e.startsWith("\0")&&f(e,t,r)}}else{var d=e.external,m=new Set(Array.isArray(d)?d:d?[d]:[]);this.isExternal=function(e){return m.has(e)}}this.shimMissingExports=e.shimMissingExports,this.scope=new GlobalScope,this.context=String(e.context);var g=e.moduleContext;if("function"==typeof g)this.getModuleContext=function(e){return g(e)||n.context};else if("object"==typeof g){var y=new Map;for(var v in g)y.set(path$2.resolve(v),g[v]);this.getModuleContext=function(e){return y.get(e)||n.context}}else this.getModuleContext=function(){return n.context};this.onwarn=e.onwarn||makeOnwarn(),this.acornOptions=e.acorn||{};var _=[];_.push(dynamicImport),_.push(acornImportMeta),e.experimentalTopLevelAwait&&(this.acornOptions.allowAwaitOutsideFunction=!0);var b=e.acornInjectPlugins;_.push.apply(_,Array.isArray(b)?b:b?[b]:[]),this.acornParser=(r=Parser).extend.apply(r,_)}return e.prototype.build=function(e,t,r){var n=this;return timeStart("parse modules",2),this.loadEntryModules(e,t).then(function(e){var t=e.entryModules,i=e.entryModuleAliases,s=e.manualChunkModules;timeEnd("parse modules",2),timeStart("analyse dependency graph",2);for(var o=0;o<t.length;o++){var a=t[o],u=t.indexOf(a,o+1);-1!==u&&error({code:"DUPLICATE_ENTRY_POINTS",message:"Duplicate entry points detected. The input entries "+i[o]+" and "+i[u]+" both point to the same module, "+a.id})}n.link();for(var c=analyseModuleExecution(t),p=c.orderedModules,l=0,h=c.cyclePaths;l<h.length;l++){var f=h[l];n.warn({code:"CIRCULAR_DEPENDENCY",importer:f[0],message:"Circular dependency: "+f.join(" -> ")})}if(timeEnd("analyse dependency graph",2),timeStart("mark included statements",2),r&&t.length>1)throw new Error("Internal Error: can only inline dynamic imports for single-file builds.");for(var d=0,m=t;d<m.length;d++){(a=m[d]).includeAllExports()}n.includeMarked(p);for(var g=0,y=n.externalModules;g<y.length;g++){y[g].warnUnusedImports()}if(timeEnd("mark included statements",2),timeStart("generate chunks",2),n.preserveModules||r||assignChunkColouringHashes(t,s),i)for(o=t.length-1;o>=0;o--)t[o].chunkAlias=i[o];var v=[];if(n.preserveModules)for(var _=0,b=p;_<b.length;_++){var E=b[_],x=new Chunk$1(n,[E]);!E.isEntryPoint&&x.isEmpty||(x.entryModules=[E]),v.push(x)}else{for(var S={},A=0,w=p;A<w.length;A++){var N=Uint8ArrayToHexString((E=w[A]).entryPointsHash),P=S[N];P?P.push(E):S[N]=[E]}for(var C in S){var I=S[C];sortByExecutionOrder(I);x=new Chunk$1(n,I);v.push(x)}}for(var k=0,O=v;k<O.length;k++){(x=O[k]).link()}for(var $=0,R=v=v.filter(function(e){return!e.isEmpty||e.entryModules.length>0||e.isManualChunk});$<R.length;$++){x=R[$];(n.preserveModules||x.entryModules.length>0)&&x.generateEntryExportsOrMarkAsTainted()}var M=[];if(!n.preserveModules)for(var T=0,L=v;T<L.length;T++)for(var j=0,D=(x=L[T]).entryModules;j<D.length;j++){a=D[j];if(x.facadeModule!==a){var B=new Chunk$1(n,[]);B.turnIntoFacade(a),M.push(B)}}return timeEnd("generate chunks",2),n.finished=!0,v.concat(M)})},e.prototype.finaliseAssets=function(e){var t=Object.create(null);return this.assetsById.forEach(function(r){void 0!==r.source&&finaliseAsset(r,t,e)}),t},e.prototype.getCache=function(){for(var e in this.pluginCache){for(var t=this.pluginCache[e],r=!0,n=0,i=Object.keys(t);n<i.length;n++){var s=i[n];t[s][0]>=this.cacheExpiry?delete t[s]:r=!1}r&&delete this.pluginCache[e]}return{modules:this.modules.map(function(e){return e.toJSON()}),plugins:this.pluginCache}},e.prototype.includeMarked=function(e){if(this.treeshake){var t=1;do{timeStart("treeshaking pass "+t,3),this.needsTreeshakingPass=!1;for(var r=0,n=e;r<n.length;r++){(o=n[r]).isExecuted&&o.include()}timeEnd("treeshaking pass "+t++,3)}while(this.needsTreeshakingPass)}else for(var i=0,s=e;i<s.length;i++){var o;(o=s[i]).includeAllInBundle()}},e.prototype.warn=function(e){e.toString=function(){var t="";return e.plugin&&(t+="("+e.plugin+" plugin) "),e.loc&&(t+=relativeId(e.loc.file)+" ("+e.loc.line+":"+e.loc.column+") "),t+=e.message},this.onwarn(e)},e.prototype.fetchAllDependencies=function(e){var t=this,r=Promise.all(e.getDynamicImportExpressions().map(function(r,n){return t.pluginDriver.hookFirst("resolveDynamicImport",[r,e.id]).then(function(i){if(i){var s=e.dynamicImports[n];if(s.alias=getAliasName(i,"string"==typeof r?r:void 0),"string"!=typeof r)s.resolution=i;else{if(!t.isExternal(i,e.id,!0))return t.fetchModule(i,e.id).then(function(e){s.resolution=e});var o=void 0;t.moduleById.has(i)?o=t.moduleById.get(i):(o=new ExternalModule({graph:t,id:i}),t.externalModules.push(o),t.moduleById.set(i,e)),s.resolution=o,o.exportsNamespace=!0}}})}));return r.catch(function(){}),Promise.all(e.sources.map(function(r){return Promise.resolve().then(function(){var n=e.resolvedIds[r];return n?!n.external&&n.id:!t.isExternal(r,e.id,!1)&&t.pluginDriver.hookFirst("resolveId",[r,e.id])}).then(function(n){var i=n||(isRelative(r)?path$2.resolve(e.id,"..",r):r),s=!1===n||t.isExternal(i,e.id,!0);if(n||s||(isRelative(r)&&error({code:"UNRESOLVED_IMPORT",message:"Could not resolve '"+r+"' from "+relativeId(e.id)}),!1!==n&&t.warn({code:"UNRESOLVED_IMPORT",importer:relativeId(e.id),message:"'"+r+"' is imported by "+relativeId(e.id)+", but could not be resolved – treating it as an external dependency",source:r,url:"https://rollupjs.org/guide/en#warning-treating-module-as-external-dependency"}),s=!0),!s)return e.resolvedIds[r]={id:n,external:!1},t.fetchModule(n,e.id);if(e.resolvedIds[r]={id:i,external:!0},!t.moduleById.has(i)){var o=new ExternalModule({graph:t,id:i});t.externalModules.push(o),t.moduleById.set(i,o)}var a=t.moduleById.get(i);for(var u in a instanceof ExternalModule==!1&&error({code:"INVALID_EXTERNAL_ID",message:"'"+r+"' is imported as an external by "+relativeId(e.id)+", but is already an existing non-external module id."}),e.importDescriptions){var c=e.importDescriptions[u];if(c.source!==r)return;a.getVariableForExportName(c.name)}})})).then(function(){return r})},e.prototype.fetchModule=function(e,t){var r=this,n=this.moduleById.get(e);if(n){if(n.isExternal)throw new Error("Cannot fetch external module "+e);return Promise.resolve(n)}var i=new Module(this,e);return this.moduleById.set(e,i),this.watchFiles[e]=!0,timeStart("load modules",3),Promise.resolve(this.pluginDriver.hookFirst("load",[e])).catch(function(r){timeEnd("load modules",3);var n="Could not load "+e;throw t&&(n+=" (imported by "+t+")"),n+=": "+r.message,new Error(n)}).then(function(t){return timeEnd("load modules",3),"string"==typeof t?t:t&&"object"==typeof t&&"string"==typeof t.code?t:void error({code:"BAD_LOADER",message:"Error loading "+relativeId(e)+": plugin load hook should return a string, a { code, map } object, or nothing/null"})}).then(function(t){var n="string"==typeof t?{ast:null,code:t}:t,s=r.cachedModules.get(e);if(s&&!s.customTransformCache&&s.originalCode===n.code){if(s.transformAssets)for(var o=0,a=s.transformAssets;o<a.length;o++){var u=a[o];r.pluginDriver.emitAsset(u.name,u.source)}return s}return transform(r,n,i)}).then(function(t){return i.setSource(t),r.modules.push(i),r.moduleById.set(e,i),r.fetchAllDependencies(i).then(function(){for(var e in i.exports)"default"!==e&&(i.exportsAll[e]=i.id);return i.exportAllSources.forEach(function(e){var t=i.resolvedIds[e].id,n=r.moduleById.get(t);if(!n.isExternal)for(var s in n.exportsAll)s in i.exportsAll?r.warn({code:"NAMESPACE_CONFLICT",message:"Conflicting namespaces: "+relativeId(i.id)+" re-exports '"+s+"' from both "+relativeId(i.exportsAll[s])+" and "+relativeId(n.exportsAll[s])+" (will be ignored)",name:s,reexporter:i.id,sources:[i.exportsAll[s],n.exportsAll[s]]}):i.exportsAll[s]=n.exportsAll[s]}),i})})},e.prototype.link=function(){for(var e=0,t=this.modules;e<t.length;e++){t[e].linkDependencies()}for(var r=0,n=this.modules;r<n.length;r++){n[r].bindReferences()}this.warnForMissingExports()},e.prototype.loadEntryModules=function(e,t){var r,n,i=this,s=!1;"string"==typeof e&&(e=[e]),Array.isArray(e)?(s=!0,n=e.concat([]),r=e):(n=Object.keys(e),r=n.map(function(t){return e[t]}));var o=r.concat([]);return t&&Object.keys(t).forEach(function(e){t[e].forEach(function(e){-1===o.indexOf(e)&&o.push(e)})}),Promise.all(o.map(function(e){return i.loadModule(e)})).then(function(e){if(s)for(var i=0;i<n.length;i++)n[i]=getAliasName(e[i].id,n[i]);var a,u=e.slice(0,r.length);if(t){a={};for(var c=0,p=Object.keys(t);c<p.length;c++){var l=p[c],h=t[l];a[l]=h.map(function(t){var r=o.indexOf(t);return e[r]})}}return{entryModules:u,entryModuleAliases:n,manualChunkModules:a}})},e.prototype.loadModule=function(e){var t=this;return this.pluginDriver.hookFirst("resolveId",[e,void 0]).then(function(r){return!1===r&&error({code:"UNRESOLVED_ENTRY",message:"Entry module cannot be external"}),null==r&&error({code:"UNRESOLVED_ENTRY",message:"Could not resolve entry ("+e+")"}),t.fetchModule(r,void 0)})},e.prototype.warnForMissingExports=function(){for(var e=0,t=this.modules;e<t.length;e++)for(var r=t[e],n=0,i=Object.keys(r.importDescriptions);n<i.length;n++){var s=i[n],o=r.importDescriptions[s];"*"===o.name||o.module.getVariableForExportName(o.name)||r.warn({code:"NON_EXISTENT_EXPORT",message:"Non-existent export '"+o.name+"' is imported from "+relativeId(o.module.id),name:o.name,source:o.module.id},o.start)}},e}();function evalIfFn(e){switch(typeof e){case"function":return e();case"string":return e;default:return""}}var concatSep=function(e,t){return t?e+"\n"+t:e},concatDblSep=function(e,t){return t?e+"\n\n"+t:e};function createAddons(e,t){var r=e.pluginDriver;return Promise.all([r.hookReduceValue("banner",evalIfFn(t.banner),[],concatSep),r.hookReduceValue("footer",evalIfFn(t.footer),[],concatSep),r.hookReduceValue("intro",evalIfFn(t.intro),[],concatDblSep),r.hookReduceValue("outro",evalIfFn(t.outro),[],concatDblSep)]).then(function(e){var t=e[0],r=e[1],n=e[2],i=e[3];return n&&(n+="\n\n"),i&&(i="\n\n"+i),t.length&&(t+="\n"),r.length&&(r="\n"+r),{intro:n,outro:i,banner:t,footer:r}}).catch(function(e){error({code:"ADDON_ERROR",message:"Could not retrieve "+e.hook+". Check configuration of "+e.plugin+".\n\tError Message: "+e.message})})}function assignChunkIds(e,t,r,n,i){for(var s={},o=e.reduce(function(e,t){var r=e[0],n=e[1];return(t.facadeModule&&t.facadeModule.isEntryPoint?r:n).push(t),[r,n]},[[],[]]),a=o[0],u=o[1],c=a.concat(u),p=0;p<c.length;p++){var l=c[p];if(r.file)l.id=path$2.basename(r.file);else if(t.preserveModules)l.generateIdPreserveModules(n,s);else{var h=void 0,f=void 0;l.facadeModule&&l.facadeModule.isEntryPoint?(h=r.entryFileNames||"[name].js",f="output.entryFileNames"):(h=r.chunkFileNames||"[name]-[hash].js",f="output.chunkFileNames"),l.generateId(h,f,i,r,s)}s[l.id]=!0}}function commondir(e){if(0===e.length)return"/";if(1===e.length)return path$2.dirname(e[0]);var t=e.slice(1).reduce(function(e,t){var r,n=t.split(/\/+|\\+/);for(r=0;e[r]===n[r]&&r<Math.min(e.length,n.length);r++);return e.slice(0,r)},e[0].split(/\/+|\\+/));return t.length>1?t.join("/"):"/"}function badExports(e,t){error({code:"INVALID_EXPORT_OPTION",message:"'"+e+"' was specified for output.exports, but entry module has following exports: "+t.join(", ")})}function getExportMode(e,t){var r=t.exports,n=t.name,i=t.format,s=e.getExportNames();return"default"===r?1===s.length&&"default"===s[0]||badExports("default",s):"none"===r&&s.length&&badExports("none",s),r&&"auto"!==r||(0===s.length?r="none":1===s.length&&"default"===s[0]?r="default":(null!==e.facadeModule&&e.facadeModule.isEntryPoint&&"es"!==i&&-1!==s.indexOf("default")&&e.graph.warn({code:"MIXED_EXPORTS",message:"Using named and default exports together. Consumers of your bundle will have to use "+(n||"bundle")+"['default'] to access the default export, which may not be what you want. Use `output.exports: 'named'` to disable this warning",url:"https://rollupjs.org/guide/en#output-exports"}),r="named")),/(?:default|named|none)/.test(r)||error({code:"INVALID_EXPORT_OPTION",message:"output.exports must be 'default', 'named', 'none', 'auto', or left unspecified (defaults to 'auto')",url:"https://rollupjs.org/guide/en#output-exports"}),r}var createGetOption=function(e,t){return function(r,n){return void 0!==t[r]?t[r]:void 0!==e[r]?e[r]:n}},normalizeObjectOptionValue=function(e){return e&&"object"!=typeof e?{}:e},getObjectOption=function(e,t,r){var n=normalizeObjectOptionValue(t[r]),i=normalizeObjectOptionValue(e[r]);return void 0!==n?n&&i?__assign({},i,n):n:i},defaultOnWarn=function(e){"string"==typeof e?console.warn(e):console.warn(e.message)},getOnWarn=function(e,t,r){return void 0===r&&(r=defaultOnWarn),t.silent?function(){}:e.onwarn?function(t){return e.onwarn(t,r)}:r},getExternal=function(e,t){var r=e.external;return"function"==typeof r?function(e){for(var n=[],i=1;i<arguments.length;i++)n[i-1]=arguments[i];return r.apply(void 0,[e].concat(n))||-1!==t.external.indexOf(e)}:(r||[]).concat(t.external)},commandAliases={c:"config",d:"dir",e:"external",f:"format",g:"globals",h:"help",i:"input",m:"sourcemap",n:"name",o:"file",v:"version",w:"watch"};function mergeOptions(e){var t=e.config,r=void 0===t?{}:t,n=e.command,i=void 0===n?{}:n,s=e.defaultOnWarnHandler,o=getCommandOptions(i),a=getInputOptions(r,o,s);o.output&&Object.assign(o,o.output);var u=r.output,c=Array.isArray(u)?u:u?[u]:[];0===c.length&&c.push({});var p=c.map(function(e){return getOutputOptions(e,o)}),l=[],h=Object.keys(a);addUnknownOptionErrors(l,Object.keys(r),h,"input option",/^output$/);var f=Object.keys(p[0]);addUnknownOptionErrors(l,p.reduce(function(e,t){return e.concat(Object.keys(t))},[]),f,"output option");var d=f.filter(function(e){return"sourcemapPathTransform"!==e});return addUnknownOptionErrors(l,Object.keys(o),h.concat(d,Object.keys(commandAliases),"config","environment","silent"),"CLI flag",/^_|output|(config.*)$/),{inputOptions:a,optionError:l.length>0?l.join("\n"):null,outputOptions:p}}function addUnknownOptionErrors(e,t,r,n,i){void 0===i&&(i=/$./);var s=t.filter(function(e){return-1===r.indexOf(e)&&!i.test(e)});s.length>0&&e.push("Unknown "+n+": "+s.join(", ")+". Allowed options: "+r.sort().join(", "))}function getCommandOptions(e){var t=__assign({},e);return t.external=e.external?e.external.split(","):[],e.globals&&(t.globals=Object.create(null),e.globals.split(",").forEach(function(e){var r=e.split(":");t.globals[r[0]]=r[1],-1===t.external.indexOf(r[0])&&t.external.push(r[0])})),t}function getInputOptions(e,t,r){void 0===t&&(t={});var n=createGetOption(e,t),i={acorn:e.acorn,acornInjectPlugins:e.acornInjectPlugins,cache:n("cache"),chunkGroupingSize:n("chunkGroupingSize",5e3),context:e.context,experimentalCacheExpiry:n("experimentalCacheExpiry",10),experimentalOptimizeChunks:n("experimentalOptimizeChunks"),experimentalTopLevelAwait:n("experimentalTopLevelAwait"),external:getExternal(e,t),inlineDynamicImports:n("inlineDynamicImports",!1),input:n("input"),manualChunks:n("manualChunks"),moduleContext:e.moduleContext,onwarn:getOnWarn(e,t,r),perf:n("perf",!1),plugins:e.plugins,preserveModules:n("preserveModules"),preserveSymlinks:n("preserveSymlinks"),shimMissingExports:n("shimMissingExports"),treeshake:getObjectOption(e,t,"treeshake"),watch:e.watch};return i.cache&&i.cache.cache&&(i.cache=i.cache.cache),i}function getOutputOptions(e,t){void 0===t&&(t={});var r=createGetOption(e,t),n=r("format");return{amd:__assign({},e.amd,t.amd),assetFileNames:r("assetFileNames"),banner:r("banner"),chunkFileNames:r("chunkFileNames"),compact:r("compact",!1),dir:r("dir"),dynamicImportFunction:r("dynamicImportFunction"),entryFileNames:r("entryFileNames"),esModule:r("esModule",!0),exports:r("exports"),extend:r("extend"),file:r("file"),footer:r("footer"),format:"esm"===n?"es":n,freeze:r("freeze",!0),globals:r("globals"),indent:r("indent",!0),interop:r("interop",!0),intro:r("intro"),name:r("name"),namespaceToStringTag:r("namespaceToStringTag",!1),noConflict:r("noConflict"),outro:r("outro"),paths:r("paths"),preferConst:r("preferConst"),sourcemap:r("sourcemap"),sourcemapExcludeSources:r("sourcemapExcludeSources"),sourcemapFile:r("sourcemapFile"),sourcemapPathTransform:r("sourcemapPathTransform"),strict:r("strict",!0)}}function checkOutputOptions(e){"es6"===e.format&&error({message:'The "es6" output format is deprecated – use "esm" instead',url:"https://rollupjs.org/guide/en#output-format"}),e.format||error({message:'You must specify "output.format", which can be one of "amd", "cjs", "system", "esm", "iife" or "umd".',url:"https://rollupjs.org/guide/en#output-format"})}function getAbsoluteEntryModulePaths(e){for(var t=[],r=0,n=e;r<n.length;r++)for(var i=0,s=n[r].entryModules;i<s.length;i++){var o=s[i];isAbsolute(o.id)&&t.push(o.id)}return t}var curWatcher,SortingFileType,throwAsyncGenerateError={get:function(){throw new Error("bundle.generate(...) now returns a Promise instead of a { code, map } object")}};function applyOptionHook(e,t){return t.options&&t.options.call({meta:{rollupVersion:version$1}},e)||e}function getInputOptions$1(e){if(!e)throw new Error("You must supply an options object to rollup");var t=mergeOptions({config:e}),r=t.inputOptions,n=t.optionError;n&&r.onwarn({message:n,code:"UNKNOWN_OPTION"});var i=r.plugins;return r.plugins=Array.isArray(i)?i.filter(Boolean):i?[i]:[],(r=r.plugins.reduce(applyOptionHook,r)).inlineDynamicImports?(r.preserveModules&&error({code:"INVALID_OPTION",message:'"preserveModules" does not support the "inlineDynamicImports" option.'}),r.manualChunks&&error({code:"INVALID_OPTION",message:'"manualChunks" option is not supported for "inlineDynamicImports".'}),r.experimentalOptimizeChunks&&error({code:"INVALID_OPTION",message:'"experimentalOptimizeChunks" option is not supported for "inlineDynamicImports".'}),(r.input instanceof Array&&r.input.length>1||"object"==typeof r.input&&Object.keys(r.input).length>1)&&error({code:"INVALID_OPTION",message:'Multiple inputs are not supported for "inlineDynamicImports".'})):r.preserveModules&&(r.manualChunks&&error({code:"INVALID_OPTION",message:'"preserveModules" does not support the "manualChunks" option.'}),r.experimentalOptimizeChunks&&error({code:"INVALID_OPTION",message:'"preserveModules" does not support the "experimentalOptimizeChunks" option.'})),r}function rollup(e){try{var t=getInputOptions$1(e);initialiseTimers(t);var r=new Graph(t,curWatcher);curWatcher=void 0;var n=!1!==e.cache;return delete t.cache,delete e.cache,timeStart("BUILD",1),r.pluginDriver.hookParallel("buildStart",[t]).then(function(){return r.build(t.input,t.manualChunks,t.inlineDynamicImports)}).then(function(e){return r.pluginDriver.hookParallel("buildEnd").then(function(){return e})},function(e){return r.pluginDriver.hookParallel("buildEnd",[e]).then(function(){throw e})}).then(function(e){timeEnd("BUILD",1);var i=!1;function s(n,s){var o=normalizeOutputOptions(t,n,e.length>1);timeStart("GENERATE",1);var a=o.assetFileNames||"assets/[name]-[hash][extname]",u=r.finaliseAssets(a),c=commondir(getAbsoluteEntryModulePaths(e));return r.pluginDriver.hookParallel("renderStart").then(function(){return createAddons(r,o)}).then(function(n){for(var s=0,a=e;s<a.length;s++){var p=a[s];t.preserveModules||p.generateInternalExports(o),p.facadeModule&&p.facadeModule.isEntryPoint&&(p.exportMode=getExportMode(p,o))}for(var l=0,h=e;l<h.length;l++){(p=h[l]).preRender(o,c)}!i&&t.experimentalOptimizeChunks&&(optimizeChunks(e,o,t.chunkGroupingSize,c),i=!0),assignChunkIds(e,t,o,c,n);for(var f=function(t){var r=e[t],n=r.facadeModule;u[r.id]={code:void 0,dynamicImports:r.getDynamicImportIds(),exports:r.getExportNames(),facadeModuleId:n&&n.id,fileName:r.id,imports:r.getImportIds(),isDynamicEntry:null!==n&&n.dynamicallyImportedBy.length>0,isEntry:null!==n&&n.isEntryPoint,map:void 0,modules:r.renderedModules,get name(){return r.getChunkName()}}},d=0;d<e.length;d++)f(d);return Promise.all(e.map(function(e){var t=u[e.id];return e.render(o,n,t).then(function(e){return t.code=e.code,t.map=e.map,r.pluginDriver.hookParallel("ongenerate",[__assign({bundle:t},o),t])})})).then(function(){})}).catch(function(e){return r.pluginDriver.hookParallel("renderError",[e]).then(function(){throw e})}).then(function(){var e=new Map(r.assetsById),t=createAssetPluginHooks(e,u,a);return r.pluginDriver.hookSeq("generateBundle",[o,u,s],function(e){return __assign({},e,t)}).then(function(){e.forEach(function(e){void 0===e.fileName&&finaliseAsset(e,u,a)})})}).then(function(){return timeEnd("GENERATE",1),u})}var o={cache:n?r.getCache():void 0,generate:function(e){var t=s(e,!1).then(function(e){return createOutput(e)});return Object.defineProperty(t,"code",throwAsyncGenerateError),Object.defineProperty(t,"map",throwAsyncGenerateError),t},watchFiles:Object.keys(r.watchFiles),write:function(e){return e&&(e.dir||e.file)||error({code:"MISSING_OPTION",message:'You must specify "output.file" or "output.dir" for the build.'}),s(e,!0).then(function(n){for(var i=0,s=0,a=Object.keys(n);s<a.length;s++){var u=a[s];if(!n[u].isAsset&&++i>1)break}return i>1&&(e.sourcemapFile&&error({code:"INVALID_OPTION",message:'"output.sourcemapFile" is only supported for single-file builds.'}),"string"==typeof e.file&&error({code:"INVALID_OPTION",message:'When building multiple chunks, the "output.dir" option must be used, not "output.file".'+("string"!=typeof t.input||!0===t.inlineDynamicImports?"":' To inline dynamic imports, set the "inlineDynamicImports" option.')})),Promise.all(Object.keys(n).map(function(t){return writeOutputFile(r,o,n[t],e)})).then(function(){return r.pluginDriver.hookParallel("writeBundle",[n])}).then(function(){return createOutput(n)})})}};return!0===t.perf&&(o.getTimings=getTimings),o})}catch(e){return Promise.reject(e)}}function getSortingFileType(e){return e.isAsset?SortingFileType.ASSET:e.isEntry?SortingFileType.ENTRY_CHUNK:SortingFileType.SECONDARY_CHUNK}function createOutput(e){return{output:Object.keys(e).map(function(t){return e[t]}).sort(function(e,t){var r=getSortingFileType(e),n=getSortingFileType(t);return r===n?0:r<n?-1:1})}}function isOutputAsset(e){return!0===e.isAsset}function writeOutputFile(e,t,r,n){var i,s,o=path$2.resolve(n.dir||path$2.dirname(n.file),r.fileName);if(isOutputAsset(r))s=r.source;else if(s=r.code,n.sourcemap&&r.map){var a=void 0;"inline"===n.sourcemap?a=r.map.toUrl():(a=path$2.basename(r.fileName)+".map",i=writeFile(o+".map",r.map.toString())),s+="//# "+SOURCEMAPPING_URL+"="+a+"\n"}return writeFile(o,s).then(function(){return i}).then(function(){return!isOutputAsset(r)&&e.pluginDriver.hookSeq("onwrite",[__assign({bundle:t},n),r])}).then(function(){})}function normalizeOutputOptions(e,t,r){if(!t)throw new Error("You must supply an options object");var n=mergeOptions({config:{output:__assign({},t,t.output,e.output)}});if(n.optionError)throw new Error(n.optionError);var i=n.outputOptions[0];return checkOutputOptions(i),"string"==typeof i.file&&("string"==typeof i.dir&&error({code:"INVALID_OPTION",message:'You must set either "output.file" for a single-file build or "output.dir" when generating multiple chunks.'}),e.preserveModules&&error({code:"INVALID_OPTION",message:'You must set "output.dir" instead of "output.file" when using the "preserveModules" option.'}),"object"!=typeof e.input||Array.isArray(e.input)||error({code:"INVALID_OPTION",message:'You must set "output.dir" instead of "output.file" when providing named inputs.'})),r&&("umd"!==i.format&&"iife"!==i.format||error({code:"INVALID_OPTION",message:"UMD and IIFE output formats are not supported for code-splitting builds."}),"string"==typeof i.file&&error({code:"INVALID_OPTION",message:'You must set "output.dir" instead of "output.file" when generating multiple chunks.'})),i}!function(e){e[e.ENTRY_CHUNK=0]="ENTRY_CHUNK",e[e.SECONDARY_CHUNK=1]="SECONDARY_CHUNK",e[e.ASSET=2]="ASSET"}(SortingFileType||(SortingFileType={}));var types$2={ROOT:0,GROUP:1,POSITION:2,SET:3,RANGE:4,REPETITION:5,REFERENCE:6,CHAR:7},INTS=function(){return[{type:types$2.RANGE,from:48,to:57}]},WORDS=function(){return[{type:types$2.CHAR,value:95},{type:types$2.RANGE,from:97,to:122},{type:types$2.RANGE,from:65,to:90}].concat(INTS())},WHITESPACE$1=function(){return[{type:types$2.CHAR,value:9},{type:types$2.CHAR,value:10},{type:types$2.CHAR,value:11},{type:types$2.CHAR,value:12},{type:types$2.CHAR,value:13},{type:types$2.CHAR,value:32},{type:types$2.CHAR,value:160},{type:types$2.CHAR,value:5760},{type:types$2.CHAR,value:6158},{type:types$2.CHAR,value:8192},{type:types$2.CHAR,value:8193},{type:types$2.CHAR,value:8194},{type:types$2.CHAR,value:8195},{type:types$2.CHAR,value:8196},{type:types$2.CHAR,value:8197},{type:types$2.CHAR,value:8198},{type:types$2.CHAR,value:8199},{type:types$2.CHAR,value:8200},{type:types$2.CHAR,value:8201},{type:types$2.CHAR,value:8202},{type:types$2.CHAR,value:8232},{type:types$2.CHAR,value:8233},{type:types$2.CHAR,value:8239},{type:types$2.CHAR,value:8287},{type:types$2.CHAR,value:12288},{type:types$2.CHAR,value:65279}]},NOTANYCHAR=function(){return[{type:types$2.CHAR,value:10},{type:types$2.CHAR,value:13},{type:types$2.CHAR,value:8232},{type:types$2.CHAR,value:8233}]},words=function(){return{type:types$2.SET,set:WORDS(),not:!1}},notWords=function(){return{type:types$2.SET,set:WORDS(),not:!0}},ints=function(){return{type:types$2.SET,set:INTS(),not:!1}},notInts=function(){return{type:types$2.SET,set:INTS(),not:!0}},whitespace=function(){return{type:types$2.SET,set:WHITESPACE$1(),not:!1}},notWhitespace=function(){return{type:types$2.SET,set:WHITESPACE$1(),not:!0}},anyChar=function(){return{type:types$2.SET,set:NOTANYCHAR(),not:!0}},sets={words:words,notWords:notWords,ints:ints,notInts:notInts,whitespace:whitespace,notWhitespace:notWhitespace,anyChar:anyChar},util=createCommonjsModule$1(function(e,t){var r={0:0,t:9,n:10,v:11,f:12,r:13};t.strToChars=function(e){return e=e.replace(/(\[\\b\])|(\\)?\\(?:u([A-F0-9]{4})|x([A-F0-9]{2})|(0?[0-7]{2})|c([@A-Z\[\\\]\^?])|([0tnvfr]))/g,function(e,t,n,i,s,o,a,u){if(n)return e;var c=t?8:i?parseInt(i,16):s?parseInt(s,16):o?parseInt(o,8):a?"@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^ ?".indexOf(a):r[u],p=String.fromCharCode(c);return/[\[\]{}\^$.|?*+()]/.test(p)&&(p="\\"+p),p})},t.tokenizeClass=function(e,r){for(var n,i,s=[],o=/\\(?:(w)|(d)|(s)|(W)|(D)|(S))|((?:(?:\\)(.)|([^\]\\]))-(?:\\)?([^\]]))|(\])|(?:\\)?(.)/g;null!=(n=o.exec(e));)if(n[1])s.push(sets.words());else if(n[2])s.push(sets.ints());else if(n[3])s.push(sets.whitespace());else if(n[4])s.push(sets.notWords());else if(n[5])s.push(sets.notInts());else if(n[6])s.push(sets.notWhitespace());else if(n[7])s.push({type:types$2.RANGE,from:(n[8]||n[9]).charCodeAt(0),to:n[10].charCodeAt(0)});else{if(!(i=n[12]))return[s,o.lastIndex];s.push({type:types$2.CHAR,value:i.charCodeAt(0)})}t.error(r,"Unterminated character class")},t.error=function(e,t){throw new SyntaxError("Invalid regular expression: /"+e+"/: "+t)}}),wordBoundary=function(){return{type:types$2.POSITION,value:"b"}},nonWordBoundary=function(){return{type:types$2.POSITION,value:"B"}},begin=function(){return{type:types$2.POSITION,value:"^"}},end=function(){return{type:types$2.POSITION,value:"$"}},positions={wordBoundary:wordBoundary,nonWordBoundary:nonWordBoundary,begin:begin,end:end},lib=function(e){var t,r,n=0,i={type:types$2.ROOT,stack:[]},s=i,o=i.stack,a=[],u=function(t){util.error(e,"Nothing to repeat at column "+(t-1))},c=util.strToChars(e);for(t=c.length;n<t;)switch(r=c[n++]){case"\\":switch(r=c[n++]){case"b":o.push(positions.wordBoundary());break;case"B":o.push(positions.nonWordBoundary());break;case"w":o.push(sets.words());break;case"W":o.push(sets.notWords());break;case"d":o.push(sets.ints());break;case"D":o.push(sets.notInts());break;case"s":o.push(sets.whitespace());break;case"S":o.push(sets.notWhitespace());break;default:/\d/.test(r)?o.push({type:types$2.REFERENCE,value:parseInt(r,10)}):o.push({type:types$2.CHAR,value:r.charCodeAt(0)})}break;case"^":o.push(positions.begin());break;case"$":o.push(positions.end());break;case"[":var p;"^"===c[n]?(p=!0,n++):p=!1;var l=util.tokenizeClass(c.slice(n),e);n+=l[1],o.push({type:types$2.SET,set:l[0],not:p});break;case".":o.push(sets.anyChar());break;case"(":var h={type:types$2.GROUP,stack:[],remember:!0};"?"===(r=c[n])&&(r=c[n+1],n+=2,"="===r?h.followedBy=!0:"!"===r?h.notFollowedBy=!0:":"!==r&&util.error(e,"Invalid group, character '"+r+"' after '?' at column "+(n-1)),h.remember=!1),o.push(h),a.push(s),s=h,o=h.stack;break;case")":0===a.length&&util.error(e,"Unmatched ) at column "+(n-1)),o=(s=a.pop()).options?s.options[s.options.length-1]:s.stack;break;case"|":s.options||(s.options=[s.stack],delete s.stack);var f=[];s.options.push(f),o=f;break;case"{":var d,m,g=/^(\d+)(,(\d+)?)?\}/.exec(c.slice(n));null!==g?(0===o.length&&u(n),d=parseInt(g[1],10),m=g[2]?g[3]?parseInt(g[3],10):1/0:d,n+=g[0].length,o.push({type:types$2.REPETITION,min:d,max:m,value:o.pop()})):o.push({type:types$2.CHAR,value:123});break;case"?":0===o.length&&u(n),o.push({type:types$2.REPETITION,min:0,max:1,value:o.pop()});break;case"+":0===o.length&&u(n),o.push({type:types$2.REPETITION,min:1,max:1/0,value:o.pop()});break;case"*":0===o.length&&u(n),o.push({type:types$2.REPETITION,min:0,max:1/0,value:o.pop()});break;default:o.push({type:types$2.CHAR,value:r.charCodeAt(0)})}return 0!==a.length&&util.error(e,"Unterminated group"),i},types_1=types$2;lib.types=types_1;var types$1$1=lib.types,safeRegex=function(e,t){t||(t={});var r=void 0===t.limit?25:t.limit;isRegExp(e)?e=e.source:"string"!=typeof e&&(e=String(e));try{e=lib(e)}catch(e){return!1}var n=0;return function e(t,i){if(t.type===types$1$1.REPETITION){if(n++,++i>1)return!1;if(n>r)return!1}if(t.options)for(var s=0,o=t.options.length;s<o;s++){if(!e({stack:t.options[s]},i))return!1}var a=t.stack||t.value&&t.value.stack;if(!a)return!0;for(s=0;s<a.length;s++){if(!e(a[s],i))return!1}return!0}(e,0)};function isRegExp(e){return"[object RegExp]"==={}.toString.call(e)}var isobject=function(e){return null!=e&&"object"==typeof e&&!1===Array.isArray(e)},toString$1$1=Object.prototype.toString,kindOf=function(e){if(void 0===e)return"undefined";if(null===e)return"null";var t=typeof e;if("boolean"===t)return"boolean";if("string"===t)return"string";if("number"===t)return"number";if("symbol"===t)return"symbol";if("function"===t)return isGeneratorFn(e)?"generatorfunction":"function";if(isArray$2(e))return"array";if(isBuffer(e))return"buffer";if(isArguments(e))return"arguments";if(isDate(e))return"date";if(isError(e))return"error";if(isRegexp(e))return"regexp";switch(ctorName(e)){case"Symbol":return"symbol";case"Promise":return"promise";case"WeakMap":return"weakmap";case"WeakSet":return"weakset";case"Map":return"map";case"Set":return"set";case"Int8Array":return"int8array";case"Uint8Array":return"uint8array";case"Uint8ClampedArray":return"uint8clampedarray";case"Int16Array":return"int16array";case"Uint16Array":return"uint16array";case"Int32Array":return"int32array";case"Uint32Array":return"uint32array";case"Float32Array":return"float32array";case"Float64Array":return"float64array"}if(isGeneratorObj(e))return"generator";switch(t=toString$1$1.call(e)){case"[object Object]":return"object";case"[object Map Iterator]":return"mapiterator";case"[object Set Iterator]":return"setiterator";case"[object String Iterator]":return"stringiterator";case"[object Array Iterator]":return"arrayiterator"}return t.slice(8,-1).toLowerCase().replace(/\s/g,"")};function ctorName(e){return e.constructor?e.constructor.name:null}function isArray$2(e){return Array.isArray?Array.isArray(e):e instanceof Array}function isError(e){return e instanceof Error||"string"==typeof e.message&&e.constructor&&"number"==typeof e.constructor.stackTraceLimit}function isDate(e){return e instanceof Date||"function"==typeof e.toDateString&&"function"==typeof e.getDate&&"function"==typeof e.setDate}function isRegexp(e){return e instanceof RegExp||"string"==typeof e.flags&&"boolean"==typeof e.ignoreCase&&"boolean"==typeof e.multiline&&"boolean"==typeof e.global}function isGeneratorFn(e,t){return"GeneratorFunction"===ctorName(e)}function isGeneratorObj(e){return"function"==typeof e.throw&&"function"==typeof e.return&&"function"==typeof e.next}function isArguments(e){try{if("number"==typeof e.length&&"function"==typeof e.callee)return!0}catch(e){if(-1!==e.message.indexOf("callee"))return!0}return!1}function isBuffer(e){return!(!e.constructor||"function"!=typeof e.constructor.isBuffer)&&e.constructor.isBuffer(e)}var accessor={get:"function",set:"function",configurable:"boolean",enumerable:"boolean"};function isAccessorDescriptor(e,t){if("string"==typeof t)return void 0!==Object.getOwnPropertyDescriptor(e,t);if("object"!==kindOf(e))return!1;if(has$1$1(e,"value")||has$1$1(e,"writable"))return!1;if(!has$1$1(e,"get")||"function"!=typeof e.get)return!1;if(has$1$1(e,"set")&&"function"!=typeof e[r]&&void 0!==e[r])return!1;for(var r in e)if(accessor.hasOwnProperty(r)&&kindOf(e[r])!==accessor[r]&&void 0!==e[r])return!1;return!0}function has$1$1(e,t){return{}.hasOwnProperty.call(e,t)}var isAccessorDescriptor_1=isAccessorDescriptor,isDataDescriptor=function(e,t){var r={configurable:"boolean",enumerable:"boolean",writable:"boolean"};if("object"!==kindOf(e))return!1;if("string"==typeof t)return void 0!==Object.getOwnPropertyDescriptor(e,t);if(!("value"in e||"writable"in e))return!1;for(var n in e)if("value"!==n&&r.hasOwnProperty(n)&&kindOf(e[n])!==r[n]&&void 0!==e[n])return!1;return!0},isDescriptor=function(e,t){return"object"===kindOf(e)&&("get"in e?isAccessorDescriptor_1(e,t):isDataDescriptor(e,t))},define$1="undefined"!=typeof Reflect&&Reflect.defineProperty?Reflect.defineProperty:Object.defineProperty,defineProperty=function(e,t,r){if(!isobject(e)&&"function"!=typeof e&&!Array.isArray(e))throw new TypeError("expected an object, function, or array");if("string"!=typeof t)throw new TypeError('expected "key" to be a string');return isDescriptor(r)?(define$1(e,t,r),e):(define$1(e,t,{configurable:!0,enumerable:!1,writable:!0,value:r}),e)};function isObjectObject(e){return!0===isobject(e)&&"[object Object]"===Object.prototype.toString.call(e)}var isPlainObject=function(e){var t,r;return!1!==isObjectObject(e)&&("function"==typeof(t=e.constructor)&&(!1!==isObjectObject(r=t.prototype)&&!1!==r.hasOwnProperty("isPrototypeOf")))},isExtendable=function(e){return isPlainObject(e)||"function"==typeof e||Array.isArray(e)},assignSymbols=function(e,t){if(null==e)throw new TypeError("expected first argument to be an object.");if(void 0===t||"undefined"==typeof Symbol)return e;if("function"!=typeof Object.getOwnPropertySymbols)return e;for(var r=Object.prototype.propertyIsEnumerable,n=Object(e),i=arguments.length,s=0;++s<i;)for(var o=Object(arguments[s]),a=Object.getOwnPropertySymbols(o),u=0;u<a.length;u++){var c=a[u];r.call(o,c)&&(n[c]=o[c])}return n},extendShallow=Object.assign||function(e){if(null==e)throw new TypeError("Cannot convert undefined or null to object");isObject$1(e)||(e={});for(var t=1;t<arguments.length;t++){var r=arguments[t];isString(r)&&(r=toObject$1(r)),isObject$1(r)&&(assign(e,r),assignSymbols(e,r))}return e};function assign(e,t){for(var r in t)hasOwn(t,r)&&(e[r]=t[r])}function isString(e){return e&&"string"==typeof e}function toObject$1(e){var t={};for(var r in e)t[r]=e[r];return t}function isObject$1(e){return e&&"object"==typeof e||isExtendable(e)}function hasOwn(e,t){return Object.prototype.hasOwnProperty.call(e,t)}function toRegex(e,t){return new RegExp(toRegex.create(e,t))}toRegex.create=function(e,t){if("string"!=typeof e)throw new TypeError("expected a string");var r=extendShallow({},t);!0===r.contains&&(r.strictNegate=!1);var n=!1!==r.strictOpen?"^":"",i=!1!==r.strictClose?"$":"",s=r.endChar?r.endChar:"+",o=n+(!1===r.strictNegate?"(?:(?!(?:"+e+")).)"+s:"(?:(?!^(?:"+e+")$).)"+s)+i;if(!0===r.safe&&!1===safeRegex(o))throw new Error("potentially unsafe regular expression: "+o);return o};var regexNot=toRegex,MAX_LENGTH=65536,cache={},toRegex$1=function(e,t){return Array.isArray(e)?makeRe$1(e.join("|"),t):makeRe$1(e,t)};function makeRe$1(e,t){if(e instanceof RegExp)return e;if("string"!=typeof e)throw new TypeError("expected a string");if(e.length>MAX_LENGTH)throw new Error("expected pattern to be less than "+MAX_LENGTH+" characters");var r=e;if((!t||t&&!1!==t.cache)&&(r=createKey(e,t),cache.hasOwnProperty(r)))return cache[r];var n=extendShallow({},t);!0===n.contains&&(!0===n.negate?n.strictNegate=!1:n.strict=!1),!1===n.strict&&(n.strictOpen=!1,n.strictClose=!1);var i,s=!1!==n.strictOpen?"^":"",o=!1!==n.strictClose?"$":"",a=n.flags||"";!0!==n.nocase||/i/.test(a)||(a+="i");try{if((n.negate||"boolean"==typeof n.strictNegate)&&(e=regexNot.create(e,n)),i=new RegExp(s+"(?:"+e+")"+o,a),!0===n.safe&&!1===safeRegex(i))throw new Error("potentially unsafe regular expression: "+i.source)}catch(s){if(!0===n.strictErrors||!0===n.safe)throw s.key=r,s.pattern=e,s.originalOptions=t,s.createdOptions=n,s;try{i=new RegExp("^"+e.replace(/(\W)/g,"\\$1")+"$")}catch(e){i=/.^/}}return!1!==n.cache&&memoize(i,r,e,n),i}function memoize(e,t,r,n){defineProperty(e,"cached",!0),defineProperty(e,"pattern",r),defineProperty(e,"options",n),defineProperty(e,"key",t),cache[t]=e}function createKey(e,t){if(!t)return e;var r=e;for(var n in t)t.hasOwnProperty(n)&&(r+=";"+n+"="+String(t[n]));return r}var makeRe_1=makeRe$1;toRegex$1.makeRe=makeRe_1;var arrayUnique=createCommonjsModule$1(function(e){e.exports=function(e){if(!Array.isArray(e))throw new TypeError("array-unique expects an array.");for(var t=e.length,r=-1;r++<t;)for(var n=r+1;n<e.length;++n)e[r]===e[n]&&e.splice(n--,1);return e},e.exports.immutable=function(t){if(!Array.isArray(t))throw new TypeError("array-unique expects an array.");for(var r=t.length,n=new Array(r),i=0;i<r;i++)n[i]=t[i];return e.exports(n)}}),isExtendable$1=function(e){return null!=e&&("object"==typeof e||"function"==typeof e)},extendShallow$1=function(e){isExtendable$1(e)||(e={});for(var t=arguments.length,r=1;r<t;r++){var n=arguments[r];isExtendable$1(n)&&assign$1(e,n)}return e};function assign$1(e,t){for(var r in t)hasOwn$1(t,r)&&(e[r]=t[r])}function hasOwn$1(e,t){return Object.prototype.hasOwnProperty.call(e,t)}var splitString=function(e,t,r){if("string"!=typeof e)throw new TypeError("expected a string");"function"==typeof t&&(r=t,t=null),"string"==typeof t&&(t={sep:t});var n,i=extendShallow({sep:"."},t),s=i.quotes||['"',"'","`"];!0===i.brackets?n={"<":">","(":")","[":"]","{":"}"}:i.brackets&&(n=i.brackets);var o,a=[],u=[],c=[""],p=i.sep,l=e.length,h=-1;function f(){if(n&&u.length)return n[u[u.length-1]]}for(;++h<l;){var d=e[h],m=e[h+1],g={val:d,idx:h,arr:c,str:e};if(a.push(g),"\\"!==d){if(n&&n[d]){u.push(d);var y=f(),v=h+1;if(-1!==e.indexOf(y,v+1))for(;u.length&&v<l;){var _=e[++v];if("\\"!==_)if(-1===s.indexOf(_)){if(y=f(),u.length&&-1===e.indexOf(y,v+1))break;n[_]?u.push(_):y===_&&u.pop()}else v=getClosingQuote(e,_,v+1);else _++}if(-1===(o=v)){c[c.length-1]+=d;continue}d=e.slice(h,o+1),g.val=d,g.idx=h=o}if(-1!==s.indexOf(d)){if(-1===(o=getClosingQuote(e,d,h+1))){c[c.length-1]+=d;continue}d=!0===keepQuotes(d,i)?e.slice(h,o+1):e.slice(h+1,o),g.val=d,g.idx=h=o}"function"==typeof r&&(r(g,a),d=g.val,h=g.idx),g.val!==p||!1===g.split?c[c.length-1]+=g.val:c.push("")}else g.val=!0===keepEscaping(i,e,h)?d+m:m,g.escaped=!0,"function"==typeof r&&r(g),c[c.length-1]+=g.val,h++}return c};function getClosingQuote(e,t,r,n){var i=e.indexOf(t,r);return"\\"===e.charAt(i-1)?getClosingQuote(e,t,i+1):i}function keepQuotes(e,t){return!0===t.keepDoubleQuotes&&'"'===e||(!0===t.keepSingleQuotes&&"'"===e||t.keepQuotes)}function keepEscaping(e,t,r){return"function"==typeof e.keepEscaping?e.keepEscaping(t,r):!0===e.keepEscaping||"\\"===t[r+1]}var arrFlatten=function(e){return flat(e,[])};function flat(e,t){for(var r,n=0,i=e.length;n<i;n++)r=e[n],Array.isArray(r)?flat(r,t):t.push(r);return t}var isBuffer_1=function(e){return null!=e&&(isBuffer$1(e)||isSlowBuffer(e)||!!e._isBuffer)};function isBuffer$1(e){return!!e.constructor&&"function"==typeof e.constructor.isBuffer&&e.constructor.isBuffer(e)}function isSlowBuffer(e){return"function"==typeof e.readFloatLE&&"function"==typeof e.slice&&isBuffer$1(e.slice(0,0))}var toString$2=Object.prototype.toString,kindOf$1=function(e){if(void 0===e)return"undefined";if(null===e)return"null";if(!0===e||!1===e||e instanceof Boolean)return"boolean";if("string"==typeof e||e instanceof String)return"string";if("number"==typeof e||e instanceof Number)return"number";if("function"==typeof e||e instanceof Function)return"function";if(void 0!==Array.isArray&&Array.isArray(e))return"array";if(e instanceof RegExp)return"regexp";if(e instanceof Date)return"date";var t=toString$2.call(e);return"[object RegExp]"===t?"regexp":"[object Date]"===t?"date":"[object Arguments]"===t?"arguments":"[object Error]"===t?"error":isBuffer_1(e)?"buffer":"[object Set]"===t?"set":"[object WeakSet]"===t?"weakset":"[object Map]"===t?"map":"[object WeakMap]"===t?"weakmap":"[object Symbol]"===t?"symbol":"[object Int8Array]"===t?"int8array":"[object Uint8Array]"===t?"uint8array":"[object Uint8ClampedArray]"===t?"uint8clampedarray":"[object Int16Array]"===t?"int16array":"[object Uint16Array]"===t?"uint16array":"[object Int32Array]"===t?"int32array":"[object Uint32Array]"===t?"uint32array":"[object Float32Array]"===t?"float32array":"[object Float64Array]"===t?"float64array":"object"},isNumber=function(e){var t=kindOf$1(e);if("string"===t){if(!e.trim())return!1}else if("number"!==t)return!1;return e-e+1>=0},extendShallow$2=function(e){isExtendable$1(e)||(e={});for(var t=arguments.length,r=1;r<t;r++){var n=arguments[r];isExtendable$1(n)&&assign$2(e,n)}return e};function assign$2(e,t){for(var r in t)hasOwn$2(t,r)&&(e[r]=t[r])}function hasOwn$2(e,t){return Object.prototype.hasOwnProperty.call(e,t)}var cache$1,res="",repeatString=repeat;function repeat(e,t){if("string"!=typeof e)throw new TypeError("expected a string");if(1===t)return e;if(2===t)return e+e;var r=e.length*t;if(cache$1!==e||void 0===cache$1)cache$1=e,res="";else if(res.length>=r)return res.substr(0,r);for(;r>res.length&&t>1;)1&t&&(res+=e),t>>=1,e+=e;return res=(res+=e).substr(0,r)}var cache$2={};function toRegexRange(e,t,r){if(!1===isNumber(e))throw new RangeError("toRegexRange: first argument is invalid.");if(void 0===t||e===t)return String(e);if(!1===isNumber(t))throw new RangeError("toRegexRange: second argument is invalid.");r=r||{};var n=e+":"+t+"="+String(r.relaxZeros)+String(r.shorthand)+String(r.capture);if(cache$2.hasOwnProperty(n))return cache$2[n].result;var i=Math.min(e,t),s=Math.max(e,t);if(1===Math.abs(i-s)){var o=e+"|"+t;return r.capture?"("+o+")":o}var a=padding(e)||padding(t),u=[],c=[],p={min:e,max:t,a:i,b:s};(a&&(p.isPadded=a,p.maxLen=String(p.max).length),i<0)&&(c=splitToPatterns(s<0?Math.abs(s):1,Math.abs(i),p,r),i=p.a=0);return s>=0&&(u=splitToPatterns(i,s,p,r)),p.negatives=c,p.positives=u,p.result=siftPatterns(c,u,r),r.capture&&u.length+c.length>1&&(p.result="("+p.result+")"),cache$2[n]=p,p.result}function siftPatterns(e,t,r){var n=filterPatterns(e,t,"-",!1,r)||[],i=filterPatterns(t,e,"",!1,r)||[],s=filterPatterns(e,t,"-?",!0,r)||[];return n.concat(s).concat(i).join("|")}function splitToRanges(e,t){e=Number(e);for(var r=1,n=[t=Number(t)],i=+countNines(e,r);e<=i&&i<=t;)n=push(n,i),i=+countNines(e,r+=1);var s=1;for(i=countZeros(t+1,s)-1;e<i&&i<=t;)n=push(n,i),i=countZeros(t+1,s+=1)-1;return n.sort(compare),n}function rangeToPattern(e,t,r){if(e===t)return{pattern:String(e),digits:[]};for(var n=zip(String(e),String(t)),i=n.length,s=-1,o="",a=0;++s<i;){var u=n[s],c=u[0],p=u[1];c===p?o+=c:"0"!==c||"9"!==p?o+=toCharacterClass(c,p):a+=1}return a&&(o+=r.shorthand?"\\d":"[0-9]"),{pattern:o,digits:[a]}}function splitToPatterns(e,t,r,n){for(var i,s=splitToRanges(e,t),o=s.length,a=-1,u=[],c=e;++a<o;){var p=s[a],l=rangeToPattern(c,p,n),h="";r.isPadded||!i||i.pattern!==l.pattern?(r.isPadded&&(h=padZeros(p,r)),l.string=h+l.pattern+toQuantifier(l.digits),u.push(l),c=p+1,i=l):(i.digits.length>1&&i.digits.pop(),i.digits.push(l.digits[0]),i.string=i.pattern+toQuantifier(i.digits),c=p+1)}return u}function filterPatterns(e,t,r,n,i){for(var s=[],o=0;o<e.length;o++){var a=e[o].string;!1!==i.relaxZeros&&"-"===r&&"0"===a.charAt(0)&&(a="{"===a.charAt(1)?"0*"+a.replace(/^0\{\d+\}/,""):"0*"+a.slice(1)),n||contains(t,"string",a)||s.push(r+a),n&&contains(t,"string",a)&&s.push(r+a)}return s}function zip(e,t){var r=[];for(var n in e)r.push([e[n],t[n]]);return r}function compare(e,t){return e>t?1:t>e?-1:0}function push(e,t){return-1===e.indexOf(t)&&e.push(t),e}function contains(e,t,r){for(var n=0;n<e.length;n++)if(e[n][t]===r)return!0;return!1}function countNines(e,t){return String(e).slice(0,-t)+repeatString("9",t)}function countZeros(e,t){return e-e%Math.pow(10,t)}function toQuantifier(e){var t=e[0],r=e[1]?","+e[1]:"";return r||t&&1!==t?"{"+t+r+"}":""}function toCharacterClass(e,t){return"["+e+(t-e==1?"":"-")+t+"]"}function padding(e){return/^-?(0+)\d/.exec(e)}function padZeros(e,t){if(t.isPadded){var r=Math.abs(t.maxLen-String(e).length);switch(r){case 0:return"";case 1:return"0";default:return"0{"+r+"}"}}return e}var toRegexRange_1=toRegexRange;function fillRange(e,t,r,n){if(void 0===e)return[];if(void 0===t||e===t){var i="string"==typeof e;return isNumber(e)&&!toNumber(e)?[i?"0":0]:[e]}"number"!=typeof r&&"string"!=typeof r&&(n=r,r=void 0),"function"==typeof n&&(n={transform:n});var s=extendShallow$2({step:r},n);if(s.step&&!isValidNumber(s.step)){if(!0===s.strictRanges)throw new TypeError("expected options.step to be a number");return[]}if(s.isNumber=isValidNumber(e)&&isValidNumber(t),!s.isNumber&&!isValid(e,t)){if(!0===s.strictRanges)throw new RangeError("invalid range arguments: "+util$2$1.inspect([e,t]));return[]}return s.isPadded=isPadded$1(e)||isPadded$1(t),s.toString=s.stringify||"string"==typeof s.step||"string"==typeof e||"string"==typeof t||!s.isNumber,s.isPadded&&(s.maxLength=Math.max(String(e).length,String(t).length)),"boolean"==typeof s.optimize&&(s.toRegex=s.optimize),"boolean"==typeof s.makeRe&&(s.toRegex=s.makeRe),expand$1(e,t,s)}function expand$1(e,t,r){var n=r.isNumber?toNumber(e):e.charCodeAt(0),i=r.isNumber?toNumber(t):t.charCodeAt(0),s=Math.abs(toNumber(r.step))||1;if(r.toRegex&&1===s)return toRange(n,i,e,t,r);for(var o={greater:[],lesser:[]},a=n<i,u=new Array(Math.round((a?i-n:n-i)/s)),c=0;a?n<=i:n>=i;){var p=r.isNumber?n:String.fromCharCode(n);r.toRegex&&(p>=0||!r.isNumber)?o.greater.push(p):o.lesser.push(Math.abs(p)),r.isPadded&&(p=zeros(p,r)),r.toString&&(p=String(p)),"function"==typeof r.transform?u[c++]=r.transform(p,n,i,s,c,u,r):u[c++]=p,a?n+=s:n-=s}return!0===r.toRegex?toSequence(u,o,r):u}function toRange(e,t,r,n,i){return i.isPadded?toRegexRange_1(r,n,i):i.isNumber?toRegexRange_1(Math.min(e,t),Math.max(e,t),i):"["+(r=String.fromCharCode(Math.min(e,t)))+"-"+(n=String.fromCharCode(Math.max(e,t)))+"]"}function toSequence(e,t,r){var n="",i="";t.greater.length&&(n=t.greater.join("|")),t.lesser.length&&(i="-("+t.lesser.join("|")+")");var s=n&&i?n+"|"+i:n||i;return r.capture?"("+s+")":s}function zeros(e,t){if(t.isPadded){var r=String(e),n=r.length,i="";"-"===r.charAt(0)&&(i="-",r=r.slice(1));var s=t.maxLength-n;e=i+repeatString("0",s)+r}return t.stringify?String(e):e}function toNumber(e){return Number(e)||0}function isPadded$1(e){return/^-?0\d/.test(e)}function isValid(e,t){return(isValidNumber(e)||isValidLetter(e))&&(isValidNumber(t)||isValidLetter(t))}function isValidLetter(e){return"string"==typeof e&&1===e.length&&/^\w+$/.test(e)}function isValidNumber(e){return isNumber(e)&&!/\./.test(e)}var fillRange_1=fillRange,repeatElement=function(e,t){for(var r=new Array(t),n=0;n<t;n++)r[n]=e;return r},utils_1=createCommonjsModule$1(function(e){var t=e.exports;t.extend=extendShallow$1,t.flatten=arrFlatten,t.isObject=isobject,t.fillRange=fillRange_1,t.repeat=repeatElement,t.unique=arrayUnique,t.define=function(e,t,r){Object.defineProperty(e,t,{writable:!0,configurable:!0,enumerable:!1,value:r})},t.isEmptySets=function(e){return/^(?:\{,\})+$/.test(e)},t.isQuotedString=function(e){var t=e.charAt(0);return("'"===t||'"'===t||"`"===t)&&e.slice(-1)===t},t.createKey=function(e,t){var r=e;if(void 0===t)return r;for(var n=Object.keys(t),i=0;i<n.length;i++){var s=n[i];r+=";"+s+"="+String(t[s])}return r},t.createOptions=function(e){var r=t.extend.apply(null,arguments);return"boolean"==typeof r.expand&&(r.optimize=!r.expand),"boolean"==typeof r.optimize&&(r.expand=!r.optimize),!0===r.optimize&&(r.makeRe=!0),r},t.join=function(e,r,n){if(n=n||{},e=t.arrayify(e),r=t.arrayify(r),!e.length)return r;if(!r.length)return e;for(var i=e.length,s=-1,o=[];++s<i;){var a=e[s];if(Array.isArray(a)){for(var u=0;u<a.length;u++)a[u]=t.join(a[u],r,n);o.push(a)}else for(var c=0;c<r.length;c++){var p=r[c];Array.isArray(p)?o.push(t.join(a,p,n)):o.push(a+p)}}return o},t.split=function(e,r){var n=t.extend({sep:","},r);return"boolean"!=typeof n.keepQuotes&&(n.keepQuotes=!0),!1===n.unescape&&(n.keepEscaping=!0),splitString(e,n,t.escapeBrackets(n))},t.expand=function(e,r){var n=t.extend({rangeLimit:1e4},r),i=t.split(e,n),s={segs:i};if(t.isQuotedString(e))return s;if(!0===n.rangeLimit&&(n.rangeLimit=1e4),i.length>1){if(!1===n.optimize)return s.val=i[0],s;s.segs=t.stringifyArray(s.segs)}else if(1===i.length){var o=e.split("..");if(1===o.length)return s.val=s.segs[s.segs.length-1]||s.val||e,s.segs=[],s;if(2===o.length&&o[0]===o[1])return s.escaped=!0,s.val=o[0],s.segs=[],s;if(o.length>1){if(!1!==n.optimize&&(n.optimize=!0,delete n.expand),!0!==n.optimize){var a=Math.min(o[0],o[1]),u=Math.max(o[0],o[1]),c=o[2]||1;if(!1!==n.rangeLimit&&(u-a)/c>=n.rangeLimit)throw new RangeError("expanded array length exceeds range limit. Use options.rangeLimit to increase or disable the limit.")}return o.push(n),s.segs=t.fillRange.apply(null,o),s.segs.length?(!0===n.optimize&&(s.segs=t.stringifyArray(s.segs)),""===s.segs?s.val=e:s.val=s.segs[0],s):(s.escaped=!0,s.val=e,s)}}else s.val=e;return s},t.escapeBrackets=function(e){return function(r){if(r.escaped&&"b"===r.val)r.val="\\b";else if("("===r.val||"["===r.val){for(var n=t.extend({},e),i=[],s=r.val,o=r.str,a=r.idx-1;++a<o.length;){var u=o[a];if("\\"!==u){if("("===u&&i.push(u),"["===u&&i.push(u),")"===u&&(i.pop(),!i.length)){s+=u;break}if("]"===u&&(i.pop(),!i.length)){s+=u;break}s+=u}else s+=(!1===n.keepEscaping?"":u)+o[++a]}r.split=!1,r.val=s.slice(1),r.idx=a}}},t.isQuantifier=function(e){return/^(?:[0-9]?,[0-9]|[0-9],)$/.test(e)},t.stringifyArray=function(e){return[t.arrayify(e).join("|")]},t.arrayify=function(e){return void 0===e?[]:"string"==typeof e?[e]:e},t.isString=function(e){return null!=e&&"string"==typeof e},t.last=function(e,t){return e[e.length-(t||1)]},t.escapeRegex=function(e){return e.replace(/\\?([!^*?()[\]{}+?\/])/g,"\\$1")}}),compilers=function(e,t){e.compiler.set("bos",function(){this.output||(this.ast.queue=isEscaped(this.ast)?[this.ast.val]:[],this.ast.count=1)}).set("bracket",function(e){var t=e.close,r=e.escaped?"\\[":"[",n=e.negated,i=e.inner;"]-"===(i=i.replace(/\\(?=[\\\w]|$)/g,"\\\\"))&&(i="\\]\\-"),n&&-1===i.indexOf(".")&&(i+="."),n&&-1===i.indexOf("/")&&(i+="/");var s=r+n+i+t,o=e.parent.queue,a=utils_1.arrayify(o.pop());o.push(utils_1.join(a,s)),o.push.apply(o,[])}).set("brace",function(e){return e.queue=isEscaped(e)?[e.val]:[],e.count=1,this.mapVisit(e.nodes)}).set("brace.open",function(e){e.parent.open=e.val}).set("text",function(e){var r=e.parent.queue,n=e.escaped,i=[e.val];if(!1===e.optimize&&(t=utils_1.extend({},t,{optimize:!1})),e.multiplier>1&&(e.parent.count*=e.multiplier),!0===t.quantifiers&&utils_1.isQuantifier(e.val))n=!0;else if(e.val.length>1){if(isType(e.parent,"brace")&&!isEscaped(e)){var s=utils_1.expand(e.val,t);if(i=s.segs,s.isOptimized&&(e.parent.isOptimized=!0),!i.length){var o=s.val||e.val;!1!==t.unescape&&(o=(o=o.replace(/\\([,.])/g,"$1")).replace(/["'`]/g,"")),i=[o],n=!0}}}else","===e.val?t.expand?(e.parent.queue.push([""]),i=[""]):i=["|"]:n=!0;if(n&&isType(e.parent,"brace")&&(e.parent.nodes.length<=4&&1===e.parent.count?e.parent.escaped=!0:e.parent.length<=3&&(e.parent.escaped=!0)),hasQueue(e.parent)){var a=utils_1.arrayify(r.pop());e.parent.count>1&&t.expand&&(a=multiply(a,e.parent.count),e.parent.count=1),r.push(utils_1.join(utils_1.flatten(a),i.shift())),r.push.apply(r,i)}else e.parent.queue=i}).set("brace.close",function(e){var r=e.parent.queue,n=e.parent.parent,i=n.queue.pop(),s=e.parent.open,o=e.val;s&&o&&isOptimized(e,t)&&(s="(",o=")");var a=utils_1.last(r);e.parent.count>1&&t.expand&&(a=multiply(r.pop(),e.parent.count),e.parent.count=1,r.push(a)),o&&"string"==typeof a&&1===a.length&&(s="",o=""),!isLiteralBrace(e,t)&&!noInner(e)||e.parent.hasEmpty||(r.push(utils_1.join(s,r.pop()||"")),r=utils_1.flatten(utils_1.join(r,o))),void 0===i?n.queue=[r]:n.queue.push(utils_1.flatten(utils_1.join(i,r)))}).set("eos",function(e){this.input||(!1!==t.optimize?this.output=utils_1.last(utils_1.flatten(this.ast.queue)):Array.isArray(utils_1.last(this.ast.queue))?this.output=utils_1.flatten(this.ast.queue.pop()):this.output=utils_1.flatten(this.ast.queue),e.parent.count>1&&t.expand&&(this.output=multiply(this.output,e.parent.count)),this.output=utils_1.arrayify(this.output),this.ast.queue=[])})};function multiply(e,t,r){return utils_1.flatten(utils_1.repeat(utils_1.arrayify(e),t))}function isEscaped(e){return!0===e.escaped}function isOptimized(e,t){return!!e.parent.isOptimized||isType(e.parent,"brace")&&!isEscaped(e.parent)&&!0!==t.expand}function isLiteralBrace(e,t){return isEscaped(e.parent)||!1!==t.optimize}function noInner(e,t){if(1===e.parent.queue.length)return!0;var r=e.parent.nodes;return 3===r.length&&isType(r[0],"brace.open")&&!isType(r[1],"text")&&isType(r[2],"brace.close")}function isType(e,t){return void 0!==e&&e.type===t}function hasQueue(e){return Array.isArray(e.queue)&&e.queue.length}var accessor$1={get:"function",set:"function",configurable:"boolean",enumerable:"boolean"};function isAccessorDescriptor$1(e,t){if("string"==typeof t)return void 0!==Object.getOwnPropertyDescriptor(e,t);if("object"!==kindOf(e))return!1;if(has$2(e,"value")||has$2(e,"writable"))return!1;if(!has$2(e,"get")||"function"!=typeof e.get)return!1;if(has$2(e,"set")&&"function"!=typeof e[r]&&void 0!==e[r])return!1;for(var r in e)if(accessor$1.hasOwnProperty(r)&&kindOf(e[r])!==accessor$1[r]&&void 0!==e[r])return!1;return!0}function has$2(e,t){return{}.hasOwnProperty.call(e,t)}var isAccessorDescriptor_1$1=isAccessorDescriptor$1,isDataDescriptor$1=function(e,t){var r={configurable:"boolean",enumerable:"boolean",writable:"boolean"};if("object"!==kindOf(e))return!1;if("string"==typeof t)return void 0!==Object.getOwnPropertyDescriptor(e,t);if(!("value"in e||"writable"in e))return!1;for(var n in e)if("value"!==n&&r.hasOwnProperty(n)&&kindOf(e[n])!==r[n]&&void 0!==e[n])return!1;return!0},isDescriptor$1=function(e,t){return"object"===kindOf(e)&&("get"in e?isAccessorDescriptor_1$1(e,t):isDataDescriptor$1(e,t))},defineProperty$1=function(e,t,r){if("object"!=typeof e&&"function"!=typeof e)throw new TypeError("expected an object or function.");if("string"!=typeof t)throw new TypeError("expected `prop` to be a string.");return isDescriptor$1(r)&&("set"in r||"get"in r)?Object.defineProperty(e,t,r):Object.defineProperty(e,t,{configurable:!0,enumerable:!1,writable:!0,value:r})},toString$3=Object.prototype.toString,kindOf$2=function(e){if(void 0===e)return"undefined";if(null===e)return"null";if(!0===e||!1===e||e instanceof Boolean)return"boolean";if("string"==typeof e||e instanceof String)return"string";if("number"==typeof e||e instanceof Number)return"number";if("function"==typeof e||e instanceof Function)return"function";if(void 0!==Array.isArray&&Array.isArray(e))return"array";if(e instanceof RegExp)return"regexp";if(e instanceof Date)return"date";var t=toString$3.call(e);return"[object RegExp]"===t?"regexp":"[object Date]"===t?"date":"[object Arguments]"===t?"arguments":"[object Error]"===t?"error":isBuffer_1(e)?"buffer":"[object Set]"===t?"set":"[object WeakSet]"===t?"weakset":"[object Map]"===t?"map":"[object WeakMap]"===t?"weakmap":"[object Symbol]"===t?"symbol":"[object Int8Array]"===t?"int8array":"[object Uint8Array]"===t?"uint8array":"[object Uint8ClampedArray]"===t?"uint8clampedarray":"[object Int16Array]"===t?"int16array":"[object Uint16Array]"===t?"uint16array":"[object Int32Array]"===t?"int32array":"[object Uint32Array]"===t?"uint32array":"[object Float32Array]"===t?"float32array":"[object Float64Array]"===t?"float64array":"object"},snapdragonUtil=createCommonjsModule$1(function(e){var t=e.exports;function r(e){return"object"===kindOf$2(e)}function n(e){return"function"==typeof e}function i(e,t,r){return"function"!=typeof e.append?e.emit(t,r):e.append(t,r)}function s(e,t){if(!e)throw new Error(t)}t.isNode=function(e){return"object"===kindOf$2(e)&&!0===e.isNode},t.noop=function(e){i(this,"",e)},t.identity=function(e){i(this,e.val,e)},t.append=function(e){return function(t){i(this,e,t)}},t.toNoop=function(e,t){t?e.nodes=t:(delete e.nodes,e.type="text",e.val="")},t.visit=function(e,r){return s(t.isNode(e),"expected node to be an instance of Node"),s(n(r),"expected a visitor function"),r(e),e.nodes?t.mapVisit(e,r):e},t.mapVisit=function(e,r){var i;s(t.isNode(e),"expected node to be an instance of Node"),s((i=e.nodes,Array.isArray(i)),"expected node.nodes to be an array"),s(n(r),"expected a visitor function");for(var o=0;o<e.nodes.length;o++)t.visit(e.nodes[o],r);return e},t.addOpen=function(e,r,i,o){if(s(t.isNode(e),"expected node to be an instance of Node"),s(n(r),"expected Node to be a constructor function"),"function"==typeof i&&(o=i,i=""),"function"!=typeof o||o(e)){var a=new r({type:e.type+".open",val:i}),u=e.unshift||e.unshiftNode;return"function"==typeof u?u.call(e,a):t.unshiftNode(e,a),a}},t.addClose=function(e,r,i,o){if(s(t.isNode(e),"expected node to be an instance of Node"),s(n(r),"expected Node to be a constructor function"),"function"==typeof i&&(o=i,i=""),"function"!=typeof o||o(e)){var a=new r({type:e.type+".close",val:i}),u=e.push||e.pushNode;return"function"==typeof u?u.call(e,a):t.pushNode(e,a),a}},t.wrapNodes=function(e,r,i){return s(t.isNode(e),"expected node to be an instance of Node"),s(n(r),"expected Node to be a constructor function"),t.addOpen(e,r,i),t.addClose(e,r,i),e},t.pushNode=function(e,r){return s(t.isNode(e),"expected parent node to be an instance of Node"),s(t.isNode(r),"expected node to be an instance of Node"),r.define("parent",e),e.nodes=e.nodes||[],e.nodes.push(r),r},t.unshiftNode=function(e,r){s(t.isNode(e),"expected parent node to be an instance of Node"),s(t.isNode(r),"expected node to be an instance of Node"),r.define("parent",e),e.nodes=e.nodes||[],e.nodes.unshift(r)},t.popNode=function(e){return s(t.isNode(e),"expected node to be an instance of Node"),"function"==typeof e.pop?e.pop():e.nodes&&e.nodes.pop()},t.shiftNode=function(e){return s(t.isNode(e),"expected node to be an instance of Node"),"function"==typeof e.shift?e.shift():e.nodes&&e.nodes.shift()},t.removeNode=function(e,r){if(s(t.isNode(e),"expected parent.node to be an instance of Node"),s(t.isNode(r),"expected node to be an instance of Node"),!e.nodes)return null;if("function"==typeof e.remove)return e.remove(r);var n=e.nodes.indexOf(r);return-1!==n?e.nodes.splice(n,1):void 0},t.isType=function(e,r){switch(s(t.isNode(e),"expected node to be an instance of Node"),kindOf$2(r)){case"array":for(var n=r.slice(),i=0;i<n.length;i++)if(t.isType(e,n[i]))return!0;return!1;case"string":return e.type===r;case"regexp":return r.test(e.type);default:throw new TypeError('expected "type" to be an array, string or regexp')}},t.hasType=function(e,r){if(s(t.isNode(e),"expected node to be an instance of Node"),!Array.isArray(e.nodes))return!1;for(var n=0;n<e.nodes.length;n++)if(t.isType(e.nodes[n],r))return!0;return!1},t.firstOfType=function(e,r){for(var n=0;n<e.length;n++){var i=e[n];if(t.isType(i,r))return i}},t.findNode=function(e,r){return Array.isArray(e)?"number"==typeof r?e[r]:t.firstOfType(e,r):null},t.isOpen=function(e){return s(t.isNode(e),"expected node to be an instance of Node"),".open"===e.type.slice(-5)},t.isClose=function(e){return s(t.isNode(e),"expected node to be an instance of Node"),".close"===e.type.slice(-6)},t.hasOpen=function(e){s(t.isNode(e),"expected node to be an instance of Node");var r=e.first||e.nodes?e.nodes[0]:null;return!!t.isNode(r)&&r.type===e.type+".open"},t.hasClose=function(e){s(t.isNode(e),"expected node to be an instance of Node");var r=e.last||e.nodes?e.nodes[e.nodes.length-1]:null;return!!t.isNode(r)&&r.type===e.type+".close"},t.hasOpenAndClose=function(e){return t.hasOpen(e)&&t.hasClose(e)},t.addType=function(e,n){s(t.isNode(n),"expected node to be an instance of Node"),s(r(e),"expected state to be an object");var i=n.parent?n.parent.type:n.type.replace(/\.open$/,"");e.hasOwnProperty("inside")||(e.inside={}),e.inside.hasOwnProperty(i)||(e.inside[i]=[]);var o=e.inside[i];return o.push(n),o},t.removeType=function(e,n){s(t.isNode(n),"expected node to be an instance of Node"),s(r(e),"expected state to be an object");var i=n.parent?n.parent.type:n.type.replace(/\.close$/,"");if(e.inside.hasOwnProperty(i))return e.inside[i].pop()},t.isEmpty=function(e,r){if(s(t.isNode(e),"expected node to be an instance of Node"),!Array.isArray(e.nodes))return"text"!==e.type||("function"==typeof r?r(e,e.parent):!t.trim(e.val));for(var n=0;n<e.nodes.length;n++){var i=e.nodes[n];if(!t.isOpen(i)&&!t.isClose(i)&&!t.isEmpty(i,r))return!1}return!0},t.isInsideType=function(e,t){return s(r(e),"expected state to be an object"),s("string"==typeof t,"expected type to be a string"),!!e.hasOwnProperty("inside")&&(!!e.inside.hasOwnProperty(t)&&e.inside[t].length>0)},t.isInside=function(e,n,i){if(s(t.isNode(n),"expected node to be an instance of Node"),s(r(e),"expected state to be an object"),Array.isArray(i)){for(var o=0;o<i.length;o++)if(t.isInside(e,n,i[o]))return!0;return!1}var a=n.parent;if("string"==typeof i)return a&&a.type===i||t.isInsideType(e,i);if("regexp"===kindOf$2(i)){if(a&&a.type&&i.test(a.type))return!0;for(var u=Object.keys(e.inside),c=u.length,p=-1;++p<c;){var l=u[p],h=e.inside[l];if(Array.isArray(h)&&0!==h.length&&i.test(l))return!0}}return!1},t.last=function(e,t){return e[e.length-(t||1)]},t.arrayify=function(e){return"string"==typeof e&&""!==e?[e]:Array.isArray(e)?e:[]},t.stringify=function(e){return t.arrayify(e).join(",")},t.trim=function(e){return"string"==typeof e?e.trim():""}}),snapdragonNode=createCommonjsModule$1(function(e,t){var r;function n(e,t,i){if("string"!=typeof t&&(i=t,t=null),defineProperty$1(this,"parent",i),defineProperty$1(this,"isNode",!0),defineProperty$1(this,"expect",null),"string"!=typeof t&&isobject(e)){r||(r=Object.getOwnPropertyNames(n.prototype));for(var s=Object.keys(e),o=0;o<s.length;o++){var a=s[o];-1===r.indexOf(a)&&(this[a]=e[a])}}else this.type=t,this.val=e}function i(e,t){if(!e)throw new Error(t)}n.isNode=function(e){return snapdragonUtil.isNode(e)},n.prototype.define=function(e,t){return defineProperty$1(this,e,t),this},n.prototype.isEmpty=function(e){return snapdragonUtil.isEmpty(this,e)},n.prototype.push=function(e){return i(n.isNode(e),"expected node to be an instance of Node"),defineProperty$1(e,"parent",this),this.nodes=this.nodes||[],this.nodes.push(e)},n.prototype.unshift=function(e){return i(n.isNode(e),"expected node to be an instance of Node"),defineProperty$1(e,"parent",this),this.nodes=this.nodes||[],this.nodes.unshift(e)},n.prototype.pop=function(){return this.nodes&&this.nodes.pop()},n.prototype.shift=function(){return this.nodes&&this.nodes.shift()},n.prototype.remove=function(e){i(n.isNode(e),"expected node to be an instance of Node"),this.nodes=this.nodes||[];var t=e.index;return-1!==t?(e.index=-1,this.nodes.splice(t,1)):null},n.prototype.find=function(e){return snapdragonUtil.findNode(this.nodes,e)},n.prototype.isType=function(e){return snapdragonUtil.isType(this,e)},n.prototype.hasType=function(e){return snapdragonUtil.hasType(this,e)},Object.defineProperty(n.prototype,"siblings",{set:function(){throw new Error("node.siblings is a getter and cannot be defined")},get:function(){return this.parent?this.parent.nodes:null}}),Object.defineProperty(n.prototype,"index",{set:function(e){defineProperty$1(this,"idx",e)},get:function(){return Array.isArray(this.siblings)?((-1!==this.idx?this.siblings[this.idx]:null)!==this&&(this.idx=this.siblings.indexOf(this)),this.idx):-1}}),Object.defineProperty(n.prototype,"prev",{set:function(){throw new Error("node.prev is a getter and cannot be defined")},get:function(){return Array.isArray(this.siblings)?this.siblings[this.index-1]||this.parent.prev:null}}),Object.defineProperty(n.prototype,"next",{set:function(){throw new Error("node.next is a getter and cannot be defined")},get:function(){return Array.isArray(this.siblings)?this.siblings[this.index+1]||this.parent.next:null}}),Object.defineProperty(n.prototype,"first",{get:function(){return this.nodes?this.nodes[0]:null}}),Object.defineProperty(n.prototype,"last",{get:function(){return this.nodes?snapdragonUtil.last(this.nodes):null}}),Object.defineProperty(n.prototype,"scope",{get:function(){return!0!==this.isScope&&this.parent?this.parent.scope:this}}),e.exports=n}),parsers=function(e,t){e.parser.set("bos",function(){this.parsed||(this.ast=this.nodes[0]=new snapdragonNode(this.ast))}).set("escape",function(){var e=this.position(),r=this.match(/^(?:\\(.)|\$\{)/);if(r){var n=this.prev(),i=utils_1.last(n.nodes),s=e(new snapdragonNode({type:"text",multiplier:1,val:r[0]}));if("\\\\"===s.val)return s;if("${"===s.val)for(var o,a=this.input,u=-1;o=a[++u];)if(this.consume(1),s.val+=o,"\\"!==o){if("}"===o)break}else s.val+=a[++u];return!1!==this.options.unescape&&(s.val=s.val.replace(/\\([{}])/g,"$1")),'"'===i.val&&'"'===this.input.charAt(0)?(i.val=s.val,void this.consume(1)):concatNodes.call(this,e,s,n,t)}}).set("bracket",function(){var e=this.isInside("brace"),t=this.position(),r=this.match(/^(?:\[([!^]?)([^\]]{2,}|\]-)(\]|[^*+?]+)|\[)/);if(r){var n=this.prev(),i=r[0],s=r[1]?"^":"",o=r[2]||"",a=r[3]||"";e&&"brace"===n.type&&(n.text=n.text||"",n.text+=i);var u=this.input.slice(0,2);if(""===o&&"\\]"===u){o+=u,this.consume(2);for(var c,p=this.input,l=-1;c=p[++l];){if(this.consume(1),"]"===c){a=c;break}o+=c}}return t(new snapdragonNode({type:"bracket",val:i,escaped:"]"!==a,negated:s,inner:o,close:a}))}}).set("multiplier",function(){var e=this.isInside("brace"),r=this.position(),n=this.match(/^\{((?:,|\{,+\})+)\}/);if(n){this.multiplier=!0;var i=this.prev(),s=n[0];e&&"brace"===i.type&&(i.text=i.text||"",i.text+=s);var o=r(new snapdragonNode({type:"text",multiplier:1,match:n,val:s}));return concatNodes.call(this,r,o,i,t)}}).set("brace.open",function(){var e=this.position(),t=this.match(/^\{(?!(?:[^\\}]?|,+)\})/);if(t){var r=this.prev(),n=utils_1.last(r.nodes);n&&n.val&&isExtglobChar(n.val.slice(-1))&&(n.optimize=!1);var i=e(new snapdragonNode({type:"brace.open",val:t[0]})),s=e(new snapdragonNode({type:"brace",nodes:[]}));s.push(i),r.push(s),this.push("brace",s)}}).set("brace.close",function(){var e=this.position(),t=this.match(/^\}/);if(t&&t[0]){var r=this.pop("brace"),n=e(new snapdragonNode({type:"brace.close",val:t[0]}));if(!this.isType(r,"brace")){if(this.options.strict)throw new Error('missing opening "{"');return n.type="text",n.multiplier=0,n.escaped=!0,n}var i=this.prev(),s=utils_1.last(i.nodes);if(s.text)if(")"===utils_1.last(s.nodes).val&&/[!@*?+]\(/.test(s.text)){var o=s.nodes[0],a=s.nodes[1];"brace.open"===o.type&&a&&"text"===a.type&&(a.optimize=!1)}if(r.nodes.length>2){var u=r.nodes[1];"text"===u.type&&","===u.val&&(r.nodes.splice(1,1),r.nodes.push(u))}r.push(n)}}).set("boundary",function(){var e=this.position(),t=this.match(/^[$^](?!\{)/);if(t)return e(new snapdragonNode({type:"text",val:t[0]}))}).set("nobrace",function(){var e=this.isInside("brace"),t=this.position(),r=this.match(/^\{[^,]?\}/);if(r){var n=this.prev(),i=r[0];return e&&"brace"===n.type&&(n.text=n.text||"",n.text+=i),t(new snapdragonNode({type:"text",multiplier:0,val:i}))}}).set("text",function(){var e=this.isInside("brace"),r=this.position(),n=this.match(/^((?!\\)[^${}[\]])+/);if(n){var i=this.prev(),s=n[0];e&&"brace"===i.type&&(i.text=i.text||"",i.text+=s);var o=r(new snapdragonNode({type:"text",multiplier:1,val:s}));return concatNodes.call(this,r,o,i,t)}})};function isExtglobChar(e){return"!"===e||"@"===e||"*"===e||"?"===e||"+"===e}function concatNodes(e,t,r,n){t.orig=t.val;var i=this.prev(),s=utils_1.last(i.nodes),o=!1;if(t.val.length>1){var a=t.val.charAt(0),u=t.val.slice(-1);o='"'===a&&'"'===u||"'"===a&&"'"===u||"`"===a&&"`"===u}if(o&&!1!==n.unescape&&(t.val=t.val.slice(1,t.val.length-1),t.escaped=!0),t.match){var c=t.match[1];c&&-1!==c.indexOf("}")||(c=t.match[0]);var p=c.replace(/\{/g,",").replace(/\}/g,"");t.multiplier*=p.length,t.val=""}"text"===s.type&&1===s.multiplier&&1===t.multiplier&&t.val?s.val+=t.val:i.push(t)}var accessor$2={get:"function",set:"function",configurable:"boolean",enumerable:"boolean"};function isAccessorDescriptor$2(e,t){if("string"==typeof t)return void 0!==Object.getOwnPropertyDescriptor(e,t);if("object"!==kindOf(e))return!1;if(has$3(e,"value")||has$3(e,"writable"))return!1;if(!has$3(e,"get")||"function"!=typeof e.get)return!1;if(has$3(e,"set")&&"function"!=typeof e[r]&&void 0!==e[r])return!1;for(var r in e)if(accessor$2.hasOwnProperty(r)&&kindOf(e[r])!==accessor$2[r]&&void 0!==e[r])return!1;return!0}function has$3(e,t){return{}.hasOwnProperty.call(e,t)}var isAccessorDescriptor_1$2=isAccessorDescriptor$2,isDataDescriptor$2=function(e,t){var r={configurable:"boolean",enumerable:"boolean",writable:"boolean"};if("object"!==kindOf(e))return!1;if("string"==typeof t)return void 0!==Object.getOwnPropertyDescriptor(e,t);if(!("value"in e||"writable"in e))return!1;for(var n in e)if("value"!==n&&r.hasOwnProperty(n)&&kindOf(e[n])!==r[n]&&void 0!==e[n])return!1;return!0},isDescriptor$2=function(e,t){return"object"===kindOf(e)&&("get"in e?isAccessorDescriptor_1$2(e,t):isDataDescriptor$2(e,t))},defineProperty$2=function(e,t,r){if("object"!=typeof e&&"function"!=typeof e)throw new TypeError("expected an object or function.");if("string"!=typeof t)throw new TypeError("expected `prop` to be a string.");return isDescriptor$2(r)&&("set"in r||"get"in r)?Object.defineProperty(e,t,r):Object.defineProperty(e,t,{configurable:!0,enumerable:!1,writable:!0,value:r})},componentEmitter=createCommonjsModule$1(function(e){function t(e){if(e)return function(e){for(var r in t.prototype)e[r]=t.prototype[r];return e}(e)}e.exports=t,t.prototype.on=t.prototype.addEventListener=function(e,t){return this._callbacks=this._callbacks||{},(this._callbacks["$"+e]=this._callbacks["$"+e]||[]).push(t),this},t.prototype.once=function(e,t){function r(){this.off(e,r),t.apply(this,arguments)}return r.fn=t,this.on(e,r),this},t.prototype.off=t.prototype.removeListener=t.prototype.removeAllListeners=t.prototype.removeEventListener=function(e,t){if(this._callbacks=this._callbacks||{},0==arguments.length)return this._callbacks={},this;var r,n=this._callbacks["$"+e];if(!n)return this;if(1==arguments.length)return delete this._callbacks["$"+e],this;for(var i=0;i<n.length;i++)if((r=n[i])===t||r.fn===t){n.splice(i,1);break}return this},t.prototype.emit=function(e){this._callbacks=this._callbacks||{};var t=[].slice.call(arguments,1),r=this._callbacks["$"+e];if(r)for(var n=0,i=(r=r.slice(0)).length;n<i;++n)r[n].apply(this,t);return this},t.prototype.listeners=function(e){return this._callbacks=this._callbacks||{},this._callbacks["$"+e]||[]},t.prototype.hasListeners=function(e){return!!this.listeners(e).length}}),objectVisit=function(e,t,r,n){if(!isobject(e)&&"function"!=typeof e)throw new Error("object-visit expects `thisArg` to be an object.");if("string"!=typeof t)throw new Error("object-visit expects `method` name to be a string");if("function"!=typeof e[t])return e;var i=[].slice.call(arguments,3);for(var s in r=r||{}){var o=[s,r[s]].concat(i);e[t].apply(e,o)}return e},mapVisit=function(e,t,r){if(isObject$2(r))return objectVisit.apply(null,arguments);if(!Array.isArray(r))throw new TypeError("expected an array: "+util$2$1.inspect(r));for(var n=[].slice.call(arguments,3),i=0;i<r.length;i++){var s=r[i];isObject$2(s)?objectVisit.apply(null,[e,t,s].concat(n)):e[t].apply(e,[s].concat(n))}};function isObject$2(e){return e&&("function"==typeof e||!Array.isArray(e)&&"object"==typeof e)}var collectionVisit=function(e,t,r){var n;if("string"==typeof r&&t in e){var i=[].slice.call(arguments,2);n=e[t].apply(e,i)}else n=Array.isArray(r)?mapVisit.apply(null,arguments):objectVisit.apply(null,arguments);return void 0!==n?n:e},toString$4=Object.prototype.toString,kindOf$3=function(e){if(void 0===e)return"undefined";if(null===e)return"null";if(!0===e||!1===e||e instanceof Boolean)return"boolean";if("string"==typeof e||e instanceof String)return"string";if("number"==typeof e||e instanceof Number)return"number";if("function"==typeof e||e instanceof Function)return"function";if(void 0!==Array.isArray&&Array.isArray(e))return"array";if(e instanceof RegExp)return"regexp";if(e instanceof Date)return"date";var t=toString$4.call(e);return"[object RegExp]"===t?"regexp":"[object Date]"===t?"date":"[object Arguments]"===t?"arguments":"[object Error]"===t?"error":isBuffer_1(e)?"buffer":"[object Set]"===t?"set":"[object WeakSet]"===t?"weakset":"[object Map]"===t?"map":"[object WeakMap]"===t?"weakmap":"[object Symbol]"===t?"symbol":"[object Int8Array]"===t?"int8array":"[object Uint8Array]"===t?"uint8array":"[object Uint8ClampedArray]"===t?"uint8clampedarray":"[object Int16Array]"===t?"int16array":"[object Uint16Array]"===t?"uint16array":"[object Int32Array]"===t?"int32array":"[object Uint32Array]"===t?"uint32array":"[object Float32Array]"===t?"float32array":"[object Float64Array]"===t?"float64array":"object"},toObjectPath=function(e){return"arguments"!==kindOf$3(e)&&(e=arguments),filter$1(e).join(".")};function filter$1(e){for(var t=e.length,r=-1,n=[];++r<t;){var i=e[r];"arguments"===kindOf$3(i)||Array.isArray(i)?n.push.apply(n,filter$1(i)):"string"==typeof i&&n.push(i)}return n}var arrUnion=function(e){if(!Array.isArray(e))throw new TypeError("arr-union expects the first argument to be an array.");for(var t=arguments.length,r=0;++r<t;){var n=arguments[r];if(n){Array.isArray(n)||(n=[n]);for(var i=0;i<n.length;i++){var s=n[i];e.indexOf(s)>=0||e.push(s)}}}return e},getValue=function(e,t,r,n,i){if(!isObject$3(e)||!t)return e;if(t=toString$5(t),r&&(t+="."+toString$5(r)),n&&(t+="."+toString$5(n)),i&&(t+="."+toString$5(i)),t in e)return e[t];for(var s=t.split("."),o=s.length,a=-1;e&&++a<o;){for(var u=s[a];"\\"===u[u.length-1];)u=u.slice(0,-1)+"."+s[++a];e=e[u]}return e};function isObject$3(e){return null!==e&&("object"==typeof e||"function"==typeof e)}function toString$5(e){return e?Array.isArray(e)?e.join("."):e:""}var extendShallow$3=function(e){isExtendable$1(e)||(e={});for(var t=arguments.length,r=1;r<t;r++){var n=arguments[r];isExtendable$1(n)&&assign$3(e,n)}return e};function assign$3(e,t){for(var r in t)hasOwn$3(t,r)&&(e[r]=t[r])}function hasOwn$3(e,t){return Object.prototype.hasOwnProperty.call(e,t)}var setValue=function(e,t,r){if(!isExtendable$1(e))return e;if(Array.isArray(t)&&(t=toObjectPath(t)),"string"!=typeof t)return e;for(var n,i=t.split("."),s=i.length,o=-1,a=e;++o<s;){for(var u=i[o];"\\"===u[u.length-1];)u=u.slice(0,-1)+"."+i[++o];if(o===s-1){n=u;break}isExtendable$1(e[u])||(e[u]={}),e=e[u]}return e.hasOwnProperty(n)&&isExtendable$1(e[n])&&isPlainObject(r)?extendShallow$3(e[n],r):e[n]=r,a},unionValue=function(e,t,r){if(!isExtendable$1(e))throw new TypeError("union-value expects the first argument to be an object.");if("string"!=typeof t)throw new TypeError("union-value expects `prop` to be a string.");var n=arrayify(getValue(e,t));return setValue(e,t,arrUnion(n,arrayify(r))),e};function arrayify(e){return null==e?[]:Array.isArray(e)?e:[e]}var toString$6={}.toString,isarray=Array.isArray||function(e){return"[object Array]"==toString$6.call(e)},isobject$1=function(e){return null!=e&&"object"==typeof e&&!1===isarray(e)},hasValues=function(e,t){if(null==e)return!1;if("boolean"==typeof e)return!0;if("number"==typeof e)return 0!==e||!0!==t;if(void 0!==e.length)return 0!==e.length;for(var r in e)if(e.hasOwnProperty(r))return!0;return!1},hasValue=function(e,t,r){return isobject$1(e)?hasValues(getValue(e,t),r):hasValues(e,t)},unsetValue=function(e,t){if(!isobject(e))throw new TypeError("expected an object.");if(e.hasOwnProperty(t))return delete e[t],!0;if(hasValue(e,t)){for(var r=t.split("."),n=r.pop();r.length&&"\\"===r[r.length-1].slice(-1);)n=r.pop().slice(0,-1)+"."+n;for(;r.length;)e=e[t=r.shift()];return delete e[n]}return!0},extendShallow$4=function(e){isExtendable$1(e)||(e={});for(var t=arguments.length,r=1;r<t;r++){var n=arguments[r];isExtendable$1(n)&&assign$4(e,n)}return e};function assign$4(e,t){for(var r in t)hasOwn$4(t,r)&&(e[r]=t[r])}function hasOwn$4(e,t){return Object.prototype.hasOwnProperty.call(e,t)}var setValue$1=function(e,t,r){if(!isExtendable$1(e))return e;if(Array.isArray(t)&&(t=[].concat.apply([],t).join(".")),"string"!=typeof t)return e;for(var n=splitString(t,{sep:".",brackets:!0}),i=n.length,s=-1,o=e;++s<i;){var a=n[s];s===i-1?isPlainObject(o[a])&&isPlainObject(r)?o[a]=extendShallow$4({},o[a],r):o[a]=r:(isExtendable$1(o[a])||(o[a]={}),o=o[a])}return e};function namespace(e){function t(t){e&&(this[e]={}),t&&this.set(t)}return componentEmitter(t.prototype),t.prototype.set=function(t,r){return Array.isArray(t)&&2===arguments.length&&(t=toObjectPath(t)),isobject(t)||Array.isArray(t)?this.visit("set",t):(setValue$1(e?this[e]:this,t,r),this.emit("set",t,r)),this},t.prototype.union=function(t,r){Array.isArray(t)&&2===arguments.length&&(t=toObjectPath(t));var n=e?this[e]:this;return unionValue(n,t,arrayify$1(r)),this.emit("union",r),this},t.prototype.get=function(t){t=toObjectPath(arguments);var r=e?this[e]:this,n=getValue(r,t);return this.emit("get",t,n),n},t.prototype.has=function(t){t=toObjectPath(arguments);var r=e?this[e]:this,n=void 0!==getValue(r,t);return this.emit("has",t,n),n},t.prototype.del=function(t){return Array.isArray(t)?this.visit("del",t):(unsetValue(e?this[e]:this,t),this.emit("del",t)),this},t.prototype.clear=function(){e&&(this[e]={})},t.prototype.visit=function(e,t){return collectionVisit(this,e,t),this},t}function arrayify$1(e){return e?Array.isArray(e)?e:[e]:[]}var cacheBase=namespace(),namespace_1=namespace;cacheBase.namespace=namespace_1;var isExtendable$2=function(e){return isPlainObject(e)||"function"==typeof e||Array.isArray(e)},forIn=function(e,t,r){for(var n in e)if(!1===t.call(r,e[n],n,e))break};function mixinDeep(e,t){for(var r=arguments.length,n=0;++n<r;){var i=arguments[n];isObject$4(i)&&forIn(i,copy,e)}return e}function copy(e,t){if("__proto__"!==t){var r=this[t];isObject$4(e)&&isObject$4(r)?mixinDeep(r,e):this[t]=e}}function isObject$4(e){return isExtendable$2(e)&&!Array.isArray(e)}var mixinDeep_1=mixinDeep;function pascalcase(e){if("string"!=typeof e)throw new TypeError("expected a string.");return 1===(e=e.replace(/([A-Z])/g," $1")).length?e.toUpperCase():(e=(e=e.replace(/^[\W_]+|[\W_]+$/g,"").toLowerCase()).charAt(0).toUpperCase()+e.slice(1)).replace(/[\W_]+(\w|$)/g,function(e,t){return t.toUpperCase()})}var pascalcase_1=pascalcase,toString$7=Object.prototype.toString,kindOf$4=function(e){var t=typeof e;return"undefined"===t?"undefined":null===e?"null":!0===e||!1===e||e instanceof Boolean?"boolean":"string"===t||e instanceof String?"string":"number"===t||e instanceof Number?"number":"function"===t||e instanceof Function?void 0!==e.constructor.name&&"Generator"===e.constructor.name.slice(0,9)?"generatorfunction":"function":void 0!==Array.isArray&&Array.isArray(e)?"array":e instanceof RegExp?"regexp":e instanceof Date?"date":"[object RegExp]"===(t=toString$7.call(e))?"regexp":"[object Date]"===t?"date":"[object Arguments]"===t?"arguments":"[object Error]"===t?"error":"[object Promise]"===t?"promise":isBuffer$2(e)?"buffer":"[object Set]"===t?"set":"[object WeakSet]"===t?"weakset":"[object Map]"===t?"map":"[object WeakMap]"===t?"weakmap":"[object Symbol]"===t?"symbol":"[object Map Iterator]"===t?"mapiterator":"[object Set Iterator]"===t?"setiterator":"[object String Iterator]"===t?"stringiterator":"[object Array Iterator]"===t?"arrayiterator":"[object Int8Array]"===t?"int8array":"[object Uint8Array]"===t?"uint8array":"[object Uint8ClampedArray]"===t?"uint8clampedarray":"[object Int16Array]"===t?"int16array":"[object Uint16Array]"===t?"uint16array":"[object Int32Array]"===t?"int32array":"[object Uint32Array]"===t?"uint32array":"[object Float32Array]"===t?"float32array":"[object Float64Array]"===t?"float64array":"object"};function isBuffer$2(e){return e.constructor&&"function"==typeof e.constructor.isBuffer&&e.constructor.isBuffer(e)}var toString$8=Object.prototype.toString,kindOf$5=function(e){if(void 0===e)return"undefined";if(null===e)return"null";if(!0===e||!1===e||e instanceof Boolean)return"boolean";if("string"==typeof e||e instanceof String)return"string";if("number"==typeof e||e instanceof Number)return"number";if("function"==typeof e||e instanceof Function)return"function";if(void 0!==Array.isArray&&Array.isArray(e))return"array";if(e instanceof RegExp)return"regexp";if(e instanceof Date)return"date";var t=toString$8.call(e);return"[object RegExp]"===t?"regexp":"[object Date]"===t?"date":"[object Arguments]"===t?"arguments":"[object Error]"===t?"error":isBuffer_1(e)?"buffer":"[object Set]"===t?"set":"[object WeakSet]"===t?"weakset":"[object Map]"===t?"map":"[object WeakMap]"===t?"weakmap":"[object Symbol]"===t?"symbol":"[object Int8Array]"===t?"int8array":"[object Uint8Array]"===t?"uint8array":"[object Uint8ClampedArray]"===t?"uint8clampedarray":"[object Int16Array]"===t?"int16array":"[object Uint16Array]"===t?"uint16array":"[object Int32Array]"===t?"int32array":"[object Uint32Array]"===t?"uint32array":"[object Float32Array]"===t?"float32array":"[object Float64Array]"===t?"float64array":"object"},accessor$3={get:"function",set:"function",configurable:"boolean",enumerable:"boolean"};function isAccessorDescriptor$3(e,t){if("string"==typeof t)return void 0!==Object.getOwnPropertyDescriptor(e,t);if("object"!==kindOf$5(e))return!1;if(has$4(e,"value")||has$4(e,"writable"))return!1;if(!has$4(e,"get")||"function"!=typeof e.get)return!1;if(has$4(e,"set")&&"function"!=typeof e[r]&&void 0!==e[r])return!1;for(var r in e)if(accessor$3.hasOwnProperty(r)&&kindOf$5(e[r])!==accessor$3[r]&&void 0!==e[r])return!1;return!0}function has$4(e,t){return{}.hasOwnProperty.call(e,t)}var isAccessorDescriptor_1$3=isAccessorDescriptor$3,toString$9=Object.prototype.toString,kindOf$6=function(e){if(void 0===e)return"undefined";if(null===e)return"null";if(!0===e||!1===e||e instanceof Boolean)return"boolean";if("string"==typeof e||e instanceof String)return"string";if("number"==typeof e||e instanceof Number)return"number";if("function"==typeof e||e instanceof Function)return"function";if(void 0!==Array.isArray&&Array.isArray(e))return"array";if(e instanceof RegExp)return"regexp";if(e instanceof Date)return"date";var t=toString$9.call(e);return"[object RegExp]"===t?"regexp":"[object Date]"===t?"date":"[object Arguments]"===t?"arguments":"[object Error]"===t?"error":isBuffer_1(e)?"buffer":"[object Set]"===t?"set":"[object WeakSet]"===t?"weakset":"[object Map]"===t?"map":"[object WeakMap]"===t?"weakmap":"[object Symbol]"===t?"symbol":"[object Int8Array]"===t?"int8array":"[object Uint8Array]"===t?"uint8array":"[object Uint8ClampedArray]"===t?"uint8clampedarray":"[object Int16Array]"===t?"int16array":"[object Uint16Array]"===t?"uint16array":"[object Int32Array]"===t?"int32array":"[object Uint32Array]"===t?"uint32array":"[object Float32Array]"===t?"float32array":"[object Float64Array]"===t?"float64array":"object"},data$1={configurable:"boolean",enumerable:"boolean",writable:"boolean"};function isDataDescriptor$3(e,t){if("object"!==kindOf$6(e))return!1;if("string"==typeof t)return void 0!==Object.getOwnPropertyDescriptor(e,t);if(!("value"in e||"writable"in e))return!1;for(var r in e)if("value"!==r&&data$1.hasOwnProperty(r)&&kindOf$6(e[r])!==data$1[r]&&void 0!==e[r])return!1;return!0}var isDataDescriptor_1=isDataDescriptor$3,isDescriptor$3=function(e,t){return"object"===kindOf$4(e)&&("get"in e?isAccessorDescriptor_1$3(e,t):isDataDescriptor_1(e,t))},defineProperty$3=function(e,t,r){if("object"!=typeof e&&"function"!=typeof e)throw new TypeError("expected an object or function.");if("string"!=typeof t)throw new TypeError("expected `prop` to be a string.");return isDescriptor$3(r)&&("set"in r||"get"in r)?Object.defineProperty(e,t,r):Object.defineProperty(e,t,{configurable:!0,enumerable:!1,writable:!0,value:r})},toString$a=Object.prototype.toString,kindOf$7=function(e){if(void 0===e)return"undefined";if(null===e)return"null";if(!0===e||!1===e||e instanceof Boolean)return"boolean";if("string"==typeof e||e instanceof String)return"string";if("number"==typeof e||e instanceof Number)return"number";if("function"==typeof e||e instanceof Function)return"function";if(void 0!==Array.isArray&&Array.isArray(e))return"array";if(e instanceof RegExp)return"regexp";if(e instanceof Date)return"date";var t=toString$a.call(e);return"[object RegExp]"===t?"regexp":"[object Date]"===t?"date":"[object Arguments]"===t?"arguments":"[object Error]"===t?"error":isBuffer_1(e)?"buffer":"[object Set]"===t?"set":"[object WeakSet]"===t?"weakset":"[object Map]"===t?"map":"[object WeakMap]"===t?"weakmap":"[object Symbol]"===t?"symbol":"[object Int8Array]"===t?"int8array":"[object Uint8Array]"===t?"uint8array":"[object Uint8ClampedArray]"===t?"uint8clampedarray":"[object Int16Array]"===t?"int16array":"[object Uint16Array]"===t?"uint16array":"[object Int32Array]"===t?"int32array":"[object Uint32Array]"===t?"uint32array":"[object Float32Array]"===t?"float32array":"[object Float64Array]"===t?"float64array":"object"},copyDescriptor=function(e,t,r,n){if(isObject$5(t)||"function"==typeof t||(n=r,r=t,t=e),!isObject$5(e)&&"function"!=typeof e)throw new TypeError("expected the first argument to be an object");if(!isObject$5(t)&&"function"!=typeof t)throw new TypeError("expected provider to be an object");if("string"!=typeof n&&(n=r),"string"!=typeof r)throw new TypeError("expected key to be a string");if(!(r in t))throw new Error('property "'+r+'" does not exist');var i=Object.getOwnPropertyDescriptor(t,r);i&&Object.defineProperty(e,n,i)};function isObject$5(e){return"[object Object]"==={}.toString.call(e)}var defineProperty$4=function(e,t,r){if("object"!=typeof e&&"function"!=typeof e)throw new TypeError("expected an object or function.");if("string"!=typeof t)throw new TypeError("expected `prop` to be a string.");return isDescriptor$3(r)&&("set"in r||"get"in r)?Object.defineProperty(e,t,r):Object.defineProperty(e,t,{configurable:!0,enumerable:!1,writable:!0,value:r})};function copy$1(e,t,r){if(!isObject$6(e))throw new TypeError("expected receiving object to be an object.");if(!isObject$6(t))throw new TypeError("expected providing object to be an object.");var n=nativeKeys(t),i=Object.keys(t),s=n.length;for(r=arrayify$2(r);s--;){var o=n[s];has$5(i,o)?defineProperty$4(e,o,t[o]):o in e||has$5(r,o)||copyDescriptor(e,t,o)}}function isObject$6(e){return"object"===kindOf$7(e)||"function"==typeof e}function has$5(e,t){var r=(t=arrayify$2(t)).length;if(isObject$6(e)){for(var n in e)if(t.indexOf(n)>-1)return!0;return has$5(nativeKeys(e),t)}if(Array.isArray(e)){for(var i=e;r--;)if(i.indexOf(t[r])>-1)return!0;return!1}throw new TypeError("expected an array or object.")}function arrayify$2(e){return e?Array.isArray(e)?e:[e]:[]}function hasConstructor(e){return isObject$6(e)&&void 0!==e.constructor}function nativeKeys(e){return hasConstructor(e)?Object.getOwnPropertyNames(e):[]}var objectCopy=copy$1,has_1=has$5;objectCopy.has=has_1;var defineProperty$5=function(e,t,r){if("object"!=typeof e&&"function"!=typeof e)throw new TypeError("expected an object or function.");if("string"!=typeof t)throw new TypeError("expected `prop` to be a string.");return isDescriptor$3(r)&&("set"in r||"get"in r)?Object.defineProperty(e,t,r):Object.defineProperty(e,t,{configurable:!0,enumerable:!1,writable:!0,value:r})};function extend$1(e,t){if("function"!=typeof e)throw new TypeError("expected Parent to be a function.");return function(r,n){if("function"!=typeof r)throw new TypeError("expected Ctor to be a function.");if(util$2$1.inherits(r,e),objectCopy(r,e),"object"==typeof n){var i=Object.create(n);for(var s in i)r.prototype[s]=i[s]}defineProperty$5(r.prototype,"_parent_",{configurable:!0,set:function(){},get:function(){return e.prototype}}),"function"==typeof t&&t(r,e),r.extend=extend$1(r,t)}}var staticExtend=extend$1,classUtils=createCommonjsModule$1(function(e){var t=e.exports;t.isObject=function(e){return isobject(e)||"function"==typeof e},t.has=function(e,r){var n=(r=t.arrayify(r)).length;if(t.isObject(e)){for(var i in e)if(r.indexOf(i)>-1)return!0;var s=t.nativeKeys(e);return t.has(s,r)}if(Array.isArray(e)){for(var o=e;n--;)if(o.indexOf(r[n])>-1)return!0;return!1}throw new TypeError("expected an array or object.")},t.hasAll=function(e,r){for(var n=(r=t.arrayify(r)).length;n--;)if(!t.has(e,r[n]))return!1;return!0},t.arrayify=function(e){return e?Array.isArray(e)?e:[e]:[]},t.noop=function(){},t.identity=function(e){return e},t.hasConstructor=function(e){return t.isObject(e)&&void 0!==e.constructor},t.nativeKeys=function(e){if(!t.hasConstructor(e))return[];var r=Object.getOwnPropertyNames(e);return"caller"in e&&r.push("caller"),r},t.getDescriptor=function(e,r){if(!t.isObject(e))throw new TypeError("expected an object.");if("string"!=typeof r)throw new TypeError("expected key to be a string.");return Object.getOwnPropertyDescriptor(e,r)},t.copyDescriptor=function(e,r,n){if(!t.isObject(e))throw new TypeError("expected receiving object to be an object.");if(!t.isObject(r))throw new TypeError("expected providing object to be an object.");if("string"!=typeof n)throw new TypeError("expected name to be a string.");var i=t.getDescriptor(r,n);i&&Object.defineProperty(e,n,i)},t.copy=function(e,r,n){if(!t.isObject(e))throw new TypeError("expected receiving object to be an object.");if(!t.isObject(r))throw new TypeError("expected providing object to be an object.");var i,s=Object.getOwnPropertyNames(r),o=Object.keys(r),a=s.length;for(n=t.arrayify(n);a--;)i=s[a],t.has(o,i)?defineProperty$3(e,i,r[i]):i in e||t.has(n,i)||t.copyDescriptor(e,r,i)},t.inherit=function(e,r,n){if(!t.isObject(e))throw new TypeError("expected receiving object to be an object.");if(!t.isObject(r))throw new TypeError("expected providing object to be an object.");var i=[];for(var s in r)i.push(s),e[s]=r[s];i=i.concat(t.arrayify(n));var o=r.prototype||r,a=e.prototype||e;t.copy(a,o,i)},t.extend=function(){return staticExtend.apply(null,arguments)},t.bubble=function(e,r){r=r||[],e.bubble=function(n,i){Array.isArray(i)&&(r=arrUnion([],r,i));for(var s=r.length,o=-1;++o<s;){var a=r[o];e.on(a,n.emit.bind(n,a))}t.bubble(n,r)}}});function namespace$1(e){var t=e?cacheBase.namespace(e):cacheBase,r=[];function n(e,r){if(!(this instanceof n))return new n(e,r);t.call(this,e),this.is("base"),this.initBase(e,r)}return util$2$1.inherits(n,t),componentEmitter(n),n.prototype.initBase=function(t,i){this.options=mixinDeep_1({},this.options,i),this.cache=this.cache||{},this.define("registered",{}),e&&(this[e]={}),this.define("_callbacks",this._callbacks),isobject(t)&&this.visit("set",t),n.run(this,"use",r)},n.prototype.is=function(e){if("string"!=typeof e)throw new TypeError("expected name to be a string");return this.define("is"+pascalcase_1(e),!0),this.define("_name",e),this.define("_appname",e),this},n.prototype.isRegistered=function(e,t){return!!this.registered.hasOwnProperty(e)||(!1!==t&&(this.registered[e]=!0,this.emit("plugin",e)),!1)},n.prototype.use=function(e){return e.call(this,this),this},n.prototype.define=function(e,t){return isobject(e)?this.visit("define",e):(defineProperty$2(this,e,t),this)},n.prototype.mixin=function(e,t){return n.prototype[e]=t,this},n.prototype.mixins=n.prototype.mixins||[],Object.defineProperty(n.prototype,"base",{configurable:!0,get:function(){return this.parent?this.parent.base:this}}),defineProperty$2(n,"use",function(e){return r.push(e),n}),defineProperty$2(n,"run",function(e,t,r){for(var i=r.length,s=0;i--;)e[t](r[s++]);return n}),defineProperty$2(n,"extend",classUtils.extend(n,function(e,t){return e.prototype.mixins=e.prototype.mixins||[],defineProperty$2(e,"mixin",function(t){var r=t(e.prototype,e);return"function"==typeof r&&e.prototype.mixins.push(r),e}),defineProperty$2(e,"mixins",function(t){return n.run(t,"mixin",e.prototype.mixins),e}),e.prototype.mixin=function(t,r){return e.prototype[t]=r,this},n})),defineProperty$2(n,"mixin",function(e){var t=e(n.prototype,n);return"function"==typeof t&&n.prototype.mixins.push(t),n}),defineProperty$2(n,"mixins",function(e){return n.run(e,"mixin",n.prototype.mixins),n}),defineProperty$2(n,"inherit",classUtils.inherit),defineProperty$2(n,"bubble",classUtils.bubble),n}var base$2=namespace$1(),namespace_1$1=namespace$1;base$2.namespace=namespace_1$1;var defineProperty$6=function(e,t,r){if("object"!=typeof e&&"function"!=typeof e)throw new TypeError("expected an object or function.");if("string"!=typeof t)throw new TypeError("expected `prop` to be a string.");return isDescriptor$3(r)&&("set"in r||"get"in r)?Object.defineProperty(e,t,r):Object.defineProperty(e,t,{configurable:!0,enumerable:!1,writable:!0,value:r})},use=function e(t,r){if(!isObject$7(t)&&"function"!=typeof t)throw new TypeError("expected an object or function");var n=isObject$7(r)?r:{},i="string"==typeof n.prop?n.prop:"fns";function s(e,r,s){var o=1;if("string"==typeof e||Array.isArray(e)?(r=function(e,t){return function r(){return this.type===e?t.apply(this,arguments):r}}(e,r),o++):(s=r,r=e),"function"!=typeof r)throw new TypeError("expected a function");var a=this||t,u=a[i],c=[].slice.call(arguments,o);c.unshift(a),"function"==typeof n.hook&&n.hook.apply(a,c);var p=r.apply(a,c);return"function"==typeof p&&-1===u.indexOf(p)&&u.push(p),a}return Array.isArray(t[i])||define$1$1(t,i,[]),define$1$1(t,"use",s),define$1$1(t,"run",function(r){if(isObject$7(r)){r.use&&r.run||(define$1$1(r,i,r[i]||[]),define$1$1(r,"use",s)),r[i]&&-1!==r[i].indexOf(e)||r.use(e);for(var n=(this||t)[i],o=n.length,a=-1;++a<o;)r.use(n[a]);return r}}),t};function isObject$7(e){return e&&"object"==typeof e&&!Array.isArray(e)}function define$1$1(e,t,r){Object.defineProperty(e,t,{configurable:!0,writable:!0,value:r})}var s=1e3,m=60*s,h=60*m,d=24*h,y=365.25*d,ms=function(e,t){t=t||{};var r=typeof e;if("string"===r&&e.length>0)return parse$1(e);if("number"===r&&!1===isNaN(e))return t.long?fmtLong(e):fmtShort(e);throw new Error("val is not a non-empty string or a valid number. val="+JSON.stringify(e))};function parse$1(e){if(!((e=String(e)).length>100)){var t=/^((?:\d+)?\.?\d+) *(milliseconds?|msecs?|ms|seconds?|secs?|s|minutes?|mins?|m|hours?|hrs?|h|days?|d|years?|yrs?|y)?$/i.exec(e);if(t){var r=parseFloat(t[1]);switch((t[2]||"ms").toLowerCase()){case"years":case"year":case"yrs":case"yr":case"y":return r*y;case"days":case"day":case"d":return r*d;case"hours":case"hour":case"hrs":case"hr":case"h":return r*h;case"minutes":case"minute":case"mins":case"min":case"m":return r*m;case"seconds":case"second":case"secs":case"sec":case"s":return r*s;case"milliseconds":case"millisecond":case"msecs":case"msec":case"ms":return r;default:return}}}}function fmtShort(e){return e>=d?Math.round(e/d)+"d":e>=h?Math.round(e/h)+"h":e>=m?Math.round(e/m)+"m":e>=s?Math.round(e/s)+"s":e+"ms"}function fmtLong(e){return plural(e,d,"day")||plural(e,h,"hour")||plural(e,m,"minute")||plural(e,s,"second")||e+" ms"}function plural(e,t,r){if(!(e<t))return e<1.5*t?Math.floor(e/t)+" "+r:Math.ceil(e/t)+" "+r+"s"}var debug=createCommonjsModule$1(function(e,t){var r;function n(e){function n(){if(n.enabled){var e=n,i=+new Date,s=i-(r||i);e.diff=s,e.prev=r,e.curr=i,r=i;for(var o=new Array(arguments.length),a=0;a<o.length;a++)o[a]=arguments[a];o[0]=t.coerce(o[0]),"string"!=typeof o[0]&&o.unshift("%O");var u=0;o[0]=o[0].replace(/%([a-zA-Z%])/g,function(r,n){if("%%"===r)return r;u++;var i=t.formatters[n];if("function"==typeof i){var s=o[u];r=i.call(e,s),o.splice(u,1),u--}return r}),t.formatArgs.call(e,o),(n.log||t.log||console.log.bind(console)).apply(e,o)}}return n.namespace=e,n.enabled=t.enabled(e),n.useColors=t.useColors(),n.color=function(e){var r,n=0;for(r in e)n=(n<<5)-n+e.charCodeAt(r),n|=0;return t.colors[Math.abs(n)%t.colors.length]}(e),"function"==typeof t.init&&t.init(n),n}(t=e.exports=n.debug=n.default=n).coerce=function(e){return e instanceof Error?e.stack||e.message:e},t.disable=function(){t.enable("")},t.enable=function(e){t.save(e),t.names=[],t.skips=[];for(var r=("string"==typeof e?e:"").split(/[\s,]+/),n=r.length,i=0;i<n;i++)r[i]&&("-"===(e=r[i].replace(/\*/g,".*?"))[0]?t.skips.push(new RegExp("^"+e.substr(1)+"$")):t.names.push(new RegExp("^"+e+"$")))},t.enabled=function(e){var r,n;for(r=0,n=t.skips.length;r<n;r++)if(t.skips[r].test(e))return!1;for(r=0,n=t.names.length;r<n;r++)if(t.names[r].test(e))return!0;return!1},t.humanize=ms,t.names=[],t.skips=[],t.formatters={}}),browser=createCommonjsModule$1(function(e,t){function r(){var e;try{e=t.storage.debug}catch(e){}return!e&&"undefined"!=typeof process&&"env"in process&&(e=process.env.DEBUG),e}(t=e.exports=debug).log=function(){return"object"==typeof console&&console.log&&Function.prototype.apply.call(console.log,console,arguments)},t.formatArgs=function(e){var r=this.useColors;if(e[0]=(r?"%c":"")+this.namespace+(r?" %c":" ")+e[0]+(r?"%c ":" ")+"+"+t.humanize(this.diff),!r)return;var n="color: "+this.color;e.splice(1,0,n,"color: inherit");var i=0,s=0;e[0].replace(/%[a-zA-Z%]/g,function(e){"%%"!==e&&(i++,"%c"===e&&(s=i))}),e.splice(s,0,n)},t.save=function(e){try{null==e?t.storage.removeItem("debug"):t.storage.debug=e}catch(e){}},t.load=r,t.useColors=function(){if("undefined"!=typeof window&&window.process&&"renderer"===window.process.type)return!0;return"undefined"!=typeof document&&document.documentElement&&document.documentElement.style&&document.documentElement.style.WebkitAppearance||"undefined"!=typeof window&&window.console&&(window.console.firebug||window.console.exception&&window.console.table)||"undefined"!=typeof navigator&&navigator.userAgent&&navigator.userAgent.toLowerCase().match(/firefox\/(\d+)/)&&parseInt(RegExp.$1,10)>=31||"undefined"!=typeof navigator&&navigator.userAgent&&navigator.userAgent.toLowerCase().match(/applewebkit\/(\d+)/)},t.storage="undefined"!=typeof chrome&&void 0!==chrome.storage?chrome.storage.local:function(){try{return window.localStorage}catch(e){}}(),t.colors=["lightseagreen","forestgreen","goldenrod","dodgerblue","darkorchid","crimson"],t.formatters.j=function(e){try{return JSON.stringify(e)}catch(e){return"[UnexpectedJSONParseError]: "+e.message}},t.enable(r())}),node=createCommonjsModule$1(function(e,t){(t=e.exports=debug).init=function(e){e.inspectOpts={};for(var r=Object.keys(t.inspectOpts),n=0;n<r.length;n++)e.inspectOpts[r[n]]=t.inspectOpts[r[n]]},t.log=function(){return n.write(util$2$1.format.apply(util$2$1,arguments)+"\n")},t.formatArgs=function(e){var r=this.namespace;if(this.useColors){var n=this.color,i="  [3"+n+";1m"+r+" [0m";e[0]=i+e[0].split("\n").join("\n"+i),e.push("[3"+n+"m+"+t.humanize(this.diff)+"[0m")}else e[0]=(new Date).toUTCString()+" "+r+" "+e[0]},t.save=function(e){null==e?delete process.env.DEBUG:process.env.DEBUG=e},t.load=i,t.useColors=function(){return"colors"in t.inspectOpts?Boolean(t.inspectOpts.colors):tty$1.isatty(r)},t.colors=[6,2,3,4,5,1],t.inspectOpts=Object.keys(process.env).filter(function(e){return/^debug_/i.test(e)}).reduce(function(e,t){var r=t.substring(6).toLowerCase().replace(/_([a-z])/g,function(e,t){return t.toUpperCase()}),n=process.env[t];return n=!!/^(yes|on|true|enabled)$/i.test(n)||!/^(no|off|false|disabled)$/i.test(n)&&("null"===n?null:Number(n)),e[r]=n,e},{});var r=parseInt(process.env.DEBUG_FD,10)||2;1!==r&&2!==r&&util$2$1.deprecate(function(){},"except for stderr(2) and stdout(1), any other usage of DEBUG_FD is deprecated. Override debug.log if you want to use a different log function (https://git.io/debug_fd)")();var n=1===r?process.stdout:2===r?process.stderr:function(e){var t;switch(process.binding("tty_wrap").guessHandleType(e)){case"TTY":(t=new tty$1.WriteStream(e))._type="tty",t._handle&&t._handle.unref&&t._handle.unref();break;case"FILE":var r=fs$2__default;(t=new r.SyncWriteStream(e,{autoClose:!1}))._type="fs";break;case"PIPE":case"TCP":var n=net$1;(t=new n.Socket({fd:e,readable:!1,writable:!0})).readable=!1,t.read=null,t._type="pipe",t._handle&&t._handle.unref&&t._handle.unref();break;default:throw new Error("Implement me. Unknown stream file type!")}return t.fd=e,t._isStdio=!0,t}(r);function i(){return process.env.DEBUG}t.formatters.o=function(e){return this.inspectOpts.colors=this.useColors,util$2$1.inspect(e,this.inspectOpts).split("\n").map(function(e){return e.trim()}).join(" ")},t.formatters.O=function(e){return this.inspectOpts.colors=this.useColors,util$2$1.inspect(e,this.inspectOpts)},t.enable(i())}),src=createCommonjsModule$1(function(e){"undefined"!=typeof process&&"renderer"===process.type?e.exports=browser:e.exports=node}),extendShallow$5=function(e){isExtendable$1(e)||(e={});for(var t=arguments.length,r=1;r<t;r++){var n=arguments[r];isExtendable$1(n)&&assign$5(e,n)}return e};function assign$5(e,t){for(var r in t)hasOwn$5(t,r)&&(e[r]=t[r])}function hasOwn$5(e,t){return Object.prototype.hasOwnProperty.call(e,t)}var intToCharMap="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/".split(""),encode$1=function(e){if(0<=e&&e<intToCharMap.length)return intToCharMap[e];throw new TypeError("Must be between 0 and 63: "+e)},decode$1=function(e){return 65<=e&&e<=90?e-65:97<=e&&e<=122?e-97+26:48<=e&&e<=57?e-48+52:43==e?62:47==e?63:-1},base64={encode:encode$1,decode:decode$1},VLQ_BASE_SHIFT=5,VLQ_BASE=1<<VLQ_BASE_SHIFT,VLQ_BASE_MASK=VLQ_BASE-1,VLQ_CONTINUATION_BIT=VLQ_BASE;function toVLQSigned(e){return e<0?1+(-e<<1):0+(e<<1)}function fromVLQSigned(e){var t=e>>1;return 1==(1&e)?-t:t}var encode$2=function(e){var t,r="",n=toVLQSigned(e);do{t=n&VLQ_BASE_MASK,(n>>>=VLQ_BASE_SHIFT)>0&&(t|=VLQ_CONTINUATION_BIT),r+=base64.encode(t)}while(n>0);return r},decode$2=function(e,t,r){var n,i,s=e.length,o=0,a=0;do{if(t>=s)throw new Error("Expected more digits in base 64 VLQ value.");if(-1===(i=base64.decode(e.charCodeAt(t++))))throw new Error("Invalid base64 digit: "+e.charAt(t-1));n=!!(i&VLQ_CONTINUATION_BIT),o+=(i&=VLQ_BASE_MASK)<<a,a+=VLQ_BASE_SHIFT}while(n);r.value=fromVLQSigned(o),r.rest=t},base64Vlq={encode:encode$2,decode:decode$2},util$1=createCommonjsModule$1(function(e,t){t.getArg=function(e,t,r){if(t in e)return e[t];if(3===arguments.length)return r;throw new Error('"'+t+'" is a required argument.')};var r=/^(?:([\w+\-.]+):)?\/\/(?:(\w+:\w+)@)?([\w.]*)(?::(\d+))?(\S*)$/,n=/^data:.+\,.+$/;function i(e){var t=e.match(r);return t?{scheme:t[1],auth:t[2],host:t[3],port:t[4],path:t[5]}:null}function s(e){var t="";return e.scheme&&(t+=e.scheme+":"),t+="//",e.auth&&(t+=e.auth+"@"),e.host&&(t+=e.host),e.port&&(t+=":"+e.port),e.path&&(t+=e.path),t}function o(e){var r=e,n=i(e);if(n){if(!n.path)return e;r=n.path}for(var o,a=t.isAbsolute(r),u=r.split(/\/+/),c=0,p=u.length-1;p>=0;p--)"."===(o=u[p])?u.splice(p,1):".."===o?c++:c>0&&(""===o?(u.splice(p+1,c),c=0):(u.splice(p,2),c--));return""===(r=u.join("/"))&&(r=a?"/":"."),n?(n.path=r,s(n)):r}t.urlParse=i,t.urlGenerate=s,t.normalize=o,t.join=function(e,t){""===e&&(e="."),""===t&&(t=".");var r=i(t),a=i(e);if(a&&(e=a.path||"/"),r&&!r.scheme)return a&&(r.scheme=a.scheme),s(r);if(r||t.match(n))return t;if(a&&!a.host&&!a.path)return a.host=t,s(a);var u="/"===t.charAt(0)?t:o(e.replace(/\/+$/,"")+"/"+t);return a?(a.path=u,s(a)):u},t.isAbsolute=function(e){return"/"===e.charAt(0)||!!e.match(r)},t.relative=function(e,t){""===e&&(e="."),e=e.replace(/\/$/,"");for(var r=0;0!==t.indexOf(e+"/");){var n=e.lastIndexOf("/");if(n<0)return t;if((e=e.slice(0,n)).match(/^([^\/]+:\/)?\/*$/))return t;++r}return Array(r+1).join("../")+t.substr(e.length+1)};var a=!("__proto__"in Object.create(null));function u(e){return e}function c(e){if(!e)return!1;var t=e.length;if(t<9)return!1;if(95!==e.charCodeAt(t-1)||95!==e.charCodeAt(t-2)||111!==e.charCodeAt(t-3)||116!==e.charCodeAt(t-4)||111!==e.charCodeAt(t-5)||114!==e.charCodeAt(t-6)||112!==e.charCodeAt(t-7)||95!==e.charCodeAt(t-8)||95!==e.charCodeAt(t-9))return!1;for(var r=t-10;r>=0;r--)if(36!==e.charCodeAt(r))return!1;return!0}function p(e,t){return e===t?0:e>t?1:-1}t.toSetString=a?u:function(e){return c(e)?"$"+e:e},t.fromSetString=a?u:function(e){return c(e)?e.slice(1):e},t.compareByOriginalPositions=function(e,t,r){var n=e.source-t.source;return 0!==n?n:0!=(n=e.originalLine-t.originalLine)?n:0!=(n=e.originalColumn-t.originalColumn)||r?n:0!=(n=e.generatedColumn-t.generatedColumn)?n:0!=(n=e.generatedLine-t.generatedLine)?n:e.name-t.name},t.compareByGeneratedPositionsDeflated=function(e,t,r){var n=e.generatedLine-t.generatedLine;return 0!==n?n:0!=(n=e.generatedColumn-t.generatedColumn)||r?n:0!=(n=e.source-t.source)?n:0!=(n=e.originalLine-t.originalLine)?n:0!=(n=e.originalColumn-t.originalColumn)?n:e.name-t.name},t.compareByGeneratedPositionsInflated=function(e,t){var r=e.generatedLine-t.generatedLine;return 0!==r?r:0!=(r=e.generatedColumn-t.generatedColumn)?r:0!==(r=p(e.source,t.source))?r:0!=(r=e.originalLine-t.originalLine)?r:0!=(r=e.originalColumn-t.originalColumn)?r:p(e.name,t.name)}}),has$6=Object.prototype.hasOwnProperty,hasNativeMap="undefined"!=typeof Map;function ArraySet(){this._array=[],this._set=hasNativeMap?new Map:Object.create(null)}ArraySet.fromArray=function(e,t){for(var r=new ArraySet,n=0,i=e.length;n<i;n++)r.add(e[n],t);return r},ArraySet.prototype.size=function(){return hasNativeMap?this._set.size:Object.getOwnPropertyNames(this._set).length},ArraySet.prototype.add=function(e,t){var r=hasNativeMap?e:util$1.toSetString(e),n=hasNativeMap?this.has(e):has$6.call(this._set,r),i=this._array.length;n&&!t||this._array.push(e),n||(hasNativeMap?this._set.set(e,i):this._set[r]=i)},ArraySet.prototype.has=function(e){if(hasNativeMap)return this._set.has(e);var t=util$1.toSetString(e);return has$6.call(this._set,t)},ArraySet.prototype.indexOf=function(e){if(hasNativeMap){var t=this._set.get(e);if(t>=0)return t}else{var r=util$1.toSetString(e);if(has$6.call(this._set,r))return this._set[r]}throw new Error('"'+e+'" is not in the set.')},ArraySet.prototype.at=function(e){if(e>=0&&e<this._array.length)return this._array[e];throw new Error("No element indexed by "+e)},ArraySet.prototype.toArray=function(){return this._array.slice()};var ArraySet_1=ArraySet,arraySet={ArraySet:ArraySet_1};function generatedPositionAfter(e,t){var r=e.generatedLine,n=t.generatedLine,i=e.generatedColumn,s=t.generatedColumn;return n>r||n==r&&s>=i||util$1.compareByGeneratedPositionsInflated(e,t)<=0}function MappingList(){this._array=[],this._sorted=!0,this._last={generatedLine:-1,generatedColumn:0}}MappingList.prototype.unsortedForEach=function(e,t){this._array.forEach(e,t)},MappingList.prototype.add=function(e){generatedPositionAfter(this._last,e)?(this._last=e,this._array.push(e)):(this._sorted=!1,this._array.push(e))},MappingList.prototype.toArray=function(){return this._sorted||(this._array.sort(util$1.compareByGeneratedPositionsInflated),this._sorted=!0),this._array};var MappingList_1=MappingList,mappingList={MappingList:MappingList_1},ArraySet$1=arraySet.ArraySet,MappingList$1=mappingList.MappingList;function SourceMapGenerator(e){e||(e={}),this._file=util$1.getArg(e,"file",null),this._sourceRoot=util$1.getArg(e,"sourceRoot",null),this._skipValidation=util$1.getArg(e,"skipValidation",!1),this._sources=new ArraySet$1,this._names=new ArraySet$1,this._mappings=new MappingList$1,this._sourcesContents=null}SourceMapGenerator.prototype._version=3,SourceMapGenerator.fromSourceMap=function(e){var t=e.sourceRoot,r=new SourceMapGenerator({file:e.file,sourceRoot:t});return e.eachMapping(function(e){var n={generated:{line:e.generatedLine,column:e.generatedColumn}};null!=e.source&&(n.source=e.source,null!=t&&(n.source=util$1.relative(t,n.source)),n.original={line:e.originalLine,column:e.originalColumn},null!=e.name&&(n.name=e.name)),r.addMapping(n)}),e.sources.forEach(function(t){var n=e.sourceContentFor(t);null!=n&&r.setSourceContent(t,n)}),r},SourceMapGenerator.prototype.addMapping=function(e){var t=util$1.getArg(e,"generated"),r=util$1.getArg(e,"original",null),n=util$1.getArg(e,"source",null),i=util$1.getArg(e,"name",null);this._skipValidation||this._validateMapping(t,r,n,i),null!=n&&(n=String(n),this._sources.has(n)||this._sources.add(n)),null!=i&&(i=String(i),this._names.has(i)||this._names.add(i)),this._mappings.add({generatedLine:t.line,generatedColumn:t.column,originalLine:null!=r&&r.line,originalColumn:null!=r&&r.column,source:n,name:i})},SourceMapGenerator.prototype.setSourceContent=function(e,t){var r=e;null!=this._sourceRoot&&(r=util$1.relative(this._sourceRoot,r)),null!=t?(this._sourcesContents||(this._sourcesContents=Object.create(null)),this._sourcesContents[util$1.toSetString(r)]=t):this._sourcesContents&&(delete this._sourcesContents[util$1.toSetString(r)],0===Object.keys(this._sourcesContents).length&&(this._sourcesContents=null))},SourceMapGenerator.prototype.applySourceMap=function(e,t,r){var n=t;if(null==t){if(null==e.file)throw new Error('SourceMapGenerator.prototype.applySourceMap requires either an explicit source file, or the source map\'s "file" property. Both were omitted.');n=e.file}var i=this._sourceRoot;null!=i&&(n=util$1.relative(i,n));var s=new ArraySet$1,o=new ArraySet$1;this._mappings.unsortedForEach(function(t){if(t.source===n&&null!=t.originalLine){var a=e.originalPositionFor({line:t.originalLine,column:t.originalColumn});null!=a.source&&(t.source=a.source,null!=r&&(t.source=util$1.join(r,t.source)),null!=i&&(t.source=util$1.relative(i,t.source)),t.originalLine=a.line,t.originalColumn=a.column,null!=a.name&&(t.name=a.name))}var u=t.source;null==u||s.has(u)||s.add(u);var c=t.name;null==c||o.has(c)||o.add(c)},this),this._sources=s,this._names=o,e.sources.forEach(function(t){var n=e.sourceContentFor(t);null!=n&&(null!=r&&(t=util$1.join(r,t)),null!=i&&(t=util$1.relative(i,t)),this.setSourceContent(t,n))},this)},SourceMapGenerator.prototype._validateMapping=function(e,t,r,n){if(t&&"number"!=typeof t.line&&"number"!=typeof t.column)throw new Error("original.line and original.column are not numbers -- you probably meant to omit the original mapping entirely and only map the generated position. If so, pass null for the original mapping instead of an object with empty or null values.");if((!(e&&"line"in e&&"column"in e&&e.line>0&&e.column>=0)||t||r||n)&&!(e&&"line"in e&&"column"in e&&t&&"line"in t&&"column"in t&&e.line>0&&e.column>=0&&t.line>0&&t.column>=0&&r))throw new Error("Invalid mapping: "+JSON.stringify({generated:e,source:r,original:t,name:n}))},SourceMapGenerator.prototype._serializeMappings=function(){for(var e,t,r,n,i=0,s=1,o=0,a=0,u=0,c=0,p="",l=this._mappings.toArray(),h=0,f=l.length;h<f;h++){if(e="",(t=l[h]).generatedLine!==s)for(i=0;t.generatedLine!==s;)e+=";",s++;else if(h>0){if(!util$1.compareByGeneratedPositionsInflated(t,l[h-1]))continue;e+=","}e+=base64Vlq.encode(t.generatedColumn-i),i=t.generatedColumn,null!=t.source&&(n=this._sources.indexOf(t.source),e+=base64Vlq.encode(n-c),c=n,e+=base64Vlq.encode(t.originalLine-1-a),a=t.originalLine-1,e+=base64Vlq.encode(t.originalColumn-o),o=t.originalColumn,null!=t.name&&(r=this._names.indexOf(t.name),e+=base64Vlq.encode(r-u),u=r)),p+=e}return p},SourceMapGenerator.prototype._generateSourcesContent=function(e,t){return e.map(function(e){if(!this._sourcesContents)return null;null!=t&&(e=util$1.relative(t,e));var r=util$1.toSetString(e);return Object.prototype.hasOwnProperty.call(this._sourcesContents,r)?this._sourcesContents[r]:null},this)},SourceMapGenerator.prototype.toJSON=function(){var e={version:this._version,sources:this._sources.toArray(),names:this._names.toArray(),mappings:this._serializeMappings()};return null!=this._file&&(e.file=this._file),null!=this._sourceRoot&&(e.sourceRoot=this._sourceRoot),this._sourcesContents&&(e.sourcesContent=this._generateSourcesContent(e.sources,e.sourceRoot)),e},SourceMapGenerator.prototype.toString=function(){return JSON.stringify(this.toJSON())};var SourceMapGenerator_1=SourceMapGenerator,sourceMapGenerator={SourceMapGenerator:SourceMapGenerator_1},binarySearch=createCommonjsModule$1(function(e,t){t.GREATEST_LOWER_BOUND=1,t.LEAST_UPPER_BOUND=2,t.search=function(e,r,n,i){if(0===r.length)return-1;var s=function e(r,n,i,s,o,a){var u=Math.floor((n-r)/2)+r,c=o(i,s[u],!0);return 0===c?u:c>0?n-u>1?e(u,n,i,s,o,a):a==t.LEAST_UPPER_BOUND?n<s.length?n:-1:u:u-r>1?e(r,u,i,s,o,a):a==t.LEAST_UPPER_BOUND?u:r<0?-1:r}(-1,r.length,e,r,n,i||t.GREATEST_LOWER_BOUND);if(s<0)return-1;for(;s-1>=0&&0===n(r[s],r[s-1],!0);)--s;return s}});function swap(e,t,r){var n=e[t];e[t]=e[r],e[r]=n}function randomIntInRange(e,t){return Math.round(e+Math.random()*(t-e))}function doQuickSort(e,t,r,n){if(r<n){var i=r-1;swap(e,randomIntInRange(r,n),n);for(var s=e[n],o=r;o<n;o++)t(e[o],s)<=0&&swap(e,i+=1,o);swap(e,i+1,o);var a=i+1;doQuickSort(e,t,r,a-1),doQuickSort(e,t,a+1,n)}}var quickSort_1=function(e,t){doQuickSort(e,t,0,e.length-1)},quickSort={quickSort:quickSort_1},ArraySet$2=arraySet.ArraySet,quickSort$1=quickSort.quickSort;function SourceMapConsumer(e){var t=e;return"string"==typeof e&&(t=JSON.parse(e.replace(/^\)\]\}'/,""))),null!=t.sections?new IndexedSourceMapConsumer(t):new BasicSourceMapConsumer(t)}SourceMapConsumer.fromSourceMap=function(e){return BasicSourceMapConsumer.fromSourceMap(e)},SourceMapConsumer.prototype._version=3,SourceMapConsumer.prototype.__generatedMappings=null,Object.defineProperty(SourceMapConsumer.prototype,"_generatedMappings",{get:function(){return this.__generatedMappings||this._parseMappings(this._mappings,this.sourceRoot),this.__generatedMappings}}),SourceMapConsumer.prototype.__originalMappings=null,Object.defineProperty(SourceMapConsumer.prototype,"_originalMappings",{get:function(){return this.__originalMappings||this._parseMappings(this._mappings,this.sourceRoot),this.__originalMappings}}),SourceMapConsumer.prototype._charIsMappingSeparator=function(e,t){var r=e.charAt(t);return";"===r||","===r},SourceMapConsumer.prototype._parseMappings=function(e,t){throw new Error("Subclasses must implement _parseMappings")},SourceMapConsumer.GENERATED_ORDER=1,SourceMapConsumer.ORIGINAL_ORDER=2,SourceMapConsumer.GREATEST_LOWER_BOUND=1,SourceMapConsumer.LEAST_UPPER_BOUND=2,SourceMapConsumer.prototype.eachMapping=function(e,t,r){var n,i=t||null;switch(r||SourceMapConsumer.GENERATED_ORDER){case SourceMapConsumer.GENERATED_ORDER:n=this._generatedMappings;break;case SourceMapConsumer.ORIGINAL_ORDER:n=this._originalMappings;break;default:throw new Error("Unknown order of iteration.")}var s=this.sourceRoot;n.map(function(e){var t=null===e.source?null:this._sources.at(e.source);return null!=t&&null!=s&&(t=util$1.join(s,t)),{source:t,generatedLine:e.generatedLine,generatedColumn:e.generatedColumn,originalLine:e.originalLine,originalColumn:e.originalColumn,name:null===e.name?null:this._names.at(e.name)}},this).forEach(e,i)},SourceMapConsumer.prototype.allGeneratedPositionsFor=function(e){var t=util$1.getArg(e,"line"),r={source:util$1.getArg(e,"source"),originalLine:t,originalColumn:util$1.getArg(e,"column",0)};if(null!=this.sourceRoot&&(r.source=util$1.relative(this.sourceRoot,r.source)),!this._sources.has(r.source))return[];r.source=this._sources.indexOf(r.source);var n=[],i=this._findMapping(r,this._originalMappings,"originalLine","originalColumn",util$1.compareByOriginalPositions,binarySearch.LEAST_UPPER_BOUND);if(i>=0){var s=this._originalMappings[i];if(void 0===e.column)for(var o=s.originalLine;s&&s.originalLine===o;)n.push({line:util$1.getArg(s,"generatedLine",null),column:util$1.getArg(s,"generatedColumn",null),lastColumn:util$1.getArg(s,"lastGeneratedColumn",null)}),s=this._originalMappings[++i];else for(var a=s.originalColumn;s&&s.originalLine===t&&s.originalColumn==a;)n.push({line:util$1.getArg(s,"generatedLine",null),column:util$1.getArg(s,"generatedColumn",null),lastColumn:util$1.getArg(s,"lastGeneratedColumn",null)}),s=this._originalMappings[++i]}return n};var SourceMapConsumer_1=SourceMapConsumer;function BasicSourceMapConsumer(e){var t=e;"string"==typeof e&&(t=JSON.parse(e.replace(/^\)\]\}'/,"")));var r=util$1.getArg(t,"version"),n=util$1.getArg(t,"sources"),i=util$1.getArg(t,"names",[]),s=util$1.getArg(t,"sourceRoot",null),o=util$1.getArg(t,"sourcesContent",null),a=util$1.getArg(t,"mappings"),u=util$1.getArg(t,"file",null);if(r!=this._version)throw new Error("Unsupported version: "+r);n=n.map(String).map(util$1.normalize).map(function(e){return s&&util$1.isAbsolute(s)&&util$1.isAbsolute(e)?util$1.relative(s,e):e}),this._names=ArraySet$2.fromArray(i.map(String),!0),this._sources=ArraySet$2.fromArray(n,!0),this.sourceRoot=s,this.sourcesContent=o,this._mappings=a,this.file=u}function Mapping(){this.generatedLine=0,this.generatedColumn=0,this.source=null,this.originalLine=null,this.originalColumn=null,this.name=null}BasicSourceMapConsumer.prototype=Object.create(SourceMapConsumer.prototype),BasicSourceMapConsumer.prototype.consumer=SourceMapConsumer,BasicSourceMapConsumer.fromSourceMap=function(e){var t=Object.create(BasicSourceMapConsumer.prototype),r=t._names=ArraySet$2.fromArray(e._names.toArray(),!0),n=t._sources=ArraySet$2.fromArray(e._sources.toArray(),!0);t.sourceRoot=e._sourceRoot,t.sourcesContent=e._generateSourcesContent(t._sources.toArray(),t.sourceRoot),t.file=e._file;for(var i=e._mappings.toArray().slice(),s=t.__generatedMappings=[],o=t.__originalMappings=[],a=0,u=i.length;a<u;a++){var c=i[a],p=new Mapping;p.generatedLine=c.generatedLine,p.generatedColumn=c.generatedColumn,c.source&&(p.source=n.indexOf(c.source),p.originalLine=c.originalLine,p.originalColumn=c.originalColumn,c.name&&(p.name=r.indexOf(c.name)),o.push(p)),s.push(p)}return quickSort$1(t.__originalMappings,util$1.compareByOriginalPositions),t},BasicSourceMapConsumer.prototype._version=3,Object.defineProperty(BasicSourceMapConsumer.prototype,"sources",{get:function(){return this._sources.toArray().map(function(e){return null!=this.sourceRoot?util$1.join(this.sourceRoot,e):e},this)}}),BasicSourceMapConsumer.prototype._parseMappings=function(e,t){for(var r,n,i,s,o,a=1,u=0,c=0,p=0,l=0,h=0,f=e.length,d=0,m={},g={},y=[],v=[];d<f;)if(";"===e.charAt(d))a++,d++,u=0;else if(","===e.charAt(d))d++;else{for((r=new Mapping).generatedLine=a,s=d;s<f&&!this._charIsMappingSeparator(e,s);s++);if(i=m[n=e.slice(d,s)])d+=n.length;else{for(i=[];d<s;)base64Vlq.decode(e,d,g),o=g.value,d=g.rest,i.push(o);if(2===i.length)throw new Error("Found a source, but no line and column");if(3===i.length)throw new Error("Found a source and line, but no column");m[n]=i}r.generatedColumn=u+i[0],u=r.generatedColumn,i.length>1&&(r.source=l+i[1],l+=i[1],r.originalLine=c+i[2],c=r.originalLine,r.originalLine+=1,r.originalColumn=p+i[3],p=r.originalColumn,i.length>4&&(r.name=h+i[4],h+=i[4])),v.push(r),"number"==typeof r.originalLine&&y.push(r)}quickSort$1(v,util$1.compareByGeneratedPositionsDeflated),this.__generatedMappings=v,quickSort$1(y,util$1.compareByOriginalPositions),this.__originalMappings=y},BasicSourceMapConsumer.prototype._findMapping=function(e,t,r,n,i,s){if(e[r]<=0)throw new TypeError("Line must be greater than or equal to 1, got "+e[r]);if(e[n]<0)throw new TypeError("Column must be greater than or equal to 0, got "+e[n]);return binarySearch.search(e,t,i,s)},BasicSourceMapConsumer.prototype.computeColumnSpans=function(){for(var e=0;e<this._generatedMappings.length;++e){var t=this._generatedMappings[e];if(e+1<this._generatedMappings.length){var r=this._generatedMappings[e+1];if(t.generatedLine===r.generatedLine){t.lastGeneratedColumn=r.generatedColumn-1;continue}}t.lastGeneratedColumn=1/0}},BasicSourceMapConsumer.prototype.originalPositionFor=function(e){var t={generatedLine:util$1.getArg(e,"line"),generatedColumn:util$1.getArg(e,"column")},r=this._findMapping(t,this._generatedMappings,"generatedLine","generatedColumn",util$1.compareByGeneratedPositionsDeflated,util$1.getArg(e,"bias",SourceMapConsumer.GREATEST_LOWER_BOUND));if(r>=0){var n=this._generatedMappings[r];if(n.generatedLine===t.generatedLine){var i=util$1.getArg(n,"source",null);null!==i&&(i=this._sources.at(i),null!=this.sourceRoot&&(i=util$1.join(this.sourceRoot,i)));var s=util$1.getArg(n,"name",null);return null!==s&&(s=this._names.at(s)),{source:i,line:util$1.getArg(n,"originalLine",null),column:util$1.getArg(n,"originalColumn",null),name:s}}}return{source:null,line:null,column:null,name:null}},BasicSourceMapConsumer.prototype.hasContentsOfAllSources=function(){return!!this.sourcesContent&&(this.sourcesContent.length>=this._sources.size()&&!this.sourcesContent.some(function(e){return null==e}))},BasicSourceMapConsumer.prototype.sourceContentFor=function(e,t){if(!this.sourcesContent)return null;if(null!=this.sourceRoot&&(e=util$1.relative(this.sourceRoot,e)),this._sources.has(e))return this.sourcesContent[this._sources.indexOf(e)];var r;if(null!=this.sourceRoot&&(r=util$1.urlParse(this.sourceRoot))){var n=e.replace(/^file:\/\//,"");if("file"==r.scheme&&this._sources.has(n))return this.sourcesContent[this._sources.indexOf(n)];if((!r.path||"/"==r.path)&&this._sources.has("/"+e))return this.sourcesContent[this._sources.indexOf("/"+e)]}if(t)return null;throw new Error('"'+e+'" is not in the SourceMap.')},BasicSourceMapConsumer.prototype.generatedPositionFor=function(e){var t=util$1.getArg(e,"source");if(null!=this.sourceRoot&&(t=util$1.relative(this.sourceRoot,t)),!this._sources.has(t))return{line:null,column:null,lastColumn:null};var r={source:t=this._sources.indexOf(t),originalLine:util$1.getArg(e,"line"),originalColumn:util$1.getArg(e,"column")},n=this._findMapping(r,this._originalMappings,"originalLine","originalColumn",util$1.compareByOriginalPositions,util$1.getArg(e,"bias",SourceMapConsumer.GREATEST_LOWER_BOUND));if(n>=0){var i=this._originalMappings[n];if(i.source===r.source)return{line:util$1.getArg(i,"generatedLine",null),column:util$1.getArg(i,"generatedColumn",null),lastColumn:util$1.getArg(i,"lastGeneratedColumn",null)}}return{line:null,column:null,lastColumn:null}};var BasicSourceMapConsumer_1=BasicSourceMapConsumer;function IndexedSourceMapConsumer(e){var t=e;"string"==typeof e&&(t=JSON.parse(e.replace(/^\)\]\}'/,"")));var r=util$1.getArg(t,"version"),n=util$1.getArg(t,"sections");if(r!=this._version)throw new Error("Unsupported version: "+r);this._sources=new ArraySet$2,this._names=new ArraySet$2;var i={line:-1,column:0};this._sections=n.map(function(e){if(e.url)throw new Error("Support for url field in sections not implemented.");var t=util$1.getArg(e,"offset"),r=util$1.getArg(t,"line"),n=util$1.getArg(t,"column");if(r<i.line||r===i.line&&n<i.column)throw new Error("Section offsets must be ordered and non-overlapping.");return i=t,{generatedOffset:{generatedLine:r+1,generatedColumn:n+1},consumer:new SourceMapConsumer(util$1.getArg(e,"map"))}})}IndexedSourceMapConsumer.prototype=Object.create(SourceMapConsumer.prototype),IndexedSourceMapConsumer.prototype.constructor=SourceMapConsumer,IndexedSourceMapConsumer.prototype._version=3,Object.defineProperty(IndexedSourceMapConsumer.prototype,"sources",{get:function(){for(var e=[],t=0;t<this._sections.length;t++)for(var r=0;r<this._sections[t].consumer.sources.length;r++)e.push(this._sections[t].consumer.sources[r]);return e}}),IndexedSourceMapConsumer.prototype.originalPositionFor=function(e){var t={generatedLine:util$1.getArg(e,"line"),generatedColumn:util$1.getArg(e,"column")},r=binarySearch.search(t,this._sections,function(e,t){var r=e.generatedLine-t.generatedOffset.generatedLine;return r||e.generatedColumn-t.generatedOffset.generatedColumn}),n=this._sections[r];return n?n.consumer.originalPositionFor({line:t.generatedLine-(n.generatedOffset.generatedLine-1),column:t.generatedColumn-(n.generatedOffset.generatedLine===t.generatedLine?n.generatedOffset.generatedColumn-1:0),bias:e.bias}):{source:null,line:null,column:null,name:null}},IndexedSourceMapConsumer.prototype.hasContentsOfAllSources=function(){return this._sections.every(function(e){return e.consumer.hasContentsOfAllSources()})},IndexedSourceMapConsumer.prototype.sourceContentFor=function(e,t){for(var r=0;r<this._sections.length;r++){var n=this._sections[r].consumer.sourceContentFor(e,!0);if(n)return n}if(t)return null;throw new Error('"'+e+'" is not in the SourceMap.')},IndexedSourceMapConsumer.prototype.generatedPositionFor=function(e){for(var t=0;t<this._sections.length;t++){var r=this._sections[t];if(-1!==r.consumer.sources.indexOf(util$1.getArg(e,"source"))){var n=r.consumer.generatedPositionFor(e);if(n)return{line:n.line+(r.generatedOffset.generatedLine-1),column:n.column+(r.generatedOffset.generatedLine===n.line?r.generatedOffset.generatedColumn-1:0)}}}return{line:null,column:null}},IndexedSourceMapConsumer.prototype._parseMappings=function(e,t){this.__generatedMappings=[],this.__originalMappings=[];for(var r=0;r<this._sections.length;r++)for(var n=this._sections[r],i=n.consumer._generatedMappings,s=0;s<i.length;s++){var o=i[s],a=n.consumer._sources.at(o.source);null!==n.consumer.sourceRoot&&(a=util$1.join(n.consumer.sourceRoot,a)),this._sources.add(a),a=this._sources.indexOf(a);var u=n.consumer._names.at(o.name);this._names.add(u),u=this._names.indexOf(u);var c={source:a,generatedLine:o.generatedLine+(n.generatedOffset.generatedLine-1),generatedColumn:o.generatedColumn+(n.generatedOffset.generatedLine===o.generatedLine?n.generatedOffset.generatedColumn-1:0),originalLine:o.originalLine,originalColumn:o.originalColumn,name:u};this.__generatedMappings.push(c),"number"==typeof c.originalLine&&this.__originalMappings.push(c)}quickSort$1(this.__generatedMappings,util$1.compareByGeneratedPositionsDeflated),quickSort$1(this.__originalMappings,util$1.compareByOriginalPositions)};var IndexedSourceMapConsumer_1=IndexedSourceMapConsumer,sourceMapConsumer={SourceMapConsumer:SourceMapConsumer_1,BasicSourceMapConsumer:BasicSourceMapConsumer_1,IndexedSourceMapConsumer:IndexedSourceMapConsumer_1},SourceMapGenerator$1=sourceMapGenerator.SourceMapGenerator,REGEX_NEWLINE=/(\r?\n)/,NEWLINE_CODE=10,isSourceNode="$$$isSourceNode$$$";function SourceNode(e,t,r,n,i){this.children=[],this.sourceContents={},this.line=null==e?null:e,this.column=null==t?null:t,this.source=null==r?null:r,this.name=null==i?null:i,this[isSourceNode]=!0,null!=n&&this.add(n)}SourceNode.fromStringWithSourceMap=function(e,t,r){var n=new SourceNode,i=e.split(REGEX_NEWLINE),s=0,o=function(){return e()+(e()||"");function e(){return s<i.length?i[s++]:void 0}},a=1,u=0,c=null;return t.eachMapping(function(e){if(null!==c){if(!(a<e.generatedLine)){var t=(r=i[s]).substr(0,e.generatedColumn-u);return i[s]=r.substr(e.generatedColumn-u),u=e.generatedColumn,p(c,t),void(c=e)}p(c,o()),a++,u=0}for(;a<e.generatedLine;)n.add(o()),a++;if(u<e.generatedColumn){var r=i[s];n.add(r.substr(0,e.generatedColumn)),i[s]=r.substr(e.generatedColumn),u=e.generatedColumn}c=e},this),s<i.length&&(c&&p(c,o()),n.add(i.splice(s).join(""))),t.sources.forEach(function(e){var i=t.sourceContentFor(e);null!=i&&(null!=r&&(e=util$1.join(r,e)),n.setSourceContent(e,i))}),n;function p(e,t){if(null===e||void 0===e.source)n.add(t);else{var i=r?util$1.join(r,e.source):e.source;n.add(new SourceNode(e.originalLine,e.originalColumn,i,t,e.name))}}},SourceNode.prototype.add=function(e){if(Array.isArray(e))e.forEach(function(e){this.add(e)},this);else{if(!e[isSourceNode]&&"string"!=typeof e)throw new TypeError("Expected a SourceNode, string, or an array of SourceNodes and strings. Got "+e);e&&this.children.push(e)}return this},SourceNode.prototype.prepend=function(e){if(Array.isArray(e))for(var t=e.length-1;t>=0;t--)this.prepend(e[t]);else{if(!e[isSourceNode]&&"string"!=typeof e)throw new TypeError("Expected a SourceNode, string, or an array of SourceNodes and strings. Got "+e);this.children.unshift(e)}return this},SourceNode.prototype.walk=function(e){for(var t,r=0,n=this.children.length;r<n;r++)(t=this.children[r])[isSourceNode]?t.walk(e):""!==t&&e(t,{source:this.source,line:this.line,column:this.column,name:this.name})},SourceNode.prototype.join=function(e){var t,r,n=this.children.length;if(n>0){for(t=[],r=0;r<n-1;r++)t.push(this.children[r]),t.push(e);t.push(this.children[r]),this.children=t}return this},SourceNode.prototype.replaceRight=function(e,t){var r=this.children[this.children.length-1];return r[isSourceNode]?r.replaceRight(e,t):"string"==typeof r?this.children[this.children.length-1]=r.replace(e,t):this.children.push("".replace(e,t)),this},SourceNode.prototype.setSourceContent=function(e,t){this.sourceContents[util$1.toSetString(e)]=t},SourceNode.prototype.walkSourceContents=function(e){for(var t=0,r=this.children.length;t<r;t++)this.children[t][isSourceNode]&&this.children[t].walkSourceContents(e);var n=Object.keys(this.sourceContents);for(t=0,r=n.length;t<r;t++)e(util$1.fromSetString(n[t]),this.sourceContents[n[t]])},SourceNode.prototype.toString=function(){var e="";return this.walk(function(t){e+=t}),e},SourceNode.prototype.toStringWithSourceMap=function(e){var t={code:"",line:1,column:0},r=new SourceMapGenerator$1(e),n=!1,i=null,s=null,o=null,a=null;return this.walk(function(e,u){t.code+=e,null!==u.source&&null!==u.line&&null!==u.column?(i===u.source&&s===u.line&&o===u.column&&a===u.name||r.addMapping({source:u.source,original:{line:u.line,column:u.column},generated:{line:t.line,column:t.column},name:u.name}),i=u.source,s=u.line,o=u.column,a=u.name,n=!0):n&&(r.addMapping({generated:{line:t.line,column:t.column}}),i=null,n=!1);for(var c=0,p=e.length;c<p;c++)e.charCodeAt(c)===NEWLINE_CODE?(t.line++,t.column=0,c+1===p?(i=null,n=!1):n&&r.addMapping({source:u.source,original:{line:u.line,column:u.column},generated:{line:t.line,column:t.column},name:u.name})):t.column++}),this.walkSourceContents(function(e,t){r.setSourceContent(e,t)}),{code:t.code,map:r}};var SourceNode_1=SourceNode,sourceNode={SourceNode:SourceNode_1},SourceMapGenerator$2=sourceMapGenerator.SourceMapGenerator,SourceMapConsumer$1=sourceMapConsumer.SourceMapConsumer,SourceNode$1=sourceNode.SourceNode,sourceMap={SourceMapGenerator:SourceMapGenerator$2,SourceMapConsumer:SourceMapConsumer$1,SourceNode:SourceNode$1},sourceMapUrl=createCommonjsModule$1(function(e,t){var r,n;e.exports=(r=/[#@] sourceMappingURL=([^\s'"]*)/,{regex:n=RegExp("(?:/\\*(?:\\s*\r?\n(?://)?)?(?:"+r.source+")\\s*\\*/|//(?:"+r.source+"))\\s*"),_innerRegex:r,getFrom:function(e){var t=e.match(n);return t?t[1]||t[2]||"":null},existsIn:function(e){return n.test(e)},removeFrom:function(e){return e.replace(n,"")},insertBefore:function(e,t){var r=e.match(n);return r?e.slice(0,r.index)+t+e.slice(r.index):e+t}})});function resolveUrl(){return Array.prototype.reduce.call(arguments,function(e,t){return url$1__default.resolve(e,t)})}var resolveUrl_1=resolveUrl,token="%[a-f0-9]{2}",singleMatcher=new RegExp(token,"gi"),multiMatcher=new RegExp("("+token+")+","gi");function decodeComponents(e,t){try{return decodeURIComponent(e.join(""))}catch(e){}if(1===e.length)return e;t=t||1;var r=e.slice(0,t),n=e.slice(t);return Array.prototype.concat.call([],decodeComponents(r),decodeComponents(n))}function decode$3(e){try{return decodeURIComponent(e)}catch(n){for(var t=e.match(singleMatcher),r=1;r<t.length;r++)t=(e=decodeComponents(t,r).join("")).match(singleMatcher);return e}}function customDecodeURIComponent(e){for(var t={"%FE%FF":"��","%FF%FE":"��"},r=multiMatcher.exec(e);r;){try{t[r[0]]=decodeURIComponent(r[0])}catch(e){var n=decode$3(r[0]);n!==r[0]&&(t[r[0]]=n)}r=multiMatcher.exec(e)}t["%C2"]="�";for(var i=Object.keys(t),s=0;s<i.length;s++){var o=i[s];e=e.replace(new RegExp(o,"g"),t[o])}return e}var decodeUriComponent=function(e){if("string"!=typeof e)throw new TypeError("Expected `encodedURI` to be of type `string`, got `"+typeof e+"`");try{return e=e.replace(/\+/g," "),decodeURIComponent(e)}catch(t){return customDecodeURIComponent(e)}};function customDecodeUriComponent(e){return decodeUriComponent(e.replace(/\+/g,"%2B"))}var decodeUriComponent_1=customDecodeUriComponent;function urix(e){return"\\"===path$2__default.sep?e.replace(/\\/g,"/").replace(/^[a-z]:\/?/i,"/"):e}var urix_1=urix;function atob(e){return Buffer.from(e,"base64").toString("binary")}var nodeAtob=atob.atob=atob;function callbackAsync(e,t,r){setImmediate(function(){e(t,r)})}function parseMapToJSON(e,t){try{return JSON.parse(e.replace(/^\)\]\}'/,""))}catch(e){throw e.sourceMapData=t,e}}function readSync(e,t,r){var n=decodeUriComponent_1(t);try{return String(e(n))}catch(e){throw e.sourceMapData=r,e}}function resolveSourceMap(e,t,r,n){var i;try{i=resolveSourceMapHelper(e,t)}catch(e){return callbackAsync(n,e)}if(!i||i.map)return callbackAsync(n,null,i);r(decodeUriComponent_1(i.url),function(e,t){if(e)return e.sourceMapData=i,n(e);i.map=String(t);try{i.map=parseMapToJSON(i.map,i)}catch(e){return n(e)}n(null,i)})}function resolveSourceMapSync(e,t,r){var n=resolveSourceMapHelper(e,t);return!n||n.map?n:(n.map=readSync(r,n.url,n),n.map=parseMapToJSON(n.map,n),n)}var dataUriRegex=/^data:([^,;]*)(;[^,;]*)*(?:,(.*))?$/,jsonMimeTypeRegex=/^(?:application|text)\/json$/;function resolveSourceMapHelper(e,t){t=urix_1(t);var r=sourceMapUrl.getFrom(e);if(!r)return null;var n=r.match(dataUriRegex);if(n){var i=n[1],s=n[2]||"",o=n[3]||"",a={sourceMappingURL:r,url:null,sourcesRelativeTo:t,map:o};if(!jsonMimeTypeRegex.test(i)){var u=new Error("Unuseful data uri mime type: "+(i||"text/plain"));throw u.sourceMapData=a,u}return a.map=parseMapToJSON(";base64"===s?nodeAtob(o):decodeURIComponent(o),a),a}var c=resolveUrl_1(t,r);return{sourceMappingURL:r,url:c,sourcesRelativeTo:c,map:null}}function resolveSources(e,t,r,n,i){"function"==typeof n&&(i=n,n={});var s=e.sources?e.sources.length:0,o={sourcesResolved:[],sourcesContent:[]};if(0!==s){var a=function(){0===--s&&i(null,o)};resolveSourcesHelper(e,t,n,function(e,t,n){if(o.sourcesResolved[n]=e,"string"==typeof t)o.sourcesContent[n]=t,callbackAsync(a,null);else{var i=decodeUriComponent_1(e);r(i,function(e,t){o.sourcesContent[n]=e||String(t),a()})}})}else callbackAsync(i,null,o)}function resolveSourcesSync(e,t,r,n){var i={sourcesResolved:[],sourcesContent:[]};return e.sources&&0!==e.sources.length?(resolveSourcesHelper(e,t,n,function(e,t,n){if(i.sourcesResolved[n]=e,null!==r)if("string"==typeof t)i.sourcesContent[n]=t;else{var s=decodeUriComponent_1(e);try{i.sourcesContent[n]=String(r(s))}catch(e){i.sourcesContent[n]=e}}}),i):i}var endingSlash=/\/?$/;function resolveSourcesHelper(e,t,r,n){var i;r=r||{},t=urix_1(t);for(var s=0,o=e.sources.length;s<o;s++)i=null,"string"==typeof r.sourceRoot?i=r.sourceRoot:"string"==typeof e.sourceRoot&&!1!==r.sourceRoot&&(i=e.sourceRoot),n(null===i||""===i?resolveUrl_1(t,e.sources[s]):resolveUrl_1(t,i.replace(endingSlash,"/"),e.sources[s]),(e.sourcesContent||[])[s],s)}function resolve(e,t,r,n,i){if("function"==typeof n&&(i=n,n={}),null===e){var s={sourceMappingURL:null,url:t,sourcesRelativeTo:t,map:null},o=decodeUriComponent_1(t);r(o,function(e,t){if(e)return e.sourceMapData=s,i(e);s.map=String(t);try{s.map=parseMapToJSON(s.map,s)}catch(e){return i(e)}a(s)})}else resolveSourceMap(e,t,r,function(e,t){return e?i(e):t?void a(t):i(null,null)});function a(e){resolveSources(e.map,e.sourcesRelativeTo,r,n,function(t,r){if(t)return i(t);e.sourcesResolved=r.sourcesResolved,e.sourcesContent=r.sourcesContent,i(null,e)})}}function resolveSync(e,t,r,n){var i;if(null===e){(i={sourceMappingURL:null,url:t,sourcesRelativeTo:t,map:null}).map=readSync(r,t,i),i.map=parseMapToJSON(i.map,i)}else if(!(i=resolveSourceMapSync(e,t,r)))return null;var s=resolveSourcesSync(i.map,i.sourcesRelativeTo,r,n);return i.sourcesResolved=s.sourcesResolved,i.sourcesContent=s.sourcesContent,i}var sourceMapResolveNode={resolveSourceMap:resolveSourceMap,resolveSourceMapSync:resolveSourceMapSync,resolveSources:resolveSources,resolveSourcesSync:resolveSourcesSync,resolve:resolve,resolveSync:resolveSync,parseMapToJSON:parseMapToJSON},extend$1$1=extendShallow$5,SourceMap$1=sourceMap,sourceMapResolve=sourceMapResolveNode,unixify=function(e){return e.split(/\\+/).join("/")},isString$1=function(e){return e&&"string"==typeof e},arrayify$3=function(e){return"string"==typeof e?[e]:e?Array.isArray(e)?e:[e]:[]},last=function(e,t){return e[e.length-(t||1)]},utils$1={extend:extend$1$1,SourceMap:SourceMap$1,sourceMapResolve:sourceMapResolve,unixify:unixify,isString:isString$1,arrayify:arrayify$3,last:last},sourceMaps=createCommonjsModule$1(function(e,t){e.exports=function(e){for(var r in defineProperty$6(e,"_comment",e.comment),e.map=new utils$1.SourceMap.SourceMapGenerator,e.position={line:1,column:1},e.content={},e.files={},t)defineProperty$6(e,r,t[r])},t.updatePosition=function(e){var t=e.match(/\n/g);t&&(this.position.line+=t.length);var r=e.lastIndexOf("\n");this.position.column=~r?e.length-r:this.position.column+e.length},t.emit=function(e,t){var r=t.position||{},n=r.source;return n&&(r.filepath&&(n=utils$1.unixify(r.filepath)),this.map.addMapping({source:n,generated:{line:this.position.line,column:Math.max(this.position.column-1,0)},original:{line:r.start.line,column:r.start.column-1}}),r.content&&this.addContent(n,r),r.filepath&&this.addFile(n,r),this.updatePosition(e),this.output+=e),e},t.addFile=function(e,t){"string"==typeof t.content&&(Object.prototype.hasOwnProperty.call(this.files,e)||(this.files[e]=t.content))},t.addContent=function(e,t){"string"==typeof t.content&&(Object.prototype.hasOwnProperty.call(this.content,e)||this.map.setSourceContent(e,t.content))},t.applySourceMaps=function(){Object.keys(this.files).forEach(function(e){var t=this.files[e];if(this.map.setSourceContent(e,t),!0===this.options.inputSourcemaps){var r=utils$1.sourceMapResolve.resolveSync(t,e,fs$2__default.readFileSync);if(r){var n=new utils$1.SourceMap.SourceMapConsumer(r.map),i=r.sourcesRelativeTo;this.map.applySourceMap(n,e,utils$1.unixify(path$2__default.dirname(i)))}}},this)},t.comment=function(e){return/^# sourceMappingURL=/.test(e.comment)?this.emit("",e.position):this._comment(e)}}),debug$1=src("snapdragon:compiler");function Compiler(e,t){debug$1("initializing",__filename),this.options=utils$1.extend({source:"string"},e),this.state=t||{},this.compilers={},this.output="",this.set("eos",function(e){return this.emit(e.val,e)}),this.set("noop",function(e){return this.emit(e.val,e)}),this.set("bos",function(e){return this.emit(e.val,e)}),use(this)}Compiler.prototype={error:function(e,t){var r=t.position||{start:{column:0}},n=this.options.source+" column:"+r.start.column+": "+e,i=new Error(n);if(i.reason=e,i.column=r.start.column,i.source=this.pattern,!this.options.silent)throw i;this.errors.push(i)},define:function(e,t){return defineProperty$6(this,e,t),this},emit:function(e,t){return this.output+=e,e},set:function(e,t){return this.compilers[e]=t,this},get:function(e){return this.compilers[e]},prev:function(e){return this.ast.nodes[this.idx-(e||1)]||{type:"bos",val:""}},next:function(e){return this.ast.nodes[this.idx+(e||1)]||{type:"eos",val:""}},visit:function(e,t,r){var n=this.compilers[e.type];if(this.idx=r,"function"!=typeof n)throw this.error('compiler "'+e.type+'" is not registered',e);return n.call(this,e,t,r)},mapVisit:function(e){if(!Array.isArray(e))throw new TypeError("expected an array");for(var t=e.length,r=-1;++r<t;)this.visit(e[r],e,r);return this},compile:function(e,t){var r=utils$1.extend({},this.options,t);return this.ast=e,this.parsingErrors=this.ast.errors,this.output="",r.sourcemap?(sourceMaps(this),this.mapVisit(this.ast.nodes),this.applySourceMaps(),this.map="generator"===r.sourcemap?this.map:this.map.toJSON(),this):(this.mapVisit(this.ast.nodes),this)}};var compiler=Compiler,hasOwn$6=Object.prototype.hasOwnProperty,mapCache=MapCache;function MapCache(e){this.__data__=e||{}}MapCache.prototype.set=function(e,t){return"__proto__"!==e&&(this.__data__[e]=t),this},MapCache.prototype.get=function(e){return"__proto__"===e?void 0:this.__data__[e]},MapCache.prototype.has=function(e){return"__proto__"!==e&&hasOwn$6.call(this.__data__,e)},MapCache.prototype.del=function(e){return this.has(e)&&delete this.__data__[e]};var position=function(e,t){this.start=e,this.end={line:t.line,column:t.column},defineProperty$6(this,"content",t.orig),defineProperty$6(this,"source",t.options.source)},debug$2=src("snapdragon:parser");function Parser$1(e){debug$2("initializing",__filename),this.options=utils$1.extend({source:"string"},e),this.init(this.options),use(this)}function visit(e,t){return e.visited?e:(defineProperty$6(e,"visited",!0),e.nodes?mapVisit$1(e.nodes,t):t(e))}function mapVisit$1(e,t){for(var r=e.length,n=-1;++n<r;)visit(e[n],t)}function hasOpen(e){return e.nodes&&e.nodes[0].type===e.type+".open"}function hasClose(e){return e.nodes&&utils$1.last(e.nodes).type===e.type+".close"}function hasDelims(e){return hasOpen(e)&&hasClose(e)}Parser$1.prototype={constructor:Parser$1,init:function(e){this.orig="",this.input="",this.parsed="",this.column=1,this.line=1,this.regex=new mapCache,this.errors=this.errors||[],this.parsers=this.parsers||{},this.types=this.types||[],this.sets=this.sets||{},this.fns=this.fns||[],this.currentType="root";var t=this.position();this.bos=t({type:"bos",val:""}),this.ast={type:"root",errors:this.errors,nodes:[this.bos]},defineProperty$6(this.bos,"parent",this.ast),this.nodes=[this.ast],this.count=0,this.setCount=0,this.stack=[]},error:function(e,t){var r=t.position||{start:{column:0,line:0}},n=r.start.line,i=r.start.column,s=this.options.source,o=new Error(s+" <line:"+n+" column:"+i+">: "+e);if(o.source=s,o.reason=e,o.pos=r,!this.options.silent)throw o;this.errors.push(o)},define:function(e,t){return defineProperty$6(this,e,t),this},position:function(){var e={line:this.line,column:this.column},t=this;return function(r){return defineProperty$6(r,"position",new position(e,t)),r}},set:function(e,t){return-1===this.types.indexOf(e)&&this.types.push(e),this.parsers[e]=t.bind(this),this},get:function(e){return this.parsers[e]},push:function(e,t){return this.sets[e]=this.sets[e]||[],this.count++,this.stack.push(t),this.sets[e].push(t)},pop:function(e){return this.sets[e]=this.sets[e]||[],this.count--,this.stack.pop(),this.sets[e].pop()},isInside:function(e){return this.sets[e]=this.sets[e]||[],this.sets[e].length>0},isType:function(e,t){return e&&e.type===t},prev:function(e){return this.stack.length>0?utils$1.last(this.stack,e):utils$1.last(this.nodes,e)},consume:function(e){this.input=this.input.substr(e)},updatePosition:function(e,t){var r=e.match(/\n/g);r&&(this.line+=r.length);var n=e.lastIndexOf("\n");this.column=~n?t-n:this.column+t,this.parsed+=e,this.consume(t)},match:function(e){var t=e.exec(this.input);if(t)return this.updatePosition(t[0],t[0].length),t},capture:function(e,t){return"function"==typeof t?this.set.apply(this,arguments):(this.regex.set(e,t),this.set(e,function(){var r=this.parsed,n=this.position(),i=this.match(t);if(i&&i[0]){var s=this.prev(),o=n({type:e,val:i[0],parsed:r,rest:this.input});i[1]&&(o.inner=i[1]),defineProperty$6(o,"inside",this.stack.length>0),defineProperty$6(o,"parent",s),s.nodes.push(o)}}.bind(this)),this)},capturePair:function(e,t,r,n){return this.sets[e]=this.sets[e]||[],this.set(e+".open",function(){var r=this.parsed,i=this.position(),s=this.match(t);if(s&&s[0]){var o=s[0];this.setCount++,this.specialChars=!0;var a=i({type:e+".open",val:o,rest:this.input});void 0!==s[1]&&(a.inner=s[1]);var u=this.prev(),c=i({type:e,nodes:[a]});defineProperty$6(c,"rest",this.input),defineProperty$6(c,"parsed",r),defineProperty$6(c,"prefix",s[1]),defineProperty$6(c,"parent",u),defineProperty$6(a,"parent",c),"function"==typeof n&&n.call(this,a,c),this.push(e,c),u.nodes.push(c)}}),this.set(e+".close",function(){var t=this.position(),n=this.match(r);if(n&&n[0]){var i=this.pop(e),s=t({type:e+".close",rest:this.input,suffix:n[1],val:n[0]});if(!this.isType(i,e)){if(this.options.strict)throw new Error('missing opening "'+e+'"');return this.setCount--,s.escaped=!0,s}"\\"===s.suffix&&(i.escaped=!0,s.escaped=!0),i.nodes.push(s),defineProperty$6(s,"parent",i)}}),this},eos:function(){var e=this.position();if(!this.input){for(var t=this.prev();"root"!==t.type&&!t.visited;){if(!0===this.options.strict)throw new SyntaxError("invalid syntax:"+util$2$1.inspect(t,null,2));hasDelims(t)||(t.parent.escaped=!0,t.escaped=!0),visit(t,function(e){hasDelims(e.parent)||(e.parent.escaped=!0,e.escaped=!0)}),t=t.parent}var r=e({type:"eos",val:this.append||""});return defineProperty$6(r,"parent",this.ast),r}},next:function(){for(var e,t=this.parsed,r=this.types.length,n=-1;++n<r;)if(e=this.parsers[this.types[n]].call(this))return defineProperty$6(e,"rest",this.input),defineProperty$6(e,"parsed",t),this.last=e,e},parse:function(e){if("string"!=typeof e)throw new TypeError("expected a string");this.init(this.options),this.orig=e,this.input=e;var t=this;function r(){e=t.input;var r=t.next();if(r){var n=t.prev();n&&(defineProperty$6(r,"parent",n),n.nodes&&n.nodes.push(r)),t.sets.hasOwnProperty(n.type)&&(t.currentType=n.type)}if(t.input&&e===t.input)throw new Error('no parsers registered for: "'+t.input.slice(0,5)+'"')}for(;this.input;)r();if(this.stack.length&&this.options.strict){var n=this.stack.pop();throw this.error("missing opening "+n.type+': "'+this.orig+'"')}var i=this.eos();return"eos"!==this.prev().type&&this.ast.nodes.push(i),this.ast}};var parser=Parser$1;function Snapdragon(e){base$2.call(this,null,e),this.options=utils$1.extend({source:"string"},this.options),this.compiler=new compiler(this.options),this.parser=new parser(this.options),Object.defineProperty(this,"compilers",{get:function(){return this.compiler.compilers}}),Object.defineProperty(this,"parsers",{get:function(){return this.parser.parsers}}),Object.defineProperty(this,"regex",{get:function(){return this.parser.regex}})}base$2.extend(Snapdragon),Snapdragon.prototype.capture=function(){return this.parser.capture.apply(this.parser,arguments)},Snapdragon.prototype.use=function(e){return e.call(this,this),this},Snapdragon.prototype.parse=function(e,t){this.options=utils$1.extend({},this.options,t);var r=this.parser.parse(e,this.options);return defineProperty$6(r,"parser",this.parser),r},Snapdragon.prototype.compile=function(e,t){this.options=utils$1.extend({},this.options,t);var r=this.compiler.compile(e,this.options);return defineProperty$6(r,"compiler",this.compiler),r};var cached,snapdragon=Snapdragon,Compiler_1=compiler,Parser_1=parser;function Braces(e){this.options=extendShallow$1({},e)}snapdragon.Compiler=Compiler_1,snapdragon.Parser=Parser_1,Braces.prototype.init=function(e){if(!this.isInitialized){this.isInitialized=!0;var t=utils_1.createOptions({},this.options,e);this.snapdragon=this.options.snapdragon||new snapdragon(t),this.compiler=this.snapdragon.compiler,this.parser=this.snapdragon.parser,compilers(this.snapdragon,t),parsers(this.snapdragon,t),utils_1.define(this.snapdragon,"parse",function(e,t){var r=snapdragon.prototype.parse.apply(this,arguments);this.parser.ast.input=e;for(var n=this.parser.stack;n.length;)i({type:"brace.close",val:""},n.pop());function i(e,t){utils_1.define(e,"parent",t),t.nodes.push(e)}return utils_1.define(r,"parser",this.parser),r})}},Braces.prototype.parse=function(e,t){return e&&"object"==typeof e&&e.nodes?e:(this.init(t),this.snapdragon.parse(e,t))},Braces.prototype.compile=function(e,t){return"string"==typeof e?e=this.parse(e,t):this.init(t),this.snapdragon.compile(e,t)},Braces.prototype.expand=function(e){var t=this.parse(e,{expand:!0});return this.compile(t,{expand:!0})},Braces.prototype.optimize=function(e){var t=this.parse(e,{optimize:!0});return this.compile(t,{optimize:!0})};var NOT_REGEX="[\\[!*+?$^\"'.\\\\/]+",not$1=createTextRegex(NOT_REGEX);function createTextRegex(e){if(cached)return cached;var t={contains:!0,strictClose:!1},r=regexNot.create(e,t),n=toRegex$1("^(?:[*]\\((?=.)|"+r+")",t);return cached=n}var fragmentCache=createCommonjsModule$1(function(e,t){function r(e){this.caches=e||{}}r.prototype={cache:function(e){return this.caches[e]||(this.caches[e]=new mapCache)},set:function(e,t,r){var n=this.cache(e);return n.set(t,r),n},has:function(e,t){return void 0!==this.get(e,t)},get:function(e,t){var r=this.cache(e);return"string"==typeof t?r.get(t):r}},e.exports=r}),cache$4=new fragmentCache,isWindows$1=createCommonjsModule$1(function(e,t){!function(r){t?e.exports=r():"undefined"!=typeof window?window.isWindows=r():void 0!==commonjsGlobal?commonjsGlobal.isWindows=r():"undefined"!=typeof self?self.isWindows=r():this.isWindows=r()}(function(){return function(){return process&&("win32"===process.platform||/^(msys|cygwin)$/.test(process.env.OSTYPE))}})}),arrDiff=function(e){for(var t=arguments.length,r=0;++r<t;)e=diffArray(e,arguments[r]);return e};function diffArray(e,t){if(!Array.isArray(t))return e.slice();for(var r=t.length,n=e.length,i=-1,s=[];++i<n;){for(var o=e[i],a=!1,u=0;u<r;u++){if(o===t[u]){a=!0;break}}!1===a&&s.push(o)}return s}var object_pick=function(e,t){if(!isobject(e)&&"function"!=typeof e)return{};var r={};if("string"==typeof t)return t in e&&(r[t]=e[t]),r;for(var n=t.length,i=-1;++i<n;){var s=t[i];s in e&&(r[s]=e[s])}return r},utils_1$1=createCommonjsModule$1(function(e){var t=e.exports,r=isWindows$1();t.define=defineProperty,t.diff=arrDiff,t.extend=extendShallow,t.pick=object_pick,t.typeOf=kindOf,t.unique=arrayUnique,t.isEmptyString=function(e){return""===String(e)||"./"===String(e)},t.isWindows=function(){return"\\"===path$2__default.sep||!0===r},t.last=function(e,t){return e[e.length-(t||1)]},t.instantiate=function(e,r){var n;return n="object"===t.typeOf(e)&&e.snapdragon?e.snapdragon:"object"===t.typeOf(r)&&r.snapdragon?r.snapdragon:new snapdragon(r),t.define(n,"parse",function(e,r){var n=snapdragon.prototype.parse.call(this,e,r);n.input=e;var i=this.parser.stack.pop();if(i&&!0!==this.options.strictErrors){var s=i.nodes[0],o=i.nodes[1];if("bracket"===i.type)"["===o.val.charAt(0)&&(o.val="\\"+o.val);else{s.val="\\"+s.val;var a=s.parent.nodes[1];"star"===a.type&&(a.loose=!0)}}return t.define(n,"parser",this.parser),n}),n},t.createKey=function(e,t){if(void 0===t)return e;var r=e;for(var n in t)t.hasOwnProperty(n)&&(r+=";"+n+"="+String(t[n]));return r},t.arrayify=function(e){return"string"==typeof e?[e]:e?Array.isArray(e)?e:[e]:[]},t.isString=function(e){return"string"==typeof e},t.isRegex=function(e){return"regexp"===t.typeOf(e)},t.isObject=function(e){return"object"===t.typeOf(e)},t.escapeRegex=function(e){return e.replace(/[-[\]{}()^$|*+?.\\\/\s]/g,"\\$&")},t.combineDupes=function(e,r){var n=(r=(r=t.arrayify(r).join("|").split("|")).map(function(e){return e.replace(/\\?([+*\\\/])/g,"\\$1")})).join("|"),i=new RegExp("("+n+")(?=\\1)","g");return e.replace(i,"")},t.hasSpecialChars=function(e){return/(?:(?:(^|\/)[!.])|[*?+()|[\]{}]|[+@]\()/.test(e)},t.toPosixPath=function(e){return e.replace(/\\+/g,"/")},t.unescape=function(e){return t.toPosixPath(e.replace(/\\(?=[*+?!.])/g,""))},t.stripDrive=function(e){return t.isWindows()?e.replace(/^[a-z]:[\\\/]+?/i,"/"):e},t.stripPrefix=function(e){return"."!==e.charAt(0)||"/"!==e.charAt(1)&&"\\"!==e.charAt(1)?e:e.slice(2)},t.isSimpleChar=function(e){return""===e.trim()||"."===e},t.isSlash=function(e){return"/"===e||"\\/"===e||"\\"===e||"\\\\"===e},t.matchPath=function(e,r){return r&&r.contains?t.containsPattern(e,r):t.equalsPattern(e,r)},t._equals=function(e,t,r){return r===e||r===t},t._contains=function(e,t,r){return-1!==e.indexOf(r)||-1!==t.indexOf(r)},t.equalsPattern=function(e,r){var n=t.unixify(r);return r=r||{},function(i){var s=t._equals(i,n(i),e);if(!0===s||!0!==r.nocase)return s;var o=i.toLowerCase();return t._equals(o,n(o),e)}},t.containsPattern=function(e,r){var n=t.unixify(r);return r=r||{},function(i){var s=t._contains(i,n(i),e);if(!0===s||!0!==r.nocase)return s;var o=i.toLowerCase();return t._contains(o,n(o),e)}},t.matchBasename=function(e){return function(t){return e.test(t)||e.test(path$2__default.basename(t))}},t.identity=function(e){return e},t.value=function(e,t,r){return r&&!1===r.unixify?e:r&&"function"==typeof r.unixify?r.unixify(e):t(e)},t.unixify=function(e){var r=e||{};return function(e){return!1!==r.stripPrefix&&(e=t.stripPrefix(e)),!0===r.unescape&&(e=t.unescape(e)),(!0===r.unixify||t.isWindows())&&(e=t.toPosixPath(e)),e}}}),extendShallow$6=function(e){isExtendable$1(e)||(e={});for(var t=arguments.length,r=1;r<t;r++){var n=arguments[r];isExtendable$1(n)&&assign$6(e,n)}return e};function assign$6(e,t){for(var r in t)hasOwn$7(t,r)&&(e[r]=t[r])}function hasOwn$7(e,t){return Object.prototype.hasOwnProperty.call(e,t)}var cached$1,posixCharacterClasses={alnum:"a-zA-Z0-9",alpha:"a-zA-Z",ascii:"\\x00-\\x7F",blank:" \\t",cntrl:"\\x00-\\x1F\\x7F",digit:"0-9",graph:"\\x21-\\x7E",lower:"a-z",print:"\\x20-\\x7E ",punct:"\\-!\"#$%&'()\\*+,./:;<=>?@[\\]^_`{|}~",space:" \\t\\r\\n\\v\\f",upper:"A-Z",word:"A-Za-z0-9_",xdigit:"A-Fa-f0-9"},compilers$2=function(e){e.compiler.set("escape",function(e){return this.emit("\\"+e.val.replace(/^\\/,""),e)}).set("text",function(e){return this.emit(e.val.replace(/([{}])/g,"\\$1"),e)}).set("posix",function(e){if("[::]"===e.val)return this.emit("\\[::\\]",e);var t=posixCharacterClasses[e.inner];return void 0===t&&(t="["+e.inner+"]"),this.emit(t,e)}).set("bracket",function(e){return this.mapVisit(e.nodes)}).set("bracket.open",function(e){return this.emit(e.val,e)}).set("bracket.inner",function(e){var t=e.val;if("["===t||"]"===t)return this.emit("\\"+e.val,e);if("^]"===t)return this.emit("^\\]",e);if("^"===t)return this.emit("^",e);/-/.test(t)&&!/(\d-\d|\w-\w)/.test(t)&&(t=t.split("-").join("\\-"));var r="^"===t.charAt(0);return r&&-1===t.indexOf("/")&&(t+="/"),r&&-1===t.indexOf(".")&&(t+="."),t=t.replace(/\\([1-9])/g,"$1"),this.emit(t,e)}).set("bracket.close",function(e){var t=e.val.replace(/^\\/,"");return!0===e.parent.escaped?this.emit("\\"+t,e):this.emit(t,e)})},last$1=function(e){return e[e.length-1]},createRegex=function(e,t){if(cached$1)return cached$1;var r,n={contains:!0,strictClose:!1},i=regexNot.create(e,n);return r=toRegex$1("string"==typeof t?"^(?:"+t+"|"+i+")":i,n),cached$1=r},utils$2={last:last$1,createRegex:createRegex},defineProperty$7=function(e,t,r){if("object"!=typeof e&&"function"!=typeof e)throw new TypeError("expected an object or function.");if("string"!=typeof t)throw new TypeError("expected `prop` to be a string.");return isDescriptor$3(r)&&("set"in r||"get"in r)?Object.defineProperty(e,t,r):Object.defineProperty(e,t,{configurable:!0,enumerable:!1,writable:!0,value:r})},TEXT_REGEX="(\\[(?=.*\\])|\\])+",not$2=utils$2.createRegex(TEXT_REGEX);function parsers$2(e){e.state=e.state||{},e.parser.sets.bracket=e.parser.sets.bracket||[],e.parser.capture("escape",function(){if(!this.isInside("bracket")){var e=this.position(),t=this.match(/^\\(.)/);if(t)return e({type:"escape",val:t[0]})}}).capture("text",function(){if(!this.isInside("bracket")){var e=this.position(),t=this.match(not$2);if(t&&t[0])return e({type:"text",val:t[0]})}}).capture("posix",function(){var t=this.position(),r=this.match(/^\[:(.*?):\](?=.*\])/);if(r){var n=this.isInside("bracket");return n&&e.posix++,t({type:"posix",insideBracket:n,inner:r[1],val:r[0]})}}).capture("bracket",function(){}).capture("bracket.open",function(){var e=this.parsed,t=this.position(),r=this.match(/^\[(?=.*\])/);if(r){var n=this.prev(),i=utils$2.last(n.nodes);if("\\"===e.slice(-1)&&!this.isInside("bracket"))return i.val=i.val.slice(0,i.val.length-1),t({type:"escape",val:r[0]});var s=t({type:"bracket.open",val:r[0]});if("bracket.open"===i.type||this.isInside("bracket"))return s.val="\\"+s.val,s.type="bracket.inner",s.escaped=!0,s;var o=t({type:"bracket",nodes:[s]});defineProperty$7(o,"parent",n),defineProperty$7(s,"parent",o),this.push("bracket",o),n.nodes.push(o)}}).capture("bracket.inner",function(){if(this.isInside("bracket")){var e=this.position(),t=this.match(not$2);if(t&&t[0]){var r=this.input.charAt(0),n=t[0],i=e({type:"bracket.inner",val:n});if("\\\\"===n)return i;var s=n.charAt(0),o=n.slice(-1);return"!"===s&&(n="^"+n.slice(1)),("\\"===o||"^"===n&&"]"===r)&&(n+=this.input[0],this.consume(1)),i.val=n,i}}}).capture("bracket.close",function(){var e=this.parsed,t=this.position(),r=this.match(/^\]/);if(r){var n=this.prev(),i=utils$2.last(n.nodes);if("\\"===e.slice(-1)&&!this.isInside("bracket"))return i.val=i.val.slice(0,i.val.length-1),t({type:"escape",val:r[0]});var s=t({type:"bracket.close",rest:this.input,val:r[0]});if("bracket.open"===i.type)return s.type="bracket.inner",s.escaped=!0,s;var o=this.pop("bracket");if(!this.isType(o,"bracket")){if(this.options.strict)throw new Error('missing opening "["');return s.type="bracket.inner",s.escaped=!0,s}o.nodes.push(s),defineProperty$7(s,"parent",o)}})}var parsers_1=parsers$2,TEXT_REGEX_1=TEXT_REGEX;parsers_1.TEXT_REGEX=TEXT_REGEX_1;var extendShallow$7=function(e){isExtendable$1(e)||(e={});for(var t=arguments.length,r=1;r<t;r++){var n=arguments[r];isExtendable$1(n)&&assign$7(e,n)}return e};function assign$7(e,t){for(var r in t)hasOwn$8(t,r)&&(e[r]=t[r])}function hasOwn$8(e,t){return Object.prototype.hasOwnProperty.call(e,t)}var debug$3=src("expand-brackets");function brackets(e,t){return debug$3("initializing from <%s>",__filename),brackets.create(e,t).output}brackets.match=function(e,t,r){e=[].concat(e);for(var n=extendShallow$7({},r),i=brackets.matcher(t,n),s=e.length,o=-1,a=[];++o<s;){var u=e[o];i(u)&&a.push(u)}if(0===a.length){if(!0===n.failglob)throw new Error('no matches found for "'+t+'"');if(!0===n.nonull||!0===n.nullglob)return[t.split("\\").join("")]}return a},brackets.isMatch=function(e,t,r){return brackets.matcher(t,r)(e)},brackets.matcher=function(e,t){var r=brackets.makeRe(e,t);return function(e){return r.test(e)}},brackets.makeRe=function(e,t){var r=brackets.create(e,t),n=extendShallow$7({strictErrors:!1},t);return toRegex$1(r.output,n)},brackets.create=function(e,t){var r=t&&t.snapdragon||new snapdragon(t);compilers$2(r),parsers_1(r);var n=r.parse(e,t);n.input=e;var i=r.compile(n,t);return i.input=e,i},brackets.compilers=compilers$2,brackets.parsers=parsers_1;var expandBrackets=brackets,compilers$3=function(e){function t(){return"function"==typeof e.options.star?e.options.star.apply(this,arguments):"string"==typeof e.options.star?e.options.star:".*?"}e.use(expandBrackets.compilers),e.compiler.set("escape",function(e){return this.emit(e.val,e)}).set("dot",function(e){return this.emit("\\"+e.val,e)}).set("qmark",function(e){var t="[^\\\\/.]",r=this.prev();if("("===e.parsed.slice(-1)){var n=e.rest.charAt(0);return"!"!==n&&"="!==n&&":"!==n?this.emit(t,e):this.emit(e.val,e)}return"text"===r.type&&r.val?this.emit(t,e):(e.val.length>1&&(t+="{"+e.val.length+"}"),this.emit(t,e))}).set("plus",function(e){var t=e.parsed.slice(-1);if("]"===t||")"===t)return this.emit(e.val,e);var r=this.output.slice(-1);return!this.output||/[?*+]/.test(r)&&"bracket"!==e.parent.type?this.emit("\\+",e):/\w/.test(r)&&!e.inside?this.emit("+\\+?",e):this.emit("+",e)}).set("star",function(e){var r=this.prev(),n="text"!==r.type&&"escape"!==r.type?"(?!\\.)":"";return this.emit(n+t.call(this,e),e)}).set("paren",function(e){return this.mapVisit(e.nodes)}).set("paren.open",function(e){var t=this.options.capture?"(":"";switch(e.parent.prefix){case"!":case"^":return this.emit(t+"(?:(?!(?:",e);case"*":case"+":case"?":case"@":return this.emit(t+"(?:",e);default:var r=e.val;return!0===this.options.bash?r="\\"+r:this.options.capture||"("!==r||"?"===e.parent.rest[0]||(r+="?:"),this.emit(r,e)}}).set("paren.close",function(e){var r=this.options.capture?")":"";switch(e.prefix){case"!":case"^":var n=/^(\)|$)/.test(e.rest)?"$":"",i=t.call(this,e);return e.parent.hasSlash&&!this.options.star&&!1!==this.options.slash&&(i=".*?"),this.emit(n+"))"+i+")"+r,e);case"*":case"+":case"?":return this.emit(")"+e.prefix+r,e);case"@":return this.emit(")"+r,e);default:var s=(!0===this.options.bash?"\\":"")+")";return this.emit(s,e)}}).set("text",function(e){var t=e.val.replace(/[\[\]]/g,"\\$&");return this.emit(t,e)})},accessor$4={get:"function",set:"function",configurable:"boolean",enumerable:"boolean"};function isAccessorDescriptor$4(e,t){if("string"==typeof t)return void 0!==Object.getOwnPropertyDescriptor(e,t);if("object"!==kindOf(e))return!1;if(has$7(e,"value")||has$7(e,"writable"))return!1;if(!has$7(e,"get")||"function"!=typeof e.get)return!1;if(has$7(e,"set")&&"function"!=typeof e[r]&&void 0!==e[r])return!1;for(var r in e)if(accessor$4.hasOwnProperty(r)&&kindOf(e[r])!==accessor$4[r]&&void 0!==e[r])return!1;return!0}function has$7(e,t){return{}.hasOwnProperty.call(e,t)}var isAccessorDescriptor_1$4=isAccessorDescriptor$4,isDataDescriptor$4=function(e,t){var r={configurable:"boolean",enumerable:"boolean",writable:"boolean"};if("object"!==kindOf(e))return!1;if("string"==typeof t)return void 0!==Object.getOwnPropertyDescriptor(e,t);if(!("value"in e||"writable"in e))return!1;for(var n in e)if("value"!==n&&r.hasOwnProperty(n)&&kindOf(e[n])!==r[n]&&void 0!==e[n])return!1;return!0},isDescriptor$4=function(e,t){return"object"===kindOf(e)&&("get"in e?isAccessorDescriptor_1$4(e,t):isDataDescriptor$4(e,t))},defineProperty$8=function(e,t,r){if("object"!=typeof e&&"function"!=typeof e)throw new TypeError("expected an object or function.");if("string"!=typeof t)throw new TypeError("expected `prop` to be a string.");return isDescriptor$4(r)&&("set"in r||"get"in r)?Object.defineProperty(e,t,r):Object.defineProperty(e,t,{configurable:!0,enumerable:!1,writable:!0,value:r})},utils_1$2=createCommonjsModule$1(function(e){var t=e.exports,r=t.cache=new fragmentCache;t.arrayify=function(e){return Array.isArray(e)?e:[e]},t.memoize=function(e,n,i,s){var o=t.createKey(e+n,i);if(r.has(e,o))return r.get(e,o);var a=s(n,i);return i&&!1===i.cache?a:(r.set(e,o,a),a)},t.createKey=function(e,t){var r=e;if(void 0===t)return r;for(var n in t)r+=";"+n+"="+String(t[n]);return r},t.createRegex=function(e){return regexNot(e,{contains:!0,strictClose:!1})}}),TEXT_REGEX$1="([!@*?+]?\\(|\\)|[*?.+\\\\]|\\[:?(?=.*\\])|:?\\])+",not$3=utils_1$2.createRegex(TEXT_REGEX$1);function parsers$3(e){e.state=e.state||{},e.use(expandBrackets.parsers),e.parser.sets.paren=e.parser.sets.paren||[],e.parser.capture("paren.open",function(){var e=this.parsed,t=this.position(),r=this.match(/^([!@*?+])?\(/);if(r){var n=this.prev(),i=r[1],s=t({type:"paren.open",parsed:e,val:r[0]}),o=t({type:"paren",prefix:i,nodes:[s]});"!"===i&&"paren"===n.type&&"!"===n.prefix&&(n.prefix="@",o.prefix="@"),defineProperty$8(o,"rest",this.input),defineProperty$8(o,"parsed",e),defineProperty$8(o,"parent",n),defineProperty$8(s,"parent",o),this.push("paren",o),n.nodes.push(o)}}).capture("paren.close",function(){var e=this.parsed,t=this.position(),r=this.match(/^\)/);if(r){var n=this.pop("paren"),i=t({type:"paren.close",rest:this.input,parsed:e,val:r[0]});if(!this.isType(n,"paren")){if(this.options.strict)throw new Error('missing opening paren: "("');return i.escaped=!0,i}i.prefix=n.prefix,n.nodes.push(i),defineProperty$8(i,"parent",n)}}).capture("escape",function(){var e=this.position(),t=this.match(/^\\(.)/);if(t)return e({type:"escape",val:t[0],ch:t[1]})}).capture("qmark",function(){var t=this.parsed,r=this.position(),n=this.match(/^\?+(?!\()/);if(n)return e.state.metachar=!0,r({type:"qmark",rest:this.input,parsed:t,val:n[0]})}).capture("star",/^\*(?!\()/).capture("plus",/^\+(?!\()/).capture("dot",/^\./).capture("text",not$3)}var TEXT_REGEX_1$1=TEXT_REGEX$1,parsers_1$1=parsers$3;function Extglob(e){this.options=extendShallow$6({source:"extglob"},e),this.snapdragon=this.options.snapdragon||new snapdragon(this.options),this.snapdragon.patterns=this.snapdragon.patterns||{},this.compiler=this.snapdragon.compiler,this.parser=this.snapdragon.parser,compilers$3(this.snapdragon),parsers_1$1(this.snapdragon),defineProperty$8(this.snapdragon,"parse",function(e,t){var r=snapdragon.prototype.parse.apply(this,arguments);r.input=e;var n=this.parser.stack.pop();if(n&&!0!==this.options.strict){var i=n.nodes[0];i.val="\\"+i.val;var s=i.parent.nodes[1];"star"===s.type&&(s.loose=!0)}return defineProperty$8(r,"parser",this.parser),r}),defineProperty$8(this,"parse",function(e,t){return this.snapdragon.parse.apply(this.snapdragon,arguments)}),defineProperty$8(this,"compile",function(e,t){return this.snapdragon.compile.apply(this.snapdragon,arguments)})}parsers_1$1.TEXT_REGEX=TEXT_REGEX_1$1;var extglob=Extglob,MAX_LENGTH$3=65536;function extglob$1(e,t){return extglob$1.create(e,t).output}extglob$1.match=function(e,t,r){if("string"!=typeof t)throw new TypeError("expected pattern to be a string");e=utils_1$2.arrayify(e);for(var n=extglob$1.matcher(t,r),i=e.length,s=-1,o=[];++s<i;){var a=e[s];n(a)&&o.push(a)}if(void 0===r)return arrayUnique(o);if(0===o.length){if(!0===r.failglob)throw new Error('no matches found for "'+t+'"');if(!0===r.nonull||!0===r.nullglob)return[t.split("\\").join("")]}return!1!==r.nodupes?arrayUnique(o):o},extglob$1.isMatch=function(e,t,r){if("string"!=typeof t)throw new TypeError("expected pattern to be a string");if("string"!=typeof e)throw new TypeError("expected a string");return t===e||(""===t||" "===t||"."===t?t===e:utils_1$2.memoize("isMatch",t,r,extglob$1.matcher)(e))},extglob$1.contains=function(e,t,r){if("string"!=typeof e)throw new TypeError("expected a string");if(""===t||" "===t||"."===t)return t===e;var n=extendShallow$6({},r,{contains:!0});return n.strictClose=!1,n.strictOpen=!1,extglob$1.isMatch(e,t,n)},extglob$1.matcher=function(e,t){if("string"!=typeof e)throw new TypeError("expected pattern to be a string");return utils_1$2.memoize("matcher",e,t,function(){var r=extglob$1.makeRe(e,t);return function(e){return r.test(e)}})},extglob$1.create=function(e,t){if("string"!=typeof e)throw new TypeError("expected pattern to be a string");return utils_1$2.memoize("create",e,t,function(){var r=new extglob(t),n=r.parse(e,t);return r.compile(n,t)})},extglob$1.capture=function(e,t,r){var n=extglob$1.makeRe(e,extendShallow$6({capture:!0},r));return utils_1$2.memoize("capture",e,r,function(){return function(e){var t=n.exec(e);return t?t.slice(1):null}})(t)},extglob$1.makeRe=function(e,t){if(e instanceof RegExp)return e;if("string"!=typeof e)throw new TypeError("expected pattern to be a string");if(e.length>MAX_LENGTH$3)throw new Error("expected pattern to be less than "+MAX_LENGTH$3+" characters");var r=utils_1$2.memoize("makeRe",e,t,function(){var r=extendShallow$6({strictErrors:!1},t);!0===r.strictErrors&&(r.strict=!0);var n=extglob$1.create(e,r);return toRegex$1(n.output,r)});if(r.source.length>MAX_LENGTH$3)throw new SyntaxError("potentially malicious regex detected");return r},extglob$1.cache=utils_1$2.cache,extglob$1.clearCache=function(){extglob$1.cache.__data__={}},extglob$1.Extglob=extglob,extglob$1.compilers=compilers$3,extglob$1.parsers=parsers_1$1;var cache$5=new fragmentCache,utils_1$3=createCommonjsModule$1(function(e){var t=e.exports;t.define=defineProperty,t.diff=arrDiff,t.extend=extendShallow,t.pick=object_pick,t.typeOf=kindOf,t.unique=arrayUnique,t.isWindows=function(){return"\\"===path$2__default.sep||"win32"===process.platform},t.instantiate=function(e,r){var n;return n="object"===t.typeOf(e)&&e.snapdragon?e.snapdragon:"object"===t.typeOf(r)&&r.snapdragon?r.snapdragon:new snapdragon(r),t.define(n,"parse",function(e,r){var n=snapdragon.prototype.parse.apply(this,arguments);n.input=e;var i=this.parser.stack.pop();if(i&&!0!==this.options.strictErrors){var s=i.nodes[0],o=i.nodes[1];if("bracket"===i.type)"["===o.val.charAt(0)&&(o.val="\\"+o.val);else{s.val="\\"+s.val;var a=s.parent.nodes[1];"star"===a.type&&(a.loose=!0)}}return t.define(n,"parser",this.parser),n}),n},t.createKey=function(e,r){if("object"!==t.typeOf(r))return e;for(var n=e,i=Object.keys(r),s=0;s<i.length;s++){var o=i[s];n+=";"+o+"="+String(r[o])}return n},t.arrayify=function(e){return"string"==typeof e?[e]:e?Array.isArray(e)?e:[e]:[]},t.isString=function(e){return"string"==typeof e},t.isObject=function(e){return"object"===t.typeOf(e)},t.hasSpecialChars=function(e){return/(?:(?:(^|\/)[!.])|[*?+()|\[\]{}]|[+@]\()/.test(e)},t.escapeRegex=function(e){return e.replace(/[-[\]{}()^$|*+?.\\\/\s]/g,"\\$&")},t.toPosixPath=function(e){return e.replace(/\\+/g,"/")},t.unescape=function(e){return t.toPosixPath(e.replace(/\\(?=[*+?!.])/g,""))},t.stripPrefix=function(e){if("."!==e.charAt(0))return e;var r=e.charAt(1);return t.isSlash(r)?e.slice(2):e},t.isSlash=function(e){return"/"===e||"\\/"===e||"\\"===e||"\\\\"===e},t.matchPath=function(e,r){return r&&r.contains?t.containsPattern(e,r):t.equalsPattern(e,r)},t._equals=function(e,t,r){return r===e||r===t},t._contains=function(e,t,r){return-1!==e.indexOf(r)||-1!==t.indexOf(r)},t.equalsPattern=function(e,r){var n=t.unixify(r);return r=r||{},function(i){var s=t._equals(i,n(i),e);if(!0===s||!0!==r.nocase)return s;var o=i.toLowerCase();return t._equals(o,n(o),e)}},t.containsPattern=function(e,r){var n=t.unixify(r);return r=r||{},function(i){var s=t._contains(i,n(i),e);if(!0===s||!0!==r.nocase)return s;var o=i.toLowerCase();return t._contains(o,n(o),e)}},t.matchBasename=function(e){return function(t){return e.test(path$2__default.basename(t))}},t.value=function(e,t,r){return r&&!1===r.unixify?e:t(e)},t.unixify=function(e){return e=e||{},function(r){return(t.isWindows()||!0===e.unixify)&&(r=t.toPosixPath(r)),!1!==e.stripPrefix&&(r=t.stripPrefix(r)),!0===e.unescape&&(r=t.unescape(r)),r}}}),modules={},getModule=function(e){var t=e?path$2__default.resolve(e):process.cwd(),r=path$2__default.join(t,"@root"),n=modules[r];return n||((n=new module$1$1(r)).filename=r,n.paths=module$1$1._nodeModulePaths(t),modules[r]=n),n},requireRelative=function(e,t){return getModule(t).require(e)};requireRelative.resolve=function(e,t){var r=getModule(t);return module$1$1._resolveFilename(e,r)};var chokidar,requireRelative_1=requireRelative;try{chokidar=requireRelative_1("chokidar",process.cwd())}catch(e){chokidar=null}var assert$1=!0,async_hooks=">= 8",buffer_ieee754="< 0.9.7",buffer=!0,child_process=!0,cluster=!0,console$1=!0,constants=!0,crypto=!0,_debugger="< 8",dgram=!0,dns=!0,domain=!0,events=!0,freelist="< 6",fs=!0,_http_agent=">= 0.11.1",_http_client=">= 0.11.1",_http_common=">= 0.11.1",_http_incoming=">= 0.11.1",_http_outgoing=">= 0.11.1",_http_server=">= 0.11.1",http=!0,http2=">= 8.8",https=!0,inspector=">= 8.0.0",_linklist="< 8",module$1=!0,net=!0,os=!0,path$1=!0,perf_hooks=">= 8.5",process$1=">= 1",punycode=!0,querystring=!0,readline=!0,repl=!0,smalloc=">= 0.11.5 && < 3",_stream_duplex=">= 0.9.4",_stream_transform=">= 0.9.4",_stream_wrap=">= 1.4.1",_stream_passthrough=">= 0.9.4",_stream_readable=">= 0.9.4",_stream_writable=">= 0.9.4",stream=!0,string_decoder=!0,sys=!0,timers$1=!0,_tls_common=">= 0.11.13",_tls_legacy=">= 0.11.3 && < 10",_tls_wrap=">= 0.11.3",tls=!0,trace_events=">= 10",tty=!0,url=!0,util$2=!0,v8=">= 1",vm=!0,worker_threads=">= 11.7",zlib=!0,core={assert:assert$1,async_hooks:async_hooks,buffer_ieee754:buffer_ieee754,buffer:buffer,child_process:child_process,cluster:cluster,console:console$1,constants:constants,crypto:crypto,_debugger:_debugger,dgram:dgram,dns:dns,domain:domain,events:events,freelist:freelist,fs:fs,"fs/promises":">= 10 && < 10.1",_http_agent:_http_agent,_http_client:_http_client,_http_common:_http_common,_http_incoming:_http_incoming,_http_outgoing:_http_outgoing,_http_server:_http_server,http:http,http2:http2,https:https,inspector:inspector,_linklist:_linklist,module:module$1,net:net,"node-inspect/lib/_inspect":">= 7.6.0","node-inspect/lib/internal/inspect_client":">= 7.6.0","node-inspect/lib/internal/inspect_repl":">= 7.6.0",os:os,path:path$1,perf_hooks:perf_hooks,process:process$1,punycode:punycode,querystring:querystring,readline:readline,repl:repl,smalloc:smalloc,_stream_duplex:_stream_duplex,_stream_transform:_stream_transform,_stream_wrap:_stream_wrap,_stream_passthrough:_stream_passthrough,_stream_readable:_stream_readable,_stream_writable:_stream_writable,stream:stream,string_decoder:string_decoder,sys:sys,timers:timers$1,_tls_common:_tls_common,_tls_legacy:_tls_legacy,_tls_wrap:_tls_wrap,tls:tls,trace_events:trace_events,tty:tty,url:url,util:util$2,"v8/tools/arguments":">= 10","v8/tools/codemap":[">= 4.4.0 && < 5",">= 5.2.0"],"v8/tools/consarray":[">= 4.4.0 && < 5",">= 5.2.0"],"v8/tools/csvparser":[">= 4.4.0 && < 5",">= 5.2.0"],"v8/tools/logreader":[">= 4.4.0 && < 5",">= 5.2.0"],"v8/tools/profile_view":[">= 4.4.0 && < 5",">= 5.2.0"],"v8/tools/splaytree":[">= 4.4.0 && < 5",">= 5.2.0"],v8:v8,vm:vm,worker_threads:worker_threads,zlib:zlib},core$1=Object.freeze({assert:assert$1,async_hooks:async_hooks,buffer_ieee754:buffer_ieee754,buffer:buffer,child_process:child_process,cluster:cluster,console:console$1,constants:constants,crypto:crypto,_debugger:_debugger,dgram:dgram,dns:dns,domain:domain,events:events,freelist:freelist,fs:fs,_http_agent:_http_agent,_http_client:_http_client,_http_common:_http_common,_http_incoming:_http_incoming,_http_outgoing:_http_outgoing,_http_server:_http_server,http:http,http2:http2,https:https,inspector:inspector,_linklist:_linklist,module:module$1,net:net,os:os,path:path$1,perf_hooks:perf_hooks,process:process$1,punycode:punycode,querystring:querystring,readline:readline,repl:repl,smalloc:smalloc,_stream_duplex:_stream_duplex,_stream_transform:_stream_transform,_stream_wrap:_stream_wrap,_stream_passthrough:_stream_passthrough,_stream_readable:_stream_readable,_stream_writable:_stream_writable,stream:stream,string_decoder:string_decoder,sys:sys,timers:timers$1,_tls_common:_tls_common,_tls_legacy:_tls_legacy,_tls_wrap:_tls_wrap,tls:tls,trace_events:trace_events,tty:tty,url:url,util:util$2,v8:v8,vm:vm,worker_threads:worker_threads,zlib:zlib,default:core}),data$2=getCjsExportFromNamespace(core$1),current=process.versions&&process.versions.node&&process.versions.node.split(".")||[];function specifierIncluded(e){for(var t=e.split(" "),r=t.length>1?t[0]:"=",n=(t.length>1?t[1]:t[0]).split("."),i=0;i<3;++i){var s=Number(current[i]||0),o=Number(n[i]||0);if(s!==o)return"<"===r?s<o:">="===r&&s>=o}return">="===r}function matchesRange(e){var t=e.split(/ ?&& ?/);if(0===t.length)return!1;for(var r=0;r<t.length;++r)if(!specifierIncluded(t[r]))return!1;return!0}function versionIncluded(e){if("boolean"==typeof e)return e;if(e&&"object"==typeof e){for(var t=0;t<e.length;++t)if(matchesRange(e[t]))return!0;return!1}return matchesRange(e)}var core$2={};for(var mod in data$2)Object.prototype.hasOwnProperty.call(data$2,mod)&&(core$2[mod]=versionIncluded(data$2[mod]));var core_1=core$2,caller=function(){var e=Error.prepareStackTrace;Error.prepareStackTrace=function(e,t){return t};var t=(new Error).stack;return Error.prepareStackTrace=e,t[2].getFileName()},pathParse=createCommonjsModule(function(e){var t="win32"===process.platform,r=/^([a-zA-Z]:|[\\\/]{2}[^\\\/]+[\\\/]+[^\\\/]+)?([\\\/])?([\s\S]*?)$/,n=/^([\s\S]*?)((?:\.{1,2}|[^\\\/]+?|)(\.[^.\/\\]*|))(?:[\\\/]*)$/,i={};i.parse=function(e){if("string"!=typeof e)throw new TypeError("Parameter 'pathString' must be a string, not "+typeof e);var t,i,s,o,a,u=(t=e,i=r.exec(t),s=(i[1]||"")+(i[2]||""),o=i[3]||"",a=n.exec(o),[s,a[1],a[2],a[3]]);if(!u||4!==u.length)throw new TypeError("Invalid path '"+e+"'");return{root:u[0],dir:u[0]+u[1].slice(0,-1),base:u[2],ext:u[3],name:u[2].slice(0,u[2].length-u[3].length)}};var s=/^(\/?|)([\s\S]*?)((?:\.{1,2}|[^\/]+?|)(\.[^.\/]*|))(?:[\/]*)$/,o={};o.parse=function(e){if("string"!=typeof e)throw new TypeError("Parameter 'pathString' must be a string, not "+typeof e);var t,r=(t=e,s.exec(t).slice(1));if(!r||4!==r.length)throw new TypeError("Invalid path '"+e+"'");return r[1]=r[1]||"",r[2]=r[2]||"",r[3]=r[3]||"",{root:r[0],dir:r[0]+r[1].slice(0,-1),base:r[2],ext:r[3],name:r[2].slice(0,r[2].length-r[3].length)}},e.exports=t?i.parse:o.parse,e.exports.posix=o.parse,e.exports.win32=i.parse}),pathParse_1=pathParse.posix,pathParse_2=pathParse.win32,parse$2=path$2__default.parse||pathParse,getNodeModulesDirs=function(e,t){var r="/";/^([A-Za-z]:)/.test(e)?r="":/^\\\\/.test(e)&&(r="\\\\");for(var n=[e],i=parse$2(e);i.dir!==n[n.length-1];)n.push(i.dir),i=parse$2(i.dir);return n.reduce(function(e,n){return e.concat(t.map(function(e){return path$2__default.join(r,n,e)}))},[])},nodeModulesPaths=function(e,t,r){var n=t&&t.moduleDirectory?[].concat(t.moduleDirectory):["node_modules"];if(t&&"function"==typeof t.paths)return t.paths(r,e,function(){return getNodeModulesDirs(e,n)},t);var i=getNodeModulesDirs(e,n);return t&&t.paths?i.concat(t.paths):i},normalizeOptions=function(e,t){return t||{}},defaultIsFile=function(e,t){fs$2__default.stat(e,function(e,r){return e?"ENOENT"===e.code||"ENOTDIR"===e.code?t(null,!1):t(e):t(null,r.isFile()||r.isFIFO())})},async=function(e,t,r){var n=r,i=t;if("function"==typeof t&&(n=i,i={}),"string"!=typeof e){var s=new TypeError("Path must be a string.");return process.nextTick(function(){n(s)})}var o=(i=normalizeOptions(e,i)).isFile||defaultIsFile,a=i.readFile||fs$2__default.readFile,u=i.extensions||[".js"],c=i.basedir||path$2__default.dirname(caller()),p=i.filename||c;i.paths=i.paths||[];var l,h=path$2__default.resolve(c);function f(t){/^(?:\.\.?(?:\/|$)|\/|([A-Za-z]:)?[\/\\])/.test(e)?(l=path$2__default.resolve(t,e),".."!==e&&"/"!==e.slice(-1)||(l+="/"),/\/$/.test(e)&&l===t?g(l,i.package,d):m(l,i.package,d)):function(e,t,r){y(r,nodeModulesPaths(t,i,e))}(e,t,function(t,r,i){if(t)n(t);else if(r)n(null,r,i);else{if(core_1[e])return n(null,e);var s=new Error("Cannot find module '"+e+"' from '"+p+"'");s.code="MODULE_NOT_FOUND",n(s)}})}function d(t,r,i){t?n(t):r?n(null,r,i):g(l,function(t,r,i){if(t)n(t);else if(r)n(null,r,i);else{var s=new Error("Cannot find module '"+e+"' from '"+p+"'");s.code="MODULE_NOT_FOUND",n(s)}})}function m(e,t,r){var n=t,s=r;"function"==typeof n&&(s=n,n=void 0),function e(t,r,n){if(0===t.length)return s(null,void 0,n);var c=r+t[0];var p=n;p?l(null,p):function e(t,r){if(""===t||"/"===t)return r(null);if("win32"===process.platform&&/^\w:[\/\\]*$/.test(t))return r(null);if(/[\/\\]node_modules[\/\\]*$/.test(t))return r(null);var n=path$2__default.join(t,"package.json");o(n,function(s,o){if(!o)return e(path$2__default.dirname(t),r);a(n,function(e,s){e&&r(e);try{var o=JSON.parse(s)}catch(e){}o&&i.packageFilter&&(o=i.packageFilter(o,n)),r(null,o,t)})})}(path$2__default.dirname(c),l);function l(n,a,l){if(p=a,n)return s(n);if(l&&p&&i.pathFilter){var f=path$2__default.relative(l,c),d=f.slice(0,f.length-t[0].length),m=i.pathFilter(p,r,d);if(m)return e([""].concat(u.slice()),path$2__default.resolve(l,m),p)}o(c,h)}function h(n,i){return n?s(n):i?s(null,c,p):void e(t.slice(1),r,p)}}([""].concat(u),e,n)}function g(e,t,r){var n=r,s=t;"function"==typeof s&&(n=s,s=i.package);var u=path$2__default.join(e,"package.json");o(u,function(t,r){return t?n(t):r?void a(u,function(t,r){if(t)return n(t);try{var s=JSON.parse(r)}catch(e){}if(i.packageFilter&&(s=i.packageFilter(s,u)),s.main){if("string"!=typeof s.main){var o=new TypeError("package “"+s.name+"” `main` must be a string");return o.code="INVALID_PACKAGE_MAIN",n(o)}return"."!==s.main&&"./"!==s.main||(s.main="index"),void m(path$2__default.resolve(e,s.main),s,function(t,r,i){return t?n(t):r?n(null,r,i):i?void g(path$2__default.resolve(e,i.main),i,function(t,r,i){return t?n(t):r?n(null,r,i):void m(path$2__default.join(e,"index"),i,n)}):m(path$2__default.join(e,"index"),i,n)})}m(path$2__default.join(e,"/index"),s,n)}):m(path$2__default.join(e,"index"),s,n)})}function y(t,r){if(0===r.length)return t(null,void 0);var n=r[0];function s(e,n,i){return e?t(e):n?t(null,n,i):void y(t,r.slice(1))}m(path$2__default.join(n,e),i.package,function(r,o,a){if(r)return t(r);if(o)return t(null,o,a);g(path$2__default.join(n,e),i.package,s)})}!1===i.preserveSymlinks?fs$2__default.realpath(h,function(e,t){e&&"ENOENT"!==e.code?n(s):f(e?h:t)}):f(h)},defaultIsFile$1=function(e){try{var t=fs$2__default.statSync(e)}catch(e){if(e&&("ENOENT"===e.code||"ENOTDIR"===e.code))return!1;throw e}return t.isFile()||t.isFIFO()},sync$1=function(e,t){if("string"!=typeof e)throw new TypeError("Path must be a string.");var r=normalizeOptions(e,t),n=r.isFile||defaultIsFile$1,i=r.readFileSync||fs$2__default.readFileSync,s=r.extensions||[".js"],o=r.basedir||path$2__default.dirname(caller()),a=r.filename||o;r.paths=r.paths||[];var u=path$2__default.resolve(o);if(!1===r.preserveSymlinks)try{u=fs$2__default.realpathSync(u)}catch(e){if("ENOENT"!==e.code)throw e}if(/^(?:\.\.?(?:\/|$)|\/|([A-Za-z]:)?[\/\\])/.test(e)){var c=path$2__default.resolve(u,e);".."!==e&&"/"!==e.slice(-1)||(c+="/");var p=f(c)||d(c);if(p)return p}else{var l=function(e,t){for(var n=nodeModulesPaths(t,r,e),i=0;i<n.length;i++){var s=n[i],o=f(path$2__default.join(s,"/",e));if(o)return o;var a=d(path$2__default.join(s,"/",e));if(a)return a}}(e,u);if(l)return l}if(core_1[e])return e;var h=new Error("Cannot find module '"+e+"' from '"+a+"'");throw h.code="MODULE_NOT_FOUND",h;function f(e){var t=function e(t){if(""===t||"/"===t)return;if("win32"===process.platform&&/^\w:[\/\\]*$/.test(t))return;if(/[\/\\]node_modules[\/\\]*$/.test(t))return;var s=path$2__default.join(t,"package.json");if(!n(s))return e(path$2__default.dirname(t));var o=i(s);try{var a=JSON.parse(o)}catch(e){}a&&r.packageFilter&&(a=r.packageFilter(a,t));return{pkg:a,dir:t}}(path$2__default.dirname(e));if(t&&t.dir&&t.pkg&&r.pathFilter){var o=path$2__default.relative(t.dir,e),a=r.pathFilter(t.pkg,e,o);a&&(e=path$2__default.resolve(t.dir,a))}if(n(e))return e;for(var u=0;u<s.length;u++){var c=e+s[u];if(n(c))return c}}function d(e){var t=path$2__default.join(e,"/package.json");if(n(t)){try{var s=i(t,"UTF8"),o=JSON.parse(s)}catch(e){}if(r.packageFilter&&(o=r.packageFilter(o,e)),o.main){if("string"!=typeof o.main){var a=new TypeError("package “"+o.name+"” `main` must be a string");throw a.code="INVALID_PACKAGE_MAIN",a}"."!==o.main&&"./"!==o.main||(o.main="index");try{var u=f(path$2__default.resolve(e,o.main));if(u)return u;var c=d(path$2__default.resolve(e,o.main));if(c)return c}catch(e){}}}return f(path$2__default.join(e,"/index"))}},resolve$1=createCommonjsModule(function(e,t){(t=e.exports=async).core=core_1,t.isCore=function(e){return core_1[e]},t.sync=sync$1}),resolve_1=resolve$1.core,resolve_2=resolve$1.isCore,resolve_3=resolve$1.sync;function walk(e,t){visit$1(e,null,t.enter,t.leave)}var shouldSkip=!1,context={skip:function(){return shouldSkip=!0}},childKeys={},toString$b=Object.prototype.toString;function isArray$3(e){return"[object Array]"===toString$b.call(e)}function visit$1(e,t,r,n,i,s){if(e){if(r){var o=shouldSkip;shouldSkip=!1,r.call(context,e,t,i,s);var a=shouldSkip;if(shouldSkip=o,a)return}for(var u=childKeys[e.type]||(childKeys[e.type]=Object.keys(e).filter(function(t){return"object"==typeof e[t]})),c=0;c<u.length;c+=1){var p=u[c],l=e[p];if(isArray$3(l))for(var h=0;h<l.length;h+=1)visit$1(l[h],e,r,n,p,h);else l&&l.type&&visit$1(l,e,r,n,p,null)}n&&n(e,t,i,s)}}var filenameRegex=function(){return/([^\\\/]+)$/},arrFlatten$1=function(e){return flat$1(e,[])};function flat$1(e,t){for(var r,n=0,i=e.length;n<i;n++)r=e[n],Array.isArray(r)?flat$1(r,t):t.push(r);return t}var slice$1=[].slice;function diff(e,t){var r=arguments.length,n=e.length,i=-1,s=[];if(1===r)return e;for(r>2&&(t=arrFlatten$1(slice$1.call(arguments,1)));++i<n;)~t.indexOf(e[i])||s.push(e[i]);return s}var arrDiff$1=diff,arrayUnique$1=function(e){if(!Array.isArray(e))throw new TypeError("array-unique expects an array.");for(var t=e.length,r=-1;r++<t;)for(var n=r+1;n<e.length;++n)e[r]===e[n]&&e.splice(n--,1);return e},toString$c={}.toString,isarray$1=Array.isArray||function(e){return"[object Array]"==toString$c.call(e)},isobject$2=function(e){return null!=e&&"object"==typeof e&&!1===isarray$1(e)},isBuffer_1$1=function(e){return null!=e&&(isBuffer$3(e)||isSlowBuffer$1(e)||!!e._isBuffer)};function isBuffer$3(e){return!!e.constructor&&"function"==typeof e.constructor.isBuffer&&e.constructor.isBuffer(e)}function isSlowBuffer$1(e){return"function"==typeof e.readFloatLE&&"function"==typeof e.slice&&isBuffer$3(e.slice(0,0))}var toString$d=Object.prototype.toString,kindOf$8=function(e){if(void 0===e)return"undefined";if(null===e)return"null";if(!0===e||!1===e||e instanceof Boolean)return"boolean";if("string"==typeof e||e instanceof String)return"string";if("number"==typeof e||e instanceof Number)return"number";if("function"==typeof e||e instanceof Function)return"function";if(void 0!==Array.isArray&&Array.isArray(e))return"array";if(e instanceof RegExp)return"regexp";if(e instanceof Date)return"date";var t=toString$d.call(e);return"[object RegExp]"===t?"regexp":"[object Date]"===t?"date":"[object Arguments]"===t?"arguments":"[object Error]"===t?"error":isBuffer_1$1(e)?"buffer":"[object Set]"===t?"set":"[object WeakSet]"===t?"weakset":"[object Map]"===t?"map":"[object WeakMap]"===t?"weakmap":"[object Symbol]"===t?"symbol":"[object Int8Array]"===t?"int8array":"[object Uint8Array]"===t?"uint8array":"[object Uint8ClampedArray]"===t?"uint8clampedarray":"[object Int16Array]"===t?"int16array":"[object Uint16Array]"===t?"uint16array":"[object Int32Array]"===t?"int32array":"[object Uint32Array]"===t?"uint32array":"[object Float32Array]"===t?"float32array":"[object Float64Array]"===t?"float64array":"object"},isNumber$1=function(e){var t=kindOf$8(e);if("number"!==t&&"string"!==t)return!1;var r=+e;return r-r+1>=0&&""!==e},isNumber$2=function(e){var t=typeof e;if("string"===t||e instanceof String){if(!e.trim())return!1}else if("number"!==t&&!(e instanceof Number))return!1;return e-e+1>=0},toString$e=Object.prototype.toString,kindOf$9=function(e){if(void 0===e)return"undefined";if(null===e)return"null";var t=typeof e;if("boolean"===t)return"boolean";if("string"===t)return"string";if("number"===t)return"number";if("symbol"===t)return"symbol";if("function"===t)return isGeneratorFn$1(e)?"generatorfunction":"function";if(isArray$4(e))return"array";if(isBuffer$4(e))return"buffer";if(isArguments$1(e))return"arguments";if(isDate$1(e))return"date";if(isError$1(e))return"error";if(isRegexp$1(e))return"regexp";switch(ctorName$1(e)){case"Symbol":return"symbol";case"Promise":return"promise";case"WeakMap":return"weakmap";case"WeakSet":return"weakset";case"Map":return"map";case"Set":return"set";case"Int8Array":return"int8array";case"Uint8Array":return"uint8array";case"Uint8ClampedArray":return"uint8clampedarray";case"Int16Array":return"int16array";case"Uint16Array":return"uint16array";case"Int32Array":return"int32array";case"Uint32Array":return"uint32array";case"Float32Array":return"float32array";case"Float64Array":return"float64array"}if(isGeneratorObj$1(e))return"generator";switch(t=toString$e.call(e)){case"[object Object]":return"object";case"[object Map Iterator]":return"mapiterator";case"[object Set Iterator]":return"setiterator";case"[object String Iterator]":return"stringiterator";case"[object Array Iterator]":return"arrayiterator"}return t.slice(8,-1).toLowerCase().replace(/\s/g,"")};function ctorName$1(e){return e.constructor?e.constructor.name:null}function isArray$4(e){return Array.isArray?Array.isArray(e):e instanceof Array}function isError$1(e){return e instanceof Error||"string"==typeof e.message&&e.constructor&&"number"==typeof e.constructor.stackTraceLimit}function isDate$1(e){return e instanceof Date||"function"==typeof e.toDateString&&"function"==typeof e.getDate&&"function"==typeof e.setDate}function isRegexp$1(e){return e instanceof RegExp||"string"==typeof e.flags&&"boolean"==typeof e.ignoreCase&&"boolean"==typeof e.multiline&&"boolean"==typeof e.global}function isGeneratorFn$1(e,t){return"GeneratorFunction"===ctorName$1(e)}function isGeneratorObj$1(e){return"function"==typeof e.throw&&"function"==typeof e.return&&"function"==typeof e.next}function isArguments$1(e){try{if("number"==typeof e.length&&"function"==typeof e.callee)return!0}catch(e){if(-1!==e.message.indexOf("callee"))return!0}return!1}function isBuffer$4(e){return!(!e.constructor||"function"!=typeof e.constructor.isBuffer)&&e.constructor.isBuffer(e)}var max=Math.pow(2,32),node$1=random,cryptographic=!0;function random(){return crypto$1__default.randomBytes(4).readUInt32BE(0)/max}node$1.cryptographic=cryptographic;var randomatic_1=randomatic,isCrypto=!!node$1.cryptographic,type={lower:"abcdefghijklmnopqrstuvwxyz",upper:"ABCDEFGHIJKLMNOPQRSTUVWXYZ",number:"0123456789",special:"~!@#$%^&()_+-={}[];',."};function randomatic(e,t,r){if(void 0===e)throw new Error("randomatic expects a string or number.");var n=!1;1===arguments.length&&("string"==typeof e?t=e.length:isNumber$2(e)&&(r={},t=e,e="*")),"object"===kindOf$9(t)&&t.hasOwnProperty("chars")&&(t=(e=(r=t).chars).length,n=!0);var i=r||{},s="",o="";if(-1!==e.indexOf("?")&&(s+=i.chars),-1!==e.indexOf("a")&&(s+=type.lower),-1!==e.indexOf("A")&&(s+=type.upper),-1!==e.indexOf("0")&&(s+=type.number),-1!==e.indexOf("!")&&(s+=type.special),-1!==e.indexOf("*")&&(s+=type.all),n&&(s+=e),i.exclude){var a="string"===kindOf$9(i.exclude)?i.exclude:i.exclude.join("");a=a.replace(new RegExp("[\\]]+","g"),""),s=s.replace(new RegExp("["+a+"]+","g"),""),-1!==i.exclude.indexOf("]")&&(s=s.replace(new RegExp("[\\]]+","g"),""))}for(;t--;)o+=s.charAt(parseInt(node$1()*s.length,10));return o}type.all=type.lower+type.upper+type.number+type.special,randomatic_1.isCrypto=isCrypto;var cache$3,res$1="",repeatString$1=repeat$1;function repeat$1(e,t){if("string"!=typeof e)throw new TypeError("expected a string");if(1===t)return e;if(2===t)return e+e;var r=e.length*t;if(cache$3!==e||void 0===cache$3)cache$3=e,res$1="";else if(res$1.length>=r)return res$1.substr(0,r);for(;r>res$1.length&&t>1;)1&t&&(res$1+=e),t>>=1,e+=e;return res$1=(res$1+=e).substr(0,r)}var repeatElement$1=function(e,t){for(var r=new Array(t),n=0;n<t;n++)r[n]=e;return r},fillRange_1$1=fillRange$1;function fillRange$1(e,t,r,n,i){if(null==e||null==t)throw new Error("fill-range expects the first and second args to be strings.");"function"==typeof r&&(i=r,n={},r=null),"function"==typeof n&&(i=n,n={}),isobject$2(r)&&(n=r,r="");var s,o=!1,a="",u=n||{};void 0===u.silent&&(u.silent=!0),r=r||u.step;var c=e,p=t;if(t="-0"===t.toString()?0:t,(u.optimize||u.makeRe)&&(r=r?r+="~":r,s=!0,o=!0,a="~"),"string"==typeof r){var l=stepRe().exec(r);if(l){var h=l.index,f=l[0];if("+"===f)return repeatElement$1(e,t);if("?"===f)return[randomatic_1(e,t)];">"===f?(r=r.substr(0,h)+r.substr(h+1),s=!0):"|"===f?(r=r.substr(0,h)+r.substr(h+1),s=!0,o=!0,a=f):"~"===f&&(r=r.substr(0,h)+r.substr(h+1),s=!0,o=!0,a=f)}else if(!isNumber$1(r)){if(!u.silent)throw new TypeError("fill-range: invalid step.");return null}}if(/[.&*()[\]^%$#@!]/.test(e)||/[.&*()[\]^%$#@!]/.test(t)){if(!u.silent)throw new RangeError("fill-range: invalid range arguments.");return null}if(!noAlphaNum(e)||!noAlphaNum(t)||hasBoth(e)||hasBoth(t)){if(!u.silent)throw new RangeError("fill-range: invalid range arguments.");return null}var d=isNumber$1(zeros$1(e)),m=isNumber$1(zeros$1(t));if(!d&&m||d&&!m){if(!u.silent)throw new TypeError("fill-range: first range argument is incompatible with second.");return null}var g=d,y=formatStep(r);g?(e=+e,t=+t):(e=e.charCodeAt(0),t=t.charCodeAt(0));var v=e>t;(e<0||t<0)&&(s=!1,o=!1);var _,b,E=isPadded$2(c,p),x=[],S=0;if(o&&shouldExpand(e,t,y,g,E,u))return"|"!==a&&"~"!==a||(a=detectSeparator(e,t,y,g,v)),wrap$1([c,p],a,u);for(;v?e>=t:e<=t;)E&&g&&(b=E(e)),null!==(_="function"==typeof i?i(e,g,b,S++):g?formatPadding(e,b):o&&isInvalidChar(e)?null:String.fromCharCode(e))&&x.push(_),v?e-=y:e+=y;return!o&&!s||u.noexpand?x:("|"!==a&&"~"!==a||(a=detectSeparator(e,t,y,g,v)),1===x.length||e<0||t<0?x:wrap$1(x,a,u))}function wrap$1(e,t,r){"~"===t&&(t="-");var n=e.join(t),i=r&&r.regexPrefix;return"|"===t&&(n="("+(n=i?i+n:n)+")"),"-"===t&&(n="["+(n=i&&"^"===i?i+n:n)+"]"),[n]}function isCharClass(e,t,r,n,i){return!i&&(n?e<=9&&t<=9:e<t&&1===r)}function shouldExpand(e,t,r,n,i,s){return(!n||!(e>9||t>9))&&(!i&&1===r&&e<t)}function detectSeparator(e,t,r,n,i){return isCharClass(e,t,r,n,i)?"~":"|"}function formatStep(e){return Math.abs(e>>0)||1}function formatPadding(e,t){var r=t?t+e:e;return t&&"-"===e.toString().charAt(0)&&(r="-"+t+e.toString().substr(1)),r.toString()}function isInvalidChar(e){var t=toStr(e);return"\\"===t||"["===t||"]"===t||"^"===t||"("===t||")"===t||"`"===t}function toStr(e){return String.fromCharCode(e)}function stepRe(){return/\?|>|\||\+|\~/g}function noAlphaNum(e){return/[a-z0-9]/i.test(e)}function hasBoth(e){return/[a-z][0-9]|[0-9][a-z]/i.test(e)}function zeros$1(e){return/^-*0+$/.test(e.toString())?"0":e}function hasZeros(e){return/[^.]\.|^-*0+[0-9]/.test(e)}function isPadded$2(e,t){if(hasZeros(e)||hasZeros(t)){var r=length(e),n=length(t),i=r>=n?r:n;return function(e){return repeatString$1("0",i-length(e))}}return!1}function length(e){return e.toString().length}var expandRange=function(e,t,r){if("string"!=typeof e)throw new TypeError("expand-range expects a string.");"function"==typeof t&&(r=t,t={}),"boolean"==typeof t&&((t={}).makeRe=!0);var n=t||{},i=e.split(".."),s=i.length;return s>3?e:1===s?i:("boolean"==typeof r&&!0===r&&(n.makeRe=!0),i.push(n),fillRange_1$1.apply(null,i.concat(r)))},before=function(e,t){return e.replace(t,function(e){var t=randomize();return cache$6[t]=e,"__ID"+t+"__"})},after=function(e){return e.replace(/__ID(.{5})__/g,function(e,t){return cache$6[t]})};function randomize(){return Math.random().toString().slice(2,7)}var braceRe,patternRe,cache$6={},preserve={before:before,after:after},braces_1=function(e,t){if("string"!=typeof e)throw new Error("braces expects a string");return braces(e,t)};function braces(e,t,r){if(""===e)return[];Array.isArray(t)||(r=t,t=[]);var n=r||{};t=t||[],void 0===n.nodupes&&(n.nodupes=!0);var i,s=n.fn;switch("function"==typeof n&&(s=n,n={}),patternRe instanceof RegExp||(patternRe=patternRegex()),(e.match(patternRe)||[])[0]){case"\\,":return escapeCommas(e,t,n);case"\\.":return escapeDots(e,t,n);case"/.":return escapePaths(e,t,n);case" ":return splitWhitespace(e);case"{,}":return exponential(e,n,braces);case"{}":return emptyBraces(e,t,n);case"\\{":case"\\}":return escapeBraces$1(e,t,n);case"${":if(!/\{[^{]+\{/.test(e))return t.concat(e);i=!0,e=preserve.before(e,es6Regex())}braceRe instanceof RegExp||(braceRe=braceRegex());var o=braceRe.exec(e);if(null==o)return[e];var a,u,c=o[1],p=o[2];if(""===p)return[e];if(-1!==p.indexOf(".."))u=(a=expandRange(p,n,s)||p.split(",")).length;else{if('"'===p[0]||"'"===p[0])return t.concat(e.split(/['"]/).join(""));if(a=p.split(","),n.makeRe)return braces(e.replace(c,wrap$2(a,"|")),n);1===(u=a.length)&&n.bash&&(a[0]=wrap$2(a[0],"\\"))}for(var l,h=a.length,f=0;h--;){var d=a[f++];if(/(\.[^.\/])/.test(d))return u>1?a:[e];if(l=splice(e,c,d),/\{[^{}]+?\}/.test(l))t=braces(l,t,n);else if(""!==l){if(n.nodupes&&-1!==t.indexOf(l))continue;t.push(i?preserve.after(l):l)}}return n.strict?filter$2(t,filterEmpty):t}function exponential(e,t,r){"function"==typeof t&&(r=t,t=null);var n,i,s=t||{},o="__ESC_EXP__",a=e.split("{,}");if(s.nodupes)return r(a.join(""),s);n=a.length-1;for(var u=(i=r(a.join(o),s)).length,c=[],p=0;u--;){var l=i[p++];if(-1===l.indexOf(o))c.push(l);else if((l=l.split("__ESC_EXP__").join(""))&&!1!==s.nodupes)c.push(l);else{var h=Math.pow(2,n);c.push.apply(c,repeatElement$1(l,h))}}return c}function wrap$2(e,t){return"|"===t?"("+e.join(t)+")":","===t?"{"+e.join(t)+"}":"-"===t?"["+e.join(t)+"]":"\\"===t?"\\{"+e+"\\}":void 0}function emptyBraces(e,t,r){return braces(e.split("{}").join("\\{\\}"),t,r)}function filterEmpty(e){return!!e&&"\\"!==e}function splitWhitespace(e){for(var t=e.split(" "),r=t.length,n=[],i=0;r--;)n.push.apply(n,braces(t[i++]));return n}function escapeBraces$1(e,t,r){return/\{[^{]+\{/.test(e)?map(braces(e=(e=e.split("\\{").join("__LT_BRACE__")).split("\\}").join("__RT_BRACE__"),t,r),function(e){return(e=e.split("__LT_BRACE__").join("{")).split("__RT_BRACE__").join("}")}):t.concat(e.split("\\").join(""))}function escapeDots(e,t,r){return/[^\\]\..+\\\./.test(e)?map(braces(e=e.split("\\.").join("__ESC_DOT__"),t,r),function(e){return e.split("__ESC_DOT__").join(".")}):t.concat(e.split("\\").join(""))}function escapePaths(e,t,r){return map(braces(e=e.split("/.").join("__ESC_PATH__"),t,r),function(e){return e.split("__ESC_PATH__").join("/.")})}function escapeCommas(e,t,r){return/\w,/.test(e)?map(braces(e=e.split("\\,").join("__ESC_COMMA__"),t,r),function(e){return e.split("__ESC_COMMA__").join(",")}):t.concat(e.split("\\").join(""))}function patternRegex(){return/\${|( (?=[{,}])|(?=[{,}]) )|{}|{,}|\\,(?=.*[{}])|\/\.(?=.*[{}])|\\\.(?={)|\\{|\\}/}function braceRegex(){return/.*(\\?\{([^}]+)\})/}function es6Regex(){return/\$\{([^}]+)\}/}function splice(e,t,r){var n=e.indexOf(t);return e.substr(0,n)+r+e.substr(n+t.length)}function map(e,t){if(null==e)return[];for(var r=e.length,n=new Array(r),i=-1;++i<r;)n[i]=t(e[i],i,e);return n}function filter$2(e,t){if(null==e)return[];if("function"!=typeof t)throw new TypeError("braces: filter expects a callback function.");for(var r=e.length,n=e.slice(),i=0;r--;)t(e[r],i++)||n.splice(r,1);return n}var isPosixBracket=function(e){return"string"==typeof e&&/\[([:.=+])(?:[^\[\]]|)+\1\]/.test(e)},POSIX={alnum:"a-zA-Z0-9",alpha:"a-zA-Z",blank:" \\t",cntrl:"\\x00-\\x1F\\x7F",digit:"0-9",graph:"\\x21-\\x7E",lower:"a-z",print:"\\x20-\\x7E",punct:"-!\"#$%&'()\\*+,./:;<=>?@[\\]^_`{|}~",space:" \\t\\r\\n\\v\\f",upper:"A-Z",word:"A-Za-z0-9_",xdigit:"A-Fa-f0-9"},expandBrackets$1=brackets$1;function brackets$1(e){if(!isPosixBracket(e))return e;var t=!1;-1!==e.indexOf("[^")&&(t=!0,e=e.split("[^").join("[")),-1!==e.indexOf("[!")&&(t=!0,e=e.split("[!").join("["));for(var r=e.split("["),n=e.split("]"),i=r.length!==n.length,s=e.split(/(?::\]\[:|\[?\[:|:\]\]?)/),o=s.length,a=0,u="",c="",p=[];o--;){var l=s[a++];"^[!"!==l&&"[!"!==l||(l="",t=!0);var h=t?"^":"",f=POSIX[l];f?p.push("["+h+f+"]"):l&&(/^\[?\w-\w\]?$/.test(l)?a===s.length?p.push("["+h+l):1===a?p.push(h+l+"]"):p.push(h+l):1===a?c+=l:a===s.length?u+=l:p.push("["+h+l+"]"))}var d=p.join("|"),m=p.length||1;return m>1&&(d="(?:"+d+")",m=1),c&&(m++,"["===c.charAt(0)&&(i?c="\\["+c.slice(1):c+="]"),d=c+d),u&&(m++,"]"===u.slice(-1)&&(u=i?u.slice(0,u.length-1)+"\\]":"["+u),d+=u),m>1&&(-1===(d=d.split("][").join("]|[")).indexOf("|")||/\(\?/.test(d)||(d="(?:"+d+")")),d=d.replace(/\[+=|=\]+/g,"\\b")}brackets$1.makeRe=function(e){try{return new RegExp(brackets$1(e))}catch(e){}},brackets$1.isMatch=function(e,t){try{return brackets$1.makeRe(t).test(e)}catch(e){return!1}},brackets$1.match=function(e,t){for(var r=e.length,n=0,i=e.slice(),s=brackets$1.makeRe(t);n<r;){var o=e[n++];s.test(o)&&i.splice(n,1)}return i};var re$1,isExtglob=function(e){return"string"==typeof e&&/[@?!+*]\(/.test(e)},cache$7={},extglob_1=extglob$2;function extglob$2(e,t){t=t||{};var r,n={},i=0,s=(e=(e=e.replace(/!\(([^\w*()])/g,"$1!(")).replace(/([*\/])\.!\([*]\)/g,function(e,t){return escape("/"===t?"\\/[^.]+":"[^.]+")}))+String(!!t.regex)+String(!!t.contains)+String(!!t.escape);if(cache$7.hasOwnProperty(s))return cache$7[s];for(re$1 instanceof RegExp||(re$1=regex()),t.negate=!1;r=re$1.exec(e);){var o=r[1],a=r[3];"!"===o&&(t.negate=!0);var u="__EXTGLOB_"+i+++"__";n[u]=wrap$3(a,o,t.escape),e=e.split(r[0]).join(u)}for(var c=Object.keys(n),p=c.length;p--;){var l=c[p];e=e.split(l).join(n[l])}var h=t.regex?toRegex$2(e,t.contains,t.negate):e;return h=h.split(".").join("\\."),cache$7[s]=h}function wrap$3(e,t,r){switch(r&&(e=escape(e)),t){case"!":return"(?!"+e+")[^/]"+(r?"%%%~":"*?");case"@":return"(?:"+e+")";case"+":return"(?:"+e+")+";case"*":return"(?:"+e+")"+(r?"%%":"*");case"?":return"(?:"+e+"|)";default:return e}}function escape(e){return e=(e=e.split("*").join("[^/]%%%~")).split(".").join("\\.")}function regex(){return/(\\?[@?!+*$]\\?)(\(([^()]*?)\))/}function negate(e){return"(?!^"+e+").*$"}function toRegex$2(e,t,r){var n=t?"^":"";return e="(?:"+e+")"+(t?"$":""),r&&(e=n+negate(e)),new RegExp(n+e)}var isGlob=function(e){return"string"==typeof e&&(/[*!?{}(|)[\]]/.test(e)||isExtglob(e))},toString$f=Object.prototype.toString,kindOf$a=function(e){if(void 0===e)return"undefined";if(null===e)return"null";if(!0===e||!1===e||e instanceof Boolean)return"boolean";if("string"==typeof e||e instanceof String)return"string";if("number"==typeof e||e instanceof Number)return"number";if("function"==typeof e||e instanceof Function)return"function";if(void 0!==Array.isArray&&Array.isArray(e))return"array";if(e instanceof RegExp)return"regexp";if(e instanceof Date)return"date";var t=toString$f.call(e);return"[object RegExp]"===t?"regexp":"[object Date]"===t?"date":"[object Arguments]"===t?"arguments":"[object Error]"===t?"error":isBuffer_1$1(e)?"buffer":"[object Set]"===t?"set":"[object WeakSet]"===t?"weakset":"[object Map]"===t?"map":"[object WeakMap]"===t?"weakmap":"[object Symbol]"===t?"symbol":"[object Int8Array]"===t?"int8array":"[object Uint8Array]"===t?"uint8array":"[object Uint8ClampedArray]"===t?"uint8clampedarray":"[object Int16Array]"===t?"int16array":"[object Uint16Array]"===t?"uint16array":"[object Int32Array]"===t?"int32array":"[object Uint32Array]"===t?"uint32array":"[object Float32Array]"===t?"float32array":"[object Float64Array]"===t?"float64array":"object"},isWin="win32"===process.platform,removeTrailingSeparator=function(e){var t=e.length-1;if(t<2)return e;for(;isSeparator(e,t);)t--;return e.substr(0,t+1)};function isSeparator(e,t){var r=e[t];return t>0&&("/"===r||isWin&&"\\"===r)}var normalizePath$1=function(e,t){if("string"!=typeof e)throw new TypeError("expected a string");return e=e.replace(/[\\\/]+/g,"/"),!1!==t&&(e=removeTrailingSeparator(e)),e},isExtendable$3=function(e){return null!=e&&("object"==typeof e||"function"==typeof e)},forIn$1=function(e,t,r){for(var n in e)if(!1===t.call(r,e[n],n,e))break},hasOwn$9=Object.prototype.hasOwnProperty,forOwn=function(e,t,r){forIn$1(e,function(n,i){if(hasOwn$9.call(e,i))return t.call(r,e[i],i,e)})},object_omit=function(e,t){if(!isExtendable$3(e))return{};var r,n=(t=[].concat.apply([],[].slice.call(arguments,1)))[t.length-1],i={};"function"==typeof n&&(r=t.pop());var s="function"==typeof r;return t.length||s?(forOwn(e,function(n,o){-1===t.indexOf(o)&&(s?r(n,o,e)&&(i[o]=n):i[o]=n)}),i):e},isExtglob$1=function(e){return"string"==typeof e&&/[@?!+*]\(/.test(e)},isGlob$1=function(e){return"string"==typeof e&&(/[*!?{}(|)[\]]/.test(e)||isExtglob$1(e))},isExtglob$2=function(e){return"string"==typeof e&&/[@?!+*]\(/.test(e)},isGlob$2=function(e){return"string"==typeof e&&(/[*!?{}(|)[\]]/.test(e)||isExtglob$2(e))},globParent=function(e){e+="a";do{e=path$2__default.dirname(e)}while(isGlob$2(e));return e},globBase=function(e){if("string"!=typeof e)throw new TypeError("glob-base expects a string.");var t={};return t.base=globParent(e),t.isGlob=isGlob$2(e),"."!==t.base?(t.glob=e.substr(t.base.length),"/"===t.glob.charAt(0)&&(t.glob=t.glob.substr(1))):t.glob=e,t.isGlob||(t.base=dirname(e),t.glob="."!==t.base?e.substr(t.base.length):e),"./"===t.glob.substr(0,2)&&(t.glob=t.glob.substr(2)),"/"===t.glob.charAt(0)&&(t.glob=t.glob.substr(1)),t};function dirname(e){return"/"===e.slice(-1)?e:path$2__default.dirname(e)}var isDotfile=function(e){if(46===e.charCodeAt(0)&&-1===e.indexOf("/",1))return!0;var t=e.lastIndexOf("/");return-1!==t&&46===e.charCodeAt(t+1)},parseGlob=createCommonjsModule(function(e){var t=e.exports.cache={};function r(e,t,r){return e&&-1!==t.indexOf(r)}function n(e){return e=(e=e.split("__SLASH__").join("/")).split("__DOT__").join(".")}e.exports=function(e){if(t.hasOwnProperty(e))return t[e];var i={};i.orig=e,i.is={},e=e.replace(/\{([^{}]*?)}|\(([^()]*?)\)|\[([^\[\]]*?)\]/g,function(e,t,r,n){var i=t||r||n;return i?e.split(i).join(i.split("/").join("__SLASH__").split(".").join("__DOT__")):e});var s=globBase(e);i.is.glob=s.isGlob,i.glob=s.glob,i.base=s.base;var o=/([^\/]*)$/.exec(e);i.path={},i.path.dirname="",i.path.basename=o[1]||"",i.path.dirname=e.split(i.path.basename).join("")||"";var a=(i.path.basename||"").split(".")||"";i.path.filename=a[0]||"",i.path.extname=a.slice(1).join(".")||"",i.path.ext="",isGlob$1(i.path.dirname)&&!i.path.basename&&(/\/$/.test(i.glob)||(i.path.basename=i.glob),i.path.dirname=i.base),-1!==e.indexOf("/")||i.is.globstar||(i.path.dirname="",i.path.basename=i.orig);var u=i.path.basename.indexOf(".");if(-1!==u&&(i.path.filename=i.path.basename.slice(0,u),i.path.extname=i.path.basename.slice(u)),"."===i.path.extname.charAt(0)){var c=i.path.extname.split(".");i.path.ext=c[c.length-1]}i.glob=n(i.glob),i.path.dirname=n(i.path.dirname),i.path.basename=n(i.path.basename),i.path.filename=n(i.path.filename),i.path.extname=n(i.path.extname);var p=e&&i.is.glob;return i.is.negated=e&&"!"===e.charAt(0),i.is.extglob=e&&isExtglob$1(e),i.is.braces=r(p,e,"{"),i.is.brackets=r(p,e,"[:"),i.is.globstar=r(p,e,"**"),i.is.dotfile=isDotfile(i.path.basename)||isDotfile(i.path.filename),i.is.dotdir=function(e){if(-1!==e.indexOf("/."))return!0;if("."===e.charAt(0)&&"/"!==e.charAt(1))return!0;return!1}(i.path.dirname),t[e]=i}}),parseGlob_1=parseGlob.cache,isPrimitive=function(e){return null==e||"function"!=typeof e&&"object"!=typeof e},isEqualShallow=function(e,t){if(!e&&!t)return!0;if(!e&&t||e&&!t)return!1;var r,n=0,i=0;for(r in t)if(i++,!isPrimitive(t[r])||!e.hasOwnProperty(r)||e[r]!==t[r])return!1;for(r in e)n++;return n===i},basic={},cache$8={},regexCache_1=regexCache;function regexCache(e,t,r){var n,i,s="_default_";if(!t&&!r)return"function"!=typeof e?e:basic[s]||(basic[s]=e(t));if("string"==typeof t){if(!r)return basic[t]||(basic[t]=e(t));s=t}else r=t;return(i=cache$8[s])&&isEqualShallow(i.opts,r)?i.regex:(memo(s,r,n=e(t,r)),n)}function memo(e,t,r){cache$8[e]={regex:r,opts:t}}var cache_1=cache$8,basic_1=basic;regexCache_1.cache=cache_1,regexCache_1.basic=basic_1;var unesc,temp,utils_1$4=createCommonjsModule(function(e){var t=process&&"win32"===process.platform,r=e.exports;r.diff=arrDiff$1,r.unique=arrayUnique$1,r.braces=braces_1,r.brackets=expandBrackets$1,r.extglob=extglob_1,r.isExtglob=isExtglob,r.isGlob=isGlob,r.typeOf=kindOf$a,r.normalize=normalizePath$1,r.omit=object_omit,r.parseGlob=parseGlob,r.cache=regexCache_1,r.filename=function(e){var t=e.match(filenameRegex());return t&&t[0]},r.isPath=function(e,t){return t=t||{},function(n){var i=r.unixify(n,t);return t.nocase?e.toLowerCase()===i.toLowerCase():e===i}},r.hasPath=function(e,t){return function(n){return-1!==r.unixify(e,t).indexOf(n)}},r.matchPath=function(e,t){return t&&t.contains?r.hasPath(e,t):r.isPath(e,t)},r.hasFilename=function(e){return function(t){var n=r.filename(t);return n&&e.test(n)}},r.arrayify=function(e){return Array.isArray(e)?e:[e]},r.unixify=function(e,n){return n&&!1===n.unixify?e:n&&!0===n.unixify||t||"\\"===path$2__default.sep?r.normalize(e,!1):n&&!0===n.unescape?e?e.toString().replace(/\\(\w)/g,"$1"):"":e},r.escapePath=function(e){return e.replace(/[\\.]/g,"\\$&")},r.unescapeGlob=function(e){return e.replace(/[\\"']/g,"")},r.escapeRe=function(e){return e.replace(/[-[\\$*+?.#^\s{}(|)\]]/g,"\\$&")},e.exports=r}),chars$2={};function reverse(e,t){return Object.keys(e).reduce(function(r,n){var i=t?t+n:n;return r[e[n]]=i,r},{})}chars$2.escapeRegex={"?":/\?/g,"@":/\@/g,"!":/\!/g,"+":/\+/g,"*":/\*/g,"(":/\(/g,")":/\)/g,"[":/\[/g,"]":/\]/g},chars$2.ESC={"?":"__UNESC_QMRK__","@":"__UNESC_AMPE__","!":"__UNESC_EXCL__","+":"__UNESC_PLUS__","*":"__UNESC_STAR__",",":"__UNESC_COMMA__","(":"__UNESC_LTPAREN__",")":"__UNESC_RTPAREN__","[":"__UNESC_LTBRACK__","]":"__UNESC_RTBRACK__"},chars$2.UNESC=unesc||(unesc=reverse(chars$2.ESC,"\\")),chars$2.ESC_TEMP={"?":"__TEMP_QMRK__","@":"__TEMP_AMPE__","!":"__TEMP_EXCL__","*":"__TEMP_STAR__","+":"__TEMP_PLUS__",",":"__TEMP_COMMA__","(":"__TEMP_LTPAREN__",")":"__TEMP_RTPAREN__","[":"__TEMP_LTBRACK__","]":"__TEMP_RTBRACK__"},chars$2.TEMP=temp||(temp=reverse(chars$2.ESC_TEMP));var chars_1=chars$2,glob$1=createCommonjsModule(function(e){var t=e.exports=function e(t,r){if(!(this instanceof e))return new e(t,r);this.options=r||{},this.pattern=t,this.history=[],this.tokens={},this.init(t)};t.prototype.init=function(e){this.orig=e,this.negated=this.isNegated(),this.options.track=this.options.track||!1,this.options.makeRe=!0},t.prototype.track=function(e){this.options.track&&this.history.push({msg:e,pattern:this.pattern})},t.prototype.isNegated=function(){return 33===this.pattern.charCodeAt(0)&&(this.pattern=this.pattern.slice(1),!0)},t.prototype.braces=function(){if(!0!==this.options.nobraces&&!0!==this.options.nobrace){var e=this.pattern.match(/[\{\(\[]/g),t=this.pattern.match(/[\}\)\]]/g);e&&t&&e.length!==t.length&&(this.options.makeRe=!1);var r=utils_1$4.braces(this.pattern,this.options);this.pattern=r.join("|")}},t.prototype.brackets=function(){!0!==this.options.nobrackets&&(this.pattern=utils_1$4.brackets(this.pattern))},t.prototype.extglob=function(){!0!==this.options.noextglob&&utils_1$4.isExtglob(this.pattern)&&(this.pattern=utils_1$4.extglob(this.pattern,{escape:!0}))},t.prototype.parse=function(e){return this.tokens=utils_1$4.parseGlob(e||this.pattern,!0),this.tokens},t.prototype._replace=function(e,t,r){this.track('before (find): "'+e+'" (replace with): "'+t+'"'),r&&(t=t.split("?").join("%~").split("*").join("%%")),this.pattern=e&&t&&"string"==typeof e?this.pattern.split(e).join(t):this.pattern.replace(e,t),this.track("after")},t.prototype.escape=function(e){this.track("before escape: ");this.pattern=e.replace(/["\\](['"]?[^"'\\]['"]?)/g,function(e,t){var r=chars_1.ESC,n=r&&r[t];return n||(/[a-z]/i.test(e)?e.split("\\").join(""):e)}),this.track("after escape: ")},t.prototype.unescape=function(e){this.pattern=e.replace(/__([A-Z]+)_([A-Z]+)__/g,function(e,t){return chars_1[t][e]}),this.pattern=function(e){return e=(e=e.split("%~").join("?")).split("%%").join("*")}(this.pattern)}}),expand_1=expand$2;function expand$2(e,t){if("string"!=typeof e)throw new TypeError("micromatch.expand(): argument should be a string.");var r=new glob$1(e,t||{}),n=r.options;if(!utils_1$4.isGlob(e))return r.pattern=r.pattern.replace(/([\/.])/g,"\\$1"),r;if(r.pattern=r.pattern.replace(/(\+)(?!\()/g,"\\$1"),r.pattern=r.pattern.split("$").join("\\$"),"boolean"!=typeof n.braces&&"boolean"!=typeof n.nobraces&&(n.braces=!0),".*"===r.pattern)return{pattern:"\\."+star$1,tokens:i,options:n};if("*"===r.pattern)return{pattern:oneStar(n.dot),tokens:i,options:n};r.parse();var i=r.tokens;return i.is.negated=n.negated,!0!==n.dotfiles&&!i.is.dotfile||!1===n.dot||(n.dotfiles=!0,n.dot=!0),!0!==n.dotdirs&&!i.is.dotdir||!1===n.dot||(n.dotdirs=!0,n.dot=!0),/[{,]\./.test(r.pattern)&&(n.makeRe=!1,n.dot=!0),!0!==n.nonegate&&(n.negated=r.negated),"."===r.pattern.charAt(0)&&"/"!==r.pattern.charAt(1)&&(r.pattern="\\"+r.pattern),r.track("before braces"),i.is.braces&&r.braces(),r.track("after braces"),r.track("before extglob"),i.is.extglob&&r.extglob(),r.track("after extglob"),r.track("before brackets"),i.is.brackets&&r.brackets(),r.track("after brackets"),r._replace("[!","[^"),r._replace("(?","(%~"),r._replace(/\[\]/,"\\[\\]"),r._replace("/[","/"+(n.dot?dotfiles:nodot)+"[",!0),r._replace("/?","/"+(n.dot?dotfiles:nodot)+"[^/]",!0),r._replace("/.","/(?=.)\\.",!0),r._replace(/^(\w):([\\\/]+?)/gi,"(?=.)$1:$2",!0),-1!==r.pattern.indexOf("[^")&&(r.pattern=negateSlash(r.pattern)),!1!==n.globstar&&"**"===r.pattern?r.pattern=globstar(n.dot):(r.pattern=balance(r.pattern,"[","]"),r.escape(r.pattern),i.is.globstar&&(r.pattern=collapse(r.pattern,"/**"),r.pattern=collapse(r.pattern,"**/"),r._replace("/**/","(?:/"+globstar(n.dot)+"/|/)",!0),r._replace(/\*{2,}/g,"**"),r._replace(/(\w+)\*(?!\/)/g,"$1[^/]*?",!0),r._replace(/\*\*\/\*(\w)/g,globstar(n.dot)+"\\/"+(n.dot?dotfiles:nodot)+"[^/]*?$1",!0),!0!==n.dot&&r._replace(/\*\*\/(.)/g,"(?:**\\/|)$1"),(""!==i.path.dirname||/,\*\*|\*\*,/.test(r.orig))&&r._replace("**",globstar(n.dot),!0)),r._replace(/\/\*$/,"\\/"+oneStar(n.dot),!0),r._replace(/(?!\/)\*$/,star$1,!0),r._replace(/([^\/]+)\*/,"$1"+oneStar(!0),!0),r._replace("*",oneStar(n.dot),!0),r._replace("?.","?\\.",!0),r._replace("?:","?:",!0),r._replace(/\?+/g,function(e){var t=e.length;return 1===t?qmark$1:qmark$1+"{"+t+"}"}),r._replace(/\.([*\w]+)/g,"\\.$1"),r._replace(/\[\^[\\\/]+\]/g,qmark$1),r._replace(/\/+/g,"\\/"),r._replace(/\\{2,}/g,"\\")),r.unescape(r.pattern),r._replace("__UNESC_STAR__","*"),r._replace("?.","?\\."),r._replace("[^\\/]",qmark$1),r.pattern.length>1&&/^[\[?*]/.test(r.pattern)&&(r.pattern=(n.dot?dotfiles:nodot)+r.pattern),r}function collapse(e,t){var r=e.split(t),n=""===r[0],i=""===r[r.length-1];return r=r.filter(Boolean),n&&r.unshift(""),i&&r.push(""),r.join(t)}function negateSlash(e){return e.replace(/\[\^([^\]]*?)\]/g,function(e,t){return-1===t.indexOf("/")&&(t="\\/"+t),"[^"+t+"]"})}function balance(e,t,r){var n=e.split(t);return n.join("").length!==e.split(r).join("").length?(e=n.join("\\"+t)).split(r).join("\\"+r):e}var qmark$1="[^/]",star$1=qmark$1+"*?",nodot="(?!\\.)(?=.)",dotfileGlob="(?:\\/|^)\\.{1,2}($|\\/)",dotfiles="(?!"+dotfileGlob+")(?=.)",twoStarDot$1="(?:(?!"+dotfileGlob+").)*?";function oneStar(e){return e?"(?!"+dotfileGlob+")(?=.)"+star$1:nodot+star$1}function globstar(e){return e?twoStarDot$1:"(?:(?!(?:\\/|^)\\.).)*?"}function micromatch(e,t,r){if(!e||!t)return[];if(void 0===(r=r||{}).cache&&(r.cache=!0),!Array.isArray(t))return match$1(e,t,r);for(var n=t.length,i=0,s=[],o=[];n--;){var a=t[i++];"string"==typeof a&&33===a.charCodeAt(0)?s.push.apply(s,match$1(e,a.slice(1),r)):o.push.apply(o,match$1(e,a,r))}return utils_1$4.diff(o,s)}function match$1(e,t,r){if("string"!==utils_1$4.typeOf(e)&&!Array.isArray(e))throw new Error(msg("match","files","a string or array"));e=utils_1$4.arrayify(e);var n=(r=r||{}).negate||!1,i=t;"string"==typeof t&&((n="!"===t.charAt(0))&&(t=t.slice(1)),!0===r.nonegate&&(n=!1));for(var s=matcher(t,r),o=e.length,a=0,u=[];a<o;){var c=e[a++],p=utils_1$4.unixify(c,r);s(p)&&u.push(p)}if(0===u.length){if(!0===r.failglob)throw new Error('micromatch.match() found no matches for: "'+i+'".');(r.nonull||r.nullglob)&&u.push(utils_1$4.unescapeGlob(i))}return n&&(u=utils_1$4.diff(e,u)),r.ignore&&r.ignore.length&&(t=r.ignore,r=utils_1$4.omit(r,["ignore"]),u=utils_1$4.diff(u,micromatch(u,t,r))),r.nodupes?utils_1$4.unique(u):u}function filter$3(e,t){if(!Array.isArray(e)&&"string"!=typeof e)throw new TypeError(msg("filter","patterns","a string or array"));for(var r=(e=utils_1$4.arrayify(e)).length,n=0,i=Array(r);n<r;)i[n]=matcher(e[n++],t);return function(e){if(null==e)return[];var r=i.length,n=0,s=!0;for(e=utils_1$4.unixify(e,t);n<r;){if(!(0,i[n++])(e)){s=!1;break}}return s}}function isMatch(e,t,r){if("string"!=typeof e)throw new TypeError(msg("isMatch","filepath","a string"));return e=utils_1$4.unixify(e,r),"object"===utils_1$4.typeOf(t)?matcher(e,t):matcher(t,r)(e)}function contains$1(e,t,r){if("string"!=typeof e)throw new TypeError(msg("contains","pattern","a string"));return(r=r||{}).contains=""!==t,e=utils_1$4.unixify(e,r),r.contains&&!utils_1$4.isGlob(t)?-1!==e.indexOf(t):matcher(t,r)(e)}function any(e,t,r){if(!Array.isArray(t)&&"string"!=typeof t)throw new TypeError(msg("any","patterns","a string or array"));var n=(t=utils_1$4.arrayify(t)).length;for(e=utils_1$4.unixify(e,r);n--;){if(matcher(t[n],r)(e))return!0}return!1}function matchKeys(e,t,r){if("object"!==utils_1$4.typeOf(e))throw new TypeError(msg("matchKeys","first argument","an object"));var n=matcher(t,r),i={};for(var s in e)e.hasOwnProperty(s)&&n(s)&&(i[s]=e[s]);return i}function matcher(e,t){if("function"==typeof e)return e;if(e instanceof RegExp)return function(t){return e.test(t)};if("string"!=typeof e)throw new TypeError(msg("matcher","pattern","a string, regex, or function"));if(e=utils_1$4.unixify(e,t),!utils_1$4.isGlob(e))return utils_1$4.matchPath(e,t);var r=makeRe$2(e,t);return t&&t.matchBase?utils_1$4.hasFilename(r,t):function(e){return e=utils_1$4.unixify(e,t),r.test(e)}}function toRegex$3(e,t){var r=Object.create(t||{}),n=r.flags||"";r.nocase&&-1===n.indexOf("i")&&(n+="i");var i,s=expand_1(e,r);r.negated=r.negated||s.negated,r.negate=r.negated,e=wrapGlob(s.pattern,r);try{return i=new RegExp(e,n)}catch(e){if(e.reason="micromatch invalid regex: ("+i+")",r.strict)throw new SyntaxError(e)}return/$^/}function wrapGlob(e,t){var r=t&&!t.contains?"^":"";return e="(?:"+e+")"+(t&&!t.contains?"$":""),t&&t.negate?r+"(?!^"+e+").*$":r+e}function makeRe$2(e,t){if("string"!==utils_1$4.typeOf(e))throw new Error(msg("makeRe","glob","a string"));return utils_1$4.cache(toRegex$3,e,t)}function msg(e,t,r){return"micromatch."+e+"(): "+t+" should be "+r+"."}micromatch.any=any,micromatch.braces=micromatch.braceExpand=utils_1$4.braces,micromatch.contains=contains$1,micromatch.expand=expand_1,micromatch.filter=filter$3,micromatch.isMatch=isMatch,micromatch.makeRe=makeRe$2,micromatch.match=match$1,micromatch.matcher=matcher,micromatch.matchKeys=matchKeys;var micromatch_1=micromatch,blockDeclarations={const:!0,let:!0},extractors$1={Literal:function(e,t){e.push(t.value)},Identifier:function(e,t){e.push(t.name)},ObjectPattern:function(e,t){t.properties.forEach(function(t){"RestElement"===t.type?extractors$1.RestElement(e,t):extractors$1[(t.value||t.key).type](e,t.value||t.key)})},ArrayPattern:function(e,t){t.elements.forEach(function(t){t&&extractors$1[t.type](e,t)})},RestElement:function(e,t){extractors$1[t.argument.type](e,t.argument)},AssignmentPattern:function(e,t){return extractors$1[t.left.type](e,t.left)}};function extractNames$1(e){var t=[];return extractors$1[e.type](t,e),t}var Scope$2=function(e){var t=this;e=e||{},this.parent=e.parent,this.isBlockScope=!!e.block,this.declarations=Object.create(null),e.params&&e.params.forEach(function(e){extractNames$1(e).forEach(function(e){t.declarations[e]=!0})})};function attachScopes(e,t){void 0===t&&(t="scope");var r=new Scope$2;return walk(e,{enter:function(e,n){if(/(Function|Class)Declaration/.test(e.type)&&r.addDeclaration(e,!1,!1),"VariableDeclaration"===e.type){var i=blockDeclarations[e.kind];e.declarations.forEach(function(e){r.addDeclaration(e,i,!0)})}var s;/Function/.test(e.type)&&(s=new Scope$2({parent:r,block:!1,params:e.params}),"FunctionExpression"===e.type&&e.id&&s.addDeclaration(e,!1,!1)),"BlockStatement"!==e.type||/Function/.test(n.type)||(s=new Scope$2({parent:r,block:!0})),"CatchClause"===e.type&&(s=new Scope$2({parent:r,params:[e.param],block:!0})),s&&(Object.defineProperty(e,t,{value:s,configurable:!0}),r=s)},leave:function(e){e[t]&&(r=r.parent)}}),r}function ensureArray(e){return Array.isArray(e)?e:null==e?[]:[e]}function createFilter(e,t){var r=function(e){return isRegexp$2(e)?e:{test:micromatch_1.matcher(path$2.resolve(e).split(path$2.sep).join("/"))}};return e=ensureArray(e).map(r),t=ensureArray(t).map(r),function(r){if("string"!=typeof r)return!1;if(/\0/.test(r))return!1;r=r.split(path$2.sep).join("/");for(var n=0;n<t.length;++n){if(t[n].test(r))return!1}for(var i=0;i<e.length;++i){if(e[i].test(r))return!0}return!e.length}}function isRegexp$2(e){return e instanceof RegExp}Scope$2.prototype.addDeclaration=function(e,t,r){var n=this;!t&&this.isBlockScope?this.parent.addDeclaration(e,t,r):e.id&&extractNames$1(e.id).forEach(function(e){n.declarations[e]=!0})},Scope$2.prototype.contains=function(e){return this.declarations[e]||!!this.parent&&this.parent.contains(e)};var reservedWords$2="break case class catch const continue debugger default delete do else export extends finally for function if import in instanceof let new return super switch this throw try typeof var void while with yield enum await implements package protected static interface private public".split(" "),builtins$2="arguments Infinity NaN undefined null true false eval uneval isFinite isNaN parseFloat parseInt decodeURI decodeURIComponent encodeURI encodeURIComponent escape unescape Object Function Boolean Symbol Error EvalError InternalError RangeError ReferenceError SyntaxError TypeError URIError Number Math Date String RegExp Array Int8Array Uint8Array Uint8ClampedArray Int16Array Uint16Array Int32Array Uint32Array Float32Array Float64Array Map Set WeakMap WeakSet SIMD ArrayBuffer DataView JSON Promise Generator GeneratorFunction Reflect Proxy Intl".split(" "),blacklisted$1=Object.create(null);function makeLegalIdentifier(e){return e=e.replace(/-(\w)/g,function(e,t){return t.toUpperCase()}).replace(/[^$_a-zA-Z0-9]/g,"_"),(/\d/.test(e[0])||blacklisted$1[e])&&(e="_"+e),e}reservedWords$2.concat(builtins$2).forEach(function(e){return blacklisted$1[e]=!0});var chars$3="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";function encode$3(e){for(var t=0,r=0,n=0,i=0,s="",o=0;o<e.length;o++){var a=e[o];if(o>0&&(s+=";"),0!==a.length){for(var u=0,c=[],p=0,l=a;p<l.length;p++){var h=l[p],f=encodeInteger$1(h[0]-u);u=h[0],h.length>1&&(f+=encodeInteger$1(h[1]-t)+encodeInteger$1(h[2]-r)+encodeInteger$1(h[3]-n),t=h[1],r=h[2],n=h[3]),5===h.length&&(f+=encodeInteger$1(h[4]-i),i=h[4]),c.push(f)}s+=c.join(",")}}return s}function encodeInteger$1(e){var t="";e=e<0?-e<<1|1:e<<1;do{var r=31&e;(e>>=5)>0&&(r|=32),t+=chars$3[r]}while(e>0);return t}var Chunk$2=function(e,t,r){this.start=e,this.end=t,this.original=r,this.intro="",this.outro="",this.content=r,this.storeName=!1,this.edited=!1,Object.defineProperties(this,{previous:{writable:!0,value:null},next:{writable:!0,value:null}})};Chunk$2.prototype.appendLeft=function(e){this.outro+=e},Chunk$2.prototype.appendRight=function(e){this.intro=this.intro+e},Chunk$2.prototype.clone=function(){var e=new Chunk$2(this.start,this.end,this.original);return e.intro=this.intro,e.outro=this.outro,e.content=this.content,e.storeName=this.storeName,e.edited=this.edited,e},Chunk$2.prototype.contains=function(e){return this.start<e&&e<this.end},Chunk$2.prototype.eachNext=function(e){for(var t=this;t;)e(t),t=t.next},Chunk$2.prototype.eachPrevious=function(e){for(var t=this;t;)e(t),t=t.previous},Chunk$2.prototype.edit=function(e,t,r){return this.content=e,r||(this.intro="",this.outro=""),this.storeName=t,this.edited=!0,this},Chunk$2.prototype.prependLeft=function(e){this.outro=e+this.outro},Chunk$2.prototype.prependRight=function(e){this.intro=e+this.intro},Chunk$2.prototype.split=function(e){var t=e-this.start,r=this.original.slice(0,t),n=this.original.slice(t);this.original=r;var i=new Chunk$2(e,this.end,n);return i.outro=this.outro,this.outro="",this.end=e,this.edited?(i.edit("",!1),this.content=""):this.content=r,i.next=this.next,i.next&&(i.next.previous=i),i.previous=this,this.next=i,i},Chunk$2.prototype.toString=function(){return this.intro+this.content+this.outro},Chunk$2.prototype.trimEnd=function(e){if(this.outro=this.outro.replace(e,""),this.outro.length)return!0;var t=this.content.replace(e,"");return t.length?(t!==this.content&&this.split(this.start+t.length).edit("",void 0,!0),!0):(this.edit("",void 0,!0),this.intro=this.intro.replace(e,""),!!this.intro.length||void 0)},Chunk$2.prototype.trimStart=function(e){if(this.intro=this.intro.replace(e,""),this.intro.length)return!0;var t=this.content.replace(e,"");return t.length?(t!==this.content&&(this.split(this.end-t.length),this.edit("",void 0,!0)),!0):(this.edit("",void 0,!0),this.outro=this.outro.replace(e,""),!!this.outro.length||void 0)};var btoa$1=function(){throw new Error("Unsupported environment: `window.btoa` or `Buffer` should be supported.")};"undefined"!=typeof window&&"function"==typeof window.btoa?btoa$1=function(e){return window.btoa(unescape(encodeURIComponent(e)))}:"function"==typeof Buffer&&(btoa$1=function(e){return Buffer.from(e,"utf-8").toString("base64")});var SourceMap$2=function(e){this.version=3,this.file=e.file,this.sources=e.sources,this.sourcesContent=e.sourcesContent,this.names=e.names,this.mappings=encode$3(e.mappings)};function guessIndent$1(e){var t=e.split("\n"),r=t.filter(function(e){return/^\t+/.test(e)}),n=t.filter(function(e){return/^ {2,}/.test(e)});if(0===r.length&&0===n.length)return null;if(r.length>=n.length)return"\t";var i=n.reduce(function(e,t){var r=/^ +/.exec(t)[0].length;return Math.min(r,e)},1/0);return new Array(i+1).join(" ")}function getRelativePath$1(e,t){var r=e.split(/[\/\\]/),n=t.split(/[\/\\]/);for(r.pop();r[0]===n[0];)r.shift(),n.shift();if(r.length)for(var i=r.length;i--;)r[i]="..";return r.concat(n).join("/")}SourceMap$2.prototype.toString=function(){return JSON.stringify(this)},SourceMap$2.prototype.toUrl=function(){return"data:application/json;charset=utf-8;base64,"+btoa$1(this.toString())};var toString$g=Object.prototype.toString;function isObject$8(e){return"[object Object]"===toString$g.call(e)}function getLocator$2(e){for(var t=e.split("\n"),r=[],n=0,i=0;n<t.length;n++)r.push(i),i+=t[n].length+1;return function(e){for(var t=0,n=r.length;t<n;){var i=t+n>>1;e<r[i]?n=i:t=i+1}var s=t-1;return{line:s,column:e-r[s]}}}var Mappings$1=function(e){this.hires=e,this.generatedCodeLine=0,this.generatedCodeColumn=0,this.raw=[],this.rawSegments=this.raw[this.generatedCodeLine]=[],this.pending=null};Mappings$1.prototype.addEdit=function(e,t,r,n){if(t.length){var i=[this.generatedCodeColumn,e,r.line,r.column];n>=0&&i.push(n),this.rawSegments.push(i)}else this.pending&&this.rawSegments.push(this.pending);this.advance(t),this.pending=null},Mappings$1.prototype.addUneditedChunk=function(e,t,r,n,i){for(var s=t.start,o=!0;s<t.end;)(this.hires||o||i[s])&&this.rawSegments.push([this.generatedCodeColumn,e,n.line,n.column]),"\n"===r[s]?(n.line+=1,n.column=0,this.generatedCodeLine+=1,this.raw[this.generatedCodeLine]=this.rawSegments=[],this.generatedCodeColumn=0):(n.column+=1,this.generatedCodeColumn+=1),s+=1,o=!1;this.pending=[this.generatedCodeColumn,e,n.line,n.column]},Mappings$1.prototype.advance=function(e){if(e){var t=e.split("\n");if(t.length>1){for(var r=0;r<t.length-1;r++)this.generatedCodeLine++,this.raw[this.generatedCodeLine]=this.rawSegments=[];this.generatedCodeColumn=0}this.generatedCodeColumn+=t[t.length-1].length}};var n$1="\n",warned$1={insertLeft:!1,insertRight:!1,storeName:!1},MagicString$1=function(e,t){void 0===t&&(t={});var r=new Chunk$2(0,e.length,e);Object.defineProperties(this,{original:{writable:!0,value:e},outro:{writable:!0,value:""},intro:{writable:!0,value:""},firstChunk:{writable:!0,value:r},lastChunk:{writable:!0,value:r},lastSearchedChunk:{writable:!0,value:r},byStart:{writable:!0,value:{}},byEnd:{writable:!0,value:{}},filename:{writable:!0,value:t.filename},indentExclusionRanges:{writable:!0,value:t.indentExclusionRanges},sourcemapLocations:{writable:!0,value:{}},storedNames:{writable:!0,value:{}},indentStr:{writable:!0,value:guessIndent$1(e)}}),this.byStart[0]=r,this.byEnd[e.length]=r};MagicString$1.prototype.addSourcemapLocation=function(e){this.sourcemapLocations[e]=!0},MagicString$1.prototype.append=function(e){if("string"!=typeof e)throw new TypeError("outro content must be a string");return this.outro+=e,this},MagicString$1.prototype.appendLeft=function(e,t){if("string"!=typeof t)throw new TypeError("inserted content must be a string");this._split(e);var r=this.byEnd[e];return r?r.appendLeft(t):this.intro+=t,this},MagicString$1.prototype.appendRight=function(e,t){if("string"!=typeof t)throw new TypeError("inserted content must be a string");this._split(e);var r=this.byStart[e];return r?r.appendRight(t):this.outro+=t,this},MagicString$1.prototype.clone=function(){for(var e=new MagicString$1(this.original,{filename:this.filename}),t=this.firstChunk,r=e.firstChunk=e.lastSearchedChunk=t.clone();t;){e.byStart[r.start]=r,e.byEnd[r.end]=r;var n=t.next,i=n&&n.clone();i&&(r.next=i,i.previous=r,r=i),t=n}return e.lastChunk=r,this.indentExclusionRanges&&(e.indentExclusionRanges=this.indentExclusionRanges.slice()),Object.keys(this.sourcemapLocations).forEach(function(t){e.sourcemapLocations[t]=!0}),e},MagicString$1.prototype.generateDecodedMap=function(e){var t=this;e=e||{};var r=Object.keys(this.storedNames),n=new Mappings$1(e.hires),i=getLocator$2(this.original);return this.intro&&n.advance(this.intro),this.firstChunk.eachNext(function(e){var s=i(e.start);e.intro.length&&n.advance(e.intro),e.edited?n.addEdit(0,e.content,s,e.storeName?r.indexOf(e.original):-1):n.addUneditedChunk(0,e,t.original,s,t.sourcemapLocations),e.outro.length&&n.advance(e.outro)}),{file:e.file?e.file.split(/[\/\\]/).pop():null,sources:[e.source?getRelativePath$1(e.file||"",e.source):null],sourcesContent:e.includeContent?[this.original]:[null],names:r,mappings:n.raw}},MagicString$1.prototype.generateMap=function(e){return new SourceMap$2(this.generateDecodedMap(e))},MagicString$1.prototype.getIndentString=function(){return null===this.indentStr?"\t":this.indentStr},MagicString$1.prototype.indent=function(e,t){var r=/^[^\r\n]/gm;if(isObject$8(e)&&(t=e,e=void 0),""===(e=void 0!==e?e:this.indentStr||"\t"))return this;var n={};(t=t||{}).exclude&&("number"==typeof t.exclude[0]?[t.exclude]:t.exclude).forEach(function(e){for(var t=e[0];t<e[1];t+=1)n[t]=!0});var i=!1!==t.indentStart,s=function(t){return i?""+e+t:(i=!0,t)};this.intro=this.intro.replace(r,s);for(var o=0,a=this.firstChunk;a;){var u=a.end;if(a.edited)n[o]||(a.content=a.content.replace(r,s),a.content.length&&(i="\n"===a.content[a.content.length-1]));else for(o=a.start;o<u;){if(!n[o]){var c=this.original[o];"\n"===c?i=!0:"\r"!==c&&i&&(i=!1,o===a.start?a.prependRight(e):(this._splitChunk(a,o),(a=a.next).prependRight(e)))}o+=1}o=a.end,a=a.next}return this.outro=this.outro.replace(r,s),this},MagicString$1.prototype.insert=function(){throw new Error("magicString.insert(...) is deprecated. Use prependRight(...) or appendLeft(...)")},MagicString$1.prototype.insertLeft=function(e,t){return warned$1.insertLeft||(console.warn("magicString.insertLeft(...) is deprecated. Use magicString.appendLeft(...) instead"),warned$1.insertLeft=!0),this.appendLeft(e,t)},MagicString$1.prototype.insertRight=function(e,t){return warned$1.insertRight||(console.warn("magicString.insertRight(...) is deprecated. Use magicString.prependRight(...) instead"),warned$1.insertRight=!0),this.prependRight(e,t)},MagicString$1.prototype.move=function(e,t,r){if(r>=e&&r<=t)throw new Error("Cannot move a selection inside itself");this._split(e),this._split(t),this._split(r);var n=this.byStart[e],i=this.byEnd[t],s=n.previous,o=i.next,a=this.byStart[r];if(!a&&i===this.lastChunk)return this;var u=a?a.previous:this.lastChunk;return s&&(s.next=o),o&&(o.previous=s),u&&(u.next=n),a&&(a.previous=i),n.previous||(this.firstChunk=i.next),i.next||(this.lastChunk=n.previous,this.lastChunk.next=null),n.previous=u,i.next=a||null,u||(this.firstChunk=n),a||(this.lastChunk=i),this},MagicString$1.prototype.overwrite=function(e,t,r,n){if("string"!=typeof r)throw new TypeError("replacement content must be a string");for(;e<0;)e+=this.original.length;for(;t<0;)t+=this.original.length;if(t>this.original.length)throw new Error("end is out of bounds");if(e===t)throw new Error("Cannot overwrite a zero-length range – use appendLeft or prependRight instead");this._split(e),this._split(t),!0===n&&(warned$1.storeName||(console.warn("The final argument to magicString.overwrite(...) should be an options object. See https://github.com/rich-harris/magic-string"),warned$1.storeName=!0),n={storeName:!0});var i=void 0!==n&&n.storeName,s=void 0!==n&&n.contentOnly;if(i){var o=this.original.slice(e,t);this.storedNames[o]=!0}var a=this.byStart[e],u=this.byEnd[t];if(a){if(t>a.end&&a.next!==this.byStart[a.end])throw new Error("Cannot overwrite across a split point");if(a.edit(r,i,s),a!==u){for(var c=a.next;c!==u;)c.edit("",!1),c=c.next;c.edit("",!1)}}else{var p=new Chunk$2(e,t,"").edit(r,i);u.next=p,p.previous=u}return this},MagicString$1.prototype.prepend=function(e){if("string"!=typeof e)throw new TypeError("outro content must be a string");return this.intro=e+this.intro,this},MagicString$1.prototype.prependLeft=function(e,t){if("string"!=typeof t)throw new TypeError("inserted content must be a string");this._split(e);var r=this.byEnd[e];return r?r.prependLeft(t):this.intro=t+this.intro,this},MagicString$1.prototype.prependRight=function(e,t){if("string"!=typeof t)throw new TypeError("inserted content must be a string");this._split(e);var r=this.byStart[e];return r?r.prependRight(t):this.outro=t+this.outro,this},MagicString$1.prototype.remove=function(e,t){for(;e<0;)e+=this.original.length;for(;t<0;)t+=this.original.length;if(e===t)return this;if(e<0||t>this.original.length)throw new Error("Character is out of bounds");if(e>t)throw new Error("end must be greater than start");this._split(e),this._split(t);for(var r=this.byStart[e];r;)r.intro="",r.outro="",r.edit(""),r=t>r.end?this.byStart[r.end]:null;return this},MagicString$1.prototype.lastChar=function(){if(this.outro.length)return this.outro[this.outro.length-1];var e=this.lastChunk;do{if(e.outro.length)return e.outro[e.outro.length-1];if(e.content.length)return e.content[e.content.length-1];if(e.intro.length)return e.intro[e.intro.length-1]}while(e=e.previous);return this.intro.length?this.intro[this.intro.length-1]:""},MagicString$1.prototype.lastLine=function(){var e=this.outro.lastIndexOf(n$1);if(-1!==e)return this.outro.substr(e+1);var t=this.outro,r=this.lastChunk;do{if(r.outro.length>0){if(-1!==(e=r.outro.lastIndexOf(n$1)))return r.outro.substr(e+1)+t;t=r.outro+t}if(r.content.length>0){if(-1!==(e=r.content.lastIndexOf(n$1)))return r.content.substr(e+1)+t;t=r.content+t}if(r.intro.length>0){if(-1!==(e=r.intro.lastIndexOf(n$1)))return r.intro.substr(e+1)+t;t=r.intro+t}}while(r=r.previous);return-1!==(e=this.intro.lastIndexOf(n$1))?this.intro.substr(e+1)+t:this.intro+t},MagicString$1.prototype.slice=function(e,t){for(void 0===e&&(e=0),void 0===t&&(t=this.original.length);e<0;)e+=this.original.length;for(;t<0;)t+=this.original.length;for(var r="",n=this.firstChunk;n&&(n.start>e||n.end<=e);){if(n.start<t&&n.end>=t)return r;n=n.next}if(n&&n.edited&&n.start!==e)throw new Error("Cannot use replaced character "+e+" as slice start anchor.");for(var i=n;n;){!n.intro||i===n&&n.start!==e||(r+=n.intro);var s=n.start<t&&n.end>=t;if(s&&n.edited&&n.end!==t)throw new Error("Cannot use replaced character "+t+" as slice end anchor.");var o=i===n?e-n.start:0,a=s?n.content.length+t-n.end:n.content.length;if(r+=n.content.slice(o,a),!n.outro||s&&n.end!==t||(r+=n.outro),s)break;n=n.next}return r},MagicString$1.prototype.snip=function(e,t){var r=this.clone();return r.remove(0,e),r.remove(t,r.original.length),r},MagicString$1.prototype._split=function(e){if(!this.byStart[e]&&!this.byEnd[e])for(var t=this.lastSearchedChunk,r=e>t.end;t;){if(t.contains(e))return this._splitChunk(t,e);t=r?this.byStart[t.end]:this.byEnd[t.start]}},MagicString$1.prototype._splitChunk=function(e,t){if(e.edited&&e.content.length){var r=getLocator$2(this.original)(t);throw new Error("Cannot split a chunk that has already been edited ("+r.line+":"+r.column+' – "'+e.original+'")')}var n=e.split(t);return this.byEnd[t]=e,this.byStart[t]=n,this.byEnd[n.end]=n,e===this.lastChunk&&(this.lastChunk=n),this.lastSearchedChunk=e,!0},MagicString$1.prototype.toString=function(){for(var e=this.intro,t=this.firstChunk;t;)e+=t.toString(),t=t.next;return e+this.outro},MagicString$1.prototype.isEmpty=function(){var e=this.firstChunk;do{if(e.intro.length&&e.intro.trim()||e.content.length&&e.content.trim()||e.outro.length&&e.outro.trim())return!1}while(e=e.next);return!0},MagicString$1.prototype.length=function(){var e=this.firstChunk,t=0;do{t+=e.intro.length+e.content.length+e.outro.length}while(e=e.next);return t},MagicString$1.prototype.trimLines=function(){return this.trim("[\\r\\n]")},MagicString$1.prototype.trim=function(e){return this.trimStart(e).trimEnd(e)},MagicString$1.prototype.trimEndAborted=function(e){var t=new RegExp((e||"\\s")+"+$");if(this.outro=this.outro.replace(t,""),this.outro.length)return!0;var r=this.lastChunk;do{var n=r.end,i=r.trimEnd(t);if(r.end!==n&&(this.lastChunk===r&&(this.lastChunk=r.next),this.byEnd[r.end]=r,this.byStart[r.next.start]=r.next,this.byEnd[r.next.end]=r.next),i)return!0;r=r.previous}while(r);return!1},MagicString$1.prototype.trimEnd=function(e){return this.trimEndAborted(e),this},MagicString$1.prototype.trimStartAborted=function(e){var t=new RegExp("^"+(e||"\\s")+"+");if(this.intro=this.intro.replace(t,""),this.intro.length)return!0;var r=this.firstChunk;do{var n=r.end,i=r.trimStart(t);if(r.end!==n&&(r===this.lastChunk&&(this.lastChunk=r.next),this.byEnd[r.end]=r,this.byStart[r.next.start]=r.next,this.byEnd[r.next.end]=r.next),i)return!0;r=r.next}while(r);return!1},MagicString$1.prototype.trimStart=function(e){return this.trimStartAborted(e),this};var PROXY_PREFIX="\0commonjs-proxy:",EXTERNAL_PREFIX="\0commonjs-external:",HELPERS_ID="\0commonjsHelpers",HELPERS="\nexport var commonjsGlobal = typeof window !== 'undefined' ? window : typeof global !== 'undefined' ? global : typeof self !== 'undefined' ? self : {};\n\nexport function commonjsRequire () {\n\tthrow new Error('Dynamic requires are not currently supported by rollup-plugin-commonjs');\n}\n\nexport function unwrapExports (x) {\n\treturn x && x.__esModule && Object.prototype.hasOwnProperty.call(x, 'default') ? x.default : x;\n}\n\nexport function createCommonjsModule(fn, module) {\n\treturn module = { exports: {} }, fn(module, module.exports), module.exports;\n}\n\nexport function getCjsExportFromNamespace (n) {\n\treturn n && n.default || n;\n}",isCjsPromises=Object.create(null);function getIsCjsPromise(e){var t=isCjsPromises[e];if(t)return t.promise;var r=new Promise(function(r){isCjsPromises[e]=t={resolve:r,promise:void 0}});return t.promise=r,r}function setIsCjsPromise(e,t){var r=isCjsPromises[e];r?r.resolve&&(r.resolve(t),r.resolve=void 0):isCjsPromises[e]={promise:t,resolve:void 0}}function isFile(e){try{return fs$2.statSync(e).isFile()}catch(e){return!1}}function addJsExtensionIfNecessary$1(e){return isFile(e)?e:isFile(e+=".js")?e:null}var absolutePath$1=/^(?:\/|(?:[A-Za-z]:)?[\\|\/])/;function isAbsolute$1(e){return absolutePath$1.test(e)}function defaultResolver(e,t){return isAbsolute$1(e)?addJsExtensionIfNecessary$1(path$2.resolve(e)):void 0===t?addJsExtensionIfNecessary$1(path$2.resolve(process.cwd(),e)):"."!==e[0]?null:addJsExtensionIfNecessary$1(path$2.resolve(path$2.dirname(t),e))}function getName(e){var t=makeLegalIdentifier(path$2.basename(e,path$2.extname(e)));if("index"!==t)return t;var r=path$2.dirname(e).split(path$2.sep);return makeLegalIdentifier(r[r.length-1])}function first(e){return function(){for(var t=this,r=[],n=arguments.length;n--;)r[n]=arguments[n];return e.reduce(function(e,n){return e.then(function(e){return null!=e?e:Promise.resolve(n.call.apply(n,[t].concat(r)))})},Promise.resolve())}}function getCandidatesForExtension(e,t){return[e+t,e+path$2.sep+"index"+t]}function getCandidates(e,t){return t.reduce(function(t,r){return t.concat(getCandidatesForExtension(e,r))},[e])}function getResolveId(e){var t;function r(e,r){var n=e.startsWith(PROXY_PREFIX);if(n)e=e.slice(PROXY_PREFIX.length);else if(e.startsWith("\0"))return e;return r&&r.startsWith(PROXY_PREFIX)&&(r=r.slice(PROXY_PREFIX.length)),t.call(this,e,r).then(function(t){return t?n?PROXY_PREFIX+t:t:(t=defaultResolver(e,r),n?t?PROXY_PREFIX+t:EXTERNAL_PREFIX+e:t)})}return r.setRollupOptions=function(n){var i=(n.plugins||[]).map(function(t){return t.resolveId===r?function(t,r){if("."===t[0]&&r)for(var n=getCandidates(path$2.resolve(path$2.dirname(r),t),e),i=0;i<n.length;i+=1)try{if(fs$2.statSync(n[i]).isFile())return n[i]}catch(e){}}:t.resolveId}).filter(Boolean);i.unshift(function(e){return!function(e){return!!n.external&&(Array.isArray(n.external)?n.external.includes(e):n.external(e))}(e)&&null}),t=first(i)},r}function isReference$1(e,t){return"MemberExpression"===t.type?t.computed||e===t.object:("Property"!==t.type||e===t.value)&&("MethodDefinition"!==t.type&&("ExportSpecifier"!==t.type||e===t.local))}function flatten(e){for(var t=[];"MemberExpression"===e.type;){if(e.computed)return null;t.unshift(e.property.name),e=e.object}if("Identifier"!==e.type)return null;var r=e.name;return t.unshift(r),{name:r,keypath:t.join(".")}}function extractNames$2(e){var t=[];return extractors$2[e.type](t,e),t}var extractors$2={Identifier:function(e,t){e.push(t.name)},ObjectPattern:function(e,t){t.properties.forEach(function(t){extractors$2[t.value.type](e,t.value)})},ArrayPattern:function(e,t){t.elements.forEach(function(t){t&&extractors$2[t.type](e,t)})},RestElement:function(e,t){extractors$2[t.argument.type](e,t.argument)},AssignmentPattern:function(e,t){extractors$2[t.left.type](e,t.left)}};function isTruthy(e){return"Literal"===e.type?!!e.value:"ParenthesizedExpression"===e.type?isTruthy(e.expression):e.operator in operators?operators[e.operator](e):void 0}function isFalsy(e){return not$4(isTruthy(e))}function not$4(e){return void 0===e?e:!e}function equals(e,t,r){if(e.type===t.type)return"Literal"===e.type?r?e.value===t.value:e.value==t.value:void 0}var operators={"==":function(e){return equals(e.left,e.right,!1)},"!=":function(e){return not$4(operators["=="](e))},"===":function(e){return equals(e.left,e.right,!0)},"!==":function(e){return not$4(operators["==="](e))},"!":function(e){return isFalsy(e.argument)},"&&":function(e){return isTruthy(e.left)&&isTruthy(e.right)},"||":function(e){return isTruthy(e.left)||isTruthy(e.right)}},reserved="process location abstract arguments boolean break byte case catch char class const continue debugger default delete do double else enum eval export extends false final finally float for from function goto if implements import in instanceof int interface let long native new null package private protected public return short static super switch synchronized this throw throws transient true try typeof var void volatile while with yield".split(" "),blacklist={__esModule:!0};reserved.forEach(function(e){return blacklist[e]=!0});var exportsPattern=/^(?:module\.)?exports(?:\.([a-zA-Z_$][a-zA-Z_$0-9]*))?$/,firstpassGlobal=/\b(?:require|module|exports|global)\b/,firstpassNoGlobal=/\b(?:require|module|exports)\b/,importExportDeclaration=/^(?:Import|Export(?:Named|Default))Declaration/,functionType=/^(?:FunctionDeclaration|FunctionExpression|ArrowFunctionExpression)$/;function deconflict(e,t,r){for(var n=1,i=r;e.contains(i)||t.has(i)||i in blacklist;)i=r+"_"+n++;return e.declarations[i]=!0,i}function tryParse$1(e,t,r){try{return e(t,{allowReturnOutsideFunction:!0})}catch(e){throw e.message+=" in "+r,e}}function hasCjsKeywords(e,t){return(t?firstpassNoGlobal:firstpassGlobal).test(e)}function checkEsModule(e,t,r){for(var n=tryParse$1(e,t,r),i=!1,s=0,o=n.body;s<o.length;s+=1){var a=o[s];if("ExportDefaultDeclaration"===a.type)return{isEsModule:!0,hasDefaultExport:!0,ast:n};if("ExportNamedDeclaration"===a.type){i=!0;for(var u=0,c=a.specifiers;u<c.length;u+=1){if("default"===c[u].exported.name)return{isEsModule:!0,hasDefaultExport:!0,ast:n}}}else importExportDeclaration.test(a.type)&&(i=!0)}return{isEsModule:i,hasDefaultExport:!1,ast:n}}function transformCommonjs(e,t,r,n,i,s,o,a,u,c){var p=c||tryParse$1(e,t,r),l=new MagicString$1(t),h={},f=[],d=0,m=attachScopes(p,"scope"),g={module:!1,exports:!1,global:!1,require:!1},y=0,v=0,_=new Set,b=deconflict(m,_,"commonjsHelpers"),E={},x=/__esModule/.test(t);function S(e){if(function(e){if(e&&"CallExpression"===e.type&&"require"===e.callee.name&&!m.contains("require")&&0!==e.arguments.length)return!0}(e)&&!function(e){return e.arguments.length>1||"Literal"!==e.arguments[0].type&&("TemplateLiteral"!==e.arguments[0].type||e.arguments[0].expressions.length>0)}(e)&&!s(e.arguments[0].value))return!0}function A(e,t){var r=function(e){return"Literal"===e.arguments[0].type?e.arguments[0].value:e.arguments[0].quasis[0].value.cooked}(e);if(void 0===h[r]){if(!t)do{t="require$$"+d++}while(m.contains(t));f.push(r),h[r]={source:r,name:t,importsDefault:!1}}return h[r]}var w=new Set;if(walk(p,{enter:function(e){"AssignmentExpression"===e.type&&"MemberExpression"!==e.left.type&&extractNames$2(e.left).forEach(function(e){w.add(e)})}}),walk(p,{enter:function(e,t){if(a&&(l.addSourcemapLocation(e.start),l.addSourcemapLocation(e.end)),t&&("IfStatement"===t.type||"ConditionalExpression"===t.type)){if(e===t.consequent&&isFalsy(t.test))return this.skip();if(e===t.alternate&&isTruthy(t.test))return this.skip()}if(e._skip)return this.skip();if(v+=1,e.scope&&(m=e.scope),functionType.test(e.type)&&(y+=1),"ReturnStatement"===e.type&&0===y&&(x=!0),"ThisExpression"===e.type&&0===y)return g.global=!0,void(i||l.overwrite(e.start,e.end,b+".commonjsGlobal",{storeName:!0}));if("UnaryExpression"===e.type&&"typeof"===e.operator){var r=flatten(e.argument);if(!r)return;if(m.contains(r.name))return;"module.exports"!==r.keypath&&"module"!==r.keypath&&"exports"!==r.keypath||l.overwrite(e.start,e.end,"'object'",{storeName:!1})}if("Identifier"!==e.type){if("AssignmentExpression"===e.type){if("MemberExpression"!==e.left.type)return;var n=flatten(e.left);if(!n)return;if(m.contains(n.name))return;var s=exportsPattern.exec(n.keypath);if(!s||"exports"===n.keypath)return;return g[n.name]=!0,v>3&&(x=!0),e.left._skip=!0,"module.exports"===n.keypath&&"ObjectExpression"===e.right.type?e.right.properties.forEach(function(e){if(!e.computed&&"Identifier"===e.key.type){var t=e.key.name;t===makeLegalIdentifier(t)&&(E[t]=!0)}}):void(s[1]&&(E[s[1]]=!0))}if("VariableDeclarator"===e.type&&"Identifier"===e.id.type&&S(e.init)){if(m.parent)return;if(w.has(e.id.name))return;var o=A(e.init,e.id.name);o.importsDefault=!0,o.name===e.id.name&&(e._shouldRemove=!0)}if(S(e)){var c=A(e);"ExpressionStatement"===t.type?l.remove(t.start,t.end):(c.importsDefault=!0,l.overwrite(e.start,e.end,c.name)),e.callee._skip=!0}}else if(isReference$1(e,t)&&!m.contains(e.name)){if(e.name in g){if("require"===e.name){if(u)return;l.overwrite(e.start,e.end,b+".commonjsRequire",{storeName:!0})}g[e.name]=!0,"global"!==e.name||i||l.overwrite(e.start,e.end,b+".commonjsGlobal",{storeName:!0}),"module"!==e.name&&"exports"!==e.name||(x=!0)}"define"===e.name&&l.overwrite(e.start,e.end,"undefined",{storeName:!0}),_.add(e.name)}},leave:function(e){if(v-=1,e.scope&&(m=m.parent),functionType.test(e.type)&&(y-=1),"VariableDeclaration"===e.type){for(var t=!1,r=e.declarations[0].start,n=0;n<e.declarations.length;n+=1){var i=e.declarations[n];i._shouldRemove?l.remove(r,i.end):(t||(l.remove(r,i.start),t=!0),r=i.end)}t||l.remove(e.start,e.end)}}}),!f.length&&!g.module&&!g.exports&&!g.require&&(i||!g.global)){if(Object.keys(E).length)throw new Error("Custom named exports were specified for "+r+" but it does not appear to be a CommonJS module");return null}var N=(x||g.global||g.require?["import * as "+b+" from '"+HELPERS_ID+"';"]:[]).concat(f.map(function(e){return"import '"+e+"';"}),f.map(function(e){var t=h[e],r=t.name;return"import "+(t.importsDefault?r+" from ":"")+"'"+PROXY_PREFIX+e+"';"})).join("\n")+"\n\n",P=[],C="",I="",k=deconflict(m,_,getName(r));if(!n){var O={str:"export { "+k+" as __moduleExports };",name:"__moduleExports"};P.push(O)}var $=getName(r);function R(e){var t=deconflict(m,_,$),r=t===$?"export var "+e+" = "+k+"."+e+";":"var "+t+" = "+k+"."+e+";\nexport { "+t+" as "+e+" };";P.push({str:r,name:e})}o&&o.forEach(R);var M=[],T=!1;if(x){var L="module"+(g.exports?", exports":"");C="var "+k+" = "+b+".createCommonjsModule(function ("+L+") {\n",I="\n});"}else{var j=[];p.body.forEach(function(e){if("ExpressionStatement"===e.type&&"AssignmentExpression"===e.expression.type){var t=e.expression.left,r=flatten(t);if(!r)return;var n=exportsPattern.exec(r.keypath);if(!n)return;if("module.exports"===r.keypath)T=!0,l.overwrite(t.start,t.end,"var "+k);else{var i=n[1],s=deconflict(m,_,i);j.push({name:i,deconflicted:s}),l.overwrite(e.start,t.end,"var "+s);var o=i===s?"export { "+i+" };":"export { "+s+" as "+i+" };";"default"!==i&&(P.push({str:o,name:i}),delete E[i]),M.push(k+"."+i+" = "+s+";")}}}),T||(I="\n\nvar "+k+" = {\n"+j.map(function(e){return"\t"+e.name+": "+e.deconflicted}).join(",\n")+"\n};")}Object.keys(E).filter(function(e){return!blacklist[e]}).forEach(R);var D=/__esModule/.test(t)?"export default "+b+".unwrapExports("+k+");":"export default "+k+";",B=P.filter(function(e){return"default"!==e.name||!T}).map(function(e){return e.str}),U="\n\n"+[D].concat(B).concat(T?M:[]).join("\n");return l.trim().prepend(N+C).trim().append(I+U),{code:t=l.toString(),map:a?l.generateMap():null}}function commonjs(e){void 0===e&&(e={});var t=e.extensions||[".js"],r=createFilter(e.include,e.exclude),n=e.ignoreGlobal,i={};e.namedExports&&Object.keys(e.namedExports).forEach(function(t){var r;try{r=resolve_3(t,{basedir:process.cwd()})}catch(e){r=path$2.resolve(t)}i[r]=e.namedExports[t]});var s=Object.create(null),o=Object.create(null),a=!!e.ignore,u="function"==typeof e.ignore?e.ignore:Array.isArray(e.ignore)?function(t){return e.ignore.includes(t)}:function(){return!1},c=null,p=getResolveId(t),l=!1!==e.sourceMap;return{name:"commonjs",options:function(e){p.setRollupOptions(e);var t=e.input||e.entry,r=Array.isArray(t)?t:"object"==typeof t&&null!==t?Object.values(t):[t];c=Promise.all(r.map(function(e){return p(e)}))},resolveId:p,load:function(e){if(e===HELPERS_ID)return HELPERS;if(e.startsWith(EXTERNAL_PREFIX)){var t=e.slice(EXTERNAL_PREFIX.length),r=getName(t);return"import "+r+" from "+JSON.stringify(t)+"; export default "+r+";"}if(e.startsWith(PROXY_PREFIX)){var n=e.slice(PROXY_PREFIX.length),i=getName(n);return getIsCjsPromise(n).then(function(e){return e?"import { __moduleExports } from "+JSON.stringify(n)+"; export default __moduleExports;":s[n]?"import * as "+i+" from "+JSON.stringify(n)+"; export default "+i+";":o[n]?"export {default} from "+JSON.stringify(n)+";":"import * as "+i+" from "+JSON.stringify(n)+'; import {getCjsExportFromNamespace} from "'+HELPERS_ID+'"; export default getCjsExportFromNamespace('+i+")"})}},transform:function(e,p){var h=this;if(!r(p)||-1===t.indexOf(path$2.extname(p)))return setIsCjsPromise(p,Promise.resolve(null)),null;var f=c.then(function(t){var r=checkEsModule(h.parse,e,p),c=r.isEsModule,f=r.hasDefaultExport,d=r.ast;if(c)return(f?o:s)[p]=!0,null;if(!hasCjsKeywords(e,n))return s[p]=!0,null;var m=transformCommonjs(h.parse,e,p,-1!==t.indexOf(p),n,u,i[p],l,a,d);return m||(s[p]=!0,null)}).catch(function(e){h.error(e,e.loc)});return setIsCjsPromise(p,f.then(Boolean,function(){return!1})),f}}}const{builtinModules:builtinModules}=module$1$1,blacklist$1=["sys"];var builtinModules_1=(builtinModules||Object.keys(process.binding("natives"))).filter(e=>!/^_|^(internal|v8|node-inspect)\/|\//.test(e)&&!blacklist$1.includes(e)).sort(),ES6ImportExportRegExp=/(?:^\s*|[}{\(\);,\n]\s*)(import\s+['"]|(import|module)\s+[^"'\(\)\n;]+\s+from\s+['"]|export\s+(\*|\{|default|function|var|const|let|[_$a-zA-Z\xA0-\uFFFF][_$a-zA-Z0-9\xA0-\uFFFF]*))/,ES6AliasRegExp=/(?:^\s*|[}{\(\);,\n]\s*)(export\s*\*\s*from\s*(?:'([^']+)'|"([^"]+)"))/,isModule=function(e){return ES6ImportExportRegExp.test(e)||ES6AliasRegExp.test(e)},ES6_BROWSER_EMPTY=path$2.resolve(__dirname,"../src/empty.js"),DEFAULT_EXTS=[".mjs",".js",".json",".node"],readFileCache={},readFileAsync=function(e){return new Promise(function(t,r){return fs$2__default.readFile(e,function(e,n){return e?r(e):t(n)})})},statAsync=function(e){return new Promise(function(t,r){return fs$2__default.stat(e,function(e,n){return e?r(e):t(n)})})};function cachedReadFile(e,t){e in readFileCache==!1&&(readFileCache[e]=readFileAsync(e).catch(function(t){throw delete readFileCache[e],t})),readFileCache[e].then(function(e){return t(null,e)},t)}var isFileCache={};function cachedIsFile(e,t){e in isFileCache==!1&&(isFileCache[e]=statAsync(e).then(function(e){return e.isFile()},function(t){if("ENOENT"===t.code)return!1;throw delete isFileCache[e],t})),isFileCache[e].then(function(e){return t(null,e)},t)}var resolveIdAsync=function(e,t){return new Promise(function(r,n){return resolve$1(e,t,function(e,t){return e?n(e):r(t)})})};function nodeResolve(e){void 0===e&&(e={});var t,r=!1!==e.module,n=!1!==e.main,i=!0===e.jsnext,s=!0===e.preferBuiltins||!1===e.preferBuiltins,o=!s||e.preferBuiltins,a=e.customResolveOptions||{},u=e.jail,c=Array.isArray(e.only)?e.only.map(function(e){return e instanceof RegExp?e:new RegExp("^"+String(e).replace(/[\\^$*+?.()|[\]{}]/g,"\\$&")+"$")}):null,p={};if(e.skip)throw new Error("options.skip is no longer supported — you should use the main Rollup `external` option instead");if(!r&&!n&&!i)throw new Error("At least one of options.module, options.main or options.jsnext must be true");return{name:"node-resolve",options:function(e){t=e.preserveSymlinks},generateBundle:function(){isFileCache={},readFileCache={}},resolveId:function(l,h){var f=this;if(/\0/.test(l))return null;var d=h?path$2.dirname(h):process.cwd();if(e.browser&&p[h]){var m=path$2.resolve(d,l),g=p[h];if(!1===g[l]||!1===g[m])return ES6_BROWSER_EMPTY;(g[l]||g[m]||g[m+".js"]||g[m+".json"])&&(l=g[l]||g[m]||g[m+".js"]||g[m+".json"])}var y=l.split(/[\/\\]/),v=y.shift();if("@"===v[0]&&y.length?v+="/"+y.shift():"."===v[0]&&(v=path$2.resolve(d,l)),c&&!c.some(function(e){return e.test(v)}))return null;var _=!1,b=!1,E=e.extensions||DEFAULT_EXTS,x={basedir:d,packageFilter:function(t,s){var o=path$2.dirname(s);return e.browser&&"object"==typeof t.browser&&(b=Object.keys(t.browser).reduce(function(e,r){var n=t.browser[r];if(n&&"."===n[0]&&(n=path$2.resolve(o,t.browser[r])),e[r]=n,"."===r[0]){var i=path$2.resolve(o,r);e[i]=n,path$2.extname(r)||E.reduce(function(e,t){return e[i+t]=e[r],e},e)}return e},{})),e.browser&&"string"==typeof t.browser?t.main=t.browser:r&&t.module?t.main=t.module:i&&t["jsnext:main"]?t.main=t["jsnext:main"]:!i&&!r||n||(_=!0),t},readFile:cachedReadFile,isFile:cachedIsFile,extensions:E};return void 0!==t&&(x.preserveSymlinks=t),resolveIdAsync(l,Object.assign(x,a)).then(function(r){if(r&&e.browser&&b){if(b.hasOwnProperty(r)){if(!b[r])return p[r]=b,ES6_BROWSER_EMPTY;r=b[r]}p[r]=b}if(!_){if(!t&&r&&fs$2__default.existsSync(r)&&(r=fs$2__default.realpathSync(r)),~builtinModules_1.indexOf(r))return null;if(~builtinModules_1.indexOf(l)&&o)return s||f.warn("preferring built-in module '"+l+"' over local alternative at '"+r+"', pass 'preferBuiltins: false' to disable this behavior or 'preferBuiltins: true' to disable this warning"),null;if(u&&0!==r.indexOf(path$2.normalize(u.trim(path$2.sep))))return null}return r&&e.modulesOnly?readFileAsync(r,"utf-8").then(function(e){return isModule(e)?r:null}):r}).catch(function(){return null})}}}const NodeRollup={rollup:rollup,plugins:{commonjs:commonjs,nodeResolve:nodeResolve,emptyJsResolver:()=>({load:e=>e.endsWith("empty.js")&&e.endsWith(path$2__default.join(__dirname,"../src/empty.js"))?"export default {};":null})}};class NodeStorage{constructor(e){this.fs=e;const t=`stencil-storage-${crypto$1.createHash("md5").update(__dirname).digest("base64").replace(/\W/g,"")}.json`;this.storagePath=path$2.join(os$1.tmpdir(),t)}get(e){return __awaiter(this,void 0,void 0,function*(){return(yield this.readData())[e]})}set(e,t){return __awaiter(this,void 0,void 0,function*(){(yield this.readData())[e]=t,this.writeData()})}readData(){return __awaiter(this,void 0,void 0,function*(){if(!this.data)try{const e=yield this.fs.readFile(this.storagePath);this.data=JSON.parse(e)}catch(e){this.data={}}return this.data})}writeData(){try{const e=JSON.stringify(this.data,null,2);this.fs.writeFileSync(this.storagePath,e)}catch(e){}}}var isWsl_1=createCommonjsModule(function(e){const t=()=>{if("linux"!==process.platform)return!1;if(os$1__default.release().includes("Microsoft"))return!0;try{return fs$2__default.readFileSync("/proc/version","utf8").includes("Microsoft")}catch(e){return!1}};process.env.__IS_WSL_TEST__?e.exports=t:e.exports=t()}),opn=(e,t)=>{if("string"!=typeof e)return Promise.reject(new Error("Expected a `target`"));let r;t=Object.assign({wait:!0},t);let n=[],i=[];const s={};Array.isArray(t.app)&&(n=t.app.slice(1),t.app=t.app[0]),"darwin"===process.platform?(r="open",t.wait&&i.push("-W"),t.app&&i.push("-a",t.app)):"win32"===process.platform||isWsl_1?(r="cmd"+(isWsl_1?".exe":""),i.push("/c","start",'""',"/b"),e=e.replace(/&/g,"^&"),t.wait&&i.push("/wait"),t.app&&i.push(t.app),n.length>0&&(i=i.concat(n))):(r=t.app?t.app:"android"===process.platform?"xdg-open":path$2__default.join(__dirname,"xdg-open"),n.length>0&&(i=i.concat(n)),t.wait||(s.stdio="ignore",s.detached=!0)),i.push(e),"darwin"===process.platform&&n.length>0&&(i.push("--args"),i=i.concat(n));const o=cp__default.spawn(r,i,s);return t.wait?new Promise((e,t)=>{o.once("error",t),o.once("close",r=>{r>0?t(new Error("Exited with code "+r)):e(o)})}):(o.unref(),Promise.resolve(o))},semver=createCommonjsModule(function(e,t){var r;t=e.exports=H,r="object"==typeof process&&process.env&&process.env.NODE_DEBUG&&/\bsemver\b/i.test(process.env.NODE_DEBUG)?function(){var e=Array.prototype.slice.call(arguments,0);e.unshift("SEMVER"),console.log.apply(console,e)}:function(){},t.SEMVER_SPEC_VERSION="2.0.0";var n=256,i=Number.MAX_SAFE_INTEGER||9007199254740991,s=t.re=[],o=t.src=[],a=0,u=a++;o[u]="0|[1-9]\\d*";var c=a++;o[c]="[0-9]+";var p=a++;o[p]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var l=a++;o[l]="("+o[u]+")\\.("+o[u]+")\\.("+o[u]+")";var h=a++;o[h]="("+o[c]+")\\.("+o[c]+")\\.("+o[c]+")";var f=a++;o[f]="(?:"+o[u]+"|"+o[p]+")";var d=a++;o[d]="(?:"+o[c]+"|"+o[p]+")";var m=a++;o[m]="(?:-("+o[f]+"(?:\\."+o[f]+")*))";var g=a++;o[g]="(?:-?("+o[d]+"(?:\\."+o[d]+")*))";var y=a++;o[y]="[0-9A-Za-z-]+";var v=a++;o[v]="(?:\\+("+o[y]+"(?:\\."+o[y]+")*))";var _=a++,b="v?"+o[l]+o[m]+"?"+o[v]+"?";o[_]="^"+b+"$";var E="[v=\\s]*"+o[h]+o[g]+"?"+o[v]+"?",x=a++;o[x]="^"+E+"$";var S=a++;o[S]="((?:<|>)?=?)";var A=a++;o[A]=o[c]+"|x|X|\\*";var w=a++;o[w]=o[u]+"|x|X|\\*";var N=a++;o[N]="[v=\\s]*("+o[w]+")(?:\\.("+o[w]+")(?:\\.("+o[w]+")(?:"+o[m]+")?"+o[v]+"?)?)?";var P=a++;o[P]="[v=\\s]*("+o[A]+")(?:\\.("+o[A]+")(?:\\.("+o[A]+")(?:"+o[g]+")?"+o[v]+"?)?)?";var C=a++;o[C]="^"+o[S]+"\\s*"+o[N]+"$";var I=a++;o[I]="^"+o[S]+"\\s*"+o[P]+"$";var k=a++;o[k]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var O=a++;o[O]="(?:~>?)";var $=a++;o[$]="(\\s*)"+o[O]+"\\s+",s[$]=new RegExp(o[$],"g");var R=a++;o[R]="^"+o[O]+o[N]+"$";var M=a++;o[M]="^"+o[O]+o[P]+"$";var T=a++;o[T]="(?:\\^)";var L=a++;o[L]="(\\s*)"+o[T]+"\\s+",s[L]=new RegExp(o[L],"g");var j=a++;o[j]="^"+o[T]+o[N]+"$";var D=a++;o[D]="^"+o[T]+o[P]+"$";var B=a++;o[B]="^"+o[S]+"\\s*("+E+")$|^$";var U=a++;o[U]="^"+o[S]+"\\s*("+b+")$|^$";var V=a++;o[V]="(\\s*)"+o[S]+"\\s*("+E+"|"+o[N]+")",s[V]=new RegExp(o[V],"g");var F=a++;o[F]="^\\s*("+o[N]+")\\s+-\\s+("+o[N]+")\\s*$";var W=a++;o[W]="^\\s*("+o[P]+")\\s+-\\s+("+o[P]+")\\s*$";var z=a++;o[z]="(<|>)?=?\\s*\\*";for(var q=0;q<35;q++)r(q,o[q]),s[q]||(s[q]=new RegExp(o[q]));function K(e,t){if(t&&"object"==typeof t||(t={loose:!!t,includePrerelease:!1}),e instanceof H)return e;if("string"!=typeof e)return null;if(e.length>n)return null;if(!(t.loose?s[x]:s[_]).test(e))return null;try{return new H(e,t)}catch(e){return null}}function H(e,t){if(t&&"object"==typeof t||(t={loose:!!t,includePrerelease:!1}),e instanceof H){if(e.loose===t.loose)return e;e=e.version}else if("string"!=typeof e)throw new TypeError("Invalid Version: "+e);if(e.length>n)throw new TypeError("version is longer than "+n+" characters");if(!(this instanceof H))return new H(e,t);r("SemVer",e,t),this.options=t,this.loose=!!t.loose;var o=e.trim().match(t.loose?s[x]:s[_]);if(!o)throw new TypeError("Invalid Version: "+e);if(this.raw=e,this.major=+o[1],this.minor=+o[2],this.patch=+o[3],this.major>i||this.major<0)throw new TypeError("Invalid major version");if(this.minor>i||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>i||this.patch<0)throw new TypeError("Invalid patch version");o[4]?this.prerelease=o[4].split(".").map(function(e){if(/^[0-9]+$/.test(e)){var t=+e;if(t>=0&&t<i)return t}return e}):this.prerelease=[],this.build=o[5]?o[5].split("."):[],this.format()}t.parse=K,t.valid=function(e,t){var r=K(e,t);return r?r.version:null},t.clean=function(e,t){var r=K(e.trim().replace(/^[=v]+/,""),t);return r?r.version:null},t.SemVer=H,H.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},H.prototype.toString=function(){return this.version},H.prototype.compare=function(e){return r("SemVer.compare",this.version,this.options,e),e instanceof H||(e=new H(e,this.options)),this.compareMain(e)||this.comparePre(e)},H.prototype.compareMain=function(e){return e instanceof H||(e=new H(e,this.options)),Y(this.major,e.major)||Y(this.minor,e.minor)||Y(this.patch,e.patch)},H.prototype.comparePre=function(e){if(e instanceof H||(e=new H(e,this.options)),this.prerelease.length&&!e.prerelease.length)return-1;if(!this.prerelease.length&&e.prerelease.length)return 1;if(!this.prerelease.length&&!e.prerelease.length)return 0;var t=0;do{var n=this.prerelease[t],i=e.prerelease[t];if(r("prerelease compare",t,n,i),void 0===n&&void 0===i)return 0;if(void 0===i)return 1;if(void 0===n)return-1;if(n!==i)return Y(n,i)}while(++t)},H.prototype.inc=function(e,t){switch(e){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",t);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",t);break;case"prepatch":this.prerelease.length=0,this.inc("patch",t),this.inc("pre",t);break;case"prerelease":0===this.prerelease.length&&this.inc("patch",t),this.inc("pre",t);break;case"major":0===this.minor&&0===this.patch&&0!==this.prerelease.length||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":0===this.patch&&0!==this.prerelease.length||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":0===this.prerelease.length&&this.patch++,this.prerelease=[];break;case"pre":if(0===this.prerelease.length)this.prerelease=[0];else{for(var r=this.prerelease.length;--r>=0;)"number"==typeof this.prerelease[r]&&(this.prerelease[r]++,r=-2);-1===r&&this.prerelease.push(0)}t&&(this.prerelease[0]===t?isNaN(this.prerelease[1])&&(this.prerelease=[t,0]):this.prerelease=[t,0]);break;default:throw new Error("invalid increment argument: "+e)}return this.format(),this.raw=this.version,this},t.inc=function(e,t,r,n){"string"==typeof r&&(n=r,r=void 0);try{return new H(e,r).inc(t,n).version}catch(e){return null}},t.diff=function(e,t){if(Z(e,t))return null;var r=K(e),n=K(t);if(r.prerelease.length||n.prerelease.length){for(var i in r)if(("major"===i||"minor"===i||"patch"===i)&&r[i]!==n[i])return"pre"+i;return"prerelease"}for(var i in r)if(("major"===i||"minor"===i||"patch"===i)&&r[i]!==n[i])return i},t.compareIdentifiers=Y;var G=/^[0-9]+$/;function Y(e,t){var r=G.test(e),n=G.test(t);return r&&n&&(e=+e,t=+t),r&&!n?-1:n&&!r?1:e<t?-1:e>t?1:0}function X(e,t,r){return new H(e,r).compare(new H(t,r))}function Q(e,t,r){return X(e,t,r)>0}function J(e,t,r){return X(e,t,r)<0}function Z(e,t,r){return 0===X(e,t,r)}function ee(e,t,r){return 0!==X(e,t,r)}function te(e,t,r){return X(e,t,r)>=0}function re(e,t,r){return X(e,t,r)<=0}function ne(e,t,r,n){var i;switch(t){case"===":"object"==typeof e&&(e=e.version),"object"==typeof r&&(r=r.version),i=e===r;break;case"!==":"object"==typeof e&&(e=e.version),"object"==typeof r&&(r=r.version),i=e!==r;break;case"":case"=":case"==":i=Z(e,r,n);break;case"!=":i=ee(e,r,n);break;case">":i=Q(e,r,n);break;case">=":i=te(e,r,n);break;case"<":i=J(e,r,n);break;case"<=":i=re(e,r,n);break;default:throw new TypeError("Invalid operator: "+t)}return i}function ie(e,t){if(t&&"object"==typeof t||(t={loose:!!t,includePrerelease:!1}),e instanceof ie){if(e.loose===!!t.loose)return e;e=e.value}if(!(this instanceof ie))return new ie(e,t);r("comparator",e,t),this.options=t,this.loose=!!t.loose,this.parse(e),this.semver===se?this.value="":this.value=this.operator+this.semver.version,r("comp",this)}t.rcompareIdentifiers=function(e,t){return Y(t,e)},t.major=function(e,t){return new H(e,t).major},t.minor=function(e,t){return new H(e,t).minor},t.patch=function(e,t){return new H(e,t).patch},t.compare=X,t.compareLoose=function(e,t){return X(e,t,!0)},t.rcompare=function(e,t,r){return X(t,e,r)},t.sort=function(e,r){return e.sort(function(e,n){return t.compare(e,n,r)})},t.rsort=function(e,r){return e.sort(function(e,n){return t.rcompare(e,n,r)})},t.gt=Q,t.lt=J,t.eq=Z,t.neq=ee,t.gte=te,t.lte=re,t.cmp=ne,t.Comparator=ie;var se={};function oe(e,t){if(t&&"object"==typeof t||(t={loose:!!t,includePrerelease:!1}),e instanceof oe)return e.loose===!!t.loose&&e.includePrerelease===!!t.includePrerelease?e:new oe(e.raw,t);if(e instanceof ie)return new oe(e.value,t);if(!(this instanceof oe))return new oe(e,t);if(this.options=t,this.loose=!!t.loose,this.includePrerelease=!!t.includePrerelease,this.raw=e,this.set=e.split(/\s*\|\|\s*/).map(function(e){return this.parseRange(e.trim())},this).filter(function(e){return e.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+e);this.format()}function ae(e){return!e||"x"===e.toLowerCase()||"*"===e}function ue(e,t,r,n,i,s,o,a,u,c,p,l,h){return((t=ae(r)?"":ae(n)?">="+r+".0.0":ae(i)?">="+r+"."+n+".0":">="+t)+" "+(a=ae(u)?"":ae(c)?"<"+(+u+1)+".0.0":ae(p)?"<"+u+"."+(+c+1)+".0":l?"<="+u+"."+c+"."+p+"-"+l:"<="+a)).trim()}function ce(e,t,n){for(var i=0;i<e.length;i++)if(!e[i].test(t))return!1;if(n||(n={}),t.prerelease.length&&!n.includePrerelease){for(i=0;i<e.length;i++)if(r(e[i].semver),e[i].semver!==se&&e[i].semver.prerelease.length>0){var s=e[i].semver;if(s.major===t.major&&s.minor===t.minor&&s.patch===t.patch)return!0}return!1}return!0}function pe(e,t,r){try{t=new oe(t,r)}catch(e){return!1}return t.test(e)}function le(e,t,r,n){var i,s,o,a,u;switch(e=new H(e,n),t=new oe(t,n),r){case">":i=Q,s=re,o=J,a=">",u=">=";break;case"<":i=J,s=te,o=Q,a="<",u="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(pe(e,t,n))return!1;for(var c=0;c<t.set.length;++c){var p=t.set[c],l=null,h=null;if(p.forEach(function(e){e.semver===se&&(e=new ie(">=0.0.0")),l=l||e,h=h||e,i(e.semver,l.semver,n)?l=e:o(e.semver,h.semver,n)&&(h=e)}),l.operator===a||l.operator===u)return!1;if((!h.operator||h.operator===a)&&s(e,h.semver))return!1;if(h.operator===u&&o(e,h.semver))return!1}return!0}ie.prototype.parse=function(e){var t=this.options.loose?s[B]:s[U],r=e.match(t);if(!r)throw new TypeError("Invalid comparator: "+e);this.operator=r[1],"="===this.operator&&(this.operator=""),r[2]?this.semver=new H(r[2],this.options.loose):this.semver=se},ie.prototype.toString=function(){return this.value},ie.prototype.test=function(e){return r("Comparator.test",e,this.options.loose),this.semver===se||("string"==typeof e&&(e=new H(e,this.options)),ne(e,this.operator,this.semver,this.options))},ie.prototype.intersects=function(e,t){if(!(e instanceof ie))throw new TypeError("a Comparator is required");var r;if(t&&"object"==typeof t||(t={loose:!!t,includePrerelease:!1}),""===this.operator)return r=new oe(e.value,t),pe(this.value,r,t);if(""===e.operator)return r=new oe(this.value,t),pe(e.semver,r,t);var n=!(">="!==this.operator&&">"!==this.operator||">="!==e.operator&&">"!==e.operator),i=!("<="!==this.operator&&"<"!==this.operator||"<="!==e.operator&&"<"!==e.operator),s=this.semver.version===e.semver.version,o=!(">="!==this.operator&&"<="!==this.operator||">="!==e.operator&&"<="!==e.operator),a=ne(this.semver,"<",e.semver,t)&&(">="===this.operator||">"===this.operator)&&("<="===e.operator||"<"===e.operator),u=ne(this.semver,">",e.semver,t)&&("<="===this.operator||"<"===this.operator)&&(">="===e.operator||">"===e.operator);return n||i||s&&o||a||u},t.Range=oe,oe.prototype.format=function(){return this.range=this.set.map(function(e){return e.join(" ").trim()}).join("||").trim(),this.range},oe.prototype.toString=function(){return this.range},oe.prototype.parseRange=function(e){var t=this.options.loose;e=e.trim();var n=t?s[W]:s[F];e=e.replace(n,ue),r("hyphen replace",e),e=e.replace(s[V],"$1$2$3"),r("comparator trim",e,s[V]),e=(e=(e=e.replace(s[$],"$1~")).replace(s[L],"$1^")).split(/\s+/).join(" ");var i=t?s[B]:s[U],o=e.split(" ").map(function(e){return function(e,t){return r("comp",e,t),e=function(e,t){return e.trim().split(/\s+/).map(function(e){return function(e,t){r("caret",e,t),t&&"object"==typeof t||(t={loose:!!t,includePrerelease:!1});var n=t.loose?s[D]:s[j];return e.replace(n,function(t,n,i,s,o){var a;return r("caret",e,t,n,i,s,o),ae(n)?a="":ae(i)?a=">="+n+".0.0 <"+(+n+1)+".0.0":ae(s)?a="0"===n?">="+n+"."+i+".0 <"+n+"."+(+i+1)+".0":">="+n+"."+i+".0 <"+(+n+1)+".0.0":o?(r("replaceCaret pr",o),"-"!==o.charAt(0)&&(o="-"+o),a="0"===n?"0"===i?">="+n+"."+i+"."+s+o+" <"+n+"."+i+"."+(+s+1):">="+n+"."+i+"."+s+o+" <"+n+"."+(+i+1)+".0":">="+n+"."+i+"."+s+o+" <"+(+n+1)+".0.0"):(r("no pr"),a="0"===n?"0"===i?">="+n+"."+i+"."+s+" <"+n+"."+i+"."+(+s+1):">="+n+"."+i+"."+s+" <"+n+"."+(+i+1)+".0":">="+n+"."+i+"."+s+" <"+(+n+1)+".0.0"),r("caret return",a),a})}(e,t)}).join(" ")}(e,t),r("caret",e),e=function(e,t){return e.trim().split(/\s+/).map(function(e){return function(e,t){t&&"object"==typeof t||(t={loose:!!t,includePrerelease:!1});var n=t.loose?s[M]:s[R];return e.replace(n,function(t,n,i,s,o){var a;return r("tilde",e,t,n,i,s,o),ae(n)?a="":ae(i)?a=">="+n+".0.0 <"+(+n+1)+".0.0":ae(s)?a=">="+n+"."+i+".0 <"+n+"."+(+i+1)+".0":o?(r("replaceTilde pr",o),"-"!==o.charAt(0)&&(o="-"+o),a=">="+n+"."+i+"."+s+o+" <"+n+"."+(+i+1)+".0"):a=">="+n+"."+i+"."+s+" <"+n+"."+(+i+1)+".0",r("tilde return",a),a})}(e,t)}).join(" ")}(e,t),r("tildes",e),e=function(e,t){return r("replaceXRanges",e,t),e.split(/\s+/).map(function(e){return function(e,t){e=e.trim(),t&&"object"==typeof t||(t={loose:!!t,includePrerelease:!1});var n=t.loose?s[I]:s[C];return e.replace(n,function(t,n,i,s,o,a){r("xRange",e,t,n,i,s,o,a);var u=ae(i),c=u||ae(s),p=c||ae(o),l=p;return"="===n&&l&&(n=""),u?t=">"===n||"<"===n?"<0.0.0":"*":n&&l?(c&&(s=0),p&&(o=0),">"===n?(n=">=",c?(i=+i+1,s=0,o=0):p&&(s=+s+1,o=0)):"<="===n&&(n="<",c?i=+i+1:s=+s+1),t=n+i+"."+s+"."+o):c?t=">="+i+".0.0 <"+(+i+1)+".0.0":p&&(t=">="+i+"."+s+".0 <"+i+"."+(+s+1)+".0"),r("xRange return",t),t})}(e,t)}).join(" ")}(e,t),r("xrange",e),e=function(e,t){return r("replaceStars",e,t),e.trim().replace(s[z],"")}(e,t),r("stars",e),e}(e,this.options)},this).join(" ").split(/\s+/);return this.options.loose&&(o=o.filter(function(e){return!!e.match(i)})),o=o.map(function(e){return new ie(e,this.options)},this)},oe.prototype.intersects=function(e,t){if(!(e instanceof oe))throw new TypeError("a Range is required");return this.set.some(function(r){return r.every(function(r){return e.set.some(function(e){return e.every(function(e){return r.intersects(e,t)})})})})},t.toComparators=function(e,t){return new oe(e,t).set.map(function(e){return e.map(function(e){return e.value}).join(" ").trim().split(" ")})},oe.prototype.test=function(e){if(!e)return!1;"string"==typeof e&&(e=new H(e,this.options));for(var t=0;t<this.set.length;t++)if(ce(this.set[t],e,this.options))return!0;return!1},t.satisfies=pe,t.maxSatisfying=function(e,t,r){var n=null,i=null;try{var s=new oe(t,r)}catch(e){return null}return e.forEach(function(e){s.test(e)&&(n&&-1!==i.compare(e)||(i=new H(n=e,r)))}),n},t.minSatisfying=function(e,t,r){var n=null,i=null;try{var s=new oe(t,r)}catch(e){return null}return e.forEach(function(e){s.test(e)&&(n&&1!==i.compare(e)||(i=new H(n=e,r)))}),n},t.validRange=function(e,t){try{return new oe(e,t).range||"*"}catch(e){return null}},t.ltr=function(e,t,r){return le(e,t,"<",r)},t.gtr=function(e,t,r){return le(e,t,">",r)},t.outside=le,t.prerelease=function(e,t){var r=K(e,t);return r&&r.prerelease.length?r.prerelease:null},t.intersects=function(e,t,r){return e=new oe(e,r),t=new oe(t,r),e.intersects(t)},t.coerce=function(e){if(e instanceof H)return e;if("string"!=typeof e)return null;var t=e.match(s[k]);return null==t?null:K((t[1]||"0")+"."+(t[2]||"0")+"."+(t[3]||"0"))}}),semver_1=semver.SEMVER_SPEC_VERSION,semver_2=semver.re,semver_3=semver.src,semver_4=semver.parse,semver_5=semver.valid,semver_6=semver.clean,semver_7=semver.SemVer,semver_8=semver.inc,semver_9=semver.diff,semver_10=semver.compareIdentifiers,semver_11=semver.rcompareIdentifiers,semver_12=semver.major,semver_13=semver.minor,semver_14=semver.patch,semver_15=semver.compare,semver_16=semver.compareLoose,semver_17=semver.rcompare,semver_18=semver.sort,semver_19=semver.rsort,semver_20=semver.gt,semver_21=semver.lt,semver_22=semver.eq,semver_23=semver.neq,semver_24=semver.gte,semver_25=semver.lte,semver_26=semver.cmp,semver_27=semver.Comparator,semver_28=semver.Range,semver_29=semver.toComparators,semver_30=semver.satisfies,semver_31=semver.maxSatisfying,semver_32=semver.minSatisfying,semver_33=semver.validRange,semver_34=semver.ltr,semver_35=semver.gtr,semver_36=semver.outside,semver_37=semver.prerelease,semver_38=semver.intersects,semver_39=semver.coerce;class WorkerMain extends events$1.EventEmitter{constructor(e,t){super(),this.id=e,this.tasks=[],this.exitCode=null,this.processQueue=!0,this.sendQueue=[],this.stopped=!1,this.successfulMessage=!1,this.totalTasksAssigned=0,this.workerKeys=[],this.fork(t)}fork(e){const t={execArgv:process.execArgv.filter(e=>!/^--(debug|inspect)/.test(e)),env:process.env,cwd:process.cwd()};this.childProcess=cp.fork(e,["--start-worker"],t),this.childProcess.on("message",this.receiveFromWorker.bind(this)),this.childProcess.once("exit",e=>{this.exitCode=e,this.emit("exit",e)}),this.childProcess.on("error",e=>{this.emit("error",e)})}run(e){this.totalTasksAssigned++,this.tasks.push(e),this.sendToWorker({taskId:e.taskId,method:e.method,args:e.args})}sendToWorker(e){if(!this.processQueue)return void this.sendQueue.push(e);this.childProcess.send(e,e=>{if(!(e&&e instanceof Error)&&(this.processQueue=!0,this.sendQueue.length>0)){const e=this.sendQueue.slice();this.sendQueue=[],e.forEach(e=>this.sendToWorker(e))}})&&!/^win/.test(process.platform)||(this.processQueue=!1)}receiveFromWorker(e){if(this.successfulMessage=!0,this.stopped)return;const t=this.tasks.find(t=>t.taskId===e.taskId);if(!t)return;e.error?t.reject(e.error):t.resolve(e.value);const r=this.tasks.indexOf(t);r>-1&&this.tasks.splice(r,1),this.emit("response",e)}stop(){this.stopped=!0;for(const e of this.tasks)e.reject(TASK_CANCELED_MSG);this.tasks.length=0,this.successfulMessage?(this.childProcess.send({exit:!0}),setTimeout(()=>{null===this.exitCode&&this.childProcess.kill("SIGKILL")},100)):this.childProcess.kill("SIGKILL")}}class WorkerManager extends events$1.EventEmitter{constructor(e,t){super(),this.modulePath=e,this.options=t,this.workerIds=0,this.taskIds=0,this.isEnding=!1,this.taskQueue=[],this.workers=[],this.useForkedWorkers=!1,this.useForkedWorkers=this.options.maxConcurrentWorkers>1,this.useForkedWorkers&&this.startWorkers()}onError(e,t){if("ERR_IPC_CHANNEL_CLOSED"===e.code)return this.stopWorker(t)}onExit(e){setTimeout(()=>{let t=!1;const r=this.workers.find(t=>t.id===e);if(r&&r.tasks.length>0){for(const e of r.tasks)e.retries++,this.taskQueue.unshift(e),t=!0;r.tasks.length=0}this.stopWorker(e),t&&this.processTaskQueue()},10)}startWorkers(){for(;this.workers.length<this.options.maxConcurrentWorkers;)this.startWorker()}startWorker(){const e=this.workerIds++,t=new WorkerMain(e,this.modulePath);t.on("response",this.processTaskQueue.bind(this)),t.once("exit",()=>{this.onExit(e)}),t.on("error",t=>{this.onError(t,e)}),this.workers.push(t)}stopWorker(e){const t=this.workers.find(t=>t.id===e);if(t){t.successfulMessage||(this.useForkedWorkers=!1),t.stop();const e=this.workers.indexOf(t);e>-1&&this.workers.splice(e,1)}}processTaskQueue(){if(!this.isEnding&&0!==this.taskQueue.length)for(this.startWorkers();this.taskQueue.length>0;){const e=getWorker(this.taskQueue[0],this.workers,this.options.maxConcurrentTasksPerWorker);if(!e)break;e.run(this.taskQueue.shift())}}run(e,t,r={}){if(this.isEnding)return Promise.reject(TASK_CANCELED_MSG);if(this.useForkedWorkers)return new Promise((n,i)=>{const s={taskId:this.taskIds++,method:e,args:t,retries:0,resolve:n,reject:i,isLongRunningTask:!!r.isLongRunningTask,workerKey:r.workerKey};this.taskQueue.push(s),this.processTaskQueue()});if(!this.mainThreadRunner){const e=require(this.modulePath);this.mainThreadRunner=new e.createRunner}return this.mainThreadRunner(e,t)}cancelTasks(){for(const e of this.workers){for(const t of e.tasks)t.reject(TASK_CANCELED_MSG);e.tasks.length=0}this.taskQueue.length=0,this.taskIds=0}destroy(){if(!this.isEnding){this.isEnding=!0;for(const e of this.taskQueue)e.reject(TASK_CANCELED_MSG);this.taskQueue.length=0;const e=this.workers.map(e=>e.id);for(const t of e)this.stopWorker(t)}}}function getWorker(e,t,r){return e.workerKey?getWorkerFromKey(t,r,e.workerKey):getNextWorker(t,r)}function getWorkerFromKey(e,t,r){let n=e.find(e=>e.workerKeys.includes(r));return n||((n=getNextWorker(e,t))||(n=e.find(e=>0===e.workerKeys.length))||(n=e[0]),n.workerKeys.push(r),n)}function getNextWorker(e,t){const r=e.filter(e=>!e.stopped&&(!(e.tasks.length>=t)&&!e.tasks.some(e=>e.isLongRunningTask)));return 0===r.length?null:r.sort((e,t)=>e.tasks.length<t.tasks.length?-1:e.tasks.length>t.tasks.length?1:e.totalTasksAssigned<t.totalTasksAssigned?-1:e.totalTasksAssigned>t.totalTasksAssigned?1:0)[0]}class NodeSystem{constructor(e){this.destroys=[],this.semver={lt:semver.lt,lte:semver.lte,gt:semver.gt,gte:semver.gte,prerelease:semver.prerelease,satisfies:semver.satisfies},this.fs=e||new NodeFs,this.path=path$2,this.nodeResolveModule=new NodeResolveModule,this.storage=new NodeStorage(this.fs),this.packageDir=path$2.join(__dirname,"..","..",".."),this.distDir=path$2.join(this.packageDir,"dist");try{this.packageJsonData=require(path$2.join(this.packageDir,"package.json"))}catch(e){throw new Error(`unable to resolve "package.json" from: ${this.packageDir}`)}try{this.typescriptPackageJson=require(this.resolveModule(this.packageDir,"typescript"))}catch(e){throw new Error(`unable to resolve "typescript" from: ${this.packageDir}`)}}initWorkers(e,t){if(this.sysWorker)return this.sysWorker.options;const r=require.resolve(path$2.join(this.distDir,"sys","node","sys-worker.js")),n=os$1.cpus().length;return e="number"==typeof e?Math.max(1,Math.min(n,e)):n,this.sysWorker=new WorkerManager(r,{maxConcurrentWorkers:e,maxConcurrentTasksPerWorker:t}),this.addDestroy(()=>{this.sysWorker&&this.sysWorker.destroy()}),this.sysWorker.options}cancelWorkerTasks(){this.sysWorker&&this.sysWorker.cancelTasks()}destroy(){this.destroys.forEach(e=>{e()}),this.destroys.length=0}addDestroy(e){this.destroys.push(e)}get compiler(){return{name:this.packageJsonData.name,version:this.packageJsonData.version,runtime:path$2.join(this.distDir,"compiler","index.js"),packageDir:this.packageDir,typescriptVersion:this.typescriptPackageJson.version}}copy(e){return __awaiter(this,void 0,void 0,function*(){return this.sysWorker.run("copy",[e],{isLongRunningTask:!0})})}get createDom(){return this._existingDom?this._existingDom:createDom}set createDom(e){this._existingDom=e}createFsWatcher(e,t,r){const n=createFsWatcher(e,t,r);return this.addDestroy(()=>{n.close()}),n}generateContentHash(e,t){let r=crypto$1.createHash("md5").update(e).digest("base64");return"number"==typeof t&&(r=r.replace(/\W/g,"").substr(0,t).toLowerCase()),r}getClientCoreFile(e){const t=normalizePath(path$2.join(this.distDir,"client",e.staticName));return this.fs.readFile(t)}glob(e,t){return new Promise((r,n)=>{glob_1(e,t,(e,t)=>{e?n(e):r(t)})})}loadConfigFile(e,t){const r=loadConfigFile(this.fs,e,t);return r.sys||(r.sys=this),r}get lazyRequire(){return this.nodeLazyRequire||(this.nodeLazyRequire=new NodeLazyRequire(this.semver,this.nodeResolveModule,this.packageJsonData)),this.nodeLazyRequire}optimizeCss(e){return this.sysWorker.run("optimizeCss",[e])}minifyJs(e,t){return this.sysWorker.run("minifyJs",[e,t])}open(e,t){return opn(e,t)}get details(){const e={cpuModel:"",cpus:-1,platform:"",release:"",runtime:"node",runtimeVersion:"",tmpDir:os$1.tmpdir()};try{const t=os$1.cpus();e.cpuModel=t[0].model,e.cpus=t.length,e.platform=os$1.platform(),e.release=os$1.release(),e.runtimeVersion=process.version}catch(e){}return e}requestLatestCompilerVersion(){return this.sysWorker.run("requestLatestCompilerVersion")}resolveModule(e,t,r){return this.nodeResolveModule.resolveModule(e,t,r)}get rollup(){return NodeRollup}scopeCss(e,t,r,n){return this.sysWorker.run("scopeCss",[e,t,r,n])}get color(){return ansiColors}transpileToEs5(e,t,r){return __awaiter(this,void 0,void 0,function*(){return this.sysWorker.run("transpileToEs5",[e,t,r])})}get url(){return url$1}validateTypes(e,t,r,n,i){return this.sysWorker.run("validateTypes",[e,t,r,n,i],{isLongRunningTask:!0,workerKey:"validateTypes"})}get vm(){return{createContext:createContext,runInContext:runInContext}}}exports.NodeLogger=NodeLogger,exports.NodeSystem=NodeSystem;